/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * LoongArch Disassembler                                                  *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#include "llvm/MC/MCInst.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include <assert.h>

namespace llvm {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * Have a static const max_size_in_bits equal to the number of bits in the
//   encoding.
// * be default-constructible and copy-constructible
// * be constructible from a uint64_t
// * be constructible from an APInt (this can be private)
// * Support getBitsSet(loBit, hiBit)
// * be convertible to uint64_t
// * Support the ~, &, ==, !=, and |= operators with other objects of the same type
// * Support shift (<<, >>) with signed and unsigned integers on the RHS
// * Support put (<<) to raw_ostream&
template<typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static InsnType fieldFromInstruction(InsnType insn, unsigned startBit,
                                     unsigned numBits, std::true_type) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template<typename InsnType>
static InsnType fieldFromInstruction(InsnType insn, unsigned startBit,
                                     unsigned numBits, std::false_type) {
  assert(startBit + numBits <= InsnType::max_size_in_bits && "Instruction field out of bounds!");
  InsnType fieldMask = InsnType::getBitsSet(0, numBits);
  return (insn >> startBit) & fieldMask;
}

template<typename InsnType>
static InsnType fieldFromInstruction(InsnType insn, unsigned startBit,
                                     unsigned numBits) {
  return fieldFromInstruction(insn, startBit, numBits, std::is_integral<InsnType>());
}

static const uint8_t DecoderTableLoongArch32[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 0, 199, 5, 0, // Skip to: 1487
/* 8 */       MCD::OPC_ExtractField, 22, 4,  // Inst{25-22} ...
/* 11 */      MCD::OPC_FilterValue, 0, 41, 2, 0, // Skip to: 569
/* 16 */      MCD::OPC_ExtractField, 18, 4,  // Inst{21-18} ...
/* 19 */      MCD::OPC_FilterValue, 0, 187, 0, 0, // Skip to: 211
/* 24 */      MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 27 */      MCD::OPC_FilterValue, 0, 147, 0, 0, // Skip to: 179
/* 32 */      MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 35 */      MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 44
/* 40 */      MCD::OPC_Decode, 220, 3, 0, // Opcode: CLO_D
/* 44 */      MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 53
/* 49 */      MCD::OPC_Decode, 222, 3, 0, // Opcode: CLZ_D
/* 53 */      MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 62
/* 58 */      MCD::OPC_Decode, 239, 3, 0, // Opcode: CTO_D
/* 62 */      MCD::OPC_FilterValue, 11, 4, 0, 0, // Skip to: 71
/* 67 */      MCD::OPC_Decode, 241, 3, 0, // Opcode: CTZ_D
/* 71 */      MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 80
/* 76 */      MCD::OPC_Decode, 145, 6, 0, // Opcode: REVB_4H
/* 80 */      MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 89
/* 85 */      MCD::OPC_Decode, 143, 6, 0, // Opcode: REVB_2W
/* 89 */      MCD::OPC_FilterValue, 15, 4, 0, 0, // Skip to: 98
/* 94 */      MCD::OPC_Decode, 146, 6, 0, // Opcode: REVB_D
/* 98 */      MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 107
/* 103 */     MCD::OPC_Decode, 147, 6, 0, // Opcode: REVH_2W
/* 107 */     MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 116
/* 112 */     MCD::OPC_Decode, 149, 6, 0, // Opcode: REVH_D
/* 116 */     MCD::OPC_FilterValue, 19, 4, 0, 0, // Skip to: 125
/* 121 */     MCD::OPC_Decode, 199, 3, 0, // Opcode: BITREV_8B
/* 125 */     MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 134
/* 130 */     MCD::OPC_Decode, 200, 3, 0, // Opcode: BITREV_D
/* 134 */     MCD::OPC_FilterValue, 22, 4, 0, 0, // Skip to: 143
/* 139 */     MCD::OPC_Decode, 252, 3, 0, // Opcode: EXT_W_H
/* 143 */     MCD::OPC_FilterValue, 23, 4, 0, 0, // Skip to: 152
/* 148 */     MCD::OPC_Decode, 250, 3, 0, // Opcode: EXT_W_B
/* 152 */     MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 161
/* 157 */     MCD::OPC_Decode, 139, 6, 0, // Opcode: RDTIMEL_W
/* 161 */     MCD::OPC_FilterValue, 25, 4, 0, 0, // Skip to: 170
/* 166 */     MCD::OPC_Decode, 137, 6, 0, // Opcode: RDTIMEH_W
/* 170 */     MCD::OPC_FilterValue, 26, 209, 80, 0, // Skip to: 20864
/* 175 */     MCD::OPC_Decode, 141, 6, 0, // Opcode: RDTIME_D
/* 179 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 195
/* 184 */     MCD::OPC_CheckField, 0, 5, 0, 193, 80, 0, // Skip to: 20864
/* 191 */     MCD::OPC_Decode, 185, 3, 1, // Opcode: ASRTLE_D
/* 195 */     MCD::OPC_FilterValue, 3, 184, 80, 0, // Skip to: 20864
/* 200 */     MCD::OPC_CheckField, 0, 5, 0, 177, 80, 0, // Skip to: 20864
/* 207 */     MCD::OPC_Decode, 184, 3, 1, // Opcode: ASRTGT_D
/* 211 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 227
/* 216 */     MCD::OPC_CheckField, 17, 1, 1, 161, 80, 0, // Skip to: 20864
/* 223 */     MCD::OPC_Decode, 141, 3, 2, // Opcode: ALSL_WU
/* 227 */     MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 236
/* 232 */     MCD::OPC_Decode, 216, 3, 3, // Opcode: BYTEPICK_D
/* 236 */     MCD::OPC_FilterValue, 4, 57, 0, 0, // Skip to: 298
/* 241 */     MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 244 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 253
/* 249 */     MCD::OPC_Decode, 136, 3, 4, // Opcode: ADD_D
/* 253 */     MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 262
/* 258 */     MCD::OPC_Decode, 205, 6, 4, // Opcode: SUB_D
/* 262 */     MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 271
/* 267 */     MCD::OPC_Decode, 163, 6, 5, // Opcode: SLT
/* 271 */     MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 280
/* 276 */     MCD::OPC_Decode, 167, 6, 5, // Opcode: SLTU
/* 280 */     MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 289
/* 285 */     MCD::OPC_Decode, 209, 5, 4, // Opcode: MASKEQZ
/* 289 */     MCD::OPC_FilterValue, 7, 90, 80, 0, // Skip to: 20864
/* 294 */     MCD::OPC_Decode, 211, 5, 4, // Opcode: MASKNEZ
/* 298 */     MCD::OPC_FilterValue, 5, 57, 0, 0, // Skip to: 360
/* 303 */     MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 306 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 315
/* 311 */     MCD::OPC_Decode, 242, 5, 4, // Opcode: NOR
/* 315 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 324
/* 320 */     MCD::OPC_Decode, 178, 3, 4, // Opcode: AND
/* 324 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 333
/* 329 */     MCD::OPC_Decode, 244, 5, 4, // Opcode: OR
/* 333 */     MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 342
/* 338 */     MCD::OPC_Decode, 220, 12, 4, // Opcode: XOR
/* 342 */     MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 351
/* 347 */     MCD::OPC_Decode, 250, 5, 4, // Opcode: ORN
/* 351 */     MCD::OPC_FilterValue, 5, 28, 80, 0, // Skip to: 20864
/* 356 */     MCD::OPC_Decode, 182, 3, 4, // Opcode: ANDN
/* 360 */     MCD::OPC_FilterValue, 6, 39, 0, 0, // Skip to: 404
/* 365 */     MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 368 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 377
/* 373 */     MCD::OPC_Decode, 161, 6, 6, // Opcode: SLL_D
/* 377 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 386
/* 382 */     MCD::OPC_Decode, 178, 6, 6, // Opcode: SRL_D
/* 386 */     MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 395
/* 391 */     MCD::OPC_Decode, 174, 6, 6, // Opcode: SRA_D
/* 395 */     MCD::OPC_FilterValue, 7, 240, 79, 0, // Skip to: 20864
/* 400 */     MCD::OPC_Decode, 152, 6, 6, // Opcode: ROTR_D
/* 404 */     MCD::OPC_FilterValue, 7, 48, 0, 0, // Skip to: 457
/* 409 */     MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 412 */     MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 421
/* 417 */     MCD::OPC_Decode, 240, 5, 4, // Opcode: MUL_D
/* 421 */     MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 430
/* 426 */     MCD::OPC_Decode, 234, 5, 4, // Opcode: MULH_D
/* 430 */     MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 439
/* 435 */     MCD::OPC_Decode, 235, 5, 4, // Opcode: MULH_DU
/* 439 */     MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 448
/* 444 */     MCD::OPC_Decode, 238, 5, 4, // Opcode: MULW_D_W
/* 448 */     MCD::OPC_FilterValue, 7, 187, 79, 0, // Skip to: 20864
/* 453 */     MCD::OPC_Decode, 239, 5, 4, // Opcode: MULW_D_WU
/* 457 */     MCD::OPC_FilterValue, 8, 39, 0, 0, // Skip to: 501
/* 462 */     MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 465 */     MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 474
/* 470 */     MCD::OPC_Decode, 245, 3, 4, // Opcode: DIV_D
/* 474 */     MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 483
/* 479 */     MCD::OPC_Decode, 213, 5, 4, // Opcode: MOD_D
/* 483 */     MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 492
/* 488 */     MCD::OPC_Decode, 246, 3, 4, // Opcode: DIV_DU
/* 492 */     MCD::OPC_FilterValue, 7, 143, 79, 0, // Skip to: 20864
/* 497 */     MCD::OPC_Decode, 214, 5, 4, // Opcode: MOD_DU
/* 501 */     MCD::OPC_FilterValue, 9, 21, 0, 0, // Skip to: 527
/* 506 */     MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 509 */     MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 518
/* 514 */     MCD::OPC_Decode, 230, 3, 7, // Opcode: CRC_W_D_W
/* 518 */     MCD::OPC_FilterValue, 7, 117, 79, 0, // Skip to: 20864
/* 523 */     MCD::OPC_Decode, 226, 3, 7, // Opcode: CRCC_W_D_W
/* 527 */     MCD::OPC_FilterValue, 10, 21, 0, 0, // Skip to: 553
/* 532 */     MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 535 */     MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 544
/* 540 */     MCD::OPC_Decode, 244, 3, 8, // Opcode: DBCL
/* 544 */     MCD::OPC_FilterValue, 7, 91, 79, 0, // Skip to: 20864
/* 549 */     MCD::OPC_Decode, 133, 5, 8, // Opcode: HYPCALL
/* 553 */     MCD::OPC_FilterValue, 11, 82, 79, 0, // Skip to: 20864
/* 558 */     MCD::OPC_CheckField, 17, 1, 0, 75, 79, 0, // Skip to: 20864
/* 565 */     MCD::OPC_Decode, 139, 3, 9, // Opcode: ALSL_D
/* 569 */     MCD::OPC_FilterValue, 1, 39, 0, 0, // Skip to: 613
/* 574 */     MCD::OPC_ExtractField, 16, 6,  // Inst{21-16} ...
/* 577 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 586
/* 582 */     MCD::OPC_Decode, 156, 6, 10, // Opcode: SLLI_D
/* 586 */     MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 595
/* 591 */     MCD::OPC_Decode, 176, 6, 10, // Opcode: SRLI_D
/* 595 */     MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 604
/* 600 */     MCD::OPC_Decode, 172, 6, 10, // Opcode: SRAI_D
/* 604 */     MCD::OPC_FilterValue, 13, 31, 79, 0, // Skip to: 20864
/* 609 */     MCD::OPC_Decode, 150, 6, 10, // Opcode: ROTRI_D
/* 613 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 622
/* 618 */     MCD::OPC_Decode, 212, 3, 11, // Opcode: BSTRINS_D
/* 622 */     MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 631
/* 627 */     MCD::OPC_Decode, 214, 3, 12, // Opcode: BSTRPICK_D
/* 631 */     MCD::OPC_FilterValue, 4, 11, 3, 0, // Skip to: 1415
/* 636 */     MCD::OPC_ExtractField, 15, 7,  // Inst{21-15} ...
/* 639 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 648
/* 644 */     MCD::OPC_Decode, 129, 4, 13, // Opcode: FADD_S
/* 648 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 657
/* 653 */     MCD::OPC_Decode, 128, 4, 14, // Opcode: FADD_D
/* 657 */     MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 666
/* 662 */     MCD::OPC_Decode, 241, 4, 13, // Opcode: FSUB_S
/* 666 */     MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 675
/* 671 */     MCD::OPC_Decode, 240, 4, 14, // Opcode: FSUB_D
/* 675 */     MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 684
/* 680 */     MCD::OPC_Decode, 213, 4, 13, // Opcode: FMUL_S
/* 684 */     MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 693
/* 689 */     MCD::OPC_Decode, 212, 4, 14, // Opcode: FMUL_D
/* 693 */     MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 702
/* 698 */     MCD::OPC_Decode, 183, 4, 13, // Opcode: FDIV_S
/* 702 */     MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 711
/* 707 */     MCD::OPC_Decode, 182, 4, 14, // Opcode: FDIV_D
/* 711 */     MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 720
/* 716 */     MCD::OPC_Decode, 203, 4, 13, // Opcode: FMAX_S
/* 720 */     MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 729
/* 725 */     MCD::OPC_Decode, 202, 4, 14, // Opcode: FMAX_D
/* 729 */     MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 738
/* 734 */     MCD::OPC_Decode, 207, 4, 13, // Opcode: FMIN_S
/* 738 */     MCD::OPC_FilterValue, 22, 4, 0, 0, // Skip to: 747
/* 743 */     MCD::OPC_Decode, 206, 4, 14, // Opcode: FMIN_D
/* 747 */     MCD::OPC_FilterValue, 25, 4, 0, 0, // Skip to: 756
/* 752 */     MCD::OPC_Decode, 201, 4, 13, // Opcode: FMAXA_S
/* 756 */     MCD::OPC_FilterValue, 26, 4, 0, 0, // Skip to: 765
/* 761 */     MCD::OPC_Decode, 200, 4, 14, // Opcode: FMAXA_D
/* 765 */     MCD::OPC_FilterValue, 29, 4, 0, 0, // Skip to: 774
/* 770 */     MCD::OPC_Decode, 205, 4, 13, // Opcode: FMINA_S
/* 774 */     MCD::OPC_FilterValue, 30, 4, 0, 0, // Skip to: 783
/* 779 */     MCD::OPC_Decode, 204, 4, 14, // Opcode: FMINA_D
/* 783 */     MCD::OPC_FilterValue, 33, 4, 0, 0, // Skip to: 792
/* 788 */     MCD::OPC_Decode, 227, 4, 13, // Opcode: FSCALEB_S
/* 792 */     MCD::OPC_FilterValue, 34, 4, 0, 0, // Skip to: 801
/* 797 */     MCD::OPC_Decode, 226, 4, 14, // Opcode: FSCALEB_D
/* 801 */     MCD::OPC_FilterValue, 37, 4, 0, 0, // Skip to: 810
/* 806 */     MCD::OPC_Decode, 179, 4, 13, // Opcode: FCOPYSIGN_S
/* 810 */     MCD::OPC_FilterValue, 38, 4, 0, 0, // Skip to: 819
/* 815 */     MCD::OPC_Decode, 178, 4, 14, // Opcode: FCOPYSIGN_D
/* 819 */     MCD::OPC_FilterValue, 40, 129, 0, 0, // Skip to: 953
/* 824 */     MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 827 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 836
/* 832 */     MCD::OPC_Decode, 255, 3, 15, // Opcode: FABS_S
/* 836 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 845
/* 841 */     MCD::OPC_Decode, 254, 3, 16, // Opcode: FABS_D
/* 845 */     MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 854
/* 850 */     MCD::OPC_Decode, 215, 4, 15, // Opcode: FNEG_S
/* 854 */     MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 863
/* 859 */     MCD::OPC_Decode, 214, 4, 16, // Opcode: FNEG_D
/* 863 */     MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 872
/* 868 */     MCD::OPC_Decode, 197, 4, 15, // Opcode: FLOGB_S
/* 872 */     MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 881
/* 877 */     MCD::OPC_Decode, 196, 4, 16, // Opcode: FLOGB_D
/* 881 */     MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 890
/* 886 */     MCD::OPC_Decode, 131, 4, 15, // Opcode: FCLASS_S
/* 890 */     MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 899
/* 895 */     MCD::OPC_Decode, 130, 4, 16, // Opcode: FCLASS_D
/* 899 */     MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 908
/* 904 */     MCD::OPC_Decode, 231, 4, 15, // Opcode: FSQRT_S
/* 908 */     MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 917
/* 913 */     MCD::OPC_Decode, 230, 4, 16, // Opcode: FSQRT_D
/* 917 */     MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 926
/* 922 */     MCD::OPC_Decode, 221, 4, 15, // Opcode: FRECIP_S
/* 926 */     MCD::OPC_FilterValue, 22, 4, 0, 0, // Skip to: 935
/* 931 */     MCD::OPC_Decode, 220, 4, 16, // Opcode: FRECIP_D
/* 935 */     MCD::OPC_FilterValue, 25, 4, 0, 0, // Skip to: 944
/* 940 */     MCD::OPC_Decode, 225, 4, 15, // Opcode: FRSQRT_S
/* 944 */     MCD::OPC_FilterValue, 26, 203, 77, 0, // Skip to: 20864
/* 949 */     MCD::OPC_Decode, 224, 4, 16, // Opcode: FRSQRT_D
/* 953 */     MCD::OPC_FilterValue, 41, 157, 0, 0, // Skip to: 1115
/* 958 */     MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 961 */     MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 970
/* 966 */     MCD::OPC_Decode, 209, 4, 15, // Opcode: FMOV_S
/* 970 */     MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 979
/* 975 */     MCD::OPC_Decode, 208, 4, 16, // Opcode: FMOV_D
/* 979 */     MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 988
/* 984 */     MCD::OPC_Decode, 233, 5, 17, // Opcode: MOVGR2FR_W
/* 988 */     MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 997
/* 993 */     MCD::OPC_Decode, 232, 5, 18, // Opcode: MOVGR2FR_D
/* 997 */     MCD::OPC_FilterValue, 11, 4, 0, 0, // Skip to: 1006
/* 1002 */    MCD::OPC_Decode, 231, 5, 19, // Opcode: MOVGR2FRH_W
/* 1006 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 1015
/* 1011 */    MCD::OPC_Decode, 226, 5, 20, // Opcode: MOVFR2GR_S
/* 1015 */    MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 1024
/* 1020 */    MCD::OPC_Decode, 224, 5, 21, // Opcode: MOVFR2GR_D
/* 1024 */    MCD::OPC_FilterValue, 15, 4, 0, 0, // Skip to: 1033
/* 1029 */    MCD::OPC_Decode, 227, 5, 20, // Opcode: MOVFRH2GR_S
/* 1033 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 1042
/* 1038 */    MCD::OPC_Decode, 230, 5, 22, // Opcode: MOVGR2FCSR
/* 1042 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 1051
/* 1047 */    MCD::OPC_Decode, 221, 5, 23, // Opcode: MOVFCSR2GR
/* 1051 */    MCD::OPC_FilterValue, 20, 11, 0, 0, // Skip to: 1067
/* 1056 */    MCD::OPC_CheckField, 3, 2, 0, 89, 77, 0, // Skip to: 20864
/* 1063 */    MCD::OPC_Decode, 222, 5, 24, // Opcode: MOVFR2CF
/* 1067 */    MCD::OPC_FilterValue, 21, 11, 0, 0, // Skip to: 1083
/* 1072 */    MCD::OPC_CheckField, 8, 2, 0, 73, 77, 0, // Skip to: 20864
/* 1079 */    MCD::OPC_Decode, 217, 5, 25, // Opcode: MOVCF2FR
/* 1083 */    MCD::OPC_FilterValue, 22, 11, 0, 0, // Skip to: 1099
/* 1088 */    MCD::OPC_CheckField, 3, 2, 0, 57, 77, 0, // Skip to: 20864
/* 1095 */    MCD::OPC_Decode, 228, 5, 26, // Opcode: MOVGR2CF
/* 1099 */    MCD::OPC_FilterValue, 23, 48, 77, 0, // Skip to: 20864
/* 1104 */    MCD::OPC_CheckField, 8, 2, 0, 41, 77, 0, // Skip to: 20864
/* 1111 */    MCD::OPC_Decode, 219, 5, 27, // Opcode: MOVCF2GR
/* 1115 */    MCD::OPC_FilterValue, 50, 21, 0, 0, // Skip to: 1141
/* 1120 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 1123 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 1132
/* 1128 */    MCD::OPC_Decode, 181, 4, 28, // Opcode: FCVT_S_D
/* 1132 */    MCD::OPC_FilterValue, 9, 15, 77, 0, // Skip to: 20864
/* 1137 */    MCD::OPC_Decode, 180, 4, 29, // Opcode: FCVT_D_S
/* 1141 */    MCD::OPC_FilterValue, 52, 75, 0, 0, // Skip to: 1221
/* 1146 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 1149 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1158
/* 1154 */    MCD::OPC_Decode, 245, 4, 15, // Opcode: FTINTRM_W_S
/* 1158 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1167
/* 1163 */    MCD::OPC_Decode, 244, 4, 16, // Opcode: FTINTRM_W_D
/* 1167 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 1176
/* 1172 */    MCD::OPC_Decode, 243, 4, 15, // Opcode: FTINTRM_L_S
/* 1176 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 1185
/* 1181 */    MCD::OPC_Decode, 242, 4, 16, // Opcode: FTINTRM_L_D
/* 1185 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 1194
/* 1190 */    MCD::OPC_Decode, 253, 4, 15, // Opcode: FTINTRP_W_S
/* 1194 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 1203
/* 1199 */    MCD::OPC_Decode, 252, 4, 16, // Opcode: FTINTRP_W_D
/* 1203 */    MCD::OPC_FilterValue, 25, 4, 0, 0, // Skip to: 1212
/* 1208 */    MCD::OPC_Decode, 251, 4, 15, // Opcode: FTINTRP_L_S
/* 1212 */    MCD::OPC_FilterValue, 26, 191, 76, 0, // Skip to: 20864
/* 1217 */    MCD::OPC_Decode, 250, 4, 16, // Opcode: FTINTRP_L_D
/* 1221 */    MCD::OPC_FilterValue, 53, 75, 0, 0, // Skip to: 1301
/* 1226 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 1229 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1238
/* 1234 */    MCD::OPC_Decode, 128, 5, 15, // Opcode: FTINTRZ_W_S
/* 1238 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1247
/* 1243 */    MCD::OPC_Decode, 214, 6, 28, // Opcode: TRUNC_W_D
/* 1247 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 1256
/* 1252 */    MCD::OPC_Decode, 255, 4, 29, // Opcode: FTINTRZ_L_S
/* 1256 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 1265
/* 1261 */    MCD::OPC_Decode, 254, 4, 16, // Opcode: FTINTRZ_L_D
/* 1265 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 1274
/* 1270 */    MCD::OPC_Decode, 249, 4, 15, // Opcode: FTINTRNE_W_S
/* 1274 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 1283
/* 1279 */    MCD::OPC_Decode, 248, 4, 16, // Opcode: FTINTRNE_W_D
/* 1283 */    MCD::OPC_FilterValue, 25, 4, 0, 0, // Skip to: 1292
/* 1288 */    MCD::OPC_Decode, 247, 4, 15, // Opcode: FTINTRNE_L_S
/* 1292 */    MCD::OPC_FilterValue, 26, 111, 76, 0, // Skip to: 20864
/* 1297 */    MCD::OPC_Decode, 246, 4, 16, // Opcode: FTINTRNE_L_D
/* 1301 */    MCD::OPC_FilterValue, 54, 39, 0, 0, // Skip to: 1345
/* 1306 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 1309 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1318
/* 1314 */    MCD::OPC_Decode, 132, 5, 15, // Opcode: FTINT_W_S
/* 1318 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1327
/* 1323 */    MCD::OPC_Decode, 131, 5, 28, // Opcode: FTINT_W_D
/* 1327 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 1336
/* 1332 */    MCD::OPC_Decode, 130, 5, 29, // Opcode: FTINT_L_S
/* 1336 */    MCD::OPC_FilterValue, 10, 67, 76, 0, // Skip to: 20864
/* 1341 */    MCD::OPC_Decode, 129, 5, 16, // Opcode: FTINT_L_D
/* 1345 */    MCD::OPC_FilterValue, 58, 39, 0, 0, // Skip to: 1389
/* 1350 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 1353 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 1362
/* 1358 */    MCD::OPC_Decode, 187, 4, 15, // Opcode: FFINT_S_W
/* 1362 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 1371
/* 1367 */    MCD::OPC_Decode, 186, 4, 28, // Opcode: FFINT_S_L
/* 1371 */    MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 1380
/* 1376 */    MCD::OPC_Decode, 185, 4, 29, // Opcode: FFINT_D_W
/* 1380 */    MCD::OPC_FilterValue, 10, 23, 76, 0, // Skip to: 20864
/* 1385 */    MCD::OPC_Decode, 184, 4, 16, // Opcode: FFINT_D_L
/* 1389 */    MCD::OPC_FilterValue, 60, 14, 76, 0, // Skip to: 20864
/* 1394 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 1397 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 1406
/* 1402 */    MCD::OPC_Decode, 223, 4, 15, // Opcode: FRINT_S
/* 1406 */    MCD::OPC_FilterValue, 18, 253, 75, 0, // Skip to: 20864
/* 1411 */    MCD::OPC_Decode, 222, 4, 16, // Opcode: FRINT_D
/* 1415 */    MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 1424
/* 1420 */    MCD::OPC_Decode, 165, 6, 30, // Opcode: SLTI
/* 1424 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 1433
/* 1429 */    MCD::OPC_Decode, 169, 6, 30, // Opcode: SLTUI
/* 1433 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 1442
/* 1438 */    MCD::OPC_Decode, 134, 3, 31, // Opcode: ADDI_W64
/* 1442 */    MCD::OPC_FilterValue, 11, 4, 0, 0, // Skip to: 1451
/* 1447 */    MCD::OPC_Decode, 130, 3, 31, // Opcode: ADDI_D
/* 1451 */    MCD::OPC_FilterValue, 12, 4, 0, 0, // Skip to: 1460
/* 1456 */    MCD::OPC_Decode, 206, 5, 31, // Opcode: LU52I_D
/* 1460 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 1469
/* 1465 */    MCD::OPC_Decode, 180, 3, 32, // Opcode: ANDI
/* 1469 */    MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 1478
/* 1474 */    MCD::OPC_Decode, 246, 5, 32, // Opcode: ORI
/* 1478 */    MCD::OPC_FilterValue, 15, 181, 75, 0, // Skip to: 20864
/* 1483 */    MCD::OPC_Decode, 222, 12, 32, // Opcode: XORI
/* 1487 */    MCD::OPC_FilterValue, 1, 18, 1, 0, // Skip to: 1766
/* 1492 */    MCD::OPC_ExtractField, 24, 2,  // Inst{25-24} ...
/* 1495 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 1525
/* 1500 */    MCD::OPC_ExtractField, 5, 5,  // Inst{9-5} ...
/* 1503 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1512
/* 1508 */    MCD::OPC_Decode, 233, 3, 33, // Opcode: CSRRD
/* 1512 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1521
/* 1517 */    MCD::OPC_Decode, 235, 3, 34, // Opcode: CSRWR
/* 1521 */    MCD::OPC_Decode, 237, 3, 35, // Opcode: CSRXCHG
/* 1525 */    MCD::OPC_FilterValue, 2, 134, 75, 0, // Skip to: 20864
/* 1530 */    MCD::OPC_ExtractField, 22, 2,  // Inst{23-22} ...
/* 1533 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1542
/* 1538 */    MCD::OPC_Decode, 218, 3, 36, // Opcode: CACOP
/* 1542 */    MCD::OPC_FilterValue, 1, 117, 75, 0, // Skip to: 20864
/* 1547 */    MCD::OPC_ExtractField, 18, 4,  // Inst{21-18} ...
/* 1550 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1559
/* 1555 */    MCD::OPC_Decode, 153, 5, 37, // Opcode: LDDIR
/* 1559 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 1575
/* 1564 */    MCD::OPC_CheckField, 0, 5, 0, 93, 75, 0, // Skip to: 20864
/* 1571 */    MCD::OPC_Decode, 163, 5, 38, // Opcode: LDPTE
/* 1575 */    MCD::OPC_FilterValue, 2, 84, 75, 0, // Skip to: 20864
/* 1580 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 1583 */    MCD::OPC_FilterValue, 0, 160, 0, 0, // Skip to: 1748
/* 1588 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 1591 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1600
/* 1596 */    MCD::OPC_Decode, 137, 5, 0, // Opcode: IOCSRRD_B
/* 1600 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1609
/* 1605 */    MCD::OPC_Decode, 140, 5, 0, // Opcode: IOCSRRD_H
/* 1609 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1618
/* 1614 */    MCD::OPC_Decode, 142, 5, 0, // Opcode: IOCSRRD_W
/* 1618 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 1627
/* 1623 */    MCD::OPC_Decode, 139, 5, 39, // Opcode: IOCSRRD_D
/* 1627 */    MCD::OPC_FilterValue, 7, 4, 0, 0, // Skip to: 1636
/* 1632 */    MCD::OPC_Decode, 145, 5, 39, // Opcode: IOCSRWR_D
/* 1636 */    MCD::OPC_FilterValue, 8, 11, 0, 0, // Skip to: 1652
/* 1641 */    MCD::OPC_CheckField, 0, 10, 0, 16, 75, 0, // Skip to: 20864
/* 1648 */    MCD::OPC_Decode, 208, 6, 40, // Opcode: TLBCLR
/* 1652 */    MCD::OPC_FilterValue, 9, 11, 0, 0, // Skip to: 1668
/* 1657 */    MCD::OPC_CheckField, 0, 10, 0, 0, 75, 0, // Skip to: 20864
/* 1664 */    MCD::OPC_Decode, 210, 6, 40, // Opcode: TLBFLUSH
/* 1668 */    MCD::OPC_FilterValue, 10, 11, 0, 0, // Skip to: 1684
/* 1673 */    MCD::OPC_CheckField, 0, 10, 0, 240, 74, 0, // Skip to: 20864
/* 1680 */    MCD::OPC_Decode, 212, 6, 40, // Opcode: TLBSRCH
/* 1684 */    MCD::OPC_FilterValue, 11, 11, 0, 0, // Skip to: 1700
/* 1689 */    MCD::OPC_CheckField, 0, 10, 0, 224, 74, 0, // Skip to: 20864
/* 1696 */    MCD::OPC_Decode, 211, 6, 40, // Opcode: TLBRD
/* 1700 */    MCD::OPC_FilterValue, 12, 11, 0, 0, // Skip to: 1716
/* 1705 */    MCD::OPC_CheckField, 0, 10, 0, 208, 74, 0, // Skip to: 20864
/* 1712 */    MCD::OPC_Decode, 213, 6, 40, // Opcode: TLBWR
/* 1716 */    MCD::OPC_FilterValue, 13, 11, 0, 0, // Skip to: 1732
/* 1721 */    MCD::OPC_CheckField, 0, 10, 0, 192, 74, 0, // Skip to: 20864
/* 1728 */    MCD::OPC_Decode, 209, 6, 40, // Opcode: TLBFILL
/* 1732 */    MCD::OPC_FilterValue, 14, 183, 74, 0, // Skip to: 20864
/* 1737 */    MCD::OPC_CheckField, 0, 10, 0, 176, 74, 0, // Skip to: 20864
/* 1744 */    MCD::OPC_Decode, 249, 3, 40, // Opcode: ERTN
/* 1748 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1757
/* 1753 */    MCD::OPC_Decode, 135, 5, 8, // Opcode: IDLE
/* 1757 */    MCD::OPC_FilterValue, 3, 158, 74, 0, // Skip to: 20864
/* 1762 */    MCD::OPC_Decode, 136, 5, 41, // Opcode: INVTLB
/* 1766 */    MCD::OPC_FilterValue, 2, 219, 0, 0, // Skip to: 1990
/* 1771 */    MCD::OPC_ExtractField, 20, 6,  // Inst{25-20} ...
/* 1774 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1783
/* 1779 */    MCD::OPC_Decode, 199, 4, 42, // Opcode: FMADD_S
/* 1783 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1792
/* 1788 */    MCD::OPC_Decode, 198, 4, 43, // Opcode: FMADD_D
/* 1792 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 1801
/* 1797 */    MCD::OPC_Decode, 211, 4, 42, // Opcode: FMSUB_S
/* 1801 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 1810
/* 1806 */    MCD::OPC_Decode, 210, 4, 43, // Opcode: FMSUB_D
/* 1810 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 1819
/* 1815 */    MCD::OPC_Decode, 217, 4, 42, // Opcode: FNMADD_S
/* 1819 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 1828
/* 1824 */    MCD::OPC_Decode, 216, 4, 43, // Opcode: FNMADD_D
/* 1828 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 1837
/* 1833 */    MCD::OPC_Decode, 219, 4, 42, // Opcode: FNMSUB_S
/* 1837 */    MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 1846
/* 1842 */    MCD::OPC_Decode, 218, 4, 43, // Opcode: FNMSUB_D
/* 1846 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 1855
/* 1851 */    MCD::OPC_Decode, 161, 8, 44, // Opcode: VFMADD_S
/* 1855 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 1864
/* 1860 */    MCD::OPC_Decode, 160, 8, 45, // Opcode: VFMADD_D
/* 1864 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 1873
/* 1869 */    MCD::OPC_Decode, 171, 8, 44, // Opcode: VFMSUB_S
/* 1873 */    MCD::OPC_FilterValue, 22, 4, 0, 0, // Skip to: 1882
/* 1878 */    MCD::OPC_Decode, 170, 8, 45, // Opcode: VFMSUB_D
/* 1882 */    MCD::OPC_FilterValue, 25, 4, 0, 0, // Skip to: 1891
/* 1887 */    MCD::OPC_Decode, 175, 8, 44, // Opcode: VFNMADD_S
/* 1891 */    MCD::OPC_FilterValue, 26, 4, 0, 0, // Skip to: 1900
/* 1896 */    MCD::OPC_Decode, 174, 8, 45, // Opcode: VFNMADD_D
/* 1900 */    MCD::OPC_FilterValue, 29, 4, 0, 0, // Skip to: 1909
/* 1905 */    MCD::OPC_Decode, 177, 8, 44, // Opcode: VFNMSUB_S
/* 1909 */    MCD::OPC_FilterValue, 30, 4, 0, 0, // Skip to: 1918
/* 1914 */    MCD::OPC_Decode, 176, 8, 45, // Opcode: VFNMSUB_D
/* 1918 */    MCD::OPC_FilterValue, 33, 4, 0, 0, // Skip to: 1927
/* 1923 */    MCD::OPC_Decode, 162, 14, 46, // Opcode: XVFMADD_S
/* 1927 */    MCD::OPC_FilterValue, 34, 4, 0, 0, // Skip to: 1936
/* 1932 */    MCD::OPC_Decode, 161, 14, 47, // Opcode: XVFMADD_D
/* 1936 */    MCD::OPC_FilterValue, 37, 4, 0, 0, // Skip to: 1945
/* 1941 */    MCD::OPC_Decode, 172, 14, 46, // Opcode: XVFMSUB_S
/* 1945 */    MCD::OPC_FilterValue, 38, 4, 0, 0, // Skip to: 1954
/* 1950 */    MCD::OPC_Decode, 171, 14, 47, // Opcode: XVFMSUB_D
/* 1954 */    MCD::OPC_FilterValue, 41, 4, 0, 0, // Skip to: 1963
/* 1959 */    MCD::OPC_Decode, 176, 14, 46, // Opcode: XVFNMADD_S
/* 1963 */    MCD::OPC_FilterValue, 42, 4, 0, 0, // Skip to: 1972
/* 1968 */    MCD::OPC_Decode, 175, 14, 47, // Opcode: XVFNMADD_D
/* 1972 */    MCD::OPC_FilterValue, 45, 4, 0, 0, // Skip to: 1981
/* 1977 */    MCD::OPC_Decode, 178, 14, 46, // Opcode: XVFNMSUB_S
/* 1981 */    MCD::OPC_FilterValue, 46, 190, 73, 0, // Skip to: 20864
/* 1986 */    MCD::OPC_Decode, 177, 14, 47, // Opcode: XVFNMSUB_D
/* 1990 */    MCD::OPC_FilterValue, 3, 63, 6, 0, // Skip to: 3594
/* 1995 */    MCD::OPC_ExtractField, 20, 6,  // Inst{25-20} ...
/* 1998 */    MCD::OPC_FilterValue, 1, 99, 1, 0, // Skip to: 2358
/* 2003 */    MCD::OPC_ExtractField, 15, 5,  // Inst{19-15} ...
/* 2006 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2022
/* 2011 */    MCD::OPC_CheckField, 3, 2, 0, 158, 73, 0, // Skip to: 20864
/* 2018 */    MCD::OPC_Decode, 133, 4, 48, // Opcode: FCMP_CAF_S
/* 2022 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2038
/* 2027 */    MCD::OPC_CheckField, 3, 2, 0, 142, 73, 0, // Skip to: 20864
/* 2034 */    MCD::OPC_Decode, 157, 4, 48, // Opcode: FCMP_SAF_S
/* 2038 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2054
/* 2043 */    MCD::OPC_CheckField, 3, 2, 0, 126, 73, 0, // Skip to: 20864
/* 2050 */    MCD::OPC_Decode, 139, 4, 48, // Opcode: FCMP_CLT_S
/* 2054 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2070
/* 2059 */    MCD::OPC_CheckField, 3, 2, 0, 110, 73, 0, // Skip to: 20864
/* 2066 */    MCD::OPC_Decode, 163, 4, 48, // Opcode: FCMP_SLT_S
/* 2070 */    MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 2086
/* 2075 */    MCD::OPC_CheckField, 3, 2, 0, 94, 73, 0, // Skip to: 20864
/* 2082 */    MCD::OPC_Decode, 135, 4, 48, // Opcode: FCMP_CEQ_S
/* 2086 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 2102
/* 2091 */    MCD::OPC_CheckField, 3, 2, 0, 78, 73, 0, // Skip to: 20864
/* 2098 */    MCD::OPC_Decode, 159, 4, 48, // Opcode: FCMP_SEQ_S
/* 2102 */    MCD::OPC_FilterValue, 6, 11, 0, 0, // Skip to: 2118
/* 2107 */    MCD::OPC_CheckField, 3, 2, 0, 62, 73, 0, // Skip to: 20864
/* 2114 */    MCD::OPC_Decode, 137, 4, 48, // Opcode: FCMP_CLE_S
/* 2118 */    MCD::OPC_FilterValue, 7, 11, 0, 0, // Skip to: 2134
/* 2123 */    MCD::OPC_CheckField, 3, 2, 0, 46, 73, 0, // Skip to: 20864
/* 2130 */    MCD::OPC_Decode, 161, 4, 48, // Opcode: FCMP_SLE_S
/* 2134 */    MCD::OPC_FilterValue, 8, 11, 0, 0, // Skip to: 2150
/* 2139 */    MCD::OPC_CheckField, 3, 2, 0, 30, 73, 0, // Skip to: 20864
/* 2146 */    MCD::OPC_Decode, 153, 4, 48, // Opcode: FCMP_CUN_S
/* 2150 */    MCD::OPC_FilterValue, 9, 11, 0, 0, // Skip to: 2166
/* 2155 */    MCD::OPC_CheckField, 3, 2, 0, 14, 73, 0, // Skip to: 20864
/* 2162 */    MCD::OPC_Decode, 177, 4, 48, // Opcode: FCMP_SUN_S
/* 2166 */    MCD::OPC_FilterValue, 10, 11, 0, 0, // Skip to: 2182
/* 2171 */    MCD::OPC_CheckField, 3, 2, 0, 254, 72, 0, // Skip to: 20864
/* 2178 */    MCD::OPC_Decode, 149, 4, 48, // Opcode: FCMP_CULT_S
/* 2182 */    MCD::OPC_FilterValue, 11, 11, 0, 0, // Skip to: 2198
/* 2187 */    MCD::OPC_CheckField, 3, 2, 0, 238, 72, 0, // Skip to: 20864
/* 2194 */    MCD::OPC_Decode, 173, 4, 48, // Opcode: FCMP_SULT_S
/* 2198 */    MCD::OPC_FilterValue, 12, 11, 0, 0, // Skip to: 2214
/* 2203 */    MCD::OPC_CheckField, 3, 2, 0, 222, 72, 0, // Skip to: 20864
/* 2210 */    MCD::OPC_Decode, 145, 4, 48, // Opcode: FCMP_CUEQ_S
/* 2214 */    MCD::OPC_FilterValue, 13, 11, 0, 0, // Skip to: 2230
/* 2219 */    MCD::OPC_CheckField, 3, 2, 0, 206, 72, 0, // Skip to: 20864
/* 2226 */    MCD::OPC_Decode, 169, 4, 48, // Opcode: FCMP_SUEQ_S
/* 2230 */    MCD::OPC_FilterValue, 14, 11, 0, 0, // Skip to: 2246
/* 2235 */    MCD::OPC_CheckField, 3, 2, 0, 190, 72, 0, // Skip to: 20864
/* 2242 */    MCD::OPC_Decode, 147, 4, 48, // Opcode: FCMP_CULE_S
/* 2246 */    MCD::OPC_FilterValue, 15, 11, 0, 0, // Skip to: 2262
/* 2251 */    MCD::OPC_CheckField, 3, 2, 0, 174, 72, 0, // Skip to: 20864
/* 2258 */    MCD::OPC_Decode, 171, 4, 48, // Opcode: FCMP_SULE_S
/* 2262 */    MCD::OPC_FilterValue, 16, 11, 0, 0, // Skip to: 2278
/* 2267 */    MCD::OPC_CheckField, 3, 2, 0, 158, 72, 0, // Skip to: 20864
/* 2274 */    MCD::OPC_Decode, 141, 4, 48, // Opcode: FCMP_CNE_S
/* 2278 */    MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 2294
/* 2283 */    MCD::OPC_CheckField, 3, 2, 0, 142, 72, 0, // Skip to: 20864
/* 2290 */    MCD::OPC_Decode, 165, 4, 48, // Opcode: FCMP_SNE_S
/* 2294 */    MCD::OPC_FilterValue, 20, 11, 0, 0, // Skip to: 2310
/* 2299 */    MCD::OPC_CheckField, 3, 2, 0, 126, 72, 0, // Skip to: 20864
/* 2306 */    MCD::OPC_Decode, 143, 4, 48, // Opcode: FCMP_COR_S
/* 2310 */    MCD::OPC_FilterValue, 21, 11, 0, 0, // Skip to: 2326
/* 2315 */    MCD::OPC_CheckField, 3, 2, 0, 110, 72, 0, // Skip to: 20864
/* 2322 */    MCD::OPC_Decode, 167, 4, 48, // Opcode: FCMP_SOR_S
/* 2326 */    MCD::OPC_FilterValue, 24, 11, 0, 0, // Skip to: 2342
/* 2331 */    MCD::OPC_CheckField, 3, 2, 0, 94, 72, 0, // Skip to: 20864
/* 2338 */    MCD::OPC_Decode, 151, 4, 48, // Opcode: FCMP_CUNE_S
/* 2342 */    MCD::OPC_FilterValue, 25, 85, 72, 0, // Skip to: 20864
/* 2347 */    MCD::OPC_CheckField, 3, 2, 0, 78, 72, 0, // Skip to: 20864
/* 2354 */    MCD::OPC_Decode, 175, 4, 48, // Opcode: FCMP_SUNE_S
/* 2358 */    MCD::OPC_FilterValue, 2, 99, 1, 0, // Skip to: 2718
/* 2363 */    MCD::OPC_ExtractField, 15, 5,  // Inst{19-15} ...
/* 2366 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2382
/* 2371 */    MCD::OPC_CheckField, 3, 2, 0, 54, 72, 0, // Skip to: 20864
/* 2378 */    MCD::OPC_Decode, 132, 4, 49, // Opcode: FCMP_CAF_D
/* 2382 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2398
/* 2387 */    MCD::OPC_CheckField, 3, 2, 0, 38, 72, 0, // Skip to: 20864
/* 2394 */    MCD::OPC_Decode, 156, 4, 49, // Opcode: FCMP_SAF_D
/* 2398 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2414
/* 2403 */    MCD::OPC_CheckField, 3, 2, 0, 22, 72, 0, // Skip to: 20864
/* 2410 */    MCD::OPC_Decode, 138, 4, 49, // Opcode: FCMP_CLT_D
/* 2414 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2430
/* 2419 */    MCD::OPC_CheckField, 3, 2, 0, 6, 72, 0, // Skip to: 20864
/* 2426 */    MCD::OPC_Decode, 162, 4, 49, // Opcode: FCMP_SLT_D
/* 2430 */    MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 2446
/* 2435 */    MCD::OPC_CheckField, 3, 2, 0, 246, 71, 0, // Skip to: 20864
/* 2442 */    MCD::OPC_Decode, 134, 4, 49, // Opcode: FCMP_CEQ_D
/* 2446 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 2462
/* 2451 */    MCD::OPC_CheckField, 3, 2, 0, 230, 71, 0, // Skip to: 20864
/* 2458 */    MCD::OPC_Decode, 158, 4, 49, // Opcode: FCMP_SEQ_D
/* 2462 */    MCD::OPC_FilterValue, 6, 11, 0, 0, // Skip to: 2478
/* 2467 */    MCD::OPC_CheckField, 3, 2, 0, 214, 71, 0, // Skip to: 20864
/* 2474 */    MCD::OPC_Decode, 136, 4, 49, // Opcode: FCMP_CLE_D
/* 2478 */    MCD::OPC_FilterValue, 7, 11, 0, 0, // Skip to: 2494
/* 2483 */    MCD::OPC_CheckField, 3, 2, 0, 198, 71, 0, // Skip to: 20864
/* 2490 */    MCD::OPC_Decode, 160, 4, 49, // Opcode: FCMP_SLE_D
/* 2494 */    MCD::OPC_FilterValue, 8, 11, 0, 0, // Skip to: 2510
/* 2499 */    MCD::OPC_CheckField, 3, 2, 0, 182, 71, 0, // Skip to: 20864
/* 2506 */    MCD::OPC_Decode, 152, 4, 49, // Opcode: FCMP_CUN_D
/* 2510 */    MCD::OPC_FilterValue, 9, 11, 0, 0, // Skip to: 2526
/* 2515 */    MCD::OPC_CheckField, 3, 2, 0, 166, 71, 0, // Skip to: 20864
/* 2522 */    MCD::OPC_Decode, 176, 4, 49, // Opcode: FCMP_SUN_D
/* 2526 */    MCD::OPC_FilterValue, 10, 11, 0, 0, // Skip to: 2542
/* 2531 */    MCD::OPC_CheckField, 3, 2, 0, 150, 71, 0, // Skip to: 20864
/* 2538 */    MCD::OPC_Decode, 148, 4, 49, // Opcode: FCMP_CULT_D
/* 2542 */    MCD::OPC_FilterValue, 11, 11, 0, 0, // Skip to: 2558
/* 2547 */    MCD::OPC_CheckField, 3, 2, 0, 134, 71, 0, // Skip to: 20864
/* 2554 */    MCD::OPC_Decode, 172, 4, 49, // Opcode: FCMP_SULT_D
/* 2558 */    MCD::OPC_FilterValue, 12, 11, 0, 0, // Skip to: 2574
/* 2563 */    MCD::OPC_CheckField, 3, 2, 0, 118, 71, 0, // Skip to: 20864
/* 2570 */    MCD::OPC_Decode, 144, 4, 49, // Opcode: FCMP_CUEQ_D
/* 2574 */    MCD::OPC_FilterValue, 13, 11, 0, 0, // Skip to: 2590
/* 2579 */    MCD::OPC_CheckField, 3, 2, 0, 102, 71, 0, // Skip to: 20864
/* 2586 */    MCD::OPC_Decode, 168, 4, 49, // Opcode: FCMP_SUEQ_D
/* 2590 */    MCD::OPC_FilterValue, 14, 11, 0, 0, // Skip to: 2606
/* 2595 */    MCD::OPC_CheckField, 3, 2, 0, 86, 71, 0, // Skip to: 20864
/* 2602 */    MCD::OPC_Decode, 146, 4, 49, // Opcode: FCMP_CULE_D
/* 2606 */    MCD::OPC_FilterValue, 15, 11, 0, 0, // Skip to: 2622
/* 2611 */    MCD::OPC_CheckField, 3, 2, 0, 70, 71, 0, // Skip to: 20864
/* 2618 */    MCD::OPC_Decode, 170, 4, 49, // Opcode: FCMP_SULE_D
/* 2622 */    MCD::OPC_FilterValue, 16, 11, 0, 0, // Skip to: 2638
/* 2627 */    MCD::OPC_CheckField, 3, 2, 0, 54, 71, 0, // Skip to: 20864
/* 2634 */    MCD::OPC_Decode, 140, 4, 49, // Opcode: FCMP_CNE_D
/* 2638 */    MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 2654
/* 2643 */    MCD::OPC_CheckField, 3, 2, 0, 38, 71, 0, // Skip to: 20864
/* 2650 */    MCD::OPC_Decode, 164, 4, 49, // Opcode: FCMP_SNE_D
/* 2654 */    MCD::OPC_FilterValue, 20, 11, 0, 0, // Skip to: 2670
/* 2659 */    MCD::OPC_CheckField, 3, 2, 0, 22, 71, 0, // Skip to: 20864
/* 2666 */    MCD::OPC_Decode, 142, 4, 49, // Opcode: FCMP_COR_D
/* 2670 */    MCD::OPC_FilterValue, 21, 11, 0, 0, // Skip to: 2686
/* 2675 */    MCD::OPC_CheckField, 3, 2, 0, 6, 71, 0, // Skip to: 20864
/* 2682 */    MCD::OPC_Decode, 166, 4, 49, // Opcode: FCMP_SOR_D
/* 2686 */    MCD::OPC_FilterValue, 24, 11, 0, 0, // Skip to: 2702
/* 2691 */    MCD::OPC_CheckField, 3, 2, 0, 246, 70, 0, // Skip to: 20864
/* 2698 */    MCD::OPC_Decode, 150, 4, 49, // Opcode: FCMP_CUNE_D
/* 2702 */    MCD::OPC_FilterValue, 25, 237, 70, 0, // Skip to: 20864
/* 2707 */    MCD::OPC_CheckField, 3, 2, 0, 230, 70, 0, // Skip to: 20864
/* 2714 */    MCD::OPC_Decode, 174, 4, 49, // Opcode: FCMP_SUNE_D
/* 2718 */    MCD::OPC_FilterValue, 5, 201, 0, 0, // Skip to: 2924
/* 2723 */    MCD::OPC_ExtractField, 15, 5,  // Inst{19-15} ...
/* 2726 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2735
/* 2731 */    MCD::OPC_Decode, 228, 7, 50, // Opcode: VFCMP_CAF_S
/* 2735 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2744
/* 2740 */    MCD::OPC_Decode, 250, 7, 50, // Opcode: VFCMP_SAF_S
/* 2744 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2753
/* 2749 */    MCD::OPC_Decode, 234, 7, 50, // Opcode: VFCMP_CLT_S
/* 2753 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 2762
/* 2758 */    MCD::OPC_Decode, 128, 8, 50, // Opcode: VFCMP_SLT_S
/* 2762 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 2771
/* 2767 */    MCD::OPC_Decode, 230, 7, 50, // Opcode: VFCMP_CEQ_S
/* 2771 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 2780
/* 2776 */    MCD::OPC_Decode, 252, 7, 50, // Opcode: VFCMP_SEQ_S
/* 2780 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 2789
/* 2785 */    MCD::OPC_Decode, 232, 7, 50, // Opcode: VFCMP_CLE_S
/* 2789 */    MCD::OPC_FilterValue, 7, 4, 0, 0, // Skip to: 2798
/* 2794 */    MCD::OPC_Decode, 254, 7, 50, // Opcode: VFCMP_SLE_S
/* 2798 */    MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 2807
/* 2803 */    MCD::OPC_Decode, 248, 7, 50, // Opcode: VFCMP_CUN_S
/* 2807 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 2816
/* 2812 */    MCD::OPC_Decode, 142, 8, 50, // Opcode: VFCMP_SUN_S
/* 2816 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 2825
/* 2821 */    MCD::OPC_Decode, 244, 7, 50, // Opcode: VFCMP_CULT_S
/* 2825 */    MCD::OPC_FilterValue, 11, 4, 0, 0, // Skip to: 2834
/* 2830 */    MCD::OPC_Decode, 138, 8, 50, // Opcode: VFCMP_SULT_S
/* 2834 */    MCD::OPC_FilterValue, 12, 4, 0, 0, // Skip to: 2843
/* 2839 */    MCD::OPC_Decode, 240, 7, 50, // Opcode: VFCMP_CUEQ_S
/* 2843 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 2852
/* 2848 */    MCD::OPC_Decode, 134, 8, 50, // Opcode: VFCMP_SUEQ_S
/* 2852 */    MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 2861
/* 2857 */    MCD::OPC_Decode, 242, 7, 50, // Opcode: VFCMP_CULE_S
/* 2861 */    MCD::OPC_FilterValue, 15, 4, 0, 0, // Skip to: 2870
/* 2866 */    MCD::OPC_Decode, 136, 8, 50, // Opcode: VFCMP_SULE_S
/* 2870 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 2879
/* 2875 */    MCD::OPC_Decode, 236, 7, 50, // Opcode: VFCMP_CNE_S
/* 2879 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 2888
/* 2884 */    MCD::OPC_Decode, 130, 8, 50, // Opcode: VFCMP_SNE_S
/* 2888 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 2897
/* 2893 */    MCD::OPC_Decode, 238, 7, 50, // Opcode: VFCMP_COR_S
/* 2897 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 2906
/* 2902 */    MCD::OPC_Decode, 132, 8, 50, // Opcode: VFCMP_SOR_S
/* 2906 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 2915
/* 2911 */    MCD::OPC_Decode, 246, 7, 50, // Opcode: VFCMP_CUNE_S
/* 2915 */    MCD::OPC_FilterValue, 25, 24, 70, 0, // Skip to: 20864
/* 2920 */    MCD::OPC_Decode, 140, 8, 50, // Opcode: VFCMP_SUNE_S
/* 2924 */    MCD::OPC_FilterValue, 6, 201, 0, 0, // Skip to: 3130
/* 2929 */    MCD::OPC_ExtractField, 15, 5,  // Inst{19-15} ...
/* 2932 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2941
/* 2937 */    MCD::OPC_Decode, 227, 7, 51, // Opcode: VFCMP_CAF_D
/* 2941 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2950
/* 2946 */    MCD::OPC_Decode, 249, 7, 51, // Opcode: VFCMP_SAF_D
/* 2950 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2959
/* 2955 */    MCD::OPC_Decode, 233, 7, 51, // Opcode: VFCMP_CLT_D
/* 2959 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 2968
/* 2964 */    MCD::OPC_Decode, 255, 7, 51, // Opcode: VFCMP_SLT_D
/* 2968 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 2977
/* 2973 */    MCD::OPC_Decode, 229, 7, 51, // Opcode: VFCMP_CEQ_D
/* 2977 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 2986
/* 2982 */    MCD::OPC_Decode, 251, 7, 51, // Opcode: VFCMP_SEQ_D
/* 2986 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 2995
/* 2991 */    MCD::OPC_Decode, 231, 7, 51, // Opcode: VFCMP_CLE_D
/* 2995 */    MCD::OPC_FilterValue, 7, 4, 0, 0, // Skip to: 3004
/* 3000 */    MCD::OPC_Decode, 253, 7, 51, // Opcode: VFCMP_SLE_D
/* 3004 */    MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 3013
/* 3009 */    MCD::OPC_Decode, 247, 7, 51, // Opcode: VFCMP_CUN_D
/* 3013 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 3022
/* 3018 */    MCD::OPC_Decode, 141, 8, 51, // Opcode: VFCMP_SUN_D
/* 3022 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 3031
/* 3027 */    MCD::OPC_Decode, 243, 7, 51, // Opcode: VFCMP_CULT_D
/* 3031 */    MCD::OPC_FilterValue, 11, 4, 0, 0, // Skip to: 3040
/* 3036 */    MCD::OPC_Decode, 137, 8, 51, // Opcode: VFCMP_SULT_D
/* 3040 */    MCD::OPC_FilterValue, 12, 4, 0, 0, // Skip to: 3049
/* 3045 */    MCD::OPC_Decode, 239, 7, 51, // Opcode: VFCMP_CUEQ_D
/* 3049 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 3058
/* 3054 */    MCD::OPC_Decode, 133, 8, 51, // Opcode: VFCMP_SUEQ_D
/* 3058 */    MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 3067
/* 3063 */    MCD::OPC_Decode, 241, 7, 51, // Opcode: VFCMP_CULE_D
/* 3067 */    MCD::OPC_FilterValue, 15, 4, 0, 0, // Skip to: 3076
/* 3072 */    MCD::OPC_Decode, 135, 8, 51, // Opcode: VFCMP_SULE_D
/* 3076 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 3085
/* 3081 */    MCD::OPC_Decode, 235, 7, 51, // Opcode: VFCMP_CNE_D
/* 3085 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 3094
/* 3090 */    MCD::OPC_Decode, 129, 8, 51, // Opcode: VFCMP_SNE_D
/* 3094 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 3103
/* 3099 */    MCD::OPC_Decode, 237, 7, 51, // Opcode: VFCMP_COR_D
/* 3103 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 3112
/* 3108 */    MCD::OPC_Decode, 131, 8, 51, // Opcode: VFCMP_SOR_D
/* 3112 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 3121
/* 3117 */    MCD::OPC_Decode, 245, 7, 51, // Opcode: VFCMP_CUNE_D
/* 3121 */    MCD::OPC_FilterValue, 25, 74, 69, 0, // Skip to: 20864
/* 3126 */    MCD::OPC_Decode, 139, 8, 51, // Opcode: VFCMP_SUNE_D
/* 3130 */    MCD::OPC_FilterValue, 9, 201, 0, 0, // Skip to: 3336
/* 3135 */    MCD::OPC_ExtractField, 15, 5,  // Inst{19-15} ...
/* 3138 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3147
/* 3143 */    MCD::OPC_Decode, 229, 13, 52, // Opcode: XVFCMP_CAF_S
/* 3147 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3156
/* 3152 */    MCD::OPC_Decode, 251, 13, 52, // Opcode: XVFCMP_SAF_S
/* 3156 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3165
/* 3161 */    MCD::OPC_Decode, 235, 13, 52, // Opcode: XVFCMP_CLT_S
/* 3165 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 3174
/* 3170 */    MCD::OPC_Decode, 129, 14, 52, // Opcode: XVFCMP_SLT_S
/* 3174 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 3183
/* 3179 */    MCD::OPC_Decode, 231, 13, 52, // Opcode: XVFCMP_CEQ_S
/* 3183 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 3192
/* 3188 */    MCD::OPC_Decode, 253, 13, 52, // Opcode: XVFCMP_SEQ_S
/* 3192 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 3201
/* 3197 */    MCD::OPC_Decode, 233, 13, 52, // Opcode: XVFCMP_CLE_S
/* 3201 */    MCD::OPC_FilterValue, 7, 4, 0, 0, // Skip to: 3210
/* 3206 */    MCD::OPC_Decode, 255, 13, 52, // Opcode: XVFCMP_SLE_S
/* 3210 */    MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 3219
/* 3215 */    MCD::OPC_Decode, 249, 13, 52, // Opcode: XVFCMP_CUN_S
/* 3219 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 3228
/* 3224 */    MCD::OPC_Decode, 143, 14, 52, // Opcode: XVFCMP_SUN_S
/* 3228 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 3237
/* 3233 */    MCD::OPC_Decode, 245, 13, 52, // Opcode: XVFCMP_CULT_S
/* 3237 */    MCD::OPC_FilterValue, 11, 4, 0, 0, // Skip to: 3246
/* 3242 */    MCD::OPC_Decode, 139, 14, 52, // Opcode: XVFCMP_SULT_S
/* 3246 */    MCD::OPC_FilterValue, 12, 4, 0, 0, // Skip to: 3255
/* 3251 */    MCD::OPC_Decode, 241, 13, 52, // Opcode: XVFCMP_CUEQ_S
/* 3255 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 3264
/* 3260 */    MCD::OPC_Decode, 135, 14, 52, // Opcode: XVFCMP_SUEQ_S
/* 3264 */    MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 3273
/* 3269 */    MCD::OPC_Decode, 243, 13, 52, // Opcode: XVFCMP_CULE_S
/* 3273 */    MCD::OPC_FilterValue, 15, 4, 0, 0, // Skip to: 3282
/* 3278 */    MCD::OPC_Decode, 137, 14, 52, // Opcode: XVFCMP_SULE_S
/* 3282 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 3291
/* 3287 */    MCD::OPC_Decode, 237, 13, 52, // Opcode: XVFCMP_CNE_S
/* 3291 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 3300
/* 3296 */    MCD::OPC_Decode, 131, 14, 52, // Opcode: XVFCMP_SNE_S
/* 3300 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 3309
/* 3305 */    MCD::OPC_Decode, 239, 13, 52, // Opcode: XVFCMP_COR_S
/* 3309 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 3318
/* 3314 */    MCD::OPC_Decode, 133, 14, 52, // Opcode: XVFCMP_SOR_S
/* 3318 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 3327
/* 3323 */    MCD::OPC_Decode, 247, 13, 52, // Opcode: XVFCMP_CUNE_S
/* 3327 */    MCD::OPC_FilterValue, 25, 124, 68, 0, // Skip to: 20864
/* 3332 */    MCD::OPC_Decode, 141, 14, 52, // Opcode: XVFCMP_SUNE_S
/* 3336 */    MCD::OPC_FilterValue, 10, 201, 0, 0, // Skip to: 3542
/* 3341 */    MCD::OPC_ExtractField, 15, 5,  // Inst{19-15} ...
/* 3344 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3353
/* 3349 */    MCD::OPC_Decode, 228, 13, 53, // Opcode: XVFCMP_CAF_D
/* 3353 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3362
/* 3358 */    MCD::OPC_Decode, 250, 13, 53, // Opcode: XVFCMP_SAF_D
/* 3362 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3371
/* 3367 */    MCD::OPC_Decode, 234, 13, 53, // Opcode: XVFCMP_CLT_D
/* 3371 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 3380
/* 3376 */    MCD::OPC_Decode, 128, 14, 53, // Opcode: XVFCMP_SLT_D
/* 3380 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 3389
/* 3385 */    MCD::OPC_Decode, 230, 13, 53, // Opcode: XVFCMP_CEQ_D
/* 3389 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 3398
/* 3394 */    MCD::OPC_Decode, 252, 13, 53, // Opcode: XVFCMP_SEQ_D
/* 3398 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 3407
/* 3403 */    MCD::OPC_Decode, 232, 13, 53, // Opcode: XVFCMP_CLE_D
/* 3407 */    MCD::OPC_FilterValue, 7, 4, 0, 0, // Skip to: 3416
/* 3412 */    MCD::OPC_Decode, 254, 13, 53, // Opcode: XVFCMP_SLE_D
/* 3416 */    MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 3425
/* 3421 */    MCD::OPC_Decode, 248, 13, 53, // Opcode: XVFCMP_CUN_D
/* 3425 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 3434
/* 3430 */    MCD::OPC_Decode, 142, 14, 53, // Opcode: XVFCMP_SUN_D
/* 3434 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 3443
/* 3439 */    MCD::OPC_Decode, 244, 13, 53, // Opcode: XVFCMP_CULT_D
/* 3443 */    MCD::OPC_FilterValue, 11, 4, 0, 0, // Skip to: 3452
/* 3448 */    MCD::OPC_Decode, 138, 14, 53, // Opcode: XVFCMP_SULT_D
/* 3452 */    MCD::OPC_FilterValue, 12, 4, 0, 0, // Skip to: 3461
/* 3457 */    MCD::OPC_Decode, 240, 13, 53, // Opcode: XVFCMP_CUEQ_D
/* 3461 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 3470
/* 3466 */    MCD::OPC_Decode, 134, 14, 53, // Opcode: XVFCMP_SUEQ_D
/* 3470 */    MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 3479
/* 3475 */    MCD::OPC_Decode, 242, 13, 53, // Opcode: XVFCMP_CULE_D
/* 3479 */    MCD::OPC_FilterValue, 15, 4, 0, 0, // Skip to: 3488
/* 3484 */    MCD::OPC_Decode, 136, 14, 53, // Opcode: XVFCMP_SULE_D
/* 3488 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 3497
/* 3493 */    MCD::OPC_Decode, 236, 13, 53, // Opcode: XVFCMP_CNE_D
/* 3497 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 3506
/* 3502 */    MCD::OPC_Decode, 130, 14, 53, // Opcode: XVFCMP_SNE_D
/* 3506 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 3515
/* 3511 */    MCD::OPC_Decode, 238, 13, 53, // Opcode: XVFCMP_COR_D
/* 3515 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 3524
/* 3520 */    MCD::OPC_Decode, 132, 14, 53, // Opcode: XVFCMP_SOR_D
/* 3524 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 3533
/* 3529 */    MCD::OPC_Decode, 246, 13, 53, // Opcode: XVFCMP_CUNE_D
/* 3533 */    MCD::OPC_FilterValue, 25, 174, 67, 0, // Skip to: 20864
/* 3538 */    MCD::OPC_Decode, 140, 14, 53, // Opcode: XVFCMP_SUNE_D
/* 3542 */    MCD::OPC_FilterValue, 16, 11, 0, 0, // Skip to: 3558
/* 3547 */    MCD::OPC_CheckField, 18, 2, 0, 158, 67, 0, // Skip to: 20864
/* 3554 */    MCD::OPC_Decode, 229, 4, 54, // Opcode: FSEL_T_S
/* 3558 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 3567
/* 3563 */    MCD::OPC_Decode, 170, 7, 55, // Opcode: VBITSEL_V
/* 3567 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 3576
/* 3572 */    MCD::OPC_Decode, 183, 13, 56, // Opcode: XVBITSEL_V
/* 3576 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 3585
/* 3581 */    MCD::OPC_Decode, 241, 10, 55, // Opcode: VSHUF_B
/* 3585 */    MCD::OPC_FilterValue, 22, 122, 67, 0, // Skip to: 20864
/* 3590 */    MCD::OPC_Decode, 129, 17, 56, // Opcode: XVSHUF_B
/* 3594 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 3603
/* 3599 */    MCD::OPC_Decode, 135, 3, 57, // Opcode: ADDU16I_D
/* 3603 */    MCD::OPC_FilterValue, 5, 21, 0, 0, // Skip to: 3629
/* 3608 */    MCD::OPC_ExtractField, 25, 1,  // Inst{25} ...
/* 3611 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3620
/* 3616 */    MCD::OPC_Decode, 199, 5, 58, // Opcode: LU12I_W
/* 3620 */    MCD::OPC_FilterValue, 1, 87, 67, 0, // Skip to: 20864
/* 3625 */    MCD::OPC_Decode, 202, 5, 58, // Opcode: LU32I_D
/* 3629 */    MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 3655
/* 3634 */    MCD::OPC_ExtractField, 25, 1,  // Inst{25} ...
/* 3637 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3646
/* 3642 */    MCD::OPC_Decode, 252, 5, 58, // Opcode: PCADDI
/* 3646 */    MCD::OPC_FilterValue, 1, 61, 67, 0, // Skip to: 20864
/* 3651 */    MCD::OPC_Decode, 131, 6, 58, // Opcode: PCALAU12I
/* 3655 */    MCD::OPC_FilterValue, 7, 21, 0, 0, // Skip to: 3681
/* 3660 */    MCD::OPC_ExtractField, 25, 1,  // Inst{25} ...
/* 3663 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3672
/* 3668 */    MCD::OPC_Decode, 254, 5, 58, // Opcode: PCADDU12I
/* 3672 */    MCD::OPC_FilterValue, 1, 35, 67, 0, // Skip to: 20864
/* 3677 */    MCD::OPC_Decode, 130, 6, 58, // Opcode: PCADDU18I
/* 3681 */    MCD::OPC_FilterValue, 8, 21, 0, 0, // Skip to: 3707
/* 3686 */    MCD::OPC_ExtractField, 24, 2,  // Inst{25-24} ...
/* 3689 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3698
/* 3694 */    MCD::OPC_Decode, 197, 5, 59, // Opcode: LL_D
/* 3698 */    MCD::OPC_FilterValue, 3, 9, 67, 0, // Skip to: 20864
/* 3703 */    MCD::OPC_Decode, 154, 6, 59, // Opcode: SC_D
/* 3707 */    MCD::OPC_FilterValue, 9, 39, 0, 0, // Skip to: 3751
/* 3712 */    MCD::OPC_ExtractField, 24, 2,  // Inst{25-24} ...
/* 3715 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3724
/* 3720 */    MCD::OPC_Decode, 166, 5, 59, // Opcode: LDPTR_W
/* 3724 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3733
/* 3729 */    MCD::OPC_Decode, 189, 6, 59, // Opcode: STPTR_W
/* 3733 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3742
/* 3738 */    MCD::OPC_Decode, 165, 5, 59, // Opcode: LDPTR_D
/* 3742 */    MCD::OPC_FilterValue, 3, 221, 66, 0, // Skip to: 20864
/* 3747 */    MCD::OPC_Decode, 188, 6, 59, // Opcode: STPTR_D
/* 3751 */    MCD::OPC_FilterValue, 10, 147, 0, 0, // Skip to: 3903
/* 3756 */    MCD::OPC_ExtractField, 22, 4,  // Inst{25-22} ...
/* 3759 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3768
/* 3764 */    MCD::OPC_Decode, 181, 5, 60, // Opcode: LD_B
/* 3768 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3777
/* 3773 */    MCD::OPC_Decode, 188, 5, 60, // Opcode: LD_H
/* 3777 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3786
/* 3782 */    MCD::OPC_Decode, 192, 5, 60, // Opcode: LD_W
/* 3786 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 3795
/* 3791 */    MCD::OPC_Decode, 185, 5, 60, // Opcode: LD_D
/* 3795 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 3804
/* 3800 */    MCD::OPC_Decode, 198, 6, 60, // Opcode: ST_B
/* 3804 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 3813
/* 3809 */    MCD::OPC_Decode, 201, 6, 60, // Opcode: ST_H
/* 3813 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 3822
/* 3818 */    MCD::OPC_Decode, 203, 6, 60, // Opcode: ST_W
/* 3822 */    MCD::OPC_FilterValue, 7, 4, 0, 0, // Skip to: 3831
/* 3827 */    MCD::OPC_Decode, 200, 6, 60, // Opcode: ST_D
/* 3831 */    MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 3840
/* 3836 */    MCD::OPC_Decode, 183, 5, 60, // Opcode: LD_BU
/* 3840 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 3849
/* 3845 */    MCD::OPC_Decode, 190, 5, 60, // Opcode: LD_HU
/* 3849 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 3858
/* 3854 */    MCD::OPC_Decode, 194, 5, 60, // Opcode: LD_WU
/* 3858 */    MCD::OPC_FilterValue, 11, 4, 0, 0, // Skip to: 3867
/* 3863 */    MCD::OPC_Decode, 135, 6, 61, // Opcode: PRELD_Raw
/* 3867 */    MCD::OPC_FilterValue, 12, 4, 0, 0, // Skip to: 3876
/* 3872 */    MCD::OPC_Decode, 195, 4, 62, // Opcode: FLD_S
/* 3876 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 3885
/* 3881 */    MCD::OPC_Decode, 239, 4, 62, // Opcode: FST_S
/* 3885 */    MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 3894
/* 3890 */    MCD::OPC_Decode, 194, 4, 62, // Opcode: FLD_D
/* 3894 */    MCD::OPC_FilterValue, 15, 69, 66, 0, // Skip to: 20864
/* 3899 */    MCD::OPC_Decode, 238, 4, 62, // Opcode: FST_D
/* 3903 */    MCD::OPC_FilterValue, 11, 39, 0, 0, // Skip to: 3947
/* 3908 */    MCD::OPC_ExtractField, 22, 4,  // Inst{25-22} ...
/* 3911 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3920
/* 3916 */    MCD::OPC_Decode, 129, 9, 63, // Opcode: VLD
/* 3920 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3929
/* 3925 */    MCD::OPC_Decode, 183, 12, 63, // Opcode: VST
/* 3929 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3938
/* 3934 */    MCD::OPC_Decode, 131, 15, 64, // Opcode: XVLD
/* 3938 */    MCD::OPC_FilterValue, 3, 25, 66, 0, // Skip to: 20864
/* 3943 */    MCD::OPC_Decode, 207, 18, 64, // Opcode: XVST
/* 3947 */    MCD::OPC_FilterValue, 12, 1, 1, 0, // Skip to: 4209
/* 3952 */    MCD::OPC_ExtractField, 23, 3,  // Inst{25-23} ...
/* 3955 */    MCD::OPC_FilterValue, 0, 44, 0, 0, // Skip to: 4004
/* 3960 */    MCD::OPC_ExtractField, 21, 2,  // Inst{22-21} ...
/* 3963 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3979
/* 3968 */    MCD::OPC_CheckField, 19, 2, 2, 249, 65, 0, // Skip to: 20864
/* 3975 */    MCD::OPC_Decode, 136, 9, 65, // Opcode: VLDREPL_D
/* 3979 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 3995
/* 3984 */    MCD::OPC_CheckField, 20, 1, 0, 233, 65, 0, // Skip to: 20864
/* 3991 */    MCD::OPC_Decode, 138, 9, 65, // Opcode: VLDREPL_W
/* 3995 */    MCD::OPC_FilterValue, 2, 224, 65, 0, // Skip to: 20864
/* 4000 */    MCD::OPC_Decode, 137, 9, 65, // Opcode: VLDREPL_H
/* 4004 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 4020
/* 4009 */    MCD::OPC_CheckField, 22, 1, 0, 208, 65, 0, // Skip to: 20864
/* 4016 */    MCD::OPC_Decode, 135, 9, 65, // Opcode: VLDREPL_B
/* 4020 */    MCD::OPC_FilterValue, 2, 44, 0, 0, // Skip to: 4069
/* 4025 */    MCD::OPC_ExtractField, 21, 2,  // Inst{22-21} ...
/* 4028 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4044
/* 4033 */    MCD::OPC_CheckField, 19, 2, 2, 184, 65, 0, // Skip to: 20864
/* 4040 */    MCD::OPC_Decode, 185, 12, 66, // Opcode: VSTELM_D
/* 4044 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 4060
/* 4049 */    MCD::OPC_CheckField, 20, 1, 0, 168, 65, 0, // Skip to: 20864
/* 4056 */    MCD::OPC_Decode, 187, 12, 66, // Opcode: VSTELM_W
/* 4060 */    MCD::OPC_FilterValue, 2, 159, 65, 0, // Skip to: 20864
/* 4065 */    MCD::OPC_Decode, 186, 12, 66, // Opcode: VSTELM_H
/* 4069 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 4085
/* 4074 */    MCD::OPC_CheckField, 22, 1, 0, 143, 65, 0, // Skip to: 20864
/* 4081 */    MCD::OPC_Decode, 184, 12, 66, // Opcode: VSTELM_B
/* 4085 */    MCD::OPC_FilterValue, 4, 44, 0, 0, // Skip to: 4134
/* 4090 */    MCD::OPC_ExtractField, 21, 2,  // Inst{22-21} ...
/* 4093 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4109
/* 4098 */    MCD::OPC_CheckField, 19, 2, 2, 119, 65, 0, // Skip to: 20864
/* 4105 */    MCD::OPC_Decode, 138, 15, 67, // Opcode: XVLDREPL_D
/* 4109 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 4125
/* 4114 */    MCD::OPC_CheckField, 20, 1, 0, 103, 65, 0, // Skip to: 20864
/* 4121 */    MCD::OPC_Decode, 140, 15, 67, // Opcode: XVLDREPL_W
/* 4125 */    MCD::OPC_FilterValue, 2, 94, 65, 0, // Skip to: 20864
/* 4130 */    MCD::OPC_Decode, 139, 15, 67, // Opcode: XVLDREPL_H
/* 4134 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 4150
/* 4139 */    MCD::OPC_CheckField, 22, 1, 0, 78, 65, 0, // Skip to: 20864
/* 4146 */    MCD::OPC_Decode, 137, 15, 67, // Opcode: XVLDREPL_B
/* 4150 */    MCD::OPC_FilterValue, 6, 45, 0, 0, // Skip to: 4200
/* 4155 */    MCD::OPC_ExtractField, 22, 1,  // Inst{22} ...
/* 4158 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 4191
/* 4163 */    MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 4166 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4182
/* 4171 */    MCD::OPC_CheckField, 20, 1, 1, 46, 65, 0, // Skip to: 20864
/* 4178 */    MCD::OPC_Decode, 209, 18, 68, // Opcode: XVSTELM_D
/* 4182 */    MCD::OPC_FilterValue, 1, 37, 65, 0, // Skip to: 20864
/* 4187 */    MCD::OPC_Decode, 211, 18, 68, // Opcode: XVSTELM_W
/* 4191 */    MCD::OPC_FilterValue, 1, 28, 65, 0, // Skip to: 20864
/* 4196 */    MCD::OPC_Decode, 210, 18, 68, // Opcode: XVSTELM_H
/* 4200 */    MCD::OPC_FilterValue, 7, 19, 65, 0, // Skip to: 20864
/* 4205 */    MCD::OPC_Decode, 208, 18, 68, // Opcode: XVSTELM_B
/* 4209 */    MCD::OPC_FilterValue, 14, 10, 3, 0, // Skip to: 4992
/* 4214 */    MCD::OPC_ExtractField, 15, 11,  // Inst{25-15} ...
/* 4217 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4226
/* 4222 */    MCD::OPC_Decode, 168, 5, 69, // Opcode: LDX_B
/* 4226 */    MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 4235
/* 4231 */    MCD::OPC_Decode, 174, 5, 69, // Opcode: LDX_H
/* 4235 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 4244
/* 4240 */    MCD::OPC_Decode, 178, 5, 69, // Opcode: LDX_W
/* 4244 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 4253
/* 4249 */    MCD::OPC_Decode, 172, 5, 69, // Opcode: LDX_D
/* 4253 */    MCD::OPC_FilterValue, 32, 4, 0, 0, // Skip to: 4262
/* 4258 */    MCD::OPC_Decode, 191, 6, 69, // Opcode: STX_B
/* 4262 */    MCD::OPC_FilterValue, 40, 4, 0, 0, // Skip to: 4271
/* 4267 */    MCD::OPC_Decode, 194, 6, 69, // Opcode: STX_H
/* 4271 */    MCD::OPC_FilterValue, 48, 4, 0, 0, // Skip to: 4280
/* 4276 */    MCD::OPC_Decode, 196, 6, 69, // Opcode: STX_W
/* 4280 */    MCD::OPC_FilterValue, 56, 4, 0, 0, // Skip to: 4289
/* 4285 */    MCD::OPC_Decode, 193, 6, 69, // Opcode: STX_D
/* 4289 */    MCD::OPC_FilterValue, 64, 4, 0, 0, // Skip to: 4298
/* 4294 */    MCD::OPC_Decode, 170, 5, 69, // Opcode: LDX_BU
/* 4298 */    MCD::OPC_FilterValue, 72, 4, 0, 0, // Skip to: 4307
/* 4303 */    MCD::OPC_Decode, 176, 5, 69, // Opcode: LDX_HU
/* 4307 */    MCD::OPC_FilterValue, 80, 4, 0, 0, // Skip to: 4316
/* 4312 */    MCD::OPC_Decode, 180, 5, 69, // Opcode: LDX_WU
/* 4316 */    MCD::OPC_FilterValue, 96, 4, 0, 0, // Skip to: 4325
/* 4321 */    MCD::OPC_Decode, 193, 4, 70, // Opcode: FLDX_S
/* 4325 */    MCD::OPC_FilterValue, 104, 4, 0, 0, // Skip to: 4334
/* 4330 */    MCD::OPC_Decode, 192, 4, 71, // Opcode: FLDX_D
/* 4334 */    MCD::OPC_FilterValue, 112, 4, 0, 0, // Skip to: 4343
/* 4339 */    MCD::OPC_Decode, 237, 4, 70, // Opcode: FSTX_S
/* 4343 */    MCD::OPC_FilterValue, 120, 4, 0, 0, // Skip to: 4352
/* 4348 */    MCD::OPC_Decode, 236, 4, 71, // Opcode: FSTX_D
/* 4352 */    MCD::OPC_FilterValue, 128, 1, 4, 0, 0, // Skip to: 4362
/* 4358 */    MCD::OPC_Decode, 139, 9, 72, // Opcode: VLDX
/* 4362 */    MCD::OPC_FilterValue, 136, 1, 4, 0, 0, // Skip to: 4372
/* 4368 */    MCD::OPC_Decode, 188, 12, 72, // Opcode: VSTX
/* 4372 */    MCD::OPC_FilterValue, 144, 1, 4, 0, 0, // Skip to: 4382
/* 4378 */    MCD::OPC_Decode, 141, 15, 73, // Opcode: XVLDX
/* 4382 */    MCD::OPC_FilterValue, 152, 1, 4, 0, 0, // Skip to: 4392
/* 4388 */    MCD::OPC_Decode, 212, 18, 73, // Opcode: XVSTX
/* 4392 */    MCD::OPC_FilterValue, 192, 1, 4, 0, 0, // Skip to: 4402
/* 4398 */    MCD::OPC_Decode, 173, 3, 74, // Opcode: AMSWAP_W
/* 4402 */    MCD::OPC_FilterValue, 193, 1, 4, 0, 0, // Skip to: 4412
/* 4408 */    MCD::OPC_Decode, 170, 3, 74, // Opcode: AMSWAP_D
/* 4412 */    MCD::OPC_FilterValue, 194, 1, 4, 0, 0, // Skip to: 4422
/* 4418 */    MCD::OPC_Decode, 145, 3, 74, // Opcode: AMADD_W
/* 4422 */    MCD::OPC_FilterValue, 195, 1, 4, 0, 0, // Skip to: 4432
/* 4428 */    MCD::OPC_Decode, 142, 3, 74, // Opcode: AMADD_D
/* 4432 */    MCD::OPC_FilterValue, 196, 1, 4, 0, 0, // Skip to: 4442
/* 4438 */    MCD::OPC_Decode, 149, 3, 74, // Opcode: AMAND_W
/* 4442 */    MCD::OPC_FilterValue, 197, 1, 4, 0, 0, // Skip to: 4452
/* 4448 */    MCD::OPC_Decode, 146, 3, 74, // Opcode: AMAND_D
/* 4452 */    MCD::OPC_FilterValue, 198, 1, 4, 0, 0, // Skip to: 4462
/* 4458 */    MCD::OPC_Decode, 169, 3, 74, // Opcode: AMOR_W
/* 4462 */    MCD::OPC_FilterValue, 199, 1, 4, 0, 0, // Skip to: 4472
/* 4468 */    MCD::OPC_Decode, 166, 3, 74, // Opcode: AMOR_D
/* 4472 */    MCD::OPC_FilterValue, 200, 1, 4, 0, 0, // Skip to: 4482
/* 4478 */    MCD::OPC_Decode, 177, 3, 74, // Opcode: AMXOR_W
/* 4482 */    MCD::OPC_FilterValue, 201, 1, 4, 0, 0, // Skip to: 4492
/* 4488 */    MCD::OPC_Decode, 174, 3, 74, // Opcode: AMXOR_D
/* 4492 */    MCD::OPC_FilterValue, 202, 1, 4, 0, 0, // Skip to: 4502
/* 4498 */    MCD::OPC_Decode, 156, 3, 74, // Opcode: AMMAX_W
/* 4502 */    MCD::OPC_FilterValue, 203, 1, 4, 0, 0, // Skip to: 4512
/* 4508 */    MCD::OPC_Decode, 150, 3, 74, // Opcode: AMMAX_D
/* 4512 */    MCD::OPC_FilterValue, 204, 1, 4, 0, 0, // Skip to: 4522
/* 4518 */    MCD::OPC_Decode, 164, 3, 74, // Opcode: AMMIN_W
/* 4522 */    MCD::OPC_FilterValue, 205, 1, 4, 0, 0, // Skip to: 4532
/* 4528 */    MCD::OPC_Decode, 158, 3, 74, // Opcode: AMMIN_D
/* 4532 */    MCD::OPC_FilterValue, 206, 1, 4, 0, 0, // Skip to: 4542
/* 4538 */    MCD::OPC_Decode, 157, 3, 74, // Opcode: AMMAX_WU
/* 4542 */    MCD::OPC_FilterValue, 207, 1, 4, 0, 0, // Skip to: 4552
/* 4548 */    MCD::OPC_Decode, 155, 3, 74, // Opcode: AMMAX_DU
/* 4552 */    MCD::OPC_FilterValue, 208, 1, 4, 0, 0, // Skip to: 4562
/* 4558 */    MCD::OPC_Decode, 165, 3, 74, // Opcode: AMMIN_WU
/* 4562 */    MCD::OPC_FilterValue, 209, 1, 4, 0, 0, // Skip to: 4572
/* 4568 */    MCD::OPC_Decode, 163, 3, 74, // Opcode: AMMIN_DU
/* 4572 */    MCD::OPC_FilterValue, 210, 1, 4, 0, 0, // Skip to: 4582
/* 4578 */    MCD::OPC_Decode, 172, 3, 74, // Opcode: AMSWAP_DB_W
/* 4582 */    MCD::OPC_FilterValue, 211, 1, 4, 0, 0, // Skip to: 4592
/* 4588 */    MCD::OPC_Decode, 171, 3, 74, // Opcode: AMSWAP_DB_D
/* 4592 */    MCD::OPC_FilterValue, 212, 1, 4, 0, 0, // Skip to: 4602
/* 4598 */    MCD::OPC_Decode, 144, 3, 74, // Opcode: AMADD_DB_W
/* 4602 */    MCD::OPC_FilterValue, 213, 1, 4, 0, 0, // Skip to: 4612
/* 4608 */    MCD::OPC_Decode, 143, 3, 74, // Opcode: AMADD_DB_D
/* 4612 */    MCD::OPC_FilterValue, 214, 1, 4, 0, 0, // Skip to: 4622
/* 4618 */    MCD::OPC_Decode, 148, 3, 74, // Opcode: AMAND_DB_W
/* 4622 */    MCD::OPC_FilterValue, 215, 1, 4, 0, 0, // Skip to: 4632
/* 4628 */    MCD::OPC_Decode, 147, 3, 74, // Opcode: AMAND_DB_D
/* 4632 */    MCD::OPC_FilterValue, 216, 1, 4, 0, 0, // Skip to: 4642
/* 4638 */    MCD::OPC_Decode, 168, 3, 74, // Opcode: AMOR_DB_W
/* 4642 */    MCD::OPC_FilterValue, 217, 1, 4, 0, 0, // Skip to: 4652
/* 4648 */    MCD::OPC_Decode, 167, 3, 74, // Opcode: AMOR_DB_D
/* 4652 */    MCD::OPC_FilterValue, 218, 1, 4, 0, 0, // Skip to: 4662
/* 4658 */    MCD::OPC_Decode, 176, 3, 74, // Opcode: AMXOR_DB_W
/* 4662 */    MCD::OPC_FilterValue, 219, 1, 4, 0, 0, // Skip to: 4672
/* 4668 */    MCD::OPC_Decode, 175, 3, 74, // Opcode: AMXOR_DB_D
/* 4672 */    MCD::OPC_FilterValue, 220, 1, 4, 0, 0, // Skip to: 4682
/* 4678 */    MCD::OPC_Decode, 153, 3, 74, // Opcode: AMMAX_DB_W
/* 4682 */    MCD::OPC_FilterValue, 221, 1, 4, 0, 0, // Skip to: 4692
/* 4688 */    MCD::OPC_Decode, 151, 3, 74, // Opcode: AMMAX_DB_D
/* 4692 */    MCD::OPC_FilterValue, 222, 1, 4, 0, 0, // Skip to: 4702
/* 4698 */    MCD::OPC_Decode, 161, 3, 74, // Opcode: AMMIN_DB_W
/* 4702 */    MCD::OPC_FilterValue, 223, 1, 4, 0, 0, // Skip to: 4712
/* 4708 */    MCD::OPC_Decode, 159, 3, 74, // Opcode: AMMIN_DB_D
/* 4712 */    MCD::OPC_FilterValue, 224, 1, 4, 0, 0, // Skip to: 4722
/* 4718 */    MCD::OPC_Decode, 154, 3, 74, // Opcode: AMMAX_DB_WU
/* 4722 */    MCD::OPC_FilterValue, 225, 1, 4, 0, 0, // Skip to: 4732
/* 4728 */    MCD::OPC_Decode, 152, 3, 74, // Opcode: AMMAX_DB_DU
/* 4732 */    MCD::OPC_FilterValue, 226, 1, 4, 0, 0, // Skip to: 4742
/* 4738 */    MCD::OPC_Decode, 162, 3, 74, // Opcode: AMMIN_DB_WU
/* 4742 */    MCD::OPC_FilterValue, 227, 1, 4, 0, 0, // Skip to: 4752
/* 4748 */    MCD::OPC_Decode, 160, 3, 74, // Opcode: AMMIN_DB_DU
/* 4752 */    MCD::OPC_FilterValue, 232, 1, 4, 0, 0, // Skip to: 4762
/* 4758 */    MCD::OPC_Decode, 189, 4, 75, // Opcode: FLDGT_S
/* 4762 */    MCD::OPC_FilterValue, 233, 1, 4, 0, 0, // Skip to: 4772
/* 4768 */    MCD::OPC_Decode, 188, 4, 76, // Opcode: FLDGT_D
/* 4772 */    MCD::OPC_FilterValue, 234, 1, 4, 0, 0, // Skip to: 4782
/* 4778 */    MCD::OPC_Decode, 191, 4, 75, // Opcode: FLDLE_S
/* 4782 */    MCD::OPC_FilterValue, 235, 1, 4, 0, 0, // Skip to: 4792
/* 4788 */    MCD::OPC_Decode, 190, 4, 76, // Opcode: FLDLE_D
/* 4792 */    MCD::OPC_FilterValue, 236, 1, 4, 0, 0, // Skip to: 4802
/* 4798 */    MCD::OPC_Decode, 233, 4, 75, // Opcode: FSTGT_S
/* 4802 */    MCD::OPC_FilterValue, 237, 1, 4, 0, 0, // Skip to: 4812
/* 4808 */    MCD::OPC_Decode, 232, 4, 76, // Opcode: FSTGT_D
/* 4812 */    MCD::OPC_FilterValue, 238, 1, 4, 0, 0, // Skip to: 4822
/* 4818 */    MCD::OPC_Decode, 235, 4, 75, // Opcode: FSTLE_S
/* 4822 */    MCD::OPC_FilterValue, 239, 1, 4, 0, 0, // Skip to: 4832
/* 4828 */    MCD::OPC_Decode, 234, 4, 76, // Opcode: FSTLE_D
/* 4832 */    MCD::OPC_FilterValue, 240, 1, 4, 0, 0, // Skip to: 4842
/* 4838 */    MCD::OPC_Decode, 155, 5, 4, // Opcode: LDGT_B
/* 4842 */    MCD::OPC_FilterValue, 241, 1, 4, 0, 0, // Skip to: 4852
/* 4848 */    MCD::OPC_Decode, 157, 5, 4, // Opcode: LDGT_H
/* 4852 */    MCD::OPC_FilterValue, 242, 1, 4, 0, 0, // Skip to: 4862
/* 4858 */    MCD::OPC_Decode, 158, 5, 4, // Opcode: LDGT_W
/* 4862 */    MCD::OPC_FilterValue, 243, 1, 4, 0, 0, // Skip to: 4872
/* 4868 */    MCD::OPC_Decode, 156, 5, 4, // Opcode: LDGT_D
/* 4872 */    MCD::OPC_FilterValue, 244, 1, 4, 0, 0, // Skip to: 4882
/* 4878 */    MCD::OPC_Decode, 159, 5, 4, // Opcode: LDLE_B
/* 4882 */    MCD::OPC_FilterValue, 245, 1, 4, 0, 0, // Skip to: 4892
/* 4888 */    MCD::OPC_Decode, 161, 5, 4, // Opcode: LDLE_H
/* 4892 */    MCD::OPC_FilterValue, 246, 1, 4, 0, 0, // Skip to: 4902
/* 4898 */    MCD::OPC_Decode, 162, 5, 4, // Opcode: LDLE_W
/* 4902 */    MCD::OPC_FilterValue, 247, 1, 4, 0, 0, // Skip to: 4912
/* 4908 */    MCD::OPC_Decode, 160, 5, 4, // Opcode: LDLE_D
/* 4912 */    MCD::OPC_FilterValue, 248, 1, 4, 0, 0, // Skip to: 4922
/* 4918 */    MCD::OPC_Decode, 180, 6, 4, // Opcode: STGT_B
/* 4922 */    MCD::OPC_FilterValue, 249, 1, 4, 0, 0, // Skip to: 4932
/* 4928 */    MCD::OPC_Decode, 182, 6, 4, // Opcode: STGT_H
/* 4932 */    MCD::OPC_FilterValue, 250, 1, 4, 0, 0, // Skip to: 4942
/* 4938 */    MCD::OPC_Decode, 183, 6, 4, // Opcode: STGT_W
/* 4942 */    MCD::OPC_FilterValue, 251, 1, 4, 0, 0, // Skip to: 4952
/* 4948 */    MCD::OPC_Decode, 181, 6, 4, // Opcode: STGT_D
/* 4952 */    MCD::OPC_FilterValue, 252, 1, 4, 0, 0, // Skip to: 4962
/* 4958 */    MCD::OPC_Decode, 184, 6, 4, // Opcode: STLE_B
/* 4962 */    MCD::OPC_FilterValue, 253, 1, 4, 0, 0, // Skip to: 4972
/* 4968 */    MCD::OPC_Decode, 186, 6, 4, // Opcode: STLE_H
/* 4972 */    MCD::OPC_FilterValue, 254, 1, 4, 0, 0, // Skip to: 4982
/* 4978 */    MCD::OPC_Decode, 187, 6, 4, // Opcode: STLE_W
/* 4982 */    MCD::OPC_FilterValue, 255, 1, 4, 62, 0, // Skip to: 20864
/* 4988 */    MCD::OPC_Decode, 185, 6, 4, // Opcode: STLE_D
/* 4992 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 5001
/* 4997 */    MCD::OPC_Decode, 192, 3, 77, // Opcode: BEQZ
/* 5001 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 5010
/* 5006 */    MCD::OPC_Decode, 209, 3, 77, // Opcode: BNEZ
/* 5010 */    MCD::OPC_FilterValue, 18, 21, 0, 0, // Skip to: 5036
/* 5015 */    MCD::OPC_ExtractField, 8, 2,  // Inst{9-8} ...
/* 5018 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5027
/* 5023 */    MCD::OPC_Decode, 188, 3, 78, // Opcode: BCEQZ
/* 5027 */    MCD::OPC_FilterValue, 1, 216, 61, 0, // Skip to: 20864
/* 5032 */    MCD::OPC_Decode, 189, 3, 78, // Opcode: BCNEZ
/* 5036 */    MCD::OPC_FilterValue, 19, 15, 0, 0, // Skip to: 5056
/* 5041 */    MCD::OPC_CheckField, 10, 16, 0, 4, 0, 0, // Skip to: 5052
/* 5048 */    MCD::OPC_Decode, 150, 5, 79, // Opcode: JIRLR
/* 5052 */    MCD::OPC_Decode, 148, 5, 57, // Opcode: JIRL
/* 5056 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 5065
/* 5061 */    MCD::OPC_Decode, 186, 3, 80, // Opcode: B
/* 5065 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 5074
/* 5070 */    MCD::OPC_Decode, 202, 3, 80, // Opcode: BL
/* 5074 */    MCD::OPC_FilterValue, 22, 4, 0, 0, // Skip to: 5083
/* 5079 */    MCD::OPC_Decode, 190, 3, 81, // Opcode: BEQ
/* 5083 */    MCD::OPC_FilterValue, 23, 4, 0, 0, // Skip to: 5092
/* 5088 */    MCD::OPC_Decode, 207, 3, 81, // Opcode: BNE
/* 5092 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 5101
/* 5097 */    MCD::OPC_Decode, 203, 3, 81, // Opcode: BLT
/* 5101 */    MCD::OPC_FilterValue, 25, 4, 0, 0, // Skip to: 5110
/* 5106 */    MCD::OPC_Decode, 194, 3, 81, // Opcode: BGE
/* 5110 */    MCD::OPC_FilterValue, 26, 4, 0, 0, // Skip to: 5119
/* 5115 */    MCD::OPC_Decode, 205, 3, 81, // Opcode: BLTU
/* 5119 */    MCD::OPC_FilterValue, 27, 4, 0, 0, // Skip to: 5128
/* 5124 */    MCD::OPC_Decode, 196, 3, 81, // Opcode: BGEU
/* 5128 */    MCD::OPC_FilterValue, 28, 117, 29, 0, // Skip to: 12674
/* 5133 */    MCD::OPC_ExtractField, 18, 8,  // Inst{25-18} ...
/* 5136 */    MCD::OPC_FilterValue, 0, 75, 0, 0, // Skip to: 5216
/* 5141 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 5144 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5153
/* 5149 */    MCD::OPC_Decode, 223, 10, 82, // Opcode: VSEQ_B
/* 5153 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5162
/* 5158 */    MCD::OPC_Decode, 225, 10, 83, // Opcode: VSEQ_H
/* 5162 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5171
/* 5167 */    MCD::OPC_Decode, 226, 10, 50, // Opcode: VSEQ_W
/* 5171 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 5180
/* 5176 */    MCD::OPC_Decode, 224, 10, 51, // Opcode: VSEQ_D
/* 5180 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 5189
/* 5185 */    MCD::OPC_Decode, 137, 11, 82, // Opcode: VSLE_B
/* 5189 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 5198
/* 5194 */    MCD::OPC_Decode, 141, 11, 83, // Opcode: VSLE_H
/* 5198 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 5207
/* 5203 */    MCD::OPC_Decode, 143, 11, 50, // Opcode: VSLE_W
/* 5207 */    MCD::OPC_FilterValue, 7, 36, 61, 0, // Skip to: 20864
/* 5212 */    MCD::OPC_Decode, 139, 11, 51, // Opcode: VSLE_D
/* 5216 */    MCD::OPC_FilterValue, 1, 75, 0, 0, // Skip to: 5296
/* 5221 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 5224 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5233
/* 5229 */    MCD::OPC_Decode, 138, 11, 82, // Opcode: VSLE_BU
/* 5233 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5242
/* 5238 */    MCD::OPC_Decode, 142, 11, 83, // Opcode: VSLE_HU
/* 5242 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5251
/* 5247 */    MCD::OPC_Decode, 144, 11, 50, // Opcode: VSLE_WU
/* 5251 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 5260
/* 5256 */    MCD::OPC_Decode, 140, 11, 51, // Opcode: VSLE_DU
/* 5260 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 5269
/* 5265 */    MCD::OPC_Decode, 175, 11, 82, // Opcode: VSLT_B
/* 5269 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 5278
/* 5274 */    MCD::OPC_Decode, 179, 11, 83, // Opcode: VSLT_H
/* 5278 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 5287
/* 5283 */    MCD::OPC_Decode, 181, 11, 50, // Opcode: VSLT_W
/* 5287 */    MCD::OPC_FilterValue, 7, 212, 60, 0, // Skip to: 20864
/* 5292 */    MCD::OPC_Decode, 177, 11, 51, // Opcode: VSLT_D
/* 5296 */    MCD::OPC_FilterValue, 2, 75, 0, 0, // Skip to: 5376
/* 5301 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 5304 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5313
/* 5309 */    MCD::OPC_Decode, 176, 11, 82, // Opcode: VSLT_BU
/* 5313 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5322
/* 5318 */    MCD::OPC_Decode, 180, 11, 83, // Opcode: VSLT_HU
/* 5322 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5331
/* 5327 */    MCD::OPC_Decode, 182, 11, 50, // Opcode: VSLT_WU
/* 5331 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 5340
/* 5336 */    MCD::OPC_Decode, 178, 11, 51, // Opcode: VSLT_DU
/* 5340 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 5349
/* 5345 */    MCD::OPC_Decode, 255, 6, 82, // Opcode: VADD_B
/* 5349 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 5358
/* 5354 */    MCD::OPC_Decode, 129, 7, 83, // Opcode: VADD_H
/* 5358 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 5367
/* 5363 */    MCD::OPC_Decode, 131, 7, 50, // Opcode: VADD_W
/* 5367 */    MCD::OPC_FilterValue, 7, 132, 60, 0, // Skip to: 20864
/* 5372 */    MCD::OPC_Decode, 128, 7, 51, // Opcode: VADD_D
/* 5376 */    MCD::OPC_FilterValue, 3, 39, 0, 0, // Skip to: 5420
/* 5381 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 5384 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5393
/* 5389 */    MCD::OPC_Decode, 212, 12, 82, // Opcode: VSUB_B
/* 5393 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5402
/* 5398 */    MCD::OPC_Decode, 214, 12, 83, // Opcode: VSUB_H
/* 5402 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5411
/* 5407 */    MCD::OPC_Decode, 216, 12, 50, // Opcode: VSUB_W
/* 5411 */    MCD::OPC_FilterValue, 3, 88, 60, 0, // Skip to: 20864
/* 5416 */    MCD::OPC_Decode, 213, 12, 51, // Opcode: VSUB_D
/* 5420 */    MCD::OPC_FilterValue, 7, 39, 0, 0, // Skip to: 5464
/* 5425 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 5428 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 5437
/* 5433 */    MCD::OPC_Decode, 234, 6, 84, // Opcode: VADDWEV_H_B
/* 5437 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 5446
/* 5442 */    MCD::OPC_Decode, 240, 6, 85, // Opcode: VADDWEV_W_H
/* 5446 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 5455
/* 5451 */    MCD::OPC_Decode, 231, 6, 86, // Opcode: VADDWEV_D_W
/* 5455 */    MCD::OPC_FilterValue, 7, 44, 60, 0, // Skip to: 20864
/* 5460 */    MCD::OPC_Decode, 237, 6, 51, // Opcode: VADDWEV_Q_D
/* 5464 */    MCD::OPC_FilterValue, 8, 75, 0, 0, // Skip to: 5544
/* 5469 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 5472 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5481
/* 5477 */    MCD::OPC_Decode, 198, 12, 84, // Opcode: VSUBWEV_H_B
/* 5481 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5490
/* 5486 */    MCD::OPC_Decode, 202, 12, 85, // Opcode: VSUBWEV_W_H
/* 5490 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5499
/* 5495 */    MCD::OPC_Decode, 196, 12, 86, // Opcode: VSUBWEV_D_W
/* 5499 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 5508
/* 5504 */    MCD::OPC_Decode, 200, 12, 51, // Opcode: VSUBWEV_Q_D
/* 5508 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 5517
/* 5513 */    MCD::OPC_Decode, 246, 6, 84, // Opcode: VADDWOD_H_B
/* 5517 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 5526
/* 5522 */    MCD::OPC_Decode, 252, 6, 85, // Opcode: VADDWOD_W_H
/* 5526 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 5535
/* 5531 */    MCD::OPC_Decode, 243, 6, 86, // Opcode: VADDWOD_D_W
/* 5535 */    MCD::OPC_FilterValue, 7, 220, 59, 0, // Skip to: 20864
/* 5540 */    MCD::OPC_Decode, 249, 6, 51, // Opcode: VADDWOD_Q_D
/* 5544 */    MCD::OPC_FilterValue, 9, 39, 0, 0, // Skip to: 5588
/* 5549 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 5552 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5561
/* 5557 */    MCD::OPC_Decode, 206, 12, 84, // Opcode: VSUBWOD_H_B
/* 5561 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5570
/* 5566 */    MCD::OPC_Decode, 210, 12, 85, // Opcode: VSUBWOD_W_H
/* 5570 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5579
/* 5575 */    MCD::OPC_Decode, 204, 12, 86, // Opcode: VSUBWOD_D_W
/* 5579 */    MCD::OPC_FilterValue, 3, 176, 59, 0, // Skip to: 20864
/* 5584 */    MCD::OPC_Decode, 208, 12, 51, // Opcode: VSUBWOD_Q_D
/* 5588 */    MCD::OPC_FilterValue, 11, 39, 0, 0, // Skip to: 5632
/* 5593 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 5596 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 5605
/* 5601 */    MCD::OPC_Decode, 235, 6, 84, // Opcode: VADDWEV_H_BU
/* 5605 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 5614
/* 5610 */    MCD::OPC_Decode, 241, 6, 85, // Opcode: VADDWEV_W_HU
/* 5614 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 5623
/* 5619 */    MCD::OPC_Decode, 232, 6, 86, // Opcode: VADDWEV_D_WU
/* 5623 */    MCD::OPC_FilterValue, 7, 132, 59, 0, // Skip to: 20864
/* 5628 */    MCD::OPC_Decode, 238, 6, 51, // Opcode: VADDWEV_Q_DU
/* 5632 */    MCD::OPC_FilterValue, 12, 75, 0, 0, // Skip to: 5712
/* 5637 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 5640 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5649
/* 5645 */    MCD::OPC_Decode, 199, 12, 84, // Opcode: VSUBWEV_H_BU
/* 5649 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5658
/* 5654 */    MCD::OPC_Decode, 203, 12, 85, // Opcode: VSUBWEV_W_HU
/* 5658 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5667
/* 5663 */    MCD::OPC_Decode, 197, 12, 86, // Opcode: VSUBWEV_D_WU
/* 5667 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 5676
/* 5672 */    MCD::OPC_Decode, 201, 12, 51, // Opcode: VSUBWEV_Q_DU
/* 5676 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 5685
/* 5681 */    MCD::OPC_Decode, 247, 6, 84, // Opcode: VADDWOD_H_BU
/* 5685 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 5694
/* 5690 */    MCD::OPC_Decode, 253, 6, 85, // Opcode: VADDWOD_W_HU
/* 5694 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 5703
/* 5699 */    MCD::OPC_Decode, 244, 6, 86, // Opcode: VADDWOD_D_WU
/* 5703 */    MCD::OPC_FilterValue, 7, 52, 59, 0, // Skip to: 20864
/* 5708 */    MCD::OPC_Decode, 250, 6, 51, // Opcode: VADDWOD_Q_DU
/* 5712 */    MCD::OPC_FilterValue, 13, 39, 0, 0, // Skip to: 5756
/* 5717 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 5720 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5729
/* 5725 */    MCD::OPC_Decode, 207, 12, 84, // Opcode: VSUBWOD_H_BU
/* 5729 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5738
/* 5734 */    MCD::OPC_Decode, 211, 12, 85, // Opcode: VSUBWOD_W_HU
/* 5738 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5747
/* 5743 */    MCD::OPC_Decode, 205, 12, 86, // Opcode: VSUBWOD_D_WU
/* 5747 */    MCD::OPC_FilterValue, 3, 8, 59, 0, // Skip to: 20864
/* 5752 */    MCD::OPC_Decode, 209, 12, 51, // Opcode: VSUBWOD_Q_DU
/* 5756 */    MCD::OPC_FilterValue, 15, 39, 0, 0, // Skip to: 5800
/* 5761 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 5764 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 5773
/* 5769 */    MCD::OPC_Decode, 236, 6, 84, // Opcode: VADDWEV_H_BU_B
/* 5773 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 5782
/* 5778 */    MCD::OPC_Decode, 242, 6, 85, // Opcode: VADDWEV_W_HU_H
/* 5782 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 5791
/* 5787 */    MCD::OPC_Decode, 233, 6, 86, // Opcode: VADDWEV_D_WU_W
/* 5791 */    MCD::OPC_FilterValue, 7, 220, 58, 0, // Skip to: 20864
/* 5796 */    MCD::OPC_Decode, 239, 6, 51, // Opcode: VADDWEV_Q_DU_D
/* 5800 */    MCD::OPC_FilterValue, 16, 39, 0, 0, // Skip to: 5844
/* 5805 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 5808 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5817
/* 5813 */    MCD::OPC_Decode, 248, 6, 84, // Opcode: VADDWOD_H_BU_B
/* 5817 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5826
/* 5822 */    MCD::OPC_Decode, 254, 6, 85, // Opcode: VADDWOD_W_HU_H
/* 5826 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5835
/* 5831 */    MCD::OPC_Decode, 245, 6, 86, // Opcode: VADDWOD_D_WU_W
/* 5835 */    MCD::OPC_FilterValue, 3, 176, 58, 0, // Skip to: 20864
/* 5840 */    MCD::OPC_Decode, 251, 6, 51, // Opcode: VADDWOD_Q_DU_D
/* 5844 */    MCD::OPC_FilterValue, 17, 39, 0, 0, // Skip to: 5888
/* 5849 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 5852 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 5861
/* 5857 */    MCD::OPC_Decode, 199, 10, 82, // Opcode: VSADD_B
/* 5861 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 5870
/* 5866 */    MCD::OPC_Decode, 203, 10, 83, // Opcode: VSADD_H
/* 5870 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 5879
/* 5875 */    MCD::OPC_Decode, 205, 10, 50, // Opcode: VSADD_W
/* 5879 */    MCD::OPC_FilterValue, 7, 132, 58, 0, // Skip to: 20864
/* 5884 */    MCD::OPC_Decode, 201, 10, 51, // Opcode: VSADD_D
/* 5888 */    MCD::OPC_FilterValue, 18, 75, 0, 0, // Skip to: 5968
/* 5893 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 5896 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5905
/* 5901 */    MCD::OPC_Decode, 175, 12, 82, // Opcode: VSSUB_B
/* 5905 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5914
/* 5910 */    MCD::OPC_Decode, 179, 12, 83, // Opcode: VSSUB_H
/* 5914 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5923
/* 5919 */    MCD::OPC_Decode, 181, 12, 50, // Opcode: VSSUB_W
/* 5923 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 5932
/* 5928 */    MCD::OPC_Decode, 177, 12, 51, // Opcode: VSSUB_D
/* 5932 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 5941
/* 5937 */    MCD::OPC_Decode, 200, 10, 82, // Opcode: VSADD_BU
/* 5941 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 5950
/* 5946 */    MCD::OPC_Decode, 204, 10, 83, // Opcode: VSADD_HU
/* 5950 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 5959
/* 5955 */    MCD::OPC_Decode, 206, 10, 50, // Opcode: VSADD_WU
/* 5959 */    MCD::OPC_FilterValue, 7, 52, 58, 0, // Skip to: 20864
/* 5964 */    MCD::OPC_Decode, 202, 10, 51, // Opcode: VSADD_DU
/* 5968 */    MCD::OPC_FilterValue, 19, 39, 0, 0, // Skip to: 6012
/* 5973 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 5976 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5985
/* 5981 */    MCD::OPC_Decode, 176, 12, 82, // Opcode: VSSUB_BU
/* 5985 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5994
/* 5990 */    MCD::OPC_Decode, 180, 12, 83, // Opcode: VSSUB_HU
/* 5994 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6003
/* 5999 */    MCD::OPC_Decode, 182, 12, 50, // Opcode: VSSUB_WU
/* 6003 */    MCD::OPC_FilterValue, 3, 8, 58, 0, // Skip to: 20864
/* 6008 */    MCD::OPC_Decode, 178, 12, 51, // Opcode: VSSUB_DU
/* 6012 */    MCD::OPC_FilterValue, 21, 75, 0, 0, // Skip to: 6092
/* 6017 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 6020 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6029
/* 6025 */    MCD::OPC_Decode, 232, 8, 84, // Opcode: VHADDW_H_B
/* 6029 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6038
/* 6034 */    MCD::OPC_Decode, 236, 8, 85, // Opcode: VHADDW_W_H
/* 6038 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6047
/* 6043 */    MCD::OPC_Decode, 230, 8, 86, // Opcode: VHADDW_D_W
/* 6047 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 6056
/* 6052 */    MCD::OPC_Decode, 234, 8, 51, // Opcode: VHADDW_Q_D
/* 6056 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 6065
/* 6061 */    MCD::OPC_Decode, 240, 8, 84, // Opcode: VHSUBW_H_B
/* 6065 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 6074
/* 6070 */    MCD::OPC_Decode, 244, 8, 85, // Opcode: VHSUBW_W_H
/* 6074 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 6083
/* 6079 */    MCD::OPC_Decode, 238, 8, 86, // Opcode: VHSUBW_D_W
/* 6083 */    MCD::OPC_FilterValue, 7, 184, 57, 0, // Skip to: 20864
/* 6088 */    MCD::OPC_Decode, 242, 8, 51, // Opcode: VHSUBW_Q_D
/* 6092 */    MCD::OPC_FilterValue, 22, 75, 0, 0, // Skip to: 6172
/* 6097 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 6100 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6109
/* 6105 */    MCD::OPC_Decode, 231, 8, 84, // Opcode: VHADDW_HU_BU
/* 6109 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6118
/* 6114 */    MCD::OPC_Decode, 235, 8, 85, // Opcode: VHADDW_WU_HU
/* 6118 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6127
/* 6123 */    MCD::OPC_Decode, 229, 8, 86, // Opcode: VHADDW_DU_WU
/* 6127 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 6136
/* 6132 */    MCD::OPC_Decode, 233, 8, 51, // Opcode: VHADDW_QU_DU
/* 6136 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 6145
/* 6141 */    MCD::OPC_Decode, 239, 8, 84, // Opcode: VHSUBW_HU_BU
/* 6145 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 6154
/* 6150 */    MCD::OPC_Decode, 243, 8, 85, // Opcode: VHSUBW_WU_HU
/* 6154 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 6163
/* 6159 */    MCD::OPC_Decode, 237, 8, 86, // Opcode: VHSUBW_DU_WU
/* 6163 */    MCD::OPC_FilterValue, 7, 104, 57, 0, // Skip to: 20864
/* 6168 */    MCD::OPC_Decode, 241, 8, 51, // Opcode: VHSUBW_QU_DU
/* 6172 */    MCD::OPC_FilterValue, 23, 39, 0, 0, // Skip to: 6216
/* 6177 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 6180 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6189
/* 6185 */    MCD::OPC_Decode, 223, 6, 82, // Opcode: VADDA_B
/* 6189 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6198
/* 6194 */    MCD::OPC_Decode, 225, 6, 83, // Opcode: VADDA_H
/* 6198 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6207
/* 6203 */    MCD::OPC_Decode, 226, 6, 50, // Opcode: VADDA_W
/* 6207 */    MCD::OPC_FilterValue, 3, 60, 57, 0, // Skip to: 20864
/* 6212 */    MCD::OPC_Decode, 224, 6, 51, // Opcode: VADDA_D
/* 6216 */    MCD::OPC_FilterValue, 24, 75, 0, 0, // Skip to: 6296
/* 6221 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 6224 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6233
/* 6229 */    MCD::OPC_Decode, 215, 6, 82, // Opcode: VABSD_B
/* 6233 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6242
/* 6238 */    MCD::OPC_Decode, 219, 6, 83, // Opcode: VABSD_H
/* 6242 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6251
/* 6247 */    MCD::OPC_Decode, 221, 6, 50, // Opcode: VABSD_W
/* 6251 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 6260
/* 6256 */    MCD::OPC_Decode, 217, 6, 51, // Opcode: VABSD_D
/* 6260 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 6269
/* 6265 */    MCD::OPC_Decode, 216, 6, 82, // Opcode: VABSD_BU
/* 6269 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 6278
/* 6274 */    MCD::OPC_Decode, 220, 6, 83, // Opcode: VABSD_HU
/* 6278 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 6287
/* 6283 */    MCD::OPC_Decode, 222, 6, 50, // Opcode: VABSD_WU
/* 6287 */    MCD::OPC_FilterValue, 7, 236, 56, 0, // Skip to: 20864
/* 6292 */    MCD::OPC_Decode, 218, 6, 51, // Opcode: VABSD_DU
/* 6296 */    MCD::OPC_FilterValue, 25, 75, 0, 0, // Skip to: 6376
/* 6301 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 6304 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6313
/* 6309 */    MCD::OPC_Decode, 144, 7, 82, // Opcode: VAVG_B
/* 6313 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6322
/* 6318 */    MCD::OPC_Decode, 148, 7, 83, // Opcode: VAVG_H
/* 6322 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6331
/* 6327 */    MCD::OPC_Decode, 150, 7, 50, // Opcode: VAVG_W
/* 6331 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 6340
/* 6336 */    MCD::OPC_Decode, 146, 7, 51, // Opcode: VAVG_D
/* 6340 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 6349
/* 6345 */    MCD::OPC_Decode, 145, 7, 82, // Opcode: VAVG_BU
/* 6349 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 6358
/* 6354 */    MCD::OPC_Decode, 149, 7, 83, // Opcode: VAVG_HU
/* 6358 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 6367
/* 6363 */    MCD::OPC_Decode, 151, 7, 50, // Opcode: VAVG_WU
/* 6367 */    MCD::OPC_FilterValue, 7, 156, 56, 0, // Skip to: 20864
/* 6372 */    MCD::OPC_Decode, 147, 7, 51, // Opcode: VAVG_DU
/* 6376 */    MCD::OPC_FilterValue, 26, 75, 0, 0, // Skip to: 6456
/* 6381 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 6384 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6393
/* 6389 */    MCD::OPC_Decode, 136, 7, 82, // Opcode: VAVGR_B
/* 6393 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6402
/* 6398 */    MCD::OPC_Decode, 140, 7, 83, // Opcode: VAVGR_H
/* 6402 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6411
/* 6407 */    MCD::OPC_Decode, 142, 7, 50, // Opcode: VAVGR_W
/* 6411 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 6420
/* 6416 */    MCD::OPC_Decode, 138, 7, 51, // Opcode: VAVGR_D
/* 6420 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 6429
/* 6425 */    MCD::OPC_Decode, 137, 7, 82, // Opcode: VAVGR_BU
/* 6429 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 6438
/* 6434 */    MCD::OPC_Decode, 141, 7, 83, // Opcode: VAVGR_HU
/* 6438 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 6447
/* 6443 */    MCD::OPC_Decode, 143, 7, 50, // Opcode: VAVGR_WU
/* 6447 */    MCD::OPC_FilterValue, 7, 76, 56, 0, // Skip to: 20864
/* 6452 */    MCD::OPC_Decode, 139, 7, 51, // Opcode: VAVGR_DU
/* 6456 */    MCD::OPC_FilterValue, 28, 75, 0, 0, // Skip to: 6536
/* 6461 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 6464 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6473
/* 6469 */    MCD::OPC_Decode, 187, 9, 82, // Opcode: VMAX_B
/* 6473 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6482
/* 6478 */    MCD::OPC_Decode, 191, 9, 83, // Opcode: VMAX_H
/* 6482 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6491
/* 6487 */    MCD::OPC_Decode, 193, 9, 50, // Opcode: VMAX_W
/* 6491 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 6500
/* 6496 */    MCD::OPC_Decode, 189, 9, 51, // Opcode: VMAX_D
/* 6500 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 6509
/* 6505 */    MCD::OPC_Decode, 207, 9, 82, // Opcode: VMIN_B
/* 6509 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 6518
/* 6514 */    MCD::OPC_Decode, 211, 9, 83, // Opcode: VMIN_H
/* 6518 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 6527
/* 6523 */    MCD::OPC_Decode, 213, 9, 50, // Opcode: VMIN_W
/* 6527 */    MCD::OPC_FilterValue, 7, 252, 55, 0, // Skip to: 20864
/* 6532 */    MCD::OPC_Decode, 209, 9, 51, // Opcode: VMIN_D
/* 6536 */    MCD::OPC_FilterValue, 29, 75, 0, 0, // Skip to: 6616
/* 6541 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 6544 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6553
/* 6549 */    MCD::OPC_Decode, 188, 9, 82, // Opcode: VMAX_BU
/* 6553 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6562
/* 6558 */    MCD::OPC_Decode, 192, 9, 83, // Opcode: VMAX_HU
/* 6562 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6571
/* 6567 */    MCD::OPC_Decode, 194, 9, 50, // Opcode: VMAX_WU
/* 6571 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 6580
/* 6576 */    MCD::OPC_Decode, 190, 9, 51, // Opcode: VMAX_DU
/* 6580 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 6589
/* 6585 */    MCD::OPC_Decode, 208, 9, 82, // Opcode: VMIN_BU
/* 6589 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 6598
/* 6594 */    MCD::OPC_Decode, 212, 9, 83, // Opcode: VMIN_HU
/* 6598 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 6607
/* 6603 */    MCD::OPC_Decode, 214, 9, 50, // Opcode: VMIN_WU
/* 6607 */    MCD::OPC_FilterValue, 7, 172, 55, 0, // Skip to: 20864
/* 6612 */    MCD::OPC_Decode, 210, 9, 51, // Opcode: VMIN_DU
/* 6616 */    MCD::OPC_FilterValue, 33, 75, 0, 0, // Skip to: 6696
/* 6621 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 6624 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6633
/* 6629 */    MCD::OPC_Decode, 137, 10, 82, // Opcode: VMUL_B
/* 6633 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6642
/* 6638 */    MCD::OPC_Decode, 139, 10, 83, // Opcode: VMUL_H
/* 6642 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6651
/* 6647 */    MCD::OPC_Decode, 140, 10, 50, // Opcode: VMUL_W
/* 6651 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 6660
/* 6656 */    MCD::OPC_Decode, 138, 10, 51, // Opcode: VMUL_D
/* 6660 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 6669
/* 6665 */    MCD::OPC_Decode, 233, 9, 82, // Opcode: VMUH_B
/* 6669 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 6678
/* 6674 */    MCD::OPC_Decode, 237, 9, 83, // Opcode: VMUH_H
/* 6678 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 6687
/* 6683 */    MCD::OPC_Decode, 239, 9, 50, // Opcode: VMUH_W
/* 6687 */    MCD::OPC_FilterValue, 7, 92, 55, 0, // Skip to: 20864
/* 6692 */    MCD::OPC_Decode, 235, 9, 51, // Opcode: VMUH_D
/* 6696 */    MCD::OPC_FilterValue, 34, 39, 0, 0, // Skip to: 6740
/* 6701 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 6704 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6713
/* 6709 */    MCD::OPC_Decode, 234, 9, 82, // Opcode: VMUH_BU
/* 6713 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6722
/* 6718 */    MCD::OPC_Decode, 238, 9, 83, // Opcode: VMUH_HU
/* 6722 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6731
/* 6727 */    MCD::OPC_Decode, 240, 9, 50, // Opcode: VMUH_WU
/* 6731 */    MCD::OPC_FilterValue, 3, 48, 55, 0, // Skip to: 20864
/* 6736 */    MCD::OPC_Decode, 236, 9, 51, // Opcode: VMUH_DU
/* 6740 */    MCD::OPC_FilterValue, 36, 75, 0, 0, // Skip to: 6820
/* 6745 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 6748 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6757
/* 6753 */    MCD::OPC_Decode, 244, 9, 84, // Opcode: VMULWEV_H_B
/* 6757 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6766
/* 6762 */    MCD::OPC_Decode, 250, 9, 85, // Opcode: VMULWEV_W_H
/* 6766 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6775
/* 6771 */    MCD::OPC_Decode, 241, 9, 86, // Opcode: VMULWEV_D_W
/* 6775 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 6784
/* 6780 */    MCD::OPC_Decode, 247, 9, 51, // Opcode: VMULWEV_Q_D
/* 6784 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 6793
/* 6789 */    MCD::OPC_Decode, 128, 10, 84, // Opcode: VMULWOD_H_B
/* 6793 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 6802
/* 6798 */    MCD::OPC_Decode, 134, 10, 85, // Opcode: VMULWOD_W_H
/* 6802 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 6811
/* 6807 */    MCD::OPC_Decode, 253, 9, 86, // Opcode: VMULWOD_D_W
/* 6811 */    MCD::OPC_FilterValue, 7, 224, 54, 0, // Skip to: 20864
/* 6816 */    MCD::OPC_Decode, 131, 10, 51, // Opcode: VMULWOD_Q_D
/* 6820 */    MCD::OPC_FilterValue, 38, 75, 0, 0, // Skip to: 6900
/* 6825 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 6828 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6837
/* 6833 */    MCD::OPC_Decode, 245, 9, 84, // Opcode: VMULWEV_H_BU
/* 6837 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6846
/* 6842 */    MCD::OPC_Decode, 251, 9, 85, // Opcode: VMULWEV_W_HU
/* 6846 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6855
/* 6851 */    MCD::OPC_Decode, 242, 9, 86, // Opcode: VMULWEV_D_WU
/* 6855 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 6864
/* 6860 */    MCD::OPC_Decode, 248, 9, 51, // Opcode: VMULWEV_Q_DU
/* 6864 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 6873
/* 6869 */    MCD::OPC_Decode, 129, 10, 84, // Opcode: VMULWOD_H_BU
/* 6873 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 6882
/* 6878 */    MCD::OPC_Decode, 135, 10, 85, // Opcode: VMULWOD_W_HU
/* 6882 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 6891
/* 6887 */    MCD::OPC_Decode, 254, 9, 86, // Opcode: VMULWOD_D_WU
/* 6891 */    MCD::OPC_FilterValue, 7, 144, 54, 0, // Skip to: 20864
/* 6896 */    MCD::OPC_Decode, 132, 10, 51, // Opcode: VMULWOD_Q_DU
/* 6900 */    MCD::OPC_FilterValue, 40, 75, 0, 0, // Skip to: 6980
/* 6905 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 6908 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6917
/* 6913 */    MCD::OPC_Decode, 246, 9, 84, // Opcode: VMULWEV_H_BU_B
/* 6917 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6926
/* 6922 */    MCD::OPC_Decode, 252, 9, 85, // Opcode: VMULWEV_W_HU_H
/* 6926 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6935
/* 6931 */    MCD::OPC_Decode, 243, 9, 86, // Opcode: VMULWEV_D_WU_W
/* 6935 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 6944
/* 6940 */    MCD::OPC_Decode, 249, 9, 51, // Opcode: VMULWEV_Q_DU_D
/* 6944 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 6953
/* 6949 */    MCD::OPC_Decode, 130, 10, 84, // Opcode: VMULWOD_H_BU_B
/* 6953 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 6962
/* 6958 */    MCD::OPC_Decode, 136, 10, 85, // Opcode: VMULWOD_W_HU_H
/* 6962 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 6971
/* 6967 */    MCD::OPC_Decode, 255, 9, 86, // Opcode: VMULWOD_D_WU_W
/* 6971 */    MCD::OPC_FilterValue, 7, 64, 54, 0, // Skip to: 20864
/* 6976 */    MCD::OPC_Decode, 133, 10, 51, // Opcode: VMULWOD_Q_DU_D
/* 6980 */    MCD::OPC_FilterValue, 42, 75, 0, 0, // Skip to: 7060
/* 6985 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 6988 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6997
/* 6993 */    MCD::OPC_Decode, 167, 9, 87, // Opcode: VMADD_B
/* 6997 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7006
/* 7002 */    MCD::OPC_Decode, 169, 9, 88, // Opcode: VMADD_H
/* 7006 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7015
/* 7011 */    MCD::OPC_Decode, 170, 9, 89, // Opcode: VMADD_W
/* 7015 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 7024
/* 7020 */    MCD::OPC_Decode, 168, 9, 90, // Opcode: VMADD_D
/* 7024 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 7033
/* 7029 */    MCD::OPC_Decode, 229, 9, 87, // Opcode: VMSUB_B
/* 7033 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 7042
/* 7038 */    MCD::OPC_Decode, 231, 9, 88, // Opcode: VMSUB_H
/* 7042 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 7051
/* 7047 */    MCD::OPC_Decode, 232, 9, 89, // Opcode: VMSUB_W
/* 7051 */    MCD::OPC_FilterValue, 7, 240, 53, 0, // Skip to: 20864
/* 7056 */    MCD::OPC_Decode, 230, 9, 90, // Opcode: VMSUB_D
/* 7060 */    MCD::OPC_FilterValue, 43, 75, 0, 0, // Skip to: 7140
/* 7065 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 7068 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7077
/* 7073 */    MCD::OPC_Decode, 146, 9, 91, // Opcode: VMADDWEV_H_B
/* 7077 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7086
/* 7082 */    MCD::OPC_Decode, 152, 9, 92, // Opcode: VMADDWEV_W_H
/* 7086 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7095
/* 7091 */    MCD::OPC_Decode, 143, 9, 93, // Opcode: VMADDWEV_D_W
/* 7095 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 7104
/* 7100 */    MCD::OPC_Decode, 149, 9, 90, // Opcode: VMADDWEV_Q_D
/* 7104 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 7113
/* 7109 */    MCD::OPC_Decode, 158, 9, 91, // Opcode: VMADDWOD_H_B
/* 7113 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 7122
/* 7118 */    MCD::OPC_Decode, 164, 9, 92, // Opcode: VMADDWOD_W_H
/* 7122 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 7131
/* 7127 */    MCD::OPC_Decode, 155, 9, 93, // Opcode: VMADDWOD_D_W
/* 7131 */    MCD::OPC_FilterValue, 7, 160, 53, 0, // Skip to: 20864
/* 7136 */    MCD::OPC_Decode, 161, 9, 90, // Opcode: VMADDWOD_Q_D
/* 7140 */    MCD::OPC_FilterValue, 45, 75, 0, 0, // Skip to: 7220
/* 7145 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 7148 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7157
/* 7153 */    MCD::OPC_Decode, 147, 9, 91, // Opcode: VMADDWEV_H_BU
/* 7157 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7166
/* 7162 */    MCD::OPC_Decode, 153, 9, 92, // Opcode: VMADDWEV_W_HU
/* 7166 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7175
/* 7171 */    MCD::OPC_Decode, 144, 9, 93, // Opcode: VMADDWEV_D_WU
/* 7175 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 7184
/* 7180 */    MCD::OPC_Decode, 150, 9, 90, // Opcode: VMADDWEV_Q_DU
/* 7184 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 7193
/* 7189 */    MCD::OPC_Decode, 159, 9, 91, // Opcode: VMADDWOD_H_BU
/* 7193 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 7202
/* 7198 */    MCD::OPC_Decode, 165, 9, 92, // Opcode: VMADDWOD_W_HU
/* 7202 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 7211
/* 7207 */    MCD::OPC_Decode, 156, 9, 93, // Opcode: VMADDWOD_D_WU
/* 7211 */    MCD::OPC_FilterValue, 7, 80, 53, 0, // Skip to: 20864
/* 7216 */    MCD::OPC_Decode, 162, 9, 90, // Opcode: VMADDWOD_Q_DU
/* 7220 */    MCD::OPC_FilterValue, 47, 75, 0, 0, // Skip to: 7300
/* 7225 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 7228 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7237
/* 7233 */    MCD::OPC_Decode, 148, 9, 91, // Opcode: VMADDWEV_H_BU_B
/* 7237 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7246
/* 7242 */    MCD::OPC_Decode, 154, 9, 92, // Opcode: VMADDWEV_W_HU_H
/* 7246 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7255
/* 7251 */    MCD::OPC_Decode, 145, 9, 93, // Opcode: VMADDWEV_D_WU_W
/* 7255 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 7264
/* 7260 */    MCD::OPC_Decode, 151, 9, 90, // Opcode: VMADDWEV_Q_DU_D
/* 7264 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 7273
/* 7269 */    MCD::OPC_Decode, 160, 9, 91, // Opcode: VMADDWOD_H_BU_B
/* 7273 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 7282
/* 7278 */    MCD::OPC_Decode, 166, 9, 92, // Opcode: VMADDWOD_W_HU_H
/* 7282 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 7291
/* 7287 */    MCD::OPC_Decode, 157, 9, 93, // Opcode: VMADDWOD_D_WU_W
/* 7291 */    MCD::OPC_FilterValue, 7, 0, 53, 0, // Skip to: 20864
/* 7296 */    MCD::OPC_Decode, 163, 9, 90, // Opcode: VMADDWOD_Q_DU_D
/* 7300 */    MCD::OPC_FilterValue, 56, 75, 0, 0, // Skip to: 7380
/* 7305 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 7308 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7317
/* 7313 */    MCD::OPC_Decode, 189, 7, 82, // Opcode: VDIV_B
/* 7317 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7326
/* 7322 */    MCD::OPC_Decode, 193, 7, 83, // Opcode: VDIV_H
/* 7326 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7335
/* 7331 */    MCD::OPC_Decode, 195, 7, 50, // Opcode: VDIV_W
/* 7335 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 7344
/* 7340 */    MCD::OPC_Decode, 191, 7, 51, // Opcode: VDIV_D
/* 7344 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 7353
/* 7349 */    MCD::OPC_Decode, 215, 9, 82, // Opcode: VMOD_B
/* 7353 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 7362
/* 7358 */    MCD::OPC_Decode, 219, 9, 83, // Opcode: VMOD_H
/* 7362 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 7371
/* 7367 */    MCD::OPC_Decode, 221, 9, 50, // Opcode: VMOD_W
/* 7371 */    MCD::OPC_FilterValue, 7, 176, 52, 0, // Skip to: 20864
/* 7376 */    MCD::OPC_Decode, 217, 9, 51, // Opcode: VMOD_D
/* 7380 */    MCD::OPC_FilterValue, 57, 75, 0, 0, // Skip to: 7460
/* 7385 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 7388 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7397
/* 7393 */    MCD::OPC_Decode, 190, 7, 82, // Opcode: VDIV_BU
/* 7397 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7406
/* 7402 */    MCD::OPC_Decode, 194, 7, 83, // Opcode: VDIV_HU
/* 7406 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7415
/* 7411 */    MCD::OPC_Decode, 196, 7, 50, // Opcode: VDIV_WU
/* 7415 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 7424
/* 7420 */    MCD::OPC_Decode, 192, 7, 51, // Opcode: VDIV_DU
/* 7424 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 7433
/* 7429 */    MCD::OPC_Decode, 216, 9, 82, // Opcode: VMOD_BU
/* 7433 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 7442
/* 7438 */    MCD::OPC_Decode, 220, 9, 83, // Opcode: VMOD_HU
/* 7442 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 7451
/* 7447 */    MCD::OPC_Decode, 222, 9, 50, // Opcode: VMOD_WU
/* 7451 */    MCD::OPC_FilterValue, 7, 96, 52, 0, // Skip to: 20864
/* 7456 */    MCD::OPC_Decode, 218, 9, 51, // Opcode: VMOD_DU
/* 7460 */    MCD::OPC_FilterValue, 58, 75, 0, 0, // Skip to: 7540
/* 7465 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 7468 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7477
/* 7473 */    MCD::OPC_Decode, 155, 11, 82, // Opcode: VSLL_B
/* 7477 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7486
/* 7482 */    MCD::OPC_Decode, 157, 11, 83, // Opcode: VSLL_H
/* 7486 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7495
/* 7491 */    MCD::OPC_Decode, 158, 11, 50, // Opcode: VSLL_W
/* 7495 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 7504
/* 7500 */    MCD::OPC_Decode, 156, 11, 51, // Opcode: VSLL_D
/* 7504 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 7513
/* 7509 */    MCD::OPC_Decode, 243, 11, 82, // Opcode: VSRL_B
/* 7513 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 7522
/* 7518 */    MCD::OPC_Decode, 245, 11, 83, // Opcode: VSRL_H
/* 7522 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 7531
/* 7527 */    MCD::OPC_Decode, 246, 11, 50, // Opcode: VSRL_W
/* 7531 */    MCD::OPC_FilterValue, 7, 16, 52, 0, // Skip to: 20864
/* 7536 */    MCD::OPC_Decode, 244, 11, 51, // Opcode: VSRL_D
/* 7540 */    MCD::OPC_FilterValue, 59, 75, 0, 0, // Skip to: 7620
/* 7545 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 7548 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7557
/* 7553 */    MCD::OPC_Decode, 213, 11, 82, // Opcode: VSRA_B
/* 7557 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7566
/* 7562 */    MCD::OPC_Decode, 215, 11, 83, // Opcode: VSRA_H
/* 7566 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7575
/* 7571 */    MCD::OPC_Decode, 216, 11, 50, // Opcode: VSRA_W
/* 7575 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 7584
/* 7580 */    MCD::OPC_Decode, 214, 11, 51, // Opcode: VSRA_D
/* 7584 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 7593
/* 7589 */    MCD::OPC_Decode, 195, 10, 82, // Opcode: VROTR_B
/* 7593 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 7602
/* 7598 */    MCD::OPC_Decode, 197, 10, 83, // Opcode: VROTR_H
/* 7602 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 7611
/* 7607 */    MCD::OPC_Decode, 198, 10, 50, // Opcode: VROTR_W
/* 7611 */    MCD::OPC_FilterValue, 7, 192, 51, 0, // Skip to: 20864
/* 7616 */    MCD::OPC_Decode, 196, 10, 51, // Opcode: VROTR_D
/* 7620 */    MCD::OPC_FilterValue, 60, 75, 0, 0, // Skip to: 7700
/* 7625 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 7628 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7637
/* 7633 */    MCD::OPC_Decode, 239, 11, 82, // Opcode: VSRLR_B
/* 7637 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7646
/* 7642 */    MCD::OPC_Decode, 241, 11, 83, // Opcode: VSRLR_H
/* 7646 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7655
/* 7651 */    MCD::OPC_Decode, 242, 11, 50, // Opcode: VSRLR_W
/* 7655 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 7664
/* 7660 */    MCD::OPC_Decode, 240, 11, 51, // Opcode: VSRLR_D
/* 7664 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 7673
/* 7669 */    MCD::OPC_Decode, 209, 11, 82, // Opcode: VSRAR_B
/* 7673 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 7682
/* 7678 */    MCD::OPC_Decode, 211, 11, 83, // Opcode: VSRAR_H
/* 7682 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 7691
/* 7687 */    MCD::OPC_Decode, 212, 11, 50, // Opcode: VSRAR_W
/* 7691 */    MCD::OPC_FilterValue, 7, 112, 51, 0, // Skip to: 20864
/* 7696 */    MCD::OPC_Decode, 210, 11, 51, // Opcode: VSRAR_D
/* 7700 */    MCD::OPC_FilterValue, 61, 57, 0, 0, // Skip to: 7762
/* 7705 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 7708 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7717
/* 7713 */    MCD::OPC_Decode, 225, 11, 94, // Opcode: VSRLN_B_H
/* 7717 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7726
/* 7722 */    MCD::OPC_Decode, 226, 11, 95, // Opcode: VSRLN_H_W
/* 7726 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 7735
/* 7731 */    MCD::OPC_Decode, 227, 11, 96, // Opcode: VSRLN_W_D
/* 7735 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 7744
/* 7740 */    MCD::OPC_Decode, 195, 11, 94, // Opcode: VSRAN_B_H
/* 7744 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 7753
/* 7749 */    MCD::OPC_Decode, 196, 11, 95, // Opcode: VSRAN_H_W
/* 7753 */    MCD::OPC_FilterValue, 7, 50, 51, 0, // Skip to: 20864
/* 7758 */    MCD::OPC_Decode, 197, 11, 96, // Opcode: VSRAN_W_D
/* 7762 */    MCD::OPC_FilterValue, 62, 57, 0, 0, // Skip to: 7824
/* 7767 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 7770 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7779
/* 7775 */    MCD::OPC_Decode, 236, 11, 94, // Opcode: VSRLRN_B_H
/* 7779 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7788
/* 7784 */    MCD::OPC_Decode, 237, 11, 95, // Opcode: VSRLRN_H_W
/* 7788 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 7797
/* 7793 */    MCD::OPC_Decode, 238, 11, 96, // Opcode: VSRLRN_W_D
/* 7797 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 7806
/* 7802 */    MCD::OPC_Decode, 206, 11, 94, // Opcode: VSRARN_B_H
/* 7806 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 7815
/* 7811 */    MCD::OPC_Decode, 207, 11, 95, // Opcode: VSRARN_H_W
/* 7815 */    MCD::OPC_FilterValue, 7, 244, 50, 0, // Skip to: 20864
/* 7820 */    MCD::OPC_Decode, 208, 11, 96, // Opcode: VSRARN_W_D
/* 7824 */    MCD::OPC_FilterValue, 63, 57, 0, 0, // Skip to: 7886
/* 7829 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 7832 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7841
/* 7837 */    MCD::OPC_Decode, 156, 12, 94, // Opcode: VSSRLN_B_H
/* 7841 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7850
/* 7846 */    MCD::OPC_Decode, 158, 12, 95, // Opcode: VSSRLN_H_W
/* 7850 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 7859
/* 7855 */    MCD::OPC_Decode, 160, 12, 96, // Opcode: VSSRLN_W_D
/* 7859 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 7868
/* 7864 */    MCD::OPC_Decode, 128, 12, 94, // Opcode: VSSRAN_B_H
/* 7868 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 7877
/* 7873 */    MCD::OPC_Decode, 130, 12, 95, // Opcode: VSSRAN_H_W
/* 7877 */    MCD::OPC_FilterValue, 7, 182, 50, 0, // Skip to: 20864
/* 7882 */    MCD::OPC_Decode, 132, 12, 96, // Opcode: VSSRAN_W_D
/* 7886 */    MCD::OPC_FilterValue, 64, 57, 0, 0, // Skip to: 7948
/* 7891 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 7894 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7903
/* 7899 */    MCD::OPC_Decode, 170, 12, 94, // Opcode: VSSRLRN_B_H
/* 7903 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7912
/* 7908 */    MCD::OPC_Decode, 172, 12, 95, // Opcode: VSSRLRN_H_W
/* 7912 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 7921
/* 7917 */    MCD::OPC_Decode, 174, 12, 96, // Opcode: VSSRLRN_W_D
/* 7921 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 7930
/* 7926 */    MCD::OPC_Decode, 142, 12, 94, // Opcode: VSSRARN_B_H
/* 7930 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 7939
/* 7935 */    MCD::OPC_Decode, 144, 12, 95, // Opcode: VSSRARN_H_W
/* 7939 */    MCD::OPC_FilterValue, 7, 120, 50, 0, // Skip to: 20864
/* 7944 */    MCD::OPC_Decode, 146, 12, 96, // Opcode: VSSRARN_W_D
/* 7948 */    MCD::OPC_FilterValue, 65, 57, 0, 0, // Skip to: 8010
/* 7953 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 7956 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7965
/* 7961 */    MCD::OPC_Decode, 155, 12, 94, // Opcode: VSSRLN_BU_H
/* 7965 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7974
/* 7970 */    MCD::OPC_Decode, 157, 12, 95, // Opcode: VSSRLN_HU_W
/* 7974 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 7983
/* 7979 */    MCD::OPC_Decode, 159, 12, 96, // Opcode: VSSRLN_WU_D
/* 7983 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 7992
/* 7988 */    MCD::OPC_Decode, 255, 11, 94, // Opcode: VSSRAN_BU_H
/* 7992 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 8001
/* 7997 */    MCD::OPC_Decode, 129, 12, 95, // Opcode: VSSRAN_HU_W
/* 8001 */    MCD::OPC_FilterValue, 7, 58, 50, 0, // Skip to: 20864
/* 8006 */    MCD::OPC_Decode, 131, 12, 96, // Opcode: VSSRAN_WU_D
/* 8010 */    MCD::OPC_FilterValue, 66, 57, 0, 0, // Skip to: 8072
/* 8015 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8018 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8027
/* 8023 */    MCD::OPC_Decode, 169, 12, 94, // Opcode: VSSRLRN_BU_H
/* 8027 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8036
/* 8032 */    MCD::OPC_Decode, 171, 12, 95, // Opcode: VSSRLRN_HU_W
/* 8036 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 8045
/* 8041 */    MCD::OPC_Decode, 173, 12, 96, // Opcode: VSSRLRN_WU_D
/* 8045 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 8054
/* 8050 */    MCD::OPC_Decode, 141, 12, 94, // Opcode: VSSRARN_BU_H
/* 8054 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 8063
/* 8059 */    MCD::OPC_Decode, 143, 12, 95, // Opcode: VSSRARN_HU_W
/* 8063 */    MCD::OPC_FilterValue, 7, 252, 49, 0, // Skip to: 20864
/* 8068 */    MCD::OPC_Decode, 145, 12, 96, // Opcode: VSSRARN_WU_D
/* 8072 */    MCD::OPC_FilterValue, 67, 75, 0, 0, // Skip to: 8152
/* 8077 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8080 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8089
/* 8085 */    MCD::OPC_Decode, 156, 7, 82, // Opcode: VBITCLR_B
/* 8089 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8098
/* 8094 */    MCD::OPC_Decode, 158, 7, 83, // Opcode: VBITCLR_H
/* 8098 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8107
/* 8103 */    MCD::OPC_Decode, 159, 7, 50, // Opcode: VBITCLR_W
/* 8107 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 8116
/* 8112 */    MCD::OPC_Decode, 157, 7, 51, // Opcode: VBITCLR_D
/* 8116 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8125
/* 8121 */    MCD::OPC_Decode, 175, 7, 82, // Opcode: VBITSET_B
/* 8125 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 8134
/* 8130 */    MCD::OPC_Decode, 177, 7, 83, // Opcode: VBITSET_H
/* 8134 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 8143
/* 8139 */    MCD::OPC_Decode, 178, 7, 50, // Opcode: VBITSET_W
/* 8143 */    MCD::OPC_FilterValue, 7, 172, 49, 0, // Skip to: 20864
/* 8148 */    MCD::OPC_Decode, 176, 7, 51, // Opcode: VBITSET_D
/* 8152 */    MCD::OPC_FilterValue, 68, 39, 0, 0, // Skip to: 8196
/* 8157 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8160 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8169
/* 8165 */    MCD::OPC_Decode, 164, 7, 82, // Opcode: VBITREV_B
/* 8169 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8178
/* 8174 */    MCD::OPC_Decode, 166, 7, 83, // Opcode: VBITREV_H
/* 8178 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8187
/* 8183 */    MCD::OPC_Decode, 167, 7, 50, // Opcode: VBITREV_W
/* 8187 */    MCD::OPC_FilterValue, 3, 128, 49, 0, // Skip to: 20864
/* 8192 */    MCD::OPC_Decode, 165, 7, 51, // Opcode: VBITREV_D
/* 8196 */    MCD::OPC_FilterValue, 69, 39, 0, 0, // Skip to: 8240
/* 8201 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8204 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8213
/* 8209 */    MCD::OPC_Decode, 150, 10, 82, // Opcode: VPACKEV_B
/* 8213 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 8222
/* 8218 */    MCD::OPC_Decode, 152, 10, 83, // Opcode: VPACKEV_H
/* 8222 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 8231
/* 8227 */    MCD::OPC_Decode, 153, 10, 50, // Opcode: VPACKEV_W
/* 8231 */    MCD::OPC_FilterValue, 7, 84, 49, 0, // Skip to: 20864
/* 8236 */    MCD::OPC_Decode, 151, 10, 51, // Opcode: VPACKEV_D
/* 8240 */    MCD::OPC_FilterValue, 70, 75, 0, 0, // Skip to: 8320
/* 8245 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8248 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8257
/* 8253 */    MCD::OPC_Decode, 154, 10, 82, // Opcode: VPACKOD_B
/* 8257 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8266
/* 8262 */    MCD::OPC_Decode, 156, 10, 83, // Opcode: VPACKOD_H
/* 8266 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8275
/* 8271 */    MCD::OPC_Decode, 157, 10, 50, // Opcode: VPACKOD_W
/* 8275 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 8284
/* 8280 */    MCD::OPC_Decode, 155, 10, 51, // Opcode: VPACKOD_D
/* 8284 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8293
/* 8289 */    MCD::OPC_Decode, 249, 8, 82, // Opcode: VILVL_B
/* 8293 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 8302
/* 8298 */    MCD::OPC_Decode, 251, 8, 83, // Opcode: VILVL_H
/* 8302 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 8311
/* 8307 */    MCD::OPC_Decode, 252, 8, 50, // Opcode: VILVL_W
/* 8311 */    MCD::OPC_FilterValue, 7, 4, 49, 0, // Skip to: 20864
/* 8316 */    MCD::OPC_Decode, 250, 8, 51, // Opcode: VILVL_D
/* 8320 */    MCD::OPC_FilterValue, 71, 75, 0, 0, // Skip to: 8400
/* 8325 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8328 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8337
/* 8333 */    MCD::OPC_Decode, 245, 8, 82, // Opcode: VILVH_B
/* 8337 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8346
/* 8342 */    MCD::OPC_Decode, 247, 8, 83, // Opcode: VILVH_H
/* 8346 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8355
/* 8351 */    MCD::OPC_Decode, 248, 8, 50, // Opcode: VILVH_W
/* 8355 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 8364
/* 8360 */    MCD::OPC_Decode, 246, 8, 51, // Opcode: VILVH_D
/* 8364 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8373
/* 8369 */    MCD::OPC_Decode, 163, 10, 82, // Opcode: VPICKEV_B
/* 8373 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 8382
/* 8378 */    MCD::OPC_Decode, 165, 10, 83, // Opcode: VPICKEV_H
/* 8382 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 8391
/* 8387 */    MCD::OPC_Decode, 166, 10, 50, // Opcode: VPICKEV_W
/* 8391 */    MCD::OPC_FilterValue, 7, 180, 48, 0, // Skip to: 20864
/* 8396 */    MCD::OPC_Decode, 164, 10, 51, // Opcode: VPICKEV_D
/* 8400 */    MCD::OPC_FilterValue, 72, 75, 0, 0, // Skip to: 8480
/* 8405 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8408 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8417
/* 8413 */    MCD::OPC_Decode, 167, 10, 82, // Opcode: VPICKOD_B
/* 8417 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8426
/* 8422 */    MCD::OPC_Decode, 169, 10, 83, // Opcode: VPICKOD_H
/* 8426 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8435
/* 8431 */    MCD::OPC_Decode, 170, 10, 50, // Opcode: VPICKOD_W
/* 8435 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 8444
/* 8440 */    MCD::OPC_Decode, 168, 10, 51, // Opcode: VPICKOD_D
/* 8444 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8453
/* 8449 */    MCD::OPC_Decode, 187, 10, 97, // Opcode: VREPLVE_B
/* 8453 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 8462
/* 8458 */    MCD::OPC_Decode, 189, 10, 98, // Opcode: VREPLVE_H
/* 8462 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 8471
/* 8467 */    MCD::OPC_Decode, 190, 10, 99, // Opcode: VREPLVE_W
/* 8471 */    MCD::OPC_FilterValue, 7, 100, 48, 0, // Skip to: 20864
/* 8476 */    MCD::OPC_Decode, 188, 10, 100, // Opcode: VREPLVE_D
/* 8480 */    MCD::OPC_FilterValue, 73, 39, 0, 0, // Skip to: 8524
/* 8485 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8488 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8497
/* 8493 */    MCD::OPC_Decode, 135, 7, 82, // Opcode: VAND_V
/* 8497 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 8506
/* 8502 */    MCD::OPC_Decode, 149, 10, 82, // Opcode: VOR_V
/* 8506 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 8515
/* 8511 */    MCD::OPC_Decode, 219, 12, 82, // Opcode: VXOR_V
/* 8515 */    MCD::OPC_FilterValue, 7, 56, 48, 0, // Skip to: 20864
/* 8520 */    MCD::OPC_Decode, 146, 10, 82, // Opcode: VNOR_V
/* 8524 */    MCD::OPC_FilterValue, 74, 39, 0, 0, // Skip to: 8568
/* 8529 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8532 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8541
/* 8537 */    MCD::OPC_Decode, 134, 7, 82, // Opcode: VANDN_V
/* 8541 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8550
/* 8546 */    MCD::OPC_Decode, 148, 10, 82, // Opcode: VORN_V
/* 8550 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 8559
/* 8555 */    MCD::OPC_Decode, 194, 8, 87, // Opcode: VFRSTP_B
/* 8559 */    MCD::OPC_FilterValue, 7, 12, 48, 0, // Skip to: 20864
/* 8564 */    MCD::OPC_Decode, 195, 8, 88, // Opcode: VFRSTP_H
/* 8568 */    MCD::OPC_FilterValue, 75, 57, 0, 0, // Skip to: 8630
/* 8573 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8576 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8585
/* 8581 */    MCD::OPC_Decode, 130, 7, 51, // Opcode: VADD_Q
/* 8585 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 8594
/* 8590 */    MCD::OPC_Decode, 215, 12, 51, // Opcode: VSUB_Q
/* 8594 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8603
/* 8599 */    MCD::OPC_Decode, 245, 10, 82, // Opcode: VSIGNCOV_B
/* 8603 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 8612
/* 8608 */    MCD::OPC_Decode, 247, 10, 83, // Opcode: VSIGNCOV_H
/* 8612 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 8621
/* 8617 */    MCD::OPC_Decode, 248, 10, 50, // Opcode: VSIGNCOV_W
/* 8621 */    MCD::OPC_FilterValue, 7, 206, 47, 0, // Skip to: 20864
/* 8626 */    MCD::OPC_Decode, 246, 10, 51, // Opcode: VSIGNCOV_D
/* 8630 */    MCD::OPC_FilterValue, 76, 39, 0, 0, // Skip to: 8674
/* 8635 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8638 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8647
/* 8643 */    MCD::OPC_Decode, 224, 7, 50, // Opcode: VFADD_S
/* 8647 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8656
/* 8652 */    MCD::OPC_Decode, 223, 7, 51, // Opcode: VFADD_D
/* 8656 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 8665
/* 8661 */    MCD::OPC_Decode, 199, 8, 50, // Opcode: VFSUB_S
/* 8665 */    MCD::OPC_FilterValue, 6, 162, 47, 0, // Skip to: 20864
/* 8670 */    MCD::OPC_Decode, 198, 8, 51, // Opcode: VFSUB_D
/* 8674 */    MCD::OPC_FilterValue, 78, 39, 0, 0, // Skip to: 8718
/* 8679 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8682 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8691
/* 8687 */    MCD::OPC_Decode, 173, 8, 50, // Opcode: VFMUL_S
/* 8691 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8700
/* 8696 */    MCD::OPC_Decode, 172, 8, 51, // Opcode: VFMUL_D
/* 8700 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 8709
/* 8705 */    MCD::OPC_Decode, 150, 8, 50, // Opcode: VFDIV_S
/* 8709 */    MCD::OPC_FilterValue, 6, 118, 47, 0, // Skip to: 20864
/* 8714 */    MCD::OPC_Decode, 149, 8, 51, // Opcode: VFDIV_D
/* 8718 */    MCD::OPC_FilterValue, 79, 39, 0, 0, // Skip to: 8762
/* 8723 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8726 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8735
/* 8731 */    MCD::OPC_Decode, 165, 8, 50, // Opcode: VFMAX_S
/* 8735 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8744
/* 8740 */    MCD::OPC_Decode, 164, 8, 51, // Opcode: VFMAX_D
/* 8744 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 8753
/* 8749 */    MCD::OPC_Decode, 169, 8, 50, // Opcode: VFMIN_S
/* 8753 */    MCD::OPC_FilterValue, 6, 74, 47, 0, // Skip to: 20864
/* 8758 */    MCD::OPC_Decode, 168, 8, 51, // Opcode: VFMIN_D
/* 8762 */    MCD::OPC_FilterValue, 80, 39, 0, 0, // Skip to: 8806
/* 8767 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8770 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8779
/* 8775 */    MCD::OPC_Decode, 163, 8, 50, // Opcode: VFMAXA_S
/* 8779 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8788
/* 8784 */    MCD::OPC_Decode, 162, 8, 51, // Opcode: VFMAXA_D
/* 8788 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 8797
/* 8793 */    MCD::OPC_Decode, 167, 8, 50, // Opcode: VFMINA_S
/* 8797 */    MCD::OPC_FilterValue, 6, 30, 47, 0, // Skip to: 20864
/* 8802 */    MCD::OPC_Decode, 166, 8, 51, // Opcode: VFMINA_D
/* 8806 */    MCD::OPC_FilterValue, 81, 21, 0, 0, // Skip to: 8832
/* 8811 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8814 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8823
/* 8819 */    MCD::OPC_Decode, 147, 8, 95, // Opcode: VFCVT_H_S
/* 8823 */    MCD::OPC_FilterValue, 5, 4, 47, 0, // Skip to: 20864
/* 8828 */    MCD::OPC_Decode, 148, 8, 96, // Opcode: VFCVT_S_D
/* 8832 */    MCD::OPC_FilterValue, 82, 57, 0, 0, // Skip to: 8894
/* 8837 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8840 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8849
/* 8845 */    MCD::OPC_Decode, 155, 8, 96, // Opcode: VFFINT_S_L
/* 8849 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 8858
/* 8854 */    MCD::OPC_Decode, 227, 8, 96, // Opcode: VFTINT_W_D
/* 8858 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8867
/* 8863 */    MCD::OPC_Decode, 205, 8, 96, // Opcode: VFTINTRM_W_D
/* 8867 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 8876
/* 8872 */    MCD::OPC_Decode, 215, 8, 96, // Opcode: VFTINTRP_W_D
/* 8876 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 8885
/* 8881 */    MCD::OPC_Decode, 222, 8, 96, // Opcode: VFTINTRZ_W_D
/* 8885 */    MCD::OPC_FilterValue, 7, 198, 46, 0, // Skip to: 20864
/* 8890 */    MCD::OPC_Decode, 210, 8, 96, // Opcode: VFTINTRNE_W_D
/* 8894 */    MCD::OPC_FilterValue, 94, 30, 0, 0, // Skip to: 8929
/* 8899 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8902 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 8911
/* 8907 */    MCD::OPC_Decode, 243, 10, 88, // Opcode: VSHUF_H
/* 8911 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 8920
/* 8916 */    MCD::OPC_Decode, 244, 10, 89, // Opcode: VSHUF_W
/* 8920 */    MCD::OPC_FilterValue, 7, 163, 46, 0, // Skip to: 20864
/* 8925 */    MCD::OPC_Decode, 242, 10, 90, // Opcode: VSHUF_D
/* 8929 */    MCD::OPC_FilterValue, 160, 1, 75, 0, 0, // Skip to: 9010
/* 8935 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 8938 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8947
/* 8943 */    MCD::OPC_Decode, 215, 10, 101, // Opcode: VSEQI_B
/* 8947 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8956
/* 8952 */    MCD::OPC_Decode, 219, 10, 102, // Opcode: VSEQI_H
/* 8956 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8965
/* 8961 */    MCD::OPC_Decode, 221, 10, 103, // Opcode: VSEQI_W
/* 8965 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 8974
/* 8970 */    MCD::OPC_Decode, 217, 10, 104, // Opcode: VSEQI_D
/* 8974 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8983
/* 8979 */    MCD::OPC_Decode, 249, 10, 101, // Opcode: VSLEI_B
/* 8983 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 8992
/* 8988 */    MCD::OPC_Decode, 129, 11, 102, // Opcode: VSLEI_H
/* 8992 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 9001
/* 8997 */    MCD::OPC_Decode, 133, 11, 103, // Opcode: VSLEI_W
/* 9001 */    MCD::OPC_FilterValue, 7, 82, 46, 0, // Skip to: 20864
/* 9006 */    MCD::OPC_Decode, 253, 10, 104, // Opcode: VSLEI_D
/* 9010 */    MCD::OPC_FilterValue, 161, 1, 75, 0, 0, // Skip to: 9091
/* 9016 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 9019 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 9028
/* 9024 */    MCD::OPC_Decode, 250, 10, 105, // Opcode: VSLEI_BU
/* 9028 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 9037
/* 9033 */    MCD::OPC_Decode, 130, 11, 106, // Opcode: VSLEI_HU
/* 9037 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 9046
/* 9042 */    MCD::OPC_Decode, 134, 11, 107, // Opcode: VSLEI_WU
/* 9046 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 9055
/* 9051 */    MCD::OPC_Decode, 254, 10, 108, // Opcode: VSLEI_DU
/* 9055 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 9064
/* 9060 */    MCD::OPC_Decode, 159, 11, 101, // Opcode: VSLTI_B
/* 9064 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 9073
/* 9069 */    MCD::OPC_Decode, 167, 11, 102, // Opcode: VSLTI_H
/* 9073 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 9082
/* 9078 */    MCD::OPC_Decode, 171, 11, 103, // Opcode: VSLTI_W
/* 9082 */    MCD::OPC_FilterValue, 7, 1, 46, 0, // Skip to: 20864
/* 9087 */    MCD::OPC_Decode, 163, 11, 104, // Opcode: VSLTI_D
/* 9091 */    MCD::OPC_FilterValue, 162, 1, 75, 0, 0, // Skip to: 9172
/* 9097 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 9100 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 9109
/* 9105 */    MCD::OPC_Decode, 160, 11, 105, // Opcode: VSLTI_BU
/* 9109 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 9118
/* 9114 */    MCD::OPC_Decode, 168, 11, 106, // Opcode: VSLTI_HU
/* 9118 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 9127
/* 9123 */    MCD::OPC_Decode, 172, 11, 107, // Opcode: VSLTI_WU
/* 9127 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 9136
/* 9132 */    MCD::OPC_Decode, 164, 11, 108, // Opcode: VSLTI_DU
/* 9136 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 9145
/* 9141 */    MCD::OPC_Decode, 227, 6, 105, // Opcode: VADDI_BU
/* 9145 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 9154
/* 9150 */    MCD::OPC_Decode, 229, 6, 106, // Opcode: VADDI_HU
/* 9154 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 9163
/* 9159 */    MCD::OPC_Decode, 230, 6, 107, // Opcode: VADDI_WU
/* 9163 */    MCD::OPC_FilterValue, 7, 176, 45, 0, // Skip to: 20864
/* 9168 */    MCD::OPC_Decode, 228, 6, 108, // Opcode: VADDI_DU
/* 9172 */    MCD::OPC_FilterValue, 163, 1, 57, 0, 0, // Skip to: 9235
/* 9178 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 9181 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 9190
/* 9186 */    MCD::OPC_Decode, 192, 12, 105, // Opcode: VSUBI_BU
/* 9190 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 9199
/* 9195 */    MCD::OPC_Decode, 194, 12, 106, // Opcode: VSUBI_HU
/* 9199 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 9208
/* 9204 */    MCD::OPC_Decode, 195, 12, 107, // Opcode: VSUBI_WU
/* 9208 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 9217
/* 9213 */    MCD::OPC_Decode, 193, 12, 108, // Opcode: VSUBI_DU
/* 9217 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 9226
/* 9222 */    MCD::OPC_Decode, 179, 7, 105, // Opcode: VBSLL_V
/* 9226 */    MCD::OPC_FilterValue, 5, 113, 45, 0, // Skip to: 20864
/* 9231 */    MCD::OPC_Decode, 180, 7, 105, // Opcode: VBSRL_V
/* 9235 */    MCD::OPC_FilterValue, 164, 1, 75, 0, 0, // Skip to: 9316
/* 9241 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 9244 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 9253
/* 9249 */    MCD::OPC_Decode, 171, 9, 101, // Opcode: VMAXI_B
/* 9253 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 9262
/* 9258 */    MCD::OPC_Decode, 179, 9, 102, // Opcode: VMAXI_H
/* 9262 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 9271
/* 9267 */    MCD::OPC_Decode, 183, 9, 103, // Opcode: VMAXI_W
/* 9271 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 9280
/* 9276 */    MCD::OPC_Decode, 175, 9, 104, // Opcode: VMAXI_D
/* 9280 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 9289
/* 9285 */    MCD::OPC_Decode, 195, 9, 101, // Opcode: VMINI_B
/* 9289 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 9298
/* 9294 */    MCD::OPC_Decode, 201, 9, 102, // Opcode: VMINI_H
/* 9298 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 9307
/* 9303 */    MCD::OPC_Decode, 204, 9, 103, // Opcode: VMINI_W
/* 9307 */    MCD::OPC_FilterValue, 7, 32, 45, 0, // Skip to: 20864
/* 9312 */    MCD::OPC_Decode, 198, 9, 104, // Opcode: VMINI_D
/* 9316 */    MCD::OPC_FilterValue, 165, 1, 75, 0, 0, // Skip to: 9397
/* 9322 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 9325 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 9334
/* 9330 */    MCD::OPC_Decode, 172, 9, 105, // Opcode: VMAXI_BU
/* 9334 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 9343
/* 9339 */    MCD::OPC_Decode, 180, 9, 106, // Opcode: VMAXI_HU
/* 9343 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 9352
/* 9348 */    MCD::OPC_Decode, 184, 9, 107, // Opcode: VMAXI_WU
/* 9352 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 9361
/* 9357 */    MCD::OPC_Decode, 176, 9, 108, // Opcode: VMAXI_DU
/* 9361 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 9370
/* 9366 */    MCD::OPC_Decode, 196, 9, 105, // Opcode: VMINI_BU
/* 9370 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 9379
/* 9375 */    MCD::OPC_Decode, 202, 9, 106, // Opcode: VMINI_HU
/* 9379 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 9388
/* 9384 */    MCD::OPC_Decode, 205, 9, 107, // Opcode: VMINI_WU
/* 9388 */    MCD::OPC_FilterValue, 7, 207, 44, 0, // Skip to: 20864
/* 9393 */    MCD::OPC_Decode, 199, 9, 108, // Opcode: VMINI_DU
/* 9397 */    MCD::OPC_FilterValue, 166, 1, 21, 0, 0, // Skip to: 9424
/* 9403 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 9406 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 9415
/* 9411 */    MCD::OPC_Decode, 192, 8, 109, // Opcode: VFRSTPI_B
/* 9415 */    MCD::OPC_FilterValue, 5, 180, 44, 0, // Skip to: 20864
/* 9420 */    MCD::OPC_Decode, 193, 8, 110, // Opcode: VFRSTPI_H
/* 9424 */    MCD::OPC_FilterValue, 167, 1, 229, 3, 0, // Skip to: 10427
/* 9430 */    MCD::OPC_ExtractField, 10, 8,  // Inst{17-10} ...
/* 9433 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 9442
/* 9438 */    MCD::OPC_Decode, 181, 7, 111, // Opcode: VCLO_B
/* 9442 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 9451
/* 9447 */    MCD::OPC_Decode, 183, 7, 112, // Opcode: VCLO_H
/* 9451 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 9460
/* 9456 */    MCD::OPC_Decode, 184, 7, 113, // Opcode: VCLO_W
/* 9460 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 9469
/* 9465 */    MCD::OPC_Decode, 182, 7, 114, // Opcode: VCLO_D
/* 9469 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 9478
/* 9474 */    MCD::OPC_Decode, 185, 7, 111, // Opcode: VCLZ_B
/* 9478 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 9487
/* 9483 */    MCD::OPC_Decode, 187, 7, 112, // Opcode: VCLZ_H
/* 9487 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 9496
/* 9492 */    MCD::OPC_Decode, 188, 7, 113, // Opcode: VCLZ_W
/* 9496 */    MCD::OPC_FilterValue, 7, 4, 0, 0, // Skip to: 9505
/* 9501 */    MCD::OPC_Decode, 186, 7, 114, // Opcode: VCLZ_D
/* 9505 */    MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 9514
/* 9510 */    MCD::OPC_Decode, 158, 10, 111, // Opcode: VPCNT_B
/* 9514 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 9523
/* 9519 */    MCD::OPC_Decode, 160, 10, 112, // Opcode: VPCNT_H
/* 9523 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 9532
/* 9528 */    MCD::OPC_Decode, 161, 10, 113, // Opcode: VPCNT_W
/* 9532 */    MCD::OPC_FilterValue, 11, 4, 0, 0, // Skip to: 9541
/* 9537 */    MCD::OPC_Decode, 159, 10, 114, // Opcode: VPCNT_D
/* 9541 */    MCD::OPC_FilterValue, 12, 4, 0, 0, // Skip to: 9550
/* 9546 */    MCD::OPC_Decode, 141, 10, 111, // Opcode: VNEG_B
/* 9550 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 9559
/* 9555 */    MCD::OPC_Decode, 143, 10, 112, // Opcode: VNEG_H
/* 9559 */    MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 9568
/* 9564 */    MCD::OPC_Decode, 144, 10, 113, // Opcode: VNEG_W
/* 9568 */    MCD::OPC_FilterValue, 15, 4, 0, 0, // Skip to: 9577
/* 9573 */    MCD::OPC_Decode, 142, 10, 114, // Opcode: VNEG_D
/* 9577 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 9586
/* 9582 */    MCD::OPC_Decode, 224, 9, 111, // Opcode: VMSKLTZ_B
/* 9586 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 9595
/* 9591 */    MCD::OPC_Decode, 226, 9, 112, // Opcode: VMSKLTZ_H
/* 9595 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 9604
/* 9600 */    MCD::OPC_Decode, 227, 9, 113, // Opcode: VMSKLTZ_W
/* 9604 */    MCD::OPC_FilterValue, 19, 4, 0, 0, // Skip to: 9613
/* 9609 */    MCD::OPC_Decode, 225, 9, 114, // Opcode: VMSKLTZ_D
/* 9613 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 9622
/* 9618 */    MCD::OPC_Decode, 223, 9, 111, // Opcode: VMSKGEZ_B
/* 9622 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 9631
/* 9627 */    MCD::OPC_Decode, 228, 9, 111, // Opcode: VMSKNZ_B
/* 9631 */    MCD::OPC_FilterValue, 38, 11, 0, 0, // Skip to: 9647
/* 9636 */    MCD::OPC_CheckField, 3, 2, 0, 213, 43, 0, // Skip to: 20864
/* 9643 */    MCD::OPC_Decode, 235, 10, 115, // Opcode: VSETEQZ_V
/* 9647 */    MCD::OPC_FilterValue, 39, 11, 0, 0, // Skip to: 9663
/* 9652 */    MCD::OPC_CheckField, 3, 2, 0, 197, 43, 0, // Skip to: 20864
/* 9659 */    MCD::OPC_Decode, 236, 10, 115, // Opcode: VSETNEZ_V
/* 9663 */    MCD::OPC_FilterValue, 40, 11, 0, 0, // Skip to: 9679
/* 9668 */    MCD::OPC_CheckField, 3, 2, 0, 181, 43, 0, // Skip to: 20864
/* 9675 */    MCD::OPC_Decode, 231, 10, 115, // Opcode: VSETANYEQZ_B
/* 9679 */    MCD::OPC_FilterValue, 41, 11, 0, 0, // Skip to: 9695
/* 9684 */    MCD::OPC_CheckField, 3, 2, 0, 165, 43, 0, // Skip to: 20864
/* 9691 */    MCD::OPC_Decode, 233, 10, 116, // Opcode: VSETANYEQZ_H
/* 9695 */    MCD::OPC_FilterValue, 42, 11, 0, 0, // Skip to: 9711
/* 9700 */    MCD::OPC_CheckField, 3, 2, 0, 149, 43, 0, // Skip to: 20864
/* 9707 */    MCD::OPC_Decode, 234, 10, 117, // Opcode: VSETANYEQZ_W
/* 9711 */    MCD::OPC_FilterValue, 43, 11, 0, 0, // Skip to: 9727
/* 9716 */    MCD::OPC_CheckField, 3, 2, 0, 133, 43, 0, // Skip to: 20864
/* 9723 */    MCD::OPC_Decode, 232, 10, 118, // Opcode: VSETANYEQZ_D
/* 9727 */    MCD::OPC_FilterValue, 44, 11, 0, 0, // Skip to: 9743
/* 9732 */    MCD::OPC_CheckField, 3, 2, 0, 117, 43, 0, // Skip to: 20864
/* 9739 */    MCD::OPC_Decode, 227, 10, 115, // Opcode: VSETALLNEZ_B
/* 9743 */    MCD::OPC_FilterValue, 45, 11, 0, 0, // Skip to: 9759
/* 9748 */    MCD::OPC_CheckField, 3, 2, 0, 101, 43, 0, // Skip to: 20864
/* 9755 */    MCD::OPC_Decode, 229, 10, 116, // Opcode: VSETALLNEZ_H
/* 9759 */    MCD::OPC_FilterValue, 46, 11, 0, 0, // Skip to: 9775
/* 9764 */    MCD::OPC_CheckField, 3, 2, 0, 85, 43, 0, // Skip to: 20864
/* 9771 */    MCD::OPC_Decode, 230, 10, 117, // Opcode: VSETALLNEZ_W
/* 9775 */    MCD::OPC_FilterValue, 47, 11, 0, 0, // Skip to: 9791
/* 9780 */    MCD::OPC_CheckField, 3, 2, 0, 69, 43, 0, // Skip to: 20864
/* 9787 */    MCD::OPC_Decode, 228, 10, 118, // Opcode: VSETALLNEZ_D
/* 9791 */    MCD::OPC_FilterValue, 49, 4, 0, 0, // Skip to: 9800
/* 9796 */    MCD::OPC_Decode, 159, 8, 113, // Opcode: VFLOGB_S
/* 9800 */    MCD::OPC_FilterValue, 50, 4, 0, 0, // Skip to: 9809
/* 9805 */    MCD::OPC_Decode, 158, 8, 114, // Opcode: VFLOGB_D
/* 9809 */    MCD::OPC_FilterValue, 53, 4, 0, 0, // Skip to: 9818
/* 9814 */    MCD::OPC_Decode, 226, 7, 113, // Opcode: VFCLASS_S
/* 9818 */    MCD::OPC_FilterValue, 54, 4, 0, 0, // Skip to: 9827
/* 9823 */    MCD::OPC_Decode, 225, 7, 114, // Opcode: VFCLASS_D
/* 9827 */    MCD::OPC_FilterValue, 57, 4, 0, 0, // Skip to: 9836
/* 9832 */    MCD::OPC_Decode, 197, 8, 113, // Opcode: VFSQRT_S
/* 9836 */    MCD::OPC_FilterValue, 58, 4, 0, 0, // Skip to: 9845
/* 9841 */    MCD::OPC_Decode, 196, 8, 114, // Opcode: VFSQRT_D
/* 9845 */    MCD::OPC_FilterValue, 61, 4, 0, 0, // Skip to: 9854
/* 9850 */    MCD::OPC_Decode, 179, 8, 113, // Opcode: VFRECIP_S
/* 9854 */    MCD::OPC_FilterValue, 62, 4, 0, 0, // Skip to: 9863
/* 9859 */    MCD::OPC_Decode, 178, 8, 114, // Opcode: VFRECIP_D
/* 9863 */    MCD::OPC_FilterValue, 65, 4, 0, 0, // Skip to: 9872
/* 9868 */    MCD::OPC_Decode, 191, 8, 113, // Opcode: VFRSQRT_S
/* 9872 */    MCD::OPC_FilterValue, 66, 4, 0, 0, // Skip to: 9881
/* 9877 */    MCD::OPC_Decode, 190, 8, 114, // Opcode: VFRSQRT_D
/* 9881 */    MCD::OPC_FilterValue, 77, 4, 0, 0, // Skip to: 9890
/* 9886 */    MCD::OPC_Decode, 189, 8, 113, // Opcode: VFRINT_S
/* 9890 */    MCD::OPC_FilterValue, 78, 4, 0, 0, // Skip to: 9899
/* 9895 */    MCD::OPC_Decode, 188, 8, 114, // Opcode: VFRINT_D
/* 9899 */    MCD::OPC_FilterValue, 81, 4, 0, 0, // Skip to: 9908
/* 9904 */    MCD::OPC_Decode, 181, 8, 113, // Opcode: VFRINTRM_S
/* 9908 */    MCD::OPC_FilterValue, 82, 4, 0, 0, // Skip to: 9917
/* 9913 */    MCD::OPC_Decode, 180, 8, 114, // Opcode: VFRINTRM_D
/* 9917 */    MCD::OPC_FilterValue, 85, 4, 0, 0, // Skip to: 9926
/* 9922 */    MCD::OPC_Decode, 185, 8, 113, // Opcode: VFRINTRP_S
/* 9926 */    MCD::OPC_FilterValue, 86, 4, 0, 0, // Skip to: 9935
/* 9931 */    MCD::OPC_Decode, 184, 8, 114, // Opcode: VFRINTRP_D
/* 9935 */    MCD::OPC_FilterValue, 89, 4, 0, 0, // Skip to: 9944
/* 9940 */    MCD::OPC_Decode, 187, 8, 113, // Opcode: VFRINTRZ_S
/* 9944 */    MCD::OPC_FilterValue, 90, 4, 0, 0, // Skip to: 9953
/* 9949 */    MCD::OPC_Decode, 186, 8, 114, // Opcode: VFRINTRZ_D
/* 9953 */    MCD::OPC_FilterValue, 93, 4, 0, 0, // Skip to: 9962
/* 9958 */    MCD::OPC_Decode, 183, 8, 113, // Opcode: VFRINTRNE_S
/* 9962 */    MCD::OPC_FilterValue, 94, 4, 0, 0, // Skip to: 9971
/* 9967 */    MCD::OPC_Decode, 182, 8, 114, // Opcode: VFRINTRNE_D
/* 9971 */    MCD::OPC_FilterValue, 122, 4, 0, 0, // Skip to: 9980
/* 9976 */    MCD::OPC_Decode, 146, 8, 119, // Opcode: VFCVTL_S_H
/* 9980 */    MCD::OPC_FilterValue, 123, 4, 0, 0, // Skip to: 9989
/* 9985 */    MCD::OPC_Decode, 144, 8, 119, // Opcode: VFCVTH_S_H
/* 9989 */    MCD::OPC_FilterValue, 124, 4, 0, 0, // Skip to: 9998
/* 9994 */    MCD::OPC_Decode, 145, 8, 120, // Opcode: VFCVTL_D_S
/* 9998 */    MCD::OPC_FilterValue, 125, 4, 0, 0, // Skip to: 10007
/* 10003 */   MCD::OPC_Decode, 143, 8, 120, // Opcode: VFCVTH_D_S
/* 10007 */   MCD::OPC_FilterValue, 128, 1, 4, 0, 0, // Skip to: 10017
/* 10013 */   MCD::OPC_Decode, 156, 8, 113, // Opcode: VFFINT_S_W
/* 10017 */   MCD::OPC_FilterValue, 129, 1, 4, 0, 0, // Skip to: 10027
/* 10023 */   MCD::OPC_Decode, 157, 8, 113, // Opcode: VFFINT_S_WU
/* 10027 */   MCD::OPC_FilterValue, 130, 1, 4, 0, 0, // Skip to: 10037
/* 10033 */   MCD::OPC_Decode, 153, 8, 114, // Opcode: VFFINT_D_L
/* 10037 */   MCD::OPC_FilterValue, 131, 1, 4, 0, 0, // Skip to: 10047
/* 10043 */   MCD::OPC_Decode, 154, 8, 114, // Opcode: VFFINT_D_LU
/* 10047 */   MCD::OPC_FilterValue, 132, 1, 4, 0, 0, // Skip to: 10057
/* 10053 */   MCD::OPC_Decode, 152, 8, 120, // Opcode: VFFINTL_D_W
/* 10057 */   MCD::OPC_FilterValue, 133, 1, 4, 0, 0, // Skip to: 10067
/* 10063 */   MCD::OPC_Decode, 151, 8, 120, // Opcode: VFFINTH_D_W
/* 10067 */   MCD::OPC_FilterValue, 140, 1, 4, 0, 0, // Skip to: 10077
/* 10073 */   MCD::OPC_Decode, 228, 8, 113, // Opcode: VFTINT_W_S
/* 10077 */   MCD::OPC_FilterValue, 141, 1, 4, 0, 0, // Skip to: 10087
/* 10083 */   MCD::OPC_Decode, 225, 8, 114, // Opcode: VFTINT_L_D
/* 10087 */   MCD::OPC_FilterValue, 142, 1, 4, 0, 0, // Skip to: 10097
/* 10093 */   MCD::OPC_Decode, 206, 8, 113, // Opcode: VFTINTRM_W_S
/* 10097 */   MCD::OPC_FilterValue, 143, 1, 4, 0, 0, // Skip to: 10107
/* 10103 */   MCD::OPC_Decode, 204, 8, 114, // Opcode: VFTINTRM_L_D
/* 10107 */   MCD::OPC_FilterValue, 144, 1, 4, 0, 0, // Skip to: 10117
/* 10113 */   MCD::OPC_Decode, 216, 8, 113, // Opcode: VFTINTRP_W_S
/* 10117 */   MCD::OPC_FilterValue, 145, 1, 4, 0, 0, // Skip to: 10127
/* 10123 */   MCD::OPC_Decode, 214, 8, 114, // Opcode: VFTINTRP_L_D
/* 10127 */   MCD::OPC_FilterValue, 146, 1, 4, 0, 0, // Skip to: 10137
/* 10133 */   MCD::OPC_Decode, 223, 8, 113, // Opcode: VFTINTRZ_W_S
/* 10137 */   MCD::OPC_FilterValue, 147, 1, 4, 0, 0, // Skip to: 10147
/* 10143 */   MCD::OPC_Decode, 220, 8, 114, // Opcode: VFTINTRZ_L_D
/* 10147 */   MCD::OPC_FilterValue, 148, 1, 4, 0, 0, // Skip to: 10157
/* 10153 */   MCD::OPC_Decode, 211, 8, 113, // Opcode: VFTINTRNE_W_S
/* 10157 */   MCD::OPC_FilterValue, 149, 1, 4, 0, 0, // Skip to: 10167
/* 10163 */   MCD::OPC_Decode, 209, 8, 114, // Opcode: VFTINTRNE_L_D
/* 10167 */   MCD::OPC_FilterValue, 150, 1, 4, 0, 0, // Skip to: 10177
/* 10173 */   MCD::OPC_Decode, 226, 8, 113, // Opcode: VFTINT_WU_S
/* 10177 */   MCD::OPC_FilterValue, 151, 1, 4, 0, 0, // Skip to: 10187
/* 10183 */   MCD::OPC_Decode, 224, 8, 114, // Opcode: VFTINT_LU_D
/* 10187 */   MCD::OPC_FilterValue, 156, 1, 4, 0, 0, // Skip to: 10197
/* 10193 */   MCD::OPC_Decode, 221, 8, 113, // Opcode: VFTINTRZ_WU_S
/* 10197 */   MCD::OPC_FilterValue, 157, 1, 4, 0, 0, // Skip to: 10207
/* 10203 */   MCD::OPC_Decode, 219, 8, 114, // Opcode: VFTINTRZ_LU_D
/* 10207 */   MCD::OPC_FilterValue, 160, 1, 4, 0, 0, // Skip to: 10217
/* 10213 */   MCD::OPC_Decode, 201, 8, 120, // Opcode: VFTINTL_L_S
/* 10217 */   MCD::OPC_FilterValue, 161, 1, 4, 0, 0, // Skip to: 10227
/* 10223 */   MCD::OPC_Decode, 200, 8, 120, // Opcode: VFTINTH_L_S
/* 10227 */   MCD::OPC_FilterValue, 162, 1, 4, 0, 0, // Skip to: 10237
/* 10233 */   MCD::OPC_Decode, 203, 8, 120, // Opcode: VFTINTRML_L_S
/* 10237 */   MCD::OPC_FilterValue, 163, 1, 4, 0, 0, // Skip to: 10247
/* 10243 */   MCD::OPC_Decode, 202, 8, 120, // Opcode: VFTINTRMH_L_S
/* 10247 */   MCD::OPC_FilterValue, 164, 1, 4, 0, 0, // Skip to: 10257
/* 10253 */   MCD::OPC_Decode, 213, 8, 120, // Opcode: VFTINTRPL_L_S
/* 10257 */   MCD::OPC_FilterValue, 165, 1, 4, 0, 0, // Skip to: 10267
/* 10263 */   MCD::OPC_Decode, 212, 8, 120, // Opcode: VFTINTRPH_L_S
/* 10267 */   MCD::OPC_FilterValue, 166, 1, 4, 0, 0, // Skip to: 10277
/* 10273 */   MCD::OPC_Decode, 218, 8, 120, // Opcode: VFTINTRZL_L_S
/* 10277 */   MCD::OPC_FilterValue, 167, 1, 4, 0, 0, // Skip to: 10287
/* 10283 */   MCD::OPC_Decode, 217, 8, 120, // Opcode: VFTINTRZH_L_S
/* 10287 */   MCD::OPC_FilterValue, 168, 1, 4, 0, 0, // Skip to: 10297
/* 10293 */   MCD::OPC_Decode, 208, 8, 120, // Opcode: VFTINTRNEL_L_S
/* 10297 */   MCD::OPC_FilterValue, 169, 1, 4, 0, 0, // Skip to: 10307
/* 10303 */   MCD::OPC_Decode, 207, 8, 120, // Opcode: VFTINTRNEH_L_S
/* 10307 */   MCD::OPC_FilterValue, 184, 1, 4, 0, 0, // Skip to: 10317
/* 10313 */   MCD::OPC_Decode, 212, 7, 121, // Opcode: VEXTH_H_B
/* 10317 */   MCD::OPC_FilterValue, 185, 1, 4, 0, 0, // Skip to: 10327
/* 10323 */   MCD::OPC_Decode, 216, 7, 119, // Opcode: VEXTH_W_H
/* 10327 */   MCD::OPC_FilterValue, 186, 1, 4, 0, 0, // Skip to: 10337
/* 10333 */   MCD::OPC_Decode, 210, 7, 120, // Opcode: VEXTH_D_W
/* 10337 */   MCD::OPC_FilterValue, 187, 1, 4, 0, 0, // Skip to: 10347
/* 10343 */   MCD::OPC_Decode, 214, 7, 114, // Opcode: VEXTH_Q_D
/* 10347 */   MCD::OPC_FilterValue, 188, 1, 4, 0, 0, // Skip to: 10357
/* 10353 */   MCD::OPC_Decode, 211, 7, 121, // Opcode: VEXTH_HU_BU
/* 10357 */   MCD::OPC_FilterValue, 189, 1, 4, 0, 0, // Skip to: 10367
/* 10363 */   MCD::OPC_Decode, 215, 7, 119, // Opcode: VEXTH_WU_HU
/* 10367 */   MCD::OPC_FilterValue, 190, 1, 4, 0, 0, // Skip to: 10377
/* 10373 */   MCD::OPC_Decode, 209, 7, 120, // Opcode: VEXTH_DU_WU
/* 10377 */   MCD::OPC_FilterValue, 191, 1, 4, 0, 0, // Skip to: 10387
/* 10383 */   MCD::OPC_Decode, 213, 7, 114, // Opcode: VEXTH_QU_DU
/* 10387 */   MCD::OPC_FilterValue, 192, 1, 4, 0, 0, // Skip to: 10397
/* 10393 */   MCD::OPC_Decode, 179, 10, 122, // Opcode: VREPLGR2VR_B
/* 10397 */   MCD::OPC_FilterValue, 193, 1, 4, 0, 0, // Skip to: 10407
/* 10403 */   MCD::OPC_Decode, 181, 10, 123, // Opcode: VREPLGR2VR_H
/* 10407 */   MCD::OPC_FilterValue, 194, 1, 4, 0, 0, // Skip to: 10417
/* 10413 */   MCD::OPC_Decode, 182, 10, 124, // Opcode: VREPLGR2VR_W
/* 10417 */   MCD::OPC_FilterValue, 195, 1, 201, 40, 0, // Skip to: 20864
/* 10423 */   MCD::OPC_Decode, 180, 10, 125, // Opcode: VREPLGR2VR_D
/* 10427 */   MCD::OPC_FilterValue, 168, 1, 63, 0, 0, // Skip to: 10496
/* 10433 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 10436 */   MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 10486
/* 10441 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 10444 */   MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 10477
/* 10449 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 10452 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 10468
/* 10457 */   MCD::OPC_CheckField, 13, 1, 1, 160, 40, 0, // Skip to: 20864
/* 10464 */   MCD::OPC_Decode, 191, 10, 126, // Opcode: VROTRI_B
/* 10468 */   MCD::OPC_FilterValue, 1, 151, 40, 0, // Skip to: 20864
/* 10473 */   MCD::OPC_Decode, 193, 10, 127, // Opcode: VROTRI_H
/* 10477 */   MCD::OPC_FilterValue, 1, 142, 40, 0, // Skip to: 20864
/* 10482 */   MCD::OPC_Decode, 194, 10, 107, // Opcode: VROTRI_W
/* 10486 */   MCD::OPC_FilterValue, 1, 133, 40, 0, // Skip to: 20864
/* 10491 */   MCD::OPC_Decode, 192, 10, 128, 1, // Opcode: VROTRI_D
/* 10496 */   MCD::OPC_FilterValue, 169, 1, 63, 0, 0, // Skip to: 10565
/* 10502 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 10505 */   MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 10555
/* 10510 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 10513 */   MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 10546
/* 10518 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 10521 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 10537
/* 10526 */   MCD::OPC_CheckField, 13, 1, 1, 91, 40, 0, // Skip to: 20864
/* 10533 */   MCD::OPC_Decode, 228, 11, 126, // Opcode: VSRLRI_B
/* 10537 */   MCD::OPC_FilterValue, 1, 82, 40, 0, // Skip to: 20864
/* 10542 */   MCD::OPC_Decode, 230, 11, 127, // Opcode: VSRLRI_H
/* 10546 */   MCD::OPC_FilterValue, 1, 73, 40, 0, // Skip to: 20864
/* 10551 */   MCD::OPC_Decode, 231, 11, 107, // Opcode: VSRLRI_W
/* 10555 */   MCD::OPC_FilterValue, 1, 64, 40, 0, // Skip to: 20864
/* 10560 */   MCD::OPC_Decode, 229, 11, 128, 1, // Opcode: VSRLRI_D
/* 10565 */   MCD::OPC_FilterValue, 170, 1, 63, 0, 0, // Skip to: 10634
/* 10571 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 10574 */   MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 10624
/* 10579 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 10582 */   MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 10615
/* 10587 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 10590 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 10606
/* 10595 */   MCD::OPC_CheckField, 13, 1, 1, 22, 40, 0, // Skip to: 20864
/* 10602 */   MCD::OPC_Decode, 198, 11, 126, // Opcode: VSRARI_B
/* 10606 */   MCD::OPC_FilterValue, 1, 13, 40, 0, // Skip to: 20864
/* 10611 */   MCD::OPC_Decode, 200, 11, 127, // Opcode: VSRARI_H
/* 10615 */   MCD::OPC_FilterValue, 1, 4, 40, 0, // Skip to: 20864
/* 10620 */   MCD::OPC_Decode, 201, 11, 107, // Opcode: VSRARI_W
/* 10624 */   MCD::OPC_FilterValue, 1, 251, 39, 0, // Skip to: 20864
/* 10629 */   MCD::OPC_Decode, 199, 11, 128, 1, // Opcode: VSRARI_D
/* 10634 */   MCD::OPC_FilterValue, 186, 1, 66, 0, 0, // Skip to: 10706
/* 10640 */   MCD::OPC_ExtractField, 14, 4,  // Inst{17-14} ...
/* 10643 */   MCD::OPC_FilterValue, 14, 5, 0, 0, // Skip to: 10653
/* 10648 */   MCD::OPC_Decode, 253, 8, 129, 1, // Opcode: VINSGR2VR_B
/* 10653 */   MCD::OPC_FilterValue, 15, 222, 39, 0, // Skip to: 20864
/* 10658 */   MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 10661 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10671
/* 10666 */   MCD::OPC_Decode, 255, 8, 130, 1, // Opcode: VINSGR2VR_H
/* 10671 */   MCD::OPC_FilterValue, 1, 204, 39, 0, // Skip to: 20864
/* 10676 */   MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 10679 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10689
/* 10684 */   MCD::OPC_Decode, 128, 9, 131, 1, // Opcode: VINSGR2VR_W
/* 10689 */   MCD::OPC_FilterValue, 1, 186, 39, 0, // Skip to: 20864
/* 10694 */   MCD::OPC_CheckField, 11, 1, 0, 179, 39, 0, // Skip to: 20864
/* 10701 */   MCD::OPC_Decode, 254, 8, 132, 1, // Opcode: VINSGR2VR_D
/* 10706 */   MCD::OPC_FilterValue, 187, 1, 66, 0, 0, // Skip to: 10778
/* 10712 */   MCD::OPC_ExtractField, 14, 4,  // Inst{17-14} ...
/* 10715 */   MCD::OPC_FilterValue, 14, 5, 0, 0, // Skip to: 10725
/* 10720 */   MCD::OPC_Decode, 171, 10, 133, 1, // Opcode: VPICKVE2GR_B
/* 10725 */   MCD::OPC_FilterValue, 15, 150, 39, 0, // Skip to: 20864
/* 10730 */   MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 10733 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10743
/* 10738 */   MCD::OPC_Decode, 175, 10, 134, 1, // Opcode: VPICKVE2GR_H
/* 10743 */   MCD::OPC_FilterValue, 1, 132, 39, 0, // Skip to: 20864
/* 10748 */   MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 10751 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10761
/* 10756 */   MCD::OPC_Decode, 177, 10, 135, 1, // Opcode: VPICKVE2GR_W
/* 10761 */   MCD::OPC_FilterValue, 1, 114, 39, 0, // Skip to: 20864
/* 10766 */   MCD::OPC_CheckField, 11, 1, 0, 107, 39, 0, // Skip to: 20864
/* 10773 */   MCD::OPC_Decode, 173, 10, 136, 1, // Opcode: VPICKVE2GR_D
/* 10778 */   MCD::OPC_FilterValue, 188, 1, 66, 0, 0, // Skip to: 10850
/* 10784 */   MCD::OPC_ExtractField, 14, 4,  // Inst{17-14} ...
/* 10787 */   MCD::OPC_FilterValue, 14, 5, 0, 0, // Skip to: 10797
/* 10792 */   MCD::OPC_Decode, 172, 10, 133, 1, // Opcode: VPICKVE2GR_BU
/* 10797 */   MCD::OPC_FilterValue, 15, 78, 39, 0, // Skip to: 20864
/* 10802 */   MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 10805 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10815
/* 10810 */   MCD::OPC_Decode, 176, 10, 134, 1, // Opcode: VPICKVE2GR_HU
/* 10815 */   MCD::OPC_FilterValue, 1, 60, 39, 0, // Skip to: 20864
/* 10820 */   MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 10823 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10833
/* 10828 */   MCD::OPC_Decode, 178, 10, 135, 1, // Opcode: VPICKVE2GR_WU
/* 10833 */   MCD::OPC_FilterValue, 1, 42, 39, 0, // Skip to: 20864
/* 10838 */   MCD::OPC_CheckField, 11, 1, 0, 35, 39, 0, // Skip to: 20864
/* 10845 */   MCD::OPC_Decode, 174, 10, 136, 1, // Opcode: VPICKVE2GR_DU
/* 10850 */   MCD::OPC_FilterValue, 189, 1, 66, 0, 0, // Skip to: 10922
/* 10856 */   MCD::OPC_ExtractField, 14, 4,  // Inst{17-14} ...
/* 10859 */   MCD::OPC_FilterValue, 14, 5, 0, 0, // Skip to: 10869
/* 10864 */   MCD::OPC_Decode, 183, 10, 137, 1, // Opcode: VREPLVEI_B
/* 10869 */   MCD::OPC_FilterValue, 15, 6, 39, 0, // Skip to: 20864
/* 10874 */   MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 10877 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10887
/* 10882 */   MCD::OPC_Decode, 185, 10, 138, 1, // Opcode: VREPLVEI_H
/* 10887 */   MCD::OPC_FilterValue, 1, 244, 38, 0, // Skip to: 20864
/* 10892 */   MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 10895 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10905
/* 10900 */   MCD::OPC_Decode, 186, 10, 139, 1, // Opcode: VREPLVEI_W
/* 10905 */   MCD::OPC_FilterValue, 1, 226, 38, 0, // Skip to: 20864
/* 10910 */   MCD::OPC_CheckField, 11, 1, 0, 219, 38, 0, // Skip to: 20864
/* 10917 */   MCD::OPC_Decode, 184, 10, 140, 1, // Opcode: VREPLVEI_D
/* 10922 */   MCD::OPC_FilterValue, 194, 1, 64, 0, 0, // Skip to: 10992
/* 10928 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 10931 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 10966
/* 10936 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 10939 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10956
/* 10944 */   MCD::OPC_CheckField, 13, 1, 1, 185, 38, 0, // Skip to: 20864
/* 10951 */   MCD::OPC_Decode, 152, 11, 141, 1, // Opcode: VSLLWIL_H_B
/* 10956 */   MCD::OPC_FilterValue, 1, 175, 38, 0, // Skip to: 20864
/* 10961 */   MCD::OPC_Decode, 154, 11, 142, 1, // Opcode: VSLLWIL_W_H
/* 10966 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 10976
/* 10971 */   MCD::OPC_Decode, 150, 11, 143, 1, // Opcode: VSLLWIL_D_W
/* 10976 */   MCD::OPC_FilterValue, 2, 155, 38, 0, // Skip to: 20864
/* 10981 */   MCD::OPC_CheckField, 10, 5, 0, 148, 38, 0, // Skip to: 20864
/* 10988 */   MCD::OPC_Decode, 218, 7, 114, // Opcode: VEXTL_Q_D
/* 10992 */   MCD::OPC_FilterValue, 195, 1, 64, 0, 0, // Skip to: 11062
/* 10998 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 11001 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 11036
/* 11006 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 11009 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11026
/* 11014 */   MCD::OPC_CheckField, 13, 1, 1, 115, 38, 0, // Skip to: 20864
/* 11021 */   MCD::OPC_Decode, 151, 11, 141, 1, // Opcode: VSLLWIL_HU_BU
/* 11026 */   MCD::OPC_FilterValue, 1, 105, 38, 0, // Skip to: 20864
/* 11031 */   MCD::OPC_Decode, 153, 11, 142, 1, // Opcode: VSLLWIL_WU_HU
/* 11036 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 11046
/* 11041 */   MCD::OPC_Decode, 149, 11, 143, 1, // Opcode: VSLLWIL_DU_WU
/* 11046 */   MCD::OPC_FilterValue, 2, 85, 38, 0, // Skip to: 20864
/* 11051 */   MCD::OPC_CheckField, 10, 5, 0, 78, 38, 0, // Skip to: 20864
/* 11058 */   MCD::OPC_Decode, 217, 7, 114, // Opcode: VEXTL_QU_DU
/* 11062 */   MCD::OPC_FilterValue, 196, 1, 63, 0, 0, // Skip to: 11131
/* 11068 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 11071 */   MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 11121
/* 11076 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 11079 */   MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 11112
/* 11084 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 11087 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 11103
/* 11092 */   MCD::OPC_CheckField, 13, 1, 1, 37, 38, 0, // Skip to: 20864
/* 11099 */   MCD::OPC_Decode, 152, 7, 126, // Opcode: VBITCLRI_B
/* 11103 */   MCD::OPC_FilterValue, 1, 28, 38, 0, // Skip to: 20864
/* 11108 */   MCD::OPC_Decode, 154, 7, 127, // Opcode: VBITCLRI_H
/* 11112 */   MCD::OPC_FilterValue, 1, 19, 38, 0, // Skip to: 20864
/* 11117 */   MCD::OPC_Decode, 155, 7, 107, // Opcode: VBITCLRI_W
/* 11121 */   MCD::OPC_FilterValue, 1, 10, 38, 0, // Skip to: 20864
/* 11126 */   MCD::OPC_Decode, 153, 7, 128, 1, // Opcode: VBITCLRI_D
/* 11131 */   MCD::OPC_FilterValue, 197, 1, 63, 0, 0, // Skip to: 11200
/* 11137 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 11140 */   MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 11190
/* 11145 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 11148 */   MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 11181
/* 11153 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 11156 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 11172
/* 11161 */   MCD::OPC_CheckField, 13, 1, 1, 224, 37, 0, // Skip to: 20864
/* 11168 */   MCD::OPC_Decode, 171, 7, 126, // Opcode: VBITSETI_B
/* 11172 */   MCD::OPC_FilterValue, 1, 215, 37, 0, // Skip to: 20864
/* 11177 */   MCD::OPC_Decode, 173, 7, 127, // Opcode: VBITSETI_H
/* 11181 */   MCD::OPC_FilterValue, 1, 206, 37, 0, // Skip to: 20864
/* 11186 */   MCD::OPC_Decode, 174, 7, 107, // Opcode: VBITSETI_W
/* 11190 */   MCD::OPC_FilterValue, 1, 197, 37, 0, // Skip to: 20864
/* 11195 */   MCD::OPC_Decode, 172, 7, 128, 1, // Opcode: VBITSETI_D
/* 11200 */   MCD::OPC_FilterValue, 198, 1, 63, 0, 0, // Skip to: 11269
/* 11206 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 11209 */   MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 11259
/* 11214 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 11217 */   MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 11250
/* 11222 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 11225 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 11241
/* 11230 */   MCD::OPC_CheckField, 13, 1, 1, 155, 37, 0, // Skip to: 20864
/* 11237 */   MCD::OPC_Decode, 160, 7, 126, // Opcode: VBITREVI_B
/* 11241 */   MCD::OPC_FilterValue, 1, 146, 37, 0, // Skip to: 20864
/* 11246 */   MCD::OPC_Decode, 162, 7, 127, // Opcode: VBITREVI_H
/* 11250 */   MCD::OPC_FilterValue, 1, 137, 37, 0, // Skip to: 20864
/* 11255 */   MCD::OPC_Decode, 163, 7, 107, // Opcode: VBITREVI_W
/* 11259 */   MCD::OPC_FilterValue, 1, 128, 37, 0, // Skip to: 20864
/* 11264 */   MCD::OPC_Decode, 161, 7, 128, 1, // Opcode: VBITREVI_D
/* 11269 */   MCD::OPC_FilterValue, 201, 1, 63, 0, 0, // Skip to: 11338
/* 11275 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 11278 */   MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 11328
/* 11283 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 11286 */   MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 11319
/* 11291 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 11294 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 11310
/* 11299 */   MCD::OPC_CheckField, 13, 1, 1, 86, 37, 0, // Skip to: 20864
/* 11306 */   MCD::OPC_Decode, 207, 10, 126, // Opcode: VSAT_B
/* 11310 */   MCD::OPC_FilterValue, 1, 77, 37, 0, // Skip to: 20864
/* 11315 */   MCD::OPC_Decode, 211, 10, 127, // Opcode: VSAT_H
/* 11319 */   MCD::OPC_FilterValue, 1, 68, 37, 0, // Skip to: 20864
/* 11324 */   MCD::OPC_Decode, 213, 10, 107, // Opcode: VSAT_W
/* 11328 */   MCD::OPC_FilterValue, 1, 59, 37, 0, // Skip to: 20864
/* 11333 */   MCD::OPC_Decode, 209, 10, 128, 1, // Opcode: VSAT_D
/* 11338 */   MCD::OPC_FilterValue, 202, 1, 63, 0, 0, // Skip to: 11407
/* 11344 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 11347 */   MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 11397
/* 11352 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 11355 */   MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 11388
/* 11360 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 11363 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 11379
/* 11368 */   MCD::OPC_CheckField, 13, 1, 1, 17, 37, 0, // Skip to: 20864
/* 11375 */   MCD::OPC_Decode, 208, 10, 126, // Opcode: VSAT_BU
/* 11379 */   MCD::OPC_FilterValue, 1, 8, 37, 0, // Skip to: 20864
/* 11384 */   MCD::OPC_Decode, 212, 10, 127, // Opcode: VSAT_HU
/* 11388 */   MCD::OPC_FilterValue, 1, 255, 36, 0, // Skip to: 20864
/* 11393 */   MCD::OPC_Decode, 214, 10, 107, // Opcode: VSAT_WU
/* 11397 */   MCD::OPC_FilterValue, 1, 246, 36, 0, // Skip to: 20864
/* 11402 */   MCD::OPC_Decode, 210, 10, 128, 1, // Opcode: VSAT_DU
/* 11407 */   MCD::OPC_FilterValue, 203, 1, 63, 0, 0, // Skip to: 11476
/* 11413 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 11416 */   MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 11466
/* 11421 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 11424 */   MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 11457
/* 11429 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 11432 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 11448
/* 11437 */   MCD::OPC_CheckField, 13, 1, 1, 204, 36, 0, // Skip to: 20864
/* 11444 */   MCD::OPC_Decode, 145, 11, 126, // Opcode: VSLLI_B
/* 11448 */   MCD::OPC_FilterValue, 1, 195, 36, 0, // Skip to: 20864
/* 11453 */   MCD::OPC_Decode, 147, 11, 127, // Opcode: VSLLI_H
/* 11457 */   MCD::OPC_FilterValue, 1, 186, 36, 0, // Skip to: 20864
/* 11462 */   MCD::OPC_Decode, 148, 11, 107, // Opcode: VSLLI_W
/* 11466 */   MCD::OPC_FilterValue, 1, 177, 36, 0, // Skip to: 20864
/* 11471 */   MCD::OPC_Decode, 146, 11, 128, 1, // Opcode: VSLLI_D
/* 11476 */   MCD::OPC_FilterValue, 204, 1, 63, 0, 0, // Skip to: 11545
/* 11482 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 11485 */   MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 11535
/* 11490 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 11493 */   MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 11526
/* 11498 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 11501 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 11517
/* 11506 */   MCD::OPC_CheckField, 13, 1, 1, 135, 36, 0, // Skip to: 20864
/* 11513 */   MCD::OPC_Decode, 217, 11, 126, // Opcode: VSRLI_B
/* 11517 */   MCD::OPC_FilterValue, 1, 126, 36, 0, // Skip to: 20864
/* 11522 */   MCD::OPC_Decode, 219, 11, 127, // Opcode: VSRLI_H
/* 11526 */   MCD::OPC_FilterValue, 1, 117, 36, 0, // Skip to: 20864
/* 11531 */   MCD::OPC_Decode, 220, 11, 107, // Opcode: VSRLI_W
/* 11535 */   MCD::OPC_FilterValue, 1, 108, 36, 0, // Skip to: 20864
/* 11540 */   MCD::OPC_Decode, 218, 11, 128, 1, // Opcode: VSRLI_D
/* 11545 */   MCD::OPC_FilterValue, 205, 1, 63, 0, 0, // Skip to: 11614
/* 11551 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 11554 */   MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 11604
/* 11559 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 11562 */   MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 11595
/* 11567 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 11570 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 11586
/* 11575 */   MCD::OPC_CheckField, 13, 1, 1, 66, 36, 0, // Skip to: 20864
/* 11582 */   MCD::OPC_Decode, 183, 11, 126, // Opcode: VSRAI_B
/* 11586 */   MCD::OPC_FilterValue, 1, 57, 36, 0, // Skip to: 20864
/* 11591 */   MCD::OPC_Decode, 187, 11, 127, // Opcode: VSRAI_H
/* 11595 */   MCD::OPC_FilterValue, 1, 48, 36, 0, // Skip to: 20864
/* 11600 */   MCD::OPC_Decode, 189, 11, 107, // Opcode: VSRAI_W
/* 11604 */   MCD::OPC_FilterValue, 1, 39, 36, 0, // Skip to: 20864
/* 11609 */   MCD::OPC_Decode, 185, 11, 128, 1, // Opcode: VSRAI_D
/* 11614 */   MCD::OPC_FilterValue, 208, 1, 65, 0, 0, // Skip to: 11685
/* 11620 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 11623 */   MCD::OPC_FilterValue, 0, 47, 0, 0, // Skip to: 11675
/* 11628 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 11631 */   MCD::OPC_FilterValue, 0, 29, 0, 0, // Skip to: 11665
/* 11636 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 11639 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11656
/* 11644 */   MCD::OPC_CheckField, 14, 1, 1, 253, 35, 0, // Skip to: 20864
/* 11651 */   MCD::OPC_Decode, 221, 11, 144, 1, // Opcode: VSRLNI_B_H
/* 11656 */   MCD::OPC_FilterValue, 1, 243, 35, 0, // Skip to: 20864
/* 11661 */   MCD::OPC_Decode, 223, 11, 110, // Opcode: VSRLNI_H_W
/* 11665 */   MCD::OPC_FilterValue, 1, 234, 35, 0, // Skip to: 20864
/* 11670 */   MCD::OPC_Decode, 224, 11, 145, 1, // Opcode: VSRLNI_W_D
/* 11675 */   MCD::OPC_FilterValue, 1, 224, 35, 0, // Skip to: 20864
/* 11680 */   MCD::OPC_Decode, 222, 11, 146, 1, // Opcode: VSRLNI_D_Q
/* 11685 */   MCD::OPC_FilterValue, 209, 1, 65, 0, 0, // Skip to: 11756
/* 11691 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 11694 */   MCD::OPC_FilterValue, 0, 47, 0, 0, // Skip to: 11746
/* 11699 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 11702 */   MCD::OPC_FilterValue, 0, 29, 0, 0, // Skip to: 11736
/* 11707 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 11710 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11727
/* 11715 */   MCD::OPC_CheckField, 14, 1, 1, 182, 35, 0, // Skip to: 20864
/* 11722 */   MCD::OPC_Decode, 232, 11, 144, 1, // Opcode: VSRLRNI_B_H
/* 11727 */   MCD::OPC_FilterValue, 1, 172, 35, 0, // Skip to: 20864
/* 11732 */   MCD::OPC_Decode, 234, 11, 110, // Opcode: VSRLRNI_H_W
/* 11736 */   MCD::OPC_FilterValue, 1, 163, 35, 0, // Skip to: 20864
/* 11741 */   MCD::OPC_Decode, 235, 11, 145, 1, // Opcode: VSRLRNI_W_D
/* 11746 */   MCD::OPC_FilterValue, 1, 153, 35, 0, // Skip to: 20864
/* 11751 */   MCD::OPC_Decode, 233, 11, 146, 1, // Opcode: VSRLRNI_D_Q
/* 11756 */   MCD::OPC_FilterValue, 210, 1, 65, 0, 0, // Skip to: 11827
/* 11762 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 11765 */   MCD::OPC_FilterValue, 0, 47, 0, 0, // Skip to: 11817
/* 11770 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 11773 */   MCD::OPC_FilterValue, 0, 29, 0, 0, // Skip to: 11807
/* 11778 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 11781 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11798
/* 11786 */   MCD::OPC_CheckField, 14, 1, 1, 111, 35, 0, // Skip to: 20864
/* 11793 */   MCD::OPC_Decode, 148, 12, 144, 1, // Opcode: VSSRLNI_B_H
/* 11798 */   MCD::OPC_FilterValue, 1, 101, 35, 0, // Skip to: 20864
/* 11803 */   MCD::OPC_Decode, 152, 12, 110, // Opcode: VSSRLNI_H_W
/* 11807 */   MCD::OPC_FilterValue, 1, 92, 35, 0, // Skip to: 20864
/* 11812 */   MCD::OPC_Decode, 154, 12, 145, 1, // Opcode: VSSRLNI_W_D
/* 11817 */   MCD::OPC_FilterValue, 1, 82, 35, 0, // Skip to: 20864
/* 11822 */   MCD::OPC_Decode, 150, 12, 146, 1, // Opcode: VSSRLNI_D_Q
/* 11827 */   MCD::OPC_FilterValue, 211, 1, 65, 0, 0, // Skip to: 11898
/* 11833 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 11836 */   MCD::OPC_FilterValue, 0, 47, 0, 0, // Skip to: 11888
/* 11841 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 11844 */   MCD::OPC_FilterValue, 0, 29, 0, 0, // Skip to: 11878
/* 11849 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 11852 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11869
/* 11857 */   MCD::OPC_CheckField, 14, 1, 1, 40, 35, 0, // Skip to: 20864
/* 11864 */   MCD::OPC_Decode, 147, 12, 144, 1, // Opcode: VSSRLNI_BU_H
/* 11869 */   MCD::OPC_FilterValue, 1, 30, 35, 0, // Skip to: 20864
/* 11874 */   MCD::OPC_Decode, 151, 12, 110, // Opcode: VSSRLNI_HU_W
/* 11878 */   MCD::OPC_FilterValue, 1, 21, 35, 0, // Skip to: 20864
/* 11883 */   MCD::OPC_Decode, 153, 12, 145, 1, // Opcode: VSSRLNI_WU_D
/* 11888 */   MCD::OPC_FilterValue, 1, 11, 35, 0, // Skip to: 20864
/* 11893 */   MCD::OPC_Decode, 149, 12, 146, 1, // Opcode: VSSRLNI_DU_Q
/* 11898 */   MCD::OPC_FilterValue, 212, 1, 65, 0, 0, // Skip to: 11969
/* 11904 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 11907 */   MCD::OPC_FilterValue, 0, 47, 0, 0, // Skip to: 11959
/* 11912 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 11915 */   MCD::OPC_FilterValue, 0, 29, 0, 0, // Skip to: 11949
/* 11920 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 11923 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11940
/* 11928 */   MCD::OPC_CheckField, 14, 1, 1, 225, 34, 0, // Skip to: 20864
/* 11935 */   MCD::OPC_Decode, 162, 12, 144, 1, // Opcode: VSSRLRNI_B_H
/* 11940 */   MCD::OPC_FilterValue, 1, 215, 34, 0, // Skip to: 20864
/* 11945 */   MCD::OPC_Decode, 166, 12, 110, // Opcode: VSSRLRNI_H_W
/* 11949 */   MCD::OPC_FilterValue, 1, 206, 34, 0, // Skip to: 20864
/* 11954 */   MCD::OPC_Decode, 168, 12, 145, 1, // Opcode: VSSRLRNI_W_D
/* 11959 */   MCD::OPC_FilterValue, 1, 196, 34, 0, // Skip to: 20864
/* 11964 */   MCD::OPC_Decode, 164, 12, 146, 1, // Opcode: VSSRLRNI_D_Q
/* 11969 */   MCD::OPC_FilterValue, 213, 1, 65, 0, 0, // Skip to: 12040
/* 11975 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 11978 */   MCD::OPC_FilterValue, 0, 47, 0, 0, // Skip to: 12030
/* 11983 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 11986 */   MCD::OPC_FilterValue, 0, 29, 0, 0, // Skip to: 12020
/* 11991 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 11994 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12011
/* 11999 */   MCD::OPC_CheckField, 14, 1, 1, 154, 34, 0, // Skip to: 20864
/* 12006 */   MCD::OPC_Decode, 161, 12, 144, 1, // Opcode: VSSRLRNI_BU_H
/* 12011 */   MCD::OPC_FilterValue, 1, 144, 34, 0, // Skip to: 20864
/* 12016 */   MCD::OPC_Decode, 165, 12, 110, // Opcode: VSSRLRNI_HU_W
/* 12020 */   MCD::OPC_FilterValue, 1, 135, 34, 0, // Skip to: 20864
/* 12025 */   MCD::OPC_Decode, 167, 12, 145, 1, // Opcode: VSSRLRNI_WU_D
/* 12030 */   MCD::OPC_FilterValue, 1, 125, 34, 0, // Skip to: 20864
/* 12035 */   MCD::OPC_Decode, 163, 12, 146, 1, // Opcode: VSSRLRNI_DU_Q
/* 12040 */   MCD::OPC_FilterValue, 214, 1, 65, 0, 0, // Skip to: 12111
/* 12046 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 12049 */   MCD::OPC_FilterValue, 0, 47, 0, 0, // Skip to: 12101
/* 12054 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 12057 */   MCD::OPC_FilterValue, 0, 29, 0, 0, // Skip to: 12091
/* 12062 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 12065 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12082
/* 12070 */   MCD::OPC_CheckField, 14, 1, 1, 83, 34, 0, // Skip to: 20864
/* 12077 */   MCD::OPC_Decode, 191, 11, 144, 1, // Opcode: VSRANI_B_H
/* 12082 */   MCD::OPC_FilterValue, 1, 73, 34, 0, // Skip to: 20864
/* 12087 */   MCD::OPC_Decode, 193, 11, 110, // Opcode: VSRANI_H_W
/* 12091 */   MCD::OPC_FilterValue, 1, 64, 34, 0, // Skip to: 20864
/* 12096 */   MCD::OPC_Decode, 194, 11, 145, 1, // Opcode: VSRANI_W_D
/* 12101 */   MCD::OPC_FilterValue, 1, 54, 34, 0, // Skip to: 20864
/* 12106 */   MCD::OPC_Decode, 192, 11, 146, 1, // Opcode: VSRANI_D_Q
/* 12111 */   MCD::OPC_FilterValue, 215, 1, 65, 0, 0, // Skip to: 12182
/* 12117 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 12120 */   MCD::OPC_FilterValue, 0, 47, 0, 0, // Skip to: 12172
/* 12125 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 12128 */   MCD::OPC_FilterValue, 0, 29, 0, 0, // Skip to: 12162
/* 12133 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 12136 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12153
/* 12141 */   MCD::OPC_CheckField, 14, 1, 1, 12, 34, 0, // Skip to: 20864
/* 12148 */   MCD::OPC_Decode, 202, 11, 144, 1, // Opcode: VSRARNI_B_H
/* 12153 */   MCD::OPC_FilterValue, 1, 2, 34, 0, // Skip to: 20864
/* 12158 */   MCD::OPC_Decode, 204, 11, 110, // Opcode: VSRARNI_H_W
/* 12162 */   MCD::OPC_FilterValue, 1, 249, 33, 0, // Skip to: 20864
/* 12167 */   MCD::OPC_Decode, 205, 11, 145, 1, // Opcode: VSRARNI_W_D
/* 12172 */   MCD::OPC_FilterValue, 1, 239, 33, 0, // Skip to: 20864
/* 12177 */   MCD::OPC_Decode, 203, 11, 146, 1, // Opcode: VSRARNI_D_Q
/* 12182 */   MCD::OPC_FilterValue, 216, 1, 65, 0, 0, // Skip to: 12253
/* 12188 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 12191 */   MCD::OPC_FilterValue, 0, 47, 0, 0, // Skip to: 12243
/* 12196 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 12199 */   MCD::OPC_FilterValue, 0, 29, 0, 0, // Skip to: 12233
/* 12204 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 12207 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12224
/* 12212 */   MCD::OPC_CheckField, 14, 1, 1, 197, 33, 0, // Skip to: 20864
/* 12219 */   MCD::OPC_Decode, 248, 11, 144, 1, // Opcode: VSSRANI_B_H
/* 12224 */   MCD::OPC_FilterValue, 1, 187, 33, 0, // Skip to: 20864
/* 12229 */   MCD::OPC_Decode, 252, 11, 110, // Opcode: VSSRANI_H_W
/* 12233 */   MCD::OPC_FilterValue, 1, 178, 33, 0, // Skip to: 20864
/* 12238 */   MCD::OPC_Decode, 254, 11, 145, 1, // Opcode: VSSRANI_W_D
/* 12243 */   MCD::OPC_FilterValue, 1, 168, 33, 0, // Skip to: 20864
/* 12248 */   MCD::OPC_Decode, 250, 11, 146, 1, // Opcode: VSSRANI_D_Q
/* 12253 */   MCD::OPC_FilterValue, 217, 1, 65, 0, 0, // Skip to: 12324
/* 12259 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 12262 */   MCD::OPC_FilterValue, 0, 47, 0, 0, // Skip to: 12314
/* 12267 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 12270 */   MCD::OPC_FilterValue, 0, 29, 0, 0, // Skip to: 12304
/* 12275 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 12278 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12295
/* 12283 */   MCD::OPC_CheckField, 14, 1, 1, 126, 33, 0, // Skip to: 20864
/* 12290 */   MCD::OPC_Decode, 247, 11, 144, 1, // Opcode: VSSRANI_BU_H
/* 12295 */   MCD::OPC_FilterValue, 1, 116, 33, 0, // Skip to: 20864
/* 12300 */   MCD::OPC_Decode, 251, 11, 110, // Opcode: VSSRANI_HU_W
/* 12304 */   MCD::OPC_FilterValue, 1, 107, 33, 0, // Skip to: 20864
/* 12309 */   MCD::OPC_Decode, 253, 11, 145, 1, // Opcode: VSSRANI_WU_D
/* 12314 */   MCD::OPC_FilterValue, 1, 97, 33, 0, // Skip to: 20864
/* 12319 */   MCD::OPC_Decode, 249, 11, 146, 1, // Opcode: VSSRANI_DU_Q
/* 12324 */   MCD::OPC_FilterValue, 218, 1, 65, 0, 0, // Skip to: 12395
/* 12330 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 12333 */   MCD::OPC_FilterValue, 0, 47, 0, 0, // Skip to: 12385
/* 12338 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 12341 */   MCD::OPC_FilterValue, 0, 29, 0, 0, // Skip to: 12375
/* 12346 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 12349 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12366
/* 12354 */   MCD::OPC_CheckField, 14, 1, 1, 55, 33, 0, // Skip to: 20864
/* 12361 */   MCD::OPC_Decode, 134, 12, 144, 1, // Opcode: VSSRARNI_B_H
/* 12366 */   MCD::OPC_FilterValue, 1, 45, 33, 0, // Skip to: 20864
/* 12371 */   MCD::OPC_Decode, 138, 12, 110, // Opcode: VSSRARNI_H_W
/* 12375 */   MCD::OPC_FilterValue, 1, 36, 33, 0, // Skip to: 20864
/* 12380 */   MCD::OPC_Decode, 140, 12, 145, 1, // Opcode: VSSRARNI_W_D
/* 12385 */   MCD::OPC_FilterValue, 1, 26, 33, 0, // Skip to: 20864
/* 12390 */   MCD::OPC_Decode, 136, 12, 146, 1, // Opcode: VSSRARNI_D_Q
/* 12395 */   MCD::OPC_FilterValue, 219, 1, 65, 0, 0, // Skip to: 12466
/* 12401 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 12404 */   MCD::OPC_FilterValue, 0, 47, 0, 0, // Skip to: 12456
/* 12409 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 12412 */   MCD::OPC_FilterValue, 0, 29, 0, 0, // Skip to: 12446
/* 12417 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 12420 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12437
/* 12425 */   MCD::OPC_CheckField, 14, 1, 1, 240, 32, 0, // Skip to: 20864
/* 12432 */   MCD::OPC_Decode, 133, 12, 144, 1, // Opcode: VSSRARNI_BU_H
/* 12437 */   MCD::OPC_FilterValue, 1, 230, 32, 0, // Skip to: 20864
/* 12442 */   MCD::OPC_Decode, 137, 12, 110, // Opcode: VSSRARNI_HU_W
/* 12446 */   MCD::OPC_FilterValue, 1, 221, 32, 0, // Skip to: 20864
/* 12451 */   MCD::OPC_Decode, 139, 12, 145, 1, // Opcode: VSSRARNI_WU_D
/* 12456 */   MCD::OPC_FilterValue, 1, 211, 32, 0, // Skip to: 20864
/* 12461 */   MCD::OPC_Decode, 135, 12, 146, 1, // Opcode: VSSRARNI_DU_Q
/* 12466 */   MCD::OPC_FilterValue, 224, 1, 5, 0, 0, // Skip to: 12477
/* 12472 */   MCD::OPC_Decode, 220, 7, 147, 1, // Opcode: VEXTRINS_D
/* 12477 */   MCD::OPC_FilterValue, 225, 1, 5, 0, 0, // Skip to: 12488
/* 12483 */   MCD::OPC_Decode, 222, 7, 148, 1, // Opcode: VEXTRINS_W
/* 12488 */   MCD::OPC_FilterValue, 226, 1, 5, 0, 0, // Skip to: 12499
/* 12494 */   MCD::OPC_Decode, 221, 7, 149, 1, // Opcode: VEXTRINS_H
/* 12499 */   MCD::OPC_FilterValue, 227, 1, 5, 0, 0, // Skip to: 12510
/* 12505 */   MCD::OPC_Decode, 219, 7, 150, 1, // Opcode: VEXTRINS_B
/* 12510 */   MCD::OPC_FilterValue, 228, 1, 5, 0, 0, // Skip to: 12521
/* 12516 */   MCD::OPC_Decode, 237, 10, 151, 1, // Opcode: VSHUF4I_B
/* 12521 */   MCD::OPC_FilterValue, 229, 1, 5, 0, 0, // Skip to: 12532
/* 12527 */   MCD::OPC_Decode, 239, 10, 152, 1, // Opcode: VSHUF4I_H
/* 12532 */   MCD::OPC_FilterValue, 230, 1, 5, 0, 0, // Skip to: 12543
/* 12538 */   MCD::OPC_Decode, 240, 10, 153, 1, // Opcode: VSHUF4I_W
/* 12543 */   MCD::OPC_FilterValue, 231, 1, 5, 0, 0, // Skip to: 12554
/* 12549 */   MCD::OPC_Decode, 238, 10, 147, 1, // Opcode: VSHUF4I_D
/* 12554 */   MCD::OPC_FilterValue, 241, 1, 5, 0, 0, // Skip to: 12565
/* 12560 */   MCD::OPC_Decode, 168, 7, 150, 1, // Opcode: VBITSELI_B
/* 12565 */   MCD::OPC_FilterValue, 244, 1, 5, 0, 0, // Skip to: 12576
/* 12571 */   MCD::OPC_Decode, 132, 7, 151, 1, // Opcode: VANDI_B
/* 12576 */   MCD::OPC_FilterValue, 245, 1, 5, 0, 0, // Skip to: 12587
/* 12582 */   MCD::OPC_Decode, 147, 10, 151, 1, // Opcode: VORI_B
/* 12587 */   MCD::OPC_FilterValue, 246, 1, 5, 0, 0, // Skip to: 12598
/* 12593 */   MCD::OPC_Decode, 217, 12, 151, 1, // Opcode: VXORI_B
/* 12598 */   MCD::OPC_FilterValue, 247, 1, 5, 0, 0, // Skip to: 12609
/* 12604 */   MCD::OPC_Decode, 145, 10, 151, 1, // Opcode: VNORI_B
/* 12609 */   MCD::OPC_FilterValue, 248, 1, 48, 0, 0, // Skip to: 12663
/* 12615 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 12618 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 12628
/* 12623 */   MCD::OPC_Decode, 131, 9, 154, 1, // Opcode: VLDI_B
/* 12628 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 12638
/* 12633 */   MCD::OPC_Decode, 133, 9, 154, 1, // Opcode: VLDI_H
/* 12638 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12648
/* 12643 */   MCD::OPC_Decode, 134, 9, 154, 1, // Opcode: VLDI_W
/* 12648 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 12658
/* 12653 */   MCD::OPC_Decode, 132, 9, 154, 1, // Opcode: VLDI_D
/* 12658 */   MCD::OPC_Decode, 130, 9, 155, 1, // Opcode: VLDI
/* 12663 */   MCD::OPC_FilterValue, 249, 1, 3, 32, 0, // Skip to: 20864
/* 12669 */   MCD::OPC_Decode, 162, 10, 148, 1, // Opcode: VPERMI_W
/* 12674 */   MCD::OPC_FilterValue, 29, 249, 31, 0, // Skip to: 20864
/* 12679 */   MCD::OPC_ExtractField, 18, 8,  // Inst{25-18} ...
/* 12682 */   MCD::OPC_FilterValue, 0, 79, 0, 0, // Skip to: 12766
/* 12687 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 12690 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 12700
/* 12695 */   MCD::OPC_Decode, 239, 16, 156, 1, // Opcode: XVSEQ_B
/* 12700 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 12710
/* 12705 */   MCD::OPC_Decode, 241, 16, 157, 1, // Opcode: XVSEQ_H
/* 12710 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 12719
/* 12715 */   MCD::OPC_Decode, 242, 16, 52, // Opcode: XVSEQ_W
/* 12719 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 12728
/* 12724 */   MCD::OPC_Decode, 240, 16, 53, // Opcode: XVSEQ_D
/* 12728 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 12738
/* 12733 */   MCD::OPC_Decode, 153, 17, 156, 1, // Opcode: XVSLE_B
/* 12738 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 12748
/* 12743 */   MCD::OPC_Decode, 157, 17, 157, 1, // Opcode: XVSLE_H
/* 12748 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 12757
/* 12753 */   MCD::OPC_Decode, 159, 17, 52, // Opcode: XVSLE_W
/* 12757 */   MCD::OPC_FilterValue, 7, 166, 31, 0, // Skip to: 20864
/* 12762 */   MCD::OPC_Decode, 155, 17, 53, // Opcode: XVSLE_D
/* 12766 */   MCD::OPC_FilterValue, 1, 79, 0, 0, // Skip to: 12850
/* 12771 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 12774 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 12784
/* 12779 */   MCD::OPC_Decode, 154, 17, 156, 1, // Opcode: XVSLE_BU
/* 12784 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 12794
/* 12789 */   MCD::OPC_Decode, 158, 17, 157, 1, // Opcode: XVSLE_HU
/* 12794 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 12803
/* 12799 */   MCD::OPC_Decode, 160, 17, 52, // Opcode: XVSLE_WU
/* 12803 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 12812
/* 12808 */   MCD::OPC_Decode, 156, 17, 53, // Opcode: XVSLE_DU
/* 12812 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 12822
/* 12817 */   MCD::OPC_Decode, 195, 17, 156, 1, // Opcode: XVSLT_B
/* 12822 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 12832
/* 12827 */   MCD::OPC_Decode, 199, 17, 157, 1, // Opcode: XVSLT_H
/* 12832 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 12841
/* 12837 */   MCD::OPC_Decode, 201, 17, 52, // Opcode: XVSLT_W
/* 12841 */   MCD::OPC_FilterValue, 7, 82, 31, 0, // Skip to: 20864
/* 12846 */   MCD::OPC_Decode, 197, 17, 53, // Opcode: XVSLT_D
/* 12850 */   MCD::OPC_FilterValue, 2, 79, 0, 0, // Skip to: 12934
/* 12855 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 12858 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 12868
/* 12863 */   MCD::OPC_Decode, 196, 17, 156, 1, // Opcode: XVSLT_BU
/* 12868 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 12878
/* 12873 */   MCD::OPC_Decode, 200, 17, 157, 1, // Opcode: XVSLT_HU
/* 12878 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 12887
/* 12883 */   MCD::OPC_Decode, 202, 17, 52, // Opcode: XVSLT_WU
/* 12887 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 12896
/* 12892 */   MCD::OPC_Decode, 198, 17, 53, // Opcode: XVSLT_DU
/* 12896 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 12906
/* 12901 */   MCD::OPC_Decode, 140, 13, 156, 1, // Opcode: XVADD_B
/* 12906 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 12916
/* 12911 */   MCD::OPC_Decode, 142, 13, 157, 1, // Opcode: XVADD_H
/* 12916 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 12925
/* 12921 */   MCD::OPC_Decode, 144, 13, 52, // Opcode: XVADD_W
/* 12925 */   MCD::OPC_FilterValue, 7, 254, 30, 0, // Skip to: 20864
/* 12930 */   MCD::OPC_Decode, 141, 13, 53, // Opcode: XVADD_D
/* 12934 */   MCD::OPC_FilterValue, 3, 41, 0, 0, // Skip to: 12980
/* 12939 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 12942 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 12952
/* 12947 */   MCD::OPC_Decode, 240, 18, 156, 1, // Opcode: XVSUB_B
/* 12952 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 12962
/* 12957 */   MCD::OPC_Decode, 242, 18, 157, 1, // Opcode: XVSUB_H
/* 12962 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 12971
/* 12967 */   MCD::OPC_Decode, 244, 18, 52, // Opcode: XVSUB_W
/* 12971 */   MCD::OPC_FilterValue, 3, 208, 30, 0, // Skip to: 20864
/* 12976 */   MCD::OPC_Decode, 241, 18, 53, // Opcode: XVSUB_D
/* 12980 */   MCD::OPC_FilterValue, 7, 42, 0, 0, // Skip to: 13027
/* 12985 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 12988 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 12998
/* 12993 */   MCD::OPC_Decode, 247, 12, 158, 1, // Opcode: XVADDWEV_H_B
/* 12998 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 13008
/* 13003 */   MCD::OPC_Decode, 253, 12, 159, 1, // Opcode: XVADDWEV_W_H
/* 13008 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 13018
/* 13013 */   MCD::OPC_Decode, 244, 12, 160, 1, // Opcode: XVADDWEV_D_W
/* 13018 */   MCD::OPC_FilterValue, 7, 161, 30, 0, // Skip to: 20864
/* 13023 */   MCD::OPC_Decode, 250, 12, 53, // Opcode: XVADDWEV_Q_D
/* 13027 */   MCD::OPC_FilterValue, 8, 81, 0, 0, // Skip to: 13113
/* 13032 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 13035 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 13045
/* 13040 */   MCD::OPC_Decode, 226, 18, 158, 1, // Opcode: XVSUBWEV_H_B
/* 13045 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13055
/* 13050 */   MCD::OPC_Decode, 230, 18, 159, 1, // Opcode: XVSUBWEV_W_H
/* 13055 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 13065
/* 13060 */   MCD::OPC_Decode, 224, 18, 160, 1, // Opcode: XVSUBWEV_D_W
/* 13065 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 13074
/* 13070 */   MCD::OPC_Decode, 228, 18, 53, // Opcode: XVSUBWEV_Q_D
/* 13074 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 13084
/* 13079 */   MCD::OPC_Decode, 131, 13, 158, 1, // Opcode: XVADDWOD_H_B
/* 13084 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 13094
/* 13089 */   MCD::OPC_Decode, 137, 13, 159, 1, // Opcode: XVADDWOD_W_H
/* 13094 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 13104
/* 13099 */   MCD::OPC_Decode, 128, 13, 160, 1, // Opcode: XVADDWOD_D_W
/* 13104 */   MCD::OPC_FilterValue, 7, 75, 30, 0, // Skip to: 20864
/* 13109 */   MCD::OPC_Decode, 134, 13, 53, // Opcode: XVADDWOD_Q_D
/* 13113 */   MCD::OPC_FilterValue, 9, 42, 0, 0, // Skip to: 13160
/* 13118 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 13121 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 13131
/* 13126 */   MCD::OPC_Decode, 234, 18, 158, 1, // Opcode: XVSUBWOD_H_B
/* 13131 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13141
/* 13136 */   MCD::OPC_Decode, 238, 18, 159, 1, // Opcode: XVSUBWOD_W_H
/* 13141 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 13151
/* 13146 */   MCD::OPC_Decode, 232, 18, 160, 1, // Opcode: XVSUBWOD_D_W
/* 13151 */   MCD::OPC_FilterValue, 3, 28, 30, 0, // Skip to: 20864
/* 13156 */   MCD::OPC_Decode, 236, 18, 53, // Opcode: XVSUBWOD_Q_D
/* 13160 */   MCD::OPC_FilterValue, 11, 42, 0, 0, // Skip to: 13207
/* 13165 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 13168 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 13178
/* 13173 */   MCD::OPC_Decode, 248, 12, 158, 1, // Opcode: XVADDWEV_H_BU
/* 13178 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 13188
/* 13183 */   MCD::OPC_Decode, 254, 12, 159, 1, // Opcode: XVADDWEV_W_HU
/* 13188 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 13198
/* 13193 */   MCD::OPC_Decode, 245, 12, 160, 1, // Opcode: XVADDWEV_D_WU
/* 13198 */   MCD::OPC_FilterValue, 7, 237, 29, 0, // Skip to: 20864
/* 13203 */   MCD::OPC_Decode, 251, 12, 53, // Opcode: XVADDWEV_Q_DU
/* 13207 */   MCD::OPC_FilterValue, 12, 81, 0, 0, // Skip to: 13293
/* 13212 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 13215 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 13225
/* 13220 */   MCD::OPC_Decode, 227, 18, 158, 1, // Opcode: XVSUBWEV_H_BU
/* 13225 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13235
/* 13230 */   MCD::OPC_Decode, 231, 18, 159, 1, // Opcode: XVSUBWEV_W_HU
/* 13235 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 13245
/* 13240 */   MCD::OPC_Decode, 225, 18, 160, 1, // Opcode: XVSUBWEV_D_WU
/* 13245 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 13254
/* 13250 */   MCD::OPC_Decode, 229, 18, 53, // Opcode: XVSUBWEV_Q_DU
/* 13254 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 13264
/* 13259 */   MCD::OPC_Decode, 132, 13, 158, 1, // Opcode: XVADDWOD_H_BU
/* 13264 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 13274
/* 13269 */   MCD::OPC_Decode, 138, 13, 159, 1, // Opcode: XVADDWOD_W_HU
/* 13274 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 13284
/* 13279 */   MCD::OPC_Decode, 129, 13, 160, 1, // Opcode: XVADDWOD_D_WU
/* 13284 */   MCD::OPC_FilterValue, 7, 151, 29, 0, // Skip to: 20864
/* 13289 */   MCD::OPC_Decode, 135, 13, 53, // Opcode: XVADDWOD_Q_DU
/* 13293 */   MCD::OPC_FilterValue, 13, 42, 0, 0, // Skip to: 13340
/* 13298 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 13301 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 13311
/* 13306 */   MCD::OPC_Decode, 235, 18, 158, 1, // Opcode: XVSUBWOD_H_BU
/* 13311 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13321
/* 13316 */   MCD::OPC_Decode, 239, 18, 159, 1, // Opcode: XVSUBWOD_W_HU
/* 13321 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 13331
/* 13326 */   MCD::OPC_Decode, 233, 18, 160, 1, // Opcode: XVSUBWOD_D_WU
/* 13331 */   MCD::OPC_FilterValue, 3, 104, 29, 0, // Skip to: 20864
/* 13336 */   MCD::OPC_Decode, 237, 18, 53, // Opcode: XVSUBWOD_Q_DU
/* 13340 */   MCD::OPC_FilterValue, 15, 42, 0, 0, // Skip to: 13387
/* 13345 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 13348 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 13358
/* 13353 */   MCD::OPC_Decode, 249, 12, 158, 1, // Opcode: XVADDWEV_H_BU_B
/* 13358 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 13368
/* 13363 */   MCD::OPC_Decode, 255, 12, 159, 1, // Opcode: XVADDWEV_W_HU_H
/* 13368 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 13378
/* 13373 */   MCD::OPC_Decode, 246, 12, 160, 1, // Opcode: XVADDWEV_D_WU_W
/* 13378 */   MCD::OPC_FilterValue, 7, 57, 29, 0, // Skip to: 20864
/* 13383 */   MCD::OPC_Decode, 252, 12, 53, // Opcode: XVADDWEV_Q_DU_D
/* 13387 */   MCD::OPC_FilterValue, 16, 42, 0, 0, // Skip to: 13434
/* 13392 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 13395 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 13405
/* 13400 */   MCD::OPC_Decode, 133, 13, 158, 1, // Opcode: XVADDWOD_H_BU_B
/* 13405 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13415
/* 13410 */   MCD::OPC_Decode, 139, 13, 159, 1, // Opcode: XVADDWOD_W_HU_H
/* 13415 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 13425
/* 13420 */   MCD::OPC_Decode, 130, 13, 160, 1, // Opcode: XVADDWOD_D_WU_W
/* 13425 */   MCD::OPC_FilterValue, 3, 10, 29, 0, // Skip to: 20864
/* 13430 */   MCD::OPC_Decode, 136, 13, 53, // Opcode: XVADDWOD_Q_DU_D
/* 13434 */   MCD::OPC_FilterValue, 17, 41, 0, 0, // Skip to: 13480
/* 13439 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 13442 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 13452
/* 13447 */   MCD::OPC_Decode, 215, 16, 156, 1, // Opcode: XVSADD_B
/* 13452 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 13462
/* 13457 */   MCD::OPC_Decode, 219, 16, 157, 1, // Opcode: XVSADD_H
/* 13462 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 13471
/* 13467 */   MCD::OPC_Decode, 221, 16, 52, // Opcode: XVSADD_W
/* 13471 */   MCD::OPC_FilterValue, 7, 220, 28, 0, // Skip to: 20864
/* 13476 */   MCD::OPC_Decode, 217, 16, 53, // Opcode: XVSADD_D
/* 13480 */   MCD::OPC_FilterValue, 18, 79, 0, 0, // Skip to: 13564
/* 13485 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 13488 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 13498
/* 13493 */   MCD::OPC_Decode, 199, 18, 156, 1, // Opcode: XVSSUB_B
/* 13498 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13508
/* 13503 */   MCD::OPC_Decode, 203, 18, 157, 1, // Opcode: XVSSUB_H
/* 13508 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 13517
/* 13513 */   MCD::OPC_Decode, 205, 18, 52, // Opcode: XVSSUB_W
/* 13517 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 13526
/* 13522 */   MCD::OPC_Decode, 201, 18, 53, // Opcode: XVSSUB_D
/* 13526 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 13536
/* 13531 */   MCD::OPC_Decode, 216, 16, 156, 1, // Opcode: XVSADD_BU
/* 13536 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 13546
/* 13541 */   MCD::OPC_Decode, 220, 16, 157, 1, // Opcode: XVSADD_HU
/* 13546 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 13555
/* 13551 */   MCD::OPC_Decode, 222, 16, 52, // Opcode: XVSADD_WU
/* 13555 */   MCD::OPC_FilterValue, 7, 136, 28, 0, // Skip to: 20864
/* 13560 */   MCD::OPC_Decode, 218, 16, 53, // Opcode: XVSADD_DU
/* 13564 */   MCD::OPC_FilterValue, 19, 41, 0, 0, // Skip to: 13610
/* 13569 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 13572 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 13582
/* 13577 */   MCD::OPC_Decode, 200, 18, 156, 1, // Opcode: XVSSUB_BU
/* 13582 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13592
/* 13587 */   MCD::OPC_Decode, 204, 18, 157, 1, // Opcode: XVSSUB_HU
/* 13592 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 13601
/* 13597 */   MCD::OPC_Decode, 206, 18, 52, // Opcode: XVSSUB_WU
/* 13601 */   MCD::OPC_FilterValue, 3, 90, 28, 0, // Skip to: 20864
/* 13606 */   MCD::OPC_Decode, 202, 18, 53, // Opcode: XVSSUB_DU
/* 13610 */   MCD::OPC_FilterValue, 21, 81, 0, 0, // Skip to: 13696
/* 13615 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 13618 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 13628
/* 13623 */   MCD::OPC_Decode, 233, 14, 158, 1, // Opcode: XVHADDW_H_B
/* 13628 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13638
/* 13633 */   MCD::OPC_Decode, 237, 14, 159, 1, // Opcode: XVHADDW_W_H
/* 13638 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 13648
/* 13643 */   MCD::OPC_Decode, 231, 14, 160, 1, // Opcode: XVHADDW_D_W
/* 13648 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 13657
/* 13653 */   MCD::OPC_Decode, 235, 14, 53, // Opcode: XVHADDW_Q_D
/* 13657 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 13667
/* 13662 */   MCD::OPC_Decode, 242, 14, 158, 1, // Opcode: XVHSUBW_H_B
/* 13667 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 13677
/* 13672 */   MCD::OPC_Decode, 246, 14, 159, 1, // Opcode: XVHSUBW_W_H
/* 13677 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 13687
/* 13682 */   MCD::OPC_Decode, 240, 14, 160, 1, // Opcode: XVHSUBW_D_W
/* 13687 */   MCD::OPC_FilterValue, 7, 4, 28, 0, // Skip to: 20864
/* 13692 */   MCD::OPC_Decode, 244, 14, 53, // Opcode: XVHSUBW_Q_D
/* 13696 */   MCD::OPC_FilterValue, 22, 81, 0, 0, // Skip to: 13782
/* 13701 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 13704 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 13714
/* 13709 */   MCD::OPC_Decode, 232, 14, 158, 1, // Opcode: XVHADDW_HU_BU
/* 13714 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13724
/* 13719 */   MCD::OPC_Decode, 236, 14, 159, 1, // Opcode: XVHADDW_WU_HU
/* 13724 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 13734
/* 13729 */   MCD::OPC_Decode, 230, 14, 160, 1, // Opcode: XVHADDW_DU_WU
/* 13734 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 13743
/* 13739 */   MCD::OPC_Decode, 234, 14, 53, // Opcode: XVHADDW_QU_DU
/* 13743 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 13753
/* 13748 */   MCD::OPC_Decode, 241, 14, 158, 1, // Opcode: XVHSUBW_HU_BU
/* 13753 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 13763
/* 13758 */   MCD::OPC_Decode, 245, 14, 159, 1, // Opcode: XVHSUBW_WU_HU
/* 13763 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 13773
/* 13768 */   MCD::OPC_Decode, 239, 14, 160, 1, // Opcode: XVHSUBW_DU_WU
/* 13773 */   MCD::OPC_FilterValue, 7, 174, 27, 0, // Skip to: 20864
/* 13778 */   MCD::OPC_Decode, 243, 14, 53, // Opcode: XVHSUBW_QU_DU
/* 13782 */   MCD::OPC_FilterValue, 23, 41, 0, 0, // Skip to: 13828
/* 13787 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 13790 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 13800
/* 13795 */   MCD::OPC_Decode, 232, 12, 156, 1, // Opcode: XVADDA_B
/* 13800 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13810
/* 13805 */   MCD::OPC_Decode, 234, 12, 157, 1, // Opcode: XVADDA_H
/* 13810 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 13819
/* 13815 */   MCD::OPC_Decode, 235, 12, 52, // Opcode: XVADDA_W
/* 13819 */   MCD::OPC_FilterValue, 3, 128, 27, 0, // Skip to: 20864
/* 13824 */   MCD::OPC_Decode, 233, 12, 53, // Opcode: XVADDA_D
/* 13828 */   MCD::OPC_FilterValue, 24, 79, 0, 0, // Skip to: 13912
/* 13833 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 13836 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 13846
/* 13841 */   MCD::OPC_Decode, 224, 12, 156, 1, // Opcode: XVABSD_B
/* 13846 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13856
/* 13851 */   MCD::OPC_Decode, 228, 12, 157, 1, // Opcode: XVABSD_H
/* 13856 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 13865
/* 13861 */   MCD::OPC_Decode, 230, 12, 52, // Opcode: XVABSD_W
/* 13865 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 13874
/* 13870 */   MCD::OPC_Decode, 226, 12, 53, // Opcode: XVABSD_D
/* 13874 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 13884
/* 13879 */   MCD::OPC_Decode, 225, 12, 156, 1, // Opcode: XVABSD_BU
/* 13884 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 13894
/* 13889 */   MCD::OPC_Decode, 229, 12, 157, 1, // Opcode: XVABSD_HU
/* 13894 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 13903
/* 13899 */   MCD::OPC_Decode, 231, 12, 52, // Opcode: XVABSD_WU
/* 13903 */   MCD::OPC_FilterValue, 7, 44, 27, 0, // Skip to: 20864
/* 13908 */   MCD::OPC_Decode, 227, 12, 53, // Opcode: XVABSD_DU
/* 13912 */   MCD::OPC_FilterValue, 25, 79, 0, 0, // Skip to: 13996
/* 13917 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 13920 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 13930
/* 13925 */   MCD::OPC_Decode, 157, 13, 156, 1, // Opcode: XVAVG_B
/* 13930 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13940
/* 13935 */   MCD::OPC_Decode, 161, 13, 157, 1, // Opcode: XVAVG_H
/* 13940 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 13949
/* 13945 */   MCD::OPC_Decode, 163, 13, 52, // Opcode: XVAVG_W
/* 13949 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 13958
/* 13954 */   MCD::OPC_Decode, 159, 13, 53, // Opcode: XVAVG_D
/* 13958 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 13968
/* 13963 */   MCD::OPC_Decode, 158, 13, 156, 1, // Opcode: XVAVG_BU
/* 13968 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 13978
/* 13973 */   MCD::OPC_Decode, 162, 13, 157, 1, // Opcode: XVAVG_HU
/* 13978 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 13987
/* 13983 */   MCD::OPC_Decode, 164, 13, 52, // Opcode: XVAVG_WU
/* 13987 */   MCD::OPC_FilterValue, 7, 216, 26, 0, // Skip to: 20864
/* 13992 */   MCD::OPC_Decode, 160, 13, 53, // Opcode: XVAVG_DU
/* 13996 */   MCD::OPC_FilterValue, 26, 79, 0, 0, // Skip to: 14080
/* 14001 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 14004 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 14014
/* 14009 */   MCD::OPC_Decode, 149, 13, 156, 1, // Opcode: XVAVGR_B
/* 14014 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 14024
/* 14019 */   MCD::OPC_Decode, 153, 13, 157, 1, // Opcode: XVAVGR_H
/* 14024 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 14033
/* 14029 */   MCD::OPC_Decode, 155, 13, 52, // Opcode: XVAVGR_W
/* 14033 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 14042
/* 14038 */   MCD::OPC_Decode, 151, 13, 53, // Opcode: XVAVGR_D
/* 14042 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 14052
/* 14047 */   MCD::OPC_Decode, 150, 13, 156, 1, // Opcode: XVAVGR_BU
/* 14052 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 14062
/* 14057 */   MCD::OPC_Decode, 154, 13, 157, 1, // Opcode: XVAVGR_HU
/* 14062 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 14071
/* 14067 */   MCD::OPC_Decode, 156, 13, 52, // Opcode: XVAVGR_WU
/* 14071 */   MCD::OPC_FilterValue, 7, 132, 26, 0, // Skip to: 20864
/* 14076 */   MCD::OPC_Decode, 152, 13, 53, // Opcode: XVAVGR_DU
/* 14080 */   MCD::OPC_FilterValue, 28, 79, 0, 0, // Skip to: 14164
/* 14085 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 14088 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 14098
/* 14093 */   MCD::OPC_Decode, 189, 15, 156, 1, // Opcode: XVMAX_B
/* 14098 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 14108
/* 14103 */   MCD::OPC_Decode, 193, 15, 157, 1, // Opcode: XVMAX_H
/* 14108 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 14117
/* 14113 */   MCD::OPC_Decode, 195, 15, 52, // Opcode: XVMAX_W
/* 14117 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 14126
/* 14122 */   MCD::OPC_Decode, 191, 15, 53, // Opcode: XVMAX_D
/* 14126 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 14136
/* 14131 */   MCD::OPC_Decode, 213, 15, 156, 1, // Opcode: XVMIN_B
/* 14136 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 14146
/* 14141 */   MCD::OPC_Decode, 217, 15, 157, 1, // Opcode: XVMIN_H
/* 14146 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 14155
/* 14151 */   MCD::OPC_Decode, 219, 15, 52, // Opcode: XVMIN_W
/* 14155 */   MCD::OPC_FilterValue, 7, 48, 26, 0, // Skip to: 20864
/* 14160 */   MCD::OPC_Decode, 215, 15, 53, // Opcode: XVMIN_D
/* 14164 */   MCD::OPC_FilterValue, 29, 79, 0, 0, // Skip to: 14248
/* 14169 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 14172 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 14182
/* 14177 */   MCD::OPC_Decode, 190, 15, 156, 1, // Opcode: XVMAX_BU
/* 14182 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 14192
/* 14187 */   MCD::OPC_Decode, 194, 15, 157, 1, // Opcode: XVMAX_HU
/* 14192 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 14201
/* 14197 */   MCD::OPC_Decode, 196, 15, 52, // Opcode: XVMAX_WU
/* 14201 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 14210
/* 14206 */   MCD::OPC_Decode, 192, 15, 53, // Opcode: XVMAX_DU
/* 14210 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 14220
/* 14215 */   MCD::OPC_Decode, 214, 15, 156, 1, // Opcode: XVMIN_BU
/* 14220 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 14230
/* 14225 */   MCD::OPC_Decode, 218, 15, 157, 1, // Opcode: XVMIN_HU
/* 14230 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 14239
/* 14235 */   MCD::OPC_Decode, 220, 15, 52, // Opcode: XVMIN_WU
/* 14239 */   MCD::OPC_FilterValue, 7, 220, 25, 0, // Skip to: 20864
/* 14244 */   MCD::OPC_Decode, 216, 15, 53, // Opcode: XVMIN_DU
/* 14248 */   MCD::OPC_FilterValue, 33, 79, 0, 0, // Skip to: 14332
/* 14253 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 14256 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 14266
/* 14261 */   MCD::OPC_Decode, 143, 16, 156, 1, // Opcode: XVMUL_B
/* 14266 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 14276
/* 14271 */   MCD::OPC_Decode, 145, 16, 157, 1, // Opcode: XVMUL_H
/* 14276 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 14285
/* 14281 */   MCD::OPC_Decode, 146, 16, 52, // Opcode: XVMUL_W
/* 14285 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 14294
/* 14290 */   MCD::OPC_Decode, 144, 16, 53, // Opcode: XVMUL_D
/* 14294 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 14304
/* 14299 */   MCD::OPC_Decode, 239, 15, 156, 1, // Opcode: XVMUH_B
/* 14304 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 14314
/* 14309 */   MCD::OPC_Decode, 243, 15, 157, 1, // Opcode: XVMUH_H
/* 14314 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 14323
/* 14319 */   MCD::OPC_Decode, 245, 15, 52, // Opcode: XVMUH_W
/* 14323 */   MCD::OPC_FilterValue, 7, 136, 25, 0, // Skip to: 20864
/* 14328 */   MCD::OPC_Decode, 241, 15, 53, // Opcode: XVMUH_D
/* 14332 */   MCD::OPC_FilterValue, 34, 41, 0, 0, // Skip to: 14378
/* 14337 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 14340 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 14350
/* 14345 */   MCD::OPC_Decode, 240, 15, 156, 1, // Opcode: XVMUH_BU
/* 14350 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 14360
/* 14355 */   MCD::OPC_Decode, 244, 15, 157, 1, // Opcode: XVMUH_HU
/* 14360 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 14369
/* 14365 */   MCD::OPC_Decode, 246, 15, 52, // Opcode: XVMUH_WU
/* 14369 */   MCD::OPC_FilterValue, 3, 90, 25, 0, // Skip to: 20864
/* 14374 */   MCD::OPC_Decode, 242, 15, 53, // Opcode: XVMUH_DU
/* 14378 */   MCD::OPC_FilterValue, 36, 81, 0, 0, // Skip to: 14464
/* 14383 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 14386 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 14396
/* 14391 */   MCD::OPC_Decode, 250, 15, 158, 1, // Opcode: XVMULWEV_H_B
/* 14396 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 14406
/* 14401 */   MCD::OPC_Decode, 128, 16, 159, 1, // Opcode: XVMULWEV_W_H
/* 14406 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 14416
/* 14411 */   MCD::OPC_Decode, 247, 15, 160, 1, // Opcode: XVMULWEV_D_W
/* 14416 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 14425
/* 14421 */   MCD::OPC_Decode, 253, 15, 53, // Opcode: XVMULWEV_Q_D
/* 14425 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 14435
/* 14430 */   MCD::OPC_Decode, 134, 16, 158, 1, // Opcode: XVMULWOD_H_B
/* 14435 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 14445
/* 14440 */   MCD::OPC_Decode, 140, 16, 159, 1, // Opcode: XVMULWOD_W_H
/* 14445 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 14455
/* 14450 */   MCD::OPC_Decode, 131, 16, 160, 1, // Opcode: XVMULWOD_D_W
/* 14455 */   MCD::OPC_FilterValue, 7, 4, 25, 0, // Skip to: 20864
/* 14460 */   MCD::OPC_Decode, 137, 16, 53, // Opcode: XVMULWOD_Q_D
/* 14464 */   MCD::OPC_FilterValue, 38, 81, 0, 0, // Skip to: 14550
/* 14469 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 14472 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 14482
/* 14477 */   MCD::OPC_Decode, 251, 15, 158, 1, // Opcode: XVMULWEV_H_BU
/* 14482 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 14492
/* 14487 */   MCD::OPC_Decode, 129, 16, 159, 1, // Opcode: XVMULWEV_W_HU
/* 14492 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 14502
/* 14497 */   MCD::OPC_Decode, 248, 15, 160, 1, // Opcode: XVMULWEV_D_WU
/* 14502 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 14511
/* 14507 */   MCD::OPC_Decode, 254, 15, 53, // Opcode: XVMULWEV_Q_DU
/* 14511 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 14521
/* 14516 */   MCD::OPC_Decode, 135, 16, 158, 1, // Opcode: XVMULWOD_H_BU
/* 14521 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 14531
/* 14526 */   MCD::OPC_Decode, 141, 16, 159, 1, // Opcode: XVMULWOD_W_HU
/* 14531 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 14541
/* 14536 */   MCD::OPC_Decode, 132, 16, 160, 1, // Opcode: XVMULWOD_D_WU
/* 14541 */   MCD::OPC_FilterValue, 7, 174, 24, 0, // Skip to: 20864
/* 14546 */   MCD::OPC_Decode, 138, 16, 53, // Opcode: XVMULWOD_Q_DU
/* 14550 */   MCD::OPC_FilterValue, 40, 81, 0, 0, // Skip to: 14636
/* 14555 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 14558 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 14568
/* 14563 */   MCD::OPC_Decode, 252, 15, 158, 1, // Opcode: XVMULWEV_H_BU_B
/* 14568 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 14578
/* 14573 */   MCD::OPC_Decode, 130, 16, 159, 1, // Opcode: XVMULWEV_W_HU_H
/* 14578 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 14588
/* 14583 */   MCD::OPC_Decode, 249, 15, 160, 1, // Opcode: XVMULWEV_D_WU_W
/* 14588 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 14597
/* 14593 */   MCD::OPC_Decode, 255, 15, 53, // Opcode: XVMULWEV_Q_DU_D
/* 14597 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 14607
/* 14602 */   MCD::OPC_Decode, 136, 16, 158, 1, // Opcode: XVMULWOD_H_BU_B
/* 14607 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 14617
/* 14612 */   MCD::OPC_Decode, 142, 16, 159, 1, // Opcode: XVMULWOD_W_HU_H
/* 14617 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 14627
/* 14622 */   MCD::OPC_Decode, 133, 16, 160, 1, // Opcode: XVMULWOD_D_WU_W
/* 14627 */   MCD::OPC_FilterValue, 7, 88, 24, 0, // Skip to: 20864
/* 14632 */   MCD::OPC_Decode, 139, 16, 53, // Opcode: XVMULWOD_Q_DU_D
/* 14636 */   MCD::OPC_FilterValue, 42, 83, 0, 0, // Skip to: 14724
/* 14641 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 14644 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 14654
/* 14649 */   MCD::OPC_Decode, 169, 15, 161, 1, // Opcode: XVMADD_B
/* 14654 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 14664
/* 14659 */   MCD::OPC_Decode, 171, 15, 162, 1, // Opcode: XVMADD_H
/* 14664 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 14674
/* 14669 */   MCD::OPC_Decode, 172, 15, 163, 1, // Opcode: XVMADD_W
/* 14674 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 14684
/* 14679 */   MCD::OPC_Decode, 170, 15, 164, 1, // Opcode: XVMADD_D
/* 14684 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 14694
/* 14689 */   MCD::OPC_Decode, 235, 15, 161, 1, // Opcode: XVMSUB_B
/* 14694 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 14704
/* 14699 */   MCD::OPC_Decode, 237, 15, 162, 1, // Opcode: XVMSUB_H
/* 14704 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 14714
/* 14709 */   MCD::OPC_Decode, 238, 15, 163, 1, // Opcode: XVMSUB_W
/* 14714 */   MCD::OPC_FilterValue, 7, 1, 24, 0, // Skip to: 20864
/* 14719 */   MCD::OPC_Decode, 236, 15, 164, 1, // Opcode: XVMSUB_D
/* 14724 */   MCD::OPC_FilterValue, 43, 83, 0, 0, // Skip to: 14812
/* 14729 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 14732 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 14742
/* 14737 */   MCD::OPC_Decode, 148, 15, 165, 1, // Opcode: XVMADDWEV_H_B
/* 14742 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 14752
/* 14747 */   MCD::OPC_Decode, 154, 15, 166, 1, // Opcode: XVMADDWEV_W_H
/* 14752 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 14762
/* 14757 */   MCD::OPC_Decode, 145, 15, 167, 1, // Opcode: XVMADDWEV_D_W
/* 14762 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 14772
/* 14767 */   MCD::OPC_Decode, 151, 15, 164, 1, // Opcode: XVMADDWEV_Q_D
/* 14772 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 14782
/* 14777 */   MCD::OPC_Decode, 160, 15, 165, 1, // Opcode: XVMADDWOD_H_B
/* 14782 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 14792
/* 14787 */   MCD::OPC_Decode, 166, 15, 166, 1, // Opcode: XVMADDWOD_W_H
/* 14792 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 14802
/* 14797 */   MCD::OPC_Decode, 157, 15, 167, 1, // Opcode: XVMADDWOD_D_W
/* 14802 */   MCD::OPC_FilterValue, 7, 169, 23, 0, // Skip to: 20864
/* 14807 */   MCD::OPC_Decode, 163, 15, 164, 1, // Opcode: XVMADDWOD_Q_D
/* 14812 */   MCD::OPC_FilterValue, 45, 83, 0, 0, // Skip to: 14900
/* 14817 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 14820 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 14830
/* 14825 */   MCD::OPC_Decode, 149, 15, 165, 1, // Opcode: XVMADDWEV_H_BU
/* 14830 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 14840
/* 14835 */   MCD::OPC_Decode, 155, 15, 166, 1, // Opcode: XVMADDWEV_W_HU
/* 14840 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 14850
/* 14845 */   MCD::OPC_Decode, 146, 15, 167, 1, // Opcode: XVMADDWEV_D_WU
/* 14850 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 14860
/* 14855 */   MCD::OPC_Decode, 152, 15, 164, 1, // Opcode: XVMADDWEV_Q_DU
/* 14860 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 14870
/* 14865 */   MCD::OPC_Decode, 161, 15, 165, 1, // Opcode: XVMADDWOD_H_BU
/* 14870 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 14880
/* 14875 */   MCD::OPC_Decode, 167, 15, 166, 1, // Opcode: XVMADDWOD_W_HU
/* 14880 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 14890
/* 14885 */   MCD::OPC_Decode, 158, 15, 167, 1, // Opcode: XVMADDWOD_D_WU
/* 14890 */   MCD::OPC_FilterValue, 7, 81, 23, 0, // Skip to: 20864
/* 14895 */   MCD::OPC_Decode, 164, 15, 164, 1, // Opcode: XVMADDWOD_Q_DU
/* 14900 */   MCD::OPC_FilterValue, 47, 83, 0, 0, // Skip to: 14988
/* 14905 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 14908 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 14918
/* 14913 */   MCD::OPC_Decode, 150, 15, 165, 1, // Opcode: XVMADDWEV_H_BU_B
/* 14918 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 14928
/* 14923 */   MCD::OPC_Decode, 156, 15, 166, 1, // Opcode: XVMADDWEV_W_HU_H
/* 14928 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 14938
/* 14933 */   MCD::OPC_Decode, 147, 15, 167, 1, // Opcode: XVMADDWEV_D_WU_W
/* 14938 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 14948
/* 14943 */   MCD::OPC_Decode, 153, 15, 164, 1, // Opcode: XVMADDWEV_Q_DU_D
/* 14948 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 14958
/* 14953 */   MCD::OPC_Decode, 162, 15, 165, 1, // Opcode: XVMADDWOD_H_BU_B
/* 14958 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 14968
/* 14963 */   MCD::OPC_Decode, 168, 15, 166, 1, // Opcode: XVMADDWOD_W_HU_H
/* 14968 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 14978
/* 14973 */   MCD::OPC_Decode, 159, 15, 167, 1, // Opcode: XVMADDWOD_D_WU_W
/* 14978 */   MCD::OPC_FilterValue, 7, 249, 22, 0, // Skip to: 20864
/* 14983 */   MCD::OPC_Decode, 165, 15, 164, 1, // Opcode: XVMADDWOD_Q_DU_D
/* 14988 */   MCD::OPC_FilterValue, 56, 79, 0, 0, // Skip to: 15072
/* 14993 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 14996 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 15006
/* 15001 */   MCD::OPC_Decode, 202, 13, 156, 1, // Opcode: XVDIV_B
/* 15006 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 15016
/* 15011 */   MCD::OPC_Decode, 206, 13, 157, 1, // Opcode: XVDIV_H
/* 15016 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 15025
/* 15021 */   MCD::OPC_Decode, 208, 13, 52, // Opcode: XVDIV_W
/* 15025 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 15034
/* 15030 */   MCD::OPC_Decode, 204, 13, 53, // Opcode: XVDIV_D
/* 15034 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 15044
/* 15039 */   MCD::OPC_Decode, 221, 15, 156, 1, // Opcode: XVMOD_B
/* 15044 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 15054
/* 15049 */   MCD::OPC_Decode, 225, 15, 157, 1, // Opcode: XVMOD_H
/* 15054 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 15063
/* 15059 */   MCD::OPC_Decode, 227, 15, 52, // Opcode: XVMOD_W
/* 15063 */   MCD::OPC_FilterValue, 7, 164, 22, 0, // Skip to: 20864
/* 15068 */   MCD::OPC_Decode, 223, 15, 53, // Opcode: XVMOD_D
/* 15072 */   MCD::OPC_FilterValue, 57, 79, 0, 0, // Skip to: 15156
/* 15077 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 15080 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 15090
/* 15085 */   MCD::OPC_Decode, 203, 13, 156, 1, // Opcode: XVDIV_BU
/* 15090 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 15100
/* 15095 */   MCD::OPC_Decode, 207, 13, 157, 1, // Opcode: XVDIV_HU
/* 15100 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 15109
/* 15105 */   MCD::OPC_Decode, 209, 13, 52, // Opcode: XVDIV_WU
/* 15109 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 15118
/* 15114 */   MCD::OPC_Decode, 205, 13, 53, // Opcode: XVDIV_DU
/* 15118 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 15128
/* 15123 */   MCD::OPC_Decode, 222, 15, 156, 1, // Opcode: XVMOD_BU
/* 15128 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 15138
/* 15133 */   MCD::OPC_Decode, 226, 15, 157, 1, // Opcode: XVMOD_HU
/* 15138 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 15147
/* 15143 */   MCD::OPC_Decode, 228, 15, 52, // Opcode: XVMOD_WU
/* 15147 */   MCD::OPC_FilterValue, 7, 80, 22, 0, // Skip to: 20864
/* 15152 */   MCD::OPC_Decode, 224, 15, 53, // Opcode: XVMOD_DU
/* 15156 */   MCD::OPC_FilterValue, 58, 79, 0, 0, // Skip to: 15240
/* 15161 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 15164 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 15174
/* 15169 */   MCD::OPC_Decode, 175, 17, 156, 1, // Opcode: XVSLL_B
/* 15174 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 15184
/* 15179 */   MCD::OPC_Decode, 177, 17, 157, 1, // Opcode: XVSLL_H
/* 15184 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 15193
/* 15189 */   MCD::OPC_Decode, 178, 17, 52, // Opcode: XVSLL_W
/* 15193 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 15202
/* 15198 */   MCD::OPC_Decode, 176, 17, 53, // Opcode: XVSLL_D
/* 15202 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 15212
/* 15207 */   MCD::OPC_Decode, 139, 18, 156, 1, // Opcode: XVSRL_B
/* 15212 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 15222
/* 15217 */   MCD::OPC_Decode, 141, 18, 157, 1, // Opcode: XVSRL_H
/* 15222 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 15231
/* 15227 */   MCD::OPC_Decode, 142, 18, 52, // Opcode: XVSRL_W
/* 15231 */   MCD::OPC_FilterValue, 7, 252, 21, 0, // Skip to: 20864
/* 15236 */   MCD::OPC_Decode, 140, 18, 53, // Opcode: XVSRL_D
/* 15240 */   MCD::OPC_FilterValue, 59, 79, 0, 0, // Skip to: 15324
/* 15245 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 15248 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 15258
/* 15253 */   MCD::OPC_Decode, 233, 17, 156, 1, // Opcode: XVSRA_B
/* 15258 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 15268
/* 15263 */   MCD::OPC_Decode, 235, 17, 157, 1, // Opcode: XVSRA_H
/* 15268 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 15277
/* 15273 */   MCD::OPC_Decode, 236, 17, 52, // Opcode: XVSRA_W
/* 15277 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 15286
/* 15282 */   MCD::OPC_Decode, 234, 17, 53, // Opcode: XVSRA_D
/* 15286 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 15296
/* 15291 */   MCD::OPC_Decode, 211, 16, 156, 1, // Opcode: XVROTR_B
/* 15296 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 15306
/* 15301 */   MCD::OPC_Decode, 213, 16, 157, 1, // Opcode: XVROTR_H
/* 15306 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 15315
/* 15311 */   MCD::OPC_Decode, 214, 16, 52, // Opcode: XVROTR_W
/* 15315 */   MCD::OPC_FilterValue, 7, 168, 21, 0, // Skip to: 20864
/* 15320 */   MCD::OPC_Decode, 212, 16, 53, // Opcode: XVROTR_D
/* 15324 */   MCD::OPC_FilterValue, 60, 79, 0, 0, // Skip to: 15408
/* 15329 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 15332 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 15342
/* 15337 */   MCD::OPC_Decode, 135, 18, 156, 1, // Opcode: XVSRLR_B
/* 15342 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 15352
/* 15347 */   MCD::OPC_Decode, 137, 18, 157, 1, // Opcode: XVSRLR_H
/* 15352 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 15361
/* 15357 */   MCD::OPC_Decode, 138, 18, 52, // Opcode: XVSRLR_W
/* 15361 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 15370
/* 15366 */   MCD::OPC_Decode, 136, 18, 53, // Opcode: XVSRLR_D
/* 15370 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 15380
/* 15375 */   MCD::OPC_Decode, 229, 17, 156, 1, // Opcode: XVSRAR_B
/* 15380 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 15390
/* 15385 */   MCD::OPC_Decode, 231, 17, 157, 1, // Opcode: XVSRAR_H
/* 15390 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 15399
/* 15395 */   MCD::OPC_Decode, 232, 17, 52, // Opcode: XVSRAR_W
/* 15399 */   MCD::OPC_FilterValue, 7, 84, 21, 0, // Skip to: 20864
/* 15404 */   MCD::OPC_Decode, 230, 17, 53, // Opcode: XVSRAR_D
/* 15408 */   MCD::OPC_FilterValue, 61, 63, 0, 0, // Skip to: 15476
/* 15413 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 15416 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 15426
/* 15421 */   MCD::OPC_Decode, 249, 17, 168, 1, // Opcode: XVSRLN_B_H
/* 15426 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 15436
/* 15431 */   MCD::OPC_Decode, 250, 17, 169, 1, // Opcode: XVSRLN_H_W
/* 15436 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 15446
/* 15441 */   MCD::OPC_Decode, 251, 17, 170, 1, // Opcode: XVSRLN_W_D
/* 15446 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 15456
/* 15451 */   MCD::OPC_Decode, 215, 17, 168, 1, // Opcode: XVSRAN_B_H
/* 15456 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 15466
/* 15461 */   MCD::OPC_Decode, 216, 17, 169, 1, // Opcode: XVSRAN_H_W
/* 15466 */   MCD::OPC_FilterValue, 7, 17, 21, 0, // Skip to: 20864
/* 15471 */   MCD::OPC_Decode, 217, 17, 170, 1, // Opcode: XVSRAN_W_D
/* 15476 */   MCD::OPC_FilterValue, 62, 63, 0, 0, // Skip to: 15544
/* 15481 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 15484 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 15494
/* 15489 */   MCD::OPC_Decode, 132, 18, 168, 1, // Opcode: XVSRLRN_B_H
/* 15494 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 15504
/* 15499 */   MCD::OPC_Decode, 133, 18, 169, 1, // Opcode: XVSRLRN_H_W
/* 15504 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 15514
/* 15509 */   MCD::OPC_Decode, 134, 18, 170, 1, // Opcode: XVSRLRN_W_D
/* 15514 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 15524
/* 15519 */   MCD::OPC_Decode, 226, 17, 168, 1, // Opcode: XVSRARN_B_H
/* 15524 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 15534
/* 15529 */   MCD::OPC_Decode, 227, 17, 169, 1, // Opcode: XVSRARN_H_W
/* 15534 */   MCD::OPC_FilterValue, 7, 205, 20, 0, // Skip to: 20864
/* 15539 */   MCD::OPC_Decode, 228, 17, 170, 1, // Opcode: XVSRARN_W_D
/* 15544 */   MCD::OPC_FilterValue, 63, 63, 0, 0, // Skip to: 15612
/* 15549 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 15552 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 15562
/* 15557 */   MCD::OPC_Decode, 180, 18, 168, 1, // Opcode: XVSSRLN_B_H
/* 15562 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 15572
/* 15567 */   MCD::OPC_Decode, 182, 18, 169, 1, // Opcode: XVSSRLN_H_W
/* 15572 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 15582
/* 15577 */   MCD::OPC_Decode, 184, 18, 170, 1, // Opcode: XVSSRLN_W_D
/* 15582 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 15592
/* 15587 */   MCD::OPC_Decode, 152, 18, 168, 1, // Opcode: XVSSRAN_B_H
/* 15592 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 15602
/* 15597 */   MCD::OPC_Decode, 154, 18, 169, 1, // Opcode: XVSSRAN_H_W
/* 15602 */   MCD::OPC_FilterValue, 7, 137, 20, 0, // Skip to: 20864
/* 15607 */   MCD::OPC_Decode, 156, 18, 170, 1, // Opcode: XVSSRAN_W_D
/* 15612 */   MCD::OPC_FilterValue, 64, 63, 0, 0, // Skip to: 15680
/* 15617 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 15620 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 15630
/* 15625 */   MCD::OPC_Decode, 194, 18, 168, 1, // Opcode: XVSSRLRN_B_H
/* 15630 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 15640
/* 15635 */   MCD::OPC_Decode, 196, 18, 169, 1, // Opcode: XVSSRLRN_H_W
/* 15640 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 15650
/* 15645 */   MCD::OPC_Decode, 198, 18, 170, 1, // Opcode: XVSSRLRN_W_D
/* 15650 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 15660
/* 15655 */   MCD::OPC_Decode, 166, 18, 168, 1, // Opcode: XVSSRARN_B_H
/* 15660 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 15670
/* 15665 */   MCD::OPC_Decode, 168, 18, 169, 1, // Opcode: XVSSRARN_H_W
/* 15670 */   MCD::OPC_FilterValue, 7, 69, 20, 0, // Skip to: 20864
/* 15675 */   MCD::OPC_Decode, 170, 18, 170, 1, // Opcode: XVSSRARN_W_D
/* 15680 */   MCD::OPC_FilterValue, 65, 63, 0, 0, // Skip to: 15748
/* 15685 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 15688 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 15698
/* 15693 */   MCD::OPC_Decode, 179, 18, 168, 1, // Opcode: XVSSRLN_BU_H
/* 15698 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 15708
/* 15703 */   MCD::OPC_Decode, 181, 18, 169, 1, // Opcode: XVSSRLN_HU_W
/* 15708 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 15718
/* 15713 */   MCD::OPC_Decode, 183, 18, 170, 1, // Opcode: XVSSRLN_WU_D
/* 15718 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 15728
/* 15723 */   MCD::OPC_Decode, 151, 18, 168, 1, // Opcode: XVSSRAN_BU_H
/* 15728 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 15738
/* 15733 */   MCD::OPC_Decode, 153, 18, 169, 1, // Opcode: XVSSRAN_HU_W
/* 15738 */   MCD::OPC_FilterValue, 7, 1, 20, 0, // Skip to: 20864
/* 15743 */   MCD::OPC_Decode, 155, 18, 170, 1, // Opcode: XVSSRAN_WU_D
/* 15748 */   MCD::OPC_FilterValue, 66, 63, 0, 0, // Skip to: 15816
/* 15753 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 15756 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 15766
/* 15761 */   MCD::OPC_Decode, 193, 18, 168, 1, // Opcode: XVSSRLRN_BU_H
/* 15766 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 15776
/* 15771 */   MCD::OPC_Decode, 195, 18, 169, 1, // Opcode: XVSSRLRN_HU_W
/* 15776 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 15786
/* 15781 */   MCD::OPC_Decode, 197, 18, 170, 1, // Opcode: XVSSRLRN_WU_D
/* 15786 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 15796
/* 15791 */   MCD::OPC_Decode, 165, 18, 168, 1, // Opcode: XVSSRARN_BU_H
/* 15796 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 15806
/* 15801 */   MCD::OPC_Decode, 167, 18, 169, 1, // Opcode: XVSSRARN_HU_W
/* 15806 */   MCD::OPC_FilterValue, 7, 189, 19, 0, // Skip to: 20864
/* 15811 */   MCD::OPC_Decode, 169, 18, 170, 1, // Opcode: XVSSRARN_WU_D
/* 15816 */   MCD::OPC_FilterValue, 67, 79, 0, 0, // Skip to: 15900
/* 15821 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 15824 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 15834
/* 15829 */   MCD::OPC_Decode, 169, 13, 156, 1, // Opcode: XVBITCLR_B
/* 15834 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 15844
/* 15839 */   MCD::OPC_Decode, 171, 13, 157, 1, // Opcode: XVBITCLR_H
/* 15844 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 15853
/* 15849 */   MCD::OPC_Decode, 172, 13, 52, // Opcode: XVBITCLR_W
/* 15853 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 15862
/* 15858 */   MCD::OPC_Decode, 170, 13, 53, // Opcode: XVBITCLR_D
/* 15862 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 15872
/* 15867 */   MCD::OPC_Decode, 188, 13, 156, 1, // Opcode: XVBITSET_B
/* 15872 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 15882
/* 15877 */   MCD::OPC_Decode, 190, 13, 157, 1, // Opcode: XVBITSET_H
/* 15882 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 15891
/* 15887 */   MCD::OPC_Decode, 191, 13, 52, // Opcode: XVBITSET_W
/* 15891 */   MCD::OPC_FilterValue, 7, 104, 19, 0, // Skip to: 20864
/* 15896 */   MCD::OPC_Decode, 189, 13, 53, // Opcode: XVBITSET_D
/* 15900 */   MCD::OPC_FilterValue, 68, 41, 0, 0, // Skip to: 15946
/* 15905 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 15908 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 15918
/* 15913 */   MCD::OPC_Decode, 177, 13, 156, 1, // Opcode: XVBITREV_B
/* 15918 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 15928
/* 15923 */   MCD::OPC_Decode, 179, 13, 157, 1, // Opcode: XVBITREV_H
/* 15928 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 15937
/* 15933 */   MCD::OPC_Decode, 180, 13, 52, // Opcode: XVBITREV_W
/* 15937 */   MCD::OPC_FilterValue, 3, 58, 19, 0, // Skip to: 20864
/* 15942 */   MCD::OPC_Decode, 178, 13, 53, // Opcode: XVBITREV_D
/* 15946 */   MCD::OPC_FilterValue, 69, 41, 0, 0, // Skip to: 15992
/* 15951 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 15954 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 15964
/* 15959 */   MCD::OPC_Decode, 156, 16, 156, 1, // Opcode: XVPACKEV_B
/* 15964 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 15974
/* 15969 */   MCD::OPC_Decode, 158, 16, 157, 1, // Opcode: XVPACKEV_H
/* 15974 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 15983
/* 15979 */   MCD::OPC_Decode, 159, 16, 52, // Opcode: XVPACKEV_W
/* 15983 */   MCD::OPC_FilterValue, 7, 12, 19, 0, // Skip to: 20864
/* 15988 */   MCD::OPC_Decode, 157, 16, 53, // Opcode: XVPACKEV_D
/* 15992 */   MCD::OPC_FilterValue, 70, 79, 0, 0, // Skip to: 16076
/* 15997 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16000 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 16010
/* 16005 */   MCD::OPC_Decode, 160, 16, 156, 1, // Opcode: XVPACKOD_B
/* 16010 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 16020
/* 16015 */   MCD::OPC_Decode, 162, 16, 157, 1, // Opcode: XVPACKOD_H
/* 16020 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 16029
/* 16025 */   MCD::OPC_Decode, 163, 16, 52, // Opcode: XVPACKOD_W
/* 16029 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 16038
/* 16034 */   MCD::OPC_Decode, 161, 16, 53, // Opcode: XVPACKOD_D
/* 16038 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 16048
/* 16043 */   MCD::OPC_Decode, 251, 14, 156, 1, // Opcode: XVILVL_B
/* 16048 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 16058
/* 16053 */   MCD::OPC_Decode, 253, 14, 157, 1, // Opcode: XVILVL_H
/* 16058 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 16067
/* 16063 */   MCD::OPC_Decode, 254, 14, 52, // Opcode: XVILVL_W
/* 16067 */   MCD::OPC_FilterValue, 7, 184, 18, 0, // Skip to: 20864
/* 16072 */   MCD::OPC_Decode, 252, 14, 53, // Opcode: XVILVL_D
/* 16076 */   MCD::OPC_FilterValue, 71, 79, 0, 0, // Skip to: 16160
/* 16081 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16084 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 16094
/* 16089 */   MCD::OPC_Decode, 247, 14, 156, 1, // Opcode: XVILVH_B
/* 16094 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 16104
/* 16099 */   MCD::OPC_Decode, 249, 14, 157, 1, // Opcode: XVILVH_H
/* 16104 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 16113
/* 16109 */   MCD::OPC_Decode, 250, 14, 52, // Opcode: XVILVH_W
/* 16113 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 16122
/* 16118 */   MCD::OPC_Decode, 248, 14, 53, // Opcode: XVILVH_D
/* 16122 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 16132
/* 16127 */   MCD::OPC_Decode, 175, 16, 156, 1, // Opcode: XVPICKEV_B
/* 16132 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 16142
/* 16137 */   MCD::OPC_Decode, 177, 16, 157, 1, // Opcode: XVPICKEV_H
/* 16142 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 16151
/* 16147 */   MCD::OPC_Decode, 178, 16, 52, // Opcode: XVPICKEV_W
/* 16151 */   MCD::OPC_FilterValue, 7, 100, 18, 0, // Skip to: 20864
/* 16156 */   MCD::OPC_Decode, 176, 16, 53, // Opcode: XVPICKEV_D
/* 16160 */   MCD::OPC_FilterValue, 72, 81, 0, 0, // Skip to: 16246
/* 16165 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16168 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 16178
/* 16173 */   MCD::OPC_Decode, 179, 16, 156, 1, // Opcode: XVPICKOD_B
/* 16178 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 16188
/* 16183 */   MCD::OPC_Decode, 181, 16, 157, 1, // Opcode: XVPICKOD_H
/* 16188 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 16197
/* 16193 */   MCD::OPC_Decode, 182, 16, 52, // Opcode: XVPICKOD_W
/* 16197 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 16206
/* 16202 */   MCD::OPC_Decode, 180, 16, 53, // Opcode: XVPICKOD_D
/* 16206 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 16216
/* 16211 */   MCD::OPC_Decode, 202, 16, 171, 1, // Opcode: XVREPLVE_B
/* 16216 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 16226
/* 16221 */   MCD::OPC_Decode, 204, 16, 172, 1, // Opcode: XVREPLVE_H
/* 16226 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 16236
/* 16231 */   MCD::OPC_Decode, 205, 16, 173, 1, // Opcode: XVREPLVE_W
/* 16236 */   MCD::OPC_FilterValue, 7, 15, 18, 0, // Skip to: 20864
/* 16241 */   MCD::OPC_Decode, 203, 16, 174, 1, // Opcode: XVREPLVE_D
/* 16246 */   MCD::OPC_FilterValue, 73, 43, 0, 0, // Skip to: 16294
/* 16251 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16254 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 16264
/* 16259 */   MCD::OPC_Decode, 148, 13, 156, 1, // Opcode: XVAND_V
/* 16264 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 16274
/* 16269 */   MCD::OPC_Decode, 155, 16, 156, 1, // Opcode: XVOR_V
/* 16274 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 16284
/* 16279 */   MCD::OPC_Decode, 247, 18, 156, 1, // Opcode: XVXOR_V
/* 16284 */   MCD::OPC_FilterValue, 7, 223, 17, 0, // Skip to: 20864
/* 16289 */   MCD::OPC_Decode, 152, 16, 156, 1, // Opcode: XVNOR_V
/* 16294 */   MCD::OPC_FilterValue, 74, 43, 0, 0, // Skip to: 16342
/* 16299 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16302 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 16312
/* 16307 */   MCD::OPC_Decode, 147, 13, 156, 1, // Opcode: XVANDN_V
/* 16312 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 16322
/* 16317 */   MCD::OPC_Decode, 154, 16, 156, 1, // Opcode: XVORN_V
/* 16322 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 16332
/* 16327 */   MCD::OPC_Decode, 195, 14, 161, 1, // Opcode: XVFRSTP_B
/* 16332 */   MCD::OPC_FilterValue, 7, 175, 17, 0, // Skip to: 20864
/* 16337 */   MCD::OPC_Decode, 196, 14, 162, 1, // Opcode: XVFRSTP_H
/* 16342 */   MCD::OPC_FilterValue, 75, 59, 0, 0, // Skip to: 16406
/* 16347 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16350 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 16359
/* 16355 */   MCD::OPC_Decode, 143, 13, 53, // Opcode: XVADD_Q
/* 16359 */   MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 16368
/* 16364 */   MCD::OPC_Decode, 243, 18, 53, // Opcode: XVSUB_Q
/* 16368 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 16378
/* 16373 */   MCD::OPC_Decode, 133, 17, 156, 1, // Opcode: XVSIGNCOV_B
/* 16378 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 16388
/* 16383 */   MCD::OPC_Decode, 135, 17, 157, 1, // Opcode: XVSIGNCOV_H
/* 16388 */   MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 16397
/* 16393 */   MCD::OPC_Decode, 136, 17, 52, // Opcode: XVSIGNCOV_W
/* 16397 */   MCD::OPC_FilterValue, 7, 110, 17, 0, // Skip to: 20864
/* 16402 */   MCD::OPC_Decode, 134, 17, 53, // Opcode: XVSIGNCOV_D
/* 16406 */   MCD::OPC_FilterValue, 76, 39, 0, 0, // Skip to: 16450
/* 16411 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16414 */   MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 16423
/* 16419 */   MCD::OPC_Decode, 225, 13, 52, // Opcode: XVFADD_S
/* 16423 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 16432
/* 16428 */   MCD::OPC_Decode, 224, 13, 53, // Opcode: XVFADD_D
/* 16432 */   MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 16441
/* 16437 */   MCD::OPC_Decode, 200, 14, 52, // Opcode: XVFSUB_S
/* 16441 */   MCD::OPC_FilterValue, 6, 66, 17, 0, // Skip to: 20864
/* 16446 */   MCD::OPC_Decode, 199, 14, 53, // Opcode: XVFSUB_D
/* 16450 */   MCD::OPC_FilterValue, 78, 39, 0, 0, // Skip to: 16494
/* 16455 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16458 */   MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 16467
/* 16463 */   MCD::OPC_Decode, 174, 14, 52, // Opcode: XVFMUL_S
/* 16467 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 16476
/* 16472 */   MCD::OPC_Decode, 173, 14, 53, // Opcode: XVFMUL_D
/* 16476 */   MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 16485
/* 16481 */   MCD::OPC_Decode, 151, 14, 52, // Opcode: XVFDIV_S
/* 16485 */   MCD::OPC_FilterValue, 6, 22, 17, 0, // Skip to: 20864
/* 16490 */   MCD::OPC_Decode, 150, 14, 53, // Opcode: XVFDIV_D
/* 16494 */   MCD::OPC_FilterValue, 79, 39, 0, 0, // Skip to: 16538
/* 16499 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16502 */   MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 16511
/* 16507 */   MCD::OPC_Decode, 166, 14, 52, // Opcode: XVFMAX_S
/* 16511 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 16520
/* 16516 */   MCD::OPC_Decode, 165, 14, 53, // Opcode: XVFMAX_D
/* 16520 */   MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 16529
/* 16525 */   MCD::OPC_Decode, 170, 14, 52, // Opcode: XVFMIN_S
/* 16529 */   MCD::OPC_FilterValue, 6, 234, 16, 0, // Skip to: 20864
/* 16534 */   MCD::OPC_Decode, 169, 14, 53, // Opcode: XVFMIN_D
/* 16538 */   MCD::OPC_FilterValue, 80, 39, 0, 0, // Skip to: 16582
/* 16543 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16546 */   MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 16555
/* 16551 */   MCD::OPC_Decode, 164, 14, 52, // Opcode: XVFMAXA_S
/* 16555 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 16564
/* 16560 */   MCD::OPC_Decode, 163, 14, 53, // Opcode: XVFMAXA_D
/* 16564 */   MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 16573
/* 16569 */   MCD::OPC_Decode, 168, 14, 52, // Opcode: XVFMINA_S
/* 16573 */   MCD::OPC_FilterValue, 6, 190, 16, 0, // Skip to: 20864
/* 16578 */   MCD::OPC_Decode, 167, 14, 53, // Opcode: XVFMINA_D
/* 16582 */   MCD::OPC_FilterValue, 81, 23, 0, 0, // Skip to: 16610
/* 16587 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16590 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 16600
/* 16595 */   MCD::OPC_Decode, 148, 14, 169, 1, // Opcode: XVFCVT_H_S
/* 16600 */   MCD::OPC_FilterValue, 5, 163, 16, 0, // Skip to: 20864
/* 16605 */   MCD::OPC_Decode, 149, 14, 170, 1, // Opcode: XVFCVT_S_D
/* 16610 */   MCD::OPC_FilterValue, 82, 63, 0, 0, // Skip to: 16678
/* 16615 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16618 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 16628
/* 16623 */   MCD::OPC_Decode, 156, 14, 170, 1, // Opcode: XVFFINT_S_L
/* 16628 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 16638
/* 16633 */   MCD::OPC_Decode, 228, 14, 170, 1, // Opcode: XVFTINT_W_D
/* 16638 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 16648
/* 16643 */   MCD::OPC_Decode, 206, 14, 170, 1, // Opcode: XVFTINTRM_W_D
/* 16648 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 16658
/* 16653 */   MCD::OPC_Decode, 216, 14, 170, 1, // Opcode: XVFTINTRP_W_D
/* 16658 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 16668
/* 16663 */   MCD::OPC_Decode, 223, 14, 170, 1, // Opcode: XVFTINTRZ_W_D
/* 16668 */   MCD::OPC_FilterValue, 7, 95, 16, 0, // Skip to: 20864
/* 16673 */   MCD::OPC_Decode, 211, 14, 170, 1, // Opcode: XVFTINTRNE_W_D
/* 16678 */   MCD::OPC_FilterValue, 94, 33, 0, 0, // Skip to: 16716
/* 16683 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16686 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 16696
/* 16691 */   MCD::OPC_Decode, 131, 17, 162, 1, // Opcode: XVSHUF_H
/* 16696 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 16706
/* 16701 */   MCD::OPC_Decode, 132, 17, 163, 1, // Opcode: XVSHUF_W
/* 16706 */   MCD::OPC_FilterValue, 7, 57, 16, 0, // Skip to: 20864
/* 16711 */   MCD::OPC_Decode, 130, 17, 164, 1, // Opcode: XVSHUF_D
/* 16716 */   MCD::OPC_FilterValue, 95, 11, 0, 0, // Skip to: 16732
/* 16721 */   MCD::OPC_CheckField, 15, 3, 2, 40, 16, 0, // Skip to: 20864
/* 16728 */   MCD::OPC_Decode, 174, 16, 52, // Opcode: XVPERM_W
/* 16732 */   MCD::OPC_FilterValue, 160, 1, 83, 0, 0, // Skip to: 16821
/* 16738 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16741 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 16751
/* 16746 */   MCD::OPC_Decode, 231, 16, 175, 1, // Opcode: XVSEQI_B
/* 16751 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 16761
/* 16756 */   MCD::OPC_Decode, 235, 16, 176, 1, // Opcode: XVSEQI_H
/* 16761 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 16771
/* 16766 */   MCD::OPC_Decode, 237, 16, 177, 1, // Opcode: XVSEQI_W
/* 16771 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 16781
/* 16776 */   MCD::OPC_Decode, 233, 16, 178, 1, // Opcode: XVSEQI_D
/* 16781 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 16791
/* 16786 */   MCD::OPC_Decode, 137, 17, 175, 1, // Opcode: XVSLEI_B
/* 16791 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 16801
/* 16796 */   MCD::OPC_Decode, 145, 17, 176, 1, // Opcode: XVSLEI_H
/* 16801 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 16811
/* 16806 */   MCD::OPC_Decode, 149, 17, 177, 1, // Opcode: XVSLEI_W
/* 16811 */   MCD::OPC_FilterValue, 7, 208, 15, 0, // Skip to: 20864
/* 16816 */   MCD::OPC_Decode, 141, 17, 178, 1, // Opcode: XVSLEI_D
/* 16821 */   MCD::OPC_FilterValue, 161, 1, 83, 0, 0, // Skip to: 16910
/* 16827 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16830 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 16840
/* 16835 */   MCD::OPC_Decode, 138, 17, 179, 1, // Opcode: XVSLEI_BU
/* 16840 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 16850
/* 16845 */   MCD::OPC_Decode, 146, 17, 180, 1, // Opcode: XVSLEI_HU
/* 16850 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 16860
/* 16855 */   MCD::OPC_Decode, 150, 17, 181, 1, // Opcode: XVSLEI_WU
/* 16860 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 16870
/* 16865 */   MCD::OPC_Decode, 142, 17, 182, 1, // Opcode: XVSLEI_DU
/* 16870 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 16880
/* 16875 */   MCD::OPC_Decode, 179, 17, 175, 1, // Opcode: XVSLTI_B
/* 16880 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 16890
/* 16885 */   MCD::OPC_Decode, 187, 17, 176, 1, // Opcode: XVSLTI_H
/* 16890 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 16900
/* 16895 */   MCD::OPC_Decode, 191, 17, 177, 1, // Opcode: XVSLTI_W
/* 16900 */   MCD::OPC_FilterValue, 7, 119, 15, 0, // Skip to: 20864
/* 16905 */   MCD::OPC_Decode, 183, 17, 178, 1, // Opcode: XVSLTI_D
/* 16910 */   MCD::OPC_FilterValue, 162, 1, 83, 0, 0, // Skip to: 16999
/* 16916 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 16919 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 16929
/* 16924 */   MCD::OPC_Decode, 180, 17, 179, 1, // Opcode: XVSLTI_BU
/* 16929 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 16939
/* 16934 */   MCD::OPC_Decode, 188, 17, 180, 1, // Opcode: XVSLTI_HU
/* 16939 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 16949
/* 16944 */   MCD::OPC_Decode, 192, 17, 181, 1, // Opcode: XVSLTI_WU
/* 16949 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 16959
/* 16954 */   MCD::OPC_Decode, 184, 17, 182, 1, // Opcode: XVSLTI_DU
/* 16959 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 16969
/* 16964 */   MCD::OPC_Decode, 236, 12, 179, 1, // Opcode: XVADDI_BU
/* 16969 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 16979
/* 16974 */   MCD::OPC_Decode, 240, 12, 180, 1, // Opcode: XVADDI_HU
/* 16979 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 16989
/* 16984 */   MCD::OPC_Decode, 242, 12, 181, 1, // Opcode: XVADDI_WU
/* 16989 */   MCD::OPC_FilterValue, 7, 30, 15, 0, // Skip to: 20864
/* 16994 */   MCD::OPC_Decode, 238, 12, 182, 1, // Opcode: XVADDI_DU
/* 16999 */   MCD::OPC_FilterValue, 163, 1, 63, 0, 0, // Skip to: 17068
/* 17005 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 17008 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 17018
/* 17013 */   MCD::OPC_Decode, 216, 18, 179, 1, // Opcode: XVSUBI_BU
/* 17018 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 17028
/* 17023 */   MCD::OPC_Decode, 220, 18, 180, 1, // Opcode: XVSUBI_HU
/* 17028 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 17038
/* 17033 */   MCD::OPC_Decode, 222, 18, 181, 1, // Opcode: XVSUBI_WU
/* 17038 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 17048
/* 17043 */   MCD::OPC_Decode, 218, 18, 182, 1, // Opcode: XVSUBI_DU
/* 17048 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 17058
/* 17053 */   MCD::OPC_Decode, 192, 13, 179, 1, // Opcode: XVBSLL_V
/* 17058 */   MCD::OPC_FilterValue, 5, 217, 14, 0, // Skip to: 20864
/* 17063 */   MCD::OPC_Decode, 193, 13, 179, 1, // Opcode: XVBSRL_V
/* 17068 */   MCD::OPC_FilterValue, 164, 1, 83, 0, 0, // Skip to: 17157
/* 17074 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 17077 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 17087
/* 17082 */   MCD::OPC_Decode, 173, 15, 175, 1, // Opcode: XVMAXI_B
/* 17087 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 17097
/* 17092 */   MCD::OPC_Decode, 181, 15, 176, 1, // Opcode: XVMAXI_H
/* 17097 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 17107
/* 17102 */   MCD::OPC_Decode, 185, 15, 177, 1, // Opcode: XVMAXI_W
/* 17107 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 17117
/* 17112 */   MCD::OPC_Decode, 177, 15, 178, 1, // Opcode: XVMAXI_D
/* 17117 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 17127
/* 17122 */   MCD::OPC_Decode, 197, 15, 175, 1, // Opcode: XVMINI_B
/* 17127 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 17137
/* 17132 */   MCD::OPC_Decode, 205, 15, 176, 1, // Opcode: XVMINI_H
/* 17137 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 17147
/* 17142 */   MCD::OPC_Decode, 209, 15, 177, 1, // Opcode: XVMINI_W
/* 17147 */   MCD::OPC_FilterValue, 7, 128, 14, 0, // Skip to: 20864
/* 17152 */   MCD::OPC_Decode, 201, 15, 178, 1, // Opcode: XVMINI_D
/* 17157 */   MCD::OPC_FilterValue, 165, 1, 83, 0, 0, // Skip to: 17246
/* 17163 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 17166 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 17176
/* 17171 */   MCD::OPC_Decode, 174, 15, 179, 1, // Opcode: XVMAXI_BU
/* 17176 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 17186
/* 17181 */   MCD::OPC_Decode, 182, 15, 180, 1, // Opcode: XVMAXI_HU
/* 17186 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 17196
/* 17191 */   MCD::OPC_Decode, 186, 15, 181, 1, // Opcode: XVMAXI_WU
/* 17196 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 17206
/* 17201 */   MCD::OPC_Decode, 178, 15, 182, 1, // Opcode: XVMAXI_DU
/* 17206 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 17216
/* 17211 */   MCD::OPC_Decode, 198, 15, 179, 1, // Opcode: XVMINI_BU
/* 17216 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 17226
/* 17221 */   MCD::OPC_Decode, 206, 15, 180, 1, // Opcode: XVMINI_HU
/* 17226 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 17236
/* 17231 */   MCD::OPC_Decode, 210, 15, 181, 1, // Opcode: XVMINI_WU
/* 17236 */   MCD::OPC_FilterValue, 7, 39, 14, 0, // Skip to: 20864
/* 17241 */   MCD::OPC_Decode, 202, 15, 182, 1, // Opcode: XVMINI_DU
/* 17246 */   MCD::OPC_FilterValue, 166, 1, 23, 0, 0, // Skip to: 17275
/* 17252 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 17255 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 17265
/* 17260 */   MCD::OPC_Decode, 193, 14, 183, 1, // Opcode: XVFRSTPI_B
/* 17265 */   MCD::OPC_FilterValue, 5, 10, 14, 0, // Skip to: 20864
/* 17270 */   MCD::OPC_Decode, 194, 14, 184, 1, // Opcode: XVFRSTPI_H
/* 17275 */   MCD::OPC_FilterValue, 167, 1, 215, 4, 0, // Skip to: 18520
/* 17281 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 17284 */   MCD::OPC_FilterValue, 0, 223, 0, 0, // Skip to: 17512
/* 17289 */   MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 17292 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 17302
/* 17297 */   MCD::OPC_Decode, 194, 13, 185, 1, // Opcode: XVCLO_B
/* 17302 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 17312
/* 17307 */   MCD::OPC_Decode, 196, 13, 186, 1, // Opcode: XVCLO_H
/* 17312 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 17322
/* 17317 */   MCD::OPC_Decode, 197, 13, 187, 1, // Opcode: XVCLO_W
/* 17322 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 17332
/* 17327 */   MCD::OPC_Decode, 195, 13, 188, 1, // Opcode: XVCLO_D
/* 17332 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 17342
/* 17337 */   MCD::OPC_Decode, 198, 13, 185, 1, // Opcode: XVCLZ_B
/* 17342 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 17352
/* 17347 */   MCD::OPC_Decode, 200, 13, 186, 1, // Opcode: XVCLZ_H
/* 17352 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 17362
/* 17357 */   MCD::OPC_Decode, 201, 13, 187, 1, // Opcode: XVCLZ_W
/* 17362 */   MCD::OPC_FilterValue, 7, 5, 0, 0, // Skip to: 17372
/* 17367 */   MCD::OPC_Decode, 199, 13, 188, 1, // Opcode: XVCLZ_D
/* 17372 */   MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 17382
/* 17377 */   MCD::OPC_Decode, 164, 16, 185, 1, // Opcode: XVPCNT_B
/* 17382 */   MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 17392
/* 17387 */   MCD::OPC_Decode, 166, 16, 186, 1, // Opcode: XVPCNT_H
/* 17392 */   MCD::OPC_FilterValue, 10, 5, 0, 0, // Skip to: 17402
/* 17397 */   MCD::OPC_Decode, 167, 16, 187, 1, // Opcode: XVPCNT_W
/* 17402 */   MCD::OPC_FilterValue, 11, 5, 0, 0, // Skip to: 17412
/* 17407 */   MCD::OPC_Decode, 165, 16, 188, 1, // Opcode: XVPCNT_D
/* 17412 */   MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 17422
/* 17417 */   MCD::OPC_Decode, 147, 16, 185, 1, // Opcode: XVNEG_B
/* 17422 */   MCD::OPC_FilterValue, 13, 5, 0, 0, // Skip to: 17432
/* 17427 */   MCD::OPC_Decode, 149, 16, 186, 1, // Opcode: XVNEG_H
/* 17432 */   MCD::OPC_FilterValue, 14, 5, 0, 0, // Skip to: 17442
/* 17437 */   MCD::OPC_Decode, 150, 16, 187, 1, // Opcode: XVNEG_W
/* 17442 */   MCD::OPC_FilterValue, 15, 5, 0, 0, // Skip to: 17452
/* 17447 */   MCD::OPC_Decode, 148, 16, 188, 1, // Opcode: XVNEG_D
/* 17452 */   MCD::OPC_FilterValue, 16, 5, 0, 0, // Skip to: 17462
/* 17457 */   MCD::OPC_Decode, 230, 15, 185, 1, // Opcode: XVMSKLTZ_B
/* 17462 */   MCD::OPC_FilterValue, 17, 5, 0, 0, // Skip to: 17472
/* 17467 */   MCD::OPC_Decode, 232, 15, 186, 1, // Opcode: XVMSKLTZ_H
/* 17472 */   MCD::OPC_FilterValue, 18, 5, 0, 0, // Skip to: 17482
/* 17477 */   MCD::OPC_Decode, 233, 15, 187, 1, // Opcode: XVMSKLTZ_W
/* 17482 */   MCD::OPC_FilterValue, 19, 5, 0, 0, // Skip to: 17492
/* 17487 */   MCD::OPC_Decode, 231, 15, 188, 1, // Opcode: XVMSKLTZ_D
/* 17492 */   MCD::OPC_FilterValue, 20, 5, 0, 0, // Skip to: 17502
/* 17497 */   MCD::OPC_Decode, 229, 15, 185, 1, // Opcode: XVMSKGEZ_B
/* 17502 */   MCD::OPC_FilterValue, 24, 29, 13, 0, // Skip to: 20864
/* 17507 */   MCD::OPC_Decode, 234, 15, 185, 1, // Opcode: XVMSKNZ_B
/* 17512 */   MCD::OPC_FilterValue, 1, 253, 0, 0, // Skip to: 17770
/* 17517 */   MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 17520 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 17537
/* 17525 */   MCD::OPC_CheckField, 3, 2, 0, 4, 13, 0, // Skip to: 20864
/* 17532 */   MCD::OPC_Decode, 251, 16, 189, 1, // Opcode: XVSETEQZ_V
/* 17537 */   MCD::OPC_FilterValue, 7, 12, 0, 0, // Skip to: 17554
/* 17542 */   MCD::OPC_CheckField, 3, 2, 0, 243, 12, 0, // Skip to: 20864
/* 17549 */   MCD::OPC_Decode, 252, 16, 189, 1, // Opcode: XVSETNEZ_V
/* 17554 */   MCD::OPC_FilterValue, 8, 12, 0, 0, // Skip to: 17571
/* 17559 */   MCD::OPC_CheckField, 3, 2, 0, 226, 12, 0, // Skip to: 20864
/* 17566 */   MCD::OPC_Decode, 247, 16, 189, 1, // Opcode: XVSETANYEQZ_B
/* 17571 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 17588
/* 17576 */   MCD::OPC_CheckField, 3, 2, 0, 209, 12, 0, // Skip to: 20864
/* 17583 */   MCD::OPC_Decode, 249, 16, 190, 1, // Opcode: XVSETANYEQZ_H
/* 17588 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 17605
/* 17593 */   MCD::OPC_CheckField, 3, 2, 0, 192, 12, 0, // Skip to: 20864
/* 17600 */   MCD::OPC_Decode, 250, 16, 191, 1, // Opcode: XVSETANYEQZ_W
/* 17605 */   MCD::OPC_FilterValue, 11, 12, 0, 0, // Skip to: 17622
/* 17610 */   MCD::OPC_CheckField, 3, 2, 0, 175, 12, 0, // Skip to: 20864
/* 17617 */   MCD::OPC_Decode, 248, 16, 192, 1, // Opcode: XVSETANYEQZ_D
/* 17622 */   MCD::OPC_FilterValue, 12, 12, 0, 0, // Skip to: 17639
/* 17627 */   MCD::OPC_CheckField, 3, 2, 0, 158, 12, 0, // Skip to: 20864
/* 17634 */   MCD::OPC_Decode, 243, 16, 189, 1, // Opcode: XVSETALLNEZ_B
/* 17639 */   MCD::OPC_FilterValue, 13, 12, 0, 0, // Skip to: 17656
/* 17644 */   MCD::OPC_CheckField, 3, 2, 0, 141, 12, 0, // Skip to: 20864
/* 17651 */   MCD::OPC_Decode, 245, 16, 190, 1, // Opcode: XVSETALLNEZ_H
/* 17656 */   MCD::OPC_FilterValue, 14, 12, 0, 0, // Skip to: 17673
/* 17661 */   MCD::OPC_CheckField, 3, 2, 0, 124, 12, 0, // Skip to: 20864
/* 17668 */   MCD::OPC_Decode, 246, 16, 191, 1, // Opcode: XVSETALLNEZ_W
/* 17673 */   MCD::OPC_FilterValue, 15, 12, 0, 0, // Skip to: 17690
/* 17678 */   MCD::OPC_CheckField, 3, 2, 0, 107, 12, 0, // Skip to: 20864
/* 17685 */   MCD::OPC_Decode, 244, 16, 192, 1, // Opcode: XVSETALLNEZ_D
/* 17690 */   MCD::OPC_FilterValue, 17, 5, 0, 0, // Skip to: 17700
/* 17695 */   MCD::OPC_Decode, 160, 14, 187, 1, // Opcode: XVFLOGB_S
/* 17700 */   MCD::OPC_FilterValue, 18, 5, 0, 0, // Skip to: 17710
/* 17705 */   MCD::OPC_Decode, 159, 14, 188, 1, // Opcode: XVFLOGB_D
/* 17710 */   MCD::OPC_FilterValue, 21, 5, 0, 0, // Skip to: 17720
/* 17715 */   MCD::OPC_Decode, 227, 13, 187, 1, // Opcode: XVFCLASS_S
/* 17720 */   MCD::OPC_FilterValue, 22, 5, 0, 0, // Skip to: 17730
/* 17725 */   MCD::OPC_Decode, 226, 13, 188, 1, // Opcode: XVFCLASS_D
/* 17730 */   MCD::OPC_FilterValue, 25, 5, 0, 0, // Skip to: 17740
/* 17735 */   MCD::OPC_Decode, 198, 14, 187, 1, // Opcode: XVFSQRT_S
/* 17740 */   MCD::OPC_FilterValue, 26, 5, 0, 0, // Skip to: 17750
/* 17745 */   MCD::OPC_Decode, 197, 14, 188, 1, // Opcode: XVFSQRT_D
/* 17750 */   MCD::OPC_FilterValue, 29, 5, 0, 0, // Skip to: 17760
/* 17755 */   MCD::OPC_Decode, 180, 14, 187, 1, // Opcode: XVFRECIP_S
/* 17760 */   MCD::OPC_FilterValue, 30, 27, 12, 0, // Skip to: 20864
/* 17765 */   MCD::OPC_Decode, 179, 14, 188, 1, // Opcode: XVFRECIP_D
/* 17770 */   MCD::OPC_FilterValue, 2, 123, 0, 0, // Skip to: 17898
/* 17775 */   MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 17778 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 17788
/* 17783 */   MCD::OPC_Decode, 192, 14, 187, 1, // Opcode: XVFRSQRT_S
/* 17788 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 17798
/* 17793 */   MCD::OPC_Decode, 191, 14, 188, 1, // Opcode: XVFRSQRT_D
/* 17798 */   MCD::OPC_FilterValue, 13, 5, 0, 0, // Skip to: 17808
/* 17803 */   MCD::OPC_Decode, 190, 14, 187, 1, // Opcode: XVFRINT_S
/* 17808 */   MCD::OPC_FilterValue, 14, 5, 0, 0, // Skip to: 17818
/* 17813 */   MCD::OPC_Decode, 189, 14, 188, 1, // Opcode: XVFRINT_D
/* 17818 */   MCD::OPC_FilterValue, 17, 5, 0, 0, // Skip to: 17828
/* 17823 */   MCD::OPC_Decode, 182, 14, 187, 1, // Opcode: XVFRINTRM_S
/* 17828 */   MCD::OPC_FilterValue, 18, 5, 0, 0, // Skip to: 17838
/* 17833 */   MCD::OPC_Decode, 181, 14, 188, 1, // Opcode: XVFRINTRM_D
/* 17838 */   MCD::OPC_FilterValue, 21, 5, 0, 0, // Skip to: 17848
/* 17843 */   MCD::OPC_Decode, 186, 14, 187, 1, // Opcode: XVFRINTRP_S
/* 17848 */   MCD::OPC_FilterValue, 22, 5, 0, 0, // Skip to: 17858
/* 17853 */   MCD::OPC_Decode, 185, 14, 188, 1, // Opcode: XVFRINTRP_D
/* 17858 */   MCD::OPC_FilterValue, 25, 5, 0, 0, // Skip to: 17868
/* 17863 */   MCD::OPC_Decode, 188, 14, 187, 1, // Opcode: XVFRINTRZ_S
/* 17868 */   MCD::OPC_FilterValue, 26, 5, 0, 0, // Skip to: 17878
/* 17873 */   MCD::OPC_Decode, 187, 14, 188, 1, // Opcode: XVFRINTRZ_D
/* 17878 */   MCD::OPC_FilterValue, 29, 5, 0, 0, // Skip to: 17888
/* 17883 */   MCD::OPC_Decode, 184, 14, 187, 1, // Opcode: XVFRINTRNE_S
/* 17888 */   MCD::OPC_FilterValue, 30, 155, 11, 0, // Skip to: 20864
/* 17893 */   MCD::OPC_Decode, 183, 14, 188, 1, // Opcode: XVFRINTRNE_D
/* 17898 */   MCD::OPC_FilterValue, 3, 43, 0, 0, // Skip to: 17946
/* 17903 */   MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 17906 */   MCD::OPC_FilterValue, 26, 5, 0, 0, // Skip to: 17916
/* 17911 */   MCD::OPC_Decode, 147, 14, 193, 1, // Opcode: XVFCVTL_S_H
/* 17916 */   MCD::OPC_FilterValue, 27, 5, 0, 0, // Skip to: 17926
/* 17921 */   MCD::OPC_Decode, 145, 14, 193, 1, // Opcode: XVFCVTH_S_H
/* 17926 */   MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 17936
/* 17931 */   MCD::OPC_Decode, 146, 14, 194, 1, // Opcode: XVFCVTL_D_S
/* 17936 */   MCD::OPC_FilterValue, 29, 107, 11, 0, // Skip to: 20864
/* 17941 */   MCD::OPC_Decode, 144, 14, 194, 1, // Opcode: XVFCVTH_D_S
/* 17946 */   MCD::OPC_FilterValue, 4, 203, 0, 0, // Skip to: 18154
/* 17951 */   MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 17954 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 17964
/* 17959 */   MCD::OPC_Decode, 157, 14, 187, 1, // Opcode: XVFFINT_S_W
/* 17964 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 17974
/* 17969 */   MCD::OPC_Decode, 158, 14, 187, 1, // Opcode: XVFFINT_S_WU
/* 17974 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 17984
/* 17979 */   MCD::OPC_Decode, 154, 14, 188, 1, // Opcode: XVFFINT_D_L
/* 17984 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 17994
/* 17989 */   MCD::OPC_Decode, 155, 14, 188, 1, // Opcode: XVFFINT_D_LU
/* 17994 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 18004
/* 17999 */   MCD::OPC_Decode, 153, 14, 194, 1, // Opcode: XVFFINTL_D_W
/* 18004 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 18014
/* 18009 */   MCD::OPC_Decode, 152, 14, 194, 1, // Opcode: XVFFINTH_D_W
/* 18014 */   MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 18024
/* 18019 */   MCD::OPC_Decode, 229, 14, 187, 1, // Opcode: XVFTINT_W_S
/* 18024 */   MCD::OPC_FilterValue, 13, 5, 0, 0, // Skip to: 18034
/* 18029 */   MCD::OPC_Decode, 226, 14, 188, 1, // Opcode: XVFTINT_L_D
/* 18034 */   MCD::OPC_FilterValue, 14, 5, 0, 0, // Skip to: 18044
/* 18039 */   MCD::OPC_Decode, 207, 14, 187, 1, // Opcode: XVFTINTRM_W_S
/* 18044 */   MCD::OPC_FilterValue, 15, 5, 0, 0, // Skip to: 18054
/* 18049 */   MCD::OPC_Decode, 205, 14, 188, 1, // Opcode: XVFTINTRM_L_D
/* 18054 */   MCD::OPC_FilterValue, 16, 5, 0, 0, // Skip to: 18064
/* 18059 */   MCD::OPC_Decode, 217, 14, 187, 1, // Opcode: XVFTINTRP_W_S
/* 18064 */   MCD::OPC_FilterValue, 17, 5, 0, 0, // Skip to: 18074
/* 18069 */   MCD::OPC_Decode, 215, 14, 188, 1, // Opcode: XVFTINTRP_L_D
/* 18074 */   MCD::OPC_FilterValue, 18, 5, 0, 0, // Skip to: 18084
/* 18079 */   MCD::OPC_Decode, 224, 14, 187, 1, // Opcode: XVFTINTRZ_W_S
/* 18084 */   MCD::OPC_FilterValue, 19, 5, 0, 0, // Skip to: 18094
/* 18089 */   MCD::OPC_Decode, 221, 14, 188, 1, // Opcode: XVFTINTRZ_L_D
/* 18094 */   MCD::OPC_FilterValue, 20, 5, 0, 0, // Skip to: 18104
/* 18099 */   MCD::OPC_Decode, 212, 14, 187, 1, // Opcode: XVFTINTRNE_W_S
/* 18104 */   MCD::OPC_FilterValue, 21, 5, 0, 0, // Skip to: 18114
/* 18109 */   MCD::OPC_Decode, 210, 14, 188, 1, // Opcode: XVFTINTRNE_L_D
/* 18114 */   MCD::OPC_FilterValue, 22, 5, 0, 0, // Skip to: 18124
/* 18119 */   MCD::OPC_Decode, 227, 14, 187, 1, // Opcode: XVFTINT_WU_S
/* 18124 */   MCD::OPC_FilterValue, 23, 5, 0, 0, // Skip to: 18134
/* 18129 */   MCD::OPC_Decode, 225, 14, 188, 1, // Opcode: XVFTINT_LU_D
/* 18134 */   MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 18144
/* 18139 */   MCD::OPC_Decode, 222, 14, 187, 1, // Opcode: XVFTINTRZ_WU_S
/* 18144 */   MCD::OPC_FilterValue, 29, 155, 10, 0, // Skip to: 20864
/* 18149 */   MCD::OPC_Decode, 220, 14, 188, 1, // Opcode: XVFTINTRZ_LU_D
/* 18154 */   MCD::OPC_FilterValue, 5, 183, 0, 0, // Skip to: 18342
/* 18159 */   MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 18162 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 18172
/* 18167 */   MCD::OPC_Decode, 202, 14, 194, 1, // Opcode: XVFTINTL_L_S
/* 18172 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 18182
/* 18177 */   MCD::OPC_Decode, 201, 14, 194, 1, // Opcode: XVFTINTH_L_S
/* 18182 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 18192
/* 18187 */   MCD::OPC_Decode, 204, 14, 194, 1, // Opcode: XVFTINTRML_L_S
/* 18192 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 18202
/* 18197 */   MCD::OPC_Decode, 203, 14, 194, 1, // Opcode: XVFTINTRMH_L_S
/* 18202 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 18212
/* 18207 */   MCD::OPC_Decode, 214, 14, 194, 1, // Opcode: XVFTINTRPL_L_S
/* 18212 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 18222
/* 18217 */   MCD::OPC_Decode, 213, 14, 194, 1, // Opcode: XVFTINTRPH_L_S
/* 18222 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 18232
/* 18227 */   MCD::OPC_Decode, 219, 14, 194, 1, // Opcode: XVFTINTRZL_L_S
/* 18232 */   MCD::OPC_FilterValue, 7, 5, 0, 0, // Skip to: 18242
/* 18237 */   MCD::OPC_Decode, 218, 14, 194, 1, // Opcode: XVFTINTRZH_L_S
/* 18242 */   MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 18252
/* 18247 */   MCD::OPC_Decode, 209, 14, 194, 1, // Opcode: XVFTINTRNEL_L_S
/* 18252 */   MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 18262
/* 18257 */   MCD::OPC_Decode, 208, 14, 194, 1, // Opcode: XVFTINTRNEH_L_S
/* 18262 */   MCD::OPC_FilterValue, 24, 5, 0, 0, // Skip to: 18272
/* 18267 */   MCD::OPC_Decode, 213, 13, 195, 1, // Opcode: XVEXTH_H_B
/* 18272 */   MCD::OPC_FilterValue, 25, 5, 0, 0, // Skip to: 18282
/* 18277 */   MCD::OPC_Decode, 217, 13, 193, 1, // Opcode: XVEXTH_W_H
/* 18282 */   MCD::OPC_FilterValue, 26, 5, 0, 0, // Skip to: 18292
/* 18287 */   MCD::OPC_Decode, 211, 13, 194, 1, // Opcode: XVEXTH_D_W
/* 18292 */   MCD::OPC_FilterValue, 27, 5, 0, 0, // Skip to: 18302
/* 18297 */   MCD::OPC_Decode, 215, 13, 188, 1, // Opcode: XVEXTH_Q_D
/* 18302 */   MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 18312
/* 18307 */   MCD::OPC_Decode, 212, 13, 195, 1, // Opcode: XVEXTH_HU_BU
/* 18312 */   MCD::OPC_FilterValue, 29, 5, 0, 0, // Skip to: 18322
/* 18317 */   MCD::OPC_Decode, 216, 13, 193, 1, // Opcode: XVEXTH_WU_HU
/* 18322 */   MCD::OPC_FilterValue, 30, 5, 0, 0, // Skip to: 18332
/* 18327 */   MCD::OPC_Decode, 210, 13, 194, 1, // Opcode: XVEXTH_DU_WU
/* 18332 */   MCD::OPC_FilterValue, 31, 223, 9, 0, // Skip to: 20864
/* 18337 */   MCD::OPC_Decode, 214, 13, 188, 1, // Opcode: XVEXTH_QU_DU
/* 18342 */   MCD::OPC_FilterValue, 6, 163, 0, 0, // Skip to: 18510
/* 18347 */   MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 18350 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 18360
/* 18355 */   MCD::OPC_Decode, 193, 16, 196, 1, // Opcode: XVREPLGR2VR_B
/* 18360 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 18370
/* 18365 */   MCD::OPC_Decode, 195, 16, 197, 1, // Opcode: XVREPLGR2VR_H
/* 18370 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 18380
/* 18375 */   MCD::OPC_Decode, 196, 16, 198, 1, // Opcode: XVREPLGR2VR_W
/* 18380 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 18390
/* 18385 */   MCD::OPC_Decode, 194, 16, 199, 1, // Opcode: XVREPLGR2VR_D
/* 18390 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 18400
/* 18395 */   MCD::OPC_Decode, 204, 7, 195, 1, // Opcode: VEXT2XV_H_B
/* 18400 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 18410
/* 18405 */   MCD::OPC_Decode, 207, 7, 200, 1, // Opcode: VEXT2XV_W_B
/* 18410 */   MCD::OPC_FilterValue, 6, 5, 0, 0, // Skip to: 18420
/* 18415 */   MCD::OPC_Decode, 200, 7, 201, 1, // Opcode: VEXT2XV_D_B
/* 18420 */   MCD::OPC_FilterValue, 7, 5, 0, 0, // Skip to: 18430
/* 18425 */   MCD::OPC_Decode, 208, 7, 193, 1, // Opcode: VEXT2XV_W_H
/* 18430 */   MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 18440
/* 18435 */   MCD::OPC_Decode, 201, 7, 202, 1, // Opcode: VEXT2XV_D_H
/* 18440 */   MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 18450
/* 18445 */   MCD::OPC_Decode, 202, 7, 194, 1, // Opcode: VEXT2XV_D_W
/* 18450 */   MCD::OPC_FilterValue, 10, 5, 0, 0, // Skip to: 18460
/* 18455 */   MCD::OPC_Decode, 203, 7, 195, 1, // Opcode: VEXT2XV_HU_BU
/* 18460 */   MCD::OPC_FilterValue, 11, 5, 0, 0, // Skip to: 18470
/* 18465 */   MCD::OPC_Decode, 205, 7, 200, 1, // Opcode: VEXT2XV_WU_BU
/* 18470 */   MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 18480
/* 18475 */   MCD::OPC_Decode, 197, 7, 201, 1, // Opcode: VEXT2XV_DU_BU
/* 18480 */   MCD::OPC_FilterValue, 13, 5, 0, 0, // Skip to: 18490
/* 18485 */   MCD::OPC_Decode, 206, 7, 193, 1, // Opcode: VEXT2XV_WU_HU
/* 18490 */   MCD::OPC_FilterValue, 14, 5, 0, 0, // Skip to: 18500
/* 18495 */   MCD::OPC_Decode, 198, 7, 202, 1, // Opcode: VEXT2XV_DU_HU
/* 18500 */   MCD::OPC_FilterValue, 15, 55, 9, 0, // Skip to: 20864
/* 18505 */   MCD::OPC_Decode, 199, 7, 194, 1, // Opcode: VEXT2XV_DU_WU
/* 18510 */   MCD::OPC_FilterValue, 7, 45, 9, 0, // Skip to: 20864
/* 18515 */   MCD::OPC_Decode, 238, 14, 182, 1, // Opcode: XVHSELI_D
/* 18520 */   MCD::OPC_FilterValue, 168, 1, 66, 0, 0, // Skip to: 18592
/* 18526 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 18529 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 18582
/* 18534 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 18537 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 18572
/* 18542 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 18545 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 18562
/* 18550 */   MCD::OPC_CheckField, 13, 1, 1, 3, 9, 0, // Skip to: 20864
/* 18557 */   MCD::OPC_Decode, 207, 16, 203, 1, // Opcode: XVROTRI_B
/* 18562 */   MCD::OPC_FilterValue, 1, 249, 8, 0, // Skip to: 20864
/* 18567 */   MCD::OPC_Decode, 209, 16, 204, 1, // Opcode: XVROTRI_H
/* 18572 */   MCD::OPC_FilterValue, 1, 239, 8, 0, // Skip to: 20864
/* 18577 */   MCD::OPC_Decode, 210, 16, 181, 1, // Opcode: XVROTRI_W
/* 18582 */   MCD::OPC_FilterValue, 1, 229, 8, 0, // Skip to: 20864
/* 18587 */   MCD::OPC_Decode, 208, 16, 205, 1, // Opcode: XVROTRI_D
/* 18592 */   MCD::OPC_FilterValue, 169, 1, 66, 0, 0, // Skip to: 18664
/* 18598 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 18601 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 18654
/* 18606 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 18609 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 18644
/* 18614 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 18617 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 18634
/* 18622 */   MCD::OPC_CheckField, 13, 1, 1, 187, 8, 0, // Skip to: 20864
/* 18629 */   MCD::OPC_Decode, 252, 17, 203, 1, // Opcode: XVSRLRI_B
/* 18634 */   MCD::OPC_FilterValue, 1, 177, 8, 0, // Skip to: 20864
/* 18639 */   MCD::OPC_Decode, 254, 17, 204, 1, // Opcode: XVSRLRI_H
/* 18644 */   MCD::OPC_FilterValue, 1, 167, 8, 0, // Skip to: 20864
/* 18649 */   MCD::OPC_Decode, 255, 17, 181, 1, // Opcode: XVSRLRI_W
/* 18654 */   MCD::OPC_FilterValue, 1, 157, 8, 0, // Skip to: 20864
/* 18659 */   MCD::OPC_Decode, 253, 17, 205, 1, // Opcode: XVSRLRI_D
/* 18664 */   MCD::OPC_FilterValue, 170, 1, 66, 0, 0, // Skip to: 18736
/* 18670 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 18673 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 18726
/* 18678 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 18681 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 18716
/* 18686 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 18689 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 18706
/* 18694 */   MCD::OPC_CheckField, 13, 1, 1, 115, 8, 0, // Skip to: 20864
/* 18701 */   MCD::OPC_Decode, 218, 17, 203, 1, // Opcode: XVSRARI_B
/* 18706 */   MCD::OPC_FilterValue, 1, 105, 8, 0, // Skip to: 20864
/* 18711 */   MCD::OPC_Decode, 220, 17, 204, 1, // Opcode: XVSRARI_H
/* 18716 */   MCD::OPC_FilterValue, 1, 95, 8, 0, // Skip to: 20864
/* 18721 */   MCD::OPC_Decode, 221, 17, 181, 1, // Opcode: XVSRARI_W
/* 18726 */   MCD::OPC_FilterValue, 1, 85, 8, 0, // Skip to: 20864
/* 18731 */   MCD::OPC_Decode, 219, 17, 205, 1, // Opcode: XVSRARI_D
/* 18736 */   MCD::OPC_FilterValue, 186, 1, 30, 0, 0, // Skip to: 18772
/* 18742 */   MCD::OPC_ExtractField, 13, 5,  // Inst{17-13} ...
/* 18745 */   MCD::OPC_FilterValue, 30, 5, 0, 0, // Skip to: 18755
/* 18750 */   MCD::OPC_Decode, 128, 15, 206, 1, // Opcode: XVINSGR2VR_W
/* 18755 */   MCD::OPC_FilterValue, 31, 56, 8, 0, // Skip to: 20864
/* 18760 */   MCD::OPC_CheckField, 12, 1, 0, 49, 8, 0, // Skip to: 20864
/* 18767 */   MCD::OPC_Decode, 255, 14, 207, 1, // Opcode: XVINSGR2VR_D
/* 18772 */   MCD::OPC_FilterValue, 187, 1, 30, 0, 0, // Skip to: 18808
/* 18778 */   MCD::OPC_ExtractField, 13, 5,  // Inst{17-13} ...
/* 18781 */   MCD::OPC_FilterValue, 30, 5, 0, 0, // Skip to: 18791
/* 18786 */   MCD::OPC_Decode, 185, 16, 208, 1, // Opcode: XVPICKVE2GR_W
/* 18791 */   MCD::OPC_FilterValue, 31, 20, 8, 0, // Skip to: 20864
/* 18796 */   MCD::OPC_CheckField, 12, 1, 0, 13, 8, 0, // Skip to: 20864
/* 18803 */   MCD::OPC_Decode, 183, 16, 209, 1, // Opcode: XVPICKVE2GR_D
/* 18808 */   MCD::OPC_FilterValue, 188, 1, 30, 0, 0, // Skip to: 18844
/* 18814 */   MCD::OPC_ExtractField, 13, 5,  // Inst{17-13} ...
/* 18817 */   MCD::OPC_FilterValue, 30, 5, 0, 0, // Skip to: 18827
/* 18822 */   MCD::OPC_Decode, 186, 16, 208, 1, // Opcode: XVPICKVE2GR_WU
/* 18827 */   MCD::OPC_FilterValue, 31, 240, 7, 0, // Skip to: 20864
/* 18832 */   MCD::OPC_CheckField, 12, 1, 0, 233, 7, 0, // Skip to: 20864
/* 18839 */   MCD::OPC_Decode, 184, 16, 209, 1, // Opcode: XVPICKVE2GR_DU
/* 18844 */   MCD::OPC_FilterValue, 189, 1, 66, 0, 0, // Skip to: 18916
/* 18850 */   MCD::OPC_ExtractField, 14, 4,  // Inst{17-14} ...
/* 18853 */   MCD::OPC_FilterValue, 14, 5, 0, 0, // Skip to: 18863
/* 18858 */   MCD::OPC_Decode, 189, 16, 210, 1, // Opcode: XVREPL128VEI_B
/* 18863 */   MCD::OPC_FilterValue, 15, 204, 7, 0, // Skip to: 20864
/* 18868 */   MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 18871 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 18881
/* 18876 */   MCD::OPC_Decode, 191, 16, 211, 1, // Opcode: XVREPL128VEI_H
/* 18881 */   MCD::OPC_FilterValue, 1, 186, 7, 0, // Skip to: 20864
/* 18886 */   MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 18889 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 18899
/* 18894 */   MCD::OPC_Decode, 192, 16, 212, 1, // Opcode: XVREPL128VEI_W
/* 18899 */   MCD::OPC_FilterValue, 1, 168, 7, 0, // Skip to: 20864
/* 18904 */   MCD::OPC_CheckField, 11, 1, 0, 161, 7, 0, // Skip to: 20864
/* 18911 */   MCD::OPC_Decode, 190, 16, 213, 1, // Opcode: XVREPL128VEI_D
/* 18916 */   MCD::OPC_FilterValue, 191, 1, 30, 0, 0, // Skip to: 18952
/* 18922 */   MCD::OPC_ExtractField, 13, 5,  // Inst{17-13} ...
/* 18925 */   MCD::OPC_FilterValue, 30, 5, 0, 0, // Skip to: 18935
/* 18930 */   MCD::OPC_Decode, 130, 15, 214, 1, // Opcode: XVINSVE0_W
/* 18935 */   MCD::OPC_FilterValue, 31, 132, 7, 0, // Skip to: 20864
/* 18940 */   MCD::OPC_CheckField, 12, 1, 0, 125, 7, 0, // Skip to: 20864
/* 18947 */   MCD::OPC_Decode, 129, 15, 215, 1, // Opcode: XVINSVE0_D
/* 18952 */   MCD::OPC_FilterValue, 192, 1, 30, 0, 0, // Skip to: 18988
/* 18958 */   MCD::OPC_ExtractField, 13, 5,  // Inst{17-13} ...
/* 18961 */   MCD::OPC_FilterValue, 30, 5, 0, 0, // Skip to: 18971
/* 18966 */   MCD::OPC_Decode, 188, 16, 214, 1, // Opcode: XVPICKVE_W
/* 18971 */   MCD::OPC_FilterValue, 31, 96, 7, 0, // Skip to: 20864
/* 18976 */   MCD::OPC_CheckField, 12, 1, 0, 89, 7, 0, // Skip to: 20864
/* 18983 */   MCD::OPC_Decode, 187, 16, 215, 1, // Opcode: XVPICKVE_D
/* 18988 */   MCD::OPC_FilterValue, 193, 1, 58, 0, 0, // Skip to: 19052
/* 18994 */   MCD::OPC_ExtractField, 10, 8,  // Inst{17-10} ...
/* 18997 */   MCD::OPC_FilterValue, 192, 1, 5, 0, 0, // Skip to: 19008
/* 19003 */   MCD::OPC_Decode, 197, 16, 185, 1, // Opcode: XVREPLVE0_B
/* 19008 */   MCD::OPC_FilterValue, 224, 1, 5, 0, 0, // Skip to: 19019
/* 19014 */   MCD::OPC_Decode, 199, 16, 186, 1, // Opcode: XVREPLVE0_H
/* 19019 */   MCD::OPC_FilterValue, 240, 1, 5, 0, 0, // Skip to: 19030
/* 19025 */   MCD::OPC_Decode, 201, 16, 187, 1, // Opcode: XVREPLVE0_W
/* 19030 */   MCD::OPC_FilterValue, 248, 1, 5, 0, 0, // Skip to: 19041
/* 19036 */   MCD::OPC_Decode, 198, 16, 188, 1, // Opcode: XVREPLVE0_D
/* 19041 */   MCD::OPC_FilterValue, 252, 1, 25, 7, 0, // Skip to: 20864
/* 19047 */   MCD::OPC_Decode, 200, 16, 185, 1, // Opcode: XVREPLVE0_Q
/* 19052 */   MCD::OPC_FilterValue, 194, 1, 65, 0, 0, // Skip to: 19123
/* 19058 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 19061 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 19096
/* 19066 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 19069 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 19086
/* 19074 */   MCD::OPC_CheckField, 13, 1, 1, 247, 6, 0, // Skip to: 20864
/* 19081 */   MCD::OPC_Decode, 172, 17, 216, 1, // Opcode: XVSLLWIL_H_B
/* 19086 */   MCD::OPC_FilterValue, 1, 237, 6, 0, // Skip to: 20864
/* 19091 */   MCD::OPC_Decode, 174, 17, 217, 1, // Opcode: XVSLLWIL_W_H
/* 19096 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 19106
/* 19101 */   MCD::OPC_Decode, 170, 17, 218, 1, // Opcode: XVSLLWIL_D_W
/* 19106 */   MCD::OPC_FilterValue, 2, 217, 6, 0, // Skip to: 20864
/* 19111 */   MCD::OPC_CheckField, 10, 5, 0, 210, 6, 0, // Skip to: 20864
/* 19118 */   MCD::OPC_Decode, 219, 13, 188, 1, // Opcode: XVEXTL_Q_D
/* 19123 */   MCD::OPC_FilterValue, 195, 1, 65, 0, 0, // Skip to: 19194
/* 19129 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 19132 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 19167
/* 19137 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 19140 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 19157
/* 19145 */   MCD::OPC_CheckField, 13, 1, 1, 176, 6, 0, // Skip to: 20864
/* 19152 */   MCD::OPC_Decode, 171, 17, 216, 1, // Opcode: XVSLLWIL_HU_BU
/* 19157 */   MCD::OPC_FilterValue, 1, 166, 6, 0, // Skip to: 20864
/* 19162 */   MCD::OPC_Decode, 173, 17, 217, 1, // Opcode: XVSLLWIL_WU_HU
/* 19167 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 19177
/* 19172 */   MCD::OPC_Decode, 169, 17, 218, 1, // Opcode: XVSLLWIL_DU_WU
/* 19177 */   MCD::OPC_FilterValue, 2, 146, 6, 0, // Skip to: 20864
/* 19182 */   MCD::OPC_CheckField, 10, 5, 0, 139, 6, 0, // Skip to: 20864
/* 19189 */   MCD::OPC_Decode, 218, 13, 188, 1, // Opcode: XVEXTL_QU_DU
/* 19194 */   MCD::OPC_FilterValue, 196, 1, 66, 0, 0, // Skip to: 19266
/* 19200 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 19203 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 19256
/* 19208 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 19211 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 19246
/* 19216 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 19219 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 19236
/* 19224 */   MCD::OPC_CheckField, 13, 1, 1, 97, 6, 0, // Skip to: 20864
/* 19231 */   MCD::OPC_Decode, 165, 13, 203, 1, // Opcode: XVBITCLRI_B
/* 19236 */   MCD::OPC_FilterValue, 1, 87, 6, 0, // Skip to: 20864
/* 19241 */   MCD::OPC_Decode, 167, 13, 204, 1, // Opcode: XVBITCLRI_H
/* 19246 */   MCD::OPC_FilterValue, 1, 77, 6, 0, // Skip to: 20864
/* 19251 */   MCD::OPC_Decode, 168, 13, 181, 1, // Opcode: XVBITCLRI_W
/* 19256 */   MCD::OPC_FilterValue, 1, 67, 6, 0, // Skip to: 20864
/* 19261 */   MCD::OPC_Decode, 166, 13, 205, 1, // Opcode: XVBITCLRI_D
/* 19266 */   MCD::OPC_FilterValue, 197, 1, 66, 0, 0, // Skip to: 19338
/* 19272 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 19275 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 19328
/* 19280 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 19283 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 19318
/* 19288 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 19291 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 19308
/* 19296 */   MCD::OPC_CheckField, 13, 1, 1, 25, 6, 0, // Skip to: 20864
/* 19303 */   MCD::OPC_Decode, 184, 13, 203, 1, // Opcode: XVBITSETI_B
/* 19308 */   MCD::OPC_FilterValue, 1, 15, 6, 0, // Skip to: 20864
/* 19313 */   MCD::OPC_Decode, 186, 13, 204, 1, // Opcode: XVBITSETI_H
/* 19318 */   MCD::OPC_FilterValue, 1, 5, 6, 0, // Skip to: 20864
/* 19323 */   MCD::OPC_Decode, 187, 13, 181, 1, // Opcode: XVBITSETI_W
/* 19328 */   MCD::OPC_FilterValue, 1, 251, 5, 0, // Skip to: 20864
/* 19333 */   MCD::OPC_Decode, 185, 13, 205, 1, // Opcode: XVBITSETI_D
/* 19338 */   MCD::OPC_FilterValue, 198, 1, 66, 0, 0, // Skip to: 19410
/* 19344 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 19347 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 19400
/* 19352 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 19355 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 19390
/* 19360 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 19363 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 19380
/* 19368 */   MCD::OPC_CheckField, 13, 1, 1, 209, 5, 0, // Skip to: 20864
/* 19375 */   MCD::OPC_Decode, 173, 13, 203, 1, // Opcode: XVBITREVI_B
/* 19380 */   MCD::OPC_FilterValue, 1, 199, 5, 0, // Skip to: 20864
/* 19385 */   MCD::OPC_Decode, 175, 13, 204, 1, // Opcode: XVBITREVI_H
/* 19390 */   MCD::OPC_FilterValue, 1, 189, 5, 0, // Skip to: 20864
/* 19395 */   MCD::OPC_Decode, 176, 13, 181, 1, // Opcode: XVBITREVI_W
/* 19400 */   MCD::OPC_FilterValue, 1, 179, 5, 0, // Skip to: 20864
/* 19405 */   MCD::OPC_Decode, 174, 13, 205, 1, // Opcode: XVBITREVI_D
/* 19410 */   MCD::OPC_FilterValue, 201, 1, 66, 0, 0, // Skip to: 19482
/* 19416 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 19419 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 19472
/* 19424 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 19427 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 19462
/* 19432 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 19435 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 19452
/* 19440 */   MCD::OPC_CheckField, 13, 1, 1, 137, 5, 0, // Skip to: 20864
/* 19447 */   MCD::OPC_Decode, 223, 16, 203, 1, // Opcode: XVSAT_B
/* 19452 */   MCD::OPC_FilterValue, 1, 127, 5, 0, // Skip to: 20864
/* 19457 */   MCD::OPC_Decode, 227, 16, 204, 1, // Opcode: XVSAT_H
/* 19462 */   MCD::OPC_FilterValue, 1, 117, 5, 0, // Skip to: 20864
/* 19467 */   MCD::OPC_Decode, 229, 16, 181, 1, // Opcode: XVSAT_W
/* 19472 */   MCD::OPC_FilterValue, 1, 107, 5, 0, // Skip to: 20864
/* 19477 */   MCD::OPC_Decode, 225, 16, 205, 1, // Opcode: XVSAT_D
/* 19482 */   MCD::OPC_FilterValue, 202, 1, 66, 0, 0, // Skip to: 19554
/* 19488 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 19491 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 19544
/* 19496 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 19499 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 19534
/* 19504 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 19507 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 19524
/* 19512 */   MCD::OPC_CheckField, 13, 1, 1, 65, 5, 0, // Skip to: 20864
/* 19519 */   MCD::OPC_Decode, 224, 16, 203, 1, // Opcode: XVSAT_BU
/* 19524 */   MCD::OPC_FilterValue, 1, 55, 5, 0, // Skip to: 20864
/* 19529 */   MCD::OPC_Decode, 228, 16, 204, 1, // Opcode: XVSAT_HU
/* 19534 */   MCD::OPC_FilterValue, 1, 45, 5, 0, // Skip to: 20864
/* 19539 */   MCD::OPC_Decode, 230, 16, 181, 1, // Opcode: XVSAT_WU
/* 19544 */   MCD::OPC_FilterValue, 1, 35, 5, 0, // Skip to: 20864
/* 19549 */   MCD::OPC_Decode, 226, 16, 205, 1, // Opcode: XVSAT_DU
/* 19554 */   MCD::OPC_FilterValue, 203, 1, 66, 0, 0, // Skip to: 19626
/* 19560 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 19563 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 19616
/* 19568 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 19571 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 19606
/* 19576 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 19579 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 19596
/* 19584 */   MCD::OPC_CheckField, 13, 1, 1, 249, 4, 0, // Skip to: 20864
/* 19591 */   MCD::OPC_Decode, 161, 17, 203, 1, // Opcode: XVSLLI_B
/* 19596 */   MCD::OPC_FilterValue, 1, 239, 4, 0, // Skip to: 20864
/* 19601 */   MCD::OPC_Decode, 165, 17, 204, 1, // Opcode: XVSLLI_H
/* 19606 */   MCD::OPC_FilterValue, 1, 229, 4, 0, // Skip to: 20864
/* 19611 */   MCD::OPC_Decode, 167, 17, 181, 1, // Opcode: XVSLLI_W
/* 19616 */   MCD::OPC_FilterValue, 1, 219, 4, 0, // Skip to: 20864
/* 19621 */   MCD::OPC_Decode, 163, 17, 205, 1, // Opcode: XVSLLI_D
/* 19626 */   MCD::OPC_FilterValue, 204, 1, 66, 0, 0, // Skip to: 19698
/* 19632 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 19635 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 19688
/* 19640 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 19643 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 19678
/* 19648 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 19651 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 19668
/* 19656 */   MCD::OPC_CheckField, 13, 1, 1, 177, 4, 0, // Skip to: 20864
/* 19663 */   MCD::OPC_Decode, 237, 17, 203, 1, // Opcode: XVSRLI_B
/* 19668 */   MCD::OPC_FilterValue, 1, 167, 4, 0, // Skip to: 20864
/* 19673 */   MCD::OPC_Decode, 241, 17, 204, 1, // Opcode: XVSRLI_H
/* 19678 */   MCD::OPC_FilterValue, 1, 157, 4, 0, // Skip to: 20864
/* 19683 */   MCD::OPC_Decode, 243, 17, 181, 1, // Opcode: XVSRLI_W
/* 19688 */   MCD::OPC_FilterValue, 1, 147, 4, 0, // Skip to: 20864
/* 19693 */   MCD::OPC_Decode, 239, 17, 205, 1, // Opcode: XVSRLI_D
/* 19698 */   MCD::OPC_FilterValue, 205, 1, 66, 0, 0, // Skip to: 19770
/* 19704 */   MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 19707 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 19760
/* 19712 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 19715 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 19750
/* 19720 */   MCD::OPC_ExtractField, 14, 1,  // Inst{14} ...
/* 19723 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 19740
/* 19728 */   MCD::OPC_CheckField, 13, 1, 1, 105, 4, 0, // Skip to: 20864
/* 19735 */   MCD::OPC_Decode, 203, 17, 203, 1, // Opcode: XVSRAI_B
/* 19740 */   MCD::OPC_FilterValue, 1, 95, 4, 0, // Skip to: 20864
/* 19745 */   MCD::OPC_Decode, 207, 17, 204, 1, // Opcode: XVSRAI_H
/* 19750 */   MCD::OPC_FilterValue, 1, 85, 4, 0, // Skip to: 20864
/* 19755 */   MCD::OPC_Decode, 209, 17, 181, 1, // Opcode: XVSRAI_W
/* 19760 */   MCD::OPC_FilterValue, 1, 75, 4, 0, // Skip to: 20864
/* 19765 */   MCD::OPC_Decode, 205, 17, 205, 1, // Opcode: XVSRAI_D
/* 19770 */   MCD::OPC_FilterValue, 208, 1, 66, 0, 0, // Skip to: 19842
/* 19776 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 19779 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 19832
/* 19784 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 19787 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 19822
/* 19792 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 19795 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 19812
/* 19800 */   MCD::OPC_CheckField, 14, 1, 1, 33, 4, 0, // Skip to: 20864
/* 19807 */   MCD::OPC_Decode, 245, 17, 219, 1, // Opcode: XVSRLNI_B_H
/* 19812 */   MCD::OPC_FilterValue, 1, 23, 4, 0, // Skip to: 20864
/* 19817 */   MCD::OPC_Decode, 247, 17, 184, 1, // Opcode: XVSRLNI_H_W
/* 19822 */   MCD::OPC_FilterValue, 1, 13, 4, 0, // Skip to: 20864
/* 19827 */   MCD::OPC_Decode, 248, 17, 220, 1, // Opcode: XVSRLNI_W_D
/* 19832 */   MCD::OPC_FilterValue, 1, 3, 4, 0, // Skip to: 20864
/* 19837 */   MCD::OPC_Decode, 246, 17, 221, 1, // Opcode: XVSRLNI_D_Q
/* 19842 */   MCD::OPC_FilterValue, 209, 1, 66, 0, 0, // Skip to: 19914
/* 19848 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 19851 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 19904
/* 19856 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 19859 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 19894
/* 19864 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 19867 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 19884
/* 19872 */   MCD::OPC_CheckField, 14, 1, 1, 217, 3, 0, // Skip to: 20864
/* 19879 */   MCD::OPC_Decode, 128, 18, 219, 1, // Opcode: XVSRLRNI_B_H
/* 19884 */   MCD::OPC_FilterValue, 1, 207, 3, 0, // Skip to: 20864
/* 19889 */   MCD::OPC_Decode, 130, 18, 184, 1, // Opcode: XVSRLRNI_H_W
/* 19894 */   MCD::OPC_FilterValue, 1, 197, 3, 0, // Skip to: 20864
/* 19899 */   MCD::OPC_Decode, 131, 18, 220, 1, // Opcode: XVSRLRNI_W_D
/* 19904 */   MCD::OPC_FilterValue, 1, 187, 3, 0, // Skip to: 20864
/* 19909 */   MCD::OPC_Decode, 129, 18, 221, 1, // Opcode: XVSRLRNI_D_Q
/* 19914 */   MCD::OPC_FilterValue, 210, 1, 66, 0, 0, // Skip to: 19986
/* 19920 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 19923 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 19976
/* 19928 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 19931 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 19966
/* 19936 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 19939 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 19956
/* 19944 */   MCD::OPC_CheckField, 14, 1, 1, 145, 3, 0, // Skip to: 20864
/* 19951 */   MCD::OPC_Decode, 172, 18, 219, 1, // Opcode: XVSSRLNI_B_H
/* 19956 */   MCD::OPC_FilterValue, 1, 135, 3, 0, // Skip to: 20864
/* 19961 */   MCD::OPC_Decode, 176, 18, 184, 1, // Opcode: XVSSRLNI_H_W
/* 19966 */   MCD::OPC_FilterValue, 1, 125, 3, 0, // Skip to: 20864
/* 19971 */   MCD::OPC_Decode, 178, 18, 220, 1, // Opcode: XVSSRLNI_W_D
/* 19976 */   MCD::OPC_FilterValue, 1, 115, 3, 0, // Skip to: 20864
/* 19981 */   MCD::OPC_Decode, 174, 18, 221, 1, // Opcode: XVSSRLNI_D_Q
/* 19986 */   MCD::OPC_FilterValue, 211, 1, 66, 0, 0, // Skip to: 20058
/* 19992 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 19995 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 20048
/* 20000 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 20003 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 20038
/* 20008 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 20011 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 20028
/* 20016 */   MCD::OPC_CheckField, 14, 1, 1, 73, 3, 0, // Skip to: 20864
/* 20023 */   MCD::OPC_Decode, 171, 18, 219, 1, // Opcode: XVSSRLNI_BU_H
/* 20028 */   MCD::OPC_FilterValue, 1, 63, 3, 0, // Skip to: 20864
/* 20033 */   MCD::OPC_Decode, 175, 18, 184, 1, // Opcode: XVSSRLNI_HU_W
/* 20038 */   MCD::OPC_FilterValue, 1, 53, 3, 0, // Skip to: 20864
/* 20043 */   MCD::OPC_Decode, 177, 18, 220, 1, // Opcode: XVSSRLNI_WU_D
/* 20048 */   MCD::OPC_FilterValue, 1, 43, 3, 0, // Skip to: 20864
/* 20053 */   MCD::OPC_Decode, 173, 18, 221, 1, // Opcode: XVSSRLNI_DU_Q
/* 20058 */   MCD::OPC_FilterValue, 212, 1, 66, 0, 0, // Skip to: 20130
/* 20064 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 20067 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 20120
/* 20072 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 20075 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 20110
/* 20080 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 20083 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 20100
/* 20088 */   MCD::OPC_CheckField, 14, 1, 1, 1, 3, 0, // Skip to: 20864
/* 20095 */   MCD::OPC_Decode, 186, 18, 219, 1, // Opcode: XVSSRLRNI_B_H
/* 20100 */   MCD::OPC_FilterValue, 1, 247, 2, 0, // Skip to: 20864
/* 20105 */   MCD::OPC_Decode, 190, 18, 184, 1, // Opcode: XVSSRLRNI_H_W
/* 20110 */   MCD::OPC_FilterValue, 1, 237, 2, 0, // Skip to: 20864
/* 20115 */   MCD::OPC_Decode, 192, 18, 220, 1, // Opcode: XVSSRLRNI_W_D
/* 20120 */   MCD::OPC_FilterValue, 1, 227, 2, 0, // Skip to: 20864
/* 20125 */   MCD::OPC_Decode, 188, 18, 221, 1, // Opcode: XVSSRLRNI_D_Q
/* 20130 */   MCD::OPC_FilterValue, 213, 1, 66, 0, 0, // Skip to: 20202
/* 20136 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 20139 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 20192
/* 20144 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 20147 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 20182
/* 20152 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 20155 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 20172
/* 20160 */   MCD::OPC_CheckField, 14, 1, 1, 185, 2, 0, // Skip to: 20864
/* 20167 */   MCD::OPC_Decode, 185, 18, 219, 1, // Opcode: XVSSRLRNI_BU_H
/* 20172 */   MCD::OPC_FilterValue, 1, 175, 2, 0, // Skip to: 20864
/* 20177 */   MCD::OPC_Decode, 189, 18, 184, 1, // Opcode: XVSSRLRNI_HU_W
/* 20182 */   MCD::OPC_FilterValue, 1, 165, 2, 0, // Skip to: 20864
/* 20187 */   MCD::OPC_Decode, 191, 18, 220, 1, // Opcode: XVSSRLRNI_WU_D
/* 20192 */   MCD::OPC_FilterValue, 1, 155, 2, 0, // Skip to: 20864
/* 20197 */   MCD::OPC_Decode, 187, 18, 221, 1, // Opcode: XVSSRLRNI_DU_Q
/* 20202 */   MCD::OPC_FilterValue, 214, 1, 66, 0, 0, // Skip to: 20274
/* 20208 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 20211 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 20264
/* 20216 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 20219 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 20254
/* 20224 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 20227 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 20244
/* 20232 */   MCD::OPC_CheckField, 14, 1, 1, 113, 2, 0, // Skip to: 20864
/* 20239 */   MCD::OPC_Decode, 211, 17, 219, 1, // Opcode: XVSRANI_B_H
/* 20244 */   MCD::OPC_FilterValue, 1, 103, 2, 0, // Skip to: 20864
/* 20249 */   MCD::OPC_Decode, 213, 17, 184, 1, // Opcode: XVSRANI_H_W
/* 20254 */   MCD::OPC_FilterValue, 1, 93, 2, 0, // Skip to: 20864
/* 20259 */   MCD::OPC_Decode, 214, 17, 220, 1, // Opcode: XVSRANI_W_D
/* 20264 */   MCD::OPC_FilterValue, 1, 83, 2, 0, // Skip to: 20864
/* 20269 */   MCD::OPC_Decode, 212, 17, 221, 1, // Opcode: XVSRANI_D_Q
/* 20274 */   MCD::OPC_FilterValue, 215, 1, 66, 0, 0, // Skip to: 20346
/* 20280 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 20283 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 20336
/* 20288 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 20291 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 20326
/* 20296 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 20299 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 20316
/* 20304 */   MCD::OPC_CheckField, 14, 1, 1, 41, 2, 0, // Skip to: 20864
/* 20311 */   MCD::OPC_Decode, 222, 17, 219, 1, // Opcode: XVSRARNI_B_H
/* 20316 */   MCD::OPC_FilterValue, 1, 31, 2, 0, // Skip to: 20864
/* 20321 */   MCD::OPC_Decode, 224, 17, 184, 1, // Opcode: XVSRARNI_H_W
/* 20326 */   MCD::OPC_FilterValue, 1, 21, 2, 0, // Skip to: 20864
/* 20331 */   MCD::OPC_Decode, 225, 17, 220, 1, // Opcode: XVSRARNI_W_D
/* 20336 */   MCD::OPC_FilterValue, 1, 11, 2, 0, // Skip to: 20864
/* 20341 */   MCD::OPC_Decode, 223, 17, 221, 1, // Opcode: XVSRARNI_D_Q
/* 20346 */   MCD::OPC_FilterValue, 216, 1, 66, 0, 0, // Skip to: 20418
/* 20352 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 20355 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 20408
/* 20360 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 20363 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 20398
/* 20368 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 20371 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 20388
/* 20376 */   MCD::OPC_CheckField, 14, 1, 1, 225, 1, 0, // Skip to: 20864
/* 20383 */   MCD::OPC_Decode, 144, 18, 219, 1, // Opcode: XVSSRANI_B_H
/* 20388 */   MCD::OPC_FilterValue, 1, 215, 1, 0, // Skip to: 20864
/* 20393 */   MCD::OPC_Decode, 148, 18, 184, 1, // Opcode: XVSSRANI_H_W
/* 20398 */   MCD::OPC_FilterValue, 1, 205, 1, 0, // Skip to: 20864
/* 20403 */   MCD::OPC_Decode, 150, 18, 220, 1, // Opcode: XVSSRANI_W_D
/* 20408 */   MCD::OPC_FilterValue, 1, 195, 1, 0, // Skip to: 20864
/* 20413 */   MCD::OPC_Decode, 146, 18, 221, 1, // Opcode: XVSSRANI_D_Q
/* 20418 */   MCD::OPC_FilterValue, 217, 1, 66, 0, 0, // Skip to: 20490
/* 20424 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 20427 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 20480
/* 20432 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 20435 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 20470
/* 20440 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 20443 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 20460
/* 20448 */   MCD::OPC_CheckField, 14, 1, 1, 153, 1, 0, // Skip to: 20864
/* 20455 */   MCD::OPC_Decode, 143, 18, 219, 1, // Opcode: XVSSRANI_BU_H
/* 20460 */   MCD::OPC_FilterValue, 1, 143, 1, 0, // Skip to: 20864
/* 20465 */   MCD::OPC_Decode, 147, 18, 184, 1, // Opcode: XVSSRANI_HU_W
/* 20470 */   MCD::OPC_FilterValue, 1, 133, 1, 0, // Skip to: 20864
/* 20475 */   MCD::OPC_Decode, 149, 18, 220, 1, // Opcode: XVSSRANI_WU_D
/* 20480 */   MCD::OPC_FilterValue, 1, 123, 1, 0, // Skip to: 20864
/* 20485 */   MCD::OPC_Decode, 145, 18, 221, 1, // Opcode: XVSSRANI_DU_Q
/* 20490 */   MCD::OPC_FilterValue, 218, 1, 66, 0, 0, // Skip to: 20562
/* 20496 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 20499 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 20552
/* 20504 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 20507 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 20542
/* 20512 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 20515 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 20532
/* 20520 */   MCD::OPC_CheckField, 14, 1, 1, 81, 1, 0, // Skip to: 20864
/* 20527 */   MCD::OPC_Decode, 158, 18, 219, 1, // Opcode: XVSSRARNI_B_H
/* 20532 */   MCD::OPC_FilterValue, 1, 71, 1, 0, // Skip to: 20864
/* 20537 */   MCD::OPC_Decode, 162, 18, 184, 1, // Opcode: XVSSRARNI_H_W
/* 20542 */   MCD::OPC_FilterValue, 1, 61, 1, 0, // Skip to: 20864
/* 20547 */   MCD::OPC_Decode, 164, 18, 220, 1, // Opcode: XVSSRARNI_W_D
/* 20552 */   MCD::OPC_FilterValue, 1, 51, 1, 0, // Skip to: 20864
/* 20557 */   MCD::OPC_Decode, 160, 18, 221, 1, // Opcode: XVSSRARNI_D_Q
/* 20562 */   MCD::OPC_FilterValue, 219, 1, 66, 0, 0, // Skip to: 20634
/* 20568 */   MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 20571 */   MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 20624
/* 20576 */   MCD::OPC_ExtractField, 16, 1,  // Inst{16} ...
/* 20579 */   MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 20614
/* 20584 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 20587 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 20604
/* 20592 */   MCD::OPC_CheckField, 14, 1, 1, 9, 1, 0, // Skip to: 20864
/* 20599 */   MCD::OPC_Decode, 157, 18, 219, 1, // Opcode: XVSSRARNI_BU_H
/* 20604 */   MCD::OPC_FilterValue, 1, 255, 0, 0, // Skip to: 20864
/* 20609 */   MCD::OPC_Decode, 161, 18, 184, 1, // Opcode: XVSSRARNI_HU_W
/* 20614 */   MCD::OPC_FilterValue, 1, 245, 0, 0, // Skip to: 20864
/* 20619 */   MCD::OPC_Decode, 163, 18, 220, 1, // Opcode: XVSSRARNI_WU_D
/* 20624 */   MCD::OPC_FilterValue, 1, 235, 0, 0, // Skip to: 20864
/* 20629 */   MCD::OPC_Decode, 159, 18, 221, 1, // Opcode: XVSSRARNI_DU_Q
/* 20634 */   MCD::OPC_FilterValue, 224, 1, 5, 0, 0, // Skip to: 20645
/* 20640 */   MCD::OPC_Decode, 221, 13, 222, 1, // Opcode: XVEXTRINS_D
/* 20645 */   MCD::OPC_FilterValue, 225, 1, 5, 0, 0, // Skip to: 20656
/* 20651 */   MCD::OPC_Decode, 223, 13, 223, 1, // Opcode: XVEXTRINS_W
/* 20656 */   MCD::OPC_FilterValue, 226, 1, 5, 0, 0, // Skip to: 20667
/* 20662 */   MCD::OPC_Decode, 222, 13, 224, 1, // Opcode: XVEXTRINS_H
/* 20667 */   MCD::OPC_FilterValue, 227, 1, 5, 0, 0, // Skip to: 20678
/* 20673 */   MCD::OPC_Decode, 220, 13, 225, 1, // Opcode: XVEXTRINS_B
/* 20678 */   MCD::OPC_FilterValue, 228, 1, 5, 0, 0, // Skip to: 20689
/* 20684 */   MCD::OPC_Decode, 253, 16, 226, 1, // Opcode: XVSHUF4I_B
/* 20689 */   MCD::OPC_FilterValue, 229, 1, 5, 0, 0, // Skip to: 20700
/* 20695 */   MCD::OPC_Decode, 255, 16, 227, 1, // Opcode: XVSHUF4I_H
/* 20700 */   MCD::OPC_FilterValue, 230, 1, 5, 0, 0, // Skip to: 20711
/* 20706 */   MCD::OPC_Decode, 128, 17, 228, 1, // Opcode: XVSHUF4I_W
/* 20711 */   MCD::OPC_FilterValue, 231, 1, 5, 0, 0, // Skip to: 20722
/* 20717 */   MCD::OPC_Decode, 254, 16, 222, 1, // Opcode: XVSHUF4I_D
/* 20722 */   MCD::OPC_FilterValue, 241, 1, 5, 0, 0, // Skip to: 20733
/* 20728 */   MCD::OPC_Decode, 181, 13, 225, 1, // Opcode: XVBITSELI_B
/* 20733 */   MCD::OPC_FilterValue, 244, 1, 5, 0, 0, // Skip to: 20744
/* 20739 */   MCD::OPC_Decode, 145, 13, 226, 1, // Opcode: XVANDI_B
/* 20744 */   MCD::OPC_FilterValue, 245, 1, 5, 0, 0, // Skip to: 20755
/* 20750 */   MCD::OPC_Decode, 153, 16, 226, 1, // Opcode: XVORI_B
/* 20755 */   MCD::OPC_FilterValue, 246, 1, 5, 0, 0, // Skip to: 20766
/* 20761 */   MCD::OPC_Decode, 245, 18, 226, 1, // Opcode: XVXORI_B
/* 20766 */   MCD::OPC_FilterValue, 247, 1, 5, 0, 0, // Skip to: 20777
/* 20772 */   MCD::OPC_Decode, 151, 16, 226, 1, // Opcode: XVNORI_B
/* 20777 */   MCD::OPC_FilterValue, 248, 1, 48, 0, 0, // Skip to: 20831
/* 20783 */   MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 20786 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 20796
/* 20791 */   MCD::OPC_Decode, 133, 15, 229, 1, // Opcode: XVLDI_B
/* 20796 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 20806
/* 20801 */   MCD::OPC_Decode, 135, 15, 229, 1, // Opcode: XVLDI_H
/* 20806 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 20816
/* 20811 */   MCD::OPC_Decode, 136, 15, 229, 1, // Opcode: XVLDI_W
/* 20816 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 20826
/* 20821 */   MCD::OPC_Decode, 134, 15, 229, 1, // Opcode: XVLDI_D
/* 20826 */   MCD::OPC_Decode, 132, 15, 230, 1, // Opcode: XVLDI
/* 20831 */   MCD::OPC_FilterValue, 249, 1, 5, 0, 0, // Skip to: 20842
/* 20837 */   MCD::OPC_Decode, 173, 16, 223, 1, // Opcode: XVPERMI_W
/* 20842 */   MCD::OPC_FilterValue, 250, 1, 5, 0, 0, // Skip to: 20853
/* 20848 */   MCD::OPC_Decode, 168, 16, 231, 1, // Opcode: XVPERMI_D
/* 20853 */   MCD::OPC_FilterValue, 251, 1, 5, 0, 0, // Skip to: 20864
/* 20859 */   MCD::OPC_Decode, 169, 16, 225, 1, // Opcode: XVPERMI_Q
/* 20864 */   MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableLoongArch3232[] = {
/* 0 */       MCD::OPC_ExtractField, 24, 8,  // Inst{31-24} ...
/* 3 */       MCD::OPC_FilterValue, 0, 203, 1, 0, // Skip to: 467
/* 8 */       MCD::OPC_ExtractField, 21, 3,  // Inst{23-21} ...
/* 11 */      MCD::OPC_FilterValue, 0, 249, 0, 0, // Skip to: 265
/* 16 */      MCD::OPC_ExtractField, 17, 4,  // Inst{20-17} ...
/* 19 */      MCD::OPC_FilterValue, 0, 93, 0, 0, // Skip to: 117
/* 24 */      MCD::OPC_ExtractField, 10, 7,  // Inst{16-10} ...
/* 27 */      MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 36
/* 32 */      MCD::OPC_Decode, 221, 3, 79, // Opcode: CLO_W
/* 36 */      MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 45
/* 41 */      MCD::OPC_Decode, 223, 3, 79, // Opcode: CLZ_W
/* 45 */      MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 54
/* 50 */      MCD::OPC_Decode, 240, 3, 79, // Opcode: CTO_W
/* 54 */      MCD::OPC_FilterValue, 7, 4, 0, 0, // Skip to: 63
/* 59 */      MCD::OPC_Decode, 242, 3, 79, // Opcode: CTZ_W
/* 63 */      MCD::OPC_FilterValue, 12, 4, 0, 0, // Skip to: 72
/* 68 */      MCD::OPC_Decode, 142, 6, 79, // Opcode: REVB_2H
/* 72 */      MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 81
/* 77 */      MCD::OPC_Decode, 198, 3, 79, // Opcode: BITREV_4B
/* 81 */      MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 90
/* 86 */      MCD::OPC_Decode, 201, 3, 79, // Opcode: BITREV_W
/* 90 */      MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 99
/* 95 */      MCD::OPC_Decode, 140, 6, 79, // Opcode: RDTIMEL_W32
/* 99 */      MCD::OPC_FilterValue, 25, 4, 0, 0, // Skip to: 108
/* 104 */     MCD::OPC_Decode, 138, 6, 79, // Opcode: RDTIMEH_W32
/* 108 */     MCD::OPC_FilterValue, 27, 70, 2, 0, // Skip to: 695
/* 113 */     MCD::OPC_Decode, 224, 3, 79, // Opcode: CPUCFG
/* 117 */     MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 127
/* 122 */     MCD::OPC_Decode, 140, 3, 232, 1, // Opcode: ALSL_W
/* 127 */     MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 137
/* 132 */     MCD::OPC_Decode, 217, 3, 233, 1, // Opcode: BYTEPICK_W
/* 137 */     MCD::OPC_FilterValue, 8, 23, 0, 0, // Skip to: 165
/* 142 */     MCD::OPC_ExtractField, 15, 2,  // Inst{16-15} ...
/* 145 */     MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 155
/* 150 */     MCD::OPC_Decode, 138, 3, 234, 1, // Opcode: ADD_W
/* 155 */     MCD::OPC_FilterValue, 2, 23, 2, 0, // Skip to: 695
/* 160 */     MCD::OPC_Decode, 206, 6, 234, 1, // Opcode: SUB_W
/* 165 */     MCD::OPC_FilterValue, 11, 23, 0, 0, // Skip to: 193
/* 170 */     MCD::OPC_ExtractField, 15, 2,  // Inst{16-15} ...
/* 173 */     MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 183
/* 178 */     MCD::OPC_Decode, 162, 6, 234, 1, // Opcode: SLL_W
/* 183 */     MCD::OPC_FilterValue, 3, 251, 1, 0, // Skip to: 695
/* 188 */     MCD::OPC_Decode, 179, 6, 234, 1, // Opcode: SRL_W
/* 193 */     MCD::OPC_FilterValue, 12, 12, 0, 0, // Skip to: 210
/* 198 */     MCD::OPC_CheckField, 15, 2, 0, 234, 1, 0, // Skip to: 695
/* 205 */     MCD::OPC_Decode, 175, 6, 234, 1, // Opcode: SRA_W
/* 210 */     MCD::OPC_FilterValue, 13, 12, 0, 0, // Skip to: 227
/* 215 */     MCD::OPC_CheckField, 15, 2, 2, 217, 1, 0, // Skip to: 695
/* 222 */     MCD::OPC_Decode, 153, 6, 234, 1, // Opcode: ROTR_W
/* 227 */     MCD::OPC_FilterValue, 14, 207, 1, 0, // Skip to: 695
/* 232 */     MCD::OPC_ExtractField, 15, 2,  // Inst{16-15} ...
/* 235 */     MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 245
/* 240 */     MCD::OPC_Decode, 241, 5, 234, 1, // Opcode: MUL_W
/* 245 */     MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 255
/* 250 */     MCD::OPC_Decode, 236, 5, 234, 1, // Opcode: MULH_W
/* 255 */     MCD::OPC_FilterValue, 2, 179, 1, 0, // Skip to: 695
/* 260 */     MCD::OPC_Decode, 237, 5, 234, 1, // Opcode: MULH_WU
/* 265 */     MCD::OPC_FilterValue, 1, 121, 0, 0, // Skip to: 391
/* 270 */     MCD::OPC_ExtractField, 15, 6,  // Inst{20-15} ...
/* 273 */     MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 283
/* 278 */     MCD::OPC_Decode, 247, 3, 234, 1, // Opcode: DIV_W
/* 283 */     MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 293
/* 288 */     MCD::OPC_Decode, 215, 5, 234, 1, // Opcode: MOD_W
/* 293 */     MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 303
/* 298 */     MCD::OPC_Decode, 248, 3, 234, 1, // Opcode: DIV_WU
/* 303 */     MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 313
/* 308 */     MCD::OPC_Decode, 216, 5, 234, 1, // Opcode: MOD_WU
/* 313 */     MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 323
/* 318 */     MCD::OPC_Decode, 229, 3, 234, 1, // Opcode: CRC_W_B_W
/* 323 */     MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 333
/* 328 */     MCD::OPC_Decode, 231, 3, 234, 1, // Opcode: CRC_W_H_W
/* 333 */     MCD::OPC_FilterValue, 10, 5, 0, 0, // Skip to: 343
/* 338 */     MCD::OPC_Decode, 232, 3, 234, 1, // Opcode: CRC_W_W_W
/* 343 */     MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 353
/* 348 */     MCD::OPC_Decode, 225, 3, 234, 1, // Opcode: CRCC_W_B_W
/* 353 */     MCD::OPC_FilterValue, 13, 5, 0, 0, // Skip to: 363
/* 358 */     MCD::OPC_Decode, 227, 3, 234, 1, // Opcode: CRCC_W_H_W
/* 363 */     MCD::OPC_FilterValue, 14, 5, 0, 0, // Skip to: 373
/* 368 */     MCD::OPC_Decode, 228, 3, 234, 1, // Opcode: CRCC_W_W_W
/* 373 */     MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 382
/* 378 */     MCD::OPC_Decode, 211, 3, 8, // Opcode: BREAK
/* 382 */     MCD::OPC_FilterValue, 22, 52, 1, 0, // Skip to: 695
/* 387 */     MCD::OPC_Decode, 207, 6, 8, // Opcode: SYSCALL
/* 391 */     MCD::OPC_FilterValue, 2, 43, 0, 0, // Skip to: 439
/* 396 */     MCD::OPC_ExtractField, 15, 6,  // Inst{20-15} ...
/* 399 */     MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 409
/* 404 */     MCD::OPC_Decode, 158, 6, 235, 1, // Opcode: SLLI_W
/* 409 */     MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 419
/* 414 */     MCD::OPC_Decode, 177, 6, 235, 1, // Opcode: SRLI_W
/* 419 */     MCD::OPC_FilterValue, 17, 5, 0, 0, // Skip to: 429
/* 424 */     MCD::OPC_Decode, 173, 6, 235, 1, // Opcode: SRAI_W
/* 429 */     MCD::OPC_FilterValue, 25, 5, 1, 0, // Skip to: 695
/* 434 */     MCD::OPC_Decode, 151, 6, 235, 1, // Opcode: ROTRI_W
/* 439 */     MCD::OPC_FilterValue, 3, 251, 0, 0, // Skip to: 695
/* 444 */     MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 447 */     MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 457
/* 452 */     MCD::OPC_Decode, 213, 3, 236, 1, // Opcode: BSTRINS_W
/* 457 */     MCD::OPC_FilterValue, 1, 233, 0, 0, // Skip to: 695
/* 462 */     MCD::OPC_Decode, 215, 3, 237, 1, // Opcode: BSTRPICK_W
/* 467 */     MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 484
/* 472 */     MCD::OPC_CheckField, 22, 2, 2, 216, 0, 0, // Skip to: 695
/* 479 */     MCD::OPC_Decode, 133, 3, 238, 1, // Opcode: ADDI_W
/* 484 */     MCD::OPC_FilterValue, 4, 28, 0, 0, // Skip to: 517
/* 489 */     MCD::OPC_ExtractField, 5, 5,  // Inst{9-5} ...
/* 492 */     MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 502
/* 497 */     MCD::OPC_Decode, 234, 3, 239, 1, // Opcode: CSRRD32
/* 502 */     MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 512
/* 507 */     MCD::OPC_Decode, 236, 3, 240, 1, // Opcode: CSRWR32
/* 512 */     MCD::OPC_Decode, 238, 3, 241, 1, // Opcode: CSRXCHG32
/* 517 */     MCD::OPC_FilterValue, 6, 110, 0, 0, // Skip to: 632
/* 522 */     MCD::OPC_ExtractField, 22, 2,  // Inst{23-22} ...
/* 525 */     MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 535
/* 530 */     MCD::OPC_Decode, 219, 3, 242, 1, // Opcode: CACOP32
/* 535 */     MCD::OPC_FilterValue, 1, 155, 0, 0, // Skip to: 695
/* 540 */     MCD::OPC_ExtractField, 18, 4,  // Inst{21-18} ...
/* 543 */     MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 553
/* 548 */     MCD::OPC_Decode, 154, 5, 243, 1, // Opcode: LDDIR32
/* 553 */     MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 570
/* 558 */     MCD::OPC_CheckField, 0, 5, 0, 130, 0, 0, // Skip to: 695
/* 565 */     MCD::OPC_Decode, 164, 5, 244, 1, // Opcode: LDPTE32
/* 570 */     MCD::OPC_FilterValue, 2, 120, 0, 0, // Skip to: 695
/* 575 */     MCD::OPC_ExtractField, 10, 8,  // Inst{17-10} ...
/* 578 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 587
/* 583 */     MCD::OPC_Decode, 138, 5, 79, // Opcode: IOCSRRD_B32
/* 587 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 596
/* 592 */     MCD::OPC_Decode, 141, 5, 79, // Opcode: IOCSRRD_H32
/* 596 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 605
/* 601 */     MCD::OPC_Decode, 143, 5, 79, // Opcode: IOCSRRD_W32
/* 605 */     MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 614
/* 610 */     MCD::OPC_Decode, 144, 5, 79, // Opcode: IOCSRWR_B32
/* 614 */     MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 623
/* 619 */     MCD::OPC_Decode, 146, 5, 79, // Opcode: IOCSRWR_H32
/* 623 */     MCD::OPC_FilterValue, 6, 67, 0, 0, // Skip to: 695
/* 628 */     MCD::OPC_Decode, 147, 5, 79, // Opcode: IOCSRWR_W32
/* 632 */     MCD::OPC_FilterValue, 32, 4, 0, 0, // Skip to: 641
/* 637 */     MCD::OPC_Decode, 198, 5, 59, // Opcode: LL_W
/* 641 */     MCD::OPC_FilterValue, 33, 4, 0, 0, // Skip to: 650
/* 646 */     MCD::OPC_Decode, 155, 6, 59, // Opcode: SC_W
/* 650 */     MCD::OPC_FilterValue, 42, 12, 0, 0, // Skip to: 667
/* 655 */     MCD::OPC_CheckField, 22, 2, 3, 33, 0, 0, // Skip to: 695
/* 662 */     MCD::OPC_Decode, 136, 6, 245, 1, // Opcode: PRELD_Raw32
/* 667 */     MCD::OPC_FilterValue, 56, 23, 0, 0, // Skip to: 695
/* 672 */     MCD::OPC_ExtractField, 15, 9,  // Inst{23-15} ...
/* 675 */     MCD::OPC_FilterValue, 228, 1, 4, 0, 0, // Skip to: 685
/* 681 */     MCD::OPC_Decode, 243, 3, 8, // Opcode: DBAR
/* 685 */     MCD::OPC_FilterValue, 229, 1, 4, 0, 0, // Skip to: 695
/* 691 */     MCD::OPC_Decode, 134, 5, 8, // Opcode: IBAR
/* 695 */     MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset& Bits) {
  llvm_unreachable("Invalid index!");
}

template<typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const void *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  InsnType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 2);
    if (DecodeUImmWithOffset<2, 1>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 0, 15);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 2);
    if (DecodeUImmWithOffset<2, 1>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 10, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 10, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFCSRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeFCSRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 12);
    if (DecodeSImmWithOffsetAndScale<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 12);
    if (DecodeSImmWithOffsetAndScale<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 12);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 14);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 14);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 14);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 0, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 12);
    if (DecodeSImmWithOffsetAndScale<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 40:
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 0, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 16);
    if (DecodeSImmWithOffsetAndScale<16>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 20);
    if (DecodeSImmWithOffsetAndScale<20>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 59:
    if (DecodeMemSimm14(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 60:
    if (DecodeMem(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 12);
    if (DecodeSImmWithOffsetAndScale<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 62:
    if (DecodeFMem(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 63:
    if (DecodeLSX128Mem(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 64:
    if (DecodeLASX256Mem(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 65:
    if (DecodeLSX128memlsl(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 66:
    if (DecodeLSX128memstl(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 67:
    if (DecodeLASX256memlsl(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 68:
    if (DecodeLASX256memstl(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 69:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 70:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 71:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 73:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 74:
    if (DecodeAMem(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 75:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 76:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 77:
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 0, 5) << 16;
    tmp |= fieldFromInstruction(insn, 10, 16) << 0;
    if (DecodeBranchTarget(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 78:
    tmp = fieldFromInstruction(insn, 5, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 0, 5) << 16;
    tmp |= fieldFromInstruction(insn, 10, 16) << 0;
    if (DecodeBranchTarget(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 79:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 80:
    if (DecodeJumpTarget(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 81:
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 16);
    if (DecodeBranchTarget(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 82:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 83:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 84:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 85:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 86:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 87:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 88:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 89:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 90:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 91:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 92:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 93:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 94:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 95:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 96:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 97:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 98:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 99:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 100:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 101:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeSImmWithOffsetAndScale<5>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 102:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeSImmWithOffsetAndScale<5>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 103:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeSImmWithOffsetAndScale<5>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 104:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeSImmWithOffsetAndScale<5>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 105:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 106:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 107:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 108:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 109:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 110:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 111:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 112:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 113:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 114:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 115:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 116:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 117:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 118:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 119:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 120:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 121:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 122:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 123:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 124:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 125:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 126:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 127:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 128:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 129:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 130:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 131:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 132:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 133:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 134:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 135:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 136:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 137:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 138:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 139:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 140:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 141:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 142:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 143:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 144:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 145:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 146:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 7);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 147:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 148:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 149:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 150:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 151:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 152:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 153:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLSX128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 154:
    if (DecodeLSX128Mem10(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 155:
    if (DecodeLSX128Mem13(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 156:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 157:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 158:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 159:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 160:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 161:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 162:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 163:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 164:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 165:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 166:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 167:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 168:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 169:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 170:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 171:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 172:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 173:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 174:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 175:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeSImmWithOffsetAndScale<5>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 176:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeSImmWithOffsetAndScale<5>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 177:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeSImmWithOffsetAndScale<5>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 178:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeSImmWithOffsetAndScale<5>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 179:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 180:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 181:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 182:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 183:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 184:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 185:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 186:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 187:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 188:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 189:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 190:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 191:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 192:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeFCFRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 193:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 194:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 195:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 196:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 197:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 198:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 199:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 200:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 201:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 202:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 203:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 204:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 205:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 206:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 207:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 208:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 209:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 210:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 211:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 212:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 213:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 214:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 215:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 216:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 217:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 218:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 219:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 220:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 221:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 7);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 222:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 223:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 224:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 225:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 226:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 227:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 228:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 229:
    if (DecodeLASX256Mem10(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 230:
    if (DecodeLASX256Mem13(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 231:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeLASX256DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 232:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 2);
    if (DecodeUImmWithOffset<2, 1>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 233:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 234:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 235:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 236:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 237:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 238:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 12);
    if (DecodeSImmWithOffsetAndScale<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 239:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 14);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 240:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 14);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 241:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 14);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 242:
    tmp = fieldFromInstruction(insn, 0, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 12);
    if (DecodeSImmWithOffsetAndScale<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 243:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 244:
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 245:
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 12);
    if (DecodeSImmWithOffsetAndScale<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  }
}

template<typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const void *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset& Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint32_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      ++Ptr;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      unsigned Len;
      InsnType Val = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      InsnType FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      uint32_t ExpectedValue = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      unsigned Len;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      unsigned Len;
      InsnType PositiveMask = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      InsnType NegativeMask = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      bool Fail = (insn & PositiveMask) || (~insn & NegativeMask);
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n":"PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // End llvm namespace
