/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * Mips Disassembler                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#include "llvm/MC/MCInst.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include <assert.h>

namespace llvm {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * Have a static const max_size_in_bits equal to the number of bits in the
//   encoding.
// * be default-constructible and copy-constructible
// * be constructible from a uint64_t
// * be constructible from an APInt (this can be private)
// * Support getBitsSet(loBit, hiBit)
// * be convertible to uint64_t
// * Support the ~, &, ==, !=, and |= operators with other objects of the same type
// * Support shift (<<, >>) with signed and unsigned integers on the RHS
// * Support put (<<) to raw_ostream&
template<typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static InsnType fieldFromInstruction(InsnType insn, unsigned startBit,
                                     unsigned numBits, std::true_type) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template<typename InsnType>
static InsnType fieldFromInstruction(InsnType insn, unsigned startBit,
                                     unsigned numBits, std::false_type) {
  assert(startBit + numBits <= InsnType::max_size_in_bits && "Instruction field out of bounds!");
  InsnType fieldMask = InsnType::getBitsSet(0, numBits);
  return (insn >> startBit) & fieldMask;
}

template<typename InsnType>
static InsnType fieldFromInstruction(InsnType insn, unsigned startBit,
                                     unsigned numBits) {
  return fieldFromInstruction(insn, startBit, numBits, std::is_integral<InsnType>());
}

static const uint8_t DecoderTable16[] = {
/* 0 */       MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 3 */       MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 17
/* 8 */       MCD::OPC_CheckPredicate, 0, 71, 2, 0, // Skip to: 596
/* 13 */      MCD::OPC_Decode, 238, 6, 0, // Opcode: Bimm16
/* 17 */      MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 31
/* 22 */      MCD::OPC_CheckPredicate, 0, 57, 2, 0, // Skip to: 596
/* 27 */      MCD::OPC_Decode, 236, 6, 1, // Opcode: BeqzRxImm16
/* 31 */      MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 45
/* 36 */      MCD::OPC_CheckPredicate, 0, 43, 2, 0, // Skip to: 596
/* 41 */      MCD::OPC_Decode, 240, 6, 1, // Opcode: BnezRxImm16
/* 45 */      MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 59
/* 50 */      MCD::OPC_CheckPredicate, 0, 29, 2, 0, // Skip to: 596
/* 55 */      MCD::OPC_Decode, 170, 5, 2, // Opcode: AddiuRxRxImm16
/* 59 */      MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 73
/* 64 */      MCD::OPC_CheckPredicate, 0, 15, 2, 0, // Skip to: 596
/* 69 */      MCD::OPC_Decode, 154, 21, 1, // Opcode: SltiRxImm16
/* 73 */      MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 87
/* 78 */      MCD::OPC_CheckPredicate, 0, 1, 2, 0, // Skip to: 596
/* 83 */      MCD::OPC_Decode, 156, 21, 1, // Opcode: SltiuRxImm16
/* 87 */      MCD::OPC_FilterValue, 12, 73, 0, 0, // Skip to: 165
/* 92 */      MCD::OPC_ExtractField, 8, 3,  // Inst{10-8} ...
/* 95 */      MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 109
/* 100 */     MCD::OPC_CheckPredicate, 0, 235, 1, 0, // Skip to: 596
/* 105 */     MCD::OPC_Decode, 243, 6, 0, // Opcode: Bteqz16
/* 109 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 123
/* 114 */     MCD::OPC_CheckPredicate, 0, 221, 1, 0, // Skip to: 596
/* 119 */     MCD::OPC_Decode, 245, 6, 0, // Opcode: Btnez16
/* 123 */     MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 137
/* 128 */     MCD::OPC_CheckPredicate, 0, 207, 1, 0, // Skip to: 596
/* 133 */     MCD::OPC_Decode, 173, 5, 0, // Opcode: AddiuSpImm16
/* 137 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 151
/* 142 */     MCD::OPC_CheckPredicate, 0, 193, 1, 0, // Skip to: 596
/* 147 */     MCD::OPC_Decode, 213, 16, 3, // Opcode: Move32R16
/* 151 */     MCD::OPC_FilterValue, 7, 184, 1, 0, // Skip to: 596
/* 156 */     MCD::OPC_CheckPredicate, 0, 179, 1, 0, // Skip to: 596
/* 161 */     MCD::OPC_Decode, 214, 16, 4, // Opcode: MoveR3216
/* 165 */     MCD::OPC_FilterValue, 13, 9, 0, 0, // Skip to: 179
/* 170 */     MCD::OPC_CheckPredicate, 0, 165, 1, 0, // Skip to: 596
/* 175 */     MCD::OPC_Decode, 168, 14, 1, // Opcode: LiRxImm16
/* 179 */     MCD::OPC_FilterValue, 14, 9, 0, 0, // Skip to: 193
/* 184 */     MCD::OPC_CheckPredicate, 0, 151, 1, 0, // Skip to: 596
/* 189 */     MCD::OPC_Decode, 181, 9, 1, // Opcode: CmpiRxImm16
/* 193 */     MCD::OPC_FilterValue, 22, 9, 0, 0, // Skip to: 207
/* 198 */     MCD::OPC_CheckPredicate, 0, 137, 1, 0, // Skip to: 596
/* 203 */     MCD::OPC_Decode, 171, 14, 1, // Opcode: LwRxPcTcp16
/* 207 */     MCD::OPC_FilterValue, 28, 31, 0, 0, // Skip to: 243
/* 212 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 215 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 229
/* 220 */     MCD::OPC_CheckPredicate, 0, 115, 1, 0, // Skip to: 596
/* 225 */     MCD::OPC_Decode, 175, 5, 5, // Opcode: AdduRxRyRz16
/* 229 */     MCD::OPC_FilterValue, 3, 106, 1, 0, // Skip to: 596
/* 234 */     MCD::OPC_CheckPredicate, 0, 101, 1, 0, // Skip to: 596
/* 239 */     MCD::OPC_Decode, 163, 21, 5, // Opcode: SubuRxRyRz16
/* 243 */     MCD::OPC_FilterValue, 29, 92, 1, 0, // Skip to: 596
/* 248 */     MCD::OPC_ExtractField, 0, 5,  // Inst{4-0} ...
/* 251 */     MCD::OPC_FilterValue, 0, 73, 0, 0, // Skip to: 329
/* 256 */     MCD::OPC_ExtractField, 5, 3,  // Inst{7-5} ...
/* 259 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 273
/* 264 */     MCD::OPC_CheckPredicate, 0, 71, 1, 0, // Skip to: 596
/* 269 */     MCD::OPC_Decode, 175, 13, 0, // Opcode: JumpLinkReg16
/* 273 */     MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 294
/* 278 */     MCD::OPC_CheckPredicate, 0, 57, 1, 0, // Skip to: 596
/* 283 */     MCD::OPC_CheckField, 8, 3, 0, 50, 1, 0, // Skip to: 596
/* 290 */     MCD::OPC_Decode, 172, 13, 0, // Opcode: JrRa16
/* 294 */     MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 308
/* 299 */     MCD::OPC_CheckPredicate, 0, 36, 1, 0, // Skip to: 596
/* 304 */     MCD::OPC_Decode, 174, 13, 1, // Opcode: JrcRx16
/* 308 */     MCD::OPC_FilterValue, 7, 27, 1, 0, // Skip to: 596
/* 313 */     MCD::OPC_CheckPredicate, 0, 22, 1, 0, // Skip to: 596
/* 318 */     MCD::OPC_CheckField, 8, 3, 0, 15, 1, 0, // Skip to: 596
/* 325 */     MCD::OPC_Decode, 173, 13, 0, // Opcode: JrcRa16
/* 329 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 343
/* 334 */     MCD::OPC_CheckPredicate, 0, 1, 1, 0, // Skip to: 596
/* 339 */     MCD::OPC_Decode, 153, 21, 6, // Opcode: SltRxRy16
/* 343 */     MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 357
/* 348 */     MCD::OPC_CheckPredicate, 0, 243, 0, 0, // Skip to: 596
/* 353 */     MCD::OPC_Decode, 158, 21, 6, // Opcode: SltuRxRy16
/* 357 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 371
/* 362 */     MCD::OPC_CheckPredicate, 0, 229, 0, 0, // Skip to: 596
/* 367 */     MCD::OPC_Decode, 152, 21, 7, // Opcode: SllvRxRy16
/* 371 */     MCD::OPC_FilterValue, 5, 16, 0, 0, // Skip to: 392
/* 376 */     MCD::OPC_CheckPredicate, 0, 215, 0, 0, // Skip to: 596
/* 381 */     MCD::OPC_CheckField, 5, 6, 0, 208, 0, 0, // Skip to: 596
/* 388 */     MCD::OPC_Decode, 242, 6, 0, // Opcode: Break16
/* 392 */     MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 406
/* 397 */     MCD::OPC_CheckPredicate, 0, 194, 0, 0, // Skip to: 596
/* 402 */     MCD::OPC_Decode, 162, 21, 7, // Opcode: SrlvRxRy16
/* 406 */     MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 420
/* 411 */     MCD::OPC_CheckPredicate, 0, 180, 0, 0, // Skip to: 596
/* 416 */     MCD::OPC_Decode, 160, 21, 7, // Opcode: SravRxRy16
/* 420 */     MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 434
/* 425 */     MCD::OPC_CheckPredicate, 0, 166, 0, 0, // Skip to: 596
/* 430 */     MCD::OPC_Decode, 180, 9, 6, // Opcode: CmpRxRy16
/* 434 */     MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 448
/* 439 */     MCD::OPC_CheckPredicate, 0, 152, 0, 0, // Skip to: 596
/* 444 */     MCD::OPC_Decode, 176, 5, 7, // Opcode: AndRxRxRy16
/* 448 */     MCD::OPC_FilterValue, 13, 9, 0, 0, // Skip to: 462
/* 453 */     MCD::OPC_CheckPredicate, 0, 138, 0, 0, // Skip to: 596
/* 458 */     MCD::OPC_Decode, 255, 16, 7, // Opcode: OrRxRxRy16
/* 462 */     MCD::OPC_FilterValue, 14, 9, 0, 0, // Skip to: 476
/* 467 */     MCD::OPC_CheckPredicate, 0, 124, 0, 0, // Skip to: 596
/* 472 */     MCD::OPC_Decode, 255, 21, 7, // Opcode: XorRxRxRy16
/* 476 */     MCD::OPC_FilterValue, 15, 9, 0, 0, // Skip to: 490
/* 481 */     MCD::OPC_CheckPredicate, 0, 110, 0, 0, // Skip to: 596
/* 486 */     MCD::OPC_Decode, 242, 16, 6, // Opcode: NotRxRy16
/* 490 */     MCD::OPC_FilterValue, 16, 9, 0, 0, // Skip to: 504
/* 495 */     MCD::OPC_CheckPredicate, 0, 96, 0, 0, // Skip to: 596
/* 500 */     MCD::OPC_Decode, 211, 16, 1, // Opcode: Mfhi16
/* 504 */     MCD::OPC_FilterValue, 17, 31, 0, 0, // Skip to: 540
/* 509 */     MCD::OPC_ExtractField, 5, 3,  // Inst{7-5} ...
/* 512 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 526
/* 517 */     MCD::OPC_CheckPredicate, 0, 74, 0, 0, // Skip to: 596
/* 522 */     MCD::OPC_Decode, 148, 21, 2, // Opcode: SebRx16
/* 526 */     MCD::OPC_FilterValue, 5, 65, 0, 0, // Skip to: 596
/* 531 */     MCD::OPC_CheckPredicate, 0, 60, 0, 0, // Skip to: 596
/* 536 */     MCD::OPC_Decode, 149, 21, 2, // Opcode: SehRx16
/* 540 */     MCD::OPC_FilterValue, 18, 9, 0, 0, // Skip to: 554
/* 545 */     MCD::OPC_CheckPredicate, 0, 46, 0, 0, // Skip to: 596
/* 550 */     MCD::OPC_Decode, 212, 16, 1, // Opcode: Mflo16
/* 554 */     MCD::OPC_FilterValue, 26, 9, 0, 0, // Skip to: 568
/* 559 */     MCD::OPC_CheckPredicate, 0, 32, 0, 0, // Skip to: 596
/* 564 */     MCD::OPC_Decode, 192, 10, 6, // Opcode: DivRxRy16
/* 568 */     MCD::OPC_FilterValue, 27, 9, 0, 0, // Skip to: 582
/* 573 */     MCD::OPC_CheckPredicate, 0, 18, 0, 0, // Skip to: 596
/* 578 */     MCD::OPC_Decode, 193, 10, 6, // Opcode: DivuRxRy16
/* 582 */     MCD::OPC_FilterValue, 29, 9, 0, 0, // Skip to: 596
/* 587 */     MCD::OPC_CheckPredicate, 0, 4, 0, 0, // Skip to: 596
/* 592 */     MCD::OPC_Decode, 241, 16, 6, // Opcode: NegRxRy16
/* 596 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTable32[] = {
/* 0 */       MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 3 */       MCD::OPC_FilterValue, 1, 23, 0, 0, // Skip to: 31
/* 8 */       MCD::OPC_CheckPredicate, 0, 2, 2, 0, // Skip to: 527
/* 13 */      MCD::OPC_CheckField, 27, 5, 30, 251, 1, 0, // Skip to: 527
/* 20 */      MCD::OPC_CheckField, 5, 3, 0, 244, 1, 0, // Skip to: 527
/* 27 */      MCD::OPC_Decode, 169, 5, 1, // Opcode: AddiuRxPcImmX16
/* 31 */      MCD::OPC_FilterValue, 2, 23, 0, 0, // Skip to: 59
/* 36 */      MCD::OPC_CheckPredicate, 0, 230, 1, 0, // Skip to: 527
/* 41 */      MCD::OPC_CheckField, 27, 5, 30, 223, 1, 0, // Skip to: 527
/* 48 */      MCD::OPC_CheckField, 5, 6, 0, 216, 1, 0, // Skip to: 527
/* 55 */      MCD::OPC_Decode, 239, 6, 8, // Opcode: BimmX16
/* 59 */      MCD::OPC_FilterValue, 4, 23, 0, 0, // Skip to: 87
/* 64 */      MCD::OPC_CheckPredicate, 0, 202, 1, 0, // Skip to: 527
/* 69 */      MCD::OPC_CheckField, 27, 5, 30, 195, 1, 0, // Skip to: 527
/* 76 */      MCD::OPC_CheckField, 5, 3, 0, 188, 1, 0, // Skip to: 527
/* 83 */      MCD::OPC_Decode, 237, 6, 1, // Opcode: BeqzRxImmX16
/* 87 */      MCD::OPC_FilterValue, 5, 23, 0, 0, // Skip to: 115
/* 92 */      MCD::OPC_CheckPredicate, 0, 174, 1, 0, // Skip to: 527
/* 97 */      MCD::OPC_CheckField, 27, 5, 30, 167, 1, 0, // Skip to: 527
/* 104 */     MCD::OPC_CheckField, 5, 3, 0, 160, 1, 0, // Skip to: 527
/* 111 */     MCD::OPC_Decode, 241, 6, 1, // Opcode: BnezRxImmX16
/* 115 */     MCD::OPC_FilterValue, 6, 106, 0, 0, // Skip to: 226
/* 120 */     MCD::OPC_ExtractField, 27, 5,  // Inst{31-27} ...
/* 123 */     MCD::OPC_FilterValue, 30, 143, 1, 0, // Skip to: 527
/* 128 */     MCD::OPC_ExtractField, 16, 5,  // Inst{20-16} ...
/* 131 */     MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 181
/* 136 */     MCD::OPC_ExtractField, 0, 5,  // Inst{4-0} ...
/* 139 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 153
/* 144 */     MCD::OPC_CheckPredicate, 0, 32, 0, 0, // Skip to: 181
/* 149 */     MCD::OPC_Decode, 151, 21, 6, // Opcode: SllX16
/* 153 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 167
/* 158 */     MCD::OPC_CheckPredicate, 0, 18, 0, 0, // Skip to: 181
/* 163 */     MCD::OPC_Decode, 161, 21, 6, // Opcode: SrlX16
/* 167 */     MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 181
/* 172 */     MCD::OPC_CheckPredicate, 0, 4, 0, 0, // Skip to: 181
/* 177 */     MCD::OPC_Decode, 159, 21, 6, // Opcode: SraX16
/* 181 */     MCD::OPC_ExtractField, 5, 6,  // Inst{10-5} ...
/* 184 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 198
/* 189 */     MCD::OPC_CheckPredicate, 0, 77, 1, 0, // Skip to: 527
/* 194 */     MCD::OPC_Decode, 244, 6, 0, // Opcode: BteqzX16
/* 198 */     MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 212
/* 203 */     MCD::OPC_CheckPredicate, 0, 63, 1, 0, // Skip to: 527
/* 208 */     MCD::OPC_Decode, 246, 6, 0, // Opcode: BtnezX16
/* 212 */     MCD::OPC_FilterValue, 24, 54, 1, 0, // Skip to: 527
/* 217 */     MCD::OPC_CheckPredicate, 0, 49, 1, 0, // Skip to: 527
/* 222 */     MCD::OPC_Decode, 174, 5, 0, // Opcode: AddiuSpImmX16
/* 226 */     MCD::OPC_FilterValue, 8, 23, 0, 0, // Skip to: 254
/* 231 */     MCD::OPC_CheckPredicate, 0, 35, 1, 0, // Skip to: 527
/* 236 */     MCD::OPC_CheckField, 27, 5, 30, 28, 1, 0, // Skip to: 527
/* 243 */     MCD::OPC_CheckField, 4, 1, 0, 21, 1, 0, // Skip to: 527
/* 250 */     MCD::OPC_Decode, 172, 5, 9, // Opcode: AddiuRxRyOffMemX16
/* 254 */     MCD::OPC_FilterValue, 9, 23, 0, 0, // Skip to: 282
/* 259 */     MCD::OPC_CheckPredicate, 0, 7, 1, 0, // Skip to: 527
/* 264 */     MCD::OPC_CheckField, 27, 5, 30, 0, 1, 0, // Skip to: 527
/* 271 */     MCD::OPC_CheckField, 5, 3, 0, 249, 0, 0, // Skip to: 527
/* 278 */     MCD::OPC_Decode, 168, 5, 1, // Opcode: AddiuRxImmX16
/* 282 */     MCD::OPC_FilterValue, 10, 23, 0, 0, // Skip to: 310
/* 287 */     MCD::OPC_CheckPredicate, 0, 235, 0, 0, // Skip to: 527
/* 292 */     MCD::OPC_CheckField, 27, 5, 30, 228, 0, 0, // Skip to: 527
/* 299 */     MCD::OPC_CheckField, 5, 3, 0, 221, 0, 0, // Skip to: 527
/* 306 */     MCD::OPC_Decode, 155, 21, 1, // Opcode: SltiRxImmX16
/* 310 */     MCD::OPC_FilterValue, 11, 23, 0, 0, // Skip to: 338
/* 315 */     MCD::OPC_CheckPredicate, 0, 207, 0, 0, // Skip to: 527
/* 320 */     MCD::OPC_CheckField, 27, 5, 30, 200, 0, 0, // Skip to: 527
/* 327 */     MCD::OPC_CheckField, 5, 3, 0, 193, 0, 0, // Skip to: 527
/* 334 */     MCD::OPC_Decode, 157, 21, 1, // Opcode: SltiuRxImmX16
/* 338 */     MCD::OPC_FilterValue, 13, 23, 0, 0, // Skip to: 366
/* 343 */     MCD::OPC_CheckPredicate, 0, 179, 0, 0, // Skip to: 527
/* 348 */     MCD::OPC_CheckField, 27, 5, 30, 172, 0, 0, // Skip to: 527
/* 355 */     MCD::OPC_CheckField, 5, 3, 0, 165, 0, 0, // Skip to: 527
/* 362 */     MCD::OPC_Decode, 170, 14, 1, // Opcode: LiRxImmX16
/* 366 */     MCD::OPC_FilterValue, 14, 23, 0, 0, // Skip to: 394
/* 371 */     MCD::OPC_CheckPredicate, 0, 151, 0, 0, // Skip to: 527
/* 376 */     MCD::OPC_CheckField, 27, 5, 30, 144, 0, 0, // Skip to: 527
/* 383 */     MCD::OPC_CheckField, 5, 3, 0, 137, 0, 0, // Skip to: 527
/* 390 */     MCD::OPC_Decode, 182, 9, 1, // Opcode: CmpiRxImmX16
/* 394 */     MCD::OPC_FilterValue, 18, 16, 0, 0, // Skip to: 415
/* 399 */     MCD::OPC_CheckPredicate, 0, 123, 0, 0, // Skip to: 527
/* 404 */     MCD::OPC_CheckField, 27, 5, 30, 116, 0, 0, // Skip to: 527
/* 411 */     MCD::OPC_Decode, 174, 14, 9, // Opcode: LwRxSpImmX16
/* 415 */     MCD::OPC_FilterValue, 22, 23, 0, 0, // Skip to: 443
/* 420 */     MCD::OPC_CheckPredicate, 0, 102, 0, 0, // Skip to: 527
/* 425 */     MCD::OPC_CheckField, 27, 5, 30, 95, 0, 0, // Skip to: 527
/* 432 */     MCD::OPC_CheckField, 5, 3, 0, 88, 0, 0, // Skip to: 527
/* 439 */     MCD::OPC_Decode, 172, 14, 1, // Opcode: LwRxPcTcpX16
/* 443 */     MCD::OPC_FilterValue, 24, 16, 0, 0, // Skip to: 464
/* 448 */     MCD::OPC_CheckPredicate, 0, 74, 0, 0, // Skip to: 527
/* 453 */     MCD::OPC_CheckField, 27, 5, 30, 67, 0, 0, // Skip to: 527
/* 460 */     MCD::OPC_Decode, 147, 21, 9, // Opcode: SbRxRyOffMemX16
/* 464 */     MCD::OPC_FilterValue, 25, 16, 0, 0, // Skip to: 485
/* 469 */     MCD::OPC_CheckPredicate, 0, 53, 0, 0, // Skip to: 527
/* 474 */     MCD::OPC_CheckField, 27, 5, 30, 46, 0, 0, // Skip to: 527
/* 481 */     MCD::OPC_Decode, 150, 21, 9, // Opcode: ShRxRyOffMemX16
/* 485 */     MCD::OPC_FilterValue, 26, 16, 0, 0, // Skip to: 506
/* 490 */     MCD::OPC_CheckPredicate, 0, 32, 0, 0, // Skip to: 527
/* 495 */     MCD::OPC_CheckField, 27, 5, 30, 25, 0, 0, // Skip to: 527
/* 502 */     MCD::OPC_Decode, 165, 21, 9, // Opcode: SwRxSpImmX16
/* 506 */     MCD::OPC_FilterValue, 27, 16, 0, 0, // Skip to: 527
/* 511 */     MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 527
/* 516 */     MCD::OPC_CheckField, 27, 5, 30, 4, 0, 0, // Skip to: 527
/* 523 */     MCD::OPC_Decode, 164, 21, 9, // Opcode: SwRxRyOffMemX16
/* 527 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableCOP3_32[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 51, 9, 0, 0, // Skip to: 17
/* 8 */       MCD::OPC_CheckPredicate, 1, 46, 0, 0, // Skip to: 59
/* 13 */      MCD::OPC_Decode, 131, 14, 10, // Opcode: LWC3
/* 17 */      MCD::OPC_FilterValue, 55, 9, 0, 0, // Skip to: 31
/* 22 */      MCD::OPC_CheckPredicate, 2, 32, 0, 0, // Skip to: 59
/* 27 */      MCD::OPC_Decode, 199, 13, 10, // Opcode: LDC3
/* 31 */      MCD::OPC_FilterValue, 59, 9, 0, 0, // Skip to: 45
/* 36 */      MCD::OPC_CheckPredicate, 1, 18, 0, 0, // Skip to: 59
/* 41 */      MCD::OPC_Decode, 240, 20, 10, // Opcode: SWC3
/* 45 */      MCD::OPC_FilterValue, 63, 9, 0, 0, // Skip to: 59
/* 50 */      MCD::OPC_CheckPredicate, 2, 4, 0, 0, // Skip to: 59
/* 55 */      MCD::OPC_Decode, 221, 18, 10, // Opcode: SDC3
/* 59 */      MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableCnMips32[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 18, 31, 0, 0, // Skip to: 39
/* 8 */       MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 11 */      MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 25
/* 16 */      MCD::OPC_CheckPredicate, 3, 239, 1, 0, // Skip to: 516
/* 21 */      MCD::OPC_Decode, 230, 9, 11, // Opcode: DMFC2_OCTEON
/* 25 */      MCD::OPC_FilterValue, 5, 230, 1, 0, // Skip to: 516
/* 30 */      MCD::OPC_CheckPredicate, 3, 225, 1, 0, // Skip to: 516
/* 35 */      MCD::OPC_Decode, 238, 9, 11, // Opcode: DMTC2_OCTEON
/* 39 */      MCD::OPC_FilterValue, 28, 160, 1, 0, // Skip to: 460
/* 44 */      MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 47 */      MCD::OPC_FilterValue, 3, 16, 0, 0, // Skip to: 68
/* 52 */      MCD::OPC_CheckPredicate, 3, 203, 1, 0, // Skip to: 516
/* 57 */      MCD::OPC_CheckField, 6, 5, 0, 196, 1, 0, // Skip to: 516
/* 64 */      MCD::OPC_Decode, 242, 9, 12, // Opcode: DMUL
/* 68 */      MCD::OPC_FilterValue, 8, 16, 0, 0, // Skip to: 89
/* 73 */      MCD::OPC_CheckPredicate, 3, 182, 1, 0, // Skip to: 516
/* 78 */      MCD::OPC_CheckField, 6, 15, 0, 175, 1, 0, // Skip to: 516
/* 85 */      MCD::OPC_Decode, 154, 16, 13, // Opcode: MTM0
/* 89 */      MCD::OPC_FilterValue, 9, 16, 0, 0, // Skip to: 110
/* 94 */      MCD::OPC_CheckPredicate, 3, 161, 1, 0, // Skip to: 516
/* 99 */      MCD::OPC_CheckField, 6, 15, 0, 154, 1, 0, // Skip to: 516
/* 106 */     MCD::OPC_Decode, 157, 16, 13, // Opcode: MTP0
/* 110 */     MCD::OPC_FilterValue, 10, 16, 0, 0, // Skip to: 131
/* 115 */     MCD::OPC_CheckPredicate, 3, 140, 1, 0, // Skip to: 516
/* 120 */     MCD::OPC_CheckField, 6, 15, 0, 133, 1, 0, // Skip to: 516
/* 127 */     MCD::OPC_Decode, 158, 16, 13, // Opcode: MTP1
/* 131 */     MCD::OPC_FilterValue, 11, 16, 0, 0, // Skip to: 152
/* 136 */     MCD::OPC_CheckPredicate, 3, 119, 1, 0, // Skip to: 516
/* 141 */     MCD::OPC_CheckField, 6, 15, 0, 112, 1, 0, // Skip to: 516
/* 148 */     MCD::OPC_Decode, 159, 16, 13, // Opcode: MTP2
/* 152 */     MCD::OPC_FilterValue, 12, 16, 0, 0, // Skip to: 173
/* 157 */     MCD::OPC_CheckPredicate, 3, 98, 1, 0, // Skip to: 516
/* 162 */     MCD::OPC_CheckField, 6, 15, 0, 91, 1, 0, // Skip to: 516
/* 169 */     MCD::OPC_Decode, 155, 16, 13, // Opcode: MTM1
/* 173 */     MCD::OPC_FilterValue, 13, 16, 0, 0, // Skip to: 194
/* 178 */     MCD::OPC_CheckPredicate, 3, 77, 1, 0, // Skip to: 516
/* 183 */     MCD::OPC_CheckField, 6, 15, 0, 70, 1, 0, // Skip to: 516
/* 190 */     MCD::OPC_Decode, 156, 16, 13, // Opcode: MTM2
/* 194 */     MCD::OPC_FilterValue, 15, 16, 0, 0, // Skip to: 215
/* 199 */     MCD::OPC_CheckPredicate, 3, 56, 1, 0, // Skip to: 516
/* 204 */     MCD::OPC_CheckField, 6, 5, 0, 49, 1, 0, // Skip to: 516
/* 211 */     MCD::OPC_Decode, 229, 21, 12, // Opcode: VMULU
/* 215 */     MCD::OPC_FilterValue, 16, 16, 0, 0, // Skip to: 236
/* 220 */     MCD::OPC_CheckPredicate, 3, 35, 1, 0, // Skip to: 516
/* 225 */     MCD::OPC_CheckField, 6, 5, 0, 28, 1, 0, // Skip to: 516
/* 232 */     MCD::OPC_Decode, 228, 21, 12, // Opcode: VMM0
/* 236 */     MCD::OPC_FilterValue, 17, 16, 0, 0, // Skip to: 257
/* 241 */     MCD::OPC_CheckPredicate, 3, 14, 1, 0, // Skip to: 516
/* 246 */     MCD::OPC_CheckField, 6, 5, 0, 7, 1, 0, // Skip to: 516
/* 253 */     MCD::OPC_Decode, 227, 21, 12, // Opcode: V3MULU
/* 257 */     MCD::OPC_FilterValue, 40, 16, 0, 0, // Skip to: 278
/* 262 */     MCD::OPC_CheckPredicate, 3, 249, 0, 0, // Skip to: 516
/* 267 */     MCD::OPC_CheckField, 6, 5, 0, 242, 0, 0, // Skip to: 516
/* 274 */     MCD::OPC_Decode, 178, 5, 12, // Opcode: BADDu
/* 278 */     MCD::OPC_FilterValue, 42, 16, 0, 0, // Skip to: 299
/* 283 */     MCD::OPC_CheckPredicate, 3, 228, 0, 0, // Skip to: 516
/* 288 */     MCD::OPC_CheckField, 6, 5, 0, 221, 0, 0, // Skip to: 516
/* 295 */     MCD::OPC_Decode, 252, 18, 12, // Opcode: SEQ
/* 299 */     MCD::OPC_FilterValue, 43, 16, 0, 0, // Skip to: 320
/* 304 */     MCD::OPC_CheckPredicate, 3, 207, 0, 0, // Skip to: 516
/* 309 */     MCD::OPC_CheckField, 6, 5, 0, 200, 0, 0, // Skip to: 516
/* 316 */     MCD::OPC_Decode, 224, 19, 12, // Opcode: SNE
/* 320 */     MCD::OPC_FilterValue, 44, 23, 0, 0, // Skip to: 348
/* 325 */     MCD::OPC_CheckPredicate, 3, 186, 0, 0, // Skip to: 516
/* 330 */     MCD::OPC_CheckField, 16, 5, 0, 179, 0, 0, // Skip to: 516
/* 337 */     MCD::OPC_CheckField, 6, 5, 0, 172, 0, 0, // Skip to: 516
/* 344 */     MCD::OPC_Decode, 189, 17, 14, // Opcode: POP
/* 348 */     MCD::OPC_FilterValue, 45, 23, 0, 0, // Skip to: 376
/* 353 */     MCD::OPC_CheckPredicate, 3, 158, 0, 0, // Skip to: 516
/* 358 */     MCD::OPC_CheckField, 16, 5, 0, 151, 0, 0, // Skip to: 516
/* 365 */     MCD::OPC_CheckField, 6, 5, 0, 144, 0, 0, // Skip to: 516
/* 372 */     MCD::OPC_Decode, 147, 10, 15, // Opcode: DPOP
/* 376 */     MCD::OPC_FilterValue, 46, 9, 0, 0, // Skip to: 390
/* 381 */     MCD::OPC_CheckPredicate, 3, 130, 0, 0, // Skip to: 516
/* 386 */     MCD::OPC_Decode, 253, 18, 16, // Opcode: SEQi
/* 390 */     MCD::OPC_FilterValue, 47, 9, 0, 0, // Skip to: 404
/* 395 */     MCD::OPC_CheckPredicate, 3, 116, 0, 0, // Skip to: 516
/* 400 */     MCD::OPC_Decode, 225, 19, 16, // Opcode: SNEi
/* 404 */     MCD::OPC_FilterValue, 50, 9, 0, 0, // Skip to: 418
/* 409 */     MCD::OPC_CheckPredicate, 4, 102, 0, 0, // Skip to: 516
/* 414 */     MCD::OPC_Decode, 148, 7, 17, // Opcode: CINS
/* 418 */     MCD::OPC_FilterValue, 51, 9, 0, 0, // Skip to: 432
/* 423 */     MCD::OPC_CheckPredicate, 4, 88, 0, 0, // Skip to: 516
/* 428 */     MCD::OPC_Decode, 149, 7, 17, // Opcode: CINS32
/* 432 */     MCD::OPC_FilterValue, 58, 9, 0, 0, // Skip to: 446
/* 437 */     MCD::OPC_CheckPredicate, 4, 74, 0, 0, // Skip to: 516
/* 442 */     MCD::OPC_Decode, 234, 10, 17, // Opcode: EXTS
/* 446 */     MCD::OPC_FilterValue, 59, 65, 0, 0, // Skip to: 516
/* 451 */     MCD::OPC_CheckPredicate, 4, 60, 0, 0, // Skip to: 516
/* 456 */     MCD::OPC_Decode, 235, 10, 17, // Opcode: EXTS32
/* 460 */     MCD::OPC_FilterValue, 50, 9, 0, 0, // Skip to: 474
/* 465 */     MCD::OPC_CheckPredicate, 3, 46, 0, 0, // Skip to: 516
/* 470 */     MCD::OPC_Decode, 184, 5, 18, // Opcode: BBIT0
/* 474 */     MCD::OPC_FilterValue, 54, 9, 0, 0, // Skip to: 488
/* 479 */     MCD::OPC_CheckPredicate, 3, 32, 0, 0, // Skip to: 516
/* 484 */     MCD::OPC_Decode, 185, 5, 18, // Opcode: BBIT032
/* 488 */     MCD::OPC_FilterValue, 58, 9, 0, 0, // Skip to: 502
/* 493 */     MCD::OPC_CheckPredicate, 3, 18, 0, 0, // Skip to: 516
/* 498 */     MCD::OPC_Decode, 186, 5, 18, // Opcode: BBIT1
/* 502 */     MCD::OPC_FilterValue, 62, 9, 0, 0, // Skip to: 516
/* 507 */     MCD::OPC_CheckPredicate, 3, 4, 0, 0, // Skip to: 516
/* 512 */     MCD::OPC_Decode, 187, 5, 18, // Opcode: BBIT132
/* 516 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMicroMips16[] = {
/* 0 */       MCD::OPC_ExtractField, 10, 6,  // Inst{15-10} ...
/* 3 */       MCD::OPC_FilterValue, 1, 31, 0, 0, // Skip to: 39
/* 8 */       MCD::OPC_ExtractField, 0, 1,  // Inst{0} ...
/* 11 */      MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 25
/* 16 */      MCD::OPC_CheckPredicate, 5, 114, 2, 0, // Skip to: 647
/* 21 */      MCD::OPC_Decode, 211, 4, 19, // Opcode: ADDU16_MM
/* 25 */      MCD::OPC_FilterValue, 1, 105, 2, 0, // Skip to: 647
/* 30 */      MCD::OPC_CheckPredicate, 5, 100, 2, 0, // Skip to: 647
/* 35 */      MCD::OPC_Decode, 201, 20, 19, // Opcode: SUBU16_MM
/* 39 */      MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 53
/* 44 */      MCD::OPC_CheckPredicate, 6, 86, 2, 0, // Skip to: 647
/* 49 */      MCD::OPC_Decode, 180, 13, 20, // Opcode: LBU16_MM
/* 53 */      MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 67
/* 58 */      MCD::OPC_CheckPredicate, 5, 72, 2, 0, // Skip to: 647
/* 63 */      MCD::OPC_Decode, 181, 15, 21, // Opcode: MOVE16_MM
/* 67 */      MCD::OPC_FilterValue, 9, 31, 0, 0, // Skip to: 103
/* 72 */      MCD::OPC_ExtractField, 0, 1,  // Inst{0} ...
/* 75 */      MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 89
/* 80 */      MCD::OPC_CheckPredicate, 5, 50, 2, 0, // Skip to: 647
/* 85 */      MCD::OPC_Decode, 196, 19, 22, // Opcode: SLL16_MM
/* 89 */      MCD::OPC_FilterValue, 1, 41, 2, 0, // Skip to: 647
/* 94 */      MCD::OPC_CheckPredicate, 5, 36, 2, 0, // Skip to: 647
/* 99 */      MCD::OPC_Decode, 255, 19, 22, // Opcode: SRL16_MM
/* 103 */     MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 117
/* 108 */     MCD::OPC_CheckPredicate, 6, 22, 2, 0, // Skip to: 647
/* 113 */     MCD::OPC_Decode, 220, 13, 20, // Opcode: LHU16_MM
/* 117 */     MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 131
/* 122 */     MCD::OPC_CheckPredicate, 5, 8, 2, 0, // Skip to: 647
/* 127 */     MCD::OPC_Decode, 128, 5, 23, // Opcode: ANDI16_MM
/* 131 */     MCD::OPC_FilterValue, 17, 8, 1, 0, // Skip to: 400
/* 136 */     MCD::OPC_ExtractField, 6, 4,  // Inst{9-6} ...
/* 139 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 153
/* 144 */     MCD::OPC_CheckPredicate, 5, 242, 1, 0, // Skip to: 647
/* 149 */     MCD::OPC_Decode, 239, 16, 24, // Opcode: NOT16_MM
/* 153 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 167
/* 158 */     MCD::OPC_CheckPredicate, 5, 228, 1, 0, // Skip to: 647
/* 163 */     MCD::OPC_Decode, 244, 21, 25, // Opcode: XOR16_MM
/* 167 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 181
/* 172 */     MCD::OPC_CheckPredicate, 5, 214, 1, 0, // Skip to: 647
/* 177 */     MCD::OPC_Decode, 253, 4, 25, // Opcode: AND16_MM
/* 181 */     MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 195
/* 186 */     MCD::OPC_CheckPredicate, 5, 200, 1, 0, // Skip to: 647
/* 191 */     MCD::OPC_Decode, 244, 16, 25, // Opcode: OR16_MM
/* 195 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 209
/* 200 */     MCD::OPC_CheckPredicate, 5, 186, 1, 0, // Skip to: 647
/* 205 */     MCD::OPC_Decode, 142, 14, 26, // Opcode: LWM16_MM
/* 209 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 223
/* 214 */     MCD::OPC_CheckPredicate, 5, 172, 1, 0, // Skip to: 647
/* 219 */     MCD::OPC_Decode, 250, 20, 26, // Opcode: SWM16_MM
/* 223 */     MCD::OPC_FilterValue, 6, 31, 0, 0, // Skip to: 259
/* 228 */     MCD::OPC_ExtractField, 5, 1,  // Inst{5} ...
/* 231 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 245
/* 236 */     MCD::OPC_CheckPredicate, 5, 150, 1, 0, // Skip to: 647
/* 241 */     MCD::OPC_Decode, 158, 13, 27, // Opcode: JR16_MM
/* 245 */     MCD::OPC_FilterValue, 1, 141, 1, 0, // Skip to: 647
/* 250 */     MCD::OPC_CheckPredicate, 5, 136, 1, 0, // Skip to: 647
/* 255 */     MCD::OPC_Decode, 161, 13, 27, // Opcode: JRC16_MM
/* 259 */     MCD::OPC_FilterValue, 7, 31, 0, 0, // Skip to: 295
/* 264 */     MCD::OPC_ExtractField, 5, 1,  // Inst{5} ...
/* 267 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 281
/* 272 */     MCD::OPC_CheckPredicate, 5, 114, 1, 0, // Skip to: 647
/* 277 */     MCD::OPC_Decode, 137, 13, 27, // Opcode: JALR16_MM
/* 281 */     MCD::OPC_FilterValue, 1, 105, 1, 0, // Skip to: 647
/* 286 */     MCD::OPC_CheckPredicate, 5, 100, 1, 0, // Skip to: 647
/* 291 */     MCD::OPC_Decode, 142, 13, 27, // Opcode: JALRS16_MM
/* 295 */     MCD::OPC_FilterValue, 8, 16, 0, 0, // Skip to: 316
/* 300 */     MCD::OPC_CheckPredicate, 5, 86, 1, 0, // Skip to: 647
/* 305 */     MCD::OPC_CheckField, 5, 1, 0, 79, 1, 0, // Skip to: 647
/* 312 */     MCD::OPC_Decode, 255, 14, 27, // Opcode: MFHI16_MM
/* 316 */     MCD::OPC_FilterValue, 9, 16, 0, 0, // Skip to: 337
/* 321 */     MCD::OPC_CheckPredicate, 5, 65, 1, 0, // Skip to: 647
/* 326 */     MCD::OPC_CheckField, 5, 1, 0, 58, 1, 0, // Skip to: 647
/* 333 */     MCD::OPC_Decode, 133, 15, 27, // Opcode: MFLO16_MM
/* 337 */     MCD::OPC_FilterValue, 10, 16, 0, 0, // Skip to: 358
/* 342 */     MCD::OPC_CheckPredicate, 5, 44, 1, 0, // Skip to: 647
/* 347 */     MCD::OPC_CheckField, 4, 2, 0, 37, 1, 0, // Skip to: 647
/* 354 */     MCD::OPC_Decode, 217, 6, 28, // Opcode: BREAK16_MM
/* 358 */     MCD::OPC_FilterValue, 11, 16, 0, 0, // Skip to: 379
/* 363 */     MCD::OPC_CheckPredicate, 5, 23, 1, 0, // Skip to: 647
/* 368 */     MCD::OPC_CheckField, 4, 2, 0, 16, 1, 0, // Skip to: 647
/* 375 */     MCD::OPC_Decode, 209, 18, 28, // Opcode: SDBBP16_MM
/* 379 */     MCD::OPC_FilterValue, 12, 7, 1, 0, // Skip to: 647
/* 384 */     MCD::OPC_CheckPredicate, 5, 2, 1, 0, // Skip to: 647
/* 389 */     MCD::OPC_CheckField, 5, 1, 0, 251, 0, 0, // Skip to: 647
/* 396 */     MCD::OPC_Decode, 160, 13, 29, // Opcode: JRADDIUSP
/* 400 */     MCD::OPC_FilterValue, 18, 9, 0, 0, // Skip to: 414
/* 405 */     MCD::OPC_CheckPredicate, 6, 237, 0, 0, // Skip to: 647
/* 410 */     MCD::OPC_Decode, 153, 14, 30, // Opcode: LWSP_MM
/* 414 */     MCD::OPC_FilterValue, 19, 31, 0, 0, // Skip to: 450
/* 419 */     MCD::OPC_ExtractField, 0, 1,  // Inst{0} ...
/* 422 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 436
/* 427 */     MCD::OPC_CheckPredicate, 6, 215, 0, 0, // Skip to: 647
/* 432 */     MCD::OPC_Decode, 180, 4, 31, // Opcode: ADDIUS5_MM
/* 436 */     MCD::OPC_FilterValue, 1, 206, 0, 0, // Skip to: 647
/* 441 */     MCD::OPC_CheckPredicate, 6, 201, 0, 0, // Skip to: 647
/* 446 */     MCD::OPC_Decode, 181, 4, 32, // Opcode: ADDIUSP_MM
/* 450 */     MCD::OPC_FilterValue, 25, 9, 0, 0, // Skip to: 464
/* 455 */     MCD::OPC_CheckPredicate, 6, 187, 0, 0, // Skip to: 647
/* 460 */     MCD::OPC_Decode, 136, 14, 33, // Opcode: LWGP_MM
/* 464 */     MCD::OPC_FilterValue, 26, 9, 0, 0, // Skip to: 478
/* 469 */     MCD::OPC_CheckPredicate, 6, 173, 0, 0, // Skip to: 647
/* 474 */     MCD::OPC_Decode, 252, 13, 20, // Opcode: LW16_MM
/* 478 */     MCD::OPC_FilterValue, 27, 31, 0, 0, // Skip to: 514
/* 483 */     MCD::OPC_ExtractField, 0, 1,  // Inst{0} ...
/* 486 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 500
/* 491 */     MCD::OPC_CheckPredicate, 6, 151, 0, 0, // Skip to: 647
/* 496 */     MCD::OPC_Decode, 179, 4, 34, // Opcode: ADDIUR2_MM
/* 500 */     MCD::OPC_FilterValue, 1, 142, 0, 0, // Skip to: 647
/* 505 */     MCD::OPC_CheckPredicate, 6, 137, 0, 0, // Skip to: 647
/* 510 */     MCD::OPC_Decode, 178, 4, 35, // Opcode: ADDIUR1SP_MM
/* 514 */     MCD::OPC_FilterValue, 33, 16, 0, 0, // Skip to: 535
/* 519 */     MCD::OPC_CheckPredicate, 5, 123, 0, 0, // Skip to: 647
/* 524 */     MCD::OPC_CheckField, 0, 1, 0, 116, 0, 0, // Skip to: 647
/* 531 */     MCD::OPC_Decode, 183, 15, 36, // Opcode: MOVEP_MM
/* 535 */     MCD::OPC_FilterValue, 34, 9, 0, 0, // Skip to: 549
/* 540 */     MCD::OPC_CheckPredicate, 5, 102, 0, 0, // Skip to: 647
/* 545 */     MCD::OPC_Decode, 189, 18, 20, // Opcode: SB16_MM
/* 549 */     MCD::OPC_FilterValue, 35, 9, 0, 0, // Skip to: 563
/* 554 */     MCD::OPC_CheckPredicate, 5, 88, 0, 0, // Skip to: 647
/* 559 */     MCD::OPC_Decode, 219, 5, 37, // Opcode: BEQZ16_MM
/* 563 */     MCD::OPC_FilterValue, 42, 9, 0, 0, // Skip to: 577
/* 568 */     MCD::OPC_CheckPredicate, 5, 74, 0, 0, // Skip to: 647
/* 573 */     MCD::OPC_Decode, 255, 18, 20, // Opcode: SH16_MM
/* 577 */     MCD::OPC_FilterValue, 43, 9, 0, 0, // Skip to: 591
/* 582 */     MCD::OPC_CheckPredicate, 5, 60, 0, 0, // Skip to: 647
/* 587 */     MCD::OPC_Decode, 195, 6, 37, // Opcode: BNEZ16_MM
/* 591 */     MCD::OPC_FilterValue, 50, 9, 0, 0, // Skip to: 605
/* 596 */     MCD::OPC_CheckPredicate, 5, 46, 0, 0, // Skip to: 647
/* 601 */     MCD::OPC_Decode, 131, 21, 30, // Opcode: SWSP_MM
/* 605 */     MCD::OPC_FilterValue, 51, 9, 0, 0, // Skip to: 619
/* 610 */     MCD::OPC_CheckPredicate, 6, 32, 0, 0, // Skip to: 647
/* 615 */     MCD::OPC_Decode, 177, 5, 38, // Opcode: B16_MM
/* 619 */     MCD::OPC_FilterValue, 58, 9, 0, 0, // Skip to: 633
/* 624 */     MCD::OPC_CheckPredicate, 5, 18, 0, 0, // Skip to: 647
/* 629 */     MCD::OPC_Decode, 232, 20, 20, // Opcode: SW16_MM
/* 633 */     MCD::OPC_FilterValue, 59, 9, 0, 0, // Skip to: 647
/* 638 */     MCD::OPC_CheckPredicate, 5, 4, 0, 0, // Skip to: 647
/* 643 */     MCD::OPC_Decode, 229, 13, 39, // Opcode: LI16_MM
/* 647 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMicroMips32[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 0, 238, 14, 0, // Skip to: 3830
/* 8 */       MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 11 */      MCD::OPC_FilterValue, 0, 104, 0, 0, // Skip to: 120
/* 16 */      MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 19 */      MCD::OPC_FilterValue, 0, 54, 0, 0, // Skip to: 78
/* 24 */      MCD::OPC_ExtractField, 11, 15,  // Inst{25-11} ...
/* 27 */      MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 41
/* 32 */      MCD::OPC_CheckPredicate, 6, 32, 0, 0, // Skip to: 69
/* 37 */      MCD::OPC_Decode, 157, 20, 0, // Opcode: SSNOP_MM
/* 41 */      MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 55
/* 46 */      MCD::OPC_CheckPredicate, 6, 18, 0, 0, // Skip to: 69
/* 51 */      MCD::OPC_Decode, 195, 10, 0, // Opcode: EHB_MM
/* 55 */      MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 69
/* 60 */      MCD::OPC_CheckPredicate, 6, 4, 0, 0, // Skip to: 69
/* 65 */      MCD::OPC_Decode, 145, 17, 0, // Opcode: PAUSE_MM
/* 69 */      MCD::OPC_CheckPredicate, 6, 37, 25, 0, // Skip to: 6511
/* 74 */      MCD::OPC_Decode, 209, 19, 40, // Opcode: SLL_MM
/* 78 */      MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 92
/* 83 */      MCD::OPC_CheckPredicate, 6, 23, 25, 0, // Skip to: 6511
/* 88 */      MCD::OPC_Decode, 146, 20, 40, // Opcode: SRL_MM
/* 92 */      MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 106
/* 97 */      MCD::OPC_CheckPredicate, 6, 9, 25, 0, // Skip to: 6511
/* 102 */     MCD::OPC_Decode, 252, 19, 40, // Opcode: SRA_MM
/* 106 */     MCD::OPC_FilterValue, 3, 0, 25, 0, // Skip to: 6511
/* 111 */     MCD::OPC_CheckPredicate, 6, 251, 24, 0, // Skip to: 6511
/* 116 */     MCD::OPC_Decode, 158, 18, 40, // Opcode: ROTR_MM
/* 120 */     MCD::OPC_FilterValue, 5, 227, 0, 0, // Skip to: 352
/* 125 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 128 */     MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 149
/* 133 */     MCD::OPC_CheckPredicate, 7, 229, 24, 0, // Skip to: 6511
/* 138 */     MCD::OPC_CheckField, 11, 5, 0, 222, 24, 0, // Skip to: 6511
/* 145 */     MCD::OPC_Decode, 219, 7, 41, // Opcode: CMP_EQ_PH_MM
/* 149 */     MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 170
/* 154 */     MCD::OPC_CheckPredicate, 7, 208, 24, 0, // Skip to: 6511
/* 159 */     MCD::OPC_CheckField, 11, 5, 0, 201, 24, 0, // Skip to: 6511
/* 166 */     MCD::OPC_Decode, 233, 7, 41, // Opcode: CMP_LT_PH_MM
/* 170 */     MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 191
/* 175 */     MCD::OPC_CheckPredicate, 7, 187, 24, 0, // Skip to: 6511
/* 180 */     MCD::OPC_CheckField, 11, 5, 0, 180, 24, 0, // Skip to: 6511
/* 187 */     MCD::OPC_Decode, 227, 7, 41, // Opcode: CMP_LE_PH_MM
/* 191 */     MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 205
/* 196 */     MCD::OPC_CheckPredicate, 8, 166, 24, 0, // Skip to: 6511
/* 201 */     MCD::OPC_Decode, 197, 7, 42, // Opcode: CMPGDU_EQ_QB_MMR2
/* 205 */     MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 219
/* 210 */     MCD::OPC_CheckPredicate, 8, 152, 24, 0, // Skip to: 6511
/* 215 */     MCD::OPC_Decode, 201, 7, 42, // Opcode: CMPGDU_LT_QB_MMR2
/* 219 */     MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 233
/* 224 */     MCD::OPC_CheckPredicate, 8, 138, 24, 0, // Skip to: 6511
/* 229 */     MCD::OPC_Decode, 199, 7, 42, // Opcode: CMPGDU_LE_QB_MMR2
/* 233 */     MCD::OPC_FilterValue, 9, 16, 0, 0, // Skip to: 254
/* 238 */     MCD::OPC_CheckPredicate, 7, 124, 24, 0, // Skip to: 6511
/* 243 */     MCD::OPC_CheckField, 11, 5, 0, 117, 24, 0, // Skip to: 6511
/* 250 */     MCD::OPC_Decode, 209, 7, 41, // Opcode: CMPU_EQ_QB_MM
/* 254 */     MCD::OPC_FilterValue, 10, 16, 0, 0, // Skip to: 275
/* 259 */     MCD::OPC_CheckPredicate, 7, 103, 24, 0, // Skip to: 6511
/* 264 */     MCD::OPC_CheckField, 11, 5, 0, 96, 24, 0, // Skip to: 6511
/* 271 */     MCD::OPC_Decode, 213, 7, 41, // Opcode: CMPU_LT_QB_MM
/* 275 */     MCD::OPC_FilterValue, 11, 16, 0, 0, // Skip to: 296
/* 280 */     MCD::OPC_CheckPredicate, 7, 82, 24, 0, // Skip to: 6511
/* 285 */     MCD::OPC_CheckField, 11, 5, 0, 75, 24, 0, // Skip to: 6511
/* 292 */     MCD::OPC_Decode, 211, 7, 41, // Opcode: CMPU_LE_QB_MM
/* 296 */     MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 310
/* 301 */     MCD::OPC_CheckPredicate, 7, 61, 24, 0, // Skip to: 6511
/* 306 */     MCD::OPC_Decode, 196, 4, 43, // Opcode: ADDQ_S_W_MM
/* 310 */     MCD::OPC_FilterValue, 13, 9, 0, 0, // Skip to: 324
/* 315 */     MCD::OPC_CheckPredicate, 7, 47, 24, 0, // Skip to: 6511
/* 320 */     MCD::OPC_Decode, 184, 20, 43, // Opcode: SUBQ_S_W_MM
/* 324 */     MCD::OPC_FilterValue, 14, 9, 0, 0, // Skip to: 338
/* 329 */     MCD::OPC_CheckPredicate, 7, 33, 24, 0, // Skip to: 6511
/* 334 */     MCD::OPC_Decode, 198, 4, 43, // Opcode: ADDSC_MM
/* 338 */     MCD::OPC_FilterValue, 15, 24, 24, 0, // Skip to: 6511
/* 343 */     MCD::OPC_CheckPredicate, 7, 19, 24, 0, // Skip to: 6511
/* 348 */     MCD::OPC_Decode, 235, 4, 43, // Opcode: ADDWC_MM
/* 352 */     MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 366
/* 357 */     MCD::OPC_CheckPredicate, 6, 5, 24, 0, // Skip to: 6511
/* 362 */     MCD::OPC_Decode, 219, 6, 44, // Opcode: BREAK_MM
/* 366 */     MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 380
/* 371 */     MCD::OPC_CheckPredicate, 5, 247, 23, 0, // Skip to: 6511
/* 376 */     MCD::OPC_Decode, 132, 13, 45, // Opcode: INS_MM
/* 380 */     MCD::OPC_FilterValue, 13, 167, 1, 0, // Skip to: 808
/* 385 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 388 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 402
/* 393 */     MCD::OPC_CheckPredicate, 7, 225, 23, 0, // Skip to: 6511
/* 398 */     MCD::OPC_Decode, 192, 4, 46, // Opcode: ADDQ_PH_MM
/* 402 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 416
/* 407 */     MCD::OPC_CheckPredicate, 8, 211, 23, 0, // Skip to: 6511
/* 412 */     MCD::OPC_Decode, 184, 4, 46, // Opcode: ADDQH_PH_MMR2
/* 416 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 430
/* 421 */     MCD::OPC_CheckPredicate, 8, 197, 23, 0, // Skip to: 6511
/* 426 */     MCD::OPC_Decode, 190, 4, 43, // Opcode: ADDQH_W_MMR2
/* 430 */     MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 444
/* 435 */     MCD::OPC_CheckPredicate, 7, 183, 23, 0, // Skip to: 6511
/* 440 */     MCD::OPC_Decode, 221, 4, 46, // Opcode: ADDU_QB_MM
/* 444 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 458
/* 449 */     MCD::OPC_CheckPredicate, 8, 169, 23, 0, // Skip to: 6511
/* 454 */     MCD::OPC_Decode, 219, 4, 46, // Opcode: ADDU_PH_MMR2
/* 458 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 472
/* 463 */     MCD::OPC_CheckPredicate, 8, 155, 23, 0, // Skip to: 6511
/* 468 */     MCD::OPC_Decode, 214, 4, 46, // Opcode: ADDUH_QB_MMR2
/* 472 */     MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 486
/* 477 */     MCD::OPC_CheckPredicate, 7, 141, 23, 0, // Skip to: 6511
/* 482 */     MCD::OPC_Decode, 156, 19, 47, // Opcode: SHRAV_PH_MM
/* 486 */     MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 500
/* 491 */     MCD::OPC_CheckPredicate, 8, 127, 23, 0, // Skip to: 6511
/* 496 */     MCD::OPC_Decode, 158, 19, 47, // Opcode: SHRAV_QB_MMR2
/* 500 */     MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 514
/* 505 */     MCD::OPC_CheckPredicate, 7, 113, 23, 0, // Skip to: 6511
/* 510 */     MCD::OPC_Decode, 180, 20, 46, // Opcode: SUBQ_PH_MM
/* 514 */     MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 528
/* 519 */     MCD::OPC_CheckPredicate, 8, 99, 23, 0, // Skip to: 6511
/* 524 */     MCD::OPC_Decode, 172, 20, 46, // Opcode: SUBQH_PH_MMR2
/* 528 */     MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 542
/* 533 */     MCD::OPC_CheckPredicate, 8, 85, 23, 0, // Skip to: 6511
/* 538 */     MCD::OPC_Decode, 178, 20, 43, // Opcode: SUBQH_W_MMR2
/* 542 */     MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 556
/* 547 */     MCD::OPC_CheckPredicate, 7, 71, 23, 0, // Skip to: 6511
/* 552 */     MCD::OPC_Decode, 211, 20, 46, // Opcode: SUBU_QB_MM
/* 556 */     MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 570
/* 561 */     MCD::OPC_CheckPredicate, 8, 57, 23, 0, // Skip to: 6511
/* 566 */     MCD::OPC_Decode, 209, 20, 46, // Opcode: SUBU_PH_MMR2
/* 570 */     MCD::OPC_FilterValue, 13, 9, 0, 0, // Skip to: 584
/* 575 */     MCD::OPC_CheckPredicate, 8, 43, 23, 0, // Skip to: 6511
/* 580 */     MCD::OPC_Decode, 204, 20, 46, // Opcode: SUBUH_QB_MMR2
/* 584 */     MCD::OPC_FilterValue, 15, 9, 0, 0, // Skip to: 598
/* 589 */     MCD::OPC_CheckPredicate, 8, 29, 23, 0, // Skip to: 6511
/* 594 */     MCD::OPC_Decode, 222, 17, 48, // Opcode: PRECR_SRA_PH_W_MMR2
/* 598 */     MCD::OPC_FilterValue, 16, 9, 0, 0, // Skip to: 612
/* 603 */     MCD::OPC_CheckPredicate, 7, 15, 23, 0, // Skip to: 6511
/* 608 */     MCD::OPC_Decode, 194, 4, 46, // Opcode: ADDQ_S_PH_MM
/* 612 */     MCD::OPC_FilterValue, 17, 9, 0, 0, // Skip to: 626
/* 617 */     MCD::OPC_CheckPredicate, 8, 1, 23, 0, // Skip to: 6511
/* 622 */     MCD::OPC_Decode, 186, 4, 46, // Opcode: ADDQH_R_PH_MMR2
/* 626 */     MCD::OPC_FilterValue, 18, 9, 0, 0, // Skip to: 640
/* 631 */     MCD::OPC_CheckPredicate, 8, 243, 22, 0, // Skip to: 6511
/* 636 */     MCD::OPC_Decode, 188, 4, 43, // Opcode: ADDQH_R_W_MMR2
/* 640 */     MCD::OPC_FilterValue, 19, 9, 0, 0, // Skip to: 654
/* 645 */     MCD::OPC_CheckPredicate, 7, 229, 22, 0, // Skip to: 6511
/* 650 */     MCD::OPC_Decode, 225, 4, 46, // Opcode: ADDU_S_QB_MM
/* 654 */     MCD::OPC_FilterValue, 20, 9, 0, 0, // Skip to: 668
/* 659 */     MCD::OPC_CheckPredicate, 8, 215, 22, 0, // Skip to: 6511
/* 664 */     MCD::OPC_Decode, 223, 4, 46, // Opcode: ADDU_S_PH_MMR2
/* 668 */     MCD::OPC_FilterValue, 21, 9, 0, 0, // Skip to: 682
/* 673 */     MCD::OPC_CheckPredicate, 8, 201, 22, 0, // Skip to: 6511
/* 678 */     MCD::OPC_Decode, 216, 4, 46, // Opcode: ADDUH_R_QB_MMR2
/* 682 */     MCD::OPC_FilterValue, 22, 9, 0, 0, // Skip to: 696
/* 687 */     MCD::OPC_CheckPredicate, 7, 187, 22, 0, // Skip to: 6511
/* 692 */     MCD::OPC_Decode, 160, 19, 47, // Opcode: SHRAV_R_PH_MM
/* 696 */     MCD::OPC_FilterValue, 23, 9, 0, 0, // Skip to: 710
/* 701 */     MCD::OPC_CheckPredicate, 8, 173, 22, 0, // Skip to: 6511
/* 706 */     MCD::OPC_Decode, 162, 19, 47, // Opcode: SHRAV_R_QB_MMR2
/* 710 */     MCD::OPC_FilterValue, 24, 9, 0, 0, // Skip to: 724
/* 715 */     MCD::OPC_CheckPredicate, 7, 159, 22, 0, // Skip to: 6511
/* 720 */     MCD::OPC_Decode, 182, 20, 46, // Opcode: SUBQ_S_PH_MM
/* 724 */     MCD::OPC_FilterValue, 25, 9, 0, 0, // Skip to: 738
/* 729 */     MCD::OPC_CheckPredicate, 8, 145, 22, 0, // Skip to: 6511
/* 734 */     MCD::OPC_Decode, 174, 20, 46, // Opcode: SUBQH_R_PH_MMR2
/* 738 */     MCD::OPC_FilterValue, 26, 9, 0, 0, // Skip to: 752
/* 743 */     MCD::OPC_CheckPredicate, 8, 131, 22, 0, // Skip to: 6511
/* 748 */     MCD::OPC_Decode, 176, 20, 43, // Opcode: SUBQH_R_W_MMR2
/* 752 */     MCD::OPC_FilterValue, 27, 9, 0, 0, // Skip to: 766
/* 757 */     MCD::OPC_CheckPredicate, 7, 117, 22, 0, // Skip to: 6511
/* 762 */     MCD::OPC_Decode, 215, 20, 46, // Opcode: SUBU_S_QB_MM
/* 766 */     MCD::OPC_FilterValue, 28, 9, 0, 0, // Skip to: 780
/* 771 */     MCD::OPC_CheckPredicate, 8, 103, 22, 0, // Skip to: 6511
/* 776 */     MCD::OPC_Decode, 213, 20, 46, // Opcode: SUBU_S_PH_MMR2
/* 780 */     MCD::OPC_FilterValue, 29, 9, 0, 0, // Skip to: 794
/* 785 */     MCD::OPC_CheckPredicate, 8, 89, 22, 0, // Skip to: 6511
/* 790 */     MCD::OPC_Decode, 206, 20, 46, // Opcode: SUBUH_R_QB_MMR2
/* 794 */     MCD::OPC_FilterValue, 31, 80, 22, 0, // Skip to: 6511
/* 799 */     MCD::OPC_CheckPredicate, 8, 75, 22, 0, // Skip to: 6511
/* 804 */     MCD::OPC_Decode, 224, 17, 48, // Opcode: PRECR_SRA_R_PH_W_MMR2
/* 808 */     MCD::OPC_FilterValue, 14, 31, 0, 0, // Skip to: 844
/* 813 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 816 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 830
/* 821 */     MCD::OPC_CheckPredicate, 7, 53, 22, 0, // Skip to: 6511
/* 826 */     MCD::OPC_Decode, 140, 19, 47, // Opcode: SHLLV_PH_MM
/* 830 */     MCD::OPC_FilterValue, 16, 44, 22, 0, // Skip to: 6511
/* 835 */     MCD::OPC_CheckPredicate, 7, 39, 22, 0, // Skip to: 6511
/* 840 */     MCD::OPC_Decode, 144, 19, 47, // Opcode: SHLLV_S_PH_MM
/* 844 */     MCD::OPC_FilterValue, 16, 213, 0, 0, // Skip to: 1062
/* 849 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 852 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 866
/* 857 */     MCD::OPC_CheckPredicate, 6, 17, 22, 0, // Skip to: 6511
/* 862 */     MCD::OPC_Decode, 205, 19, 49, // Opcode: SLLV_MM
/* 866 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 880
/* 871 */     MCD::OPC_CheckPredicate, 6, 3, 22, 0, // Skip to: 6511
/* 876 */     MCD::OPC_Decode, 142, 20, 49, // Opcode: SRLV_MM
/* 880 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 894
/* 885 */     MCD::OPC_CheckPredicate, 6, 245, 21, 0, // Skip to: 6511
/* 890 */     MCD::OPC_Decode, 248, 19, 49, // Opcode: SRAV_MM
/* 894 */     MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 908
/* 899 */     MCD::OPC_CheckPredicate, 6, 231, 21, 0, // Skip to: 6511
/* 904 */     MCD::OPC_Decode, 157, 18, 49, // Opcode: ROTRV_MM
/* 908 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 922
/* 913 */     MCD::OPC_CheckPredicate, 5, 217, 21, 0, // Skip to: 6511
/* 918 */     MCD::OPC_Decode, 240, 4, 43, // Opcode: ADD_MM
/* 922 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 936
/* 927 */     MCD::OPC_CheckPredicate, 5, 203, 21, 0, // Skip to: 6511
/* 932 */     MCD::OPC_Decode, 247, 4, 43, // Opcode: ADDu_MM
/* 936 */     MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 950
/* 941 */     MCD::OPC_CheckPredicate, 5, 189, 21, 0, // Skip to: 6511
/* 946 */     MCD::OPC_Decode, 224, 20, 43, // Opcode: SUB_MM
/* 950 */     MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 964
/* 955 */     MCD::OPC_CheckPredicate, 5, 175, 21, 0, // Skip to: 6511
/* 960 */     MCD::OPC_Decode, 227, 20, 43, // Opcode: SUBu_MM
/* 964 */     MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 978
/* 969 */     MCD::OPC_CheckPredicate, 5, 161, 21, 0, // Skip to: 6511
/* 974 */     MCD::OPC_Decode, 202, 16, 43, // Opcode: MUL_MM
/* 978 */     MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 992
/* 983 */     MCD::OPC_CheckPredicate, 5, 147, 21, 0, // Skip to: 6511
/* 988 */     MCD::OPC_Decode, 132, 5, 43, // Opcode: AND_MM
/* 992 */     MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 1006
/* 997 */     MCD::OPC_CheckPredicate, 5, 133, 21, 0, // Skip to: 6511
/* 1002 */    MCD::OPC_Decode, 249, 16, 43, // Opcode: OR_MM
/* 1006 */    MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 1020
/* 1011 */    MCD::OPC_CheckPredicate, 5, 119, 21, 0, // Skip to: 6511
/* 1016 */    MCD::OPC_Decode, 236, 16, 43, // Opcode: NOR_MM
/* 1020 */    MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 1034
/* 1025 */    MCD::OPC_CheckPredicate, 5, 105, 21, 0, // Skip to: 6511
/* 1030 */    MCD::OPC_Decode, 249, 21, 43, // Opcode: XOR_MM
/* 1034 */    MCD::OPC_FilterValue, 13, 9, 0, 0, // Skip to: 1048
/* 1039 */    MCD::OPC_CheckPredicate, 6, 91, 21, 0, // Skip to: 6511
/* 1044 */    MCD::OPC_Decode, 214, 19, 43, // Opcode: SLT_MM
/* 1048 */    MCD::OPC_FilterValue, 14, 82, 21, 0, // Skip to: 6511
/* 1053 */    MCD::OPC_CheckPredicate, 6, 77, 21, 0, // Skip to: 6511
/* 1058 */    MCD::OPC_Decode, 223, 19, 43, // Opcode: SLTu_MM
/* 1062 */    MCD::OPC_FilterValue, 21, 199, 0, 0, // Skip to: 1266
/* 1067 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 1070 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1084
/* 1075 */    MCD::OPC_CheckPredicate, 7, 55, 21, 0, // Skip to: 6511
/* 1080 */    MCD::OPC_Decode, 171, 16, 46, // Opcode: MULEU_S_PH_QBL_MM
/* 1084 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 1098
/* 1089 */    MCD::OPC_CheckPredicate, 7, 41, 21, 0, // Skip to: 6511
/* 1094 */    MCD::OPC_Decode, 173, 16, 46, // Opcode: MULEU_S_PH_QBR_MM
/* 1098 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 1112
/* 1103 */    MCD::OPC_CheckPredicate, 7, 27, 21, 0, // Skip to: 6511
/* 1108 */    MCD::OPC_Decode, 175, 16, 46, // Opcode: MULQ_RS_PH_MM
/* 1112 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 1126
/* 1117 */    MCD::OPC_CheckPredicate, 8, 13, 21, 0, // Skip to: 6511
/* 1122 */    MCD::OPC_Decode, 179, 16, 46, // Opcode: MULQ_S_PH_MMR2
/* 1126 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 1140
/* 1131 */    MCD::OPC_CheckPredicate, 8, 255, 20, 0, // Skip to: 6511
/* 1136 */    MCD::OPC_Decode, 177, 16, 43, // Opcode: MULQ_RS_W_MMR2
/* 1140 */    MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 1154
/* 1145 */    MCD::OPC_CheckPredicate, 8, 241, 20, 0, // Skip to: 6511
/* 1150 */    MCD::OPC_Decode, 181, 16, 43, // Opcode: MULQ_S_W_MMR2
/* 1154 */    MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 1168
/* 1159 */    MCD::OPC_CheckPredicate, 8, 227, 20, 0, // Skip to: 6511
/* 1164 */    MCD::OPC_Decode, 139, 5, 50, // Opcode: APPEND_MMR2
/* 1168 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 1182
/* 1173 */    MCD::OPC_CheckPredicate, 8, 213, 20, 0, // Skip to: 6511
/* 1178 */    MCD::OPC_Decode, 233, 17, 50, // Opcode: PREPEND_MMR2
/* 1182 */    MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 1196
/* 1187 */    MCD::OPC_CheckPredicate, 7, 199, 20, 0, // Skip to: 6511
/* 1192 */    MCD::OPC_Decode, 169, 15, 43, // Opcode: MODSUB_MM
/* 1196 */    MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 1210
/* 1201 */    MCD::OPC_CheckPredicate, 7, 185, 20, 0, // Skip to: 6511
/* 1206 */    MCD::OPC_Decode, 164, 19, 49, // Opcode: SHRAV_R_W_MM
/* 1210 */    MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 1224
/* 1215 */    MCD::OPC_CheckPredicate, 8, 171, 20, 0, // Skip to: 6511
/* 1220 */    MCD::OPC_Decode, 176, 19, 47, // Opcode: SHRLV_PH_MMR2
/* 1224 */    MCD::OPC_FilterValue, 13, 9, 0, 0, // Skip to: 1238
/* 1229 */    MCD::OPC_CheckPredicate, 7, 157, 20, 0, // Skip to: 6511
/* 1234 */    MCD::OPC_Decode, 178, 19, 47, // Opcode: SHRLV_QB_MM
/* 1238 */    MCD::OPC_FilterValue, 14, 9, 0, 0, // Skip to: 1252
/* 1243 */    MCD::OPC_CheckPredicate, 7, 143, 20, 0, // Skip to: 6511
/* 1248 */    MCD::OPC_Decode, 142, 19, 47, // Opcode: SHLLV_QB_MM
/* 1252 */    MCD::OPC_FilterValue, 15, 134, 20, 0, // Skip to: 6511
/* 1257 */    MCD::OPC_CheckPredicate, 7, 129, 20, 0, // Skip to: 6511
/* 1262 */    MCD::OPC_Decode, 146, 19, 49, // Opcode: SHLLV_S_W_MM
/* 1266 */    MCD::OPC_FilterValue, 24, 45, 0, 0, // Skip to: 1316
/* 1271 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 1274 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 1288
/* 1279 */    MCD::OPC_CheckPredicate, 5, 107, 20, 0, // Skip to: 6511
/* 1284 */    MCD::OPC_Decode, 203, 15, 51, // Opcode: MOVN_I_MM
/* 1288 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 1302
/* 1293 */    MCD::OPC_CheckPredicate, 5, 93, 20, 0, // Skip to: 6511
/* 1298 */    MCD::OPC_Decode, 223, 15, 51, // Opcode: MOVZ_I_MM
/* 1302 */    MCD::OPC_FilterValue, 4, 84, 20, 0, // Skip to: 6511
/* 1307 */    MCD::OPC_CheckPredicate, 6, 79, 20, 0, // Skip to: 6511
/* 1312 */    MCD::OPC_Decode, 159, 14, 52, // Opcode: LWXS_MM
/* 1316 */    MCD::OPC_FilterValue, 29, 23, 0, 0, // Skip to: 1344
/* 1321 */    MCD::OPC_CheckPredicate, 7, 65, 20, 0, // Skip to: 6511
/* 1326 */    MCD::OPC_CheckField, 22, 4, 0, 58, 20, 0, // Skip to: 6511
/* 1333 */    MCD::OPC_CheckField, 6, 8, 0, 51, 20, 0, // Skip to: 6511
/* 1340 */    MCD::OPC_Decode, 138, 19, 53, // Opcode: SHILO_MM
/* 1344 */    MCD::OPC_FilterValue, 37, 73, 0, 0, // Skip to: 1422
/* 1349 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 1352 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 1366
/* 1357 */    MCD::OPC_CheckPredicate, 7, 29, 20, 0, // Skip to: 6511
/* 1362 */    MCD::OPC_Decode, 167, 16, 42, // Opcode: MULEQ_S_W_PHL_MM
/* 1366 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 1380
/* 1371 */    MCD::OPC_CheckPredicate, 7, 15, 20, 0, // Skip to: 6511
/* 1376 */    MCD::OPC_Decode, 169, 16, 42, // Opcode: MULEQ_S_W_PHR_MM
/* 1380 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 1394
/* 1385 */    MCD::OPC_CheckPredicate, 7, 1, 20, 0, // Skip to: 6511
/* 1390 */    MCD::OPC_Decode, 222, 13, 52, // Opcode: LHX_MM
/* 1394 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 1408
/* 1399 */    MCD::OPC_CheckPredicate, 7, 243, 19, 0, // Skip to: 6511
/* 1404 */    MCD::OPC_Decode, 160, 14, 52, // Opcode: LWX_MM
/* 1408 */    MCD::OPC_FilterValue, 8, 234, 19, 0, // Skip to: 6511
/* 1413 */    MCD::OPC_CheckPredicate, 7, 229, 19, 0, // Skip to: 6511
/* 1418 */    MCD::OPC_Decode, 182, 13, 52, // Opcode: LBUX_MM
/* 1422 */    MCD::OPC_FilterValue, 44, 9, 0, 0, // Skip to: 1436
/* 1427 */    MCD::OPC_CheckPredicate, 5, 215, 19, 0, // Skip to: 6511
/* 1432 */    MCD::OPC_Decode, 236, 10, 54, // Opcode: EXT_MM
/* 1436 */    MCD::OPC_FilterValue, 45, 143, 0, 0, // Skip to: 1584
/* 1441 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 1444 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 1458
/* 1449 */    MCD::OPC_CheckPredicate, 8, 193, 19, 0, // Skip to: 6511
/* 1454 */    MCD::OPC_Decode, 205, 16, 46, // Opcode: MUL_PH_MMR2
/* 1458 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 1472
/* 1463 */    MCD::OPC_CheckPredicate, 8, 179, 19, 0, // Skip to: 6511
/* 1468 */    MCD::OPC_Decode, 220, 17, 46, // Opcode: PRECR_QB_PH_MMR2
/* 1472 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1486
/* 1477 */    MCD::OPC_CheckPredicate, 7, 165, 19, 0, // Skip to: 6511
/* 1482 */    MCD::OPC_Decode, 216, 17, 46, // Opcode: PRECRQ_QB_PH_MM
/* 1486 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 1500
/* 1491 */    MCD::OPC_CheckPredicate, 7, 151, 19, 0, // Skip to: 6511
/* 1496 */    MCD::OPC_Decode, 214, 17, 55, // Opcode: PRECRQ_PH_W_MM
/* 1500 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 1514
/* 1505 */    MCD::OPC_CheckPredicate, 7, 137, 19, 0, // Skip to: 6511
/* 1510 */    MCD::OPC_Decode, 218, 17, 55, // Opcode: PRECRQ_RS_PH_W_MM
/* 1514 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 1528
/* 1519 */    MCD::OPC_CheckPredicate, 7, 123, 19, 0, // Skip to: 6511
/* 1524 */    MCD::OPC_Decode, 212, 17, 46, // Opcode: PRECRQU_S_QB_PH_MM
/* 1528 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 1542
/* 1533 */    MCD::OPC_CheckPredicate, 7, 109, 19, 0, // Skip to: 6511
/* 1538 */    MCD::OPC_Decode, 129, 17, 46, // Opcode: PACKRL_PH_MM
/* 1542 */    MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 1556
/* 1547 */    MCD::OPC_CheckPredicate, 7, 95, 19, 0, // Skip to: 6511
/* 1552 */    MCD::OPC_Decode, 171, 17, 46, // Opcode: PICK_QB_MM
/* 1556 */    MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 1570
/* 1561 */    MCD::OPC_CheckPredicate, 7, 81, 19, 0, // Skip to: 6511
/* 1566 */    MCD::OPC_Decode, 169, 17, 46, // Opcode: PICK_PH_MM
/* 1570 */    MCD::OPC_FilterValue, 16, 72, 19, 0, // Skip to: 6511
/* 1575 */    MCD::OPC_CheckPredicate, 8, 67, 19, 0, // Skip to: 6511
/* 1580 */    MCD::OPC_Decode, 210, 16, 46, // Opcode: MUL_S_PH_MMR2
/* 1584 */    MCD::OPC_FilterValue, 52, 45, 0, 0, // Skip to: 1634
/* 1589 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 1592 */    MCD::OPC_FilterValue, 19, 16, 0, 0, // Skip to: 1613
/* 1597 */    MCD::OPC_CheckPredicate, 9, 45, 19, 0, // Skip to: 6511
/* 1602 */    MCD::OPC_CheckField, 14, 2, 0, 38, 19, 0, // Skip to: 6511
/* 1609 */    MCD::OPC_Decode, 253, 14, 56, // Opcode: MFHGC0_MM
/* 1613 */    MCD::OPC_FilterValue, 27, 29, 19, 0, // Skip to: 6511
/* 1618 */    MCD::OPC_CheckPredicate, 9, 24, 19, 0, // Skip to: 6511
/* 1623 */    MCD::OPC_CheckField, 14, 2, 0, 17, 19, 0, // Skip to: 6511
/* 1630 */    MCD::OPC_Decode, 141, 16, 57, // Opcode: MTHGC0_MM
/* 1634 */    MCD::OPC_FilterValue, 53, 109, 0, 0, // Skip to: 1748
/* 1639 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 1642 */    MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 1656
/* 1647 */    MCD::OPC_CheckPredicate, 7, 251, 18, 0, // Skip to: 6511
/* 1652 */    MCD::OPC_Decode, 174, 19, 40, // Opcode: SHRA_R_W_MM
/* 1656 */    MCD::OPC_FilterValue, 12, 16, 0, 0, // Skip to: 1677
/* 1661 */    MCD::OPC_CheckPredicate, 7, 237, 18, 0, // Skip to: 6511
/* 1666 */    MCD::OPC_CheckField, 11, 1, 0, 230, 18, 0, // Skip to: 6511
/* 1673 */    MCD::OPC_Decode, 166, 19, 58, // Opcode: SHRA_PH_MM
/* 1677 */    MCD::OPC_FilterValue, 14, 31, 0, 0, // Skip to: 1713
/* 1682 */    MCD::OPC_ExtractField, 11, 1,  // Inst{11} ...
/* 1685 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 1699
/* 1690 */    MCD::OPC_CheckPredicate, 7, 208, 18, 0, // Skip to: 6511
/* 1695 */    MCD::OPC_Decode, 148, 19, 58, // Opcode: SHLL_PH_MM
/* 1699 */    MCD::OPC_FilterValue, 1, 199, 18, 0, // Skip to: 6511
/* 1704 */    MCD::OPC_CheckPredicate, 7, 194, 18, 0, // Skip to: 6511
/* 1709 */    MCD::OPC_Decode, 152, 19, 58, // Opcode: SHLL_S_PH_MM
/* 1713 */    MCD::OPC_FilterValue, 15, 9, 0, 0, // Skip to: 1727
/* 1718 */    MCD::OPC_CheckPredicate, 7, 180, 18, 0, // Skip to: 6511
/* 1723 */    MCD::OPC_Decode, 154, 19, 40, // Opcode: SHLL_S_W_MM
/* 1727 */    MCD::OPC_FilterValue, 28, 171, 18, 0, // Skip to: 6511
/* 1732 */    MCD::OPC_CheckPredicate, 7, 166, 18, 0, // Skip to: 6511
/* 1737 */    MCD::OPC_CheckField, 11, 1, 0, 159, 18, 0, // Skip to: 6511
/* 1744 */    MCD::OPC_Decode, 170, 19, 58, // Opcode: SHRA_R_PH_MM
/* 1748 */    MCD::OPC_FilterValue, 60, 8, 8, 0, // Skip to: 3809
/* 1753 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 1756 */    MCD::OPC_FilterValue, 0, 31, 0, 0, // Skip to: 1792
/* 1761 */    MCD::OPC_ExtractField, 11, 1,  // Inst{11} ...
/* 1764 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 1778
/* 1769 */    MCD::OPC_CheckPredicate, 6, 129, 18, 0, // Skip to: 6511
/* 1774 */    MCD::OPC_Decode, 169, 21, 59, // Opcode: TEQ_MM
/* 1778 */    MCD::OPC_FilterValue, 1, 120, 18, 0, // Skip to: 6511
/* 1783 */    MCD::OPC_CheckPredicate, 6, 115, 18, 0, // Skip to: 6511
/* 1788 */    MCD::OPC_Decode, 208, 21, 59, // Opcode: TLT_MM
/* 1792 */    MCD::OPC_FilterValue, 1, 131, 0, 0, // Skip to: 1928
/* 1797 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 1800 */    MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 1850
/* 1805 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1808 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 1829
/* 1813 */    MCD::OPC_CheckPredicate, 7, 85, 18, 0, // Skip to: 6511
/* 1818 */    MCD::OPC_CheckField, 21, 5, 0, 78, 18, 0, // Skip to: 6511
/* 1825 */    MCD::OPC_Decode, 130, 15, 60, // Opcode: MFHI_DSP_MM
/* 1829 */    MCD::OPC_FilterValue, 1, 69, 18, 0, // Skip to: 6511
/* 1834 */    MCD::OPC_CheckPredicate, 7, 64, 18, 0, // Skip to: 6511
/* 1839 */    MCD::OPC_CheckField, 21, 5, 0, 57, 18, 0, // Skip to: 6511
/* 1846 */    MCD::OPC_Decode, 145, 16, 61, // Opcode: MTHI_DSP_MM
/* 1850 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 1864
/* 1855 */    MCD::OPC_CheckPredicate, 7, 43, 18, 0, // Skip to: 6511
/* 1860 */    MCD::OPC_Decode, 150, 19, 62, // Opcode: SHLL_QB_MM
/* 1864 */    MCD::OPC_FilterValue, 2, 45, 0, 0, // Skip to: 1914
/* 1869 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1872 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 1893
/* 1877 */    MCD::OPC_CheckPredicate, 7, 21, 18, 0, // Skip to: 6511
/* 1882 */    MCD::OPC_CheckField, 21, 5, 0, 14, 18, 0, // Skip to: 6511
/* 1889 */    MCD::OPC_Decode, 136, 15, 60, // Opcode: MFLO_DSP_MM
/* 1893 */    MCD::OPC_FilterValue, 1, 5, 18, 0, // Skip to: 6511
/* 1898 */    MCD::OPC_CheckPredicate, 7, 0, 18, 0, // Skip to: 6511
/* 1903 */    MCD::OPC_CheckField, 21, 5, 0, 249, 17, 0, // Skip to: 6511
/* 1910 */    MCD::OPC_Decode, 152, 16, 63, // Opcode: MTLO_DSP_MM
/* 1914 */    MCD::OPC_FilterValue, 3, 240, 17, 0, // Skip to: 6511
/* 1919 */    MCD::OPC_CheckPredicate, 7, 235, 17, 0, // Skip to: 6511
/* 1924 */    MCD::OPC_Decode, 182, 19, 62, // Opcode: SHRL_QB_MM
/* 1928 */    MCD::OPC_FilterValue, 2, 101, 0, 0, // Skip to: 2034
/* 1933 */    MCD::OPC_ExtractField, 11, 3,  // Inst{13-11} ...
/* 1936 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 1950
/* 1941 */    MCD::OPC_CheckPredicate, 8, 213, 17, 0, // Skip to: 6511
/* 1946 */    MCD::OPC_Decode, 146, 10, 64, // Opcode: DPA_W_PH_MMR2
/* 1950 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 1964
/* 1955 */    MCD::OPC_CheckPredicate, 8, 199, 17, 0, // Skip to: 6511
/* 1960 */    MCD::OPC_Decode, 183, 5, 65, // Opcode: BALIGN_MMR2
/* 1964 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1978
/* 1969 */    MCD::OPC_CheckPredicate, 8, 185, 17, 0, // Skip to: 6511
/* 1974 */    MCD::OPC_Decode, 144, 10, 64, // Opcode: DPAX_W_PH_MMR2
/* 1978 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 1992
/* 1983 */    MCD::OPC_CheckPredicate, 7, 171, 17, 0, // Skip to: 6511
/* 1988 */    MCD::OPC_Decode, 140, 10, 64, // Opcode: DPAU_H_QBL_MM
/* 1992 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 2006
/* 1997 */    MCD::OPC_CheckPredicate, 7, 157, 17, 0, // Skip to: 6511
/* 2002 */    MCD::OPC_Decode, 216, 10, 66, // Opcode: EXTPV_MM
/* 2006 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 2020
/* 2011 */    MCD::OPC_CheckPredicate, 7, 143, 17, 0, // Skip to: 6511
/* 2016 */    MCD::OPC_Decode, 142, 10, 64, // Opcode: DPAU_H_QBR_MM
/* 2020 */    MCD::OPC_FilterValue, 7, 134, 17, 0, // Skip to: 6511
/* 2025 */    MCD::OPC_CheckPredicate, 7, 129, 17, 0, // Skip to: 6511
/* 2030 */    MCD::OPC_Decode, 213, 10, 66, // Opcode: EXTPDPV_MM
/* 2034 */    MCD::OPC_FilterValue, 4, 171, 0, 0, // Skip to: 2210
/* 2039 */    MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 2042 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2056
/* 2047 */    MCD::OPC_CheckPredicate, 8, 107, 17, 0, // Skip to: 6511
/* 2052 */    MCD::OPC_Decode, 171, 4, 67, // Opcode: ABSQ_S_QB_MMR2
/* 2056 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2070
/* 2061 */    MCD::OPC_CheckPredicate, 7, 93, 17, 0, // Skip to: 6511
/* 2066 */    MCD::OPC_Decode, 169, 4, 67, // Opcode: ABSQ_S_PH_MM
/* 2070 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 2084
/* 2075 */    MCD::OPC_CheckPredicate, 7, 79, 17, 0, // Skip to: 6511
/* 2080 */    MCD::OPC_Decode, 173, 4, 68, // Opcode: ABSQ_S_W_MM
/* 2084 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 2098
/* 2089 */    MCD::OPC_CheckPredicate, 7, 65, 17, 0, // Skip to: 6511
/* 2094 */    MCD::OPC_Decode, 146, 6, 68, // Opcode: BITREV_MM
/* 2098 */    MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 2112
/* 2103 */    MCD::OPC_CheckPredicate, 7, 51, 17, 0, // Skip to: 6511
/* 2108 */    MCD::OPC_Decode, 131, 13, 69, // Opcode: INSV_MM
/* 2112 */    MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 2126
/* 2117 */    MCD::OPC_CheckPredicate, 7, 37, 17, 0, // Skip to: 6511
/* 2122 */    MCD::OPC_Decode, 200, 17, 70, // Opcode: PRECEQ_W_PHL_MM
/* 2126 */    MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 2140
/* 2131 */    MCD::OPC_CheckPredicate, 7, 23, 17, 0, // Skip to: 6511
/* 2136 */    MCD::OPC_Decode, 202, 17, 70, // Opcode: PRECEQ_W_PHR_MM
/* 2140 */    MCD::OPC_FilterValue, 14, 9, 0, 0, // Skip to: 2154
/* 2145 */    MCD::OPC_CheckPredicate, 7, 9, 17, 0, // Skip to: 6511
/* 2150 */    MCD::OPC_Decode, 194, 17, 67, // Opcode: PRECEQU_PH_QBL_MM
/* 2154 */    MCD::OPC_FilterValue, 18, 9, 0, 0, // Skip to: 2168
/* 2159 */    MCD::OPC_CheckPredicate, 7, 251, 16, 0, // Skip to: 6511
/* 2164 */    MCD::OPC_Decode, 198, 17, 67, // Opcode: PRECEQU_PH_QBR_MM
/* 2168 */    MCD::OPC_FilterValue, 22, 9, 0, 0, // Skip to: 2182
/* 2173 */    MCD::OPC_CheckPredicate, 7, 237, 16, 0, // Skip to: 6511
/* 2178 */    MCD::OPC_Decode, 206, 17, 67, // Opcode: PRECEU_PH_QBL_MM
/* 2182 */    MCD::OPC_FilterValue, 26, 9, 0, 0, // Skip to: 2196
/* 2187 */    MCD::OPC_CheckPredicate, 7, 223, 16, 0, // Skip to: 6511
/* 2192 */    MCD::OPC_Decode, 210, 17, 67, // Opcode: PRECEU_PH_QBR_MM
/* 2196 */    MCD::OPC_FilterValue, 30, 214, 16, 0, // Skip to: 6511
/* 2201 */    MCD::OPC_CheckPredicate, 7, 209, 16, 0, // Skip to: 6511
/* 2206 */    MCD::OPC_Decode, 129, 18, 70, // Opcode: RADDU_W_QB_MM
/* 2210 */    MCD::OPC_FilterValue, 5, 87, 0, 0, // Skip to: 2302
/* 2215 */    MCD::OPC_ExtractField, 11, 15,  // Inst{25-11} ...
/* 2218 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2232
/* 2223 */    MCD::OPC_CheckPredicate, 9, 187, 16, 0, // Skip to: 6511
/* 2228 */    MCD::OPC_Decode, 183, 21, 0, // Opcode: TLBGP_MM
/* 2232 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2246
/* 2237 */    MCD::OPC_CheckPredicate, 9, 173, 16, 0, // Skip to: 6511
/* 2242 */    MCD::OPC_Decode, 185, 21, 0, // Opcode: TLBGR_MM
/* 2246 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 2260
/* 2251 */    MCD::OPC_CheckPredicate, 9, 159, 16, 0, // Skip to: 6511
/* 2256 */    MCD::OPC_Decode, 187, 21, 0, // Opcode: TLBGWI_MM
/* 2260 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 2274
/* 2265 */    MCD::OPC_CheckPredicate, 9, 145, 16, 0, // Skip to: 6511
/* 2270 */    MCD::OPC_Decode, 189, 21, 0, // Opcode: TLBGWR_MM
/* 2274 */    MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 2288
/* 2279 */    MCD::OPC_CheckPredicate, 9, 131, 16, 0, // Skip to: 6511
/* 2284 */    MCD::OPC_Decode, 181, 21, 0, // Opcode: TLBGINV_MM
/* 2288 */    MCD::OPC_FilterValue, 10, 122, 16, 0, // Skip to: 6511
/* 2293 */    MCD::OPC_CheckPredicate, 9, 117, 16, 0, // Skip to: 6511
/* 2298 */    MCD::OPC_Decode, 180, 21, 0, // Opcode: TLBGINVF_MM
/* 2302 */    MCD::OPC_FilterValue, 7, 31, 0, 0, // Skip to: 2338
/* 2307 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 2310 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2324
/* 2315 */    MCD::OPC_CheckPredicate, 8, 95, 16, 0, // Skip to: 6511
/* 2320 */    MCD::OPC_Decode, 168, 19, 62, // Opcode: SHRA_QB_MMR2
/* 2324 */    MCD::OPC_FilterValue, 2, 86, 16, 0, // Skip to: 6511
/* 2329 */    MCD::OPC_CheckPredicate, 8, 81, 16, 0, // Skip to: 6511
/* 2334 */    MCD::OPC_Decode, 172, 19, 62, // Opcode: SHRA_R_QB_MMR2
/* 2338 */    MCD::OPC_FilterValue, 8, 31, 0, 0, // Skip to: 2374
/* 2343 */    MCD::OPC_ExtractField, 11, 1,  // Inst{11} ...
/* 2346 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2360
/* 2351 */    MCD::OPC_CheckPredicate, 6, 59, 16, 0, // Skip to: 6511
/* 2356 */    MCD::OPC_Decode, 177, 21, 59, // Opcode: TGE_MM
/* 2360 */    MCD::OPC_FilterValue, 1, 50, 16, 0, // Skip to: 6511
/* 2365 */    MCD::OPC_CheckPredicate, 6, 45, 16, 0, // Skip to: 6511
/* 2370 */    MCD::OPC_Decode, 207, 21, 59, // Opcode: TLTU_MM
/* 2374 */    MCD::OPC_FilterValue, 9, 101, 0, 0, // Skip to: 2480
/* 2379 */    MCD::OPC_ExtractField, 11, 3,  // Inst{13-11} ...
/* 2382 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 2403
/* 2387 */    MCD::OPC_CheckPredicate, 7, 23, 16, 0, // Skip to: 6511
/* 2392 */    MCD::OPC_CheckField, 21, 5, 0, 16, 16, 0, // Skip to: 6511
/* 2399 */    MCD::OPC_Decode, 148, 16, 71, // Opcode: MTHLIP_MM
/* 2403 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 2417
/* 2408 */    MCD::OPC_CheckPredicate, 7, 2, 16, 0, // Skip to: 6511
/* 2413 */    MCD::OPC_Decode, 207, 14, 64, // Opcode: MAQ_S_W_PHR_MM
/* 2417 */    MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 2438
/* 2422 */    MCD::OPC_CheckPredicate, 7, 244, 15, 0, // Skip to: 6511
/* 2427 */    MCD::OPC_CheckField, 21, 5, 0, 237, 15, 0, // Skip to: 6511
/* 2434 */    MCD::OPC_Decode, 137, 19, 71, // Opcode: SHILOV_MM
/* 2438 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 2452
/* 2443 */    MCD::OPC_CheckPredicate, 7, 223, 15, 0, // Skip to: 6511
/* 2448 */    MCD::OPC_Decode, 205, 14, 64, // Opcode: MAQ_S_W_PHL_MM
/* 2452 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 2466
/* 2457 */    MCD::OPC_CheckPredicate, 7, 209, 15, 0, // Skip to: 6511
/* 2462 */    MCD::OPC_Decode, 203, 14, 64, // Opcode: MAQ_SA_W_PHR_MM
/* 2466 */    MCD::OPC_FilterValue, 7, 200, 15, 0, // Skip to: 6511
/* 2471 */    MCD::OPC_CheckPredicate, 7, 195, 15, 0, // Skip to: 6511
/* 2476 */    MCD::OPC_Decode, 201, 14, 64, // Opcode: MAQ_SA_W_PHL_MM
/* 2480 */    MCD::OPC_FilterValue, 10, 115, 0, 0, // Skip to: 2600
/* 2485 */    MCD::OPC_ExtractField, 11, 3,  // Inst{13-11} ...
/* 2488 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2502
/* 2493 */    MCD::OPC_CheckPredicate, 7, 173, 15, 0, // Skip to: 6511
/* 2498 */    MCD::OPC_Decode, 138, 10, 64, // Opcode: DPAQ_S_W_PH_MM
/* 2502 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 2516
/* 2507 */    MCD::OPC_CheckPredicate, 7, 159, 15, 0, // Skip to: 6511
/* 2512 */    MCD::OPC_Decode, 194, 14, 64, // Opcode: MADD_DSP_MM
/* 2516 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2530
/* 2521 */    MCD::OPC_CheckPredicate, 7, 145, 15, 0, // Skip to: 6511
/* 2526 */    MCD::OPC_Decode, 136, 10, 64, // Opcode: DPAQ_SA_L_W_MM
/* 2530 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 2544
/* 2535 */    MCD::OPC_CheckPredicate, 7, 131, 15, 0, // Skip to: 6511
/* 2540 */    MCD::OPC_Decode, 184, 14, 64, // Opcode: MADDU_DSP_MM
/* 2544 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 2558
/* 2549 */    MCD::OPC_CheckPredicate, 8, 117, 15, 0, // Skip to: 6511
/* 2554 */    MCD::OPC_Decode, 134, 10, 64, // Opcode: DPAQX_S_W_PH_MMR2
/* 2558 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 2572
/* 2563 */    MCD::OPC_CheckPredicate, 7, 103, 15, 0, // Skip to: 6511
/* 2568 */    MCD::OPC_Decode, 245, 15, 64, // Opcode: MSUB_DSP_MM
/* 2572 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 2586
/* 2577 */    MCD::OPC_CheckPredicate, 8, 89, 15, 0, // Skip to: 6511
/* 2582 */    MCD::OPC_Decode, 132, 10, 64, // Opcode: DPAQX_SA_W_PH_MMR2
/* 2586 */    MCD::OPC_FilterValue, 7, 80, 15, 0, // Skip to: 6511
/* 2591 */    MCD::OPC_CheckPredicate, 7, 75, 15, 0, // Skip to: 6511
/* 2596 */    MCD::OPC_Decode, 235, 15, 64, // Opcode: MSUBU_DSP_MM
/* 2600 */    MCD::OPC_FilterValue, 12, 27, 1, 0, // Skip to: 2888
/* 2605 */    MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 2608 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2622
/* 2613 */    MCD::OPC_CheckPredicate, 7, 53, 15, 0, // Skip to: 6511
/* 2618 */    MCD::OPC_Decode, 144, 18, 72, // Opcode: REPLV_PH_MM
/* 2622 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2636
/* 2627 */    MCD::OPC_CheckPredicate, 7, 39, 15, 0, // Skip to: 6511
/* 2632 */    MCD::OPC_Decode, 146, 18, 72, // Opcode: REPLV_QB_MM
/* 2636 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 2650
/* 2641 */    MCD::OPC_CheckPredicate, 6, 25, 15, 0, // Skip to: 6511
/* 2646 */    MCD::OPC_Decode, 230, 18, 68, // Opcode: SEB_MM
/* 2650 */    MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 2664
/* 2655 */    MCD::OPC_CheckPredicate, 6, 11, 15, 0, // Skip to: 6511
/* 2660 */    MCD::OPC_Decode, 233, 18, 68, // Opcode: SEH_MM
/* 2664 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 2678
/* 2669 */    MCD::OPC_CheckPredicate, 6, 253, 14, 0, // Skip to: 6511
/* 2674 */    MCD::OPC_Decode, 173, 7, 68, // Opcode: CLO_MM
/* 2678 */    MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 2692
/* 2683 */    MCD::OPC_CheckPredicate, 6, 239, 14, 0, // Skip to: 6511
/* 2688 */    MCD::OPC_Decode, 193, 7, 68, // Opcode: CLZ_MM
/* 2692 */    MCD::OPC_FilterValue, 13, 9, 0, 0, // Skip to: 2706
/* 2697 */    MCD::OPC_CheckPredicate, 5, 225, 14, 0, // Skip to: 6511
/* 2702 */    MCD::OPC_Decode, 134, 18, 73, // Opcode: RDHWR_MM
/* 2706 */    MCD::OPC_FilterValue, 14, 9, 0, 0, // Skip to: 2720
/* 2711 */    MCD::OPC_CheckPredicate, 7, 211, 14, 0, // Skip to: 6511
/* 2716 */    MCD::OPC_Decode, 193, 17, 67, // Opcode: PRECEQU_PH_QBLA_MM
/* 2720 */    MCD::OPC_FilterValue, 15, 9, 0, 0, // Skip to: 2734
/* 2725 */    MCD::OPC_CheckPredicate, 6, 197, 14, 0, // Skip to: 6511
/* 2730 */    MCD::OPC_Decode, 241, 21, 68, // Opcode: WSBH_MM
/* 2734 */    MCD::OPC_FilterValue, 17, 9, 0, 0, // Skip to: 2748
/* 2739 */    MCD::OPC_CheckPredicate, 5, 183, 14, 0, // Skip to: 6511
/* 2744 */    MCD::OPC_Decode, 193, 16, 74, // Opcode: MULT_MM
/* 2748 */    MCD::OPC_FilterValue, 18, 9, 0, 0, // Skip to: 2762
/* 2753 */    MCD::OPC_CheckPredicate, 7, 169, 14, 0, // Skip to: 6511
/* 2758 */    MCD::OPC_Decode, 197, 17, 67, // Opcode: PRECEQU_PH_QBRA_MM
/* 2762 */    MCD::OPC_FilterValue, 19, 9, 0, 0, // Skip to: 2776
/* 2767 */    MCD::OPC_CheckPredicate, 5, 155, 14, 0, // Skip to: 6511
/* 2772 */    MCD::OPC_Decode, 195, 16, 74, // Opcode: MULTu_MM
/* 2776 */    MCD::OPC_FilterValue, 21, 9, 0, 0, // Skip to: 2790
/* 2781 */    MCD::OPC_CheckPredicate, 5, 141, 14, 0, // Skip to: 6511
/* 2786 */    MCD::OPC_Decode, 223, 18, 74, // Opcode: SDIV_MM
/* 2790 */    MCD::OPC_FilterValue, 22, 9, 0, 0, // Skip to: 2804
/* 2795 */    MCD::OPC_CheckPredicate, 7, 127, 14, 0, // Skip to: 6511
/* 2800 */    MCD::OPC_Decode, 205, 17, 67, // Opcode: PRECEU_PH_QBLA_MM
/* 2804 */    MCD::OPC_FilterValue, 23, 9, 0, 0, // Skip to: 2818
/* 2809 */    MCD::OPC_CheckPredicate, 5, 113, 14, 0, // Skip to: 6511
/* 2814 */    MCD::OPC_Decode, 226, 21, 74, // Opcode: UDIV_MM
/* 2818 */    MCD::OPC_FilterValue, 25, 9, 0, 0, // Skip to: 2832
/* 2823 */    MCD::OPC_CheckPredicate, 5, 99, 14, 0, // Skip to: 6511
/* 2828 */    MCD::OPC_Decode, 195, 14, 74, // Opcode: MADD_MM
/* 2832 */    MCD::OPC_FilterValue, 26, 9, 0, 0, // Skip to: 2846
/* 2837 */    MCD::OPC_CheckPredicate, 7, 85, 14, 0, // Skip to: 6511
/* 2842 */    MCD::OPC_Decode, 209, 17, 67, // Opcode: PRECEU_PH_QBRA_MM
/* 2846 */    MCD::OPC_FilterValue, 27, 9, 0, 0, // Skip to: 2860
/* 2851 */    MCD::OPC_CheckPredicate, 5, 71, 14, 0, // Skip to: 6511
/* 2856 */    MCD::OPC_Decode, 185, 14, 74, // Opcode: MADDU_MM
/* 2860 */    MCD::OPC_FilterValue, 29, 9, 0, 0, // Skip to: 2874
/* 2865 */    MCD::OPC_CheckPredicate, 5, 57, 14, 0, // Skip to: 6511
/* 2870 */    MCD::OPC_Decode, 246, 15, 74, // Opcode: MSUB_MM
/* 2874 */    MCD::OPC_FilterValue, 31, 48, 14, 0, // Skip to: 6511
/* 2879 */    MCD::OPC_CheckPredicate, 5, 43, 14, 0, // Skip to: 6511
/* 2884 */    MCD::OPC_Decode, 236, 15, 74, // Opcode: MSUBU_MM
/* 2888 */    MCD::OPC_FilterValue, 13, 206, 0, 0, // Skip to: 3099
/* 2893 */    MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 2896 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 2917
/* 2901 */    MCD::OPC_CheckPredicate, 6, 21, 14, 0, // Skip to: 6511
/* 2906 */    MCD::OPC_CheckField, 16, 10, 0, 14, 14, 0, // Skip to: 6511
/* 2913 */    MCD::OPC_Decode, 195, 21, 0, // Opcode: TLBP_MM
/* 2917 */    MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 2938
/* 2922 */    MCD::OPC_CheckPredicate, 6, 0, 14, 0, // Skip to: 6511
/* 2927 */    MCD::OPC_CheckField, 16, 10, 0, 249, 13, 0, // Skip to: 6511
/* 2934 */    MCD::OPC_Decode, 197, 21, 0, // Opcode: TLBR_MM
/* 2938 */    MCD::OPC_FilterValue, 4, 16, 0, 0, // Skip to: 2959
/* 2943 */    MCD::OPC_CheckPredicate, 6, 235, 13, 0, // Skip to: 6511
/* 2948 */    MCD::OPC_CheckField, 16, 10, 0, 228, 13, 0, // Skip to: 6511
/* 2955 */    MCD::OPC_Decode, 199, 21, 0, // Opcode: TLBWI_MM
/* 2959 */    MCD::OPC_FilterValue, 6, 16, 0, 0, // Skip to: 2980
/* 2964 */    MCD::OPC_CheckPredicate, 6, 214, 13, 0, // Skip to: 6511
/* 2969 */    MCD::OPC_CheckField, 16, 10, 0, 207, 13, 0, // Skip to: 6511
/* 2976 */    MCD::OPC_Decode, 201, 21, 0, // Opcode: TLBWR_MM
/* 2980 */    MCD::OPC_FilterValue, 13, 16, 0, 0, // Skip to: 3001
/* 2985 */    MCD::OPC_CheckPredicate, 6, 193, 13, 0, // Skip to: 6511
/* 2990 */    MCD::OPC_CheckField, 21, 5, 0, 186, 13, 0, // Skip to: 6511
/* 2997 */    MCD::OPC_Decode, 141, 21, 75, // Opcode: SYNC_MM
/* 3001 */    MCD::OPC_FilterValue, 17, 9, 0, 0, // Skip to: 3015
/* 3006 */    MCD::OPC_CheckPredicate, 6, 172, 13, 0, // Skip to: 6511
/* 3011 */    MCD::OPC_Decode, 144, 21, 76, // Opcode: SYSCALL_MM
/* 3015 */    MCD::OPC_FilterValue, 18, 9, 0, 0, // Skip to: 3029
/* 3020 */    MCD::OPC_CheckPredicate, 6, 158, 13, 0, // Skip to: 6511
/* 3025 */    MCD::OPC_Decode, 235, 21, 76, // Opcode: WAIT_MM
/* 3029 */    MCD::OPC_FilterValue, 24, 9, 0, 0, // Skip to: 3043
/* 3034 */    MCD::OPC_CheckPredicate, 9, 144, 13, 0, // Skip to: 6511
/* 3039 */    MCD::OPC_Decode, 232, 12, 76, // Opcode: HYPCALL_MM
/* 3043 */    MCD::OPC_FilterValue, 27, 9, 0, 0, // Skip to: 3057
/* 3048 */    MCD::OPC_CheckPredicate, 6, 130, 13, 0, // Skip to: 6511
/* 3053 */    MCD::OPC_Decode, 211, 18, 76, // Opcode: SDBBP_MM
/* 3057 */    MCD::OPC_FilterValue, 28, 16, 0, 0, // Skip to: 3078
/* 3062 */    MCD::OPC_CheckPredicate, 6, 116, 13, 0, // Skip to: 6511
/* 3067 */    MCD::OPC_CheckField, 16, 10, 0, 109, 13, 0, // Skip to: 6511
/* 3074 */    MCD::OPC_Decode, 201, 9, 0, // Opcode: DERET_MM
/* 3078 */    MCD::OPC_FilterValue, 30, 100, 13, 0, // Skip to: 6511
/* 3083 */    MCD::OPC_CheckPredicate, 6, 95, 13, 0, // Skip to: 6511
/* 3088 */    MCD::OPC_CheckField, 16, 10, 0, 88, 13, 0, // Skip to: 6511
/* 3095 */    MCD::OPC_Decode, 204, 10, 0, // Opcode: ERET_MM
/* 3099 */    MCD::OPC_FilterValue, 15, 16, 0, 0, // Skip to: 3120
/* 3104 */    MCD::OPC_CheckPredicate, 8, 74, 13, 0, // Skip to: 6511
/* 3109 */    MCD::OPC_CheckField, 11, 1, 0, 67, 13, 0, // Skip to: 6511
/* 3116 */    MCD::OPC_Decode, 180, 19, 58, // Opcode: SHRL_PH_MMR2
/* 3120 */    MCD::OPC_FilterValue, 16, 31, 0, 0, // Skip to: 3156
/* 3125 */    MCD::OPC_ExtractField, 11, 1,  // Inst{11} ...
/* 3128 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3142
/* 3133 */    MCD::OPC_CheckPredicate, 6, 45, 13, 0, // Skip to: 6511
/* 3138 */    MCD::OPC_Decode, 176, 21, 59, // Opcode: TGEU_MM
/* 3142 */    MCD::OPC_FilterValue, 1, 36, 13, 0, // Skip to: 6511
/* 3147 */    MCD::OPC_CheckPredicate, 6, 31, 13, 0, // Skip to: 6511
/* 3152 */    MCD::OPC_Decode, 212, 21, 59, // Opcode: TNE_MM
/* 3156 */    MCD::OPC_FilterValue, 18, 115, 0, 0, // Skip to: 3276
/* 3161 */    MCD::OPC_ExtractField, 11, 3,  // Inst{13-11} ...
/* 3164 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3178
/* 3169 */    MCD::OPC_CheckPredicate, 8, 9, 13, 0, // Skip to: 6511
/* 3174 */    MCD::OPC_Decode, 169, 10, 64, // Opcode: DPS_W_PH_MMR2
/* 3178 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3192
/* 3183 */    MCD::OPC_CheckPredicate, 7, 251, 12, 0, // Skip to: 6511
/* 3188 */    MCD::OPC_Decode, 192, 16, 77, // Opcode: MULT_DSP_MM
/* 3192 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 3206
/* 3197 */    MCD::OPC_CheckPredicate, 8, 237, 12, 0, // Skip to: 6511
/* 3202 */    MCD::OPC_Decode, 167, 10, 64, // Opcode: DPSX_W_PH_MMR2
/* 3206 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 3220
/* 3211 */    MCD::OPC_CheckPredicate, 7, 223, 12, 0, // Skip to: 6511
/* 3216 */    MCD::OPC_Decode, 190, 16, 77, // Opcode: MULTU_DSP_MM
/* 3220 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 3234
/* 3225 */    MCD::OPC_CheckPredicate, 7, 209, 12, 0, // Skip to: 6511
/* 3230 */    MCD::OPC_Decode, 163, 10, 64, // Opcode: DPSU_H_QBL_MM
/* 3234 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 3248
/* 3239 */    MCD::OPC_CheckPredicate, 8, 195, 12, 0, // Skip to: 6511
/* 3244 */    MCD::OPC_Decode, 187, 16, 64, // Opcode: MULSA_W_PH_MMR2
/* 3248 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 3262
/* 3253 */    MCD::OPC_CheckPredicate, 7, 181, 12, 0, // Skip to: 6511
/* 3258 */    MCD::OPC_Decode, 165, 10, 64, // Opcode: DPSU_H_QBR_MM
/* 3262 */    MCD::OPC_FilterValue, 7, 172, 12, 0, // Skip to: 6511
/* 3267 */    MCD::OPC_CheckPredicate, 7, 167, 12, 0, // Skip to: 6511
/* 3272 */    MCD::OPC_Decode, 185, 16, 64, // Opcode: MULSAQ_S_W_PH_MM
/* 3276 */    MCD::OPC_FilterValue, 19, 16, 0, 0, // Skip to: 3297
/* 3281 */    MCD::OPC_CheckPredicate, 9, 153, 12, 0, // Skip to: 6511
/* 3286 */    MCD::OPC_CheckField, 14, 2, 0, 146, 12, 0, // Skip to: 6511
/* 3293 */    MCD::OPC_Decode, 245, 14, 56, // Opcode: MFGC0_MM
/* 3297 */    MCD::OPC_FilterValue, 20, 31, 0, 0, // Skip to: 3333
/* 3302 */    MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 3305 */    MCD::OPC_FilterValue, 25, 9, 0, 0, // Skip to: 3319
/* 3310 */    MCD::OPC_CheckPredicate, 6, 124, 12, 0, // Skip to: 6511
/* 3315 */    MCD::OPC_Decode, 146, 7, 78, // Opcode: CFC2_MM
/* 3319 */    MCD::OPC_FilterValue, 27, 115, 12, 0, // Skip to: 6511
/* 3324 */    MCD::OPC_CheckPredicate, 6, 110, 12, 0, // Skip to: 6511
/* 3329 */    MCD::OPC_Decode, 173, 8, 79, // Opcode: CTC2_MM
/* 3333 */    MCD::OPC_FilterValue, 21, 87, 0, 0, // Skip to: 3425
/* 3338 */    MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 3341 */    MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 3362
/* 3346 */    MCD::OPC_CheckPredicate, 5, 88, 12, 0, // Skip to: 6511
/* 3351 */    MCD::OPC_CheckField, 21, 5, 0, 81, 12, 0, // Skip to: 6511
/* 3358 */    MCD::OPC_Decode, 131, 15, 80, // Opcode: MFHI_MM
/* 3362 */    MCD::OPC_FilterValue, 3, 16, 0, 0, // Skip to: 3383
/* 3367 */    MCD::OPC_CheckPredicate, 5, 67, 12, 0, // Skip to: 6511
/* 3372 */    MCD::OPC_CheckField, 21, 5, 0, 60, 12, 0, // Skip to: 6511
/* 3379 */    MCD::OPC_Decode, 137, 15, 80, // Opcode: MFLO_MM
/* 3383 */    MCD::OPC_FilterValue, 5, 16, 0, 0, // Skip to: 3404
/* 3388 */    MCD::OPC_CheckPredicate, 5, 46, 12, 0, // Skip to: 6511
/* 3393 */    MCD::OPC_CheckField, 21, 5, 0, 39, 12, 0, // Skip to: 6511
/* 3400 */    MCD::OPC_Decode, 146, 16, 80, // Opcode: MTHI_MM
/* 3404 */    MCD::OPC_FilterValue, 7, 30, 12, 0, // Skip to: 6511
/* 3409 */    MCD::OPC_CheckPredicate, 5, 25, 12, 0, // Skip to: 6511
/* 3414 */    MCD::OPC_CheckField, 21, 5, 0, 18, 12, 0, // Skip to: 6511
/* 3421 */    MCD::OPC_Decode, 153, 16, 80, // Opcode: MTLO_MM
/* 3425 */    MCD::OPC_FilterValue, 23, 16, 0, 0, // Skip to: 3446
/* 3430 */    MCD::OPC_CheckPredicate, 7, 4, 12, 0, // Skip to: 6511
/* 3435 */    MCD::OPC_CheckField, 11, 2, 0, 253, 11, 0, // Skip to: 6511
/* 3442 */    MCD::OPC_Decode, 150, 18, 81, // Opcode: REPL_QB_MM
/* 3446 */    MCD::OPC_FilterValue, 25, 115, 0, 0, // Skip to: 3566
/* 3451 */    MCD::OPC_ExtractField, 11, 3,  // Inst{13-11} ...
/* 3454 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3468
/* 3459 */    MCD::OPC_CheckPredicate, 7, 231, 11, 0, // Skip to: 6511
/* 3464 */    MCD::OPC_Decode, 131, 18, 82, // Opcode: RDDSP_MM
/* 3468 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3482
/* 3473 */    MCD::OPC_CheckPredicate, 7, 217, 11, 0, // Skip to: 6511
/* 3478 */    MCD::OPC_Decode, 233, 10, 83, // Opcode: EXTR_W_MM
/* 3482 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 3496
/* 3487 */    MCD::OPC_CheckPredicate, 7, 203, 11, 0, // Skip to: 6511
/* 3492 */    MCD::OPC_Decode, 238, 21, 82, // Opcode: WRDSP_MM
/* 3496 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 3510
/* 3501 */    MCD::OPC_CheckPredicate, 7, 189, 11, 0, // Skip to: 6511
/* 3506 */    MCD::OPC_Decode, 229, 10, 83, // Opcode: EXTR_R_W_MM
/* 3510 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 3524
/* 3515 */    MCD::OPC_CheckPredicate, 7, 175, 11, 0, // Skip to: 6511
/* 3520 */    MCD::OPC_Decode, 217, 10, 83, // Opcode: EXTP_MM
/* 3524 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 3538
/* 3529 */    MCD::OPC_CheckPredicate, 7, 161, 11, 0, // Skip to: 6511
/* 3534 */    MCD::OPC_Decode, 227, 10, 83, // Opcode: EXTR_RS_W_MM
/* 3538 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 3552
/* 3543 */    MCD::OPC_CheckPredicate, 7, 147, 11, 0, // Skip to: 6511
/* 3548 */    MCD::OPC_Decode, 214, 10, 83, // Opcode: EXTPDP_MM
/* 3552 */    MCD::OPC_FilterValue, 7, 138, 11, 0, // Skip to: 6511
/* 3557 */    MCD::OPC_CheckPredicate, 7, 133, 11, 0, // Skip to: 6511
/* 3562 */    MCD::OPC_Decode, 231, 10, 83, // Opcode: EXTR_S_H_MM
/* 3566 */    MCD::OPC_FilterValue, 26, 115, 0, 0, // Skip to: 3686
/* 3571 */    MCD::OPC_ExtractField, 11, 3,  // Inst{13-11} ...
/* 3574 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3588
/* 3579 */    MCD::OPC_CheckPredicate, 7, 111, 11, 0, // Skip to: 6511
/* 3584 */    MCD::OPC_Decode, 155, 10, 64, // Opcode: DPSQ_S_W_PH_MM
/* 3588 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3602
/* 3593 */    MCD::OPC_CheckPredicate, 7, 97, 11, 0, // Skip to: 6511
/* 3598 */    MCD::OPC_Decode, 225, 10, 66, // Opcode: EXTRV_W_MM
/* 3602 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 3616
/* 3607 */    MCD::OPC_CheckPredicate, 7, 83, 11, 0, // Skip to: 6511
/* 3612 */    MCD::OPC_Decode, 153, 10, 64, // Opcode: DPSQ_SA_L_W_MM
/* 3616 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 3630
/* 3621 */    MCD::OPC_CheckPredicate, 7, 69, 11, 0, // Skip to: 6511
/* 3626 */    MCD::OPC_Decode, 221, 10, 66, // Opcode: EXTRV_R_W_MM
/* 3630 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 3644
/* 3635 */    MCD::OPC_CheckPredicate, 8, 55, 11, 0, // Skip to: 6511
/* 3640 */    MCD::OPC_Decode, 151, 10, 64, // Opcode: DPSQX_S_W_PH_MMR2
/* 3644 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 3658
/* 3649 */    MCD::OPC_CheckPredicate, 7, 41, 11, 0, // Skip to: 6511
/* 3654 */    MCD::OPC_Decode, 219, 10, 66, // Opcode: EXTRV_RS_W_MM
/* 3658 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 3672
/* 3663 */    MCD::OPC_CheckPredicate, 8, 27, 11, 0, // Skip to: 6511
/* 3668 */    MCD::OPC_Decode, 149, 10, 64, // Opcode: DPSQX_SA_W_PH_MMR2
/* 3672 */    MCD::OPC_FilterValue, 7, 18, 11, 0, // Skip to: 6511
/* 3677 */    MCD::OPC_CheckPredicate, 7, 13, 11, 0, // Skip to: 6511
/* 3682 */    MCD::OPC_Decode, 223, 10, 66, // Opcode: EXTRV_S_H_MM
/* 3686 */    MCD::OPC_FilterValue, 27, 16, 0, 0, // Skip to: 3707
/* 3691 */    MCD::OPC_CheckPredicate, 9, 255, 10, 0, // Skip to: 6511
/* 3696 */    MCD::OPC_CheckField, 14, 2, 0, 248, 10, 0, // Skip to: 6511
/* 3703 */    MCD::OPC_Decode, 133, 16, 57, // Opcode: MTGC0_MM
/* 3707 */    MCD::OPC_FilterValue, 28, 47, 0, 0, // Skip to: 3759
/* 3712 */    MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 3715 */    MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 3745
/* 3720 */    MCD::OPC_CheckPredicate, 5, 11, 0, 0, // Skip to: 3736
/* 3725 */    MCD::OPC_CheckField, 21, 5, 0, 4, 0, 0, // Skip to: 3736
/* 3732 */    MCD::OPC_Decode, 168, 13, 80, // Opcode: JR_MM
/* 3736 */    MCD::OPC_CheckPredicate, 5, 210, 10, 0, // Skip to: 6511
/* 3741 */    MCD::OPC_Decode, 146, 13, 68, // Opcode: JALR_MM
/* 3745 */    MCD::OPC_FilterValue, 9, 201, 10, 0, // Skip to: 6511
/* 3750 */    MCD::OPC_CheckPredicate, 5, 196, 10, 0, // Skip to: 6511
/* 3755 */    MCD::OPC_Decode, 143, 13, 68, // Opcode: JALRS_MM
/* 3759 */    MCD::OPC_FilterValue, 29, 187, 10, 0, // Skip to: 6511
/* 3764 */    MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 3767 */    MCD::OPC_FilterValue, 8, 16, 0, 0, // Skip to: 3788
/* 3772 */    MCD::OPC_CheckPredicate, 6, 174, 10, 0, // Skip to: 6511
/* 3777 */    MCD::OPC_CheckField, 21, 5, 0, 167, 10, 0, // Skip to: 6511
/* 3784 */    MCD::OPC_Decode, 223, 9, 80, // Opcode: DI_MM
/* 3788 */    MCD::OPC_FilterValue, 10, 158, 10, 0, // Skip to: 6511
/* 3793 */    MCD::OPC_CheckPredicate, 6, 153, 10, 0, // Skip to: 6511
/* 3798 */    MCD::OPC_CheckField, 21, 5, 0, 146, 10, 0, // Skip to: 6511
/* 3805 */    MCD::OPC_Decode, 198, 10, 80, // Opcode: EI_MM
/* 3809 */    MCD::OPC_FilterValue, 61, 137, 10, 0, // Skip to: 6511
/* 3814 */    MCD::OPC_CheckPredicate, 7, 132, 10, 0, // Skip to: 6511
/* 3819 */    MCD::OPC_CheckField, 6, 5, 0, 125, 10, 0, // Skip to: 6511
/* 3826 */    MCD::OPC_Decode, 148, 18, 84, // Opcode: REPL_PH_MM
/* 3830 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 3844
/* 3835 */    MCD::OPC_CheckPredicate, 5, 111, 10, 0, // Skip to: 6511
/* 3840 */    MCD::OPC_Decode, 243, 4, 85, // Opcode: ADDi_MM
/* 3844 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 3858
/* 3849 */    MCD::OPC_CheckPredicate, 6, 97, 10, 0, // Skip to: 6511
/* 3854 */    MCD::OPC_Decode, 190, 13, 86, // Opcode: LBu_MM
/* 3858 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 3872
/* 3863 */    MCD::OPC_CheckPredicate, 6, 83, 10, 0, // Skip to: 6511
/* 3868 */    MCD::OPC_Decode, 194, 18, 86, // Opcode: SB_MM
/* 3872 */    MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 3886
/* 3877 */    MCD::OPC_CheckPredicate, 6, 69, 10, 0, // Skip to: 6511
/* 3882 */    MCD::OPC_Decode, 184, 13, 86, // Opcode: LB_MM
/* 3886 */    MCD::OPC_FilterValue, 8, 73, 0, 0, // Skip to: 3964
/* 3891 */    MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 3894 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3908
/* 3899 */    MCD::OPC_CheckPredicate, 6, 47, 10, 0, // Skip to: 6511
/* 3904 */    MCD::OPC_Decode, 147, 14, 87, // Opcode: LWP_MM
/* 3908 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 3922
/* 3913 */    MCD::OPC_CheckPredicate, 6, 33, 10, 0, // Skip to: 6511
/* 3918 */    MCD::OPC_Decode, 144, 14, 87, // Opcode: LWM32_MM
/* 3922 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 3936
/* 3927 */    MCD::OPC_CheckPredicate, 5, 19, 10, 0, // Skip to: 6511
/* 3932 */    MCD::OPC_Decode, 250, 6, 88, // Opcode: CACHE_MM
/* 3936 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 3950
/* 3941 */    MCD::OPC_CheckPredicate, 6, 5, 10, 0, // Skip to: 6511
/* 3946 */    MCD::OPC_Decode, 253, 20, 87, // Opcode: SWP_MM
/* 3950 */    MCD::OPC_FilterValue, 13, 252, 9, 0, // Skip to: 6511
/* 3955 */    MCD::OPC_CheckPredicate, 6, 247, 9, 0, // Skip to: 6511
/* 3960 */    MCD::OPC_Decode, 252, 20, 87, // Opcode: SWM32_MM
/* 3964 */    MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 3978
/* 3969 */    MCD::OPC_CheckPredicate, 5, 233, 9, 0, // Skip to: 6511
/* 3974 */    MCD::OPC_Decode, 245, 4, 85, // Opcode: ADDiu_MM
/* 3978 */    MCD::OPC_FilterValue, 13, 9, 0, 0, // Skip to: 3992
/* 3983 */    MCD::OPC_CheckPredicate, 6, 219, 9, 0, // Skip to: 6511
/* 3988 */    MCD::OPC_Decode, 228, 13, 86, // Opcode: LHu_MM
/* 3992 */    MCD::OPC_FilterValue, 14, 9, 0, 0, // Skip to: 4006
/* 3997 */    MCD::OPC_CheckPredicate, 6, 205, 9, 0, // Skip to: 6511
/* 4002 */    MCD::OPC_Decode, 183, 19, 86, // Opcode: SH_MM
/* 4006 */    MCD::OPC_FilterValue, 15, 9, 0, 0, // Skip to: 4020
/* 4011 */    MCD::OPC_CheckPredicate, 6, 191, 9, 0, // Skip to: 6511
/* 4016 */    MCD::OPC_Decode, 223, 13, 86, // Opcode: LH_MM
/* 4020 */    MCD::OPC_FilterValue, 16, 83, 1, 0, // Skip to: 4364
/* 4025 */    MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 4028 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4042
/* 4033 */    MCD::OPC_CheckPredicate, 5, 169, 9, 0, // Skip to: 6511
/* 4038 */    MCD::OPC_Decode, 176, 6, 89, // Opcode: BLTZ_MM
/* 4042 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4056
/* 4047 */    MCD::OPC_CheckPredicate, 5, 155, 9, 0, // Skip to: 6511
/* 4052 */    MCD::OPC_Decode, 171, 6, 89, // Opcode: BLTZAL_MM
/* 4056 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 4070
/* 4061 */    MCD::OPC_CheckPredicate, 5, 141, 9, 0, // Skip to: 6511
/* 4066 */    MCD::OPC_Decode, 246, 5, 89, // Opcode: BGEZ_MM
/* 4070 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 4084
/* 4075 */    MCD::OPC_CheckPredicate, 5, 127, 9, 0, // Skip to: 6511
/* 4080 */    MCD::OPC_Decode, 241, 5, 89, // Opcode: BGEZAL_MM
/* 4084 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 4098
/* 4089 */    MCD::OPC_CheckPredicate, 5, 113, 9, 0, // Skip to: 6511
/* 4094 */    MCD::OPC_Decode, 157, 6, 89, // Opcode: BLEZ_MM
/* 4098 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 4112
/* 4103 */    MCD::OPC_CheckPredicate, 5, 99, 9, 0, // Skip to: 6511
/* 4108 */    MCD::OPC_Decode, 201, 6, 89, // Opcode: BNEZC_MM
/* 4112 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 4126
/* 4117 */    MCD::OPC_CheckPredicate, 5, 85, 9, 0, // Skip to: 6511
/* 4122 */    MCD::OPC_Decode, 255, 5, 89, // Opcode: BGTZ_MM
/* 4126 */    MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 4140
/* 4131 */    MCD::OPC_CheckPredicate, 5, 71, 9, 0, // Skip to: 6511
/* 4136 */    MCD::OPC_Decode, 225, 5, 89, // Opcode: BEQZC_MM
/* 4140 */    MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 4154
/* 4145 */    MCD::OPC_CheckPredicate, 5, 57, 9, 0, // Skip to: 6511
/* 4150 */    MCD::OPC_Decode, 205, 21, 90, // Opcode: TLTI_MM
/* 4154 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 4168
/* 4159 */    MCD::OPC_CheckPredicate, 5, 43, 9, 0, // Skip to: 6511
/* 4164 */    MCD::OPC_Decode, 174, 21, 90, // Opcode: TGEI_MM
/* 4168 */    MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 4182
/* 4173 */    MCD::OPC_CheckPredicate, 5, 29, 9, 0, // Skip to: 6511
/* 4178 */    MCD::OPC_Decode, 204, 21, 90, // Opcode: TLTIU_MM
/* 4182 */    MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 4196
/* 4187 */    MCD::OPC_CheckPredicate, 5, 15, 9, 0, // Skip to: 6511
/* 4192 */    MCD::OPC_Decode, 173, 21, 90, // Opcode: TGEIU_MM
/* 4196 */    MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 4210
/* 4201 */    MCD::OPC_CheckPredicate, 5, 1, 9, 0, // Skip to: 6511
/* 4206 */    MCD::OPC_Decode, 211, 21, 90, // Opcode: TNEI_MM
/* 4210 */    MCD::OPC_FilterValue, 13, 9, 0, 0, // Skip to: 4224
/* 4215 */    MCD::OPC_CheckPredicate, 5, 243, 8, 0, // Skip to: 6511
/* 4220 */    MCD::OPC_Decode, 250, 13, 91, // Opcode: LUi_MM
/* 4224 */    MCD::OPC_FilterValue, 14, 9, 0, 0, // Skip to: 4238
/* 4229 */    MCD::OPC_CheckPredicate, 5, 229, 8, 0, // Skip to: 6511
/* 4234 */    MCD::OPC_Decode, 168, 21, 90, // Opcode: TEQI_MM
/* 4238 */    MCD::OPC_FilterValue, 16, 9, 0, 0, // Skip to: 4252
/* 4243 */    MCD::OPC_CheckPredicate, 5, 215, 8, 0, // Skip to: 6511
/* 4248 */    MCD::OPC_Decode, 139, 21, 92, // Opcode: SYNCI_MM
/* 4252 */    MCD::OPC_FilterValue, 17, 9, 0, 0, // Skip to: 4266
/* 4257 */    MCD::OPC_CheckPredicate, 5, 201, 8, 0, // Skip to: 6511
/* 4262 */    MCD::OPC_Decode, 170, 6, 89, // Opcode: BLTZALS_MM
/* 4266 */    MCD::OPC_FilterValue, 19, 9, 0, 0, // Skip to: 4280
/* 4271 */    MCD::OPC_CheckPredicate, 5, 187, 8, 0, // Skip to: 6511
/* 4276 */    MCD::OPC_Decode, 240, 5, 89, // Opcode: BGEZALS_MM
/* 4280 */    MCD::OPC_FilterValue, 25, 16, 0, 0, // Skip to: 4301
/* 4285 */    MCD::OPC_CheckPredicate, 10, 173, 8, 0, // Skip to: 6511
/* 4290 */    MCD::OPC_CheckField, 16, 5, 0, 166, 8, 0, // Skip to: 6511
/* 4297 */    MCD::OPC_Decode, 214, 6, 93, // Opcode: BPOSGE32C_MMR3
/* 4301 */    MCD::OPC_FilterValue, 27, 16, 0, 0, // Skip to: 4322
/* 4306 */    MCD::OPC_CheckPredicate, 11, 152, 8, 0, // Skip to: 6511
/* 4311 */    MCD::OPC_CheckField, 16, 5, 0, 145, 8, 0, // Skip to: 6511
/* 4318 */    MCD::OPC_Decode, 215, 6, 94, // Opcode: BPOSGE32_MM
/* 4322 */    MCD::OPC_FilterValue, 28, 16, 0, 0, // Skip to: 4343
/* 4327 */    MCD::OPC_CheckPredicate, 12, 131, 8, 0, // Skip to: 6511
/* 4332 */    MCD::OPC_CheckField, 16, 2, 0, 124, 8, 0, // Skip to: 6511
/* 4339 */    MCD::OPC_Decode, 194, 5, 95, // Opcode: BC1F_MM
/* 4343 */    MCD::OPC_FilterValue, 29, 115, 8, 0, // Skip to: 6511
/* 4348 */    MCD::OPC_CheckPredicate, 12, 110, 8, 0, // Skip to: 6511
/* 4353 */    MCD::OPC_CheckField, 16, 2, 0, 103, 8, 0, // Skip to: 6511
/* 4360 */    MCD::OPC_Decode, 199, 5, 95, // Opcode: BC1T_MM
/* 4364 */    MCD::OPC_FilterValue, 20, 9, 0, 0, // Skip to: 4378
/* 4369 */    MCD::OPC_CheckPredicate, 5, 89, 8, 0, // Skip to: 6511
/* 4374 */    MCD::OPC_Decode, 254, 16, 96, // Opcode: ORi_MM
/* 4378 */    MCD::OPC_FilterValue, 21, 197, 5, 0, // Skip to: 5860
/* 4383 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 4386 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4400
/* 4391 */    MCD::OPC_CheckPredicate, 13, 67, 8, 0, // Skip to: 6511
/* 4396 */    MCD::OPC_Decode, 199, 14, 97, // Opcode: MADD_S_MM
/* 4400 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 4414
/* 4405 */    MCD::OPC_CheckPredicate, 13, 53, 8, 0, // Skip to: 6511
/* 4410 */    MCD::OPC_Decode, 227, 16, 97, // Opcode: NMADD_S_MM
/* 4414 */    MCD::OPC_FilterValue, 8, 59, 0, 0, // Skip to: 4478
/* 4419 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 4422 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4436
/* 4427 */    MCD::OPC_CheckPredicate, 12, 31, 8, 0, // Skip to: 6511
/* 4432 */    MCD::OPC_Decode, 158, 14, 98, // Opcode: LWXC1_MM
/* 4436 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 4450
/* 4441 */    MCD::OPC_CheckPredicate, 12, 17, 8, 0, // Skip to: 6511
/* 4446 */    MCD::OPC_Decode, 134, 21, 98, // Opcode: SWXC1_MM
/* 4450 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 4464
/* 4455 */    MCD::OPC_CheckPredicate, 14, 3, 8, 0, // Skip to: 6511
/* 4460 */    MCD::OPC_Decode, 247, 13, 99, // Opcode: LUXC1_MM
/* 4464 */    MCD::OPC_FilterValue, 6, 250, 7, 0, // Skip to: 6511
/* 4469 */    MCD::OPC_CheckPredicate, 14, 245, 7, 0, // Skip to: 6511
/* 4474 */    MCD::OPC_Decode, 230, 20, 99, // Opcode: SUXC1_MM
/* 4478 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 4492
/* 4483 */    MCD::OPC_CheckPredicate, 15, 231, 7, 0, // Skip to: 6511
/* 4488 */    MCD::OPC_Decode, 191, 14, 100, // Opcode: MADD_D32_MM
/* 4492 */    MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 4506
/* 4497 */    MCD::OPC_CheckPredicate, 15, 217, 7, 0, // Skip to: 6511
/* 4502 */    MCD::OPC_Decode, 224, 16, 100, // Opcode: NMADD_D32_MM
/* 4506 */    MCD::OPC_FilterValue, 32, 101, 0, 0, // Skip to: 4612
/* 4511 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 4514 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 4535
/* 4519 */    MCD::OPC_CheckPredicate, 12, 195, 7, 0, // Skip to: 6511
/* 4524 */    MCD::OPC_CheckField, 11, 2, 0, 188, 7, 0, // Skip to: 6511
/* 4531 */    MCD::OPC_Decode, 193, 15, 101, // Opcode: MOVF_S_MM
/* 4535 */    MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 4556
/* 4540 */    MCD::OPC_CheckPredicate, 12, 174, 7, 0, // Skip to: 6511
/* 4545 */    MCD::OPC_CheckField, 11, 2, 0, 167, 7, 0, // Skip to: 6511
/* 4552 */    MCD::OPC_Decode, 213, 15, 101, // Opcode: MOVT_S_MM
/* 4556 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 4570
/* 4561 */    MCD::OPC_CheckPredicate, 5, 153, 7, 0, // Skip to: 6511
/* 4566 */    MCD::OPC_Decode, 228, 17, 102, // Opcode: PREFX_MM
/* 4570 */    MCD::OPC_FilterValue, 8, 16, 0, 0, // Skip to: 4591
/* 4575 */    MCD::OPC_CheckPredicate, 16, 139, 7, 0, // Skip to: 6511
/* 4580 */    MCD::OPC_CheckField, 11, 2, 0, 132, 7, 0, // Skip to: 6511
/* 4587 */    MCD::OPC_Decode, 187, 15, 103, // Opcode: MOVF_D32_MM
/* 4591 */    MCD::OPC_FilterValue, 9, 123, 7, 0, // Skip to: 6511
/* 4596 */    MCD::OPC_CheckPredicate, 16, 118, 7, 0, // Skip to: 6511
/* 4601 */    MCD::OPC_CheckField, 11, 2, 0, 111, 7, 0, // Skip to: 6511
/* 4608 */    MCD::OPC_Decode, 207, 15, 103, // Opcode: MOVT_D32_MM
/* 4612 */    MCD::OPC_FilterValue, 33, 9, 0, 0, // Skip to: 4626
/* 4617 */    MCD::OPC_CheckPredicate, 13, 97, 7, 0, // Skip to: 6511
/* 4622 */    MCD::OPC_Decode, 250, 15, 97, // Opcode: MSUB_S_MM
/* 4626 */    MCD::OPC_FilterValue, 34, 9, 0, 0, // Skip to: 4640
/* 4631 */    MCD::OPC_CheckPredicate, 13, 83, 7, 0, // Skip to: 6511
/* 4636 */    MCD::OPC_Decode, 232, 16, 97, // Opcode: NMSUB_S_MM
/* 4640 */    MCD::OPC_FilterValue, 41, 9, 0, 0, // Skip to: 4654
/* 4645 */    MCD::OPC_CheckPredicate, 15, 69, 7, 0, // Skip to: 6511
/* 4650 */    MCD::OPC_Decode, 242, 15, 100, // Opcode: MSUB_D32_MM
/* 4654 */    MCD::OPC_FilterValue, 42, 9, 0, 0, // Skip to: 4668
/* 4659 */    MCD::OPC_CheckPredicate, 15, 55, 7, 0, // Skip to: 6511
/* 4664 */    MCD::OPC_Decode, 229, 16, 100, // Opcode: NMSUB_D32_MM
/* 4668 */    MCD::OPC_FilterValue, 48, 59, 0, 0, // Skip to: 4732
/* 4673 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 4676 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 4690
/* 4681 */    MCD::OPC_CheckPredicate, 17, 33, 7, 0, // Skip to: 6511
/* 4686 */    MCD::OPC_Decode, 246, 10, 104, // Opcode: FADD_D32_MM
/* 4690 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 4704
/* 4695 */    MCD::OPC_CheckPredicate, 17, 19, 7, 0, // Skip to: 6511
/* 4700 */    MCD::OPC_Decode, 132, 12, 104, // Opcode: FSUB_D32_MM
/* 4704 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 4718
/* 4709 */    MCD::OPC_CheckPredicate, 17, 5, 7, 0, // Skip to: 6511
/* 4714 */    MCD::OPC_Decode, 217, 11, 104, // Opcode: FMUL_D32_MM
/* 4718 */    MCD::OPC_FilterValue, 7, 252, 6, 0, // Skip to: 6511
/* 4723 */    MCD::OPC_CheckPredicate, 17, 247, 6, 0, // Skip to: 6511
/* 4728 */    MCD::OPC_Decode, 156, 11, 104, // Opcode: FDIV_D32_MM
/* 4732 */    MCD::OPC_FilterValue, 56, 59, 0, 0, // Skip to: 4796
/* 4737 */    MCD::OPC_ExtractField, 6, 4,  // Inst{9-6} ...
/* 4740 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4754
/* 4745 */    MCD::OPC_CheckPredicate, 12, 225, 6, 0, // Skip to: 6511
/* 4750 */    MCD::OPC_Decode, 205, 15, 105, // Opcode: MOVN_I_S_MM
/* 4754 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4768
/* 4759 */    MCD::OPC_CheckPredicate, 12, 211, 6, 0, // Skip to: 6511
/* 4764 */    MCD::OPC_Decode, 225, 15, 105, // Opcode: MOVZ_I_S_MM
/* 4768 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 4782
/* 4773 */    MCD::OPC_CheckPredicate, 16, 197, 6, 0, // Skip to: 6511
/* 4778 */    MCD::OPC_Decode, 199, 15, 106, // Opcode: MOVN_I_D32_MM
/* 4782 */    MCD::OPC_FilterValue, 5, 188, 6, 0, // Skip to: 6511
/* 4787 */    MCD::OPC_CheckPredicate, 16, 183, 6, 0, // Skip to: 6511
/* 4792 */    MCD::OPC_Decode, 219, 15, 106, // Opcode: MOVZ_I_D32_MM
/* 4796 */    MCD::OPC_FilterValue, 59, 91, 2, 0, // Skip to: 5404
/* 4801 */    MCD::OPC_ExtractField, 6, 7,  // Inst{12-6} ...
/* 4804 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 4825
/* 4809 */    MCD::OPC_CheckPredicate, 18, 161, 6, 0, // Skip to: 6511
/* 4814 */    MCD::OPC_CheckField, 13, 3, 1, 154, 6, 0, // Skip to: 6511
/* 4821 */    MCD::OPC_Decode, 240, 14, 107, // Opcode: MFC1_MM
/* 4825 */    MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 4846
/* 4830 */    MCD::OPC_CheckPredicate, 17, 140, 6, 0, // Skip to: 6511
/* 4835 */    MCD::OPC_CheckField, 13, 3, 1, 133, 6, 0, // Skip to: 6511
/* 4842 */    MCD::OPC_Decode, 207, 11, 108, // Opcode: FMOV_D32_MM
/* 4846 */    MCD::OPC_FilterValue, 4, 31, 0, 0, // Skip to: 4882
/* 4851 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 4854 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4868
/* 4859 */    MCD::OPC_CheckPredicate, 19, 111, 6, 0, // Skip to: 6511
/* 4864 */    MCD::OPC_Decode, 191, 8, 109, // Opcode: CVT_L_S_MM
/* 4868 */    MCD::OPC_FilterValue, 2, 102, 6, 0, // Skip to: 6511
/* 4873 */    MCD::OPC_CheckPredicate, 19, 97, 6, 0, // Skip to: 6511
/* 4878 */    MCD::OPC_Decode, 188, 8, 110, // Opcode: CVT_L_D64_MM
/* 4882 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 4896
/* 4887 */    MCD::OPC_CheckPredicate, 12, 83, 6, 0, // Skip to: 6511
/* 4892 */    MCD::OPC_Decode, 191, 15, 111, // Opcode: MOVF_I_MM
/* 4896 */    MCD::OPC_FilterValue, 8, 31, 0, 0, // Skip to: 4932
/* 4901 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 4904 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4918
/* 4909 */    MCD::OPC_CheckPredicate, 20, 61, 6, 0, // Skip to: 6511
/* 4914 */    MCD::OPC_Decode, 175, 18, 112, // Opcode: RSQRT_S_MM
/* 4918 */    MCD::OPC_FilterValue, 2, 52, 6, 0, // Skip to: 6511
/* 4923 */    MCD::OPC_CheckPredicate, 17, 47, 6, 0, // Skip to: 6511
/* 4928 */    MCD::OPC_Decode, 171, 18, 108, // Opcode: RSQRT_D32_MM
/* 4932 */    MCD::OPC_FilterValue, 13, 31, 0, 0, // Skip to: 4968
/* 4937 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 4940 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4954
/* 4945 */    MCD::OPC_CheckPredicate, 18, 25, 6, 0, // Skip to: 6511
/* 4950 */    MCD::OPC_Decode, 243, 10, 112, // Opcode: FABS_S_MM
/* 4954 */    MCD::OPC_FilterValue, 1, 16, 6, 0, // Skip to: 6511
/* 4959 */    MCD::OPC_CheckPredicate, 17, 11, 6, 0, // Skip to: 6511
/* 4964 */    MCD::OPC_Decode, 239, 10, 108, // Opcode: FABS_D32_MM
/* 4968 */    MCD::OPC_FilterValue, 32, 16, 0, 0, // Skip to: 4989
/* 4973 */    MCD::OPC_CheckPredicate, 18, 253, 5, 0, // Skip to: 6511
/* 4978 */    MCD::OPC_CheckField, 13, 3, 1, 246, 5, 0, // Skip to: 6511
/* 4985 */    MCD::OPC_Decode, 128, 16, 113, // Opcode: MTC1_MM
/* 4989 */    MCD::OPC_FilterValue, 36, 31, 0, 0, // Skip to: 5025
/* 4994 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 4997 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 5011
/* 5002 */    MCD::OPC_CheckPredicate, 18, 224, 5, 0, // Skip to: 6511
/* 5007 */    MCD::OPC_Decode, 210, 8, 112, // Opcode: CVT_W_S_MM
/* 5011 */    MCD::OPC_FilterValue, 2, 215, 5, 0, // Skip to: 6511
/* 5016 */    MCD::OPC_CheckPredicate, 17, 210, 5, 0, // Skip to: 6511
/* 5021 */    MCD::OPC_Decode, 206, 8, 114, // Opcode: CVT_W_D32_MM
/* 5025 */    MCD::OPC_FilterValue, 37, 9, 0, 0, // Skip to: 5039
/* 5030 */    MCD::OPC_CheckPredicate, 12, 196, 5, 0, // Skip to: 6511
/* 5035 */    MCD::OPC_Decode, 211, 15, 111, // Opcode: MOVT_I_MM
/* 5039 */    MCD::OPC_FilterValue, 40, 31, 0, 0, // Skip to: 5075
/* 5044 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 5047 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 5061
/* 5052 */    MCD::OPC_CheckPredicate, 18, 174, 5, 0, // Skip to: 6511
/* 5057 */    MCD::OPC_Decode, 128, 12, 112, // Opcode: FSQRT_S_MM
/* 5061 */    MCD::OPC_FilterValue, 2, 165, 5, 0, // Skip to: 6511
/* 5066 */    MCD::OPC_CheckPredicate, 17, 160, 5, 0, // Skip to: 6511
/* 5071 */    MCD::OPC_Decode, 252, 11, 108, // Opcode: FSQRT_D32_MM
/* 5075 */    MCD::OPC_FilterValue, 44, 59, 0, 0, // Skip to: 5139
/* 5080 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 5083 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 5097
/* 5088 */    MCD::OPC_CheckPredicate, 18, 138, 5, 0, // Skip to: 6511
/* 5093 */    MCD::OPC_Decode, 194, 11, 112, // Opcode: FLOOR_W_S_MM
/* 5097 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 5111
/* 5102 */    MCD::OPC_CheckPredicate, 18, 124, 5, 0, // Skip to: 6511
/* 5107 */    MCD::OPC_Decode, 222, 21, 112, // Opcode: TRUNC_W_S_MM
/* 5111 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 5125
/* 5116 */    MCD::OPC_CheckPredicate, 17, 110, 5, 0, // Skip to: 6511
/* 5121 */    MCD::OPC_Decode, 192, 11, 114, // Opcode: FLOOR_W_MM
/* 5125 */    MCD::OPC_FilterValue, 3, 101, 5, 0, // Skip to: 6511
/* 5130 */    MCD::OPC_CheckPredicate, 17, 96, 5, 0, // Skip to: 6511
/* 5135 */    MCD::OPC_Decode, 220, 21, 114, // Opcode: TRUNC_W_MM
/* 5139 */    MCD::OPC_FilterValue, 45, 16, 0, 0, // Skip to: 5160
/* 5144 */    MCD::OPC_CheckPredicate, 17, 82, 5, 0, // Skip to: 6511
/* 5149 */    MCD::OPC_CheckField, 13, 3, 1, 75, 5, 0, // Skip to: 6511
/* 5156 */    MCD::OPC_Decode, 225, 11, 108, // Opcode: FNEG_D32_MM
/* 5160 */    MCD::OPC_FilterValue, 64, 31, 0, 0, // Skip to: 5196
/* 5165 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 5168 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 5182
/* 5173 */    MCD::OPC_CheckPredicate, 18, 53, 5, 0, // Skip to: 6511
/* 5178 */    MCD::OPC_Decode, 145, 7, 115, // Opcode: CFC1_MM
/* 5182 */    MCD::OPC_FilterValue, 1, 44, 5, 0, // Skip to: 6511
/* 5187 */    MCD::OPC_CheckPredicate, 17, 39, 5, 0, // Skip to: 6511
/* 5192 */    MCD::OPC_Decode, 248, 14, 116, // Opcode: MFHC1_D32_MM
/* 5196 */    MCD::OPC_FilterValue, 72, 31, 0, 0, // Skip to: 5232
/* 5201 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 5204 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 5218
/* 5209 */    MCD::OPC_CheckPredicate, 18, 17, 5, 0, // Skip to: 6511
/* 5214 */    MCD::OPC_Decode, 142, 18, 112, // Opcode: RECIP_S_MM
/* 5218 */    MCD::OPC_FilterValue, 2, 8, 5, 0, // Skip to: 6511
/* 5223 */    MCD::OPC_CheckPredicate, 17, 3, 5, 0, // Skip to: 6511
/* 5228 */    MCD::OPC_Decode, 138, 18, 108, // Opcode: RECIP_D32_MM
/* 5232 */    MCD::OPC_FilterValue, 77, 31, 0, 0, // Skip to: 5268
/* 5237 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 5240 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 5254
/* 5245 */    MCD::OPC_CheckPredicate, 17, 237, 4, 0, // Skip to: 6511
/* 5250 */    MCD::OPC_Decode, 178, 8, 117, // Opcode: CVT_D32_S_MM
/* 5254 */    MCD::OPC_FilterValue, 1, 228, 4, 0, // Skip to: 6511
/* 5259 */    MCD::OPC_CheckPredicate, 17, 223, 4, 0, // Skip to: 6511
/* 5264 */    MCD::OPC_Decode, 180, 8, 117, // Opcode: CVT_D32_W_MM
/* 5268 */    MCD::OPC_FilterValue, 96, 31, 0, 0, // Skip to: 5304
/* 5273 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 5276 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 5290
/* 5281 */    MCD::OPC_CheckPredicate, 18, 201, 4, 0, // Skip to: 6511
/* 5286 */    MCD::OPC_Decode, 172, 8, 118, // Opcode: CTC1_MM
/* 5290 */    MCD::OPC_FilterValue, 1, 192, 4, 0, // Skip to: 6511
/* 5295 */    MCD::OPC_CheckPredicate, 17, 187, 4, 0, // Skip to: 6511
/* 5300 */    MCD::OPC_Decode, 136, 16, 119, // Opcode: MTHC1_D32_MM
/* 5304 */    MCD::OPC_FilterValue, 108, 59, 0, 0, // Skip to: 5368
/* 5309 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 5312 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 5326
/* 5317 */    MCD::OPC_CheckPredicate, 18, 165, 4, 0, // Skip to: 6511
/* 5322 */    MCD::OPC_Decode, 134, 7, 112, // Opcode: CEIL_W_S_MM
/* 5326 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 5340
/* 5331 */    MCD::OPC_CheckPredicate, 18, 151, 4, 0, // Skip to: 6511
/* 5336 */    MCD::OPC_Decode, 168, 18, 112, // Opcode: ROUND_W_S_MM
/* 5340 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 5354
/* 5345 */    MCD::OPC_CheckPredicate, 17, 137, 4, 0, // Skip to: 6511
/* 5350 */    MCD::OPC_Decode, 132, 7, 114, // Opcode: CEIL_W_MM
/* 5354 */    MCD::OPC_FilterValue, 3, 128, 4, 0, // Skip to: 6511
/* 5359 */    MCD::OPC_CheckPredicate, 17, 123, 4, 0, // Skip to: 6511
/* 5364 */    MCD::OPC_Decode, 166, 18, 114, // Opcode: ROUND_W_MM
/* 5368 */    MCD::OPC_FilterValue, 109, 114, 4, 0, // Skip to: 6511
/* 5373 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 5376 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 5390
/* 5381 */    MCD::OPC_CheckPredicate, 17, 101, 4, 0, // Skip to: 6511
/* 5386 */    MCD::OPC_Decode, 195, 8, 114, // Opcode: CVT_S_D32_MM
/* 5390 */    MCD::OPC_FilterValue, 1, 92, 4, 0, // Skip to: 6511
/* 5395 */    MCD::OPC_CheckPredicate, 18, 87, 4, 0, // Skip to: 6511
/* 5400 */    MCD::OPC_Decode, 203, 8, 112, // Opcode: CVT_S_W_MM
/* 5404 */    MCD::OPC_FilterValue, 60, 78, 4, 0, // Skip to: 6511
/* 5409 */    MCD::OPC_ExtractField, 6, 7,  // Inst{12-6} ...
/* 5412 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 5426
/* 5417 */    MCD::OPC_CheckPredicate, 12, 65, 4, 0, // Skip to: 6511
/* 5422 */    MCD::OPC_Decode, 223, 8, 120, // Opcode: C_F_S_MM
/* 5426 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 5440
/* 5431 */    MCD::OPC_CheckPredicate, 12, 51, 4, 0, // Skip to: 6511
/* 5436 */    MCD::OPC_Decode, 179, 9, 120, // Opcode: C_UN_S_MM
/* 5440 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 5454
/* 5445 */    MCD::OPC_CheckPredicate, 12, 37, 4, 0, // Skip to: 6511
/* 5450 */    MCD::OPC_Decode, 217, 8, 120, // Opcode: C_EQ_S_MM
/* 5454 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 5468
/* 5459 */    MCD::OPC_CheckPredicate, 12, 23, 4, 0, // Skip to: 6511
/* 5464 */    MCD::OPC_Decode, 161, 9, 120, // Opcode: C_UEQ_S_MM
/* 5468 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 5482
/* 5473 */    MCD::OPC_CheckPredicate, 12, 9, 4, 0, // Skip to: 6511
/* 5478 */    MCD::OPC_Decode, 143, 9, 120, // Opcode: C_OLT_S_MM
/* 5482 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 5496
/* 5487 */    MCD::OPC_CheckPredicate, 12, 251, 3, 0, // Skip to: 6511
/* 5492 */    MCD::OPC_Decode, 173, 9, 120, // Opcode: C_ULT_S_MM
/* 5496 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 5510
/* 5501 */    MCD::OPC_CheckPredicate, 12, 237, 3, 0, // Skip to: 6511
/* 5506 */    MCD::OPC_Decode, 137, 9, 120, // Opcode: C_OLE_S_MM
/* 5510 */    MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 5524
/* 5515 */    MCD::OPC_CheckPredicate, 12, 223, 3, 0, // Skip to: 6511
/* 5520 */    MCD::OPC_Decode, 167, 9, 120, // Opcode: C_ULE_S_MM
/* 5524 */    MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 5538
/* 5529 */    MCD::OPC_CheckPredicate, 12, 209, 3, 0, // Skip to: 6511
/* 5534 */    MCD::OPC_Decode, 155, 9, 120, // Opcode: C_SF_S_MM
/* 5538 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 5552
/* 5543 */    MCD::OPC_CheckPredicate, 12, 195, 3, 0, // Skip to: 6511
/* 5548 */    MCD::OPC_Decode, 247, 8, 120, // Opcode: C_NGLE_S_MM
/* 5552 */    MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 5566
/* 5557 */    MCD::OPC_CheckPredicate, 12, 181, 3, 0, // Skip to: 6511
/* 5562 */    MCD::OPC_Decode, 149, 9, 120, // Opcode: C_SEQ_S_MM
/* 5566 */    MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 5580
/* 5571 */    MCD::OPC_CheckPredicate, 12, 167, 3, 0, // Skip to: 6511
/* 5576 */    MCD::OPC_Decode, 253, 8, 120, // Opcode: C_NGL_S_MM
/* 5580 */    MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 5594
/* 5585 */    MCD::OPC_CheckPredicate, 12, 153, 3, 0, // Skip to: 6511
/* 5590 */    MCD::OPC_Decode, 235, 8, 120, // Opcode: C_LT_S_MM
/* 5594 */    MCD::OPC_FilterValue, 13, 9, 0, 0, // Skip to: 5608
/* 5599 */    MCD::OPC_CheckPredicate, 12, 139, 3, 0, // Skip to: 6511
/* 5604 */    MCD::OPC_Decode, 241, 8, 120, // Opcode: C_NGE_S_MM
/* 5608 */    MCD::OPC_FilterValue, 14, 9, 0, 0, // Skip to: 5622
/* 5613 */    MCD::OPC_CheckPredicate, 12, 125, 3, 0, // Skip to: 6511
/* 5618 */    MCD::OPC_Decode, 229, 8, 120, // Opcode: C_LE_S_MM
/* 5622 */    MCD::OPC_FilterValue, 15, 9, 0, 0, // Skip to: 5636
/* 5627 */    MCD::OPC_CheckPredicate, 12, 111, 3, 0, // Skip to: 6511
/* 5632 */    MCD::OPC_Decode, 131, 9, 120, // Opcode: C_NGT_S_MM
/* 5636 */    MCD::OPC_FilterValue, 16, 9, 0, 0, // Skip to: 5650
/* 5641 */    MCD::OPC_CheckPredicate, 16, 97, 3, 0, // Skip to: 6511
/* 5646 */    MCD::OPC_Decode, 219, 8, 121, // Opcode: C_F_D32_MM
/* 5650 */    MCD::OPC_FilterValue, 17, 9, 0, 0, // Skip to: 5664
/* 5655 */    MCD::OPC_CheckPredicate, 16, 83, 3, 0, // Skip to: 6511
/* 5660 */    MCD::OPC_Decode, 175, 9, 121, // Opcode: C_UN_D32_MM
/* 5664 */    MCD::OPC_FilterValue, 18, 9, 0, 0, // Skip to: 5678
/* 5669 */    MCD::OPC_CheckPredicate, 16, 69, 3, 0, // Skip to: 6511
/* 5674 */    MCD::OPC_Decode, 213, 8, 121, // Opcode: C_EQ_D32_MM
/* 5678 */    MCD::OPC_FilterValue, 19, 9, 0, 0, // Skip to: 5692
/* 5683 */    MCD::OPC_CheckPredicate, 16, 55, 3, 0, // Skip to: 6511
/* 5688 */    MCD::OPC_Decode, 157, 9, 121, // Opcode: C_UEQ_D32_MM
/* 5692 */    MCD::OPC_FilterValue, 20, 9, 0, 0, // Skip to: 5706
/* 5697 */    MCD::OPC_CheckPredicate, 16, 41, 3, 0, // Skip to: 6511
/* 5702 */    MCD::OPC_Decode, 139, 9, 121, // Opcode: C_OLT_D32_MM
/* 5706 */    MCD::OPC_FilterValue, 21, 9, 0, 0, // Skip to: 5720
/* 5711 */    MCD::OPC_CheckPredicate, 16, 27, 3, 0, // Skip to: 6511
/* 5716 */    MCD::OPC_Decode, 169, 9, 121, // Opcode: C_ULT_D32_MM
/* 5720 */    MCD::OPC_FilterValue, 22, 9, 0, 0, // Skip to: 5734
/* 5725 */    MCD::OPC_CheckPredicate, 16, 13, 3, 0, // Skip to: 6511
/* 5730 */    MCD::OPC_Decode, 133, 9, 121, // Opcode: C_OLE_D32_MM
/* 5734 */    MCD::OPC_FilterValue, 23, 9, 0, 0, // Skip to: 5748
/* 5739 */    MCD::OPC_CheckPredicate, 16, 255, 2, 0, // Skip to: 6511
/* 5744 */    MCD::OPC_Decode, 163, 9, 121, // Opcode: C_ULE_D32_MM
/* 5748 */    MCD::OPC_FilterValue, 24, 9, 0, 0, // Skip to: 5762
/* 5753 */    MCD::OPC_CheckPredicate, 16, 241, 2, 0, // Skip to: 6511
/* 5758 */    MCD::OPC_Decode, 151, 9, 121, // Opcode: C_SF_D32_MM
/* 5762 */    MCD::OPC_FilterValue, 25, 9, 0, 0, // Skip to: 5776
/* 5767 */    MCD::OPC_CheckPredicate, 16, 227, 2, 0, // Skip to: 6511
/* 5772 */    MCD::OPC_Decode, 243, 8, 121, // Opcode: C_NGLE_D32_MM
/* 5776 */    MCD::OPC_FilterValue, 26, 9, 0, 0, // Skip to: 5790
/* 5781 */    MCD::OPC_CheckPredicate, 16, 213, 2, 0, // Skip to: 6511
/* 5786 */    MCD::OPC_Decode, 145, 9, 121, // Opcode: C_SEQ_D32_MM
/* 5790 */    MCD::OPC_FilterValue, 27, 9, 0, 0, // Skip to: 5804
/* 5795 */    MCD::OPC_CheckPredicate, 16, 199, 2, 0, // Skip to: 6511
/* 5800 */    MCD::OPC_Decode, 249, 8, 121, // Opcode: C_NGL_D32_MM
/* 5804 */    MCD::OPC_FilterValue, 28, 9, 0, 0, // Skip to: 5818
/* 5809 */    MCD::OPC_CheckPredicate, 16, 185, 2, 0, // Skip to: 6511
/* 5814 */    MCD::OPC_Decode, 231, 8, 121, // Opcode: C_LT_D32_MM
/* 5818 */    MCD::OPC_FilterValue, 29, 9, 0, 0, // Skip to: 5832
/* 5823 */    MCD::OPC_CheckPredicate, 16, 171, 2, 0, // Skip to: 6511
/* 5828 */    MCD::OPC_Decode, 237, 8, 121, // Opcode: C_NGE_D32_MM
/* 5832 */    MCD::OPC_FilterValue, 30, 9, 0, 0, // Skip to: 5846
/* 5837 */    MCD::OPC_CheckPredicate, 16, 157, 2, 0, // Skip to: 6511
/* 5842 */    MCD::OPC_Decode, 225, 8, 121, // Opcode: C_LE_D32_MM
/* 5846 */    MCD::OPC_FilterValue, 31, 148, 2, 0, // Skip to: 6511
/* 5851 */    MCD::OPC_CheckPredicate, 16, 143, 2, 0, // Skip to: 6511
/* 5856 */    MCD::OPC_Decode, 255, 8, 121, // Opcode: C_NGT_D32_MM
/* 5860 */    MCD::OPC_FilterValue, 22, 48, 0, 0, // Skip to: 5913
/* 5865 */    MCD::OPC_ExtractField, 0, 11,  // Inst{10-0} ...
/* 5868 */    MCD::OPC_FilterValue, 197, 1, 9, 0, 0, // Skip to: 5883
/* 5874 */    MCD::OPC_CheckPredicate, 7, 120, 2, 0, // Skip to: 6511
/* 5879 */    MCD::OPC_Decode, 203, 7, 42, // Opcode: CMPGU_EQ_QB_MM
/* 5883 */    MCD::OPC_FilterValue, 133, 2, 9, 0, 0, // Skip to: 5898
/* 5889 */    MCD::OPC_CheckPredicate, 7, 105, 2, 0, // Skip to: 6511
/* 5894 */    MCD::OPC_Decode, 207, 7, 42, // Opcode: CMPGU_LT_QB_MM
/* 5898 */    MCD::OPC_FilterValue, 197, 2, 95, 2, 0, // Skip to: 6511
/* 5904 */    MCD::OPC_CheckPredicate, 7, 90, 2, 0, // Skip to: 6511
/* 5909 */    MCD::OPC_Decode, 205, 7, 42, // Opcode: CMPGU_LE_QB_MM
/* 5913 */    MCD::OPC_FilterValue, 24, 99, 1, 0, // Skip to: 6273
/* 5918 */    MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 5921 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 5935
/* 5926 */    MCD::OPC_CheckPredicate, 5, 68, 2, 0, // Skip to: 6511
/* 5931 */    MCD::OPC_Decode, 141, 14, 87, // Opcode: LWL_MM
/* 5935 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 5949
/* 5940 */    MCD::OPC_CheckPredicate, 5, 54, 2, 0, // Skip to: 6511
/* 5945 */    MCD::OPC_Decode, 152, 14, 87, // Opcode: LWR_MM
/* 5949 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 5963
/* 5954 */    MCD::OPC_CheckPredicate, 5, 40, 2, 0, // Skip to: 6511
/* 5959 */    MCD::OPC_Decode, 229, 17, 88, // Opcode: PREF_MM
/* 5963 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 5977
/* 5968 */    MCD::OPC_CheckPredicate, 5, 26, 2, 0, // Skip to: 6511
/* 5973 */    MCD::OPC_Decode, 238, 13, 87, // Opcode: LL_MM
/* 5977 */    MCD::OPC_FilterValue, 6, 115, 0, 0, // Skip to: 6097
/* 5982 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5985 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 5999
/* 5990 */    MCD::OPC_CheckPredicate, 21, 4, 2, 0, // Skip to: 6511
/* 5995 */    MCD::OPC_Decode, 189, 13, 122, // Opcode: LBuE_MM
/* 5999 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 6013
/* 6004 */    MCD::OPC_CheckPredicate, 21, 246, 1, 0, // Skip to: 6511
/* 6009 */    MCD::OPC_Decode, 227, 13, 122, // Opcode: LHuE_MM
/* 6013 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 6027
/* 6018 */    MCD::OPC_CheckPredicate, 22, 232, 1, 0, // Skip to: 6511
/* 6023 */    MCD::OPC_Decode, 140, 14, 122, // Opcode: LWLE_MM
/* 6027 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 6041
/* 6032 */    MCD::OPC_CheckPredicate, 22, 218, 1, 0, // Skip to: 6511
/* 6037 */    MCD::OPC_Decode, 151, 14, 122, // Opcode: LWRE_MM
/* 6041 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 6055
/* 6046 */    MCD::OPC_CheckPredicate, 21, 204, 1, 0, // Skip to: 6511
/* 6051 */    MCD::OPC_Decode, 179, 13, 122, // Opcode: LBE_MM
/* 6055 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 6069
/* 6060 */    MCD::OPC_CheckPredicate, 21, 190, 1, 0, // Skip to: 6511
/* 6065 */    MCD::OPC_Decode, 219, 13, 122, // Opcode: LHE_MM
/* 6069 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 6083
/* 6074 */    MCD::OPC_CheckPredicate, 21, 176, 1, 0, // Skip to: 6511
/* 6079 */    MCD::OPC_Decode, 237, 13, 122, // Opcode: LLE_MM
/* 6083 */    MCD::OPC_FilterValue, 7, 167, 1, 0, // Skip to: 6511
/* 6088 */    MCD::OPC_CheckPredicate, 21, 162, 1, 0, // Skip to: 6511
/* 6093 */    MCD::OPC_Decode, 135, 14, 122, // Opcode: LWE_MM
/* 6097 */    MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 6111
/* 6102 */    MCD::OPC_CheckPredicate, 5, 148, 1, 0, // Skip to: 6511
/* 6107 */    MCD::OPC_Decode, 249, 20, 87, // Opcode: SWL_MM
/* 6111 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 6125
/* 6116 */    MCD::OPC_CheckPredicate, 5, 134, 1, 0, // Skip to: 6511
/* 6121 */    MCD::OPC_Decode, 130, 21, 87, // Opcode: SWR_MM
/* 6125 */    MCD::OPC_FilterValue, 10, 115, 0, 0, // Skip to: 6245
/* 6130 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6133 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 6147
/* 6138 */    MCD::OPC_CheckPredicate, 22, 112, 1, 0, // Skip to: 6511
/* 6143 */    MCD::OPC_Decode, 248, 20, 122, // Opcode: SWLE_MM
/* 6147 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 6161
/* 6152 */    MCD::OPC_CheckPredicate, 22, 98, 1, 0, // Skip to: 6511
/* 6157 */    MCD::OPC_Decode, 129, 21, 122, // Opcode: SWRE_MM
/* 6161 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 6175
/* 6166 */    MCD::OPC_CheckPredicate, 21, 84, 1, 0, // Skip to: 6511
/* 6171 */    MCD::OPC_Decode, 227, 17, 123, // Opcode: PREFE_MM
/* 6175 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 6189
/* 6180 */    MCD::OPC_CheckPredicate, 21, 70, 1, 0, // Skip to: 6511
/* 6185 */    MCD::OPC_Decode, 249, 6, 123, // Opcode: CACHEE_MM
/* 6189 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 6203
/* 6194 */    MCD::OPC_CheckPredicate, 21, 56, 1, 0, // Skip to: 6511
/* 6199 */    MCD::OPC_Decode, 193, 18, 122, // Opcode: SBE_MM
/* 6203 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 6217
/* 6208 */    MCD::OPC_CheckPredicate, 21, 42, 1, 0, // Skip to: 6511
/* 6213 */    MCD::OPC_Decode, 131, 19, 122, // Opcode: SHE_MM
/* 6217 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 6231
/* 6222 */    MCD::OPC_CheckPredicate, 21, 28, 1, 0, // Skip to: 6511
/* 6227 */    MCD::OPC_Decode, 202, 18, 122, // Opcode: SCE_MM
/* 6231 */    MCD::OPC_FilterValue, 7, 19, 1, 0, // Skip to: 6511
/* 6236 */    MCD::OPC_CheckPredicate, 21, 14, 1, 0, // Skip to: 6511
/* 6241 */    MCD::OPC_Decode, 244, 20, 122, // Opcode: SWE_MM
/* 6245 */    MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 6259
/* 6250 */    MCD::OPC_CheckPredicate, 5, 0, 1, 0, // Skip to: 6511
/* 6255 */    MCD::OPC_Decode, 203, 18, 87, // Opcode: SC_MM
/* 6259 */    MCD::OPC_FilterValue, 14, 247, 0, 0, // Skip to: 6511
/* 6264 */    MCD::OPC_CheckPredicate, 5, 242, 0, 0, // Skip to: 6511
/* 6269 */    MCD::OPC_Decode, 155, 14, 87, // Opcode: LWU_MM
/* 6273 */    MCD::OPC_FilterValue, 28, 9, 0, 0, // Skip to: 6287
/* 6278 */    MCD::OPC_CheckPredicate, 5, 228, 0, 0, // Skip to: 6511
/* 6283 */    MCD::OPC_Decode, 254, 21, 96, // Opcode: XORi_MM
/* 6287 */    MCD::OPC_FilterValue, 29, 9, 0, 0, // Skip to: 6301
/* 6292 */    MCD::OPC_CheckPredicate, 5, 214, 0, 0, // Skip to: 6511
/* 6297 */    MCD::OPC_Decode, 147, 13, 124, // Opcode: JALS_MM
/* 6301 */    MCD::OPC_FilterValue, 30, 9, 0, 0, // Skip to: 6315
/* 6306 */    MCD::OPC_CheckPredicate, 5, 200, 0, 0, // Skip to: 6511
/* 6311 */    MCD::OPC_Decode, 176, 4, 125, // Opcode: ADDIUPC_MM
/* 6315 */    MCD::OPC_FilterValue, 36, 9, 0, 0, // Skip to: 6329
/* 6320 */    MCD::OPC_CheckPredicate, 6, 186, 0, 0, // Skip to: 6511
/* 6325 */    MCD::OPC_Decode, 217, 19, 85, // Opcode: SLTi_MM
/* 6329 */    MCD::OPC_FilterValue, 37, 9, 0, 0, // Skip to: 6343
/* 6334 */    MCD::OPC_CheckPredicate, 5, 172, 0, 0, // Skip to: 6511
/* 6339 */    MCD::OPC_Decode, 227, 5, 126, // Opcode: BEQ_MM
/* 6343 */    MCD::OPC_FilterValue, 38, 9, 0, 0, // Skip to: 6357
/* 6348 */    MCD::OPC_CheckPredicate, 18, 158, 0, 0, // Skip to: 6511
/* 6353 */    MCD::OPC_Decode, 236, 20, 127, // Opcode: SWC1_MM
/* 6357 */    MCD::OPC_FilterValue, 39, 9, 0, 0, // Skip to: 6371
/* 6362 */    MCD::OPC_CheckPredicate, 18, 144, 0, 0, // Skip to: 6511
/* 6367 */    MCD::OPC_Decode, 255, 13, 127, // Opcode: LWC1_MM
/* 6371 */    MCD::OPC_FilterValue, 44, 9, 0, 0, // Skip to: 6385
/* 6376 */    MCD::OPC_CheckPredicate, 6, 130, 0, 0, // Skip to: 6511
/* 6381 */    MCD::OPC_Decode, 220, 19, 85, // Opcode: SLTiu_MM
/* 6385 */    MCD::OPC_FilterValue, 45, 9, 0, 0, // Skip to: 6399
/* 6390 */    MCD::OPC_CheckPredicate, 5, 116, 0, 0, // Skip to: 6511
/* 6395 */    MCD::OPC_Decode, 203, 6, 126, // Opcode: BNE_MM
/* 6399 */    MCD::OPC_FilterValue, 46, 9, 0, 0, // Skip to: 6413
/* 6404 */    MCD::OPC_CheckPredicate, 17, 102, 0, 0, // Skip to: 6511
/* 6409 */    MCD::OPC_Decode, 217, 18, 127, // Opcode: SDC1_MM
/* 6413 */    MCD::OPC_FilterValue, 47, 9, 0, 0, // Skip to: 6427
/* 6418 */    MCD::OPC_CheckPredicate, 17, 88, 0, 0, // Skip to: 6511
/* 6423 */    MCD::OPC_Decode, 195, 13, 127, // Opcode: LDC1_MM
/* 6427 */    MCD::OPC_FilterValue, 52, 9, 0, 0, // Skip to: 6441
/* 6432 */    MCD::OPC_CheckPredicate, 5, 74, 0, 0, // Skip to: 6511
/* 6437 */    MCD::OPC_Decode, 137, 5, 96, // Opcode: ANDi_MM
/* 6441 */    MCD::OPC_FilterValue, 53, 9, 0, 0, // Skip to: 6455
/* 6446 */    MCD::OPC_CheckPredicate, 5, 60, 0, 0, // Skip to: 6511
/* 6451 */    MCD::OPC_Decode, 169, 13, 124, // Opcode: J_MM
/* 6455 */    MCD::OPC_FilterValue, 60, 9, 0, 0, // Skip to: 6469
/* 6460 */    MCD::OPC_CheckPredicate, 5, 46, 0, 0, // Skip to: 6511
/* 6465 */    MCD::OPC_Decode, 149, 13, 124, // Opcode: JALX_MM
/* 6469 */    MCD::OPC_FilterValue, 61, 9, 0, 0, // Skip to: 6483
/* 6474 */    MCD::OPC_CheckPredicate, 5, 32, 0, 0, // Skip to: 6511
/* 6479 */    MCD::OPC_Decode, 150, 13, 124, // Opcode: JAL_MM
/* 6483 */    MCD::OPC_FilterValue, 62, 9, 0, 0, // Skip to: 6497
/* 6488 */    MCD::OPC_CheckPredicate, 6, 18, 0, 0, // Skip to: 6511
/* 6493 */    MCD::OPC_Decode, 135, 21, 86, // Opcode: SW_MM
/* 6497 */    MCD::OPC_FilterValue, 63, 9, 0, 0, // Skip to: 6511
/* 6502 */    MCD::OPC_CheckPredicate, 6, 4, 0, 0, // Skip to: 6511
/* 6507 */    MCD::OPC_Decode, 161, 14, 86, // Opcode: LW_MM
/* 6511 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMicroMipsDSP32[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 62, 10, 0, 0, // Skip to: 18
/* 8 */       MCD::OPC_CheckPredicate, 7, 20, 0, 0, // Skip to: 33
/* 13 */      MCD::OPC_Decode, 242, 20, 128, 1, // Opcode: SWDSP_MM
/* 18 */      MCD::OPC_FilterValue, 63, 10, 0, 0, // Skip to: 33
/* 23 */      MCD::OPC_CheckPredicate, 7, 5, 0, 0, // Skip to: 33
/* 28 */      MCD::OPC_Decode, 133, 14, 128, 1, // Opcode: LWDSP_MM
/* 33 */      MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMicroMipsFP6432[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 21, 39, 1, 0, // Skip to: 303
/* 8 */       MCD::OPC_ExtractField, 0, 11,  // Inst{10-0} ...
/* 11 */      MCD::OPC_FilterValue, 59, 48, 0, 0, // Skip to: 64
/* 16 */      MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 19 */      MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 34
/* 24 */      MCD::OPC_CheckPredicate, 19, 46, 1, 0, // Skip to: 331
/* 29 */      MCD::OPC_Decode, 255, 15, 129, 1, // Opcode: MTC1_D64_MM
/* 34 */      MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 49
/* 39 */      MCD::OPC_CheckPredicate, 19, 31, 1, 0, // Skip to: 331
/* 44 */      MCD::OPC_Decode, 250, 14, 130, 1, // Opcode: MFHC1_D64_MM
/* 49 */      MCD::OPC_FilterValue, 7, 21, 1, 0, // Skip to: 331
/* 54 */      MCD::OPC_CheckPredicate, 19, 16, 1, 0, // Skip to: 331
/* 59 */      MCD::OPC_Decode, 138, 16, 131, 1, // Opcode: MTHC1_D64_MM
/* 64 */      MCD::OPC_FilterValue, 123, 16, 0, 0, // Skip to: 85
/* 69 */      MCD::OPC_CheckPredicate, 19, 1, 1, 0, // Skip to: 331
/* 74 */      MCD::OPC_CheckField, 11, 5, 4, 250, 0, 0, // Skip to: 331
/* 81 */      MCD::OPC_Decode, 209, 11, 110, // Opcode: FMOV_D64_MM
/* 85 */      MCD::OPC_FilterValue, 176, 2, 10, 0, 0, // Skip to: 101
/* 91 */      MCD::OPC_CheckPredicate, 19, 235, 0, 0, // Skip to: 331
/* 96 */      MCD::OPC_Decode, 248, 10, 132, 1, // Opcode: FADD_D64_MM
/* 101 */     MCD::OPC_FilterValue, 187, 2, 17, 0, 0, // Skip to: 124
/* 107 */     MCD::OPC_CheckPredicate, 19, 219, 0, 0, // Skip to: 331
/* 112 */     MCD::OPC_CheckField, 11, 5, 9, 212, 0, 0, // Skip to: 331
/* 119 */     MCD::OPC_Decode, 208, 8, 133, 1, // Opcode: CVT_W_D64_MM
/* 124 */     MCD::OPC_FilterValue, 240, 2, 10, 0, 0, // Skip to: 140
/* 130 */     MCD::OPC_CheckPredicate, 19, 196, 0, 0, // Skip to: 331
/* 135 */     MCD::OPC_Decode, 134, 12, 132, 1, // Opcode: FSUB_D64_MM
/* 140 */     MCD::OPC_FilterValue, 176, 3, 10, 0, 0, // Skip to: 156
/* 146 */     MCD::OPC_CheckPredicate, 19, 180, 0, 0, // Skip to: 331
/* 151 */     MCD::OPC_Decode, 219, 11, 132, 1, // Opcode: FMUL_D64_MM
/* 156 */     MCD::OPC_FilterValue, 240, 3, 10, 0, 0, // Skip to: 172
/* 162 */     MCD::OPC_CheckPredicate, 19, 164, 0, 0, // Skip to: 331
/* 167 */     MCD::OPC_Decode, 158, 11, 132, 1, // Opcode: FDIV_D64_MM
/* 172 */     MCD::OPC_FilterValue, 187, 4, 45, 0, 0, // Skip to: 223
/* 178 */     MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 181 */     MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 195
/* 186 */     MCD::OPC_CheckPredicate, 19, 140, 0, 0, // Skip to: 331
/* 191 */     MCD::OPC_Decode, 173, 18, 110, // Opcode: RSQRT_D64_MM
/* 195 */     MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 209
/* 200 */     MCD::OPC_CheckPredicate, 19, 126, 0, 0, // Skip to: 331
/* 205 */     MCD::OPC_Decode, 254, 11, 110, // Opcode: FSQRT_D64_MM
/* 209 */     MCD::OPC_FilterValue, 10, 117, 0, 0, // Skip to: 331
/* 214 */     MCD::OPC_CheckPredicate, 19, 112, 0, 0, // Skip to: 331
/* 219 */     MCD::OPC_Decode, 140, 18, 110, // Opcode: RECIP_D64_MM
/* 223 */     MCD::OPC_FilterValue, 251, 6, 102, 0, 0, // Skip to: 331
/* 229 */     MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 232 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 246
/* 237 */     MCD::OPC_CheckPredicate, 19, 89, 0, 0, // Skip to: 331
/* 242 */     MCD::OPC_Decode, 183, 8, 109, // Opcode: CVT_D64_S_MM
/* 246 */     MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 261
/* 251 */     MCD::OPC_CheckPredicate, 19, 75, 0, 0, // Skip to: 331
/* 256 */     MCD::OPC_Decode, 197, 8, 133, 1, // Opcode: CVT_S_D64_MM
/* 261 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 275
/* 266 */     MCD::OPC_CheckPredicate, 19, 60, 0, 0, // Skip to: 331
/* 271 */     MCD::OPC_Decode, 241, 10, 110, // Opcode: FABS_D64_MM
/* 275 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 289
/* 280 */     MCD::OPC_CheckPredicate, 19, 46, 0, 0, // Skip to: 331
/* 285 */     MCD::OPC_Decode, 227, 11, 110, // Opcode: FNEG_D64_MM
/* 289 */     MCD::OPC_FilterValue, 6, 37, 0, 0, // Skip to: 331
/* 294 */     MCD::OPC_CheckPredicate, 19, 32, 0, 0, // Skip to: 331
/* 299 */     MCD::OPC_Decode, 185, 8, 109, // Opcode: CVT_D64_W_MM
/* 303 */     MCD::OPC_FilterValue, 46, 9, 0, 0, // Skip to: 317
/* 308 */     MCD::OPC_CheckPredicate, 23, 18, 0, 0, // Skip to: 331
/* 313 */     MCD::OPC_Decode, 216, 18, 127, // Opcode: SDC1_D64_MMR6
/* 317 */     MCD::OPC_FilterValue, 47, 9, 0, 0, // Skip to: 331
/* 322 */     MCD::OPC_CheckPredicate, 23, 4, 0, 0, // Skip to: 331
/* 327 */     MCD::OPC_Decode, 194, 13, 127, // Opcode: LDC1_D64_MMR6
/* 331 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMicroMipsR616[] = {
/* 0 */       MCD::OPC_ExtractField, 10, 6,  // Inst{15-10} ...
/* 3 */       MCD::OPC_FilterValue, 1, 33, 0, 0, // Skip to: 41
/* 8 */       MCD::OPC_ExtractField, 0, 1,  // Inst{0} ...
/* 11 */      MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 26
/* 16 */      MCD::OPC_CheckPredicate, 24, 173, 1, 0, // Skip to: 450
/* 21 */      MCD::OPC_Decode, 212, 4, 134, 1, // Opcode: ADDU16_MMR6
/* 26 */      MCD::OPC_FilterValue, 1, 163, 1, 0, // Skip to: 450
/* 31 */      MCD::OPC_CheckPredicate, 24, 158, 1, 0, // Skip to: 450
/* 36 */      MCD::OPC_Decode, 202, 20, 134, 1, // Opcode: SUBU16_MMR6
/* 41 */      MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 55
/* 46 */      MCD::OPC_CheckPredicate, 24, 143, 1, 0, // Skip to: 450
/* 51 */      MCD::OPC_Decode, 182, 15, 21, // Opcode: MOVE16_MMR6
/* 55 */      MCD::OPC_FilterValue, 9, 31, 0, 0, // Skip to: 91
/* 60 */      MCD::OPC_ExtractField, 0, 1,  // Inst{0} ...
/* 63 */      MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 77
/* 68 */      MCD::OPC_CheckPredicate, 24, 121, 1, 0, // Skip to: 450
/* 73 */      MCD::OPC_Decode, 197, 19, 22, // Opcode: SLL16_MMR6
/* 77 */      MCD::OPC_FilterValue, 1, 112, 1, 0, // Skip to: 450
/* 82 */      MCD::OPC_CheckPredicate, 24, 107, 1, 0, // Skip to: 450
/* 87 */      MCD::OPC_Decode, 128, 20, 22, // Opcode: SRL16_MMR6
/* 91 */      MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 105
/* 96 */      MCD::OPC_CheckPredicate, 24, 93, 1, 0, // Skip to: 450
/* 101 */     MCD::OPC_Decode, 129, 5, 23, // Opcode: ANDI16_MMR6
/* 105 */     MCD::OPC_FilterValue, 17, 228, 0, 0, // Skip to: 338
/* 110 */     MCD::OPC_ExtractField, 2, 1,  // Inst{2} ...
/* 113 */     MCD::OPC_FilterValue, 0, 206, 0, 0, // Skip to: 324
/* 118 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 121 */     MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 159
/* 126 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 129 */     MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 144
/* 134 */     MCD::OPC_CheckPredicate, 24, 55, 1, 0, // Skip to: 450
/* 139 */     MCD::OPC_Decode, 240, 16, 135, 1, // Opcode: NOT16_MMR6
/* 144 */     MCD::OPC_FilterValue, 1, 45, 1, 0, // Skip to: 450
/* 149 */     MCD::OPC_CheckPredicate, 24, 40, 1, 0, // Skip to: 450
/* 154 */     MCD::OPC_Decode, 245, 21, 136, 1, // Opcode: XOR16_MMR6
/* 159 */     MCD::OPC_FilterValue, 1, 33, 0, 0, // Skip to: 197
/* 164 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 167 */     MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 182
/* 172 */     MCD::OPC_CheckPredicate, 24, 17, 1, 0, // Skip to: 450
/* 177 */     MCD::OPC_Decode, 254, 4, 136, 1, // Opcode: AND16_MMR6
/* 182 */     MCD::OPC_FilterValue, 1, 7, 1, 0, // Skip to: 450
/* 187 */     MCD::OPC_CheckPredicate, 24, 2, 1, 0, // Skip to: 450
/* 192 */     MCD::OPC_Decode, 245, 16, 136, 1, // Opcode: OR16_MMR6
/* 197 */     MCD::OPC_FilterValue, 2, 31, 0, 0, // Skip to: 233
/* 202 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 205 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 219
/* 210 */     MCD::OPC_CheckPredicate, 24, 235, 0, 0, // Skip to: 450
/* 215 */     MCD::OPC_Decode, 143, 14, 26, // Opcode: LWM16_MMR6
/* 219 */     MCD::OPC_FilterValue, 1, 226, 0, 0, // Skip to: 450
/* 224 */     MCD::OPC_CheckPredicate, 24, 221, 0, 0, // Skip to: 450
/* 229 */     MCD::OPC_Decode, 251, 20, 26, // Opcode: SWM16_MMR6
/* 233 */     MCD::OPC_FilterValue, 3, 212, 0, 0, // Skip to: 450
/* 238 */     MCD::OPC_ExtractField, 3, 2,  // Inst{4-3} ...
/* 241 */     MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 256
/* 246 */     MCD::OPC_CheckPredicate, 24, 199, 0, 0, // Skip to: 450
/* 251 */     MCD::OPC_Decode, 162, 13, 137, 1, // Opcode: JRC16_MMR6
/* 256 */     MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 271
/* 261 */     MCD::OPC_CheckPredicate, 24, 184, 0, 0, // Skip to: 450
/* 266 */     MCD::OPC_Decode, 139, 13, 137, 1, // Opcode: JALRC16_MMR6
/* 271 */     MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 286
/* 276 */     MCD::OPC_CheckPredicate, 24, 169, 0, 0, // Skip to: 450
/* 281 */     MCD::OPC_Decode, 163, 13, 138, 1, // Opcode: JRCADDIUSP_MMR6
/* 286 */     MCD::OPC_FilterValue, 3, 159, 0, 0, // Skip to: 450
/* 291 */     MCD::OPC_ExtractField, 5, 1,  // Inst{5} ...
/* 294 */     MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 309
/* 299 */     MCD::OPC_CheckPredicate, 24, 146, 0, 0, // Skip to: 450
/* 304 */     MCD::OPC_Decode, 218, 6, 139, 1, // Opcode: BREAK16_MMR6
/* 309 */     MCD::OPC_FilterValue, 1, 136, 0, 0, // Skip to: 450
/* 314 */     MCD::OPC_CheckPredicate, 24, 131, 0, 0, // Skip to: 450
/* 319 */     MCD::OPC_Decode, 210, 18, 139, 1, // Opcode: SDBBP16_MMR6
/* 324 */     MCD::OPC_FilterValue, 1, 121, 0, 0, // Skip to: 450
/* 329 */     MCD::OPC_CheckPredicate, 24, 116, 0, 0, // Skip to: 450
/* 334 */     MCD::OPC_Decode, 184, 15, 36, // Opcode: MOVEP_MMR6
/* 338 */     MCD::OPC_FilterValue, 34, 9, 0, 0, // Skip to: 352
/* 343 */     MCD::OPC_CheckPredicate, 24, 102, 0, 0, // Skip to: 450
/* 348 */     MCD::OPC_Decode, 190, 18, 20, // Opcode: SB16_MMR6
/* 352 */     MCD::OPC_FilterValue, 35, 9, 0, 0, // Skip to: 366
/* 357 */     MCD::OPC_CheckPredicate, 24, 88, 0, 0, // Skip to: 450
/* 362 */     MCD::OPC_Decode, 223, 5, 37, // Opcode: BEQZC16_MMR6
/* 366 */     MCD::OPC_FilterValue, 42, 9, 0, 0, // Skip to: 380
/* 371 */     MCD::OPC_CheckPredicate, 24, 74, 0, 0, // Skip to: 450
/* 376 */     MCD::OPC_Decode, 128, 19, 20, // Opcode: SH16_MMR6
/* 380 */     MCD::OPC_FilterValue, 43, 9, 0, 0, // Skip to: 394
/* 385 */     MCD::OPC_CheckPredicate, 24, 60, 0, 0, // Skip to: 450
/* 390 */     MCD::OPC_Decode, 199, 6, 37, // Opcode: BNEZC16_MMR6
/* 394 */     MCD::OPC_FilterValue, 50, 9, 0, 0, // Skip to: 408
/* 399 */     MCD::OPC_CheckPredicate, 24, 46, 0, 0, // Skip to: 450
/* 404 */     MCD::OPC_Decode, 132, 21, 30, // Opcode: SWSP_MMR6
/* 408 */     MCD::OPC_FilterValue, 51, 9, 0, 0, // Skip to: 422
/* 413 */     MCD::OPC_CheckPredicate, 24, 32, 0, 0, // Skip to: 450
/* 418 */     MCD::OPC_Decode, 189, 5, 38, // Opcode: BC16_MMR6
/* 422 */     MCD::OPC_FilterValue, 58, 9, 0, 0, // Skip to: 436
/* 427 */     MCD::OPC_CheckPredicate, 24, 18, 0, 0, // Skip to: 450
/* 432 */     MCD::OPC_Decode, 233, 20, 20, // Opcode: SW16_MMR6
/* 436 */     MCD::OPC_FilterValue, 59, 9, 0, 0, // Skip to: 450
/* 441 */     MCD::OPC_CheckPredicate, 24, 4, 0, 0, // Skip to: 450
/* 446 */     MCD::OPC_Decode, 230, 13, 39, // Opcode: LI16_MMR6
/* 450 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMicroMipsR632[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 0, 98, 4, 0, // Skip to: 1130
/* 8 */       MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 11 */      MCD::OPC_FilterValue, 0, 112, 0, 0, // Skip to: 128
/* 16 */      MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 19 */      MCD::OPC_FilterValue, 0, 54, 0, 0, // Skip to: 78
/* 24 */      MCD::OPC_ExtractField, 11, 15,  // Inst{25-11} ...
/* 27 */      MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 41
/* 32 */      MCD::OPC_CheckPredicate, 24, 32, 0, 0, // Skip to: 69
/* 37 */      MCD::OPC_Decode, 158, 20, 0, // Opcode: SSNOP_MMR6
/* 41 */      MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 55
/* 46 */      MCD::OPC_CheckPredicate, 24, 18, 0, 0, // Skip to: 69
/* 51 */      MCD::OPC_Decode, 196, 10, 0, // Opcode: EHB_MMR6
/* 55 */      MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 69
/* 60 */      MCD::OPC_CheckPredicate, 24, 4, 0, 0, // Skip to: 69
/* 65 */      MCD::OPC_Decode, 146, 17, 0, // Opcode: PAUSE_MMR6
/* 69 */      MCD::OPC_CheckPredicate, 24, 63, 12, 0, // Skip to: 3209
/* 74 */      MCD::OPC_Decode, 210, 19, 40, // Opcode: SLL_MMR6
/* 78 */      MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 92
/* 83 */      MCD::OPC_CheckPredicate, 24, 49, 12, 0, // Skip to: 3209
/* 88 */      MCD::OPC_Decode, 238, 18, 43, // Opcode: SELEQZ_MMR6
/* 92 */      MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 106
/* 97 */      MCD::OPC_CheckPredicate, 24, 35, 12, 0, // Skip to: 3209
/* 102 */     MCD::OPC_Decode, 245, 18, 43, // Opcode: SELNEZ_MMR6
/* 106 */     MCD::OPC_FilterValue, 7, 26, 12, 0, // Skip to: 3209
/* 111 */     MCD::OPC_CheckPredicate, 24, 21, 12, 0, // Skip to: 3209
/* 116 */     MCD::OPC_CheckField, 14, 2, 0, 14, 12, 0, // Skip to: 3209
/* 123 */     MCD::OPC_Decode, 135, 18, 140, 1, // Opcode: RDHWR_MMR6
/* 128 */     MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 142
/* 133 */     MCD::OPC_CheckPredicate, 24, 255, 11, 0, // Skip to: 3209
/* 138 */     MCD::OPC_Decode, 220, 6, 44, // Opcode: BREAK_MMR6
/* 142 */     MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 156
/* 147 */     MCD::OPC_CheckPredicate, 24, 241, 11, 0, // Skip to: 3209
/* 152 */     MCD::OPC_Decode, 133, 13, 45, // Opcode: INS_MMR6
/* 156 */     MCD::OPC_FilterValue, 15, 17, 0, 0, // Skip to: 178
/* 161 */     MCD::OPC_CheckPredicate, 24, 227, 11, 0, // Skip to: 3209
/* 166 */     MCD::OPC_CheckField, 6, 3, 0, 220, 11, 0, // Skip to: 3209
/* 173 */     MCD::OPC_Decode, 242, 13, 141, 1, // Opcode: LSA_MMR6
/* 178 */     MCD::OPC_FilterValue, 16, 136, 0, 0, // Skip to: 319
/* 183 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 186 */     MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 207
/* 191 */     MCD::OPC_CheckPredicate, 24, 197, 11, 0, // Skip to: 3209
/* 196 */     MCD::OPC_CheckField, 16, 5, 0, 190, 11, 0, // Skip to: 3209
/* 203 */     MCD::OPC_Decode, 194, 7, 14, // Opcode: CLZ_MMR6
/* 207 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 221
/* 212 */     MCD::OPC_CheckPredicate, 24, 176, 11, 0, // Skip to: 3209
/* 217 */     MCD::OPC_Decode, 241, 4, 43, // Opcode: ADD_MMR6
/* 221 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 235
/* 226 */     MCD::OPC_CheckPredicate, 24, 162, 11, 0, // Skip to: 3209
/* 231 */     MCD::OPC_Decode, 217, 4, 43, // Opcode: ADDU_MMR6
/* 235 */     MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 249
/* 240 */     MCD::OPC_CheckPredicate, 24, 148, 11, 0, // Skip to: 3209
/* 245 */     MCD::OPC_Decode, 225, 20, 43, // Opcode: SUB_MMR6
/* 249 */     MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 263
/* 254 */     MCD::OPC_CheckPredicate, 24, 134, 11, 0, // Skip to: 3209
/* 259 */     MCD::OPC_Decode, 207, 20, 43, // Opcode: SUBU_MMR6
/* 263 */     MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 277
/* 268 */     MCD::OPC_CheckPredicate, 24, 120, 11, 0, // Skip to: 3209
/* 273 */     MCD::OPC_Decode, 133, 5, 43, // Opcode: AND_MMR6
/* 277 */     MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 291
/* 282 */     MCD::OPC_CheckPredicate, 24, 106, 11, 0, // Skip to: 3209
/* 287 */     MCD::OPC_Decode, 250, 16, 43, // Opcode: OR_MMR6
/* 291 */     MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 305
/* 296 */     MCD::OPC_CheckPredicate, 24, 92, 11, 0, // Skip to: 3209
/* 301 */     MCD::OPC_Decode, 237, 16, 43, // Opcode: NOR_MMR6
/* 305 */     MCD::OPC_FilterValue, 12, 83, 11, 0, // Skip to: 3209
/* 310 */     MCD::OPC_CheckPredicate, 24, 78, 11, 0, // Skip to: 3209
/* 315 */     MCD::OPC_Decode, 250, 21, 43, // Opcode: XOR_MMR6
/* 319 */     MCD::OPC_FilterValue, 24, 115, 0, 0, // Skip to: 439
/* 324 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 327 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 341
/* 332 */     MCD::OPC_CheckPredicate, 24, 56, 11, 0, // Skip to: 3209
/* 337 */     MCD::OPC_Decode, 203, 16, 43, // Opcode: MUL_MMR6
/* 341 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 355
/* 346 */     MCD::OPC_CheckPredicate, 24, 42, 11, 0, // Skip to: 3209
/* 351 */     MCD::OPC_Decode, 164, 16, 43, // Opcode: MUH_MMR6
/* 355 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 369
/* 360 */     MCD::OPC_CheckPredicate, 24, 28, 11, 0, // Skip to: 3209
/* 365 */     MCD::OPC_Decode, 197, 16, 43, // Opcode: MULU_MMR6
/* 369 */     MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 383
/* 374 */     MCD::OPC_CheckPredicate, 24, 14, 11, 0, // Skip to: 3209
/* 379 */     MCD::OPC_Decode, 163, 16, 43, // Opcode: MUHU_MMR6
/* 383 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 397
/* 388 */     MCD::OPC_CheckPredicate, 24, 0, 11, 0, // Skip to: 3209
/* 393 */     MCD::OPC_Decode, 214, 9, 43, // Opcode: DIV_MMR6
/* 397 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 411
/* 402 */     MCD::OPC_CheckPredicate, 24, 242, 10, 0, // Skip to: 3209
/* 407 */     MCD::OPC_Decode, 172, 15, 43, // Opcode: MOD_MMR6
/* 411 */     MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 425
/* 416 */     MCD::OPC_CheckPredicate, 24, 228, 10, 0, // Skip to: 3209
/* 421 */     MCD::OPC_Decode, 213, 9, 43, // Opcode: DIVU_MMR6
/* 425 */     MCD::OPC_FilterValue, 7, 219, 10, 0, // Skip to: 3209
/* 430 */     MCD::OPC_CheckPredicate, 24, 214, 10, 0, // Skip to: 3209
/* 435 */     MCD::OPC_Decode, 171, 15, 43, // Opcode: MODU_MMR6
/* 439 */     MCD::OPC_FilterValue, 31, 17, 0, 0, // Skip to: 461
/* 444 */     MCD::OPC_CheckPredicate, 24, 200, 10, 0, // Skip to: 3209
/* 449 */     MCD::OPC_CheckField, 6, 3, 0, 193, 10, 0, // Skip to: 3209
/* 456 */     MCD::OPC_Decode, 249, 4, 142, 1, // Opcode: ALIGN_MMR6
/* 461 */     MCD::OPC_FilterValue, 44, 9, 0, 0, // Skip to: 475
/* 466 */     MCD::OPC_CheckPredicate, 24, 178, 10, 0, // Skip to: 3209
/* 471 */     MCD::OPC_Decode, 237, 10, 54, // Opcode: EXT_MMR6
/* 475 */     MCD::OPC_FilterValue, 52, 45, 0, 0, // Skip to: 525
/* 480 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 483 */     MCD::OPC_FilterValue, 3, 16, 0, 0, // Skip to: 504
/* 488 */     MCD::OPC_CheckPredicate, 24, 156, 10, 0, // Skip to: 3209
/* 493 */     MCD::OPC_CheckField, 14, 2, 0, 149, 10, 0, // Skip to: 3209
/* 500 */     MCD::OPC_Decode, 246, 14, 56, // Opcode: MFHC0_MMR6
/* 504 */     MCD::OPC_FilterValue, 11, 140, 10, 0, // Skip to: 3209
/* 509 */     MCD::OPC_CheckPredicate, 24, 135, 10, 0, // Skip to: 3209
/* 514 */     MCD::OPC_CheckField, 14, 2, 0, 128, 10, 0, // Skip to: 3209
/* 521 */     MCD::OPC_Decode, 134, 16, 57, // Opcode: MTHC0_MMR6
/* 525 */     MCD::OPC_FilterValue, 60, 66, 2, 0, // Skip to: 1108
/* 530 */     MCD::OPC_ExtractField, 14, 2,  // Inst{15-14} ...
/* 533 */     MCD::OPC_FilterValue, 0, 138, 0, 0, // Skip to: 676
/* 538 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 541 */     MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 555
/* 546 */     MCD::OPC_CheckPredicate, 24, 98, 10, 0, // Skip to: 3209
/* 551 */     MCD::OPC_Decode, 237, 14, 56, // Opcode: MFC0_MMR6
/* 555 */     MCD::OPC_FilterValue, 5, 45, 0, 0, // Skip to: 605
/* 560 */     MCD::OPC_ExtractField, 11, 3,  // Inst{13-11} ...
/* 563 */     MCD::OPC_FilterValue, 3, 16, 0, 0, // Skip to: 584
/* 568 */     MCD::OPC_CheckPredicate, 24, 76, 10, 0, // Skip to: 3209
/* 573 */     MCD::OPC_CheckField, 21, 5, 0, 69, 10, 0, // Skip to: 3209
/* 580 */     MCD::OPC_Decode, 191, 10, 80, // Opcode: DVP_MMR6
/* 584 */     MCD::OPC_FilterValue, 7, 60, 10, 0, // Skip to: 3209
/* 589 */     MCD::OPC_CheckPredicate, 24, 55, 10, 0, // Skip to: 3209
/* 594 */     MCD::OPC_CheckField, 21, 5, 0, 48, 10, 0, // Skip to: 3209
/* 601 */     MCD::OPC_Decode, 208, 10, 80, // Opcode: EVP_MMR6
/* 605 */     MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 619
/* 610 */     MCD::OPC_CheckPredicate, 24, 34, 10, 0, // Skip to: 3209
/* 615 */     MCD::OPC_Decode, 252, 15, 57, // Opcode: MTC0_MMR6
/* 619 */     MCD::OPC_FilterValue, 12, 16, 0, 0, // Skip to: 640
/* 624 */     MCD::OPC_CheckPredicate, 24, 20, 10, 0, // Skip to: 3209
/* 629 */     MCD::OPC_CheckField, 11, 3, 1, 13, 10, 0, // Skip to: 3209
/* 636 */     MCD::OPC_Decode, 148, 6, 74, // Opcode: BITSWAP_MMR6
/* 640 */     MCD::OPC_FilterValue, 28, 4, 10, 0, // Skip to: 3209
/* 645 */     MCD::OPC_ExtractField, 11, 3,  // Inst{13-11} ...
/* 648 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 662
/* 653 */     MCD::OPC_CheckPredicate, 24, 247, 9, 0, // Skip to: 3209
/* 658 */     MCD::OPC_Decode, 141, 13, 68, // Opcode: JALRC_MMR6
/* 662 */     MCD::OPC_FilterValue, 3, 238, 9, 0, // Skip to: 3209
/* 667 */     MCD::OPC_CheckPredicate, 24, 233, 9, 0, // Skip to: 3209
/* 672 */     MCD::OPC_Decode, 140, 13, 68, // Opcode: JALRC_HB_MMR6
/* 676 */     MCD::OPC_FilterValue, 1, 10, 1, 0, // Skip to: 947
/* 681 */     MCD::OPC_ExtractField, 11, 3,  // Inst{13-11} ...
/* 684 */     MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 734
/* 689 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 692 */     MCD::OPC_FilterValue, 13, 16, 0, 0, // Skip to: 713
/* 697 */     MCD::OPC_CheckPredicate, 24, 203, 9, 0, // Skip to: 3209
/* 702 */     MCD::OPC_CheckField, 16, 10, 0, 196, 9, 0, // Skip to: 3209
/* 709 */     MCD::OPC_Decode, 193, 21, 0, // Opcode: TLBINV_MMR6
/* 713 */     MCD::OPC_FilterValue, 29, 187, 9, 0, // Skip to: 3209
/* 718 */     MCD::OPC_CheckPredicate, 24, 182, 9, 0, // Skip to: 3209
/* 723 */     MCD::OPC_CheckField, 21, 5, 0, 175, 9, 0, // Skip to: 3209
/* 730 */     MCD::OPC_Decode, 224, 9, 80, // Opcode: DI_MMR6
/* 734 */     MCD::OPC_FilterValue, 1, 31, 0, 0, // Skip to: 770
/* 739 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 742 */     MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 756
/* 747 */     MCD::OPC_CheckPredicate, 24, 153, 9, 0, // Skip to: 3209
/* 752 */     MCD::OPC_Decode, 174, 7, 68, // Opcode: CLO_MMR6
/* 756 */     MCD::OPC_FilterValue, 20, 144, 9, 0, // Skip to: 3209
/* 761 */     MCD::OPC_CheckPredicate, 24, 139, 9, 0, // Skip to: 3209
/* 766 */     MCD::OPC_Decode, 243, 14, 78, // Opcode: MFC2_MMR6
/* 770 */     MCD::OPC_FilterValue, 2, 45, 0, 0, // Skip to: 820
/* 775 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 778 */     MCD::OPC_FilterValue, 13, 16, 0, 0, // Skip to: 799
/* 783 */     MCD::OPC_CheckPredicate, 24, 117, 9, 0, // Skip to: 3209
/* 788 */     MCD::OPC_CheckField, 16, 10, 0, 110, 9, 0, // Skip to: 3209
/* 795 */     MCD::OPC_Decode, 192, 21, 0, // Opcode: TLBINVF_MMR6
/* 799 */     MCD::OPC_FilterValue, 29, 101, 9, 0, // Skip to: 3209
/* 804 */     MCD::OPC_CheckPredicate, 24, 96, 9, 0, // Skip to: 3209
/* 809 */     MCD::OPC_CheckField, 21, 5, 0, 89, 9, 0, // Skip to: 3209
/* 816 */     MCD::OPC_Decode, 199, 10, 80, // Opcode: EI_MMR6
/* 820 */     MCD::OPC_FilterValue, 3, 16, 0, 0, // Skip to: 841
/* 825 */     MCD::OPC_CheckPredicate, 24, 75, 9, 0, // Skip to: 3209
/* 830 */     MCD::OPC_CheckField, 6, 5, 20, 68, 9, 0, // Skip to: 3209
/* 837 */     MCD::OPC_Decode, 131, 16, 79, // Opcode: MTC2_MMR6
/* 841 */     MCD::OPC_FilterValue, 4, 23, 0, 0, // Skip to: 869
/* 846 */     MCD::OPC_CheckPredicate, 25, 54, 9, 0, // Skip to: 3209
/* 851 */     MCD::OPC_CheckField, 21, 5, 0, 47, 9, 0, // Skip to: 3209
/* 858 */     MCD::OPC_CheckField, 6, 3, 5, 40, 9, 0, // Skip to: 3209
/* 865 */     MCD::OPC_Decode, 160, 12, 80, // Opcode: GINVI_MMR6
/* 869 */     MCD::OPC_FilterValue, 5, 23, 0, 0, // Skip to: 897
/* 874 */     MCD::OPC_CheckPredicate, 24, 26, 9, 0, // Skip to: 3209
/* 879 */     MCD::OPC_CheckField, 21, 5, 0, 19, 9, 0, // Skip to: 3209
/* 886 */     MCD::OPC_CheckField, 6, 5, 13, 12, 9, 0, // Skip to: 3209
/* 893 */     MCD::OPC_Decode, 142, 21, 75, // Opcode: SYNC_MMR6
/* 897 */     MCD::OPC_FilterValue, 6, 24, 0, 0, // Skip to: 926
/* 902 */     MCD::OPC_CheckPredicate, 25, 254, 8, 0, // Skip to: 3209
/* 907 */     MCD::OPC_CheckField, 21, 5, 0, 247, 8, 0, // Skip to: 3209
/* 914 */     MCD::OPC_CheckField, 6, 3, 5, 240, 8, 0, // Skip to: 3209
/* 921 */     MCD::OPC_Decode, 162, 12, 143, 1, // Opcode: GINVT_MMR6
/* 926 */     MCD::OPC_FilterValue, 7, 230, 8, 0, // Skip to: 3209
/* 931 */     MCD::OPC_CheckPredicate, 24, 225, 8, 0, // Skip to: 3209
/* 936 */     MCD::OPC_CheckField, 6, 5, 12, 218, 8, 0, // Skip to: 3209
/* 943 */     MCD::OPC_Decode, 242, 21, 68, // Opcode: WSBH_MMR6
/* 947 */     MCD::OPC_FilterValue, 2, 45, 0, 0, // Skip to: 997
/* 952 */     MCD::OPC_ExtractField, 6, 8,  // Inst{13-6} ...
/* 955 */     MCD::OPC_FilterValue, 52, 9, 0, 0, // Skip to: 969
/* 960 */     MCD::OPC_CheckPredicate, 24, 196, 8, 0, // Skip to: 3209
/* 965 */     MCD::OPC_Decode, 251, 14, 78, // Opcode: MFHC2_MMR6
/* 969 */     MCD::OPC_FilterValue, 77, 9, 0, 0, // Skip to: 983
/* 974 */     MCD::OPC_CheckPredicate, 24, 182, 8, 0, // Skip to: 3209
/* 979 */     MCD::OPC_Decode, 236, 21, 76, // Opcode: WAIT_MMR6
/* 983 */     MCD::OPC_FilterValue, 116, 173, 8, 0, // Skip to: 3209
/* 988 */     MCD::OPC_CheckPredicate, 24, 168, 8, 0, // Skip to: 3209
/* 993 */     MCD::OPC_Decode, 139, 16, 79, // Opcode: MTHC2_MMR6
/* 997 */     MCD::OPC_FilterValue, 3, 159, 8, 0, // Skip to: 3209
/* 1002 */    MCD::OPC_ExtractField, 6, 8,  // Inst{13-6} ...
/* 1005 */    MCD::OPC_FilterValue, 109, 9, 0, 0, // Skip to: 1019
/* 1010 */    MCD::OPC_CheckPredicate, 24, 146, 8, 0, // Skip to: 3209
/* 1015 */    MCD::OPC_Decode, 212, 18, 76, // Opcode: SDBBP_MMR6
/* 1019 */    MCD::OPC_FilterValue, 133, 1, 9, 0, 0, // Skip to: 1034
/* 1025 */    MCD::OPC_CheckPredicate, 24, 131, 8, 0, // Skip to: 3209
/* 1030 */    MCD::OPC_Decode, 136, 18, 68, // Opcode: RDPGPR_MMR6
/* 1034 */    MCD::OPC_FilterValue, 141, 1, 16, 0, 0, // Skip to: 1056
/* 1040 */    MCD::OPC_CheckPredicate, 24, 116, 8, 0, // Skip to: 3209
/* 1045 */    MCD::OPC_CheckField, 16, 10, 0, 109, 8, 0, // Skip to: 3209
/* 1052 */    MCD::OPC_Decode, 202, 9, 0, // Opcode: DERET_MMR6
/* 1056 */    MCD::OPC_FilterValue, 197, 1, 9, 0, 0, // Skip to: 1071
/* 1062 */    MCD::OPC_CheckPredicate, 24, 94, 8, 0, // Skip to: 3209
/* 1067 */    MCD::OPC_Decode, 239, 21, 68, // Opcode: WRPGPR_MMR6
/* 1071 */    MCD::OPC_FilterValue, 205, 1, 84, 8, 0, // Skip to: 3209
/* 1077 */    MCD::OPC_ExtractField, 16, 10,  // Inst{25-16} ...
/* 1080 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 1094
/* 1085 */    MCD::OPC_CheckPredicate, 24, 71, 8, 0, // Skip to: 3209
/* 1090 */    MCD::OPC_Decode, 205, 10, 0, // Opcode: ERET_MMR6
/* 1094 */    MCD::OPC_FilterValue, 1, 62, 8, 0, // Skip to: 3209
/* 1099 */    MCD::OPC_CheckPredicate, 24, 57, 8, 0, // Skip to: 3209
/* 1104 */    MCD::OPC_Decode, 203, 10, 0, // Opcode: ERETNC_MMR6
/* 1108 */    MCD::OPC_FilterValue, 63, 48, 8, 0, // Skip to: 3209
/* 1113 */    MCD::OPC_CheckPredicate, 24, 43, 8, 0, // Skip to: 3209
/* 1118 */    MCD::OPC_CheckField, 22, 4, 0, 36, 8, 0, // Skip to: 3209
/* 1125 */    MCD::OPC_Decode, 186, 19, 144, 1, // Opcode: SIGRIE_MMR6
/* 1130 */    MCD::OPC_FilterValue, 4, 26, 0, 0, // Skip to: 1161
/* 1135 */    MCD::OPC_CheckPredicate, 24, 12, 0, 0, // Skip to: 1152
/* 1140 */    MCD::OPC_CheckField, 16, 5, 0, 5, 0, 0, // Skip to: 1152
/* 1147 */    MCD::OPC_Decode, 244, 13, 145, 1, // Opcode: LUI_MMR6
/* 1152 */    MCD::OPC_CheckPredicate, 24, 4, 8, 0, // Skip to: 3209
/* 1157 */    MCD::OPC_Decode, 151, 5, 96, // Opcode: AUI_MMR6
/* 1161 */    MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 1176
/* 1166 */    MCD::OPC_CheckPredicate, 24, 246, 7, 0, // Skip to: 3209
/* 1171 */    MCD::OPC_Decode, 183, 13, 146, 1, // Opcode: LBU_MMR6
/* 1176 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 1190
/* 1181 */    MCD::OPC_CheckPredicate, 24, 231, 7, 0, // Skip to: 3209
/* 1186 */    MCD::OPC_Decode, 195, 18, 86, // Opcode: SB_MMR6
/* 1190 */    MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 1205
/* 1195 */    MCD::OPC_CheckPredicate, 24, 217, 7, 0, // Skip to: 3209
/* 1200 */    MCD::OPC_Decode, 185, 13, 146, 1, // Opcode: LB_MMR6
/* 1205 */    MCD::OPC_FilterValue, 8, 105, 0, 0, // Skip to: 1315
/* 1210 */    MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 1213 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 1235
/* 1218 */    MCD::OPC_CheckPredicate, 24, 194, 7, 0, // Skip to: 3209
/* 1223 */    MCD::OPC_CheckField, 11, 1, 0, 187, 7, 0, // Skip to: 3209
/* 1230 */    MCD::OPC_Decode, 129, 14, 147, 1, // Opcode: LWC2_MMR6
/* 1235 */    MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 1257
/* 1240 */    MCD::OPC_CheckPredicate, 24, 172, 7, 0, // Skip to: 3209
/* 1245 */    MCD::OPC_CheckField, 11, 1, 0, 165, 7, 0, // Skip to: 3209
/* 1252 */    MCD::OPC_Decode, 197, 13, 147, 1, // Opcode: LDC2_MMR6
/* 1257 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 1271
/* 1262 */    MCD::OPC_CheckPredicate, 24, 150, 7, 0, // Skip to: 3209
/* 1267 */    MCD::OPC_Decode, 251, 6, 88, // Opcode: CACHE_MMR6
/* 1271 */    MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 1293
/* 1276 */    MCD::OPC_CheckPredicate, 24, 136, 7, 0, // Skip to: 3209
/* 1281 */    MCD::OPC_CheckField, 11, 1, 0, 129, 7, 0, // Skip to: 3209
/* 1288 */    MCD::OPC_Decode, 238, 20, 147, 1, // Opcode: SWC2_MMR6
/* 1293 */    MCD::OPC_FilterValue, 10, 119, 7, 0, // Skip to: 3209
/* 1298 */    MCD::OPC_CheckPredicate, 24, 114, 7, 0, // Skip to: 3209
/* 1303 */    MCD::OPC_CheckField, 11, 1, 0, 107, 7, 0, // Skip to: 3209
/* 1310 */    MCD::OPC_Decode, 219, 18, 147, 1, // Opcode: SDC2_MMR6
/* 1315 */    MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 1329
/* 1320 */    MCD::OPC_CheckPredicate, 24, 92, 7, 0, // Skip to: 3209
/* 1325 */    MCD::OPC_Decode, 182, 4, 85, // Opcode: ADDIU_MMR6
/* 1329 */    MCD::OPC_FilterValue, 14, 9, 0, 0, // Skip to: 1343
/* 1334 */    MCD::OPC_CheckPredicate, 24, 78, 7, 0, // Skip to: 3209
/* 1339 */    MCD::OPC_Decode, 184, 19, 86, // Opcode: SH_MMR6
/* 1343 */    MCD::OPC_FilterValue, 16, 78, 0, 0, // Skip to: 1426
/* 1348 */    MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 1351 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 1366
/* 1356 */    MCD::OPC_CheckPredicate, 26, 56, 7, 0, // Skip to: 3209
/* 1361 */    MCD::OPC_Decode, 191, 5, 148, 1, // Opcode: BC1EQZC_MMR6
/* 1366 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 1381
/* 1371 */    MCD::OPC_CheckPredicate, 26, 41, 7, 0, // Skip to: 3209
/* 1376 */    MCD::OPC_Decode, 196, 5, 148, 1, // Opcode: BC1NEZC_MMR6
/* 1381 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 1396
/* 1386 */    MCD::OPC_CheckPredicate, 24, 26, 7, 0, // Skip to: 3209
/* 1391 */    MCD::OPC_Decode, 201, 5, 149, 1, // Opcode: BC2EQZC_MMR6
/* 1396 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 1411
/* 1401 */    MCD::OPC_CheckPredicate, 24, 11, 7, 0, // Skip to: 3209
/* 1406 */    MCD::OPC_Decode, 203, 5, 149, 1, // Opcode: BC2NEZC_MMR6
/* 1411 */    MCD::OPC_FilterValue, 12, 1, 7, 0, // Skip to: 3209
/* 1416 */    MCD::OPC_CheckPredicate, 24, 252, 6, 0, // Skip to: 3209
/* 1421 */    MCD::OPC_Decode, 140, 21, 150, 1, // Opcode: SYNCI_MMR6
/* 1426 */    MCD::OPC_FilterValue, 20, 9, 0, 0, // Skip to: 1440
/* 1431 */    MCD::OPC_CheckPredicate, 24, 237, 6, 0, // Skip to: 3209
/* 1436 */    MCD::OPC_Decode, 248, 16, 96, // Opcode: ORI_MMR6
/* 1440 */    MCD::OPC_FilterValue, 21, 72, 5, 0, // Skip to: 2797
/* 1445 */    MCD::OPC_ExtractField, 0, 11,  // Inst{10-0} ...
/* 1448 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 1463
/* 1453 */    MCD::OPC_CheckPredicate, 26, 215, 6, 0, // Skip to: 3209
/* 1458 */    MCD::OPC_Decode, 161, 15, 151, 1, // Opcode: MIN_S_MMR6
/* 1463 */    MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 1478
/* 1468 */    MCD::OPC_CheckPredicate, 26, 200, 6, 0, // Skip to: 3209
/* 1473 */    MCD::OPC_Decode, 215, 7, 152, 1, // Opcode: CMP_AF_S_MMR6
/* 1478 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 1493
/* 1483 */    MCD::OPC_CheckPredicate, 26, 185, 6, 0, // Skip to: 3209
/* 1488 */    MCD::OPC_Decode, 230, 14, 151, 1, // Opcode: MAX_S_MMR6
/* 1493 */    MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 1508
/* 1498 */    MCD::OPC_CheckPredicate, 26, 170, 6, 0, // Skip to: 3209
/* 1503 */    MCD::OPC_Decode, 214, 7, 153, 1, // Opcode: CMP_AF_D_MMR6
/* 1508 */    MCD::OPC_FilterValue, 32, 17, 0, 0, // Skip to: 1530
/* 1513 */    MCD::OPC_CheckPredicate, 24, 155, 6, 0, // Skip to: 3209
/* 1518 */    MCD::OPC_CheckField, 11, 5, 0, 148, 6, 0, // Skip to: 3209
/* 1525 */    MCD::OPC_Decode, 154, 18, 154, 1, // Opcode: RINT_S_MMR6
/* 1530 */    MCD::OPC_FilterValue, 35, 10, 0, 0, // Skip to: 1545
/* 1535 */    MCD::OPC_CheckPredicate, 26, 133, 6, 0, // Skip to: 3209
/* 1540 */    MCD::OPC_Decode, 142, 15, 151, 1, // Opcode: MINA_S_MMR6
/* 1545 */    MCD::OPC_FilterValue, 43, 10, 0, 0, // Skip to: 1560
/* 1550 */    MCD::OPC_CheckPredicate, 26, 118, 6, 0, // Skip to: 3209
/* 1555 */    MCD::OPC_Decode, 211, 14, 151, 1, // Opcode: MAXA_S_MMR6
/* 1560 */    MCD::OPC_FilterValue, 48, 10, 0, 0, // Skip to: 1575
/* 1565 */    MCD::OPC_CheckPredicate, 26, 103, 6, 0, // Skip to: 3209
/* 1570 */    MCD::OPC_Decode, 251, 10, 155, 1, // Opcode: FADD_S_MMR6
/* 1575 */    MCD::OPC_FilterValue, 56, 10, 0, 0, // Skip to: 1590
/* 1580 */    MCD::OPC_CheckPredicate, 24, 88, 6, 0, // Skip to: 3209
/* 1585 */    MCD::OPC_Decode, 240, 18, 151, 1, // Opcode: SELEQZ_S_MMR6
/* 1590 */    MCD::OPC_FilterValue, 59, 31, 0, 0, // Skip to: 1626
/* 1595 */    MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 1598 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 1612
/* 1603 */    MCD::OPC_CheckPredicate, 26, 65, 6, 0, // Skip to: 3209
/* 1608 */    MCD::OPC_Decode, 241, 14, 107, // Opcode: MFC1_MMR6
/* 1612 */    MCD::OPC_FilterValue, 5, 56, 6, 0, // Skip to: 3209
/* 1617 */    MCD::OPC_CheckPredicate, 26, 51, 6, 0, // Skip to: 3209
/* 1622 */    MCD::OPC_Decode, 129, 16, 113, // Opcode: MTC1_MMR6
/* 1626 */    MCD::OPC_FilterValue, 69, 10, 0, 0, // Skip to: 1641
/* 1631 */    MCD::OPC_CheckPredicate, 26, 37, 6, 0, // Skip to: 3209
/* 1636 */    MCD::OPC_Decode, 155, 8, 152, 1, // Opcode: CMP_UN_S_MMR6
/* 1641 */    MCD::OPC_FilterValue, 85, 10, 0, 0, // Skip to: 1656
/* 1646 */    MCD::OPC_CheckPredicate, 26, 22, 6, 0, // Skip to: 3209
/* 1651 */    MCD::OPC_Decode, 153, 8, 153, 1, // Opcode: CMP_UN_D_MMR6
/* 1656 */    MCD::OPC_FilterValue, 96, 17, 0, 0, // Skip to: 1678
/* 1661 */    MCD::OPC_CheckPredicate, 24, 7, 6, 0, // Skip to: 3209
/* 1666 */    MCD::OPC_CheckField, 11, 5, 0, 0, 6, 0, // Skip to: 3209
/* 1673 */    MCD::OPC_Decode, 155, 7, 154, 1, // Opcode: CLASS_S_MMR6
/* 1678 */    MCD::OPC_FilterValue, 112, 10, 0, 0, // Skip to: 1693
/* 1683 */    MCD::OPC_CheckPredicate, 26, 241, 5, 0, // Skip to: 3209
/* 1688 */    MCD::OPC_Decode, 137, 12, 155, 1, // Opcode: FSUB_S_MMR6
/* 1693 */    MCD::OPC_FilterValue, 120, 10, 0, 0, // Skip to: 1708
/* 1698 */    MCD::OPC_CheckPredicate, 24, 226, 5, 0, // Skip to: 3209
/* 1703 */    MCD::OPC_Decode, 247, 18, 151, 1, // Opcode: SELNEZ_S_MMR6
/* 1708 */    MCD::OPC_FilterValue, 123, 16, 0, 0, // Skip to: 1729
/* 1713 */    MCD::OPC_CheckPredicate, 26, 211, 5, 0, // Skip to: 3209
/* 1718 */    MCD::OPC_CheckField, 11, 5, 0, 204, 5, 0, // Skip to: 3209
/* 1725 */    MCD::OPC_Decode, 212, 11, 112, // Opcode: FMOV_S_MMR6
/* 1729 */    MCD::OPC_FilterValue, 133, 1, 10, 0, 0, // Skip to: 1745
/* 1735 */    MCD::OPC_CheckPredicate, 26, 189, 5, 0, // Skip to: 3209
/* 1740 */    MCD::OPC_Decode, 221, 7, 152, 1, // Opcode: CMP_EQ_S_MMR6
/* 1745 */    MCD::OPC_FilterValue, 149, 1, 10, 0, 0, // Skip to: 1761
/* 1751 */    MCD::OPC_CheckPredicate, 26, 173, 5, 0, // Skip to: 3209
/* 1756 */    MCD::OPC_Decode, 217, 7, 153, 1, // Opcode: CMP_EQ_D_MMR6
/* 1761 */    MCD::OPC_FilterValue, 176, 1, 10, 0, 0, // Skip to: 1777
/* 1767 */    MCD::OPC_CheckPredicate, 26, 157, 5, 0, // Skip to: 3209
/* 1772 */    MCD::OPC_Decode, 222, 11, 155, 1, // Opcode: FMUL_S_MMR6
/* 1777 */    MCD::OPC_FilterValue, 184, 1, 10, 0, 0, // Skip to: 1793
/* 1783 */    MCD::OPC_CheckPredicate, 24, 141, 5, 0, // Skip to: 3209
/* 1788 */    MCD::OPC_Decode, 251, 18, 156, 1, // Opcode: SEL_S_MMR6
/* 1793 */    MCD::OPC_FilterValue, 197, 1, 10, 0, 0, // Skip to: 1809
/* 1799 */    MCD::OPC_CheckPredicate, 26, 125, 5, 0, // Skip to: 3209
/* 1804 */    MCD::OPC_Decode, 143, 8, 152, 1, // Opcode: CMP_UEQ_S_MMR6
/* 1809 */    MCD::OPC_FilterValue, 213, 1, 10, 0, 0, // Skip to: 1825
/* 1815 */    MCD::OPC_CheckPredicate, 26, 109, 5, 0, // Skip to: 3209
/* 1820 */    MCD::OPC_Decode, 141, 8, 153, 1, // Opcode: CMP_UEQ_D_MMR6
/* 1825 */    MCD::OPC_FilterValue, 240, 1, 10, 0, 0, // Skip to: 1841
/* 1831 */    MCD::OPC_CheckPredicate, 26, 93, 5, 0, // Skip to: 3209
/* 1836 */    MCD::OPC_Decode, 161, 11, 155, 1, // Opcode: FDIV_S_MMR6
/* 1841 */    MCD::OPC_FilterValue, 133, 2, 10, 0, 0, // Skip to: 1857
/* 1847 */    MCD::OPC_CheckPredicate, 26, 77, 5, 0, // Skip to: 3209
/* 1852 */    MCD::OPC_Decode, 235, 7, 152, 1, // Opcode: CMP_LT_S_MMR6
/* 1857 */    MCD::OPC_FilterValue, 149, 2, 10, 0, 0, // Skip to: 1873
/* 1863 */    MCD::OPC_CheckPredicate, 26, 61, 5, 0, // Skip to: 3209
/* 1868 */    MCD::OPC_Decode, 231, 7, 153, 1, // Opcode: CMP_LT_D_MMR6
/* 1873 */    MCD::OPC_FilterValue, 187, 2, 45, 0, 0, // Skip to: 1924
/* 1879 */    MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 1882 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 1896
/* 1887 */    MCD::OPC_CheckPredicate, 26, 37, 5, 0, // Skip to: 3209
/* 1892 */    MCD::OPC_Decode, 192, 8, 109, // Opcode: CVT_L_S_MMR6
/* 1896 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 1910
/* 1901 */    MCD::OPC_CheckPredicate, 26, 23, 5, 0, // Skip to: 3209
/* 1906 */    MCD::OPC_Decode, 211, 8, 112, // Opcode: CVT_W_S_MMR6
/* 1910 */    MCD::OPC_FilterValue, 8, 14, 5, 0, // Skip to: 3209
/* 1915 */    MCD::OPC_CheckPredicate, 26, 9, 5, 0, // Skip to: 3209
/* 1920 */    MCD::OPC_Decode, 189, 8, 110, // Opcode: CVT_L_D_MMR6
/* 1924 */    MCD::OPC_FilterValue, 197, 2, 10, 0, 0, // Skip to: 1940
/* 1930 */    MCD::OPC_CheckPredicate, 26, 250, 4, 0, // Skip to: 3209
/* 1935 */    MCD::OPC_Decode, 151, 8, 152, 1, // Opcode: CMP_ULT_S_MMR6
/* 1940 */    MCD::OPC_FilterValue, 213, 2, 10, 0, 0, // Skip to: 1956
/* 1946 */    MCD::OPC_CheckPredicate, 26, 234, 4, 0, // Skip to: 3209
/* 1951 */    MCD::OPC_Decode, 149, 8, 153, 1, // Opcode: CMP_ULT_D_MMR6
/* 1956 */    MCD::OPC_FilterValue, 133, 3, 10, 0, 0, // Skip to: 1972
/* 1962 */    MCD::OPC_CheckPredicate, 26, 218, 4, 0, // Skip to: 3209
/* 1967 */    MCD::OPC_Decode, 229, 7, 152, 1, // Opcode: CMP_LE_S_MMR6
/* 1972 */    MCD::OPC_FilterValue, 149, 3, 10, 0, 0, // Skip to: 1988
/* 1978 */    MCD::OPC_CheckPredicate, 26, 202, 4, 0, // Skip to: 3209
/* 1983 */    MCD::OPC_Decode, 225, 7, 153, 1, // Opcode: CMP_LE_D_MMR6
/* 1988 */    MCD::OPC_FilterValue, 184, 3, 10, 0, 0, // Skip to: 2004
/* 1994 */    MCD::OPC_CheckPredicate, 26, 186, 4, 0, // Skip to: 3209
/* 1999 */    MCD::OPC_Decode, 179, 14, 157, 1, // Opcode: MADDF_S_MMR6
/* 2004 */    MCD::OPC_FilterValue, 197, 3, 10, 0, 0, // Skip to: 2020
/* 2010 */    MCD::OPC_CheckPredicate, 26, 170, 4, 0, // Skip to: 3209
/* 2015 */    MCD::OPC_Decode, 147, 8, 152, 1, // Opcode: CMP_ULE_S_MMR6
/* 2020 */    MCD::OPC_FilterValue, 213, 3, 10, 0, 0, // Skip to: 2036
/* 2026 */    MCD::OPC_CheckPredicate, 26, 154, 4, 0, // Skip to: 3209
/* 2031 */    MCD::OPC_Decode, 145, 8, 153, 1, // Opcode: CMP_ULE_D_MMR6
/* 2036 */    MCD::OPC_FilterValue, 248, 3, 10, 0, 0, // Skip to: 2052
/* 2042 */    MCD::OPC_CheckPredicate, 26, 138, 4, 0, // Skip to: 3209
/* 2047 */    MCD::OPC_Decode, 230, 15, 157, 1, // Opcode: MSUBF_S_MMR6
/* 2052 */    MCD::OPC_FilterValue, 131, 4, 10, 0, 0, // Skip to: 2068
/* 2058 */    MCD::OPC_CheckPredicate, 26, 122, 4, 0, // Skip to: 3209
/* 2063 */    MCD::OPC_Decode, 156, 15, 132, 1, // Opcode: MIN_D_MMR6
/* 2068 */    MCD::OPC_FilterValue, 133, 4, 10, 0, 0, // Skip to: 2084
/* 2074 */    MCD::OPC_CheckPredicate, 26, 106, 4, 0, // Skip to: 3209
/* 2079 */    MCD::OPC_Decode, 239, 7, 152, 1, // Opcode: CMP_SAF_S_MMR6
/* 2084 */    MCD::OPC_FilterValue, 139, 4, 10, 0, 0, // Skip to: 2100
/* 2090 */    MCD::OPC_CheckPredicate, 26, 90, 4, 0, // Skip to: 3209
/* 2095 */    MCD::OPC_Decode, 225, 14, 132, 1, // Opcode: MAX_D_MMR6
/* 2100 */    MCD::OPC_FilterValue, 149, 4, 10, 0, 0, // Skip to: 2116
/* 2106 */    MCD::OPC_CheckPredicate, 26, 74, 4, 0, // Skip to: 3209
/* 2111 */    MCD::OPC_Decode, 237, 7, 153, 1, // Opcode: CMP_SAF_D_MMR6
/* 2116 */    MCD::OPC_FilterValue, 160, 4, 17, 0, 0, // Skip to: 2139
/* 2122 */    MCD::OPC_CheckPredicate, 24, 58, 4, 0, // Skip to: 3209
/* 2127 */    MCD::OPC_CheckField, 11, 5, 0, 51, 4, 0, // Skip to: 3209
/* 2134 */    MCD::OPC_Decode, 152, 18, 158, 1, // Opcode: RINT_D_MMR6
/* 2139 */    MCD::OPC_FilterValue, 163, 4, 10, 0, 0, // Skip to: 2155
/* 2145 */    MCD::OPC_CheckPredicate, 26, 35, 4, 0, // Skip to: 3209
/* 2150 */    MCD::OPC_Decode, 140, 15, 132, 1, // Opcode: MINA_D_MMR6
/* 2155 */    MCD::OPC_FilterValue, 171, 4, 10, 0, 0, // Skip to: 2171
/* 2161 */    MCD::OPC_CheckPredicate, 26, 19, 4, 0, // Skip to: 3209
/* 2166 */    MCD::OPC_Decode, 209, 14, 132, 1, // Opcode: MAXA_D_MMR6
/* 2171 */    MCD::OPC_FilterValue, 184, 4, 10, 0, 0, // Skip to: 2187
/* 2177 */    MCD::OPC_CheckPredicate, 24, 3, 4, 0, // Skip to: 3209
/* 2182 */    MCD::OPC_Decode, 237, 18, 132, 1, // Opcode: SELEQZ_D_MMR6
/* 2187 */    MCD::OPC_FilterValue, 197, 4, 10, 0, 0, // Skip to: 2203
/* 2193 */    MCD::OPC_CheckPredicate, 26, 243, 3, 0, // Skip to: 3209
/* 2198 */    MCD::OPC_Decode, 139, 8, 152, 1, // Opcode: CMP_SUN_S_MMR6
/* 2203 */    MCD::OPC_FilterValue, 213, 4, 10, 0, 0, // Skip to: 2219
/* 2209 */    MCD::OPC_CheckPredicate, 26, 227, 3, 0, // Skip to: 3209
/* 2214 */    MCD::OPC_Decode, 137, 8, 153, 1, // Opcode: CMP_SUN_D_MMR6
/* 2219 */    MCD::OPC_FilterValue, 224, 4, 17, 0, 0, // Skip to: 2242
/* 2225 */    MCD::OPC_CheckPredicate, 24, 211, 3, 0, // Skip to: 3209
/* 2230 */    MCD::OPC_CheckField, 11, 5, 0, 204, 3, 0, // Skip to: 3209
/* 2237 */    MCD::OPC_Decode, 153, 7, 158, 1, // Opcode: CLASS_D_MMR6
/* 2242 */    MCD::OPC_FilterValue, 248, 4, 10, 0, 0, // Skip to: 2258
/* 2248 */    MCD::OPC_CheckPredicate, 24, 188, 3, 0, // Skip to: 3209
/* 2253 */    MCD::OPC_Decode, 244, 18, 132, 1, // Opcode: SELNEZ_D_MMR6
/* 2258 */    MCD::OPC_FilterValue, 133, 5, 10, 0, 0, // Skip to: 2274
/* 2264 */    MCD::OPC_CheckPredicate, 26, 172, 3, 0, // Skip to: 3209
/* 2269 */    MCD::OPC_Decode, 243, 7, 152, 1, // Opcode: CMP_SEQ_S_MMR6
/* 2274 */    MCD::OPC_FilterValue, 149, 5, 10, 0, 0, // Skip to: 2290
/* 2280 */    MCD::OPC_CheckPredicate, 26, 156, 3, 0, // Skip to: 3209
/* 2285 */    MCD::OPC_Decode, 241, 7, 153, 1, // Opcode: CMP_SEQ_D_MMR6
/* 2290 */    MCD::OPC_FilterValue, 184, 5, 10, 0, 0, // Skip to: 2306
/* 2296 */    MCD::OPC_CheckPredicate, 24, 140, 3, 0, // Skip to: 3209
/* 2301 */    MCD::OPC_Decode, 249, 18, 159, 1, // Opcode: SEL_D_MMR6
/* 2306 */    MCD::OPC_FilterValue, 197, 5, 10, 0, 0, // Skip to: 2322
/* 2312 */    MCD::OPC_CheckPredicate, 26, 124, 3, 0, // Skip to: 3209
/* 2317 */    MCD::OPC_Decode, 255, 7, 152, 1, // Opcode: CMP_SUEQ_S_MMR6
/* 2322 */    MCD::OPC_FilterValue, 213, 5, 10, 0, 0, // Skip to: 2338
/* 2328 */    MCD::OPC_CheckPredicate, 26, 108, 3, 0, // Skip to: 3209
/* 2333 */    MCD::OPC_Decode, 253, 7, 153, 1, // Opcode: CMP_SUEQ_D_MMR6
/* 2338 */    MCD::OPC_FilterValue, 133, 6, 10, 0, 0, // Skip to: 2354
/* 2344 */    MCD::OPC_CheckPredicate, 26, 92, 3, 0, // Skip to: 3209
/* 2349 */    MCD::OPC_Decode, 251, 7, 152, 1, // Opcode: CMP_SLT_S_MMR6
/* 2354 */    MCD::OPC_FilterValue, 149, 6, 10, 0, 0, // Skip to: 2370
/* 2360 */    MCD::OPC_CheckPredicate, 26, 76, 3, 0, // Skip to: 3209
/* 2365 */    MCD::OPC_Decode, 249, 7, 153, 1, // Opcode: CMP_SLT_D_MMR6
/* 2370 */    MCD::OPC_FilterValue, 187, 6, 228, 0, 0, // Skip to: 2604
/* 2376 */    MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 2379 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2393
/* 2384 */    MCD::OPC_CheckPredicate, 26, 52, 3, 0, // Skip to: 3209
/* 2389 */    MCD::OPC_Decode, 188, 11, 109, // Opcode: FLOOR_L_S_MMR6
/* 2393 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 2407
/* 2398 */    MCD::OPC_CheckPredicate, 26, 38, 3, 0, // Skip to: 3209
/* 2403 */    MCD::OPC_Decode, 195, 11, 112, // Opcode: FLOOR_W_S_MMR6
/* 2407 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2421
/* 2412 */    MCD::OPC_CheckPredicate, 26, 24, 3, 0, // Skip to: 3209
/* 2417 */    MCD::OPC_Decode, 128, 7, 109, // Opcode: CEIL_L_S_MMR6
/* 2421 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 2435
/* 2426 */    MCD::OPC_CheckPredicate, 26, 10, 3, 0, // Skip to: 3209
/* 2431 */    MCD::OPC_Decode, 135, 7, 112, // Opcode: CEIL_W_S_MMR6
/* 2435 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 2449
/* 2440 */    MCD::OPC_CheckPredicate, 26, 252, 2, 0, // Skip to: 3209
/* 2445 */    MCD::OPC_Decode, 216, 21, 109, // Opcode: TRUNC_L_S_MMR6
/* 2449 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 2463
/* 2454 */    MCD::OPC_CheckPredicate, 26, 238, 2, 0, // Skip to: 3209
/* 2459 */    MCD::OPC_Decode, 223, 21, 112, // Opcode: TRUNC_W_S_MMR6
/* 2463 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 2477
/* 2468 */    MCD::OPC_CheckPredicate, 26, 224, 2, 0, // Skip to: 3209
/* 2473 */    MCD::OPC_Decode, 162, 18, 109, // Opcode: ROUND_L_S_MMR6
/* 2477 */    MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 2491
/* 2482 */    MCD::OPC_CheckPredicate, 26, 210, 2, 0, // Skip to: 3209
/* 2487 */    MCD::OPC_Decode, 169, 18, 112, // Opcode: ROUND_W_S_MMR6
/* 2491 */    MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 2505
/* 2496 */    MCD::OPC_CheckPredicate, 26, 196, 2, 0, // Skip to: 3209
/* 2501 */    MCD::OPC_Decode, 186, 11, 110, // Opcode: FLOOR_L_D_MMR6
/* 2505 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 2519
/* 2510 */    MCD::OPC_CheckPredicate, 26, 182, 2, 0, // Skip to: 3209
/* 2515 */    MCD::OPC_Decode, 191, 11, 114, // Opcode: FLOOR_W_D_MMR6
/* 2519 */    MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 2533
/* 2524 */    MCD::OPC_CheckPredicate, 26, 168, 2, 0, // Skip to: 3209
/* 2529 */    MCD::OPC_Decode, 254, 6, 110, // Opcode: CEIL_L_D_MMR6
/* 2533 */    MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 2547
/* 2538 */    MCD::OPC_CheckPredicate, 26, 154, 2, 0, // Skip to: 3209
/* 2543 */    MCD::OPC_Decode, 131, 7, 114, // Opcode: CEIL_W_D_MMR6
/* 2547 */    MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 2561
/* 2552 */    MCD::OPC_CheckPredicate, 26, 140, 2, 0, // Skip to: 3209
/* 2557 */    MCD::OPC_Decode, 214, 21, 110, // Opcode: TRUNC_L_D_MMR6
/* 2561 */    MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 2576
/* 2566 */    MCD::OPC_CheckPredicate, 26, 126, 2, 0, // Skip to: 3209
/* 2571 */    MCD::OPC_Decode, 219, 21, 133, 1, // Opcode: TRUNC_W_D_MMR6
/* 2576 */    MCD::OPC_FilterValue, 14, 9, 0, 0, // Skip to: 2590
/* 2581 */    MCD::OPC_CheckPredicate, 26, 111, 2, 0, // Skip to: 3209
/* 2586 */    MCD::OPC_Decode, 160, 18, 110, // Opcode: ROUND_L_D_MMR6
/* 2590 */    MCD::OPC_FilterValue, 15, 102, 2, 0, // Skip to: 3209
/* 2595 */    MCD::OPC_CheckPredicate, 26, 97, 2, 0, // Skip to: 3209
/* 2600 */    MCD::OPC_Decode, 165, 18, 110, // Opcode: ROUND_W_D_MMR6
/* 2604 */    MCD::OPC_FilterValue, 197, 6, 10, 0, 0, // Skip to: 2620
/* 2610 */    MCD::OPC_CheckPredicate, 26, 82, 2, 0, // Skip to: 3209
/* 2615 */    MCD::OPC_Decode, 135, 8, 152, 1, // Opcode: CMP_SULT_S_MMR6
/* 2620 */    MCD::OPC_FilterValue, 213, 6, 10, 0, 0, // Skip to: 2636
/* 2626 */    MCD::OPC_CheckPredicate, 26, 66, 2, 0, // Skip to: 3209
/* 2631 */    MCD::OPC_Decode, 133, 8, 153, 1, // Opcode: CMP_SULT_D_MMR6
/* 2636 */    MCD::OPC_FilterValue, 251, 6, 59, 0, 0, // Skip to: 2701
/* 2642 */    MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 2645 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 2659
/* 2650 */    MCD::OPC_CheckPredicate, 26, 42, 2, 0, // Skip to: 3209
/* 2655 */    MCD::OPC_Decode, 230, 11, 112, // Opcode: FNEG_S_MMR6
/* 2659 */    MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 2673
/* 2664 */    MCD::OPC_CheckPredicate, 26, 28, 2, 0, // Skip to: 3209
/* 2669 */    MCD::OPC_Decode, 204, 8, 112, // Opcode: CVT_S_W_MMR6
/* 2673 */    MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 2687
/* 2678 */    MCD::OPC_CheckPredicate, 23, 14, 2, 0, // Skip to: 3209
/* 2683 */    MCD::OPC_Decode, 186, 8, 110, // Opcode: CVT_D_L_MMR6
/* 2687 */    MCD::OPC_FilterValue, 11, 5, 2, 0, // Skip to: 3209
/* 2692 */    MCD::OPC_CheckPredicate, 23, 0, 2, 0, // Skip to: 3209
/* 2697 */    MCD::OPC_Decode, 199, 8, 109, // Opcode: CVT_S_L_MMR6
/* 2701 */    MCD::OPC_FilterValue, 133, 7, 10, 0, 0, // Skip to: 2717
/* 2707 */    MCD::OPC_CheckPredicate, 26, 241, 1, 0, // Skip to: 3209
/* 2712 */    MCD::OPC_Decode, 247, 7, 152, 1, // Opcode: CMP_SLE_S_MMR6
/* 2717 */    MCD::OPC_FilterValue, 149, 7, 10, 0, 0, // Skip to: 2733
/* 2723 */    MCD::OPC_CheckPredicate, 26, 225, 1, 0, // Skip to: 3209
/* 2728 */    MCD::OPC_Decode, 245, 7, 153, 1, // Opcode: CMP_SLE_D_MMR6
/* 2733 */    MCD::OPC_FilterValue, 184, 7, 10, 0, 0, // Skip to: 2749
/* 2739 */    MCD::OPC_CheckPredicate, 26, 209, 1, 0, // Skip to: 3209
/* 2744 */    MCD::OPC_Decode, 177, 14, 159, 1, // Opcode: MADDF_D_MMR6
/* 2749 */    MCD::OPC_FilterValue, 197, 7, 10, 0, 0, // Skip to: 2765
/* 2755 */    MCD::OPC_CheckPredicate, 26, 193, 1, 0, // Skip to: 3209
/* 2760 */    MCD::OPC_Decode, 131, 8, 152, 1, // Opcode: CMP_SULE_S_MMR6
/* 2765 */    MCD::OPC_FilterValue, 213, 7, 10, 0, 0, // Skip to: 2781
/* 2771 */    MCD::OPC_CheckPredicate, 26, 177, 1, 0, // Skip to: 3209
/* 2776 */    MCD::OPC_Decode, 129, 8, 153, 1, // Opcode: CMP_SULE_D_MMR6
/* 2781 */    MCD::OPC_FilterValue, 248, 7, 166, 1, 0, // Skip to: 3209
/* 2787 */    MCD::OPC_CheckPredicate, 26, 161, 1, 0, // Skip to: 3209
/* 2792 */    MCD::OPC_Decode, 228, 15, 159, 1, // Opcode: MSUBF_D_MMR6
/* 2797 */    MCD::OPC_FilterValue, 24, 59, 0, 0, // Skip to: 2861
/* 2802 */    MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 2805 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2819
/* 2810 */    MCD::OPC_CheckPredicate, 24, 138, 1, 0, // Skip to: 3209
/* 2815 */    MCD::OPC_Decode, 230, 17, 88, // Opcode: PREF_MMR6
/* 2819 */    MCD::OPC_FilterValue, 3, 16, 0, 0, // Skip to: 2840
/* 2824 */    MCD::OPC_CheckPredicate, 24, 124, 1, 0, // Skip to: 3209
/* 2829 */    MCD::OPC_CheckField, 9, 3, 0, 117, 1, 0, // Skip to: 3209
/* 2836 */    MCD::OPC_Decode, 239, 13, 122, // Opcode: LL_MMR6
/* 2840 */    MCD::OPC_FilterValue, 11, 108, 1, 0, // Skip to: 3209
/* 2845 */    MCD::OPC_CheckPredicate, 24, 103, 1, 0, // Skip to: 3209
/* 2850 */    MCD::OPC_CheckField, 9, 3, 0, 96, 1, 0, // Skip to: 3209
/* 2857 */    MCD::OPC_Decode, 204, 18, 122, // Opcode: SC_MMR6
/* 2861 */    MCD::OPC_FilterValue, 28, 9, 0, 0, // Skip to: 2875
/* 2866 */    MCD::OPC_CheckPredicate, 24, 82, 1, 0, // Skip to: 3209
/* 2871 */    MCD::OPC_Decode, 248, 21, 96, // Opcode: XORI_MMR6
/* 2875 */    MCD::OPC_FilterValue, 29, 27, 0, 0, // Skip to: 2907
/* 2880 */    MCD::OPC_CheckPredicate, 24, 12, 0, 0, // Skip to: 2897
/* 2885 */    MCD::OPC_CheckField, 16, 5, 0, 5, 0, 0, // Skip to: 2897
/* 2892 */    MCD::OPC_Decode, 221, 5, 160, 1, // Opcode: BEQZALC_MMR6
/* 2897 */    MCD::OPC_CheckPredicate, 24, 51, 1, 0, // Skip to: 3209
/* 2902 */    MCD::OPC_Decode, 217, 5, 160, 1, // Opcode: BEQC_MMR6
/* 2907 */    MCD::OPC_FilterValue, 30, 71, 0, 0, // Skip to: 2983
/* 2912 */    MCD::OPC_ExtractField, 19, 2,  // Inst{20-19} ...
/* 2915 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 2930
/* 2920 */    MCD::OPC_CheckPredicate, 24, 28, 1, 0, // Skip to: 3209
/* 2925 */    MCD::OPC_Decode, 177, 4, 161, 1, // Opcode: ADDIUPC_MMR6
/* 2930 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 2945
/* 2935 */    MCD::OPC_CheckPredicate, 24, 13, 1, 0, // Skip to: 3209
/* 2940 */    MCD::OPC_Decode, 146, 14, 161, 1, // Opcode: LWPC_MMR6
/* 2945 */    MCD::OPC_FilterValue, 3, 3, 1, 0, // Skip to: 3209
/* 2950 */    MCD::OPC_ExtractField, 16, 3,  // Inst{18-16} ...
/* 2953 */    MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 2968
/* 2958 */    MCD::OPC_CheckPredicate, 24, 246, 0, 0, // Skip to: 3209
/* 2963 */    MCD::OPC_Decode, 150, 5, 162, 1, // Opcode: AUIPC_MMR6
/* 2968 */    MCD::OPC_FilterValue, 7, 236, 0, 0, // Skip to: 3209
/* 2973 */    MCD::OPC_CheckPredicate, 24, 231, 0, 0, // Skip to: 3209
/* 2978 */    MCD::OPC_Decode, 251, 4, 162, 1, // Opcode: ALUIPC_MMR6
/* 2983 */    MCD::OPC_FilterValue, 31, 27, 0, 0, // Skip to: 3015
/* 2988 */    MCD::OPC_CheckPredicate, 24, 12, 0, 0, // Skip to: 3005
/* 2993 */    MCD::OPC_CheckField, 16, 5, 0, 5, 0, 0, // Skip to: 3005
/* 3000 */    MCD::OPC_Decode, 197, 6, 163, 1, // Opcode: BNEZALC_MMR6
/* 3005 */    MCD::OPC_CheckPredicate, 24, 199, 0, 0, // Skip to: 3209
/* 3010 */    MCD::OPC_Decode, 185, 6, 163, 1, // Opcode: BNEC_MMR6
/* 3015 */    MCD::OPC_FilterValue, 32, 26, 0, 0, // Skip to: 3046
/* 3020 */    MCD::OPC_CheckPredicate, 24, 11, 0, 0, // Skip to: 3036
/* 3025 */    MCD::OPC_CheckField, 21, 5, 0, 4, 0, 0, // Skip to: 3036
/* 3032 */    MCD::OPC_Decode, 153, 13, 91, // Opcode: JIALC_MMR6
/* 3036 */    MCD::OPC_CheckPredicate, 24, 168, 0, 0, // Skip to: 3209
/* 3041 */    MCD::OPC_Decode, 226, 5, 164, 1, // Opcode: BEQZC_MMR6
/* 3046 */    MCD::OPC_FilterValue, 37, 10, 0, 0, // Skip to: 3061
/* 3051 */    MCD::OPC_CheckPredicate, 24, 153, 0, 0, // Skip to: 3209
/* 3056 */    MCD::OPC_Decode, 212, 5, 165, 1, // Opcode: BC_MMR6
/* 3061 */    MCD::OPC_FilterValue, 40, 26, 0, 0, // Skip to: 3092
/* 3066 */    MCD::OPC_CheckPredicate, 24, 11, 0, 0, // Skip to: 3082
/* 3071 */    MCD::OPC_CheckField, 21, 5, 0, 4, 0, 0, // Skip to: 3082
/* 3078 */    MCD::OPC_Decode, 156, 13, 91, // Opcode: JIC_MMR6
/* 3082 */    MCD::OPC_CheckPredicate, 24, 122, 0, 0, // Skip to: 3209
/* 3087 */    MCD::OPC_Decode, 202, 6, 164, 1, // Opcode: BNEZC_MMR6
/* 3092 */    MCD::OPC_FilterValue, 45, 10, 0, 0, // Skip to: 3107
/* 3097 */    MCD::OPC_CheckPredicate, 24, 107, 0, 0, // Skip to: 3209
/* 3102 */    MCD::OPC_Decode, 181, 5, 165, 1, // Opcode: BALC_MMR6
/* 3107 */    MCD::OPC_FilterValue, 48, 10, 0, 0, // Skip to: 3122
/* 3112 */    MCD::OPC_CheckPredicate, 24, 92, 0, 0, // Skip to: 3209
/* 3117 */    MCD::OPC_Decode, 233, 5, 166, 1, // Opcode: BGEUC_MMR6
/* 3122 */    MCD::OPC_FilterValue, 52, 9, 0, 0, // Skip to: 3136
/* 3127 */    MCD::OPC_CheckPredicate, 24, 77, 0, 0, // Skip to: 3209
/* 3132 */    MCD::OPC_Decode, 131, 5, 96, // Opcode: ANDI_MMR6
/* 3136 */    MCD::OPC_FilterValue, 53, 10, 0, 0, // Skip to: 3151
/* 3141 */    MCD::OPC_CheckPredicate, 24, 63, 0, 0, // Skip to: 3209
/* 3146 */    MCD::OPC_Decode, 160, 6, 167, 1, // Opcode: BLTC_MMR6
/* 3151 */    MCD::OPC_FilterValue, 56, 10, 0, 0, // Skip to: 3166
/* 3156 */    MCD::OPC_CheckPredicate, 24, 48, 0, 0, // Skip to: 3209
/* 3161 */    MCD::OPC_Decode, 163, 6, 168, 1, // Opcode: BLTUC_MMR6
/* 3166 */    MCD::OPC_FilterValue, 61, 10, 0, 0, // Skip to: 3181
/* 3171 */    MCD::OPC_CheckPredicate, 24, 33, 0, 0, // Skip to: 3209
/* 3176 */    MCD::OPC_Decode, 230, 5, 169, 1, // Opcode: BGEC_MMR6
/* 3181 */    MCD::OPC_FilterValue, 62, 9, 0, 0, // Skip to: 3195
/* 3186 */    MCD::OPC_CheckPredicate, 24, 18, 0, 0, // Skip to: 3209
/* 3191 */    MCD::OPC_Decode, 136, 21, 86, // Opcode: SW_MMR6
/* 3195 */    MCD::OPC_FilterValue, 63, 9, 0, 0, // Skip to: 3209
/* 3200 */    MCD::OPC_CheckPredicate, 24, 4, 0, 0, // Skip to: 3209
/* 3205 */    MCD::OPC_Decode, 162, 14, 86, // Opcode: LW_MMR6
/* 3209 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMicroMipsR6_Ambiguous32[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 18
/* 8 */       MCD::OPC_CheckPredicate, 24, 84, 0, 0, // Skip to: 97
/* 13 */      MCD::OPC_Decode, 212, 6, 160, 1, // Opcode: BOVC_MMR6
/* 18 */      MCD::OPC_FilterValue, 31, 10, 0, 0, // Skip to: 33
/* 23 */      MCD::OPC_CheckPredicate, 24, 69, 0, 0, // Skip to: 97
/* 28 */      MCD::OPC_Decode, 205, 6, 163, 1, // Opcode: BNVC_MMR6
/* 33 */      MCD::OPC_FilterValue, 48, 27, 0, 0, // Skip to: 65
/* 38 */      MCD::OPC_CheckPredicate, 24, 12, 0, 0, // Skip to: 55
/* 43 */      MCD::OPC_CheckField, 16, 5, 0, 5, 0, 0, // Skip to: 55
/* 50 */      MCD::OPC_Decode, 152, 6, 166, 1, // Opcode: BLEZALC_MMR6
/* 55 */      MCD::OPC_CheckPredicate, 24, 37, 0, 0, // Skip to: 97
/* 60 */      MCD::OPC_Decode, 238, 5, 166, 1, // Opcode: BGEZALC_MMR6
/* 65 */      MCD::OPC_FilterValue, 56, 27, 0, 0, // Skip to: 97
/* 70 */      MCD::OPC_CheckPredicate, 24, 12, 0, 0, // Skip to: 87
/* 75 */      MCD::OPC_CheckField, 16, 5, 0, 5, 0, 0, // Skip to: 87
/* 82 */      MCD::OPC_Decode, 250, 5, 168, 1, // Opcode: BGTZALC_MMR6
/* 87 */      MCD::OPC_CheckPredicate, 24, 5, 0, 0, // Skip to: 97
/* 92 */      MCD::OPC_Decode, 168, 6, 168, 1, // Opcode: BLTZALC_MMR6
/* 97 */      MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMips32[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 0, 101, 4, 0, // Skip to: 1133
/* 8 */       MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 11 */      MCD::OPC_FilterValue, 0, 63, 0, 0, // Skip to: 79
/* 16 */      MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 19 */      MCD::OPC_FilterValue, 0, 89, 75, 0, // Skip to: 19313
/* 24 */      MCD::OPC_ExtractField, 6, 15,  // Inst{20-6} ...
/* 27 */      MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 41
/* 32 */      MCD::OPC_CheckPredicate, 27, 32, 0, 0, // Skip to: 69
/* 37 */      MCD::OPC_Decode, 156, 20, 0, // Opcode: SSNOP
/* 41 */      MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 55
/* 46 */      MCD::OPC_CheckPredicate, 27, 18, 0, 0, // Skip to: 69
/* 51 */      MCD::OPC_Decode, 194, 10, 0, // Opcode: EHB
/* 55 */      MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 69
/* 60 */      MCD::OPC_CheckPredicate, 28, 4, 0, 0, // Skip to: 69
/* 65 */      MCD::OPC_Decode, 144, 17, 0, // Opcode: PAUSE
/* 69 */      MCD::OPC_CheckPredicate, 27, 39, 75, 0, // Skip to: 19313
/* 74 */      MCD::OPC_Decode, 195, 19, 170, 1, // Opcode: SLL
/* 79 */      MCD::OPC_FilterValue, 1, 47, 0, 0, // Skip to: 131
/* 84 */      MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 87 */      MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 109
/* 92 */      MCD::OPC_CheckPredicate, 29, 16, 75, 0, // Skip to: 19313
/* 97 */      MCD::OPC_CheckField, 6, 5, 0, 9, 75, 0, // Skip to: 19313
/* 104 */     MCD::OPC_Decode, 189, 15, 171, 1, // Opcode: MOVF_I
/* 109 */     MCD::OPC_FilterValue, 1, 255, 74, 0, // Skip to: 19313
/* 114 */     MCD::OPC_CheckPredicate, 29, 250, 74, 0, // Skip to: 19313
/* 119 */     MCD::OPC_CheckField, 6, 5, 0, 243, 74, 0, // Skip to: 19313
/* 126 */     MCD::OPC_Decode, 209, 15, 171, 1, // Opcode: MOVT_I
/* 131 */     MCD::OPC_FilterValue, 2, 33, 0, 0, // Skip to: 169
/* 136 */     MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 139 */     MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 154
/* 144 */     MCD::OPC_CheckPredicate, 27, 220, 74, 0, // Skip to: 19313
/* 149 */     MCD::OPC_Decode, 254, 19, 170, 1, // Opcode: SRL
/* 154 */     MCD::OPC_FilterValue, 1, 210, 74, 0, // Skip to: 19313
/* 159 */     MCD::OPC_CheckPredicate, 28, 205, 74, 0, // Skip to: 19313
/* 164 */     MCD::OPC_Decode, 155, 18, 170, 1, // Opcode: ROTR
/* 169 */     MCD::OPC_FilterValue, 3, 17, 0, 0, // Skip to: 191
/* 174 */     MCD::OPC_CheckPredicate, 27, 190, 74, 0, // Skip to: 19313
/* 179 */     MCD::OPC_CheckField, 21, 5, 0, 183, 74, 0, // Skip to: 19313
/* 186 */     MCD::OPC_Decode, 234, 19, 170, 1, // Opcode: SRA
/* 191 */     MCD::OPC_FilterValue, 4, 16, 0, 0, // Skip to: 212
/* 196 */     MCD::OPC_CheckPredicate, 27, 168, 74, 0, // Skip to: 19313
/* 201 */     MCD::OPC_CheckField, 6, 5, 0, 161, 74, 0, // Skip to: 19313
/* 208 */     MCD::OPC_Decode, 204, 19, 43, // Opcode: SLLV
/* 212 */     MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 234
/* 217 */     MCD::OPC_CheckPredicate, 30, 147, 74, 0, // Skip to: 19313
/* 222 */     MCD::OPC_CheckField, 8, 3, 0, 140, 74, 0, // Skip to: 19313
/* 229 */     MCD::OPC_Decode, 241, 13, 172, 1, // Opcode: LSA
/* 234 */     MCD::OPC_FilterValue, 6, 31, 0, 0, // Skip to: 270
/* 239 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 242 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 256
/* 247 */     MCD::OPC_CheckPredicate, 27, 117, 74, 0, // Skip to: 19313
/* 252 */     MCD::OPC_Decode, 141, 20, 43, // Opcode: SRLV
/* 256 */     MCD::OPC_FilterValue, 1, 108, 74, 0, // Skip to: 19313
/* 261 */     MCD::OPC_CheckPredicate, 28, 103, 74, 0, // Skip to: 19313
/* 266 */     MCD::OPC_Decode, 156, 18, 43, // Opcode: ROTRV
/* 270 */     MCD::OPC_FilterValue, 7, 16, 0, 0, // Skip to: 291
/* 275 */     MCD::OPC_CheckPredicate, 27, 89, 74, 0, // Skip to: 19313
/* 280 */     MCD::OPC_CheckField, 6, 5, 0, 82, 74, 0, // Skip to: 19313
/* 287 */     MCD::OPC_Decode, 247, 19, 43, // Opcode: SRAV
/* 291 */     MCD::OPC_FilterValue, 8, 33, 0, 0, // Skip to: 329
/* 296 */     MCD::OPC_ExtractField, 6, 15,  // Inst{20-6} ...
/* 299 */     MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 314
/* 304 */     MCD::OPC_CheckPredicate, 31, 60, 74, 0, // Skip to: 19313
/* 309 */     MCD::OPC_Decode, 157, 13, 173, 1, // Opcode: JR
/* 314 */     MCD::OPC_FilterValue, 16, 50, 74, 0, // Skip to: 19313
/* 319 */     MCD::OPC_CheckPredicate, 32, 45, 74, 0, // Skip to: 19313
/* 324 */     MCD::OPC_Decode, 164, 13, 173, 1, // Opcode: JR_HB
/* 329 */     MCD::OPC_FilterValue, 9, 45, 0, 0, // Skip to: 379
/* 334 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 337 */     MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 358
/* 342 */     MCD::OPC_CheckPredicate, 33, 22, 74, 0, // Skip to: 19313
/* 347 */     MCD::OPC_CheckField, 16, 5, 0, 15, 74, 0, // Skip to: 19313
/* 354 */     MCD::OPC_Decode, 136, 13, 14, // Opcode: JALR
/* 358 */     MCD::OPC_FilterValue, 16, 6, 74, 0, // Skip to: 19313
/* 363 */     MCD::OPC_CheckPredicate, 34, 1, 74, 0, // Skip to: 19313
/* 368 */     MCD::OPC_CheckField, 16, 5, 0, 250, 73, 0, // Skip to: 19313
/* 375 */     MCD::OPC_Decode, 144, 13, 14, // Opcode: JALR_HB
/* 379 */     MCD::OPC_FilterValue, 10, 17, 0, 0, // Skip to: 401
/* 384 */     MCD::OPC_CheckPredicate, 35, 236, 73, 0, // Skip to: 19313
/* 389 */     MCD::OPC_CheckField, 6, 5, 0, 229, 73, 0, // Skip to: 19313
/* 396 */     MCD::OPC_Decode, 221, 15, 174, 1, // Opcode: MOVZ_I_I
/* 401 */     MCD::OPC_FilterValue, 11, 17, 0, 0, // Skip to: 423
/* 406 */     MCD::OPC_CheckPredicate, 35, 214, 73, 0, // Skip to: 19313
/* 411 */     MCD::OPC_CheckField, 6, 5, 0, 207, 73, 0, // Skip to: 19313
/* 418 */     MCD::OPC_Decode, 201, 15, 174, 1, // Opcode: MOVN_I_I
/* 423 */     MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 438
/* 428 */     MCD::OPC_CheckPredicate, 27, 192, 73, 0, // Skip to: 19313
/* 433 */     MCD::OPC_Decode, 143, 21, 175, 1, // Opcode: SYSCALL
/* 438 */     MCD::OPC_FilterValue, 13, 9, 0, 0, // Skip to: 452
/* 443 */     MCD::OPC_CheckPredicate, 27, 177, 73, 0, // Skip to: 19313
/* 448 */     MCD::OPC_Decode, 216, 6, 44, // Opcode: BREAK
/* 452 */     MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 467
/* 457 */     MCD::OPC_CheckPredicate, 36, 163, 73, 0, // Skip to: 19313
/* 462 */     MCD::OPC_Decode, 137, 21, 176, 1, // Opcode: SYNC
/* 467 */     MCD::OPC_FilterValue, 16, 51, 0, 0, // Skip to: 523
/* 472 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 475 */     MCD::OPC_FilterValue, 0, 145, 73, 0, // Skip to: 19313
/* 480 */     MCD::OPC_ExtractField, 16, 5,  // Inst{20-16} ...
/* 483 */     MCD::OPC_FilterValue, 0, 137, 73, 0, // Skip to: 19313
/* 488 */     MCD::OPC_ExtractField, 23, 3,  // Inst{25-23} ...
/* 491 */     MCD::OPC_FilterValue, 0, 129, 73, 0, // Skip to: 19313
/* 496 */     MCD::OPC_CheckPredicate, 31, 12, 0, 0, // Skip to: 513
/* 501 */     MCD::OPC_CheckField, 21, 2, 0, 5, 0, 0, // Skip to: 513
/* 508 */     MCD::OPC_Decode, 254, 14, 177, 1, // Opcode: MFHI
/* 513 */     MCD::OPC_CheckPredicate, 37, 107, 73, 0, // Skip to: 19313
/* 518 */     MCD::OPC_Decode, 129, 15, 178, 1, // Opcode: MFHI_DSP
/* 523 */     MCD::OPC_FilterValue, 17, 43, 0, 0, // Skip to: 571
/* 528 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 531 */     MCD::OPC_FilterValue, 0, 89, 73, 0, // Skip to: 19313
/* 536 */     MCD::OPC_ExtractField, 13, 8,  // Inst{20-13} ...
/* 539 */     MCD::OPC_FilterValue, 0, 81, 73, 0, // Skip to: 19313
/* 544 */     MCD::OPC_CheckPredicate, 31, 12, 0, 0, // Skip to: 561
/* 549 */     MCD::OPC_CheckField, 11, 2, 0, 5, 0, 0, // Skip to: 561
/* 556 */     MCD::OPC_Decode, 142, 16, 173, 1, // Opcode: MTHI
/* 561 */     MCD::OPC_CheckPredicate, 37, 59, 73, 0, // Skip to: 19313
/* 566 */     MCD::OPC_Decode, 144, 16, 179, 1, // Opcode: MTHI_DSP
/* 571 */     MCD::OPC_FilterValue, 18, 51, 0, 0, // Skip to: 627
/* 576 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 579 */     MCD::OPC_FilterValue, 0, 41, 73, 0, // Skip to: 19313
/* 584 */     MCD::OPC_ExtractField, 16, 5,  // Inst{20-16} ...
/* 587 */     MCD::OPC_FilterValue, 0, 33, 73, 0, // Skip to: 19313
/* 592 */     MCD::OPC_ExtractField, 23, 3,  // Inst{25-23} ...
/* 595 */     MCD::OPC_FilterValue, 0, 25, 73, 0, // Skip to: 19313
/* 600 */     MCD::OPC_CheckPredicate, 31, 12, 0, 0, // Skip to: 617
/* 605 */     MCD::OPC_CheckField, 21, 2, 0, 5, 0, 0, // Skip to: 617
/* 612 */     MCD::OPC_Decode, 132, 15, 177, 1, // Opcode: MFLO
/* 617 */     MCD::OPC_CheckPredicate, 37, 3, 73, 0, // Skip to: 19313
/* 622 */     MCD::OPC_Decode, 135, 15, 178, 1, // Opcode: MFLO_DSP
/* 627 */     MCD::OPC_FilterValue, 19, 43, 0, 0, // Skip to: 675
/* 632 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 635 */     MCD::OPC_FilterValue, 0, 241, 72, 0, // Skip to: 19313
/* 640 */     MCD::OPC_ExtractField, 13, 8,  // Inst{20-13} ...
/* 643 */     MCD::OPC_FilterValue, 0, 233, 72, 0, // Skip to: 19313
/* 648 */     MCD::OPC_CheckPredicate, 31, 12, 0, 0, // Skip to: 665
/* 653 */     MCD::OPC_CheckField, 11, 2, 0, 5, 0, 0, // Skip to: 665
/* 660 */     MCD::OPC_Decode, 149, 16, 173, 1, // Opcode: MTLO
/* 665 */     MCD::OPC_CheckPredicate, 37, 211, 72, 0, // Skip to: 19313
/* 670 */     MCD::OPC_Decode, 151, 16, 180, 1, // Opcode: MTLO_DSP
/* 675 */     MCD::OPC_FilterValue, 21, 17, 0, 0, // Skip to: 697
/* 680 */     MCD::OPC_CheckPredicate, 38, 196, 72, 0, // Skip to: 19313
/* 685 */     MCD::OPC_CheckField, 8, 3, 0, 189, 72, 0, // Skip to: 19313
/* 692 */     MCD::OPC_Decode, 225, 9, 181, 1, // Opcode: DLSA
/* 697 */     MCD::OPC_FilterValue, 24, 42, 0, 0, // Skip to: 744
/* 702 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 705 */     MCD::OPC_FilterValue, 0, 171, 72, 0, // Skip to: 19313
/* 710 */     MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 713 */     MCD::OPC_FilterValue, 0, 163, 72, 0, // Skip to: 19313
/* 718 */     MCD::OPC_CheckPredicate, 31, 11, 0, 0, // Skip to: 734
/* 723 */     MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 734
/* 730 */     MCD::OPC_Decode, 188, 16, 68, // Opcode: MULT
/* 734 */     MCD::OPC_CheckPredicate, 37, 142, 72, 0, // Skip to: 19313
/* 739 */     MCD::OPC_Decode, 191, 16, 182, 1, // Opcode: MULT_DSP
/* 744 */     MCD::OPC_FilterValue, 25, 42, 0, 0, // Skip to: 791
/* 749 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 752 */     MCD::OPC_FilterValue, 0, 124, 72, 0, // Skip to: 19313
/* 757 */     MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 760 */     MCD::OPC_FilterValue, 0, 116, 72, 0, // Skip to: 19313
/* 765 */     MCD::OPC_CheckPredicate, 31, 11, 0, 0, // Skip to: 781
/* 770 */     MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 781
/* 777 */     MCD::OPC_Decode, 194, 16, 68, // Opcode: MULTu
/* 781 */     MCD::OPC_CheckPredicate, 37, 95, 72, 0, // Skip to: 19313
/* 786 */     MCD::OPC_Decode, 189, 16, 182, 1, // Opcode: MULTU_DSP
/* 791 */     MCD::OPC_FilterValue, 26, 16, 0, 0, // Skip to: 812
/* 796 */     MCD::OPC_CheckPredicate, 31, 80, 72, 0, // Skip to: 19313
/* 801 */     MCD::OPC_CheckField, 6, 10, 0, 73, 72, 0, // Skip to: 19313
/* 808 */     MCD::OPC_Decode, 222, 18, 68, // Opcode: SDIV
/* 812 */     MCD::OPC_FilterValue, 27, 16, 0, 0, // Skip to: 833
/* 817 */     MCD::OPC_CheckPredicate, 31, 59, 72, 0, // Skip to: 19313
/* 822 */     MCD::OPC_CheckField, 6, 10, 0, 52, 72, 0, // Skip to: 19313
/* 829 */     MCD::OPC_Decode, 225, 21, 68, // Opcode: UDIV
/* 833 */     MCD::OPC_FilterValue, 32, 16, 0, 0, // Skip to: 854
/* 838 */     MCD::OPC_CheckPredicate, 27, 38, 72, 0, // Skip to: 19313
/* 843 */     MCD::OPC_CheckField, 6, 5, 0, 31, 72, 0, // Skip to: 19313
/* 850 */     MCD::OPC_Decode, 174, 4, 49, // Opcode: ADD
/* 854 */     MCD::OPC_FilterValue, 33, 16, 0, 0, // Skip to: 875
/* 859 */     MCD::OPC_CheckPredicate, 27, 17, 72, 0, // Skip to: 19313
/* 864 */     MCD::OPC_CheckField, 6, 5, 0, 10, 72, 0, // Skip to: 19313
/* 871 */     MCD::OPC_Decode, 246, 4, 49, // Opcode: ADDu
/* 875 */     MCD::OPC_FilterValue, 34, 16, 0, 0, // Skip to: 896
/* 880 */     MCD::OPC_CheckPredicate, 27, 252, 71, 0, // Skip to: 19313
/* 885 */     MCD::OPC_CheckField, 6, 5, 0, 245, 71, 0, // Skip to: 19313
/* 892 */     MCD::OPC_Decode, 170, 20, 49, // Opcode: SUB
/* 896 */     MCD::OPC_FilterValue, 35, 16, 0, 0, // Skip to: 917
/* 901 */     MCD::OPC_CheckPredicate, 27, 231, 71, 0, // Skip to: 19313
/* 906 */     MCD::OPC_CheckField, 6, 5, 0, 224, 71, 0, // Skip to: 19313
/* 913 */     MCD::OPC_Decode, 226, 20, 49, // Opcode: SUBu
/* 917 */     MCD::OPC_FilterValue, 36, 16, 0, 0, // Skip to: 938
/* 922 */     MCD::OPC_CheckPredicate, 27, 210, 71, 0, // Skip to: 19313
/* 927 */     MCD::OPC_CheckField, 6, 5, 0, 203, 71, 0, // Skip to: 19313
/* 934 */     MCD::OPC_Decode, 252, 4, 49, // Opcode: AND
/* 938 */     MCD::OPC_FilterValue, 37, 16, 0, 0, // Skip to: 959
/* 943 */     MCD::OPC_CheckPredicate, 27, 189, 71, 0, // Skip to: 19313
/* 948 */     MCD::OPC_CheckField, 6, 5, 0, 182, 71, 0, // Skip to: 19313
/* 955 */     MCD::OPC_Decode, 243, 16, 49, // Opcode: OR
/* 959 */     MCD::OPC_FilterValue, 38, 16, 0, 0, // Skip to: 980
/* 964 */     MCD::OPC_CheckPredicate, 27, 168, 71, 0, // Skip to: 19313
/* 969 */     MCD::OPC_CheckField, 6, 5, 0, 161, 71, 0, // Skip to: 19313
/* 976 */     MCD::OPC_Decode, 243, 21, 49, // Opcode: XOR
/* 980 */     MCD::OPC_FilterValue, 39, 16, 0, 0, // Skip to: 1001
/* 985 */     MCD::OPC_CheckPredicate, 27, 147, 71, 0, // Skip to: 19313
/* 990 */     MCD::OPC_CheckField, 6, 5, 0, 140, 71, 0, // Skip to: 19313
/* 997 */     MCD::OPC_Decode, 233, 16, 49, // Opcode: NOR
/* 1001 */    MCD::OPC_FilterValue, 42, 16, 0, 0, // Skip to: 1022
/* 1006 */    MCD::OPC_CheckPredicate, 27, 126, 71, 0, // Skip to: 19313
/* 1011 */    MCD::OPC_CheckField, 6, 5, 0, 119, 71, 0, // Skip to: 19313
/* 1018 */    MCD::OPC_Decode, 212, 19, 49, // Opcode: SLT
/* 1022 */    MCD::OPC_FilterValue, 43, 16, 0, 0, // Skip to: 1043
/* 1027 */    MCD::OPC_CheckPredicate, 27, 105, 71, 0, // Skip to: 19313
/* 1032 */    MCD::OPC_CheckField, 6, 5, 0, 98, 71, 0, // Skip to: 19313
/* 1039 */    MCD::OPC_Decode, 221, 19, 49, // Opcode: SLTu
/* 1043 */    MCD::OPC_FilterValue, 48, 10, 0, 0, // Skip to: 1058
/* 1048 */    MCD::OPC_CheckPredicate, 36, 84, 71, 0, // Skip to: 19313
/* 1053 */    MCD::OPC_Decode, 170, 21, 183, 1, // Opcode: TGE
/* 1058 */    MCD::OPC_FilterValue, 49, 10, 0, 0, // Skip to: 1073
/* 1063 */    MCD::OPC_CheckPredicate, 36, 69, 71, 0, // Skip to: 19313
/* 1068 */    MCD::OPC_Decode, 175, 21, 183, 1, // Opcode: TGEU
/* 1073 */    MCD::OPC_FilterValue, 50, 10, 0, 0, // Skip to: 1088
/* 1078 */    MCD::OPC_CheckPredicate, 36, 54, 71, 0, // Skip to: 19313
/* 1083 */    MCD::OPC_Decode, 202, 21, 183, 1, // Opcode: TLT
/* 1088 */    MCD::OPC_FilterValue, 51, 10, 0, 0, // Skip to: 1103
/* 1093 */    MCD::OPC_CheckPredicate, 36, 39, 71, 0, // Skip to: 19313
/* 1098 */    MCD::OPC_Decode, 206, 21, 183, 1, // Opcode: TLTU
/* 1103 */    MCD::OPC_FilterValue, 52, 10, 0, 0, // Skip to: 1118
/* 1108 */    MCD::OPC_CheckPredicate, 36, 24, 71, 0, // Skip to: 19313
/* 1113 */    MCD::OPC_Decode, 166, 21, 183, 1, // Opcode: TEQ
/* 1118 */    MCD::OPC_FilterValue, 54, 14, 71, 0, // Skip to: 19313
/* 1123 */    MCD::OPC_CheckPredicate, 36, 9, 71, 0, // Skip to: 19313
/* 1128 */    MCD::OPC_Decode, 209, 21, 183, 1, // Opcode: TNE
/* 1133 */    MCD::OPC_FilterValue, 1, 250, 0, 0, // Skip to: 1388
/* 1138 */    MCD::OPC_ExtractField, 16, 5,  // Inst{20-16} ...
/* 1141 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 1156
/* 1146 */    MCD::OPC_CheckPredicate, 27, 242, 70, 0, // Skip to: 19313
/* 1151 */    MCD::OPC_Decode, 164, 6, 184, 1, // Opcode: BLTZ
/* 1156 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 1171
/* 1161 */    MCD::OPC_CheckPredicate, 27, 227, 70, 0, // Skip to: 19313
/* 1166 */    MCD::OPC_Decode, 234, 5, 184, 1, // Opcode: BGEZ
/* 1171 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 1186
/* 1176 */    MCD::OPC_CheckPredicate, 39, 212, 70, 0, // Skip to: 19313
/* 1181 */    MCD::OPC_Decode, 175, 6, 184, 1, // Opcode: BLTZL
/* 1186 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 1201
/* 1191 */    MCD::OPC_CheckPredicate, 39, 197, 70, 0, // Skip to: 19313
/* 1196 */    MCD::OPC_Decode, 245, 5, 184, 1, // Opcode: BGEZL
/* 1201 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 1216
/* 1206 */    MCD::OPC_CheckPredicate, 39, 182, 70, 0, // Skip to: 19313
/* 1211 */    MCD::OPC_Decode, 171, 21, 162, 1, // Opcode: TGEI
/* 1216 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 1231
/* 1221 */    MCD::OPC_CheckPredicate, 39, 167, 70, 0, // Skip to: 19313
/* 1226 */    MCD::OPC_Decode, 172, 21, 162, 1, // Opcode: TGEIU
/* 1231 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 1246
/* 1236 */    MCD::OPC_CheckPredicate, 39, 152, 70, 0, // Skip to: 19313
/* 1241 */    MCD::OPC_Decode, 203, 21, 162, 1, // Opcode: TLTI
/* 1246 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 1261
/* 1251 */    MCD::OPC_CheckPredicate, 39, 137, 70, 0, // Skip to: 19313
/* 1256 */    MCD::OPC_Decode, 224, 21, 162, 1, // Opcode: TTLTIU
/* 1261 */    MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 1276
/* 1266 */    MCD::OPC_CheckPredicate, 39, 122, 70, 0, // Skip to: 19313
/* 1271 */    MCD::OPC_Decode, 167, 21, 162, 1, // Opcode: TEQI
/* 1276 */    MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 1291
/* 1281 */    MCD::OPC_CheckPredicate, 39, 107, 70, 0, // Skip to: 19313
/* 1286 */    MCD::OPC_Decode, 210, 21, 162, 1, // Opcode: TNEI
/* 1291 */    MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 1306
/* 1296 */    MCD::OPC_CheckPredicate, 31, 92, 70, 0, // Skip to: 19313
/* 1301 */    MCD::OPC_Decode, 166, 6, 184, 1, // Opcode: BLTZAL
/* 1306 */    MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 1321
/* 1311 */    MCD::OPC_CheckPredicate, 31, 77, 70, 0, // Skip to: 19313
/* 1316 */    MCD::OPC_Decode, 236, 5, 184, 1, // Opcode: BGEZAL
/* 1321 */    MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 1336
/* 1326 */    MCD::OPC_CheckPredicate, 39, 62, 70, 0, // Skip to: 19313
/* 1331 */    MCD::OPC_Decode, 169, 6, 184, 1, // Opcode: BLTZALL
/* 1336 */    MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 1351
/* 1341 */    MCD::OPC_CheckPredicate, 39, 47, 70, 0, // Skip to: 19313
/* 1346 */    MCD::OPC_Decode, 239, 5, 184, 1, // Opcode: BGEZALL
/* 1351 */    MCD::OPC_FilterValue, 28, 17, 0, 0, // Skip to: 1373
/* 1356 */    MCD::OPC_CheckPredicate, 40, 32, 70, 0, // Skip to: 19313
/* 1361 */    MCD::OPC_CheckField, 21, 5, 0, 25, 70, 0, // Skip to: 19313
/* 1368 */    MCD::OPC_Decode, 213, 6, 185, 1, // Opcode: BPOSGE32
/* 1373 */    MCD::OPC_FilterValue, 31, 15, 70, 0, // Skip to: 19313
/* 1378 */    MCD::OPC_CheckPredicate, 28, 10, 70, 0, // Skip to: 19313
/* 1383 */    MCD::OPC_Decode, 138, 21, 186, 1, // Opcode: SYNCI
/* 1388 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 1403
/* 1393 */    MCD::OPC_CheckPredicate, 27, 251, 69, 0, // Skip to: 19313
/* 1398 */    MCD::OPC_Decode, 134, 13, 187, 1, // Opcode: J
/* 1403 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 1418
/* 1408 */    MCD::OPC_CheckPredicate, 27, 236, 69, 0, // Skip to: 19313
/* 1413 */    MCD::OPC_Decode, 135, 13, 187, 1, // Opcode: JAL
/* 1418 */    MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 1433
/* 1423 */    MCD::OPC_CheckPredicate, 27, 221, 69, 0, // Skip to: 19313
/* 1428 */    MCD::OPC_Decode, 213, 5, 188, 1, // Opcode: BEQ
/* 1433 */    MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 1448
/* 1438 */    MCD::OPC_CheckPredicate, 27, 206, 69, 0, // Skip to: 19313
/* 1443 */    MCD::OPC_Decode, 181, 6, 188, 1, // Opcode: BNE
/* 1448 */    MCD::OPC_FilterValue, 6, 17, 0, 0, // Skip to: 1470
/* 1453 */    MCD::OPC_CheckPredicate, 27, 191, 69, 0, // Skip to: 19313
/* 1458 */    MCD::OPC_CheckField, 16, 5, 0, 184, 69, 0, // Skip to: 19313
/* 1465 */    MCD::OPC_Decode, 149, 6, 184, 1, // Opcode: BLEZ
/* 1470 */    MCD::OPC_FilterValue, 7, 17, 0, 0, // Skip to: 1492
/* 1475 */    MCD::OPC_CheckPredicate, 27, 169, 69, 0, // Skip to: 19313
/* 1480 */    MCD::OPC_CheckField, 16, 5, 0, 162, 69, 0, // Skip to: 19313
/* 1487 */    MCD::OPC_Decode, 247, 5, 184, 1, // Opcode: BGTZ
/* 1492 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 1507
/* 1497 */    MCD::OPC_CheckPredicate, 31, 147, 69, 0, // Skip to: 19313
/* 1502 */    MCD::OPC_Decode, 242, 4, 189, 1, // Opcode: ADDi
/* 1507 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 1522
/* 1512 */    MCD::OPC_CheckPredicate, 27, 132, 69, 0, // Skip to: 19313
/* 1517 */    MCD::OPC_Decode, 244, 4, 189, 1, // Opcode: ADDiu
/* 1522 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 1537
/* 1527 */    MCD::OPC_CheckPredicate, 27, 117, 69, 0, // Skip to: 19313
/* 1532 */    MCD::OPC_Decode, 215, 19, 189, 1, // Opcode: SLTi
/* 1537 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 1552
/* 1542 */    MCD::OPC_CheckPredicate, 27, 102, 69, 0, // Skip to: 19313
/* 1547 */    MCD::OPC_Decode, 218, 19, 189, 1, // Opcode: SLTiu
/* 1552 */    MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 1567
/* 1557 */    MCD::OPC_CheckPredicate, 27, 87, 69, 0, // Skip to: 19313
/* 1562 */    MCD::OPC_Decode, 135, 5, 190, 1, // Opcode: ANDi
/* 1567 */    MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 1582
/* 1572 */    MCD::OPC_CheckPredicate, 27, 72, 69, 0, // Skip to: 19313
/* 1577 */    MCD::OPC_Decode, 252, 16, 190, 1, // Opcode: ORi
/* 1582 */    MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 1597
/* 1587 */    MCD::OPC_CheckPredicate, 27, 57, 69, 0, // Skip to: 19313
/* 1592 */    MCD::OPC_Decode, 252, 21, 190, 1, // Opcode: XORi
/* 1597 */    MCD::OPC_FilterValue, 15, 26, 0, 0, // Skip to: 1628
/* 1602 */    MCD::OPC_CheckPredicate, 27, 11, 0, 0, // Skip to: 1618
/* 1607 */    MCD::OPC_CheckField, 21, 5, 0, 4, 0, 0, // Skip to: 1618
/* 1614 */    MCD::OPC_Decode, 248, 13, 91, // Opcode: LUi
/* 1618 */    MCD::OPC_CheckPredicate, 41, 26, 69, 0, // Skip to: 19313
/* 1623 */    MCD::OPC_Decode, 164, 12, 191, 1, // Opcode: GSDAUI
/* 1628 */    MCD::OPC_FilterValue, 16, 187, 2, 0, // Skip to: 2332
/* 1633 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1636 */    MCD::OPC_FilterValue, 0, 190, 1, 0, // Skip to: 2087
/* 1641 */    MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 1644 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 1666
/* 1649 */    MCD::OPC_CheckPredicate, 27, 251, 68, 0, // Skip to: 19313
/* 1654 */    MCD::OPC_CheckField, 4, 7, 0, 244, 68, 0, // Skip to: 19313
/* 1661 */    MCD::OPC_Decode, 236, 14, 192, 1, // Opcode: MFC0
/* 1666 */    MCD::OPC_FilterValue, 3, 63, 0, 0, // Skip to: 1734
/* 1671 */    MCD::OPC_ExtractField, 4, 7,  // Inst{10-4} ...
/* 1674 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 1689
/* 1679 */    MCD::OPC_CheckPredicate, 42, 221, 68, 0, // Skip to: 19313
/* 1684 */    MCD::OPC_Decode, 244, 14, 192, 1, // Opcode: MFGC0
/* 1689 */    MCD::OPC_FilterValue, 32, 10, 0, 0, // Skip to: 1704
/* 1694 */    MCD::OPC_CheckPredicate, 42, 206, 68, 0, // Skip to: 19313
/* 1699 */    MCD::OPC_Decode, 132, 16, 193, 1, // Opcode: MTGC0
/* 1704 */    MCD::OPC_FilterValue, 64, 10, 0, 0, // Skip to: 1719
/* 1709 */    MCD::OPC_CheckPredicate, 42, 191, 68, 0, // Skip to: 19313
/* 1714 */    MCD::OPC_Decode, 252, 14, 192, 1, // Opcode: MFHGC0
/* 1719 */    MCD::OPC_FilterValue, 96, 181, 68, 0, // Skip to: 19313
/* 1724 */    MCD::OPC_CheckPredicate, 42, 176, 68, 0, // Skip to: 19313
/* 1729 */    MCD::OPC_Decode, 140, 16, 193, 1, // Opcode: MTHGC0
/* 1734 */    MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 1756
/* 1739 */    MCD::OPC_CheckPredicate, 27, 161, 68, 0, // Skip to: 19313
/* 1744 */    MCD::OPC_CheckField, 4, 7, 0, 154, 68, 0, // Skip to: 19313
/* 1751 */    MCD::OPC_Decode, 251, 15, 193, 1, // Opcode: MTC0
/* 1756 */    MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 1778
/* 1761 */    MCD::OPC_CheckPredicate, 43, 139, 68, 0, // Skip to: 19313
/* 1766 */    MCD::OPC_CheckField, 6, 5, 0, 132, 68, 0, // Skip to: 19313
/* 1773 */    MCD::OPC_Decode, 138, 15, 194, 1, // Opcode: MFTR
/* 1778 */    MCD::OPC_FilterValue, 11, 133, 0, 0, // Skip to: 1916
/* 1783 */    MCD::OPC_ExtractField, 4, 12,  // Inst{15-4} ...
/* 1786 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 1807
/* 1791 */    MCD::OPC_CheckPredicate, 43, 109, 68, 0, // Skip to: 19313
/* 1796 */    MCD::OPC_CheckField, 0, 3, 1, 102, 68, 0, // Skip to: 19313
/* 1803 */    MCD::OPC_Decode, 190, 10, 80, // Opcode: DVPE
/* 1807 */    MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 1828
/* 1812 */    MCD::OPC_CheckPredicate, 43, 88, 68, 0, // Skip to: 19313
/* 1817 */    MCD::OPC_CheckField, 0, 3, 1, 81, 68, 0, // Skip to: 19313
/* 1824 */    MCD::OPC_Decode, 207, 10, 80, // Opcode: EVPE
/* 1828 */    MCD::OPC_FilterValue, 188, 1, 16, 0, 0, // Skip to: 1850
/* 1834 */    MCD::OPC_CheckPredicate, 43, 66, 68, 0, // Skip to: 19313
/* 1839 */    MCD::OPC_CheckField, 0, 3, 1, 59, 68, 0, // Skip to: 19313
/* 1846 */    MCD::OPC_Decode, 234, 9, 80, // Opcode: DMT
/* 1850 */    MCD::OPC_FilterValue, 190, 1, 16, 0, 0, // Skip to: 1872
/* 1856 */    MCD::OPC_CheckPredicate, 43, 44, 68, 0, // Skip to: 19313
/* 1861 */    MCD::OPC_CheckField, 0, 3, 1, 37, 68, 0, // Skip to: 19313
/* 1868 */    MCD::OPC_Decode, 200, 10, 80, // Opcode: EMT
/* 1872 */    MCD::OPC_FilterValue, 128, 12, 16, 0, 0, // Skip to: 1894
/* 1878 */    MCD::OPC_CheckPredicate, 28, 22, 68, 0, // Skip to: 19313
/* 1883 */    MCD::OPC_CheckField, 0, 3, 0, 15, 68, 0, // Skip to: 19313
/* 1890 */    MCD::OPC_Decode, 207, 9, 80, // Opcode: DI
/* 1894 */    MCD::OPC_FilterValue, 130, 12, 5, 68, 0, // Skip to: 19313
/* 1900 */    MCD::OPC_CheckPredicate, 28, 0, 68, 0, // Skip to: 19313
/* 1905 */    MCD::OPC_CheckField, 0, 3, 0, 249, 67, 0, // Skip to: 19313
/* 1912 */    MCD::OPC_Decode, 197, 10, 80, // Opcode: EI
/* 1916 */    MCD::OPC_FilterValue, 12, 17, 0, 0, // Skip to: 1938
/* 1921 */    MCD::OPC_CheckPredicate, 43, 235, 67, 0, // Skip to: 19313
/* 1926 */    MCD::OPC_CheckField, 6, 5, 0, 228, 67, 0, // Skip to: 19313
/* 1933 */    MCD::OPC_Decode, 160, 16, 194, 1, // Opcode: MTTR
/* 1938 */    MCD::OPC_FilterValue, 16, 218, 67, 0, // Skip to: 19313
/* 1943 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1946 */    MCD::OPC_FilterValue, 0, 31, 0, 0, // Skip to: 1982
/* 1951 */    MCD::OPC_ExtractField, 4, 17,  // Inst{20-4} ...
/* 1954 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 1968
/* 1959 */    MCD::OPC_CheckPredicate, 42, 197, 67, 0, // Skip to: 19313
/* 1964 */    MCD::OPC_Decode, 182, 21, 0, // Opcode: TLBGP
/* 1968 */    MCD::OPC_FilterValue, 2, 188, 67, 0, // Skip to: 19313
/* 1973 */    MCD::OPC_CheckPredicate, 44, 183, 67, 0, // Skip to: 19313
/* 1978 */    MCD::OPC_Decode, 234, 21, 0, // Opcode: WAIT
/* 1982 */    MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 2003
/* 1987 */    MCD::OPC_CheckPredicate, 27, 169, 67, 0, // Skip to: 19313
/* 1992 */    MCD::OPC_CheckField, 4, 17, 0, 162, 67, 0, // Skip to: 19313
/* 1999 */    MCD::OPC_Decode, 196, 21, 0, // Opcode: TLBR
/* 2003 */    MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 2024
/* 2008 */    MCD::OPC_CheckPredicate, 27, 148, 67, 0, // Skip to: 19313
/* 2013 */    MCD::OPC_CheckField, 4, 17, 0, 141, 67, 0, // Skip to: 19313
/* 2020 */    MCD::OPC_Decode, 198, 21, 0, // Opcode: TLBWI
/* 2024 */    MCD::OPC_FilterValue, 3, 16, 0, 0, // Skip to: 2045
/* 2029 */    MCD::OPC_CheckPredicate, 45, 127, 67, 0, // Skip to: 19313
/* 2034 */    MCD::OPC_CheckField, 4, 17, 0, 120, 67, 0, // Skip to: 19313
/* 2041 */    MCD::OPC_Decode, 190, 21, 0, // Opcode: TLBINV
/* 2045 */    MCD::OPC_FilterValue, 4, 16, 0, 0, // Skip to: 2066
/* 2050 */    MCD::OPC_CheckPredicate, 45, 106, 67, 0, // Skip to: 19313
/* 2055 */    MCD::OPC_CheckField, 4, 17, 0, 99, 67, 0, // Skip to: 19313
/* 2062 */    MCD::OPC_Decode, 191, 21, 0, // Opcode: TLBINVF
/* 2066 */    MCD::OPC_FilterValue, 6, 90, 67, 0, // Skip to: 19313
/* 2071 */    MCD::OPC_CheckPredicate, 27, 85, 67, 0, // Skip to: 19313
/* 2076 */    MCD::OPC_CheckField, 4, 17, 0, 78, 67, 0, // Skip to: 19313
/* 2083 */    MCD::OPC_Decode, 200, 21, 0, // Opcode: TLBWR
/* 2087 */    MCD::OPC_FilterValue, 1, 69, 67, 0, // Skip to: 19313
/* 2092 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2095 */    MCD::OPC_FilterValue, 0, 88, 0, 0, // Skip to: 2188
/* 2100 */    MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 2103 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 2126
/* 2108 */    MCD::OPC_CheckPredicate, 27, 48, 67, 0, // Skip to: 19313
/* 2113 */    MCD::OPC_CheckField, 6, 20, 128, 128, 32, 39, 67, 0, // Skip to: 19313
/* 2122 */    MCD::OPC_Decode, 194, 21, 0, // Opcode: TLBP
/* 2126 */    MCD::OPC_FilterValue, 1, 35, 0, 0, // Skip to: 2166
/* 2131 */    MCD::OPC_ExtractField, 6, 20,  // Inst{25-6} ...
/* 2134 */    MCD::OPC_FilterValue, 128, 128, 32, 9, 0, 0, // Skip to: 2150
/* 2141 */    MCD::OPC_CheckPredicate, 44, 15, 67, 0, // Skip to: 19313
/* 2146 */    MCD::OPC_Decode, 201, 10, 0, // Opcode: ERET
/* 2150 */    MCD::OPC_FilterValue, 129, 128, 32, 4, 67, 0, // Skip to: 19313
/* 2157 */    MCD::OPC_CheckPredicate, 46, 255, 66, 0, // Skip to: 19313
/* 2162 */    MCD::OPC_Decode, 202, 10, 0, // Opcode: ERETNC
/* 2166 */    MCD::OPC_FilterValue, 2, 246, 66, 0, // Skip to: 19313
/* 2171 */    MCD::OPC_CheckPredicate, 42, 241, 66, 0, // Skip to: 19313
/* 2176 */    MCD::OPC_CheckField, 25, 1, 1, 234, 66, 0, // Skip to: 19313
/* 2183 */    MCD::OPC_Decode, 231, 12, 195, 1, // Opcode: HYPCALL
/* 2188 */    MCD::OPC_FilterValue, 1, 19, 0, 0, // Skip to: 2212
/* 2193 */    MCD::OPC_CheckPredicate, 42, 219, 66, 0, // Skip to: 19313
/* 2198 */    MCD::OPC_CheckField, 4, 22, 128, 128, 128, 1, 209, 66, 0, // Skip to: 19313
/* 2208 */    MCD::OPC_Decode, 184, 21, 0, // Opcode: TLBGR
/* 2212 */    MCD::OPC_FilterValue, 2, 19, 0, 0, // Skip to: 2236
/* 2217 */    MCD::OPC_CheckPredicate, 42, 195, 66, 0, // Skip to: 19313
/* 2222 */    MCD::OPC_CheckField, 4, 22, 128, 128, 128, 1, 185, 66, 0, // Skip to: 19313
/* 2232 */    MCD::OPC_Decode, 186, 21, 0, // Opcode: TLBGWI
/* 2236 */    MCD::OPC_FilterValue, 3, 19, 0, 0, // Skip to: 2260
/* 2241 */    MCD::OPC_CheckPredicate, 42, 171, 66, 0, // Skip to: 19313
/* 2246 */    MCD::OPC_CheckField, 4, 22, 128, 128, 128, 1, 161, 66, 0, // Skip to: 19313
/* 2256 */    MCD::OPC_Decode, 178, 21, 0, // Opcode: TLBGINV
/* 2260 */    MCD::OPC_FilterValue, 4, 19, 0, 0, // Skip to: 2284
/* 2265 */    MCD::OPC_CheckPredicate, 42, 147, 66, 0, // Skip to: 19313
/* 2270 */    MCD::OPC_CheckField, 4, 22, 128, 128, 128, 1, 137, 66, 0, // Skip to: 19313
/* 2280 */    MCD::OPC_Decode, 179, 21, 0, // Opcode: TLBGINVF
/* 2284 */    MCD::OPC_FilterValue, 6, 19, 0, 0, // Skip to: 2308
/* 2289 */    MCD::OPC_CheckPredicate, 42, 123, 66, 0, // Skip to: 19313
/* 2294 */    MCD::OPC_CheckField, 4, 22, 128, 128, 128, 1, 113, 66, 0, // Skip to: 19313
/* 2304 */    MCD::OPC_Decode, 188, 21, 0, // Opcode: TLBGWR
/* 2308 */    MCD::OPC_FilterValue, 7, 104, 66, 0, // Skip to: 19313
/* 2313 */    MCD::OPC_CheckPredicate, 47, 99, 66, 0, // Skip to: 19313
/* 2318 */    MCD::OPC_CheckField, 4, 22, 129, 128, 128, 1, 89, 66, 0, // Skip to: 19313
/* 2328 */    MCD::OPC_Decode, 200, 9, 0, // Opcode: DERET
/* 2332 */    MCD::OPC_FilterValue, 17, 205, 7, 0, // Skip to: 4334
/* 2337 */    MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 2340 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 2362
/* 2345 */    MCD::OPC_CheckPredicate, 48, 67, 66, 0, // Skip to: 19313
/* 2350 */    MCD::OPC_CheckField, 0, 11, 0, 60, 66, 0, // Skip to: 19313
/* 2357 */    MCD::OPC_Decode, 238, 14, 196, 1, // Opcode: MFC1
/* 2362 */    MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 2384
/* 2367 */    MCD::OPC_CheckPredicate, 49, 45, 66, 0, // Skip to: 19313
/* 2372 */    MCD::OPC_CheckField, 0, 11, 0, 38, 66, 0, // Skip to: 19313
/* 2379 */    MCD::OPC_Decode, 228, 9, 197, 1, // Opcode: DMFC1
/* 2384 */    MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 2406
/* 2389 */    MCD::OPC_CheckPredicate, 48, 23, 66, 0, // Skip to: 19313
/* 2394 */    MCD::OPC_CheckField, 0, 11, 0, 16, 66, 0, // Skip to: 19313
/* 2401 */    MCD::OPC_Decode, 144, 7, 198, 1, // Opcode: CFC1
/* 2406 */    MCD::OPC_FilterValue, 3, 17, 0, 0, // Skip to: 2428
/* 2411 */    MCD::OPC_CheckPredicate, 50, 1, 66, 0, // Skip to: 19313
/* 2416 */    MCD::OPC_CheckField, 0, 11, 0, 250, 65, 0, // Skip to: 19313
/* 2423 */    MCD::OPC_Decode, 247, 14, 199, 1, // Opcode: MFHC1_D32
/* 2428 */    MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 2450
/* 2433 */    MCD::OPC_CheckPredicate, 48, 235, 65, 0, // Skip to: 19313
/* 2438 */    MCD::OPC_CheckField, 0, 11, 0, 228, 65, 0, // Skip to: 19313
/* 2445 */    MCD::OPC_Decode, 253, 15, 200, 1, // Opcode: MTC1
/* 2450 */    MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 2472
/* 2455 */    MCD::OPC_CheckPredicate, 49, 213, 65, 0, // Skip to: 19313
/* 2460 */    MCD::OPC_CheckField, 0, 11, 0, 206, 65, 0, // Skip to: 19313
/* 2467 */    MCD::OPC_Decode, 236, 9, 201, 1, // Opcode: DMTC1
/* 2472 */    MCD::OPC_FilterValue, 6, 17, 0, 0, // Skip to: 2494
/* 2477 */    MCD::OPC_CheckPredicate, 48, 191, 65, 0, // Skip to: 19313
/* 2482 */    MCD::OPC_CheckField, 0, 11, 0, 184, 65, 0, // Skip to: 19313
/* 2489 */    MCD::OPC_Decode, 171, 8, 202, 1, // Opcode: CTC1
/* 2494 */    MCD::OPC_FilterValue, 7, 17, 0, 0, // Skip to: 2516
/* 2499 */    MCD::OPC_CheckPredicate, 50, 169, 65, 0, // Skip to: 19313
/* 2504 */    MCD::OPC_CheckField, 0, 11, 0, 162, 65, 0, // Skip to: 19313
/* 2511 */    MCD::OPC_Decode, 135, 16, 203, 1, // Opcode: MTHC1_D32
/* 2516 */    MCD::OPC_FilterValue, 8, 63, 0, 0, // Skip to: 2584
/* 2521 */    MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 2524 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 2539
/* 2529 */    MCD::OPC_CheckPredicate, 51, 139, 65, 0, // Skip to: 19313
/* 2534 */    MCD::OPC_Decode, 192, 5, 204, 1, // Opcode: BC1F
/* 2539 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 2554
/* 2544 */    MCD::OPC_CheckPredicate, 51, 124, 65, 0, // Skip to: 19313
/* 2549 */    MCD::OPC_Decode, 197, 5, 204, 1, // Opcode: BC1T
/* 2554 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 2569
/* 2559 */    MCD::OPC_CheckPredicate, 52, 109, 65, 0, // Skip to: 19313
/* 2564 */    MCD::OPC_Decode, 193, 5, 204, 1, // Opcode: BC1FL
/* 2569 */    MCD::OPC_FilterValue, 3, 99, 65, 0, // Skip to: 19313
/* 2574 */    MCD::OPC_CheckPredicate, 52, 94, 65, 0, // Skip to: 19313
/* 2579 */    MCD::OPC_Decode, 198, 5, 204, 1, // Opcode: BC1TL
/* 2584 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 2599
/* 2589 */    MCD::OPC_CheckPredicate, 30, 79, 65, 0, // Skip to: 19313
/* 2594 */    MCD::OPC_Decode, 234, 6, 205, 1, // Opcode: BZ_V
/* 2599 */    MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 2614
/* 2604 */    MCD::OPC_CheckPredicate, 30, 64, 65, 0, // Skip to: 19313
/* 2609 */    MCD::OPC_Decode, 209, 6, 205, 1, // Opcode: BNZ_V
/* 2614 */    MCD::OPC_FilterValue, 16, 1, 3, 0, // Skip to: 3388
/* 2619 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 2622 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 2637
/* 2627 */    MCD::OPC_CheckPredicate, 48, 41, 65, 0, // Skip to: 19313
/* 2632 */    MCD::OPC_Decode, 249, 10, 206, 1, // Opcode: FADD_S
/* 2637 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 2652
/* 2642 */    MCD::OPC_CheckPredicate, 48, 26, 65, 0, // Skip to: 19313
/* 2647 */    MCD::OPC_Decode, 135, 12, 206, 1, // Opcode: FSUB_S
/* 2652 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 2667
/* 2657 */    MCD::OPC_CheckPredicate, 48, 11, 65, 0, // Skip to: 19313
/* 2662 */    MCD::OPC_Decode, 220, 11, 206, 1, // Opcode: FMUL_S
/* 2667 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 2682
/* 2672 */    MCD::OPC_CheckPredicate, 48, 252, 64, 0, // Skip to: 19313
/* 2677 */    MCD::OPC_Decode, 159, 11, 206, 1, // Opcode: FDIV_S
/* 2682 */    MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 2704
/* 2687 */    MCD::OPC_CheckPredicate, 53, 237, 64, 0, // Skip to: 19313
/* 2692 */    MCD::OPC_CheckField, 16, 5, 0, 230, 64, 0, // Skip to: 19313
/* 2699 */    MCD::OPC_Decode, 255, 11, 207, 1, // Opcode: FSQRT_S
/* 2704 */    MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 2726
/* 2709 */    MCD::OPC_CheckPredicate, 48, 215, 64, 0, // Skip to: 19313
/* 2714 */    MCD::OPC_CheckField, 16, 5, 0, 208, 64, 0, // Skip to: 19313
/* 2721 */    MCD::OPC_Decode, 242, 10, 207, 1, // Opcode: FABS_S
/* 2726 */    MCD::OPC_FilterValue, 6, 17, 0, 0, // Skip to: 2748
/* 2731 */    MCD::OPC_CheckPredicate, 48, 193, 64, 0, // Skip to: 19313
/* 2736 */    MCD::OPC_CheckField, 16, 5, 0, 186, 64, 0, // Skip to: 19313
/* 2743 */    MCD::OPC_Decode, 210, 11, 207, 1, // Opcode: FMOV_S
/* 2748 */    MCD::OPC_FilterValue, 7, 17, 0, 0, // Skip to: 2770
/* 2753 */    MCD::OPC_CheckPredicate, 20, 171, 64, 0, // Skip to: 19313
/* 2758 */    MCD::OPC_CheckField, 16, 5, 0, 164, 64, 0, // Skip to: 19313
/* 2765 */    MCD::OPC_Decode, 228, 11, 207, 1, // Opcode: FNEG_S
/* 2770 */    MCD::OPC_FilterValue, 12, 17, 0, 0, // Skip to: 2792
/* 2775 */    MCD::OPC_CheckPredicate, 53, 149, 64, 0, // Skip to: 19313
/* 2780 */    MCD::OPC_CheckField, 16, 5, 0, 142, 64, 0, // Skip to: 19313
/* 2787 */    MCD::OPC_Decode, 167, 18, 207, 1, // Opcode: ROUND_W_S
/* 2792 */    MCD::OPC_FilterValue, 13, 17, 0, 0, // Skip to: 2814
/* 2797 */    MCD::OPC_CheckPredicate, 53, 127, 64, 0, // Skip to: 19313
/* 2802 */    MCD::OPC_CheckField, 16, 5, 0, 120, 64, 0, // Skip to: 19313
/* 2809 */    MCD::OPC_Decode, 221, 21, 207, 1, // Opcode: TRUNC_W_S
/* 2814 */    MCD::OPC_FilterValue, 14, 17, 0, 0, // Skip to: 2836
/* 2819 */    MCD::OPC_CheckPredicate, 53, 105, 64, 0, // Skip to: 19313
/* 2824 */    MCD::OPC_CheckField, 16, 5, 0, 98, 64, 0, // Skip to: 19313
/* 2831 */    MCD::OPC_Decode, 133, 7, 207, 1, // Opcode: CEIL_W_S
/* 2836 */    MCD::OPC_FilterValue, 15, 17, 0, 0, // Skip to: 2858
/* 2841 */    MCD::OPC_CheckPredicate, 53, 83, 64, 0, // Skip to: 19313
/* 2846 */    MCD::OPC_CheckField, 16, 5, 0, 76, 64, 0, // Skip to: 19313
/* 2853 */    MCD::OPC_Decode, 193, 11, 207, 1, // Opcode: FLOOR_W_S
/* 2858 */    MCD::OPC_FilterValue, 17, 33, 0, 0, // Skip to: 2896
/* 2863 */    MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 2866 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 2881
/* 2871 */    MCD::OPC_CheckPredicate, 29, 53, 64, 0, // Skip to: 19313
/* 2876 */    MCD::OPC_Decode, 192, 15, 208, 1, // Opcode: MOVF_S
/* 2881 */    MCD::OPC_FilterValue, 1, 43, 64, 0, // Skip to: 19313
/* 2886 */    MCD::OPC_CheckPredicate, 29, 38, 64, 0, // Skip to: 19313
/* 2891 */    MCD::OPC_Decode, 212, 15, 208, 1, // Opcode: MOVT_S
/* 2896 */    MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 2911
/* 2901 */    MCD::OPC_CheckPredicate, 29, 23, 64, 0, // Skip to: 19313
/* 2906 */    MCD::OPC_Decode, 224, 15, 209, 1, // Opcode: MOVZ_I_S
/* 2911 */    MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 2926
/* 2916 */    MCD::OPC_CheckPredicate, 29, 8, 64, 0, // Skip to: 19313
/* 2921 */    MCD::OPC_Decode, 204, 15, 209, 1, // Opcode: MOVN_I_S
/* 2926 */    MCD::OPC_FilterValue, 21, 17, 0, 0, // Skip to: 2948
/* 2931 */    MCD::OPC_CheckPredicate, 54, 249, 63, 0, // Skip to: 19313
/* 2936 */    MCD::OPC_CheckField, 16, 5, 0, 242, 63, 0, // Skip to: 19313
/* 2943 */    MCD::OPC_Decode, 141, 18, 207, 1, // Opcode: RECIP_S
/* 2948 */    MCD::OPC_FilterValue, 22, 17, 0, 0, // Skip to: 2970
/* 2953 */    MCD::OPC_CheckPredicate, 54, 227, 63, 0, // Skip to: 19313
/* 2958 */    MCD::OPC_CheckField, 16, 5, 0, 220, 63, 0, // Skip to: 19313
/* 2965 */    MCD::OPC_Decode, 174, 18, 207, 1, // Opcode: RSQRT_S
/* 2970 */    MCD::OPC_FilterValue, 33, 17, 0, 0, // Skip to: 2992
/* 2975 */    MCD::OPC_CheckPredicate, 55, 205, 63, 0, // Skip to: 19313
/* 2980 */    MCD::OPC_CheckField, 16, 5, 0, 198, 63, 0, // Skip to: 19313
/* 2987 */    MCD::OPC_Decode, 177, 8, 210, 1, // Opcode: CVT_D32_S
/* 2992 */    MCD::OPC_FilterValue, 36, 17, 0, 0, // Skip to: 3014
/* 2997 */    MCD::OPC_CheckPredicate, 48, 183, 63, 0, // Skip to: 19313
/* 3002 */    MCD::OPC_CheckField, 16, 5, 0, 176, 63, 0, // Skip to: 19313
/* 3009 */    MCD::OPC_Decode, 209, 8, 207, 1, // Opcode: CVT_W_S
/* 3014 */    MCD::OPC_FilterValue, 37, 17, 0, 0, // Skip to: 3036
/* 3019 */    MCD::OPC_CheckPredicate, 56, 161, 63, 0, // Skip to: 19313
/* 3024 */    MCD::OPC_CheckField, 16, 5, 0, 154, 63, 0, // Skip to: 19313
/* 3031 */    MCD::OPC_Decode, 190, 8, 211, 1, // Opcode: CVT_L_S
/* 3036 */    MCD::OPC_FilterValue, 48, 17, 0, 0, // Skip to: 3058
/* 3041 */    MCD::OPC_CheckPredicate, 51, 139, 63, 0, // Skip to: 19313
/* 3046 */    MCD::OPC_CheckField, 6, 2, 0, 132, 63, 0, // Skip to: 19313
/* 3053 */    MCD::OPC_Decode, 222, 8, 212, 1, // Opcode: C_F_S
/* 3058 */    MCD::OPC_FilterValue, 49, 17, 0, 0, // Skip to: 3080
/* 3063 */    MCD::OPC_CheckPredicate, 51, 117, 63, 0, // Skip to: 19313
/* 3068 */    MCD::OPC_CheckField, 6, 2, 0, 110, 63, 0, // Skip to: 19313
/* 3075 */    MCD::OPC_Decode, 178, 9, 212, 1, // Opcode: C_UN_S
/* 3080 */    MCD::OPC_FilterValue, 50, 17, 0, 0, // Skip to: 3102
/* 3085 */    MCD::OPC_CheckPredicate, 51, 95, 63, 0, // Skip to: 19313
/* 3090 */    MCD::OPC_CheckField, 6, 2, 0, 88, 63, 0, // Skip to: 19313
/* 3097 */    MCD::OPC_Decode, 216, 8, 212, 1, // Opcode: C_EQ_S
/* 3102 */    MCD::OPC_FilterValue, 51, 17, 0, 0, // Skip to: 3124
/* 3107 */    MCD::OPC_CheckPredicate, 51, 73, 63, 0, // Skip to: 19313
/* 3112 */    MCD::OPC_CheckField, 6, 2, 0, 66, 63, 0, // Skip to: 19313
/* 3119 */    MCD::OPC_Decode, 160, 9, 212, 1, // Opcode: C_UEQ_S
/* 3124 */    MCD::OPC_FilterValue, 52, 17, 0, 0, // Skip to: 3146
/* 3129 */    MCD::OPC_CheckPredicate, 51, 51, 63, 0, // Skip to: 19313
/* 3134 */    MCD::OPC_CheckField, 6, 2, 0, 44, 63, 0, // Skip to: 19313
/* 3141 */    MCD::OPC_Decode, 142, 9, 212, 1, // Opcode: C_OLT_S
/* 3146 */    MCD::OPC_FilterValue, 53, 17, 0, 0, // Skip to: 3168
/* 3151 */    MCD::OPC_CheckPredicate, 51, 29, 63, 0, // Skip to: 19313
/* 3156 */    MCD::OPC_CheckField, 6, 2, 0, 22, 63, 0, // Skip to: 19313
/* 3163 */    MCD::OPC_Decode, 172, 9, 212, 1, // Opcode: C_ULT_S
/* 3168 */    MCD::OPC_FilterValue, 54, 17, 0, 0, // Skip to: 3190
/* 3173 */    MCD::OPC_CheckPredicate, 51, 7, 63, 0, // Skip to: 19313
/* 3178 */    MCD::OPC_CheckField, 6, 2, 0, 0, 63, 0, // Skip to: 19313
/* 3185 */    MCD::OPC_Decode, 136, 9, 212, 1, // Opcode: C_OLE_S
/* 3190 */    MCD::OPC_FilterValue, 55, 17, 0, 0, // Skip to: 3212
/* 3195 */    MCD::OPC_CheckPredicate, 51, 241, 62, 0, // Skip to: 19313
/* 3200 */    MCD::OPC_CheckField, 6, 2, 0, 234, 62, 0, // Skip to: 19313
/* 3207 */    MCD::OPC_Decode, 166, 9, 212, 1, // Opcode: C_ULE_S
/* 3212 */    MCD::OPC_FilterValue, 56, 17, 0, 0, // Skip to: 3234
/* 3217 */    MCD::OPC_CheckPredicate, 51, 219, 62, 0, // Skip to: 19313
/* 3222 */    MCD::OPC_CheckField, 6, 2, 0, 212, 62, 0, // Skip to: 19313
/* 3229 */    MCD::OPC_Decode, 154, 9, 212, 1, // Opcode: C_SF_S
/* 3234 */    MCD::OPC_FilterValue, 57, 17, 0, 0, // Skip to: 3256
/* 3239 */    MCD::OPC_CheckPredicate, 51, 197, 62, 0, // Skip to: 19313
/* 3244 */    MCD::OPC_CheckField, 6, 2, 0, 190, 62, 0, // Skip to: 19313
/* 3251 */    MCD::OPC_Decode, 246, 8, 212, 1, // Opcode: C_NGLE_S
/* 3256 */    MCD::OPC_FilterValue, 58, 17, 0, 0, // Skip to: 3278
/* 3261 */    MCD::OPC_CheckPredicate, 51, 175, 62, 0, // Skip to: 19313
/* 3266 */    MCD::OPC_CheckField, 6, 2, 0, 168, 62, 0, // Skip to: 19313
/* 3273 */    MCD::OPC_Decode, 148, 9, 212, 1, // Opcode: C_SEQ_S
/* 3278 */    MCD::OPC_FilterValue, 59, 17, 0, 0, // Skip to: 3300
/* 3283 */    MCD::OPC_CheckPredicate, 51, 153, 62, 0, // Skip to: 19313
/* 3288 */    MCD::OPC_CheckField, 6, 2, 0, 146, 62, 0, // Skip to: 19313
/* 3295 */    MCD::OPC_Decode, 252, 8, 212, 1, // Opcode: C_NGL_S
/* 3300 */    MCD::OPC_FilterValue, 60, 17, 0, 0, // Skip to: 3322
/* 3305 */    MCD::OPC_CheckPredicate, 51, 131, 62, 0, // Skip to: 19313
/* 3310 */    MCD::OPC_CheckField, 6, 2, 0, 124, 62, 0, // Skip to: 19313
/* 3317 */    MCD::OPC_Decode, 234, 8, 212, 1, // Opcode: C_LT_S
/* 3322 */    MCD::OPC_FilterValue, 61, 17, 0, 0, // Skip to: 3344
/* 3327 */    MCD::OPC_CheckPredicate, 51, 109, 62, 0, // Skip to: 19313
/* 3332 */    MCD::OPC_CheckField, 6, 2, 0, 102, 62, 0, // Skip to: 19313
/* 3339 */    MCD::OPC_Decode, 240, 8, 212, 1, // Opcode: C_NGE_S
/* 3344 */    MCD::OPC_FilterValue, 62, 17, 0, 0, // Skip to: 3366
/* 3349 */    MCD::OPC_CheckPredicate, 51, 87, 62, 0, // Skip to: 19313
/* 3354 */    MCD::OPC_CheckField, 6, 2, 0, 80, 62, 0, // Skip to: 19313
/* 3361 */    MCD::OPC_Decode, 228, 8, 212, 1, // Opcode: C_LE_S
/* 3366 */    MCD::OPC_FilterValue, 63, 70, 62, 0, // Skip to: 19313
/* 3371 */    MCD::OPC_CheckPredicate, 51, 65, 62, 0, // Skip to: 19313
/* 3376 */    MCD::OPC_CheckField, 6, 2, 0, 58, 62, 0, // Skip to: 19313
/* 3383 */    MCD::OPC_Decode, 130, 9, 212, 1, // Opcode: C_NGT_S
/* 3388 */    MCD::OPC_FilterValue, 17, 1, 3, 0, // Skip to: 4162
/* 3393 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 3396 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 3411
/* 3401 */    MCD::OPC_CheckPredicate, 55, 35, 62, 0, // Skip to: 19313
/* 3406 */    MCD::OPC_Decode, 245, 10, 213, 1, // Opcode: FADD_D32
/* 3411 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 3426
/* 3416 */    MCD::OPC_CheckPredicate, 55, 20, 62, 0, // Skip to: 19313
/* 3421 */    MCD::OPC_Decode, 131, 12, 213, 1, // Opcode: FSUB_D32
/* 3426 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 3441
/* 3431 */    MCD::OPC_CheckPredicate, 55, 5, 62, 0, // Skip to: 19313
/* 3436 */    MCD::OPC_Decode, 216, 11, 213, 1, // Opcode: FMUL_D32
/* 3441 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 3456
/* 3446 */    MCD::OPC_CheckPredicate, 55, 246, 61, 0, // Skip to: 19313
/* 3451 */    MCD::OPC_Decode, 155, 11, 213, 1, // Opcode: FDIV_D32
/* 3456 */    MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 3478
/* 3461 */    MCD::OPC_CheckPredicate, 57, 231, 61, 0, // Skip to: 19313
/* 3466 */    MCD::OPC_CheckField, 16, 5, 0, 224, 61, 0, // Skip to: 19313
/* 3473 */    MCD::OPC_Decode, 251, 11, 214, 1, // Opcode: FSQRT_D32
/* 3478 */    MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 3500
/* 3483 */    MCD::OPC_CheckPredicate, 55, 209, 61, 0, // Skip to: 19313
/* 3488 */    MCD::OPC_CheckField, 16, 5, 0, 202, 61, 0, // Skip to: 19313
/* 3495 */    MCD::OPC_Decode, 238, 10, 214, 1, // Opcode: FABS_D32
/* 3500 */    MCD::OPC_FilterValue, 6, 17, 0, 0, // Skip to: 3522
/* 3505 */    MCD::OPC_CheckPredicate, 55, 187, 61, 0, // Skip to: 19313
/* 3510 */    MCD::OPC_CheckField, 16, 5, 0, 180, 61, 0, // Skip to: 19313
/* 3517 */    MCD::OPC_Decode, 206, 11, 214, 1, // Opcode: FMOV_D32
/* 3522 */    MCD::OPC_FilterValue, 7, 17, 0, 0, // Skip to: 3544
/* 3527 */    MCD::OPC_CheckPredicate, 55, 165, 61, 0, // Skip to: 19313
/* 3532 */    MCD::OPC_CheckField, 16, 5, 0, 158, 61, 0, // Skip to: 19313
/* 3539 */    MCD::OPC_Decode, 224, 11, 214, 1, // Opcode: FNEG_D32
/* 3544 */    MCD::OPC_FilterValue, 12, 17, 0, 0, // Skip to: 3566
/* 3549 */    MCD::OPC_CheckPredicate, 57, 143, 61, 0, // Skip to: 19313
/* 3554 */    MCD::OPC_CheckField, 16, 5, 0, 136, 61, 0, // Skip to: 19313
/* 3561 */    MCD::OPC_Decode, 163, 18, 215, 1, // Opcode: ROUND_W_D32
/* 3566 */    MCD::OPC_FilterValue, 13, 17, 0, 0, // Skip to: 3588
/* 3571 */    MCD::OPC_CheckPredicate, 57, 121, 61, 0, // Skip to: 19313
/* 3576 */    MCD::OPC_CheckField, 16, 5, 0, 114, 61, 0, // Skip to: 19313
/* 3583 */    MCD::OPC_Decode, 217, 21, 215, 1, // Opcode: TRUNC_W_D32
/* 3588 */    MCD::OPC_FilterValue, 14, 17, 0, 0, // Skip to: 3610
/* 3593 */    MCD::OPC_CheckPredicate, 57, 99, 61, 0, // Skip to: 19313
/* 3598 */    MCD::OPC_CheckField, 16, 5, 0, 92, 61, 0, // Skip to: 19313
/* 3605 */    MCD::OPC_Decode, 129, 7, 215, 1, // Opcode: CEIL_W_D32
/* 3610 */    MCD::OPC_FilterValue, 15, 17, 0, 0, // Skip to: 3632
/* 3615 */    MCD::OPC_CheckPredicate, 57, 77, 61, 0, // Skip to: 19313
/* 3620 */    MCD::OPC_CheckField, 16, 5, 0, 70, 61, 0, // Skip to: 19313
/* 3627 */    MCD::OPC_Decode, 189, 11, 215, 1, // Opcode: FLOOR_W_D32
/* 3632 */    MCD::OPC_FilterValue, 17, 33, 0, 0, // Skip to: 3670
/* 3637 */    MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 3640 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 3655
/* 3645 */    MCD::OPC_CheckPredicate, 58, 47, 61, 0, // Skip to: 19313
/* 3650 */    MCD::OPC_Decode, 186, 15, 216, 1, // Opcode: MOVF_D32
/* 3655 */    MCD::OPC_FilterValue, 1, 37, 61, 0, // Skip to: 19313
/* 3660 */    MCD::OPC_CheckPredicate, 58, 32, 61, 0, // Skip to: 19313
/* 3665 */    MCD::OPC_Decode, 206, 15, 216, 1, // Opcode: MOVT_D32
/* 3670 */    MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 3685
/* 3675 */    MCD::OPC_CheckPredicate, 58, 17, 61, 0, // Skip to: 19313
/* 3680 */    MCD::OPC_Decode, 218, 15, 217, 1, // Opcode: MOVZ_I_D32
/* 3685 */    MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 3700
/* 3690 */    MCD::OPC_CheckPredicate, 58, 2, 61, 0, // Skip to: 19313
/* 3695 */    MCD::OPC_Decode, 198, 15, 217, 1, // Opcode: MOVN_I_D32
/* 3700 */    MCD::OPC_FilterValue, 21, 17, 0, 0, // Skip to: 3722
/* 3705 */    MCD::OPC_CheckPredicate, 59, 243, 60, 0, // Skip to: 19313
/* 3710 */    MCD::OPC_CheckField, 16, 5, 0, 236, 60, 0, // Skip to: 19313
/* 3717 */    MCD::OPC_Decode, 137, 18, 214, 1, // Opcode: RECIP_D32
/* 3722 */    MCD::OPC_FilterValue, 22, 17, 0, 0, // Skip to: 3744
/* 3727 */    MCD::OPC_CheckPredicate, 59, 221, 60, 0, // Skip to: 19313
/* 3732 */    MCD::OPC_CheckField, 16, 5, 0, 214, 60, 0, // Skip to: 19313
/* 3739 */    MCD::OPC_Decode, 170, 18, 214, 1, // Opcode: RSQRT_D32
/* 3744 */    MCD::OPC_FilterValue, 32, 17, 0, 0, // Skip to: 3766
/* 3749 */    MCD::OPC_CheckPredicate, 55, 199, 60, 0, // Skip to: 19313
/* 3754 */    MCD::OPC_CheckField, 16, 5, 0, 192, 60, 0, // Skip to: 19313
/* 3761 */    MCD::OPC_Decode, 194, 8, 215, 1, // Opcode: CVT_S_D32
/* 3766 */    MCD::OPC_FilterValue, 36, 17, 0, 0, // Skip to: 3788
/* 3771 */    MCD::OPC_CheckPredicate, 55, 177, 60, 0, // Skip to: 19313
/* 3776 */    MCD::OPC_CheckField, 16, 5, 0, 170, 60, 0, // Skip to: 19313
/* 3783 */    MCD::OPC_Decode, 205, 8, 215, 1, // Opcode: CVT_W_D32
/* 3788 */    MCD::OPC_FilterValue, 37, 17, 0, 0, // Skip to: 3810
/* 3793 */    MCD::OPC_CheckPredicate, 56, 155, 60, 0, // Skip to: 19313
/* 3798 */    MCD::OPC_CheckField, 16, 5, 0, 148, 60, 0, // Skip to: 19313
/* 3805 */    MCD::OPC_Decode, 187, 8, 218, 1, // Opcode: CVT_L_D64
/* 3810 */    MCD::OPC_FilterValue, 48, 17, 0, 0, // Skip to: 3832
/* 3815 */    MCD::OPC_CheckPredicate, 60, 133, 60, 0, // Skip to: 19313
/* 3820 */    MCD::OPC_CheckField, 6, 2, 0, 126, 60, 0, // Skip to: 19313
/* 3827 */    MCD::OPC_Decode, 218, 8, 219, 1, // Opcode: C_F_D32
/* 3832 */    MCD::OPC_FilterValue, 49, 17, 0, 0, // Skip to: 3854
/* 3837 */    MCD::OPC_CheckPredicate, 60, 111, 60, 0, // Skip to: 19313
/* 3842 */    MCD::OPC_CheckField, 6, 2, 0, 104, 60, 0, // Skip to: 19313
/* 3849 */    MCD::OPC_Decode, 174, 9, 219, 1, // Opcode: C_UN_D32
/* 3854 */    MCD::OPC_FilterValue, 50, 17, 0, 0, // Skip to: 3876
/* 3859 */    MCD::OPC_CheckPredicate, 60, 89, 60, 0, // Skip to: 19313
/* 3864 */    MCD::OPC_CheckField, 6, 2, 0, 82, 60, 0, // Skip to: 19313
/* 3871 */    MCD::OPC_Decode, 212, 8, 219, 1, // Opcode: C_EQ_D32
/* 3876 */    MCD::OPC_FilterValue, 51, 17, 0, 0, // Skip to: 3898
/* 3881 */    MCD::OPC_CheckPredicate, 60, 67, 60, 0, // Skip to: 19313
/* 3886 */    MCD::OPC_CheckField, 6, 2, 0, 60, 60, 0, // Skip to: 19313
/* 3893 */    MCD::OPC_Decode, 156, 9, 219, 1, // Opcode: C_UEQ_D32
/* 3898 */    MCD::OPC_FilterValue, 52, 17, 0, 0, // Skip to: 3920
/* 3903 */    MCD::OPC_CheckPredicate, 60, 45, 60, 0, // Skip to: 19313
/* 3908 */    MCD::OPC_CheckField, 6, 2, 0, 38, 60, 0, // Skip to: 19313
/* 3915 */    MCD::OPC_Decode, 138, 9, 219, 1, // Opcode: C_OLT_D32
/* 3920 */    MCD::OPC_FilterValue, 53, 17, 0, 0, // Skip to: 3942
/* 3925 */    MCD::OPC_CheckPredicate, 60, 23, 60, 0, // Skip to: 19313
/* 3930 */    MCD::OPC_CheckField, 6, 2, 0, 16, 60, 0, // Skip to: 19313
/* 3937 */    MCD::OPC_Decode, 168, 9, 219, 1, // Opcode: C_ULT_D32
/* 3942 */    MCD::OPC_FilterValue, 54, 17, 0, 0, // Skip to: 3964
/* 3947 */    MCD::OPC_CheckPredicate, 60, 1, 60, 0, // Skip to: 19313
/* 3952 */    MCD::OPC_CheckField, 6, 2, 0, 250, 59, 0, // Skip to: 19313
/* 3959 */    MCD::OPC_Decode, 132, 9, 219, 1, // Opcode: C_OLE_D32
/* 3964 */    MCD::OPC_FilterValue, 55, 17, 0, 0, // Skip to: 3986
/* 3969 */    MCD::OPC_CheckPredicate, 60, 235, 59, 0, // Skip to: 19313
/* 3974 */    MCD::OPC_CheckField, 6, 2, 0, 228, 59, 0, // Skip to: 19313
/* 3981 */    MCD::OPC_Decode, 162, 9, 219, 1, // Opcode: C_ULE_D32
/* 3986 */    MCD::OPC_FilterValue, 56, 17, 0, 0, // Skip to: 4008
/* 3991 */    MCD::OPC_CheckPredicate, 60, 213, 59, 0, // Skip to: 19313
/* 3996 */    MCD::OPC_CheckField, 6, 2, 0, 206, 59, 0, // Skip to: 19313
/* 4003 */    MCD::OPC_Decode, 150, 9, 219, 1, // Opcode: C_SF_D32
/* 4008 */    MCD::OPC_FilterValue, 57, 17, 0, 0, // Skip to: 4030
/* 4013 */    MCD::OPC_CheckPredicate, 60, 191, 59, 0, // Skip to: 19313
/* 4018 */    MCD::OPC_CheckField, 6, 2, 0, 184, 59, 0, // Skip to: 19313
/* 4025 */    MCD::OPC_Decode, 242, 8, 219, 1, // Opcode: C_NGLE_D32
/* 4030 */    MCD::OPC_FilterValue, 58, 17, 0, 0, // Skip to: 4052
/* 4035 */    MCD::OPC_CheckPredicate, 60, 169, 59, 0, // Skip to: 19313
/* 4040 */    MCD::OPC_CheckField, 6, 2, 0, 162, 59, 0, // Skip to: 19313
/* 4047 */    MCD::OPC_Decode, 144, 9, 219, 1, // Opcode: C_SEQ_D32
/* 4052 */    MCD::OPC_FilterValue, 59, 17, 0, 0, // Skip to: 4074
/* 4057 */    MCD::OPC_CheckPredicate, 60, 147, 59, 0, // Skip to: 19313
/* 4062 */    MCD::OPC_CheckField, 6, 2, 0, 140, 59, 0, // Skip to: 19313
/* 4069 */    MCD::OPC_Decode, 248, 8, 219, 1, // Opcode: C_NGL_D32
/* 4074 */    MCD::OPC_FilterValue, 60, 17, 0, 0, // Skip to: 4096
/* 4079 */    MCD::OPC_CheckPredicate, 60, 125, 59, 0, // Skip to: 19313
/* 4084 */    MCD::OPC_CheckField, 6, 2, 0, 118, 59, 0, // Skip to: 19313
/* 4091 */    MCD::OPC_Decode, 230, 8, 219, 1, // Opcode: C_LT_D32
/* 4096 */    MCD::OPC_FilterValue, 61, 17, 0, 0, // Skip to: 4118
/* 4101 */    MCD::OPC_CheckPredicate, 60, 103, 59, 0, // Skip to: 19313
/* 4106 */    MCD::OPC_CheckField, 6, 2, 0, 96, 59, 0, // Skip to: 19313
/* 4113 */    MCD::OPC_Decode, 236, 8, 219, 1, // Opcode: C_NGE_D32
/* 4118 */    MCD::OPC_FilterValue, 62, 17, 0, 0, // Skip to: 4140
/* 4123 */    MCD::OPC_CheckPredicate, 60, 81, 59, 0, // Skip to: 19313
/* 4128 */    MCD::OPC_CheckField, 6, 2, 0, 74, 59, 0, // Skip to: 19313
/* 4135 */    MCD::OPC_Decode, 224, 8, 219, 1, // Opcode: C_LE_D32
/* 4140 */    MCD::OPC_FilterValue, 63, 64, 59, 0, // Skip to: 19313
/* 4145 */    MCD::OPC_CheckPredicate, 60, 59, 59, 0, // Skip to: 19313
/* 4150 */    MCD::OPC_CheckField, 6, 2, 0, 52, 59, 0, // Skip to: 19313
/* 4157 */    MCD::OPC_Decode, 254, 8, 219, 1, // Opcode: C_NGT_D32
/* 4162 */    MCD::OPC_FilterValue, 20, 47, 0, 0, // Skip to: 4214
/* 4167 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 4170 */    MCD::OPC_FilterValue, 32, 17, 0, 0, // Skip to: 4192
/* 4175 */    MCD::OPC_CheckPredicate, 48, 29, 59, 0, // Skip to: 19313
/* 4180 */    MCD::OPC_CheckField, 16, 5, 0, 22, 59, 0, // Skip to: 19313
/* 4187 */    MCD::OPC_Decode, 202, 8, 207, 1, // Opcode: CVT_S_W
/* 4192 */    MCD::OPC_FilterValue, 33, 12, 59, 0, // Skip to: 19313
/* 4197 */    MCD::OPC_CheckPredicate, 55, 7, 59, 0, // Skip to: 19313
/* 4202 */    MCD::OPC_CheckField, 16, 5, 0, 0, 59, 0, // Skip to: 19313
/* 4209 */    MCD::OPC_Decode, 179, 8, 210, 1, // Opcode: CVT_D32_W
/* 4214 */    MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 4229
/* 4219 */    MCD::OPC_CheckPredicate, 30, 241, 58, 0, // Skip to: 19313
/* 4224 */    MCD::OPC_Decode, 231, 6, 205, 1, // Opcode: BZ_B
/* 4229 */    MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 4244
/* 4234 */    MCD::OPC_CheckPredicate, 30, 226, 58, 0, // Skip to: 19313
/* 4239 */    MCD::OPC_Decode, 233, 6, 220, 1, // Opcode: BZ_H
/* 4244 */    MCD::OPC_FilterValue, 26, 10, 0, 0, // Skip to: 4259
/* 4249 */    MCD::OPC_CheckPredicate, 30, 211, 58, 0, // Skip to: 19313
/* 4254 */    MCD::OPC_Decode, 235, 6, 221, 1, // Opcode: BZ_W
/* 4259 */    MCD::OPC_FilterValue, 27, 10, 0, 0, // Skip to: 4274
/* 4264 */    MCD::OPC_CheckPredicate, 30, 196, 58, 0, // Skip to: 19313
/* 4269 */    MCD::OPC_Decode, 232, 6, 222, 1, // Opcode: BZ_D
/* 4274 */    MCD::OPC_FilterValue, 28, 10, 0, 0, // Skip to: 4289
/* 4279 */    MCD::OPC_CheckPredicate, 30, 181, 58, 0, // Skip to: 19313
/* 4284 */    MCD::OPC_Decode, 206, 6, 205, 1, // Opcode: BNZ_B
/* 4289 */    MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 4304
/* 4294 */    MCD::OPC_CheckPredicate, 30, 166, 58, 0, // Skip to: 19313
/* 4299 */    MCD::OPC_Decode, 208, 6, 220, 1, // Opcode: BNZ_H
/* 4304 */    MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 4319
/* 4309 */    MCD::OPC_CheckPredicate, 30, 151, 58, 0, // Skip to: 19313
/* 4314 */    MCD::OPC_Decode, 210, 6, 221, 1, // Opcode: BNZ_W
/* 4319 */    MCD::OPC_FilterValue, 31, 141, 58, 0, // Skip to: 19313
/* 4324 */    MCD::OPC_CheckPredicate, 30, 136, 58, 0, // Skip to: 19313
/* 4329 */    MCD::OPC_Decode, 207, 6, 222, 1, // Opcode: BNZ_D
/* 4334 */    MCD::OPC_FilterValue, 18, 87, 5, 0, // Skip to: 5706
/* 4339 */    MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 4342 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 4364
/* 4347 */    MCD::OPC_CheckPredicate, 27, 113, 58, 0, // Skip to: 19313
/* 4352 */    MCD::OPC_CheckField, 3, 8, 0, 106, 58, 0, // Skip to: 19313
/* 4359 */    MCD::OPC_Decode, 242, 14, 223, 1, // Opcode: MFC2
/* 4364 */    MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 4386
/* 4369 */    MCD::OPC_CheckPredicate, 27, 91, 58, 0, // Skip to: 19313
/* 4374 */    MCD::OPC_CheckField, 3, 8, 0, 84, 58, 0, // Skip to: 19313
/* 4381 */    MCD::OPC_Decode, 130, 16, 224, 1, // Opcode: MTC2
/* 4386 */    MCD::OPC_FilterValue, 24, 183, 0, 0, // Skip to: 4574
/* 4391 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 4394 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 4409
/* 4399 */    MCD::OPC_CheckPredicate, 61, 61, 58, 0, // Skip to: 19313
/* 4404 */    MCD::OPC_Decode, 134, 17, 225, 1, // Opcode: PADDSH
/* 4409 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 4424
/* 4414 */    MCD::OPC_CheckPredicate, 61, 46, 58, 0, // Skip to: 19313
/* 4419 */    MCD::OPC_Decode, 245, 17, 225, 1, // Opcode: PSUBSH
/* 4424 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 4439
/* 4429 */    MCD::OPC_CheckPredicate, 61, 31, 58, 0, // Skip to: 19313
/* 4434 */    MCD::OPC_Decode, 234, 17, 225, 1, // Opcode: PSHUFH
/* 4439 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 4454
/* 4444 */    MCD::OPC_CheckPredicate, 61, 16, 58, 0, // Skip to: 19313
/* 4449 */    MCD::OPC_Decode, 253, 17, 225, 1, // Opcode: PUNPCKLHW
/* 4454 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 4469
/* 4459 */    MCD::OPC_CheckPredicate, 61, 1, 58, 0, // Skip to: 19313
/* 4464 */    MCD::OPC_Decode, 148, 17, 225, 1, // Opcode: PAVGH
/* 4469 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 4484
/* 4474 */    MCD::OPC_CheckPredicate, 61, 242, 57, 0, // Skip to: 19313
/* 4479 */    MCD::OPC_Decode, 159, 17, 225, 1, // Opcode: PCMPEQW
/* 4484 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 4499
/* 4489 */    MCD::OPC_CheckPredicate, 61, 227, 57, 0, // Skip to: 19313
/* 4494 */    MCD::OPC_Decode, 236, 17, 225, 1, // Opcode: PSLLW
/* 4499 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 4514
/* 4504 */    MCD::OPC_CheckPredicate, 61, 212, 57, 0, // Skip to: 19313
/* 4509 */    MCD::OPC_Decode, 240, 17, 225, 1, // Opcode: PSRLW
/* 4514 */    MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 4529
/* 4519 */    MCD::OPC_CheckPredicate, 61, 197, 57, 0, // Skip to: 19313
/* 4524 */    MCD::OPC_Decode, 178, 18, 206, 1, // Opcode: SADDUW
/* 4529 */    MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 4544
/* 4534 */    MCD::OPC_CheckPredicate, 61, 182, 57, 0, // Skip to: 19313
/* 4539 */    MCD::OPC_Decode, 164, 20, 206, 1, // Opcode: SSUBUW
/* 4544 */    MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 4559
/* 4549 */    MCD::OPC_CheckPredicate, 61, 167, 57, 0, // Skip to: 19313
/* 4554 */    MCD::OPC_Decode, 153, 20, 206, 1, // Opcode: SSLLW
/* 4559 */    MCD::OPC_FilterValue, 15, 157, 57, 0, // Skip to: 19313
/* 4564 */    MCD::OPC_CheckPredicate, 61, 152, 57, 0, // Skip to: 19313
/* 4569 */    MCD::OPC_Decode, 162, 20, 206, 1, // Opcode: SSRLW
/* 4574 */    MCD::OPC_FilterValue, 25, 183, 0, 0, // Skip to: 4762
/* 4579 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 4582 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 4597
/* 4587 */    MCD::OPC_CheckPredicate, 61, 129, 57, 0, // Skip to: 19313
/* 4592 */    MCD::OPC_Decode, 136, 17, 225, 1, // Opcode: PADDUSH
/* 4597 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 4612
/* 4602 */    MCD::OPC_CheckPredicate, 61, 114, 57, 0, // Skip to: 19313
/* 4607 */    MCD::OPC_Decode, 247, 17, 225, 1, // Opcode: PSUBUSH
/* 4612 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 4627
/* 4617 */    MCD::OPC_CheckPredicate, 61, 99, 57, 0, // Skip to: 19313
/* 4622 */    MCD::OPC_Decode, 131, 17, 206, 1, // Opcode: PACKSSWH
/* 4627 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 4642
/* 4632 */    MCD::OPC_CheckPredicate, 61, 84, 57, 0, // Skip to: 19313
/* 4637 */    MCD::OPC_Decode, 250, 17, 225, 1, // Opcode: PUNPCKHHW
/* 4642 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 4657
/* 4647 */    MCD::OPC_CheckPredicate, 61, 69, 57, 0, // Skip to: 19313
/* 4652 */    MCD::OPC_Decode, 147, 17, 225, 1, // Opcode: PAVGB
/* 4657 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 4672
/* 4662 */    MCD::OPC_CheckPredicate, 61, 54, 57, 0, // Skip to: 19313
/* 4667 */    MCD::OPC_Decode, 162, 17, 225, 1, // Opcode: PCMPGTW
/* 4672 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 4687
/* 4677 */    MCD::OPC_CheckPredicate, 61, 39, 57, 0, // Skip to: 19313
/* 4682 */    MCD::OPC_Decode, 235, 17, 225, 1, // Opcode: PSLLH
/* 4687 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 4702
/* 4692 */    MCD::OPC_CheckPredicate, 61, 24, 57, 0, // Skip to: 19313
/* 4697 */    MCD::OPC_Decode, 239, 17, 225, 1, // Opcode: PSRLH
/* 4702 */    MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 4717
/* 4707 */    MCD::OPC_CheckPredicate, 61, 9, 57, 0, // Skip to: 19313
/* 4712 */    MCD::OPC_Decode, 190, 17, 225, 1, // Opcode: POR
/* 4717 */    MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 4732
/* 4722 */    MCD::OPC_CheckPredicate, 61, 250, 56, 0, // Skip to: 19313
/* 4727 */    MCD::OPC_Decode, 143, 17, 225, 1, // Opcode: PASUBUB
/* 4732 */    MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 4747
/* 4737 */    MCD::OPC_CheckPredicate, 61, 235, 56, 0, // Skip to: 19313
/* 4742 */    MCD::OPC_Decode, 152, 20, 225, 1, // Opcode: SSLLD
/* 4747 */    MCD::OPC_FilterValue, 15, 225, 56, 0, // Skip to: 19313
/* 4752 */    MCD::OPC_CheckPredicate, 61, 220, 56, 0, // Skip to: 19313
/* 4757 */    MCD::OPC_Decode, 161, 20, 225, 1, // Opcode: SSRLD
/* 4762 */    MCD::OPC_FilterValue, 26, 183, 0, 0, // Skip to: 4950
/* 4767 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 4770 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 4785
/* 4775 */    MCD::OPC_CheckPredicate, 61, 197, 56, 0, // Skip to: 19313
/* 4780 */    MCD::OPC_Decode, 139, 17, 206, 1, // Opcode: PADD_H_LS
/* 4785 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 4800
/* 4790 */    MCD::OPC_CheckPredicate, 61, 182, 56, 0, // Skip to: 19313
/* 4795 */    MCD::OPC_Decode, 243, 17, 225, 1, // Opcode: PSUBH
/* 4800 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 4815
/* 4805 */    MCD::OPC_CheckPredicate, 61, 167, 56, 0, // Skip to: 19313
/* 4810 */    MCD::OPC_Decode, 130, 17, 206, 1, // Opcode: PACKSSHB
/* 4815 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 4830
/* 4820 */    MCD::OPC_CheckPredicate, 61, 152, 56, 0, // Skip to: 19313
/* 4825 */    MCD::OPC_Decode, 252, 17, 225, 1, // Opcode: PUNPCKLBH
/* 4830 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 4845
/* 4835 */    MCD::OPC_CheckPredicate, 61, 137, 56, 0, // Skip to: 19313
/* 4840 */    MCD::OPC_Decode, 179, 17, 225, 1, // Opcode: PMAXSH
/* 4845 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 4860
/* 4850 */    MCD::OPC_CheckPredicate, 61, 122, 56, 0, // Skip to: 19313
/* 4855 */    MCD::OPC_Decode, 158, 17, 225, 1, // Opcode: PCMPEQH
/* 4860 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 4875
/* 4865 */    MCD::OPC_CheckPredicate, 61, 107, 56, 0, // Skip to: 19313
/* 4870 */    MCD::OPC_Decode, 186, 17, 225, 1, // Opcode: PMULLH
/* 4875 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 4890
/* 4880 */    MCD::OPC_CheckPredicate, 61, 92, 56, 0, // Skip to: 19313
/* 4885 */    MCD::OPC_Decode, 238, 17, 225, 1, // Opcode: PSRAW
/* 4890 */    MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 4905
/* 4895 */    MCD::OPC_CheckPredicate, 61, 77, 56, 0, // Skip to: 19313
/* 4900 */    MCD::OPC_Decode, 179, 18, 206, 1, // Opcode: SADDW
/* 4905 */    MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 4920
/* 4910 */    MCD::OPC_CheckPredicate, 61, 62, 56, 0, // Skip to: 19313
/* 4915 */    MCD::OPC_Decode, 165, 20, 206, 1, // Opcode: SSUBW
/* 4920 */    MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 4935
/* 4925 */    MCD::OPC_CheckPredicate, 61, 47, 56, 0, // Skip to: 19313
/* 4930 */    MCD::OPC_Decode, 167, 17, 225, 1, // Opcode: PEXTRH
/* 4935 */    MCD::OPC_FilterValue, 15, 37, 56, 0, // Skip to: 19313
/* 4940 */    MCD::OPC_CheckPredicate, 61, 32, 56, 0, // Skip to: 19313
/* 4945 */    MCD::OPC_Decode, 160, 20, 206, 1, // Opcode: SSRAW
/* 4950 */    MCD::OPC_FilterValue, 27, 183, 0, 0, // Skip to: 5138
/* 4955 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 4958 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 4973
/* 4963 */    MCD::OPC_CheckPredicate, 61, 9, 56, 0, // Skip to: 19313
/* 4968 */    MCD::OPC_Decode, 140, 17, 206, 1, // Opcode: PADD_W_LS
/* 4973 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 4988
/* 4978 */    MCD::OPC_CheckPredicate, 61, 250, 55, 0, // Skip to: 19313
/* 4983 */    MCD::OPC_Decode, 248, 17, 225, 1, // Opcode: PSUBW
/* 4988 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 5003
/* 4993 */    MCD::OPC_CheckPredicate, 61, 235, 55, 0, // Skip to: 19313
/* 4998 */    MCD::OPC_Decode, 132, 17, 206, 1, // Opcode: PACKUSHB
/* 5003 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 5018
/* 5008 */    MCD::OPC_CheckPredicate, 61, 220, 55, 0, // Skip to: 19313
/* 5013 */    MCD::OPC_Decode, 249, 17, 225, 1, // Opcode: PUNPCKHBH
/* 5018 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 5033
/* 5023 */    MCD::OPC_CheckPredicate, 61, 205, 55, 0, // Skip to: 19313
/* 5028 */    MCD::OPC_Decode, 181, 17, 225, 1, // Opcode: PMINSH
/* 5033 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 5048
/* 5038 */    MCD::OPC_CheckPredicate, 61, 190, 55, 0, // Skip to: 19313
/* 5043 */    MCD::OPC_Decode, 161, 17, 225, 1, // Opcode: PCMPGTH
/* 5048 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 5063
/* 5053 */    MCD::OPC_CheckPredicate, 61, 175, 55, 0, // Skip to: 19313
/* 5058 */    MCD::OPC_Decode, 184, 17, 225, 1, // Opcode: PMULHH
/* 5063 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 5078
/* 5068 */    MCD::OPC_CheckPredicate, 61, 160, 55, 0, // Skip to: 19313
/* 5073 */    MCD::OPC_Decode, 237, 17, 225, 1, // Opcode: PSRAH
/* 5078 */    MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 5093
/* 5083 */    MCD::OPC_CheckPredicate, 61, 145, 55, 0, // Skip to: 19313
/* 5088 */    MCD::OPC_Decode, 207, 18, 225, 1, // Opcode: SDADDD
/* 5093 */    MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 5108
/* 5098 */    MCD::OPC_CheckPredicate, 61, 130, 55, 0, // Skip to: 19313
/* 5103 */    MCD::OPC_Decode, 163, 20, 225, 1, // Opcode: SSUBD
/* 5108 */    MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 5123
/* 5113 */    MCD::OPC_CheckPredicate, 61, 115, 55, 0, // Skip to: 19313
/* 5118 */    MCD::OPC_Decode, 178, 17, 225, 1, // Opcode: PMADDHW
/* 5123 */    MCD::OPC_FilterValue, 15, 105, 55, 0, // Skip to: 19313
/* 5128 */    MCD::OPC_CheckPredicate, 61, 100, 55, 0, // Skip to: 19313
/* 5133 */    MCD::OPC_Decode, 159, 20, 225, 1, // Opcode: SSRAD
/* 5138 */    MCD::OPC_FilterValue, 28, 211, 0, 0, // Skip to: 5354
/* 5143 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 5146 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 5161
/* 5151 */    MCD::OPC_CheckPredicate, 61, 77, 55, 0, // Skip to: 19313
/* 5156 */    MCD::OPC_Decode, 133, 17, 225, 1, // Opcode: PADDSB
/* 5161 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 5176
/* 5166 */    MCD::OPC_CheckPredicate, 61, 62, 55, 0, // Skip to: 19313
/* 5171 */    MCD::OPC_Decode, 244, 17, 225, 1, // Opcode: PSUBSB
/* 5176 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 5191
/* 5181 */    MCD::OPC_CheckPredicate, 61, 47, 55, 0, // Skip to: 19313
/* 5186 */    MCD::OPC_Decode, 255, 17, 225, 1, // Opcode: PXOR
/* 5191 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 5206
/* 5196 */    MCD::OPC_CheckPredicate, 61, 32, 55, 0, // Skip to: 19313
/* 5201 */    MCD::OPC_Decode, 172, 17, 225, 1, // Opcode: PINSRH_0
/* 5206 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 5221
/* 5211 */    MCD::OPC_CheckPredicate, 61, 17, 55, 0, // Skip to: 19313
/* 5216 */    MCD::OPC_Decode, 180, 17, 225, 1, // Opcode: PMAXUB
/* 5221 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 5236
/* 5226 */    MCD::OPC_CheckPredicate, 61, 2, 55, 0, // Skip to: 19313
/* 5231 */    MCD::OPC_Decode, 157, 17, 225, 1, // Opcode: PCMPEQB
/* 5236 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 5251
/* 5241 */    MCD::OPC_CheckPredicate, 61, 243, 54, 0, // Skip to: 19313
/* 5246 */    MCD::OPC_Decode, 187, 17, 225, 1, // Opcode: PMULUW
/* 5251 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 5266
/* 5256 */    MCD::OPC_CheckPredicate, 61, 228, 54, 0, // Skip to: 19313
/* 5261 */    MCD::OPC_Decode, 254, 17, 225, 1, // Opcode: PUNPCKLWD
/* 5266 */    MCD::OPC_FilterValue, 12, 17, 0, 0, // Skip to: 5288
/* 5271 */    MCD::OPC_CheckPredicate, 61, 213, 54, 0, // Skip to: 19313
/* 5276 */    MCD::OPC_CheckField, 6, 5, 0, 206, 54, 0, // Skip to: 19313
/* 5283 */    MCD::OPC_Decode, 149, 20, 226, 1, // Opcode: SSEQUD
/* 5288 */    MCD::OPC_FilterValue, 13, 17, 0, 0, // Skip to: 5310
/* 5293 */    MCD::OPC_CheckPredicate, 61, 191, 54, 0, // Skip to: 19313
/* 5298 */    MCD::OPC_CheckField, 6, 5, 0, 184, 54, 0, // Skip to: 19313
/* 5305 */    MCD::OPC_Decode, 155, 20, 226, 1, // Opcode: SSLTUD
/* 5310 */    MCD::OPC_FilterValue, 14, 17, 0, 0, // Skip to: 5332
/* 5315 */    MCD::OPC_CheckPredicate, 61, 169, 54, 0, // Skip to: 19313
/* 5320 */    MCD::OPC_CheckField, 6, 5, 0, 162, 54, 0, // Skip to: 19313
/* 5327 */    MCD::OPC_Decode, 151, 20, 226, 1, // Opcode: SSLEUD
/* 5332 */    MCD::OPC_FilterValue, 15, 152, 54, 0, // Skip to: 19313
/* 5337 */    MCD::OPC_CheckPredicate, 61, 147, 54, 0, // Skip to: 19313
/* 5342 */    MCD::OPC_CheckField, 16, 5, 0, 140, 54, 0, // Skip to: 19313
/* 5349 */    MCD::OPC_Decode, 128, 6, 227, 1, // Opcode: BIADD
/* 5354 */    MCD::OPC_FilterValue, 29, 211, 0, 0, // Skip to: 5570
/* 5359 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 5362 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 5377
/* 5367 */    MCD::OPC_CheckPredicate, 61, 117, 54, 0, // Skip to: 19313
/* 5372 */    MCD::OPC_Decode, 135, 17, 225, 1, // Opcode: PADDUSB
/* 5377 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 5392
/* 5382 */    MCD::OPC_CheckPredicate, 61, 102, 54, 0, // Skip to: 19313
/* 5387 */    MCD::OPC_Decode, 246, 17, 225, 1, // Opcode: PSUBUSB
/* 5392 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 5407
/* 5397 */    MCD::OPC_CheckPredicate, 61, 87, 54, 0, // Skip to: 19313
/* 5402 */    MCD::OPC_Decode, 188, 17, 225, 1, // Opcode: PNOR
/* 5407 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 5422
/* 5412 */    MCD::OPC_CheckPredicate, 61, 72, 54, 0, // Skip to: 19313
/* 5417 */    MCD::OPC_Decode, 173, 17, 225, 1, // Opcode: PINSRH_1
/* 5422 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 5437
/* 5427 */    MCD::OPC_CheckPredicate, 61, 57, 54, 0, // Skip to: 19313
/* 5432 */    MCD::OPC_Decode, 182, 17, 225, 1, // Opcode: PMINUB
/* 5437 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 5452
/* 5442 */    MCD::OPC_CheckPredicate, 61, 42, 54, 0, // Skip to: 19313
/* 5447 */    MCD::OPC_Decode, 160, 17, 225, 1, // Opcode: PCMPGTB
/* 5452 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 5467
/* 5457 */    MCD::OPC_CheckPredicate, 61, 27, 54, 0, // Skip to: 19313
/* 5462 */    MCD::OPC_Decode, 185, 17, 225, 1, // Opcode: PMULHUH
/* 5467 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 5482
/* 5472 */    MCD::OPC_CheckPredicate, 61, 12, 54, 0, // Skip to: 19313
/* 5477 */    MCD::OPC_Decode, 251, 17, 225, 1, // Opcode: PUNPCKHWD
/* 5482 */    MCD::OPC_FilterValue, 12, 17, 0, 0, // Skip to: 5504
/* 5487 */    MCD::OPC_CheckPredicate, 61, 253, 53, 0, // Skip to: 19313
/* 5492 */    MCD::OPC_CheckField, 6, 5, 0, 246, 53, 0, // Skip to: 19313
/* 5499 */    MCD::OPC_Decode, 148, 20, 226, 1, // Opcode: SSEQD
/* 5504 */    MCD::OPC_FilterValue, 13, 17, 0, 0, // Skip to: 5526
/* 5509 */    MCD::OPC_CheckPredicate, 61, 231, 53, 0, // Skip to: 19313
/* 5514 */    MCD::OPC_CheckField, 6, 5, 0, 224, 53, 0, // Skip to: 19313
/* 5521 */    MCD::OPC_Decode, 154, 20, 226, 1, // Opcode: SSLTD
/* 5526 */    MCD::OPC_FilterValue, 14, 17, 0, 0, // Skip to: 5548
/* 5531 */    MCD::OPC_CheckPredicate, 61, 209, 53, 0, // Skip to: 19313
/* 5536 */    MCD::OPC_CheckField, 6, 5, 0, 202, 53, 0, // Skip to: 19313
/* 5543 */    MCD::OPC_Decode, 150, 20, 226, 1, // Opcode: SSLED
/* 5548 */    MCD::OPC_FilterValue, 15, 192, 53, 0, // Skip to: 19313
/* 5553 */    MCD::OPC_CheckPredicate, 61, 187, 53, 0, // Skip to: 19313
/* 5558 */    MCD::OPC_CheckField, 16, 5, 0, 180, 53, 0, // Skip to: 19313
/* 5565 */    MCD::OPC_Decode, 183, 17, 227, 1, // Opcode: PMOVMSKB
/* 5570 */    MCD::OPC_FilterValue, 30, 63, 0, 0, // Skip to: 5638
/* 5575 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 5578 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 5593
/* 5583 */    MCD::OPC_CheckPredicate, 61, 157, 53, 0, // Skip to: 19313
/* 5588 */    MCD::OPC_Decode, 137, 17, 206, 1, // Opcode: PADD_B_LS
/* 5593 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 5608
/* 5598 */    MCD::OPC_CheckPredicate, 61, 142, 53, 0, // Skip to: 19313
/* 5603 */    MCD::OPC_Decode, 241, 17, 225, 1, // Opcode: PSUBB
/* 5608 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 5623
/* 5613 */    MCD::OPC_CheckPredicate, 61, 127, 53, 0, // Skip to: 19313
/* 5618 */    MCD::OPC_Decode, 141, 17, 225, 1, // Opcode: PAND
/* 5623 */    MCD::OPC_FilterValue, 3, 117, 53, 0, // Skip to: 19313
/* 5628 */    MCD::OPC_CheckPredicate, 61, 112, 53, 0, // Skip to: 19313
/* 5633 */    MCD::OPC_Decode, 174, 17, 225, 1, // Opcode: PINSRH_2
/* 5638 */    MCD::OPC_FilterValue, 31, 102, 53, 0, // Skip to: 19313
/* 5643 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 5646 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 5661
/* 5651 */    MCD::OPC_CheckPredicate, 61, 89, 53, 0, // Skip to: 19313
/* 5656 */    MCD::OPC_Decode, 138, 17, 225, 1, // Opcode: PADD_D_LS
/* 5661 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 5676
/* 5666 */    MCD::OPC_CheckPredicate, 61, 74, 53, 0, // Skip to: 19313
/* 5671 */    MCD::OPC_Decode, 242, 17, 225, 1, // Opcode: PSUBD
/* 5676 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 5691
/* 5681 */    MCD::OPC_CheckPredicate, 61, 59, 53, 0, // Skip to: 19313
/* 5686 */    MCD::OPC_Decode, 142, 17, 225, 1, // Opcode: PANDN
/* 5691 */    MCD::OPC_FilterValue, 3, 49, 53, 0, // Skip to: 19313
/* 5696 */    MCD::OPC_CheckPredicate, 61, 44, 53, 0, // Skip to: 19313
/* 5701 */    MCD::OPC_Decode, 175, 17, 225, 1, // Opcode: PINSRH_3
/* 5706 */    MCD::OPC_FilterValue, 19, 255, 0, 0, // Skip to: 5966
/* 5711 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 5714 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 5736
/* 5719 */    MCD::OPC_CheckPredicate, 62, 21, 53, 0, // Skip to: 19313
/* 5724 */    MCD::OPC_CheckField, 11, 5, 0, 14, 53, 0, // Skip to: 19313
/* 5731 */    MCD::OPC_Decode, 157, 14, 228, 1, // Opcode: LWXC1
/* 5736 */    MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 5758
/* 5741 */    MCD::OPC_CheckPredicate, 63, 255, 52, 0, // Skip to: 19313
/* 5746 */    MCD::OPC_CheckField, 11, 5, 0, 248, 52, 0, // Skip to: 19313
/* 5753 */    MCD::OPC_Decode, 207, 13, 229, 1, // Opcode: LDXC1
/* 5758 */    MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 5780
/* 5763 */    MCD::OPC_CheckPredicate, 64, 233, 52, 0, // Skip to: 19313
/* 5768 */    MCD::OPC_CheckField, 11, 5, 0, 226, 52, 0, // Skip to: 19313
/* 5775 */    MCD::OPC_Decode, 245, 13, 229, 1, // Opcode: LUXC1
/* 5780 */    MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 5802
/* 5785 */    MCD::OPC_CheckPredicate, 62, 211, 52, 0, // Skip to: 19313
/* 5790 */    MCD::OPC_CheckField, 6, 5, 0, 204, 52, 0, // Skip to: 19313
/* 5797 */    MCD::OPC_Decode, 133, 21, 230, 1, // Opcode: SWXC1
/* 5802 */    MCD::OPC_FilterValue, 9, 17, 0, 0, // Skip to: 5824
/* 5807 */    MCD::OPC_CheckPredicate, 63, 189, 52, 0, // Skip to: 19313
/* 5812 */    MCD::OPC_CheckField, 6, 5, 0, 182, 52, 0, // Skip to: 19313
/* 5819 */    MCD::OPC_Decode, 226, 18, 231, 1, // Opcode: SDXC1
/* 5824 */    MCD::OPC_FilterValue, 13, 17, 0, 0, // Skip to: 5846
/* 5829 */    MCD::OPC_CheckPredicate, 64, 167, 52, 0, // Skip to: 19313
/* 5834 */    MCD::OPC_CheckField, 6, 5, 0, 160, 52, 0, // Skip to: 19313
/* 5841 */    MCD::OPC_Decode, 228, 20, 231, 1, // Opcode: SUXC1
/* 5846 */    MCD::OPC_FilterValue, 32, 10, 0, 0, // Skip to: 5861
/* 5851 */    MCD::OPC_CheckPredicate, 65, 145, 52, 0, // Skip to: 19313
/* 5856 */    MCD::OPC_Decode, 198, 14, 232, 1, // Opcode: MADD_S
/* 5861 */    MCD::OPC_FilterValue, 33, 10, 0, 0, // Skip to: 5876
/* 5866 */    MCD::OPC_CheckPredicate, 66, 130, 52, 0, // Skip to: 19313
/* 5871 */    MCD::OPC_Decode, 190, 14, 233, 1, // Opcode: MADD_D32
/* 5876 */    MCD::OPC_FilterValue, 40, 10, 0, 0, // Skip to: 5891
/* 5881 */    MCD::OPC_CheckPredicate, 65, 115, 52, 0, // Skip to: 19313
/* 5886 */    MCD::OPC_Decode, 249, 15, 232, 1, // Opcode: MSUB_S
/* 5891 */    MCD::OPC_FilterValue, 41, 10, 0, 0, // Skip to: 5906
/* 5896 */    MCD::OPC_CheckPredicate, 66, 100, 52, 0, // Skip to: 19313
/* 5901 */    MCD::OPC_Decode, 241, 15, 233, 1, // Opcode: MSUB_D32
/* 5906 */    MCD::OPC_FilterValue, 48, 10, 0, 0, // Skip to: 5921
/* 5911 */    MCD::OPC_CheckPredicate, 67, 85, 52, 0, // Skip to: 19313
/* 5916 */    MCD::OPC_Decode, 226, 16, 232, 1, // Opcode: NMADD_S
/* 5921 */    MCD::OPC_FilterValue, 49, 10, 0, 0, // Skip to: 5936
/* 5926 */    MCD::OPC_CheckPredicate, 68, 70, 52, 0, // Skip to: 19313
/* 5931 */    MCD::OPC_Decode, 223, 16, 233, 1, // Opcode: NMADD_D32
/* 5936 */    MCD::OPC_FilterValue, 56, 10, 0, 0, // Skip to: 5951
/* 5941 */    MCD::OPC_CheckPredicate, 67, 55, 52, 0, // Skip to: 19313
/* 5946 */    MCD::OPC_Decode, 231, 16, 232, 1, // Opcode: NMSUB_S
/* 5951 */    MCD::OPC_FilterValue, 57, 45, 52, 0, // Skip to: 19313
/* 5956 */    MCD::OPC_CheckPredicate, 68, 40, 52, 0, // Skip to: 19313
/* 5961 */    MCD::OPC_Decode, 228, 16, 233, 1, // Opcode: NMSUB_D32
/* 5966 */    MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 5981
/* 5971 */    MCD::OPC_CheckPredicate, 39, 25, 52, 0, // Skip to: 19313
/* 5976 */    MCD::OPC_Decode, 218, 5, 188, 1, // Opcode: BEQL
/* 5981 */    MCD::OPC_FilterValue, 21, 107, 0, 0, // Skip to: 6093
/* 5986 */    MCD::OPC_ExtractField, 0, 16,  // Inst{15-0} ...
/* 5989 */    MCD::OPC_FilterValue, 123, 9, 0, 0, // Skip to: 6003
/* 5994 */    MCD::OPC_CheckPredicate, 18, 19, 0, 0, // Skip to: 6018
/* 5999 */    MCD::OPC_Decode, 211, 11, 112, // Opcode: FMOV_S_MM
/* 6003 */    MCD::OPC_FilterValue, 251, 22, 9, 0, 0, // Skip to: 6018
/* 6009 */    MCD::OPC_CheckPredicate, 18, 4, 0, 0, // Skip to: 6018
/* 6014 */    MCD::OPC_Decode, 229, 11, 112, // Opcode: FNEG_S_MM
/* 6018 */    MCD::OPC_ExtractField, 0, 11,  // Inst{10-0} ...
/* 6021 */    MCD::OPC_FilterValue, 48, 10, 0, 0, // Skip to: 6036
/* 6026 */    MCD::OPC_CheckPredicate, 18, 52, 0, 0, // Skip to: 6083
/* 6031 */    MCD::OPC_Decode, 250, 10, 151, 1, // Opcode: FADD_S_MM
/* 6036 */    MCD::OPC_FilterValue, 112, 10, 0, 0, // Skip to: 6051
/* 6041 */    MCD::OPC_CheckPredicate, 18, 37, 0, 0, // Skip to: 6083
/* 6046 */    MCD::OPC_Decode, 136, 12, 151, 1, // Opcode: FSUB_S_MM
/* 6051 */    MCD::OPC_FilterValue, 176, 1, 10, 0, 0, // Skip to: 6067
/* 6057 */    MCD::OPC_CheckPredicate, 18, 21, 0, 0, // Skip to: 6083
/* 6062 */    MCD::OPC_Decode, 221, 11, 151, 1, // Opcode: FMUL_S_MM
/* 6067 */    MCD::OPC_FilterValue, 240, 1, 10, 0, 0, // Skip to: 6083
/* 6073 */    MCD::OPC_CheckPredicate, 18, 5, 0, 0, // Skip to: 6083
/* 6078 */    MCD::OPC_Decode, 160, 11, 151, 1, // Opcode: FDIV_S_MM
/* 6083 */    MCD::OPC_CheckPredicate, 39, 169, 51, 0, // Skip to: 19313
/* 6088 */    MCD::OPC_Decode, 194, 6, 188, 1, // Opcode: BNEL
/* 6093 */    MCD::OPC_FilterValue, 22, 17, 0, 0, // Skip to: 6115
/* 6098 */    MCD::OPC_CheckPredicate, 39, 154, 51, 0, // Skip to: 19313
/* 6103 */    MCD::OPC_CheckField, 16, 5, 0, 147, 51, 0, // Skip to: 19313
/* 6110 */    MCD::OPC_Decode, 156, 6, 184, 1, // Opcode: BLEZL
/* 6115 */    MCD::OPC_FilterValue, 23, 17, 0, 0, // Skip to: 6137
/* 6120 */    MCD::OPC_CheckPredicate, 39, 132, 51, 0, // Skip to: 19313
/* 6125 */    MCD::OPC_CheckField, 16, 5, 0, 125, 51, 0, // Skip to: 19313
/* 6132 */    MCD::OPC_Decode, 254, 5, 184, 1, // Opcode: BGTZL
/* 6137 */    MCD::OPC_FilterValue, 28, 46, 3, 0, // Skip to: 6956
/* 6142 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 6145 */    MCD::OPC_FilterValue, 0, 42, 0, 0, // Skip to: 6192
/* 6150 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 6153 */    MCD::OPC_FilterValue, 0, 99, 51, 0, // Skip to: 19313
/* 6158 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 6161 */    MCD::OPC_FilterValue, 0, 91, 51, 0, // Skip to: 19313
/* 6166 */    MCD::OPC_CheckPredicate, 69, 11, 0, 0, // Skip to: 6182
/* 6171 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 6182
/* 6178 */    MCD::OPC_Decode, 175, 14, 68, // Opcode: MADD
/* 6182 */    MCD::OPC_CheckPredicate, 37, 70, 51, 0, // Skip to: 19313
/* 6187 */    MCD::OPC_Decode, 193, 14, 234, 1, // Opcode: MADD_DSP
/* 6192 */    MCD::OPC_FilterValue, 1, 42, 0, 0, // Skip to: 6239
/* 6197 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 6200 */    MCD::OPC_FilterValue, 0, 52, 51, 0, // Skip to: 19313
/* 6205 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 6208 */    MCD::OPC_FilterValue, 0, 44, 51, 0, // Skip to: 19313
/* 6213 */    MCD::OPC_CheckPredicate, 69, 11, 0, 0, // Skip to: 6229
/* 6218 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 6229
/* 6225 */    MCD::OPC_Decode, 182, 14, 68, // Opcode: MADDU
/* 6229 */    MCD::OPC_CheckPredicate, 37, 23, 51, 0, // Skip to: 19313
/* 6234 */    MCD::OPC_Decode, 183, 14, 234, 1, // Opcode: MADDU_DSP
/* 6239 */    MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 6260
/* 6244 */    MCD::OPC_CheckPredicate, 69, 8, 51, 0, // Skip to: 19313
/* 6249 */    MCD::OPC_CheckField, 6, 5, 0, 1, 51, 0, // Skip to: 19313
/* 6256 */    MCD::OPC_Decode, 165, 16, 49, // Opcode: MUL
/* 6260 */    MCD::OPC_FilterValue, 3, 16, 0, 0, // Skip to: 6281
/* 6265 */    MCD::OPC_CheckPredicate, 41, 243, 50, 0, // Skip to: 19313
/* 6270 */    MCD::OPC_CheckField, 6, 5, 18, 236, 50, 0, // Skip to: 19313
/* 6277 */    MCD::OPC_Decode, 163, 12, 12, // Opcode: GSANDN
/* 6281 */    MCD::OPC_FilterValue, 4, 42, 0, 0, // Skip to: 6328
/* 6286 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 6289 */    MCD::OPC_FilterValue, 0, 219, 50, 0, // Skip to: 19313
/* 6294 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 6297 */    MCD::OPC_FilterValue, 0, 211, 50, 0, // Skip to: 19313
/* 6302 */    MCD::OPC_CheckPredicate, 69, 11, 0, 0, // Skip to: 6318
/* 6307 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 6318
/* 6314 */    MCD::OPC_Decode, 226, 15, 68, // Opcode: MSUB
/* 6318 */    MCD::OPC_CheckPredicate, 37, 190, 50, 0, // Skip to: 19313
/* 6323 */    MCD::OPC_Decode, 244, 15, 234, 1, // Opcode: MSUB_DSP
/* 6328 */    MCD::OPC_FilterValue, 5, 42, 0, 0, // Skip to: 6375
/* 6333 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 6336 */    MCD::OPC_FilterValue, 0, 172, 50, 0, // Skip to: 19313
/* 6341 */    MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 6344 */    MCD::OPC_FilterValue, 0, 164, 50, 0, // Skip to: 19313
/* 6349 */    MCD::OPC_CheckPredicate, 69, 11, 0, 0, // Skip to: 6365
/* 6354 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 6365
/* 6361 */    MCD::OPC_Decode, 233, 15, 68, // Opcode: MSUBU
/* 6365 */    MCD::OPC_CheckPredicate, 37, 143, 50, 0, // Skip to: 19313
/* 6370 */    MCD::OPC_Decode, 234, 15, 234, 1, // Opcode: MSUBU_DSP
/* 6375 */    MCD::OPC_FilterValue, 6, 16, 0, 0, // Skip to: 6396
/* 6380 */    MCD::OPC_CheckPredicate, 41, 128, 50, 0, // Skip to: 19313
/* 6385 */    MCD::OPC_CheckField, 6, 5, 18, 121, 50, 0, // Skip to: 19313
/* 6392 */    MCD::OPC_Decode, 201, 12, 12, // Opcode: GSORN
/* 6396 */    MCD::OPC_FilterValue, 16, 16, 0, 0, // Skip to: 6417
/* 6401 */    MCD::OPC_CheckPredicate, 41, 107, 50, 0, // Skip to: 19313
/* 6406 */    MCD::OPC_CheckField, 6, 5, 0, 100, 50, 0, // Skip to: 19313
/* 6413 */    MCD::OPC_Decode, 197, 12, 12, // Opcode: GSMULT
/* 6417 */    MCD::OPC_FilterValue, 17, 16, 0, 0, // Skip to: 6438
/* 6422 */    MCD::OPC_CheckPredicate, 41, 86, 50, 0, // Skip to: 19313
/* 6427 */    MCD::OPC_CheckField, 6, 5, 0, 79, 50, 0, // Skip to: 19313
/* 6434 */    MCD::OPC_Decode, 171, 12, 12, // Opcode: GSDMULT
/* 6438 */    MCD::OPC_FilterValue, 18, 16, 0, 0, // Skip to: 6459
/* 6443 */    MCD::OPC_CheckPredicate, 41, 65, 50, 0, // Skip to: 19313
/* 6448 */    MCD::OPC_CheckField, 6, 5, 0, 58, 50, 0, // Skip to: 19313
/* 6455 */    MCD::OPC_Decode, 200, 12, 12, // Opcode: GSMULTU
/* 6459 */    MCD::OPC_FilterValue, 19, 16, 0, 0, // Skip to: 6480
/* 6464 */    MCD::OPC_CheckPredicate, 41, 44, 50, 0, // Skip to: 19313
/* 6469 */    MCD::OPC_CheckField, 6, 5, 0, 37, 50, 0, // Skip to: 19313
/* 6476 */    MCD::OPC_Decode, 174, 12, 12, // Opcode: GSDMULTU
/* 6480 */    MCD::OPC_FilterValue, 20, 16, 0, 0, // Skip to: 6501
/* 6485 */    MCD::OPC_CheckPredicate, 41, 23, 50, 0, // Skip to: 19313
/* 6490 */    MCD::OPC_CheckField, 6, 5, 0, 16, 50, 0, // Skip to: 19313
/* 6497 */    MCD::OPC_Decode, 167, 12, 49, // Opcode: GSDIV
/* 6501 */    MCD::OPC_FilterValue, 21, 16, 0, 0, // Skip to: 6522
/* 6506 */    MCD::OPC_CheckPredicate, 41, 2, 50, 0, // Skip to: 19313
/* 6511 */    MCD::OPC_CheckField, 6, 5, 0, 251, 49, 0, // Skip to: 19313
/* 6518 */    MCD::OPC_Decode, 165, 12, 12, // Opcode: GSDDIV
/* 6522 */    MCD::OPC_FilterValue, 22, 16, 0, 0, // Skip to: 6543
/* 6527 */    MCD::OPC_CheckPredicate, 41, 237, 49, 0, // Skip to: 19313
/* 6532 */    MCD::OPC_CheckField, 6, 5, 0, 230, 49, 0, // Skip to: 19313
/* 6539 */    MCD::OPC_Decode, 168, 12, 49, // Opcode: GSDIVU
/* 6543 */    MCD::OPC_FilterValue, 23, 16, 0, 0, // Skip to: 6564
/* 6548 */    MCD::OPC_CheckPredicate, 41, 216, 49, 0, // Skip to: 19313
/* 6553 */    MCD::OPC_CheckField, 6, 5, 0, 209, 49, 0, // Skip to: 19313
/* 6560 */    MCD::OPC_Decode, 166, 12, 12, // Opcode: GSDDIVU
/* 6564 */    MCD::OPC_FilterValue, 24, 16, 0, 0, // Skip to: 6585
/* 6569 */    MCD::OPC_CheckPredicate, 41, 195, 49, 0, // Skip to: 19313
/* 6574 */    MCD::OPC_CheckField, 6, 5, 0, 188, 49, 0, // Skip to: 19313
/* 6581 */    MCD::OPC_Decode, 172, 12, 12, // Opcode: GSDMULTH
/* 6585 */    MCD::OPC_FilterValue, 25, 16, 0, 0, // Skip to: 6606
/* 6590 */    MCD::OPC_CheckPredicate, 41, 174, 49, 0, // Skip to: 19313
/* 6595 */    MCD::OPC_CheckField, 6, 5, 0, 167, 49, 0, // Skip to: 19313
/* 6602 */    MCD::OPC_Decode, 173, 12, 12, // Opcode: GSDMULTHU
/* 6606 */    MCD::OPC_FilterValue, 26, 16, 0, 0, // Skip to: 6627
/* 6611 */    MCD::OPC_CheckPredicate, 41, 153, 49, 0, // Skip to: 19313
/* 6616 */    MCD::OPC_CheckField, 6, 5, 0, 146, 49, 0, // Skip to: 19313
/* 6623 */    MCD::OPC_Decode, 198, 12, 12, // Opcode: GSMULTH
/* 6627 */    MCD::OPC_FilterValue, 27, 16, 0, 0, // Skip to: 6648
/* 6632 */    MCD::OPC_CheckPredicate, 41, 132, 49, 0, // Skip to: 19313
/* 6637 */    MCD::OPC_CheckField, 6, 5, 0, 125, 49, 0, // Skip to: 19313
/* 6644 */    MCD::OPC_Decode, 199, 12, 12, // Opcode: GSMULTHU
/* 6648 */    MCD::OPC_FilterValue, 28, 16, 0, 0, // Skip to: 6669
/* 6653 */    MCD::OPC_CheckPredicate, 41, 111, 49, 0, // Skip to: 19313
/* 6658 */    MCD::OPC_CheckField, 6, 5, 0, 104, 49, 0, // Skip to: 19313
/* 6665 */    MCD::OPC_Decode, 195, 12, 12, // Opcode: GSMOD
/* 6669 */    MCD::OPC_FilterValue, 29, 16, 0, 0, // Skip to: 6690
/* 6674 */    MCD::OPC_CheckPredicate, 41, 90, 49, 0, // Skip to: 19313
/* 6679 */    MCD::OPC_CheckField, 6, 5, 0, 83, 49, 0, // Skip to: 19313
/* 6686 */    MCD::OPC_Decode, 169, 12, 12, // Opcode: GSDMOD
/* 6690 */    MCD::OPC_FilterValue, 30, 16, 0, 0, // Skip to: 6711
/* 6695 */    MCD::OPC_CheckPredicate, 41, 69, 49, 0, // Skip to: 19313
/* 6700 */    MCD::OPC_CheckField, 6, 5, 0, 62, 49, 0, // Skip to: 19313
/* 6707 */    MCD::OPC_Decode, 196, 12, 12, // Opcode: GSMODU
/* 6711 */    MCD::OPC_FilterValue, 31, 16, 0, 0, // Skip to: 6732
/* 6716 */    MCD::OPC_CheckPredicate, 41, 48, 49, 0, // Skip to: 19313
/* 6721 */    MCD::OPC_CheckField, 6, 5, 0, 41, 49, 0, // Skip to: 19313
/* 6728 */    MCD::OPC_Decode, 170, 12, 12, // Opcode: GSDMODU
/* 6732 */    MCD::OPC_FilterValue, 32, 17, 0, 0, // Skip to: 6754
/* 6737 */    MCD::OPC_CheckPredicate, 69, 27, 49, 0, // Skip to: 19313
/* 6742 */    MCD::OPC_CheckField, 6, 5, 0, 20, 49, 0, // Skip to: 19313
/* 6749 */    MCD::OPC_Decode, 192, 7, 235, 1, // Opcode: CLZ
/* 6754 */    MCD::OPC_FilterValue, 33, 17, 0, 0, // Skip to: 6776
/* 6759 */    MCD::OPC_CheckPredicate, 69, 5, 49, 0, // Skip to: 19313
/* 6764 */    MCD::OPC_CheckField, 6, 5, 0, 254, 48, 0, // Skip to: 19313
/* 6771 */    MCD::OPC_Decode, 172, 7, 235, 1, // Opcode: CLO
/* 6776 */    MCD::OPC_FilterValue, 34, 87, 0, 0, // Skip to: 6868
/* 6781 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 6784 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 6805
/* 6789 */    MCD::OPC_CheckPredicate, 41, 231, 48, 0, // Skip to: 19313
/* 6794 */    MCD::OPC_CheckField, 16, 5, 0, 224, 48, 0, // Skip to: 19313
/* 6801 */    MCD::OPC_Decode, 176, 8, 14, // Opcode: CTZ
/* 6805 */    MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 6826
/* 6810 */    MCD::OPC_CheckPredicate, 41, 210, 48, 0, // Skip to: 19313
/* 6815 */    MCD::OPC_CheckField, 16, 5, 0, 203, 48, 0, // Skip to: 19313
/* 6822 */    MCD::OPC_Decode, 175, 8, 14, // Opcode: CTO
/* 6826 */    MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 6847
/* 6831 */    MCD::OPC_CheckPredicate, 41, 189, 48, 0, // Skip to: 19313
/* 6836 */    MCD::OPC_CheckField, 16, 5, 0, 182, 48, 0, // Skip to: 19313
/* 6843 */    MCD::OPC_Decode, 197, 9, 15, // Opcode: DCTZ
/* 6847 */    MCD::OPC_FilterValue, 3, 173, 48, 0, // Skip to: 19313
/* 6852 */    MCD::OPC_CheckPredicate, 41, 168, 48, 0, // Skip to: 19313
/* 6857 */    MCD::OPC_CheckField, 16, 5, 0, 161, 48, 0, // Skip to: 19313
/* 6864 */    MCD::OPC_Decode, 196, 9, 15, // Opcode: DCTO
/* 6868 */    MCD::OPC_FilterValue, 38, 17, 0, 0, // Skip to: 6890
/* 6873 */    MCD::OPC_CheckPredicate, 41, 147, 48, 0, // Skip to: 19313
/* 6878 */    MCD::OPC_CheckField, 6, 10, 0, 140, 48, 0, // Skip to: 19313
/* 6885 */    MCD::OPC_Decode, 185, 12, 236, 1, // Opcode: GSLE
/* 6890 */    MCD::OPC_FilterValue, 39, 17, 0, 0, // Skip to: 6912
/* 6895 */    MCD::OPC_CheckPredicate, 41, 125, 48, 0, // Skip to: 19313
/* 6900 */    MCD::OPC_CheckField, 6, 10, 0, 118, 48, 0, // Skip to: 19313
/* 6907 */    MCD::OPC_Decode, 175, 12, 236, 1, // Opcode: GSGT
/* 6912 */    MCD::OPC_FilterValue, 43, 24, 0, 0, // Skip to: 6941
/* 6917 */    MCD::OPC_CheckPredicate, 41, 103, 48, 0, // Skip to: 19313
/* 6922 */    MCD::OPC_CheckField, 16, 10, 0, 96, 48, 0, // Skip to: 19313
/* 6929 */    MCD::OPC_CheckField, 6, 5, 0, 89, 48, 0, // Skip to: 19313
/* 6936 */    MCD::OPC_Decode, 183, 12, 237, 1, // Opcode: GSLDPC
/* 6941 */    MCD::OPC_FilterValue, 63, 79, 48, 0, // Skip to: 19313
/* 6946 */    MCD::OPC_CheckPredicate, 69, 74, 48, 0, // Skip to: 19313
/* 6951 */    MCD::OPC_Decode, 208, 18, 175, 1, // Opcode: SDBBP
/* 6956 */    MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 6971
/* 6961 */    MCD::OPC_CheckPredicate, 69, 59, 48, 0, // Skip to: 19313
/* 6966 */    MCD::OPC_Decode, 148, 13, 187, 1, // Opcode: JALX
/* 6971 */    MCD::OPC_FilterValue, 30, 201, 32, 0, // Skip to: 15369
/* 6976 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 6979 */    MCD::OPC_FilterValue, 0, 63, 0, 0, // Skip to: 7047
/* 6984 */    MCD::OPC_ExtractField, 24, 2,  // Inst{25-24} ...
/* 6987 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 7002
/* 6992 */    MCD::OPC_CheckPredicate, 30, 28, 48, 0, // Skip to: 19313
/* 6997 */    MCD::OPC_Decode, 130, 5, 238, 1, // Opcode: ANDI_B
/* 7002 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 7017
/* 7007 */    MCD::OPC_CheckPredicate, 30, 13, 48, 0, // Skip to: 19313
/* 7012 */    MCD::OPC_Decode, 247, 16, 238, 1, // Opcode: ORI_B
/* 7017 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 7032
/* 7022 */    MCD::OPC_CheckPredicate, 30, 254, 47, 0, // Skip to: 19313
/* 7027 */    MCD::OPC_Decode, 235, 16, 238, 1, // Opcode: NORI_B
/* 7032 */    MCD::OPC_FilterValue, 3, 244, 47, 0, // Skip to: 19313
/* 7037 */    MCD::OPC_CheckPredicate, 30, 239, 47, 0, // Skip to: 19313
/* 7042 */    MCD::OPC_Decode, 247, 21, 238, 1, // Opcode: XORI_B
/* 7047 */    MCD::OPC_FilterValue, 1, 48, 0, 0, // Skip to: 7100
/* 7052 */    MCD::OPC_ExtractField, 24, 2,  // Inst{25-24} ...
/* 7055 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 7070
/* 7060 */    MCD::OPC_CheckPredicate, 30, 216, 47, 0, // Skip to: 19313
/* 7065 */    MCD::OPC_Decode, 177, 6, 239, 1, // Opcode: BMNZI_B
/* 7070 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 7085
/* 7075 */    MCD::OPC_CheckPredicate, 30, 201, 47, 0, // Skip to: 19313
/* 7080 */    MCD::OPC_Decode, 179, 6, 239, 1, // Opcode: BMZI_B
/* 7085 */    MCD::OPC_FilterValue, 2, 191, 47, 0, // Skip to: 19313
/* 7090 */    MCD::OPC_CheckPredicate, 30, 186, 47, 0, // Skip to: 19313
/* 7095 */    MCD::OPC_Decode, 221, 6, 239, 1, // Opcode: BSELI_B
/* 7100 */    MCD::OPC_FilterValue, 2, 48, 0, 0, // Skip to: 7153
/* 7105 */    MCD::OPC_ExtractField, 24, 2,  // Inst{25-24} ...
/* 7108 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 7123
/* 7113 */    MCD::OPC_CheckPredicate, 30, 163, 47, 0, // Skip to: 19313
/* 7118 */    MCD::OPC_Decode, 132, 19, 238, 1, // Opcode: SHF_B
/* 7123 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 7138
/* 7128 */    MCD::OPC_CheckPredicate, 30, 148, 47, 0, // Skip to: 19313
/* 7133 */    MCD::OPC_Decode, 133, 19, 240, 1, // Opcode: SHF_H
/* 7138 */    MCD::OPC_FilterValue, 2, 138, 47, 0, // Skip to: 19313
/* 7143 */    MCD::OPC_CheckPredicate, 30, 133, 47, 0, // Skip to: 19313
/* 7148 */    MCD::OPC_Decode, 134, 19, 241, 1, // Opcode: SHF_W
/* 7153 */    MCD::OPC_FilterValue, 6, 107, 1, 0, // Skip to: 7521
/* 7158 */    MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 7161 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 7176
/* 7166 */    MCD::OPC_CheckPredicate, 30, 110, 47, 0, // Skip to: 19313
/* 7171 */    MCD::OPC_Decode, 226, 4, 242, 1, // Opcode: ADDVI_B
/* 7176 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 7191
/* 7181 */    MCD::OPC_CheckPredicate, 30, 95, 47, 0, // Skip to: 19313
/* 7186 */    MCD::OPC_Decode, 228, 4, 243, 1, // Opcode: ADDVI_H
/* 7191 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 7206
/* 7196 */    MCD::OPC_CheckPredicate, 30, 80, 47, 0, // Skip to: 19313
/* 7201 */    MCD::OPC_Decode, 229, 4, 244, 1, // Opcode: ADDVI_W
/* 7206 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 7221
/* 7211 */    MCD::OPC_CheckPredicate, 30, 65, 47, 0, // Skip to: 19313
/* 7216 */    MCD::OPC_Decode, 227, 4, 245, 1, // Opcode: ADDVI_D
/* 7221 */    MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 7236
/* 7226 */    MCD::OPC_CheckPredicate, 30, 50, 47, 0, // Skip to: 19313
/* 7231 */    MCD::OPC_Decode, 216, 20, 242, 1, // Opcode: SUBVI_B
/* 7236 */    MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 7251
/* 7241 */    MCD::OPC_CheckPredicate, 30, 35, 47, 0, // Skip to: 19313
/* 7246 */    MCD::OPC_Decode, 218, 20, 243, 1, // Opcode: SUBVI_H
/* 7251 */    MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 7266
/* 7256 */    MCD::OPC_CheckPredicate, 30, 20, 47, 0, // Skip to: 19313
/* 7261 */    MCD::OPC_Decode, 219, 20, 244, 1, // Opcode: SUBVI_W
/* 7266 */    MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 7281
/* 7271 */    MCD::OPC_CheckPredicate, 30, 5, 47, 0, // Skip to: 19313
/* 7276 */    MCD::OPC_Decode, 217, 20, 245, 1, // Opcode: SUBVI_D
/* 7281 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 7296
/* 7286 */    MCD::OPC_CheckPredicate, 30, 246, 46, 0, // Skip to: 19313
/* 7291 */    MCD::OPC_Decode, 212, 14, 242, 1, // Opcode: MAXI_S_B
/* 7296 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 7311
/* 7301 */    MCD::OPC_CheckPredicate, 30, 231, 46, 0, // Skip to: 19313
/* 7306 */    MCD::OPC_Decode, 214, 14, 243, 1, // Opcode: MAXI_S_H
/* 7311 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 7326
/* 7316 */    MCD::OPC_CheckPredicate, 30, 216, 46, 0, // Skip to: 19313
/* 7321 */    MCD::OPC_Decode, 215, 14, 244, 1, // Opcode: MAXI_S_W
/* 7326 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 7341
/* 7331 */    MCD::OPC_CheckPredicate, 30, 201, 46, 0, // Skip to: 19313
/* 7336 */    MCD::OPC_Decode, 213, 14, 245, 1, // Opcode: MAXI_S_D
/* 7341 */    MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 7356
/* 7346 */    MCD::OPC_CheckPredicate, 30, 186, 46, 0, // Skip to: 19313
/* 7351 */    MCD::OPC_Decode, 216, 14, 242, 1, // Opcode: MAXI_U_B
/* 7356 */    MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 7371
/* 7361 */    MCD::OPC_CheckPredicate, 30, 171, 46, 0, // Skip to: 19313
/* 7366 */    MCD::OPC_Decode, 218, 14, 243, 1, // Opcode: MAXI_U_H
/* 7371 */    MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 7386
/* 7376 */    MCD::OPC_CheckPredicate, 30, 156, 46, 0, // Skip to: 19313
/* 7381 */    MCD::OPC_Decode, 219, 14, 244, 1, // Opcode: MAXI_U_W
/* 7386 */    MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 7401
/* 7391 */    MCD::OPC_CheckPredicate, 30, 141, 46, 0, // Skip to: 19313
/* 7396 */    MCD::OPC_Decode, 217, 14, 245, 1, // Opcode: MAXI_U_D
/* 7401 */    MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 7416
/* 7406 */    MCD::OPC_CheckPredicate, 30, 126, 46, 0, // Skip to: 19313
/* 7411 */    MCD::OPC_Decode, 143, 15, 242, 1, // Opcode: MINI_S_B
/* 7416 */    MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 7431
/* 7421 */    MCD::OPC_CheckPredicate, 30, 111, 46, 0, // Skip to: 19313
/* 7426 */    MCD::OPC_Decode, 145, 15, 243, 1, // Opcode: MINI_S_H
/* 7431 */    MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 7446
/* 7436 */    MCD::OPC_CheckPredicate, 30, 96, 46, 0, // Skip to: 19313
/* 7441 */    MCD::OPC_Decode, 146, 15, 244, 1, // Opcode: MINI_S_W
/* 7446 */    MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 7461
/* 7451 */    MCD::OPC_CheckPredicate, 30, 81, 46, 0, // Skip to: 19313
/* 7456 */    MCD::OPC_Decode, 144, 15, 245, 1, // Opcode: MINI_S_D
/* 7461 */    MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 7476
/* 7466 */    MCD::OPC_CheckPredicate, 30, 66, 46, 0, // Skip to: 19313
/* 7471 */    MCD::OPC_Decode, 147, 15, 242, 1, // Opcode: MINI_U_B
/* 7476 */    MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 7491
/* 7481 */    MCD::OPC_CheckPredicate, 30, 51, 46, 0, // Skip to: 19313
/* 7486 */    MCD::OPC_Decode, 149, 15, 243, 1, // Opcode: MINI_U_H
/* 7491 */    MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 7506
/* 7496 */    MCD::OPC_CheckPredicate, 30, 36, 46, 0, // Skip to: 19313
/* 7501 */    MCD::OPC_Decode, 150, 15, 244, 1, // Opcode: MINI_U_W
/* 7506 */    MCD::OPC_FilterValue, 23, 26, 46, 0, // Skip to: 19313
/* 7511 */    MCD::OPC_CheckPredicate, 30, 21, 46, 0, // Skip to: 19313
/* 7516 */    MCD::OPC_Decode, 148, 15, 245, 1, // Opcode: MINI_U_D
/* 7521 */    MCD::OPC_FilterValue, 7, 107, 1, 0, // Skip to: 7889
/* 7526 */    MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 7529 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 7544
/* 7534 */    MCD::OPC_CheckPredicate, 30, 254, 45, 0, // Skip to: 19313
/* 7539 */    MCD::OPC_Decode, 136, 7, 242, 1, // Opcode: CEQI_B
/* 7544 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 7559
/* 7549 */    MCD::OPC_CheckPredicate, 30, 239, 45, 0, // Skip to: 19313
/* 7554 */    MCD::OPC_Decode, 138, 7, 243, 1, // Opcode: CEQI_H
/* 7559 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 7574
/* 7564 */    MCD::OPC_CheckPredicate, 30, 224, 45, 0, // Skip to: 19313
/* 7569 */    MCD::OPC_Decode, 139, 7, 244, 1, // Opcode: CEQI_W
/* 7574 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 7589
/* 7579 */    MCD::OPC_CheckPredicate, 30, 209, 45, 0, // Skip to: 19313
/* 7584 */    MCD::OPC_Decode, 137, 7, 245, 1, // Opcode: CEQI_D
/* 7589 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 7604
/* 7594 */    MCD::OPC_CheckPredicate, 30, 194, 45, 0, // Skip to: 19313
/* 7599 */    MCD::OPC_Decode, 176, 7, 242, 1, // Opcode: CLTI_S_B
/* 7604 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 7619
/* 7609 */    MCD::OPC_CheckPredicate, 30, 179, 45, 0, // Skip to: 19313
/* 7614 */    MCD::OPC_Decode, 178, 7, 243, 1, // Opcode: CLTI_S_H
/* 7619 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 7634
/* 7624 */    MCD::OPC_CheckPredicate, 30, 164, 45, 0, // Skip to: 19313
/* 7629 */    MCD::OPC_Decode, 179, 7, 244, 1, // Opcode: CLTI_S_W
/* 7634 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 7649
/* 7639 */    MCD::OPC_CheckPredicate, 30, 149, 45, 0, // Skip to: 19313
/* 7644 */    MCD::OPC_Decode, 177, 7, 245, 1, // Opcode: CLTI_S_D
/* 7649 */    MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 7664
/* 7654 */    MCD::OPC_CheckPredicate, 30, 134, 45, 0, // Skip to: 19313
/* 7659 */    MCD::OPC_Decode, 180, 7, 242, 1, // Opcode: CLTI_U_B
/* 7664 */    MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 7679
/* 7669 */    MCD::OPC_CheckPredicate, 30, 119, 45, 0, // Skip to: 19313
/* 7674 */    MCD::OPC_Decode, 182, 7, 243, 1, // Opcode: CLTI_U_H
/* 7679 */    MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 7694
/* 7684 */    MCD::OPC_CheckPredicate, 30, 104, 45, 0, // Skip to: 19313
/* 7689 */    MCD::OPC_Decode, 183, 7, 244, 1, // Opcode: CLTI_U_W
/* 7694 */    MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 7709
/* 7699 */    MCD::OPC_CheckPredicate, 30, 89, 45, 0, // Skip to: 19313
/* 7704 */    MCD::OPC_Decode, 181, 7, 245, 1, // Opcode: CLTI_U_D
/* 7709 */    MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 7724
/* 7714 */    MCD::OPC_CheckPredicate, 30, 74, 45, 0, // Skip to: 19313
/* 7719 */    MCD::OPC_Decode, 156, 7, 242, 1, // Opcode: CLEI_S_B
/* 7724 */    MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 7739
/* 7729 */    MCD::OPC_CheckPredicate, 30, 59, 45, 0, // Skip to: 19313
/* 7734 */    MCD::OPC_Decode, 158, 7, 243, 1, // Opcode: CLEI_S_H
/* 7739 */    MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 7754
/* 7744 */    MCD::OPC_CheckPredicate, 30, 44, 45, 0, // Skip to: 19313
/* 7749 */    MCD::OPC_Decode, 159, 7, 244, 1, // Opcode: CLEI_S_W
/* 7754 */    MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 7769
/* 7759 */    MCD::OPC_CheckPredicate, 30, 29, 45, 0, // Skip to: 19313
/* 7764 */    MCD::OPC_Decode, 157, 7, 245, 1, // Opcode: CLEI_S_D
/* 7769 */    MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 7784
/* 7774 */    MCD::OPC_CheckPredicate, 30, 14, 45, 0, // Skip to: 19313
/* 7779 */    MCD::OPC_Decode, 160, 7, 242, 1, // Opcode: CLEI_U_B
/* 7784 */    MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 7799
/* 7789 */    MCD::OPC_CheckPredicate, 30, 255, 44, 0, // Skip to: 19313
/* 7794 */    MCD::OPC_Decode, 162, 7, 243, 1, // Opcode: CLEI_U_H
/* 7799 */    MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 7814
/* 7804 */    MCD::OPC_CheckPredicate, 30, 240, 44, 0, // Skip to: 19313
/* 7809 */    MCD::OPC_Decode, 163, 7, 244, 1, // Opcode: CLEI_U_W
/* 7814 */    MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 7829
/* 7819 */    MCD::OPC_CheckPredicate, 30, 225, 44, 0, // Skip to: 19313
/* 7824 */    MCD::OPC_Decode, 161, 7, 245, 1, // Opcode: CLEI_U_D
/* 7829 */    MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 7844
/* 7834 */    MCD::OPC_CheckPredicate, 30, 210, 44, 0, // Skip to: 19313
/* 7839 */    MCD::OPC_Decode, 200, 13, 246, 1, // Opcode: LDI_B
/* 7844 */    MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 7859
/* 7849 */    MCD::OPC_CheckPredicate, 30, 195, 44, 0, // Skip to: 19313
/* 7854 */    MCD::OPC_Decode, 202, 13, 247, 1, // Opcode: LDI_H
/* 7859 */    MCD::OPC_FilterValue, 26, 10, 0, 0, // Skip to: 7874
/* 7864 */    MCD::OPC_CheckPredicate, 30, 180, 44, 0, // Skip to: 19313
/* 7869 */    MCD::OPC_Decode, 203, 13, 248, 1, // Opcode: LDI_W
/* 7874 */    MCD::OPC_FilterValue, 27, 170, 44, 0, // Skip to: 19313
/* 7879 */    MCD::OPC_CheckPredicate, 30, 165, 44, 0, // Skip to: 19313
/* 7884 */    MCD::OPC_Decode, 201, 13, 249, 1, // Opcode: LDI_D
/* 7889 */    MCD::OPC_FilterValue, 9, 155, 2, 0, // Skip to: 8561
/* 7894 */    MCD::OPC_ExtractField, 22, 4,  // Inst{25-22} ...
/* 7897 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 7912
/* 7902 */    MCD::OPC_CheckPredicate, 30, 142, 44, 0, // Skip to: 19313
/* 7907 */    MCD::OPC_Decode, 201, 19, 250, 1, // Opcode: SLLI_D
/* 7912 */    MCD::OPC_FilterValue, 1, 63, 0, 0, // Skip to: 7980
/* 7917 */    MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 7920 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 7935
/* 7925 */    MCD::OPC_CheckPredicate, 30, 119, 44, 0, // Skip to: 19313
/* 7930 */    MCD::OPC_Decode, 203, 19, 244, 1, // Opcode: SLLI_W
/* 7935 */    MCD::OPC_FilterValue, 1, 109, 44, 0, // Skip to: 19313
/* 7940 */    MCD::OPC_ExtractField, 20, 1,  // Inst{20} ...
/* 7943 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 7958
/* 7948 */    MCD::OPC_CheckPredicate, 30, 96, 44, 0, // Skip to: 19313
/* 7953 */    MCD::OPC_Decode, 202, 19, 251, 1, // Opcode: SLLI_H
/* 7958 */    MCD::OPC_FilterValue, 1, 86, 44, 0, // Skip to: 19313
/* 7963 */    MCD::OPC_CheckPredicate, 30, 81, 44, 0, // Skip to: 19313
/* 7968 */    MCD::OPC_CheckField, 19, 1, 0, 74, 44, 0, // Skip to: 19313
/* 7975 */    MCD::OPC_Decode, 200, 19, 252, 1, // Opcode: SLLI_B
/* 7980 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 7995
/* 7985 */    MCD::OPC_CheckPredicate, 30, 59, 44, 0, // Skip to: 19313
/* 7990 */    MCD::OPC_Decode, 236, 19, 250, 1, // Opcode: SRAI_D
/* 7995 */    MCD::OPC_FilterValue, 3, 63, 0, 0, // Skip to: 8063
/* 8000 */    MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 8003 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8018
/* 8008 */    MCD::OPC_CheckPredicate, 30, 36, 44, 0, // Skip to: 19313
/* 8013 */    MCD::OPC_Decode, 238, 19, 244, 1, // Opcode: SRAI_W
/* 8018 */    MCD::OPC_FilterValue, 1, 26, 44, 0, // Skip to: 19313
/* 8023 */    MCD::OPC_ExtractField, 20, 1,  // Inst{20} ...
/* 8026 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8041
/* 8031 */    MCD::OPC_CheckPredicate, 30, 13, 44, 0, // Skip to: 19313
/* 8036 */    MCD::OPC_Decode, 237, 19, 251, 1, // Opcode: SRAI_H
/* 8041 */    MCD::OPC_FilterValue, 1, 3, 44, 0, // Skip to: 19313
/* 8046 */    MCD::OPC_CheckPredicate, 30, 254, 43, 0, // Skip to: 19313
/* 8051 */    MCD::OPC_CheckField, 19, 1, 0, 247, 43, 0, // Skip to: 19313
/* 8058 */    MCD::OPC_Decode, 235, 19, 252, 1, // Opcode: SRAI_B
/* 8063 */    MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 8078
/* 8068 */    MCD::OPC_CheckPredicate, 30, 232, 43, 0, // Skip to: 19313
/* 8073 */    MCD::OPC_Decode, 130, 20, 250, 1, // Opcode: SRLI_D
/* 8078 */    MCD::OPC_FilterValue, 5, 63, 0, 0, // Skip to: 8146
/* 8083 */    MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 8086 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8101
/* 8091 */    MCD::OPC_CheckPredicate, 30, 209, 43, 0, // Skip to: 19313
/* 8096 */    MCD::OPC_Decode, 132, 20, 244, 1, // Opcode: SRLI_W
/* 8101 */    MCD::OPC_FilterValue, 1, 199, 43, 0, // Skip to: 19313
/* 8106 */    MCD::OPC_ExtractField, 20, 1,  // Inst{20} ...
/* 8109 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8124
/* 8114 */    MCD::OPC_CheckPredicate, 30, 186, 43, 0, // Skip to: 19313
/* 8119 */    MCD::OPC_Decode, 131, 20, 251, 1, // Opcode: SRLI_H
/* 8124 */    MCD::OPC_FilterValue, 1, 176, 43, 0, // Skip to: 19313
/* 8129 */    MCD::OPC_CheckPredicate, 30, 171, 43, 0, // Skip to: 19313
/* 8134 */    MCD::OPC_CheckField, 19, 1, 0, 164, 43, 0, // Skip to: 19313
/* 8141 */    MCD::OPC_Decode, 129, 20, 252, 1, // Opcode: SRLI_B
/* 8146 */    MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 8161
/* 8151 */    MCD::OPC_CheckPredicate, 30, 149, 43, 0, // Skip to: 19313
/* 8156 */    MCD::OPC_Decode, 205, 5, 250, 1, // Opcode: BCLRI_D
/* 8161 */    MCD::OPC_FilterValue, 7, 63, 0, 0, // Skip to: 8229
/* 8166 */    MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 8169 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8184
/* 8174 */    MCD::OPC_CheckPredicate, 30, 126, 43, 0, // Skip to: 19313
/* 8179 */    MCD::OPC_Decode, 207, 5, 244, 1, // Opcode: BCLRI_W
/* 8184 */    MCD::OPC_FilterValue, 1, 116, 43, 0, // Skip to: 19313
/* 8189 */    MCD::OPC_ExtractField, 20, 1,  // Inst{20} ...
/* 8192 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8207
/* 8197 */    MCD::OPC_CheckPredicate, 30, 103, 43, 0, // Skip to: 19313
/* 8202 */    MCD::OPC_Decode, 206, 5, 251, 1, // Opcode: BCLRI_H
/* 8207 */    MCD::OPC_FilterValue, 1, 93, 43, 0, // Skip to: 19313
/* 8212 */    MCD::OPC_CheckPredicate, 30, 88, 43, 0, // Skip to: 19313
/* 8217 */    MCD::OPC_CheckField, 19, 1, 0, 81, 43, 0, // Skip to: 19313
/* 8224 */    MCD::OPC_Decode, 204, 5, 252, 1, // Opcode: BCLRI_B
/* 8229 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 8244
/* 8234 */    MCD::OPC_CheckPredicate, 30, 66, 43, 0, // Skip to: 19313
/* 8239 */    MCD::OPC_Decode, 224, 6, 250, 1, // Opcode: BSETI_D
/* 8244 */    MCD::OPC_FilterValue, 9, 63, 0, 0, // Skip to: 8312
/* 8249 */    MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 8252 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8267
/* 8257 */    MCD::OPC_CheckPredicate, 30, 43, 43, 0, // Skip to: 19313
/* 8262 */    MCD::OPC_Decode, 226, 6, 244, 1, // Opcode: BSETI_W
/* 8267 */    MCD::OPC_FilterValue, 1, 33, 43, 0, // Skip to: 19313
/* 8272 */    MCD::OPC_ExtractField, 20, 1,  // Inst{20} ...
/* 8275 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8290
/* 8280 */    MCD::OPC_CheckPredicate, 30, 20, 43, 0, // Skip to: 19313
/* 8285 */    MCD::OPC_Decode, 225, 6, 251, 1, // Opcode: BSETI_H
/* 8290 */    MCD::OPC_FilterValue, 1, 10, 43, 0, // Skip to: 19313
/* 8295 */    MCD::OPC_CheckPredicate, 30, 5, 43, 0, // Skip to: 19313
/* 8300 */    MCD::OPC_CheckField, 19, 1, 0, 254, 42, 0, // Skip to: 19313
/* 8307 */    MCD::OPC_Decode, 223, 6, 252, 1, // Opcode: BSETI_B
/* 8312 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 8327
/* 8317 */    MCD::OPC_CheckPredicate, 30, 239, 42, 0, // Skip to: 19313
/* 8322 */    MCD::OPC_Decode, 187, 6, 250, 1, // Opcode: BNEGI_D
/* 8327 */    MCD::OPC_FilterValue, 11, 63, 0, 0, // Skip to: 8395
/* 8332 */    MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 8335 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8350
/* 8340 */    MCD::OPC_CheckPredicate, 30, 216, 42, 0, // Skip to: 19313
/* 8345 */    MCD::OPC_Decode, 189, 6, 244, 1, // Opcode: BNEGI_W
/* 8350 */    MCD::OPC_FilterValue, 1, 206, 42, 0, // Skip to: 19313
/* 8355 */    MCD::OPC_ExtractField, 20, 1,  // Inst{20} ...
/* 8358 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8373
/* 8363 */    MCD::OPC_CheckPredicate, 30, 193, 42, 0, // Skip to: 19313
/* 8368 */    MCD::OPC_Decode, 188, 6, 251, 1, // Opcode: BNEGI_H
/* 8373 */    MCD::OPC_FilterValue, 1, 183, 42, 0, // Skip to: 19313
/* 8378 */    MCD::OPC_CheckPredicate, 30, 178, 42, 0, // Skip to: 19313
/* 8383 */    MCD::OPC_CheckField, 19, 1, 0, 171, 42, 0, // Skip to: 19313
/* 8390 */    MCD::OPC_Decode, 186, 6, 252, 1, // Opcode: BNEGI_B
/* 8395 */    MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 8410
/* 8400 */    MCD::OPC_CheckPredicate, 30, 156, 42, 0, // Skip to: 19313
/* 8405 */    MCD::OPC_Decode, 130, 6, 253, 1, // Opcode: BINSLI_D
/* 8410 */    MCD::OPC_FilterValue, 13, 63, 0, 0, // Skip to: 8478
/* 8415 */    MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 8418 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8433
/* 8423 */    MCD::OPC_CheckPredicate, 30, 133, 42, 0, // Skip to: 19313
/* 8428 */    MCD::OPC_Decode, 132, 6, 254, 1, // Opcode: BINSLI_W
/* 8433 */    MCD::OPC_FilterValue, 1, 123, 42, 0, // Skip to: 19313
/* 8438 */    MCD::OPC_ExtractField, 20, 1,  // Inst{20} ...
/* 8441 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8456
/* 8446 */    MCD::OPC_CheckPredicate, 30, 110, 42, 0, // Skip to: 19313
/* 8451 */    MCD::OPC_Decode, 131, 6, 255, 1, // Opcode: BINSLI_H
/* 8456 */    MCD::OPC_FilterValue, 1, 100, 42, 0, // Skip to: 19313
/* 8461 */    MCD::OPC_CheckPredicate, 30, 95, 42, 0, // Skip to: 19313
/* 8466 */    MCD::OPC_CheckField, 19, 1, 0, 88, 42, 0, // Skip to: 19313
/* 8473 */    MCD::OPC_Decode, 129, 6, 128, 2, // Opcode: BINSLI_B
/* 8478 */    MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 8493
/* 8483 */    MCD::OPC_CheckPredicate, 30, 73, 42, 0, // Skip to: 19313
/* 8488 */    MCD::OPC_Decode, 138, 6, 253, 1, // Opcode: BINSRI_D
/* 8493 */    MCD::OPC_FilterValue, 15, 63, 42, 0, // Skip to: 19313
/* 8498 */    MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 8501 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8516
/* 8506 */    MCD::OPC_CheckPredicate, 30, 50, 42, 0, // Skip to: 19313
/* 8511 */    MCD::OPC_Decode, 140, 6, 254, 1, // Opcode: BINSRI_W
/* 8516 */    MCD::OPC_FilterValue, 1, 40, 42, 0, // Skip to: 19313
/* 8521 */    MCD::OPC_ExtractField, 20, 1,  // Inst{20} ...
/* 8524 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8539
/* 8529 */    MCD::OPC_CheckPredicate, 30, 27, 42, 0, // Skip to: 19313
/* 8534 */    MCD::OPC_Decode, 139, 6, 255, 1, // Opcode: BINSRI_H
/* 8539 */    MCD::OPC_FilterValue, 1, 17, 42, 0, // Skip to: 19313
/* 8544 */    MCD::OPC_CheckPredicate, 30, 12, 42, 0, // Skip to: 19313
/* 8549 */    MCD::OPC_CheckField, 19, 1, 0, 5, 42, 0, // Skip to: 19313
/* 8556 */    MCD::OPC_Decode, 137, 6, 128, 2, // Opcode: BINSRI_B
/* 8561 */    MCD::OPC_FilterValue, 10, 79, 1, 0, // Skip to: 8901
/* 8566 */    MCD::OPC_ExtractField, 22, 4,  // Inst{25-22} ...
/* 8569 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8584
/* 8574 */    MCD::OPC_CheckPredicate, 30, 238, 41, 0, // Skip to: 19313
/* 8579 */    MCD::OPC_Decode, 181, 18, 250, 1, // Opcode: SAT_S_D
/* 8584 */    MCD::OPC_FilterValue, 1, 63, 0, 0, // Skip to: 8652
/* 8589 */    MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 8592 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8607
/* 8597 */    MCD::OPC_CheckPredicate, 30, 215, 41, 0, // Skip to: 19313
/* 8602 */    MCD::OPC_Decode, 183, 18, 244, 1, // Opcode: SAT_S_W
/* 8607 */    MCD::OPC_FilterValue, 1, 205, 41, 0, // Skip to: 19313
/* 8612 */    MCD::OPC_ExtractField, 20, 1,  // Inst{20} ...
/* 8615 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8630
/* 8620 */    MCD::OPC_CheckPredicate, 30, 192, 41, 0, // Skip to: 19313
/* 8625 */    MCD::OPC_Decode, 182, 18, 251, 1, // Opcode: SAT_S_H
/* 8630 */    MCD::OPC_FilterValue, 1, 182, 41, 0, // Skip to: 19313
/* 8635 */    MCD::OPC_CheckPredicate, 30, 177, 41, 0, // Skip to: 19313
/* 8640 */    MCD::OPC_CheckField, 19, 1, 0, 170, 41, 0, // Skip to: 19313
/* 8647 */    MCD::OPC_Decode, 180, 18, 252, 1, // Opcode: SAT_S_B
/* 8652 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 8667
/* 8657 */    MCD::OPC_CheckPredicate, 30, 155, 41, 0, // Skip to: 19313
/* 8662 */    MCD::OPC_Decode, 185, 18, 250, 1, // Opcode: SAT_U_D
/* 8667 */    MCD::OPC_FilterValue, 3, 63, 0, 0, // Skip to: 8735
/* 8672 */    MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 8675 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8690
/* 8680 */    MCD::OPC_CheckPredicate, 30, 132, 41, 0, // Skip to: 19313
/* 8685 */    MCD::OPC_Decode, 187, 18, 244, 1, // Opcode: SAT_U_W
/* 8690 */    MCD::OPC_FilterValue, 1, 122, 41, 0, // Skip to: 19313
/* 8695 */    MCD::OPC_ExtractField, 20, 1,  // Inst{20} ...
/* 8698 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8713
/* 8703 */    MCD::OPC_CheckPredicate, 30, 109, 41, 0, // Skip to: 19313
/* 8708 */    MCD::OPC_Decode, 186, 18, 251, 1, // Opcode: SAT_U_H
/* 8713 */    MCD::OPC_FilterValue, 1, 99, 41, 0, // Skip to: 19313
/* 8718 */    MCD::OPC_CheckPredicate, 30, 94, 41, 0, // Skip to: 19313
/* 8723 */    MCD::OPC_CheckField, 19, 1, 0, 87, 41, 0, // Skip to: 19313
/* 8730 */    MCD::OPC_Decode, 184, 18, 252, 1, // Opcode: SAT_U_B
/* 8735 */    MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 8750
/* 8740 */    MCD::OPC_CheckPredicate, 30, 72, 41, 0, // Skip to: 19313
/* 8745 */    MCD::OPC_Decode, 240, 19, 250, 1, // Opcode: SRARI_D
/* 8750 */    MCD::OPC_FilterValue, 5, 63, 0, 0, // Skip to: 8818
/* 8755 */    MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 8758 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8773
/* 8763 */    MCD::OPC_CheckPredicate, 30, 49, 41, 0, // Skip to: 19313
/* 8768 */    MCD::OPC_Decode, 242, 19, 244, 1, // Opcode: SRARI_W
/* 8773 */    MCD::OPC_FilterValue, 1, 39, 41, 0, // Skip to: 19313
/* 8778 */    MCD::OPC_ExtractField, 20, 1,  // Inst{20} ...
/* 8781 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8796
/* 8786 */    MCD::OPC_CheckPredicate, 30, 26, 41, 0, // Skip to: 19313
/* 8791 */    MCD::OPC_Decode, 241, 19, 251, 1, // Opcode: SRARI_H
/* 8796 */    MCD::OPC_FilterValue, 1, 16, 41, 0, // Skip to: 19313
/* 8801 */    MCD::OPC_CheckPredicate, 30, 11, 41, 0, // Skip to: 19313
/* 8806 */    MCD::OPC_CheckField, 19, 1, 0, 4, 41, 0, // Skip to: 19313
/* 8813 */    MCD::OPC_Decode, 239, 19, 252, 1, // Opcode: SRARI_B
/* 8818 */    MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 8833
/* 8823 */    MCD::OPC_CheckPredicate, 30, 245, 40, 0, // Skip to: 19313
/* 8828 */    MCD::OPC_Decode, 134, 20, 250, 1, // Opcode: SRLRI_D
/* 8833 */    MCD::OPC_FilterValue, 7, 235, 40, 0, // Skip to: 19313
/* 8838 */    MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 8841 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8856
/* 8846 */    MCD::OPC_CheckPredicate, 30, 222, 40, 0, // Skip to: 19313
/* 8851 */    MCD::OPC_Decode, 136, 20, 244, 1, // Opcode: SRLRI_W
/* 8856 */    MCD::OPC_FilterValue, 1, 212, 40, 0, // Skip to: 19313
/* 8861 */    MCD::OPC_ExtractField, 20, 1,  // Inst{20} ...
/* 8864 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8879
/* 8869 */    MCD::OPC_CheckPredicate, 30, 199, 40, 0, // Skip to: 19313
/* 8874 */    MCD::OPC_Decode, 135, 20, 251, 1, // Opcode: SRLRI_H
/* 8879 */    MCD::OPC_FilterValue, 1, 189, 40, 0, // Skip to: 19313
/* 8884 */    MCD::OPC_CheckPredicate, 30, 184, 40, 0, // Skip to: 19313
/* 8889 */    MCD::OPC_CheckField, 19, 1, 0, 177, 40, 0, // Skip to: 19313
/* 8896 */    MCD::OPC_Decode, 133, 20, 252, 1, // Opcode: SRLRI_B
/* 8901 */    MCD::OPC_FilterValue, 13, 227, 1, 0, // Skip to: 9389
/* 8906 */    MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 8909 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8924
/* 8914 */    MCD::OPC_CheckPredicate, 30, 154, 40, 0, // Skip to: 19313
/* 8919 */    MCD::OPC_Decode, 206, 19, 129, 2, // Opcode: SLL_B
/* 8924 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 8939
/* 8929 */    MCD::OPC_CheckPredicate, 30, 139, 40, 0, // Skip to: 19313
/* 8934 */    MCD::OPC_Decode, 208, 19, 130, 2, // Opcode: SLL_H
/* 8939 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 8954
/* 8944 */    MCD::OPC_CheckPredicate, 30, 124, 40, 0, // Skip to: 19313
/* 8949 */    MCD::OPC_Decode, 211, 19, 131, 2, // Opcode: SLL_W
/* 8954 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 8969
/* 8959 */    MCD::OPC_CheckPredicate, 30, 109, 40, 0, // Skip to: 19313
/* 8964 */    MCD::OPC_Decode, 207, 19, 132, 2, // Opcode: SLL_D
/* 8969 */    MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 8984
/* 8974 */    MCD::OPC_CheckPredicate, 30, 94, 40, 0, // Skip to: 19313
/* 8979 */    MCD::OPC_Decode, 249, 19, 129, 2, // Opcode: SRA_B
/* 8984 */    MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 8999
/* 8989 */    MCD::OPC_CheckPredicate, 30, 79, 40, 0, // Skip to: 19313
/* 8994 */    MCD::OPC_Decode, 251, 19, 130, 2, // Opcode: SRA_H
/* 8999 */    MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 9014
/* 9004 */    MCD::OPC_CheckPredicate, 30, 64, 40, 0, // Skip to: 19313
/* 9009 */    MCD::OPC_Decode, 253, 19, 131, 2, // Opcode: SRA_W
/* 9014 */    MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 9029
/* 9019 */    MCD::OPC_CheckPredicate, 30, 49, 40, 0, // Skip to: 19313
/* 9024 */    MCD::OPC_Decode, 250, 19, 132, 2, // Opcode: SRA_D
/* 9029 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 9044
/* 9034 */    MCD::OPC_CheckPredicate, 30, 34, 40, 0, // Skip to: 19313
/* 9039 */    MCD::OPC_Decode, 143, 20, 129, 2, // Opcode: SRL_B
/* 9044 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 9059
/* 9049 */    MCD::OPC_CheckPredicate, 30, 19, 40, 0, // Skip to: 19313
/* 9054 */    MCD::OPC_Decode, 145, 20, 130, 2, // Opcode: SRL_H
/* 9059 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 9074
/* 9064 */    MCD::OPC_CheckPredicate, 30, 4, 40, 0, // Skip to: 19313
/* 9069 */    MCD::OPC_Decode, 147, 20, 131, 2, // Opcode: SRL_W
/* 9074 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 9089
/* 9079 */    MCD::OPC_CheckPredicate, 30, 245, 39, 0, // Skip to: 19313
/* 9084 */    MCD::OPC_Decode, 144, 20, 132, 2, // Opcode: SRL_D
/* 9089 */    MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 9104
/* 9094 */    MCD::OPC_CheckPredicate, 30, 230, 39, 0, // Skip to: 19313
/* 9099 */    MCD::OPC_Decode, 208, 5, 129, 2, // Opcode: BCLR_B
/* 9104 */    MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 9119
/* 9109 */    MCD::OPC_CheckPredicate, 30, 215, 39, 0, // Skip to: 19313
/* 9114 */    MCD::OPC_Decode, 210, 5, 130, 2, // Opcode: BCLR_H
/* 9119 */    MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 9134
/* 9124 */    MCD::OPC_CheckPredicate, 30, 200, 39, 0, // Skip to: 19313
/* 9129 */    MCD::OPC_Decode, 211, 5, 131, 2, // Opcode: BCLR_W
/* 9134 */    MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 9149
/* 9139 */    MCD::OPC_CheckPredicate, 30, 185, 39, 0, // Skip to: 19313
/* 9144 */    MCD::OPC_Decode, 209, 5, 132, 2, // Opcode: BCLR_D
/* 9149 */    MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 9164
/* 9154 */    MCD::OPC_CheckPredicate, 30, 170, 39, 0, // Skip to: 19313
/* 9159 */    MCD::OPC_Decode, 227, 6, 129, 2, // Opcode: BSET_B
/* 9164 */    MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 9179
/* 9169 */    MCD::OPC_CheckPredicate, 30, 155, 39, 0, // Skip to: 19313
/* 9174 */    MCD::OPC_Decode, 229, 6, 130, 2, // Opcode: BSET_H
/* 9179 */    MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 9194
/* 9184 */    MCD::OPC_CheckPredicate, 30, 140, 39, 0, // Skip to: 19313
/* 9189 */    MCD::OPC_Decode, 230, 6, 131, 2, // Opcode: BSET_W
/* 9194 */    MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 9209
/* 9199 */    MCD::OPC_CheckPredicate, 30, 125, 39, 0, // Skip to: 19313
/* 9204 */    MCD::OPC_Decode, 228, 6, 132, 2, // Opcode: BSET_D
/* 9209 */    MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 9224
/* 9214 */    MCD::OPC_CheckPredicate, 30, 110, 39, 0, // Skip to: 19313
/* 9219 */    MCD::OPC_Decode, 190, 6, 129, 2, // Opcode: BNEG_B
/* 9224 */    MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 9239
/* 9229 */    MCD::OPC_CheckPredicate, 30, 95, 39, 0, // Skip to: 19313
/* 9234 */    MCD::OPC_Decode, 192, 6, 130, 2, // Opcode: BNEG_H
/* 9239 */    MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 9254
/* 9244 */    MCD::OPC_CheckPredicate, 30, 80, 39, 0, // Skip to: 19313
/* 9249 */    MCD::OPC_Decode, 193, 6, 131, 2, // Opcode: BNEG_W
/* 9254 */    MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 9269
/* 9259 */    MCD::OPC_CheckPredicate, 30, 65, 39, 0, // Skip to: 19313
/* 9264 */    MCD::OPC_Decode, 191, 6, 132, 2, // Opcode: BNEG_D
/* 9269 */    MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 9284
/* 9274 */    MCD::OPC_CheckPredicate, 30, 50, 39, 0, // Skip to: 19313
/* 9279 */    MCD::OPC_Decode, 133, 6, 133, 2, // Opcode: BINSL_B
/* 9284 */    MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 9299
/* 9289 */    MCD::OPC_CheckPredicate, 30, 35, 39, 0, // Skip to: 19313
/* 9294 */    MCD::OPC_Decode, 135, 6, 134, 2, // Opcode: BINSL_H
/* 9299 */    MCD::OPC_FilterValue, 26, 10, 0, 0, // Skip to: 9314
/* 9304 */    MCD::OPC_CheckPredicate, 30, 20, 39, 0, // Skip to: 19313
/* 9309 */    MCD::OPC_Decode, 136, 6, 135, 2, // Opcode: BINSL_W
/* 9314 */    MCD::OPC_FilterValue, 27, 10, 0, 0, // Skip to: 9329
/* 9319 */    MCD::OPC_CheckPredicate, 30, 5, 39, 0, // Skip to: 19313
/* 9324 */    MCD::OPC_Decode, 134, 6, 136, 2, // Opcode: BINSL_D
/* 9329 */    MCD::OPC_FilterValue, 28, 10, 0, 0, // Skip to: 9344
/* 9334 */    MCD::OPC_CheckPredicate, 30, 246, 38, 0, // Skip to: 19313
/* 9339 */    MCD::OPC_Decode, 141, 6, 133, 2, // Opcode: BINSR_B
/* 9344 */    MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 9359
/* 9349 */    MCD::OPC_CheckPredicate, 30, 231, 38, 0, // Skip to: 19313
/* 9354 */    MCD::OPC_Decode, 143, 6, 134, 2, // Opcode: BINSR_H
/* 9359 */    MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 9374
/* 9364 */    MCD::OPC_CheckPredicate, 30, 216, 38, 0, // Skip to: 19313
/* 9369 */    MCD::OPC_Decode, 144, 6, 135, 2, // Opcode: BINSR_W
/* 9374 */    MCD::OPC_FilterValue, 31, 206, 38, 0, // Skip to: 19313
/* 9379 */    MCD::OPC_CheckPredicate, 30, 201, 38, 0, // Skip to: 19313
/* 9384 */    MCD::OPC_Decode, 142, 6, 136, 2, // Opcode: BINSR_D
/* 9389 */    MCD::OPC_FilterValue, 14, 227, 1, 0, // Skip to: 9877
/* 9394 */    MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 9397 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 9412
/* 9402 */    MCD::OPC_CheckPredicate, 30, 178, 38, 0, // Skip to: 19313
/* 9407 */    MCD::OPC_Decode, 230, 4, 129, 2, // Opcode: ADDV_B
/* 9412 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 9427
/* 9417 */    MCD::OPC_CheckPredicate, 30, 163, 38, 0, // Skip to: 19313
/* 9422 */    MCD::OPC_Decode, 232, 4, 130, 2, // Opcode: ADDV_H
/* 9427 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 9442
/* 9432 */    MCD::OPC_CheckPredicate, 30, 148, 38, 0, // Skip to: 19313
/* 9437 */    MCD::OPC_Decode, 233, 4, 131, 2, // Opcode: ADDV_W
/* 9442 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 9457
/* 9447 */    MCD::OPC_CheckPredicate, 30, 133, 38, 0, // Skip to: 19313
/* 9452 */    MCD::OPC_Decode, 231, 4, 132, 2, // Opcode: ADDV_D
/* 9457 */    MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 9472
/* 9462 */    MCD::OPC_CheckPredicate, 30, 118, 38, 0, // Skip to: 19313
/* 9467 */    MCD::OPC_Decode, 220, 20, 129, 2, // Opcode: SUBV_B
/* 9472 */    MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 9487
/* 9477 */    MCD::OPC_CheckPredicate, 30, 103, 38, 0, // Skip to: 19313
/* 9482 */    MCD::OPC_Decode, 222, 20, 130, 2, // Opcode: SUBV_H
/* 9487 */    MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 9502
/* 9492 */    MCD::OPC_CheckPredicate, 30, 88, 38, 0, // Skip to: 19313
/* 9497 */    MCD::OPC_Decode, 223, 20, 131, 2, // Opcode: SUBV_W
/* 9502 */    MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 9517
/* 9507 */    MCD::OPC_CheckPredicate, 30, 73, 38, 0, // Skip to: 19313
/* 9512 */    MCD::OPC_Decode, 221, 20, 132, 2, // Opcode: SUBV_D
/* 9517 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 9532
/* 9522 */    MCD::OPC_CheckPredicate, 30, 58, 38, 0, // Skip to: 19313
/* 9527 */    MCD::OPC_Decode, 227, 14, 129, 2, // Opcode: MAX_S_B
/* 9532 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 9547
/* 9537 */    MCD::OPC_CheckPredicate, 30, 43, 38, 0, // Skip to: 19313
/* 9542 */    MCD::OPC_Decode, 229, 14, 130, 2, // Opcode: MAX_S_H
/* 9547 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 9562
/* 9552 */    MCD::OPC_CheckPredicate, 30, 28, 38, 0, // Skip to: 19313
/* 9557 */    MCD::OPC_Decode, 231, 14, 131, 2, // Opcode: MAX_S_W
/* 9562 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 9577
/* 9567 */    MCD::OPC_CheckPredicate, 30, 13, 38, 0, // Skip to: 19313
/* 9572 */    MCD::OPC_Decode, 228, 14, 132, 2, // Opcode: MAX_S_D
/* 9577 */    MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 9592
/* 9582 */    MCD::OPC_CheckPredicate, 30, 254, 37, 0, // Skip to: 19313
/* 9587 */    MCD::OPC_Decode, 232, 14, 129, 2, // Opcode: MAX_U_B
/* 9592 */    MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 9607
/* 9597 */    MCD::OPC_CheckPredicate, 30, 239, 37, 0, // Skip to: 19313
/* 9602 */    MCD::OPC_Decode, 234, 14, 130, 2, // Opcode: MAX_U_H
/* 9607 */    MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 9622
/* 9612 */    MCD::OPC_CheckPredicate, 30, 224, 37, 0, // Skip to: 19313
/* 9617 */    MCD::OPC_Decode, 235, 14, 131, 2, // Opcode: MAX_U_W
/* 9622 */    MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 9637
/* 9627 */    MCD::OPC_CheckPredicate, 30, 209, 37, 0, // Skip to: 19313
/* 9632 */    MCD::OPC_Decode, 233, 14, 132, 2, // Opcode: MAX_U_D
/* 9637 */    MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 9652
/* 9642 */    MCD::OPC_CheckPredicate, 30, 194, 37, 0, // Skip to: 19313
/* 9647 */    MCD::OPC_Decode, 158, 15, 129, 2, // Opcode: MIN_S_B
/* 9652 */    MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 9667
/* 9657 */    MCD::OPC_CheckPredicate, 30, 179, 37, 0, // Skip to: 19313
/* 9662 */    MCD::OPC_Decode, 160, 15, 130, 2, // Opcode: MIN_S_H
/* 9667 */    MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 9682
/* 9672 */    MCD::OPC_CheckPredicate, 30, 164, 37, 0, // Skip to: 19313
/* 9677 */    MCD::OPC_Decode, 162, 15, 131, 2, // Opcode: MIN_S_W
/* 9682 */    MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 9697
/* 9687 */    MCD::OPC_CheckPredicate, 30, 149, 37, 0, // Skip to: 19313
/* 9692 */    MCD::OPC_Decode, 159, 15, 132, 2, // Opcode: MIN_S_D
/* 9697 */    MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 9712
/* 9702 */    MCD::OPC_CheckPredicate, 30, 134, 37, 0, // Skip to: 19313
/* 9707 */    MCD::OPC_Decode, 163, 15, 129, 2, // Opcode: MIN_U_B
/* 9712 */    MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 9727
/* 9717 */    MCD::OPC_CheckPredicate, 30, 119, 37, 0, // Skip to: 19313
/* 9722 */    MCD::OPC_Decode, 165, 15, 130, 2, // Opcode: MIN_U_H
/* 9727 */    MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 9742
/* 9732 */    MCD::OPC_CheckPredicate, 30, 104, 37, 0, // Skip to: 19313
/* 9737 */    MCD::OPC_Decode, 166, 15, 131, 2, // Opcode: MIN_U_W
/* 9742 */    MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 9757
/* 9747 */    MCD::OPC_CheckPredicate, 30, 89, 37, 0, // Skip to: 19313
/* 9752 */    MCD::OPC_Decode, 164, 15, 132, 2, // Opcode: MIN_U_D
/* 9757 */    MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 9772
/* 9762 */    MCD::OPC_CheckPredicate, 30, 74, 37, 0, // Skip to: 19313
/* 9767 */    MCD::OPC_Decode, 220, 14, 129, 2, // Opcode: MAX_A_B
/* 9772 */    MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 9787
/* 9777 */    MCD::OPC_CheckPredicate, 30, 59, 37, 0, // Skip to: 19313
/* 9782 */    MCD::OPC_Decode, 222, 14, 130, 2, // Opcode: MAX_A_H
/* 9787 */    MCD::OPC_FilterValue, 26, 10, 0, 0, // Skip to: 9802
/* 9792 */    MCD::OPC_CheckPredicate, 30, 44, 37, 0, // Skip to: 19313
/* 9797 */    MCD::OPC_Decode, 223, 14, 131, 2, // Opcode: MAX_A_W
/* 9802 */    MCD::OPC_FilterValue, 27, 10, 0, 0, // Skip to: 9817
/* 9807 */    MCD::OPC_CheckPredicate, 30, 29, 37, 0, // Skip to: 19313
/* 9812 */    MCD::OPC_Decode, 221, 14, 132, 2, // Opcode: MAX_A_D
/* 9817 */    MCD::OPC_FilterValue, 28, 10, 0, 0, // Skip to: 9832
/* 9822 */    MCD::OPC_CheckPredicate, 30, 14, 37, 0, // Skip to: 19313
/* 9827 */    MCD::OPC_Decode, 151, 15, 129, 2, // Opcode: MIN_A_B
/* 9832 */    MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 9847
/* 9837 */    MCD::OPC_CheckPredicate, 30, 255, 36, 0, // Skip to: 19313
/* 9842 */    MCD::OPC_Decode, 153, 15, 130, 2, // Opcode: MIN_A_H
/* 9847 */    MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 9862
/* 9852 */    MCD::OPC_CheckPredicate, 30, 240, 36, 0, // Skip to: 19313
/* 9857 */    MCD::OPC_Decode, 154, 15, 131, 2, // Opcode: MIN_A_W
/* 9862 */    MCD::OPC_FilterValue, 31, 230, 36, 0, // Skip to: 19313
/* 9867 */    MCD::OPC_CheckPredicate, 30, 225, 36, 0, // Skip to: 19313
/* 9872 */    MCD::OPC_Decode, 152, 15, 132, 2, // Opcode: MIN_A_D
/* 9877 */    MCD::OPC_FilterValue, 15, 47, 1, 0, // Skip to: 10185
/* 9882 */    MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 9885 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 9900
/* 9890 */    MCD::OPC_CheckPredicate, 30, 202, 36, 0, // Skip to: 19313
/* 9895 */    MCD::OPC_Decode, 140, 7, 129, 2, // Opcode: CEQ_B
/* 9900 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 9915
/* 9905 */    MCD::OPC_CheckPredicate, 30, 187, 36, 0, // Skip to: 19313
/* 9910 */    MCD::OPC_Decode, 142, 7, 130, 2, // Opcode: CEQ_H
/* 9915 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 9930
/* 9920 */    MCD::OPC_CheckPredicate, 30, 172, 36, 0, // Skip to: 19313
/* 9925 */    MCD::OPC_Decode, 143, 7, 131, 2, // Opcode: CEQ_W
/* 9930 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 9945
/* 9935 */    MCD::OPC_CheckPredicate, 30, 157, 36, 0, // Skip to: 19313
/* 9940 */    MCD::OPC_Decode, 141, 7, 132, 2, // Opcode: CEQ_D
/* 9945 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 9960
/* 9950 */    MCD::OPC_CheckPredicate, 30, 142, 36, 0, // Skip to: 19313
/* 9955 */    MCD::OPC_Decode, 184, 7, 129, 2, // Opcode: CLT_S_B
/* 9960 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 9975
/* 9965 */    MCD::OPC_CheckPredicate, 30, 127, 36, 0, // Skip to: 19313
/* 9970 */    MCD::OPC_Decode, 186, 7, 130, 2, // Opcode: CLT_S_H
/* 9975 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 9990
/* 9980 */    MCD::OPC_CheckPredicate, 30, 112, 36, 0, // Skip to: 19313
/* 9985 */    MCD::OPC_Decode, 187, 7, 131, 2, // Opcode: CLT_S_W
/* 9990 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 10005
/* 9995 */    MCD::OPC_CheckPredicate, 30, 97, 36, 0, // Skip to: 19313
/* 10000 */   MCD::OPC_Decode, 185, 7, 132, 2, // Opcode: CLT_S_D
/* 10005 */   MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 10020
/* 10010 */   MCD::OPC_CheckPredicate, 30, 82, 36, 0, // Skip to: 19313
/* 10015 */   MCD::OPC_Decode, 188, 7, 129, 2, // Opcode: CLT_U_B
/* 10020 */   MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 10035
/* 10025 */   MCD::OPC_CheckPredicate, 30, 67, 36, 0, // Skip to: 19313
/* 10030 */   MCD::OPC_Decode, 190, 7, 130, 2, // Opcode: CLT_U_H
/* 10035 */   MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 10050
/* 10040 */   MCD::OPC_CheckPredicate, 30, 52, 36, 0, // Skip to: 19313
/* 10045 */   MCD::OPC_Decode, 191, 7, 131, 2, // Opcode: CLT_U_W
/* 10050 */   MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 10065
/* 10055 */   MCD::OPC_CheckPredicate, 30, 37, 36, 0, // Skip to: 19313
/* 10060 */   MCD::OPC_Decode, 189, 7, 132, 2, // Opcode: CLT_U_D
/* 10065 */   MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 10080
/* 10070 */   MCD::OPC_CheckPredicate, 30, 22, 36, 0, // Skip to: 19313
/* 10075 */   MCD::OPC_Decode, 164, 7, 129, 2, // Opcode: CLE_S_B
/* 10080 */   MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 10095
/* 10085 */   MCD::OPC_CheckPredicate, 30, 7, 36, 0, // Skip to: 19313
/* 10090 */   MCD::OPC_Decode, 166, 7, 130, 2, // Opcode: CLE_S_H
/* 10095 */   MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 10110
/* 10100 */   MCD::OPC_CheckPredicate, 30, 248, 35, 0, // Skip to: 19313
/* 10105 */   MCD::OPC_Decode, 167, 7, 131, 2, // Opcode: CLE_S_W
/* 10110 */   MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 10125
/* 10115 */   MCD::OPC_CheckPredicate, 30, 233, 35, 0, // Skip to: 19313
/* 10120 */   MCD::OPC_Decode, 165, 7, 132, 2, // Opcode: CLE_S_D
/* 10125 */   MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 10140
/* 10130 */   MCD::OPC_CheckPredicate, 30, 218, 35, 0, // Skip to: 19313
/* 10135 */   MCD::OPC_Decode, 168, 7, 129, 2, // Opcode: CLE_U_B
/* 10140 */   MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 10155
/* 10145 */   MCD::OPC_CheckPredicate, 30, 203, 35, 0, // Skip to: 19313
/* 10150 */   MCD::OPC_Decode, 170, 7, 130, 2, // Opcode: CLE_U_H
/* 10155 */   MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 10170
/* 10160 */   MCD::OPC_CheckPredicate, 30, 188, 35, 0, // Skip to: 19313
/* 10165 */   MCD::OPC_Decode, 171, 7, 131, 2, // Opcode: CLE_U_W
/* 10170 */   MCD::OPC_FilterValue, 23, 178, 35, 0, // Skip to: 19313
/* 10175 */   MCD::OPC_CheckPredicate, 30, 173, 35, 0, // Skip to: 19313
/* 10180 */   MCD::OPC_Decode, 169, 7, 132, 2, // Opcode: CLE_U_D
/* 10185 */   MCD::OPC_FilterValue, 16, 227, 1, 0, // Skip to: 10673
/* 10190 */   MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 10193 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 10208
/* 10198 */   MCD::OPC_CheckPredicate, 30, 150, 35, 0, // Skip to: 19313
/* 10203 */   MCD::OPC_Decode, 236, 4, 129, 2, // Opcode: ADD_A_B
/* 10208 */   MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 10223
/* 10213 */   MCD::OPC_CheckPredicate, 30, 135, 35, 0, // Skip to: 19313
/* 10218 */   MCD::OPC_Decode, 238, 4, 130, 2, // Opcode: ADD_A_H
/* 10223 */   MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 10238
/* 10228 */   MCD::OPC_CheckPredicate, 30, 120, 35, 0, // Skip to: 19313
/* 10233 */   MCD::OPC_Decode, 239, 4, 131, 2, // Opcode: ADD_A_W
/* 10238 */   MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 10253
/* 10243 */   MCD::OPC_CheckPredicate, 30, 105, 35, 0, // Skip to: 19313
/* 10248 */   MCD::OPC_Decode, 237, 4, 132, 2, // Opcode: ADD_A_D
/* 10253 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 10268
/* 10258 */   MCD::OPC_CheckPredicate, 30, 90, 35, 0, // Skip to: 19313
/* 10263 */   MCD::OPC_Decode, 199, 4, 129, 2, // Opcode: ADDS_A_B
/* 10268 */   MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 10283
/* 10273 */   MCD::OPC_CheckPredicate, 30, 75, 35, 0, // Skip to: 19313
/* 10278 */   MCD::OPC_Decode, 201, 4, 130, 2, // Opcode: ADDS_A_H
/* 10283 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 10298
/* 10288 */   MCD::OPC_CheckPredicate, 30, 60, 35, 0, // Skip to: 19313
/* 10293 */   MCD::OPC_Decode, 202, 4, 131, 2, // Opcode: ADDS_A_W
/* 10298 */   MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 10313
/* 10303 */   MCD::OPC_CheckPredicate, 30, 45, 35, 0, // Skip to: 19313
/* 10308 */   MCD::OPC_Decode, 200, 4, 132, 2, // Opcode: ADDS_A_D
/* 10313 */   MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 10328
/* 10318 */   MCD::OPC_CheckPredicate, 30, 30, 35, 0, // Skip to: 19313
/* 10323 */   MCD::OPC_Decode, 203, 4, 129, 2, // Opcode: ADDS_S_B
/* 10328 */   MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 10343
/* 10333 */   MCD::OPC_CheckPredicate, 30, 15, 35, 0, // Skip to: 19313
/* 10338 */   MCD::OPC_Decode, 205, 4, 130, 2, // Opcode: ADDS_S_H
/* 10343 */   MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 10358
/* 10348 */   MCD::OPC_CheckPredicate, 30, 0, 35, 0, // Skip to: 19313
/* 10353 */   MCD::OPC_Decode, 206, 4, 131, 2, // Opcode: ADDS_S_W
/* 10358 */   MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 10373
/* 10363 */   MCD::OPC_CheckPredicate, 30, 241, 34, 0, // Skip to: 19313
/* 10368 */   MCD::OPC_Decode, 204, 4, 132, 2, // Opcode: ADDS_S_D
/* 10373 */   MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 10388
/* 10378 */   MCD::OPC_CheckPredicate, 30, 226, 34, 0, // Skip to: 19313
/* 10383 */   MCD::OPC_Decode, 207, 4, 129, 2, // Opcode: ADDS_U_B
/* 10388 */   MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 10403
/* 10393 */   MCD::OPC_CheckPredicate, 30, 211, 34, 0, // Skip to: 19313
/* 10398 */   MCD::OPC_Decode, 209, 4, 130, 2, // Opcode: ADDS_U_H
/* 10403 */   MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 10418
/* 10408 */   MCD::OPC_CheckPredicate, 30, 196, 34, 0, // Skip to: 19313
/* 10413 */   MCD::OPC_Decode, 210, 4, 131, 2, // Opcode: ADDS_U_W
/* 10418 */   MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 10433
/* 10423 */   MCD::OPC_CheckPredicate, 30, 181, 34, 0, // Skip to: 19313
/* 10428 */   MCD::OPC_Decode, 208, 4, 132, 2, // Opcode: ADDS_U_D
/* 10433 */   MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 10448
/* 10438 */   MCD::OPC_CheckPredicate, 30, 166, 34, 0, // Skip to: 19313
/* 10443 */   MCD::OPC_Decode, 160, 5, 129, 2, // Opcode: AVE_S_B
/* 10448 */   MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 10463
/* 10453 */   MCD::OPC_CheckPredicate, 30, 151, 34, 0, // Skip to: 19313
/* 10458 */   MCD::OPC_Decode, 162, 5, 130, 2, // Opcode: AVE_S_H
/* 10463 */   MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 10478
/* 10468 */   MCD::OPC_CheckPredicate, 30, 136, 34, 0, // Skip to: 19313
/* 10473 */   MCD::OPC_Decode, 163, 5, 131, 2, // Opcode: AVE_S_W
/* 10478 */   MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 10493
/* 10483 */   MCD::OPC_CheckPredicate, 30, 121, 34, 0, // Skip to: 19313
/* 10488 */   MCD::OPC_Decode, 161, 5, 132, 2, // Opcode: AVE_S_D
/* 10493 */   MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 10508
/* 10498 */   MCD::OPC_CheckPredicate, 30, 106, 34, 0, // Skip to: 19313
/* 10503 */   MCD::OPC_Decode, 164, 5, 129, 2, // Opcode: AVE_U_B
/* 10508 */   MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 10523
/* 10513 */   MCD::OPC_CheckPredicate, 30, 91, 34, 0, // Skip to: 19313
/* 10518 */   MCD::OPC_Decode, 166, 5, 130, 2, // Opcode: AVE_U_H
/* 10523 */   MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 10538
/* 10528 */   MCD::OPC_CheckPredicate, 30, 76, 34, 0, // Skip to: 19313
/* 10533 */   MCD::OPC_Decode, 167, 5, 131, 2, // Opcode: AVE_U_W
/* 10538 */   MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 10553
/* 10543 */   MCD::OPC_CheckPredicate, 30, 61, 34, 0, // Skip to: 19313
/* 10548 */   MCD::OPC_Decode, 165, 5, 132, 2, // Opcode: AVE_U_D
/* 10553 */   MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 10568
/* 10558 */   MCD::OPC_CheckPredicate, 30, 46, 34, 0, // Skip to: 19313
/* 10563 */   MCD::OPC_Decode, 152, 5, 129, 2, // Opcode: AVER_S_B
/* 10568 */   MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 10583
/* 10573 */   MCD::OPC_CheckPredicate, 30, 31, 34, 0, // Skip to: 19313
/* 10578 */   MCD::OPC_Decode, 154, 5, 130, 2, // Opcode: AVER_S_H
/* 10583 */   MCD::OPC_FilterValue, 26, 10, 0, 0, // Skip to: 10598
/* 10588 */   MCD::OPC_CheckPredicate, 30, 16, 34, 0, // Skip to: 19313
/* 10593 */   MCD::OPC_Decode, 155, 5, 131, 2, // Opcode: AVER_S_W
/* 10598 */   MCD::OPC_FilterValue, 27, 10, 0, 0, // Skip to: 10613
/* 10603 */   MCD::OPC_CheckPredicate, 30, 1, 34, 0, // Skip to: 19313
/* 10608 */   MCD::OPC_Decode, 153, 5, 132, 2, // Opcode: AVER_S_D
/* 10613 */   MCD::OPC_FilterValue, 28, 10, 0, 0, // Skip to: 10628
/* 10618 */   MCD::OPC_CheckPredicate, 30, 242, 33, 0, // Skip to: 19313
/* 10623 */   MCD::OPC_Decode, 156, 5, 129, 2, // Opcode: AVER_U_B
/* 10628 */   MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 10643
/* 10633 */   MCD::OPC_CheckPredicate, 30, 227, 33, 0, // Skip to: 19313
/* 10638 */   MCD::OPC_Decode, 158, 5, 130, 2, // Opcode: AVER_U_H
/* 10643 */   MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 10658
/* 10648 */   MCD::OPC_CheckPredicate, 30, 212, 33, 0, // Skip to: 19313
/* 10653 */   MCD::OPC_Decode, 159, 5, 131, 2, // Opcode: AVER_U_W
/* 10658 */   MCD::OPC_FilterValue, 31, 202, 33, 0, // Skip to: 19313
/* 10663 */   MCD::OPC_CheckPredicate, 30, 197, 33, 0, // Skip to: 19313
/* 10668 */   MCD::OPC_Decode, 157, 5, 132, 2, // Opcode: AVER_U_D
/* 10673 */   MCD::OPC_FilterValue, 17, 107, 1, 0, // Skip to: 11041
/* 10678 */   MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 10681 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 10696
/* 10686 */   MCD::OPC_CheckPredicate, 30, 174, 33, 0, // Skip to: 19313
/* 10691 */   MCD::OPC_Decode, 193, 20, 129, 2, // Opcode: SUBS_S_B
/* 10696 */   MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 10711
/* 10701 */   MCD::OPC_CheckPredicate, 30, 159, 33, 0, // Skip to: 19313
/* 10706 */   MCD::OPC_Decode, 195, 20, 130, 2, // Opcode: SUBS_S_H
/* 10711 */   MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 10726
/* 10716 */   MCD::OPC_CheckPredicate, 30, 144, 33, 0, // Skip to: 19313
/* 10721 */   MCD::OPC_Decode, 196, 20, 131, 2, // Opcode: SUBS_S_W
/* 10726 */   MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 10741
/* 10731 */   MCD::OPC_CheckPredicate, 30, 129, 33, 0, // Skip to: 19313
/* 10736 */   MCD::OPC_Decode, 194, 20, 132, 2, // Opcode: SUBS_S_D
/* 10741 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 10756
/* 10746 */   MCD::OPC_CheckPredicate, 30, 114, 33, 0, // Skip to: 19313
/* 10751 */   MCD::OPC_Decode, 197, 20, 129, 2, // Opcode: SUBS_U_B
/* 10756 */   MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 10771
/* 10761 */   MCD::OPC_CheckPredicate, 30, 99, 33, 0, // Skip to: 19313
/* 10766 */   MCD::OPC_Decode, 199, 20, 130, 2, // Opcode: SUBS_U_H
/* 10771 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 10786
/* 10776 */   MCD::OPC_CheckPredicate, 30, 84, 33, 0, // Skip to: 19313
/* 10781 */   MCD::OPC_Decode, 200, 20, 131, 2, // Opcode: SUBS_U_W
/* 10786 */   MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 10801
/* 10791 */   MCD::OPC_CheckPredicate, 30, 69, 33, 0, // Skip to: 19313
/* 10796 */   MCD::OPC_Decode, 198, 20, 132, 2, // Opcode: SUBS_U_D
/* 10801 */   MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 10816
/* 10806 */   MCD::OPC_CheckPredicate, 30, 54, 33, 0, // Skip to: 19313
/* 10811 */   MCD::OPC_Decode, 185, 20, 129, 2, // Opcode: SUBSUS_U_B
/* 10816 */   MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 10831
/* 10821 */   MCD::OPC_CheckPredicate, 30, 39, 33, 0, // Skip to: 19313
/* 10826 */   MCD::OPC_Decode, 187, 20, 130, 2, // Opcode: SUBSUS_U_H
/* 10831 */   MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 10846
/* 10836 */   MCD::OPC_CheckPredicate, 30, 24, 33, 0, // Skip to: 19313
/* 10841 */   MCD::OPC_Decode, 188, 20, 131, 2, // Opcode: SUBSUS_U_W
/* 10846 */   MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 10861
/* 10851 */   MCD::OPC_CheckPredicate, 30, 9, 33, 0, // Skip to: 19313
/* 10856 */   MCD::OPC_Decode, 186, 20, 132, 2, // Opcode: SUBSUS_U_D
/* 10861 */   MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 10876
/* 10866 */   MCD::OPC_CheckPredicate, 30, 250, 32, 0, // Skip to: 19313
/* 10871 */   MCD::OPC_Decode, 189, 20, 129, 2, // Opcode: SUBSUU_S_B
/* 10876 */   MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 10891
/* 10881 */   MCD::OPC_CheckPredicate, 30, 235, 32, 0, // Skip to: 19313
/* 10886 */   MCD::OPC_Decode, 191, 20, 130, 2, // Opcode: SUBSUU_S_H
/* 10891 */   MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 10906
/* 10896 */   MCD::OPC_CheckPredicate, 30, 220, 32, 0, // Skip to: 19313
/* 10901 */   MCD::OPC_Decode, 192, 20, 131, 2, // Opcode: SUBSUU_S_W
/* 10906 */   MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 10921
/* 10911 */   MCD::OPC_CheckPredicate, 30, 205, 32, 0, // Skip to: 19313
/* 10916 */   MCD::OPC_Decode, 190, 20, 132, 2, // Opcode: SUBSUU_S_D
/* 10921 */   MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 10936
/* 10926 */   MCD::OPC_CheckPredicate, 30, 190, 32, 0, // Skip to: 19313
/* 10931 */   MCD::OPC_Decode, 140, 5, 129, 2, // Opcode: ASUB_S_B
/* 10936 */   MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 10951
/* 10941 */   MCD::OPC_CheckPredicate, 30, 175, 32, 0, // Skip to: 19313
/* 10946 */   MCD::OPC_Decode, 142, 5, 130, 2, // Opcode: ASUB_S_H
/* 10951 */   MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 10966
/* 10956 */   MCD::OPC_CheckPredicate, 30, 160, 32, 0, // Skip to: 19313
/* 10961 */   MCD::OPC_Decode, 143, 5, 131, 2, // Opcode: ASUB_S_W
/* 10966 */   MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 10981
/* 10971 */   MCD::OPC_CheckPredicate, 30, 145, 32, 0, // Skip to: 19313
/* 10976 */   MCD::OPC_Decode, 141, 5, 132, 2, // Opcode: ASUB_S_D
/* 10981 */   MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 10996
/* 10986 */   MCD::OPC_CheckPredicate, 30, 130, 32, 0, // Skip to: 19313
/* 10991 */   MCD::OPC_Decode, 144, 5, 129, 2, // Opcode: ASUB_U_B
/* 10996 */   MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 11011
/* 11001 */   MCD::OPC_CheckPredicate, 30, 115, 32, 0, // Skip to: 19313
/* 11006 */   MCD::OPC_Decode, 146, 5, 130, 2, // Opcode: ASUB_U_H
/* 11011 */   MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 11026
/* 11016 */   MCD::OPC_CheckPredicate, 30, 100, 32, 0, // Skip to: 19313
/* 11021 */   MCD::OPC_Decode, 147, 5, 131, 2, // Opcode: ASUB_U_W
/* 11026 */   MCD::OPC_FilterValue, 23, 90, 32, 0, // Skip to: 19313
/* 11031 */   MCD::OPC_CheckPredicate, 30, 85, 32, 0, // Skip to: 19313
/* 11036 */   MCD::OPC_Decode, 145, 5, 132, 2, // Opcode: ASUB_U_D
/* 11041 */   MCD::OPC_FilterValue, 18, 167, 1, 0, // Skip to: 11469
/* 11046 */   MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 11049 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 11064
/* 11054 */   MCD::OPC_CheckPredicate, 30, 62, 32, 0, // Skip to: 19313
/* 11059 */   MCD::OPC_Decode, 198, 16, 129, 2, // Opcode: MULV_B
/* 11064 */   MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 11079
/* 11069 */   MCD::OPC_CheckPredicate, 30, 47, 32, 0, // Skip to: 19313
/* 11074 */   MCD::OPC_Decode, 200, 16, 130, 2, // Opcode: MULV_H
/* 11079 */   MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 11094
/* 11084 */   MCD::OPC_CheckPredicate, 30, 32, 32, 0, // Skip to: 19313
/* 11089 */   MCD::OPC_Decode, 201, 16, 131, 2, // Opcode: MULV_W
/* 11094 */   MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 11109
/* 11099 */   MCD::OPC_CheckPredicate, 30, 17, 32, 0, // Skip to: 19313
/* 11104 */   MCD::OPC_Decode, 199, 16, 132, 2, // Opcode: MULV_D
/* 11109 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 11124
/* 11114 */   MCD::OPC_CheckPredicate, 30, 2, 32, 0, // Skip to: 19313
/* 11119 */   MCD::OPC_Decode, 186, 14, 133, 2, // Opcode: MADDV_B
/* 11124 */   MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 11139
/* 11129 */   MCD::OPC_CheckPredicate, 30, 243, 31, 0, // Skip to: 19313
/* 11134 */   MCD::OPC_Decode, 188, 14, 134, 2, // Opcode: MADDV_H
/* 11139 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 11154
/* 11144 */   MCD::OPC_CheckPredicate, 30, 228, 31, 0, // Skip to: 19313
/* 11149 */   MCD::OPC_Decode, 189, 14, 135, 2, // Opcode: MADDV_W
/* 11154 */   MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 11169
/* 11159 */   MCD::OPC_CheckPredicate, 30, 213, 31, 0, // Skip to: 19313
/* 11164 */   MCD::OPC_Decode, 187, 14, 136, 2, // Opcode: MADDV_D
/* 11169 */   MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 11184
/* 11174 */   MCD::OPC_CheckPredicate, 30, 198, 31, 0, // Skip to: 19313
/* 11179 */   MCD::OPC_Decode, 237, 15, 133, 2, // Opcode: MSUBV_B
/* 11184 */   MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 11199
/* 11189 */   MCD::OPC_CheckPredicate, 30, 183, 31, 0, // Skip to: 19313
/* 11194 */   MCD::OPC_Decode, 239, 15, 134, 2, // Opcode: MSUBV_H
/* 11199 */   MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 11214
/* 11204 */   MCD::OPC_CheckPredicate, 30, 168, 31, 0, // Skip to: 19313
/* 11209 */   MCD::OPC_Decode, 240, 15, 135, 2, // Opcode: MSUBV_W
/* 11214 */   MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 11229
/* 11219 */   MCD::OPC_CheckPredicate, 30, 153, 31, 0, // Skip to: 19313
/* 11224 */   MCD::OPC_Decode, 238, 15, 136, 2, // Opcode: MSUBV_D
/* 11229 */   MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 11244
/* 11234 */   MCD::OPC_CheckPredicate, 30, 138, 31, 0, // Skip to: 19313
/* 11239 */   MCD::OPC_Decode, 215, 9, 129, 2, // Opcode: DIV_S_B
/* 11244 */   MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 11259
/* 11249 */   MCD::OPC_CheckPredicate, 30, 123, 31, 0, // Skip to: 19313
/* 11254 */   MCD::OPC_Decode, 217, 9, 130, 2, // Opcode: DIV_S_H
/* 11259 */   MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 11274
/* 11264 */   MCD::OPC_CheckPredicate, 30, 108, 31, 0, // Skip to: 19313
/* 11269 */   MCD::OPC_Decode, 218, 9, 131, 2, // Opcode: DIV_S_W
/* 11274 */   MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 11289
/* 11279 */   MCD::OPC_CheckPredicate, 30, 93, 31, 0, // Skip to: 19313
/* 11284 */   MCD::OPC_Decode, 216, 9, 132, 2, // Opcode: DIV_S_D
/* 11289 */   MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 11304
/* 11294 */   MCD::OPC_CheckPredicate, 30, 78, 31, 0, // Skip to: 19313
/* 11299 */   MCD::OPC_Decode, 219, 9, 129, 2, // Opcode: DIV_U_B
/* 11304 */   MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 11319
/* 11309 */   MCD::OPC_CheckPredicate, 30, 63, 31, 0, // Skip to: 19313
/* 11314 */   MCD::OPC_Decode, 221, 9, 130, 2, // Opcode: DIV_U_H
/* 11319 */   MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 11334
/* 11324 */   MCD::OPC_CheckPredicate, 30, 48, 31, 0, // Skip to: 19313
/* 11329 */   MCD::OPC_Decode, 222, 9, 131, 2, // Opcode: DIV_U_W
/* 11334 */   MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 11349
/* 11339 */   MCD::OPC_CheckPredicate, 30, 33, 31, 0, // Skip to: 19313
/* 11344 */   MCD::OPC_Decode, 220, 9, 132, 2, // Opcode: DIV_U_D
/* 11349 */   MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 11364
/* 11354 */   MCD::OPC_CheckPredicate, 30, 18, 31, 0, // Skip to: 19313
/* 11359 */   MCD::OPC_Decode, 173, 15, 129, 2, // Opcode: MOD_S_B
/* 11364 */   MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 11379
/* 11369 */   MCD::OPC_CheckPredicate, 30, 3, 31, 0, // Skip to: 19313
/* 11374 */   MCD::OPC_Decode, 175, 15, 130, 2, // Opcode: MOD_S_H
/* 11379 */   MCD::OPC_FilterValue, 26, 10, 0, 0, // Skip to: 11394
/* 11384 */   MCD::OPC_CheckPredicate, 30, 244, 30, 0, // Skip to: 19313
/* 11389 */   MCD::OPC_Decode, 176, 15, 131, 2, // Opcode: MOD_S_W
/* 11394 */   MCD::OPC_FilterValue, 27, 10, 0, 0, // Skip to: 11409
/* 11399 */   MCD::OPC_CheckPredicate, 30, 229, 30, 0, // Skip to: 19313
/* 11404 */   MCD::OPC_Decode, 174, 15, 132, 2, // Opcode: MOD_S_D
/* 11409 */   MCD::OPC_FilterValue, 28, 10, 0, 0, // Skip to: 11424
/* 11414 */   MCD::OPC_CheckPredicate, 30, 214, 30, 0, // Skip to: 19313
/* 11419 */   MCD::OPC_Decode, 177, 15, 129, 2, // Opcode: MOD_U_B
/* 11424 */   MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 11439
/* 11429 */   MCD::OPC_CheckPredicate, 30, 199, 30, 0, // Skip to: 19313
/* 11434 */   MCD::OPC_Decode, 179, 15, 130, 2, // Opcode: MOD_U_H
/* 11439 */   MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 11454
/* 11444 */   MCD::OPC_CheckPredicate, 30, 184, 30, 0, // Skip to: 19313
/* 11449 */   MCD::OPC_Decode, 180, 15, 131, 2, // Opcode: MOD_U_W
/* 11454 */   MCD::OPC_FilterValue, 31, 174, 30, 0, // Skip to: 19313
/* 11459 */   MCD::OPC_CheckPredicate, 30, 169, 30, 0, // Skip to: 19313
/* 11464 */   MCD::OPC_Decode, 178, 15, 132, 2, // Opcode: MOD_U_D
/* 11469 */   MCD::OPC_FilterValue, 19, 17, 1, 0, // Skip to: 11747
/* 11474 */   MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 11477 */   MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 11492
/* 11482 */   MCD::OPC_CheckPredicate, 30, 146, 30, 0, // Skip to: 19313
/* 11487 */   MCD::OPC_Decode, 248, 9, 137, 2, // Opcode: DOTP_S_H
/* 11492 */   MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 11507
/* 11497 */   MCD::OPC_CheckPredicate, 30, 131, 30, 0, // Skip to: 19313
/* 11502 */   MCD::OPC_Decode, 249, 9, 138, 2, // Opcode: DOTP_S_W
/* 11507 */   MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 11522
/* 11512 */   MCD::OPC_CheckPredicate, 30, 116, 30, 0, // Skip to: 19313
/* 11517 */   MCD::OPC_Decode, 247, 9, 139, 2, // Opcode: DOTP_S_D
/* 11522 */   MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 11537
/* 11527 */   MCD::OPC_CheckPredicate, 30, 101, 30, 0, // Skip to: 19313
/* 11532 */   MCD::OPC_Decode, 251, 9, 137, 2, // Opcode: DOTP_U_H
/* 11537 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 11552
/* 11542 */   MCD::OPC_CheckPredicate, 30, 86, 30, 0, // Skip to: 19313
/* 11547 */   MCD::OPC_Decode, 252, 9, 138, 2, // Opcode: DOTP_U_W
/* 11552 */   MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 11567
/* 11557 */   MCD::OPC_CheckPredicate, 30, 71, 30, 0, // Skip to: 19313
/* 11562 */   MCD::OPC_Decode, 250, 9, 139, 2, // Opcode: DOTP_U_D
/* 11567 */   MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 11582
/* 11572 */   MCD::OPC_CheckPredicate, 30, 56, 30, 0, // Skip to: 19313
/* 11577 */   MCD::OPC_Decode, 254, 9, 140, 2, // Opcode: DPADD_S_H
/* 11582 */   MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 11597
/* 11587 */   MCD::OPC_CheckPredicate, 30, 41, 30, 0, // Skip to: 19313
/* 11592 */   MCD::OPC_Decode, 255, 9, 141, 2, // Opcode: DPADD_S_W
/* 11597 */   MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 11612
/* 11602 */   MCD::OPC_CheckPredicate, 30, 26, 30, 0, // Skip to: 19313
/* 11607 */   MCD::OPC_Decode, 253, 9, 142, 2, // Opcode: DPADD_S_D
/* 11612 */   MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 11627
/* 11617 */   MCD::OPC_CheckPredicate, 30, 11, 30, 0, // Skip to: 19313
/* 11622 */   MCD::OPC_Decode, 129, 10, 140, 2, // Opcode: DPADD_U_H
/* 11627 */   MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 11642
/* 11632 */   MCD::OPC_CheckPredicate, 30, 252, 29, 0, // Skip to: 19313
/* 11637 */   MCD::OPC_Decode, 130, 10, 141, 2, // Opcode: DPADD_U_W
/* 11642 */   MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 11657
/* 11647 */   MCD::OPC_CheckPredicate, 30, 237, 29, 0, // Skip to: 19313
/* 11652 */   MCD::OPC_Decode, 128, 10, 142, 2, // Opcode: DPADD_U_D
/* 11657 */   MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 11672
/* 11662 */   MCD::OPC_CheckPredicate, 30, 222, 29, 0, // Skip to: 19313
/* 11667 */   MCD::OPC_Decode, 157, 10, 140, 2, // Opcode: DPSUB_S_H
/* 11672 */   MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 11687
/* 11677 */   MCD::OPC_CheckPredicate, 30, 207, 29, 0, // Skip to: 19313
/* 11682 */   MCD::OPC_Decode, 158, 10, 141, 2, // Opcode: DPSUB_S_W
/* 11687 */   MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 11702
/* 11692 */   MCD::OPC_CheckPredicate, 30, 192, 29, 0, // Skip to: 19313
/* 11697 */   MCD::OPC_Decode, 156, 10, 142, 2, // Opcode: DPSUB_S_D
/* 11702 */   MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 11717
/* 11707 */   MCD::OPC_CheckPredicate, 30, 177, 29, 0, // Skip to: 19313
/* 11712 */   MCD::OPC_Decode, 160, 10, 140, 2, // Opcode: DPSUB_U_H
/* 11717 */   MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 11732
/* 11722 */   MCD::OPC_CheckPredicate, 30, 162, 29, 0, // Skip to: 19313
/* 11727 */   MCD::OPC_Decode, 161, 10, 141, 2, // Opcode: DPSUB_U_W
/* 11732 */   MCD::OPC_FilterValue, 23, 152, 29, 0, // Skip to: 19313
/* 11737 */   MCD::OPC_CheckPredicate, 30, 147, 29, 0, // Skip to: 19313
/* 11742 */   MCD::OPC_Decode, 159, 10, 142, 2, // Opcode: DPSUB_U_D
/* 11747 */   MCD::OPC_FilterValue, 20, 227, 1, 0, // Skip to: 12235
/* 11752 */   MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 11755 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 11770
/* 11760 */   MCD::OPC_CheckPredicate, 30, 124, 29, 0, // Skip to: 19313
/* 11765 */   MCD::OPC_Decode, 191, 19, 143, 2, // Opcode: SLD_B
/* 11770 */   MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 11785
/* 11775 */   MCD::OPC_CheckPredicate, 30, 109, 29, 0, // Skip to: 19313
/* 11780 */   MCD::OPC_Decode, 193, 19, 144, 2, // Opcode: SLD_H
/* 11785 */   MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 11800
/* 11790 */   MCD::OPC_CheckPredicate, 30, 94, 29, 0, // Skip to: 19313
/* 11795 */   MCD::OPC_Decode, 194, 19, 145, 2, // Opcode: SLD_W
/* 11800 */   MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 11815
/* 11805 */   MCD::OPC_CheckPredicate, 30, 79, 29, 0, // Skip to: 19313
/* 11810 */   MCD::OPC_Decode, 192, 19, 146, 2, // Opcode: SLD_D
/* 11815 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 11830
/* 11820 */   MCD::OPC_CheckPredicate, 30, 64, 29, 0, // Skip to: 19313
/* 11825 */   MCD::OPC_Decode, 230, 19, 147, 2, // Opcode: SPLAT_B
/* 11830 */   MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 11845
/* 11835 */   MCD::OPC_CheckPredicate, 30, 49, 29, 0, // Skip to: 19313
/* 11840 */   MCD::OPC_Decode, 232, 19, 148, 2, // Opcode: SPLAT_H
/* 11845 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 11860
/* 11850 */   MCD::OPC_CheckPredicate, 30, 34, 29, 0, // Skip to: 19313
/* 11855 */   MCD::OPC_Decode, 233, 19, 149, 2, // Opcode: SPLAT_W
/* 11860 */   MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 11875
/* 11865 */   MCD::OPC_CheckPredicate, 30, 19, 29, 0, // Skip to: 19313
/* 11870 */   MCD::OPC_Decode, 231, 19, 150, 2, // Opcode: SPLAT_D
/* 11875 */   MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 11890
/* 11880 */   MCD::OPC_CheckPredicate, 30, 4, 29, 0, // Skip to: 19313
/* 11885 */   MCD::OPC_Decode, 149, 17, 129, 2, // Opcode: PCKEV_B
/* 11890 */   MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 11905
/* 11895 */   MCD::OPC_CheckPredicate, 30, 245, 28, 0, // Skip to: 19313
/* 11900 */   MCD::OPC_Decode, 151, 17, 130, 2, // Opcode: PCKEV_H
/* 11905 */   MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 11920
/* 11910 */   MCD::OPC_CheckPredicate, 30, 230, 28, 0, // Skip to: 19313
/* 11915 */   MCD::OPC_Decode, 152, 17, 131, 2, // Opcode: PCKEV_W
/* 11920 */   MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 11935
/* 11925 */   MCD::OPC_CheckPredicate, 30, 215, 28, 0, // Skip to: 19313
/* 11930 */   MCD::OPC_Decode, 150, 17, 132, 2, // Opcode: PCKEV_D
/* 11935 */   MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 11950
/* 11940 */   MCD::OPC_CheckPredicate, 30, 200, 28, 0, // Skip to: 19313
/* 11945 */   MCD::OPC_Decode, 153, 17, 129, 2, // Opcode: PCKOD_B
/* 11950 */   MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 11965
/* 11955 */   MCD::OPC_CheckPredicate, 30, 185, 28, 0, // Skip to: 19313
/* 11960 */   MCD::OPC_Decode, 155, 17, 130, 2, // Opcode: PCKOD_H
/* 11965 */   MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 11980
/* 11970 */   MCD::OPC_CheckPredicate, 30, 170, 28, 0, // Skip to: 19313
/* 11975 */   MCD::OPC_Decode, 156, 17, 131, 2, // Opcode: PCKOD_W
/* 11980 */   MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 11995
/* 11985 */   MCD::OPC_CheckPredicate, 30, 155, 28, 0, // Skip to: 19313
/* 11990 */   MCD::OPC_Decode, 154, 17, 132, 2, // Opcode: PCKOD_D
/* 11995 */   MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 12010
/* 12000 */   MCD::OPC_CheckPredicate, 30, 140, 28, 0, // Skip to: 19313
/* 12005 */   MCD::OPC_Decode, 237, 12, 129, 2, // Opcode: ILVL_B
/* 12010 */   MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 12025
/* 12015 */   MCD::OPC_CheckPredicate, 30, 125, 28, 0, // Skip to: 19313
/* 12020 */   MCD::OPC_Decode, 239, 12, 130, 2, // Opcode: ILVL_H
/* 12025 */   MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 12040
/* 12030 */   MCD::OPC_CheckPredicate, 30, 110, 28, 0, // Skip to: 19313
/* 12035 */   MCD::OPC_Decode, 240, 12, 131, 2, // Opcode: ILVL_W
/* 12040 */   MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 12055
/* 12045 */   MCD::OPC_CheckPredicate, 30, 95, 28, 0, // Skip to: 19313
/* 12050 */   MCD::OPC_Decode, 238, 12, 132, 2, // Opcode: ILVL_D
/* 12055 */   MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 12070
/* 12060 */   MCD::OPC_CheckPredicate, 30, 80, 28, 0, // Skip to: 19313
/* 12065 */   MCD::OPC_Decode, 245, 12, 129, 2, // Opcode: ILVR_B
/* 12070 */   MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 12085
/* 12075 */   MCD::OPC_CheckPredicate, 30, 65, 28, 0, // Skip to: 19313
/* 12080 */   MCD::OPC_Decode, 247, 12, 130, 2, // Opcode: ILVR_H
/* 12085 */   MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 12100
/* 12090 */   MCD::OPC_CheckPredicate, 30, 50, 28, 0, // Skip to: 19313
/* 12095 */   MCD::OPC_Decode, 248, 12, 131, 2, // Opcode: ILVR_W
/* 12100 */   MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 12115
/* 12105 */   MCD::OPC_CheckPredicate, 30, 35, 28, 0, // Skip to: 19313
/* 12110 */   MCD::OPC_Decode, 246, 12, 132, 2, // Opcode: ILVR_D
/* 12115 */   MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 12130
/* 12120 */   MCD::OPC_CheckPredicate, 30, 20, 28, 0, // Skip to: 19313
/* 12125 */   MCD::OPC_Decode, 233, 12, 129, 2, // Opcode: ILVEV_B
/* 12130 */   MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 12145
/* 12135 */   MCD::OPC_CheckPredicate, 30, 5, 28, 0, // Skip to: 19313
/* 12140 */   MCD::OPC_Decode, 235, 12, 130, 2, // Opcode: ILVEV_H
/* 12145 */   MCD::OPC_FilterValue, 26, 10, 0, 0, // Skip to: 12160
/* 12150 */   MCD::OPC_CheckPredicate, 30, 246, 27, 0, // Skip to: 19313
/* 12155 */   MCD::OPC_Decode, 236, 12, 131, 2, // Opcode: ILVEV_W
/* 12160 */   MCD::OPC_FilterValue, 27, 10, 0, 0, // Skip to: 12175
/* 12165 */   MCD::OPC_CheckPredicate, 30, 231, 27, 0, // Skip to: 19313
/* 12170 */   MCD::OPC_Decode, 234, 12, 132, 2, // Opcode: ILVEV_D
/* 12175 */   MCD::OPC_FilterValue, 28, 10, 0, 0, // Skip to: 12190
/* 12180 */   MCD::OPC_CheckPredicate, 30, 216, 27, 0, // Skip to: 19313
/* 12185 */   MCD::OPC_Decode, 241, 12, 129, 2, // Opcode: ILVOD_B
/* 12190 */   MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 12205
/* 12195 */   MCD::OPC_CheckPredicate, 30, 201, 27, 0, // Skip to: 19313
/* 12200 */   MCD::OPC_Decode, 243, 12, 130, 2, // Opcode: ILVOD_H
/* 12205 */   MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 12220
/* 12210 */   MCD::OPC_CheckPredicate, 30, 186, 27, 0, // Skip to: 19313
/* 12215 */   MCD::OPC_Decode, 244, 12, 131, 2, // Opcode: ILVOD_W
/* 12220 */   MCD::OPC_FilterValue, 31, 176, 27, 0, // Skip to: 19313
/* 12225 */   MCD::OPC_CheckPredicate, 30, 171, 27, 0, // Skip to: 19313
/* 12230 */   MCD::OPC_Decode, 242, 12, 132, 2, // Opcode: ILVOD_D
/* 12235 */   MCD::OPC_FilterValue, 21, 107, 1, 0, // Skip to: 12603
/* 12240 */   MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 12243 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 12258
/* 12248 */   MCD::OPC_CheckPredicate, 30, 148, 27, 0, // Skip to: 19313
/* 12253 */   MCD::OPC_Decode, 230, 21, 133, 2, // Opcode: VSHF_B
/* 12258 */   MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 12273
/* 12263 */   MCD::OPC_CheckPredicate, 30, 133, 27, 0, // Skip to: 19313
/* 12268 */   MCD::OPC_Decode, 232, 21, 134, 2, // Opcode: VSHF_H
/* 12273 */   MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 12288
/* 12278 */   MCD::OPC_CheckPredicate, 30, 118, 27, 0, // Skip to: 19313
/* 12283 */   MCD::OPC_Decode, 233, 21, 135, 2, // Opcode: VSHF_W
/* 12288 */   MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 12303
/* 12293 */   MCD::OPC_CheckPredicate, 30, 103, 27, 0, // Skip to: 19313
/* 12298 */   MCD::OPC_Decode, 231, 21, 136, 2, // Opcode: VSHF_D
/* 12303 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 12318
/* 12308 */   MCD::OPC_CheckPredicate, 30, 88, 27, 0, // Skip to: 19313
/* 12313 */   MCD::OPC_Decode, 243, 19, 129, 2, // Opcode: SRAR_B
/* 12318 */   MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 12333
/* 12323 */   MCD::OPC_CheckPredicate, 30, 73, 27, 0, // Skip to: 19313
/* 12328 */   MCD::OPC_Decode, 245, 19, 130, 2, // Opcode: SRAR_H
/* 12333 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 12348
/* 12338 */   MCD::OPC_CheckPredicate, 30, 58, 27, 0, // Skip to: 19313
/* 12343 */   MCD::OPC_Decode, 246, 19, 131, 2, // Opcode: SRAR_W
/* 12348 */   MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 12363
/* 12353 */   MCD::OPC_CheckPredicate, 30, 43, 27, 0, // Skip to: 19313
/* 12358 */   MCD::OPC_Decode, 244, 19, 132, 2, // Opcode: SRAR_D
/* 12363 */   MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 12378
/* 12368 */   MCD::OPC_CheckPredicate, 30, 28, 27, 0, // Skip to: 19313
/* 12373 */   MCD::OPC_Decode, 137, 20, 129, 2, // Opcode: SRLR_B
/* 12378 */   MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 12393
/* 12383 */   MCD::OPC_CheckPredicate, 30, 13, 27, 0, // Skip to: 19313
/* 12388 */   MCD::OPC_Decode, 139, 20, 130, 2, // Opcode: SRLR_H
/* 12393 */   MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 12408
/* 12398 */   MCD::OPC_CheckPredicate, 30, 254, 26, 0, // Skip to: 19313
/* 12403 */   MCD::OPC_Decode, 140, 20, 131, 2, // Opcode: SRLR_W
/* 12408 */   MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 12423
/* 12413 */   MCD::OPC_CheckPredicate, 30, 239, 26, 0, // Skip to: 19313
/* 12418 */   MCD::OPC_Decode, 138, 20, 132, 2, // Opcode: SRLR_D
/* 12423 */   MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 12438
/* 12428 */   MCD::OPC_CheckPredicate, 30, 224, 26, 0, // Skip to: 19313
/* 12433 */   MCD::OPC_Decode, 220, 12, 137, 2, // Opcode: HADD_S_H
/* 12438 */   MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 12453
/* 12443 */   MCD::OPC_CheckPredicate, 30, 209, 26, 0, // Skip to: 19313
/* 12448 */   MCD::OPC_Decode, 221, 12, 138, 2, // Opcode: HADD_S_W
/* 12453 */   MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 12468
/* 12458 */   MCD::OPC_CheckPredicate, 30, 194, 26, 0, // Skip to: 19313
/* 12463 */   MCD::OPC_Decode, 219, 12, 139, 2, // Opcode: HADD_S_D
/* 12468 */   MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 12483
/* 12473 */   MCD::OPC_CheckPredicate, 30, 179, 26, 0, // Skip to: 19313
/* 12478 */   MCD::OPC_Decode, 223, 12, 137, 2, // Opcode: HADD_U_H
/* 12483 */   MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 12498
/* 12488 */   MCD::OPC_CheckPredicate, 30, 164, 26, 0, // Skip to: 19313
/* 12493 */   MCD::OPC_Decode, 224, 12, 138, 2, // Opcode: HADD_U_W
/* 12498 */   MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 12513
/* 12503 */   MCD::OPC_CheckPredicate, 30, 149, 26, 0, // Skip to: 19313
/* 12508 */   MCD::OPC_Decode, 222, 12, 139, 2, // Opcode: HADD_U_D
/* 12513 */   MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 12528
/* 12518 */   MCD::OPC_CheckPredicate, 30, 134, 26, 0, // Skip to: 19313
/* 12523 */   MCD::OPC_Decode, 226, 12, 137, 2, // Opcode: HSUB_S_H
/* 12528 */   MCD::OPC_FilterValue, 26, 10, 0, 0, // Skip to: 12543
/* 12533 */   MCD::OPC_CheckPredicate, 30, 119, 26, 0, // Skip to: 19313
/* 12538 */   MCD::OPC_Decode, 227, 12, 138, 2, // Opcode: HSUB_S_W
/* 12543 */   MCD::OPC_FilterValue, 27, 10, 0, 0, // Skip to: 12558
/* 12548 */   MCD::OPC_CheckPredicate, 30, 104, 26, 0, // Skip to: 19313
/* 12553 */   MCD::OPC_Decode, 225, 12, 139, 2, // Opcode: HSUB_S_D
/* 12558 */   MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 12573
/* 12563 */   MCD::OPC_CheckPredicate, 30, 89, 26, 0, // Skip to: 19313
/* 12568 */   MCD::OPC_Decode, 229, 12, 137, 2, // Opcode: HSUB_U_H
/* 12573 */   MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 12588
/* 12578 */   MCD::OPC_CheckPredicate, 30, 74, 26, 0, // Skip to: 19313
/* 12583 */   MCD::OPC_Decode, 230, 12, 138, 2, // Opcode: HSUB_U_W
/* 12588 */   MCD::OPC_FilterValue, 31, 64, 26, 0, // Skip to: 19313
/* 12593 */   MCD::OPC_CheckPredicate, 30, 59, 26, 0, // Skip to: 19313
/* 12598 */   MCD::OPC_Decode, 228, 12, 139, 2, // Opcode: HSUB_U_D
/* 12603 */   MCD::OPC_FilterValue, 25, 26, 2, 0, // Skip to: 13146
/* 12608 */   MCD::OPC_ExtractField, 20, 6,  // Inst{25-20} ...
/* 12611 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 12626
/* 12616 */   MCD::OPC_CheckPredicate, 30, 36, 26, 0, // Skip to: 19313
/* 12621 */   MCD::OPC_Decode, 187, 19, 151, 2, // Opcode: SLDI_B
/* 12626 */   MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 12648
/* 12631 */   MCD::OPC_CheckPredicate, 30, 21, 26, 0, // Skip to: 19313
/* 12636 */   MCD::OPC_CheckField, 19, 1, 0, 14, 26, 0, // Skip to: 19313
/* 12643 */   MCD::OPC_Decode, 189, 19, 152, 2, // Opcode: SLDI_H
/* 12648 */   MCD::OPC_FilterValue, 3, 62, 0, 0, // Skip to: 12715
/* 12653 */   MCD::OPC_ExtractField, 18, 2,  // Inst{19-18} ...
/* 12656 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 12671
/* 12661 */   MCD::OPC_CheckPredicate, 30, 247, 25, 0, // Skip to: 19313
/* 12666 */   MCD::OPC_Decode, 190, 19, 153, 2, // Opcode: SLDI_W
/* 12671 */   MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 12693
/* 12676 */   MCD::OPC_CheckPredicate, 30, 232, 25, 0, // Skip to: 19313
/* 12681 */   MCD::OPC_CheckField, 17, 1, 0, 225, 25, 0, // Skip to: 19313
/* 12688 */   MCD::OPC_Decode, 188, 19, 154, 2, // Opcode: SLDI_D
/* 12693 */   MCD::OPC_FilterValue, 3, 215, 25, 0, // Skip to: 19313
/* 12698 */   MCD::OPC_CheckPredicate, 30, 210, 25, 0, // Skip to: 19313
/* 12703 */   MCD::OPC_CheckField, 16, 2, 2, 203, 25, 0, // Skip to: 19313
/* 12710 */   MCD::OPC_Decode, 174, 8, 155, 2, // Opcode: CTCMSA
/* 12715 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 12730
/* 12720 */   MCD::OPC_CheckPredicate, 30, 188, 25, 0, // Skip to: 19313
/* 12725 */   MCD::OPC_Decode, 226, 19, 156, 2, // Opcode: SPLATI_B
/* 12730 */   MCD::OPC_FilterValue, 6, 17, 0, 0, // Skip to: 12752
/* 12735 */   MCD::OPC_CheckPredicate, 30, 173, 25, 0, // Skip to: 19313
/* 12740 */   MCD::OPC_CheckField, 19, 1, 0, 166, 25, 0, // Skip to: 19313
/* 12747 */   MCD::OPC_Decode, 228, 19, 157, 2, // Opcode: SPLATI_H
/* 12752 */   MCD::OPC_FilterValue, 7, 62, 0, 0, // Skip to: 12819
/* 12757 */   MCD::OPC_ExtractField, 18, 2,  // Inst{19-18} ...
/* 12760 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 12775
/* 12765 */   MCD::OPC_CheckPredicate, 30, 143, 25, 0, // Skip to: 19313
/* 12770 */   MCD::OPC_Decode, 229, 19, 158, 2, // Opcode: SPLATI_W
/* 12775 */   MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 12797
/* 12780 */   MCD::OPC_CheckPredicate, 30, 128, 25, 0, // Skip to: 19313
/* 12785 */   MCD::OPC_CheckField, 17, 1, 0, 121, 25, 0, // Skip to: 19313
/* 12792 */   MCD::OPC_Decode, 227, 19, 159, 2, // Opcode: SPLATI_D
/* 12797 */   MCD::OPC_FilterValue, 3, 111, 25, 0, // Skip to: 19313
/* 12802 */   MCD::OPC_CheckPredicate, 30, 106, 25, 0, // Skip to: 19313
/* 12807 */   MCD::OPC_CheckField, 16, 2, 2, 99, 25, 0, // Skip to: 19313
/* 12814 */   MCD::OPC_Decode, 147, 7, 160, 2, // Opcode: CFCMSA
/* 12819 */   MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 12834
/* 12824 */   MCD::OPC_CheckPredicate, 30, 84, 25, 0, // Skip to: 19313
/* 12829 */   MCD::OPC_Decode, 156, 8, 161, 2, // Opcode: COPY_S_B
/* 12834 */   MCD::OPC_FilterValue, 10, 17, 0, 0, // Skip to: 12856
/* 12839 */   MCD::OPC_CheckPredicate, 30, 69, 25, 0, // Skip to: 19313
/* 12844 */   MCD::OPC_CheckField, 19, 1, 0, 62, 25, 0, // Skip to: 19313
/* 12851 */   MCD::OPC_Decode, 158, 8, 162, 2, // Opcode: COPY_S_H
/* 12856 */   MCD::OPC_FilterValue, 11, 62, 0, 0, // Skip to: 12923
/* 12861 */   MCD::OPC_ExtractField, 18, 2,  // Inst{19-18} ...
/* 12864 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 12879
/* 12869 */   MCD::OPC_CheckPredicate, 30, 39, 25, 0, // Skip to: 19313
/* 12874 */   MCD::OPC_Decode, 159, 8, 163, 2, // Opcode: COPY_S_W
/* 12879 */   MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 12901
/* 12884 */   MCD::OPC_CheckPredicate, 38, 24, 25, 0, // Skip to: 19313
/* 12889 */   MCD::OPC_CheckField, 17, 1, 0, 17, 25, 0, // Skip to: 19313
/* 12896 */   MCD::OPC_Decode, 157, 8, 164, 2, // Opcode: COPY_S_D
/* 12901 */   MCD::OPC_FilterValue, 3, 7, 25, 0, // Skip to: 19313
/* 12906 */   MCD::OPC_CheckPredicate, 30, 2, 25, 0, // Skip to: 19313
/* 12911 */   MCD::OPC_CheckField, 16, 2, 2, 251, 24, 0, // Skip to: 19313
/* 12918 */   MCD::OPC_Decode, 185, 15, 165, 2, // Opcode: MOVE_V
/* 12923 */   MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 12938
/* 12928 */   MCD::OPC_CheckPredicate, 30, 236, 24, 0, // Skip to: 19313
/* 12933 */   MCD::OPC_Decode, 160, 8, 161, 2, // Opcode: COPY_U_B
/* 12938 */   MCD::OPC_FilterValue, 14, 17, 0, 0, // Skip to: 12960
/* 12943 */   MCD::OPC_CheckPredicate, 30, 221, 24, 0, // Skip to: 19313
/* 12948 */   MCD::OPC_CheckField, 19, 1, 0, 214, 24, 0, // Skip to: 19313
/* 12955 */   MCD::OPC_Decode, 161, 8, 162, 2, // Opcode: COPY_U_H
/* 12960 */   MCD::OPC_FilterValue, 15, 17, 0, 0, // Skip to: 12982
/* 12965 */   MCD::OPC_CheckPredicate, 38, 199, 24, 0, // Skip to: 19313
/* 12970 */   MCD::OPC_CheckField, 18, 2, 0, 192, 24, 0, // Skip to: 19313
/* 12977 */   MCD::OPC_Decode, 162, 8, 163, 2, // Opcode: COPY_U_W
/* 12982 */   MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 12997
/* 12987 */   MCD::OPC_CheckPredicate, 30, 177, 24, 0, // Skip to: 19313
/* 12992 */   MCD::OPC_Decode, 250, 12, 166, 2, // Opcode: INSERT_B
/* 12997 */   MCD::OPC_FilterValue, 18, 17, 0, 0, // Skip to: 13019
/* 13002 */   MCD::OPC_CheckPredicate, 30, 162, 24, 0, // Skip to: 19313
/* 13007 */   MCD::OPC_CheckField, 19, 1, 0, 155, 24, 0, // Skip to: 19313
/* 13014 */   MCD::OPC_Decode, 252, 12, 167, 2, // Opcode: INSERT_H
/* 13019 */   MCD::OPC_FilterValue, 19, 40, 0, 0, // Skip to: 13064
/* 13024 */   MCD::OPC_ExtractField, 18, 2,  // Inst{19-18} ...
/* 13027 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 13042
/* 13032 */   MCD::OPC_CheckPredicate, 30, 132, 24, 0, // Skip to: 19313
/* 13037 */   MCD::OPC_Decode, 253, 12, 168, 2, // Opcode: INSERT_W
/* 13042 */   MCD::OPC_FilterValue, 2, 122, 24, 0, // Skip to: 19313
/* 13047 */   MCD::OPC_CheckPredicate, 38, 117, 24, 0, // Skip to: 19313
/* 13052 */   MCD::OPC_CheckField, 17, 1, 0, 110, 24, 0, // Skip to: 19313
/* 13059 */   MCD::OPC_Decode, 251, 12, 169, 2, // Opcode: INSERT_D
/* 13064 */   MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 13079
/* 13069 */   MCD::OPC_CheckPredicate, 30, 95, 24, 0, // Skip to: 19313
/* 13074 */   MCD::OPC_Decode, 255, 12, 170, 2, // Opcode: INSVE_B
/* 13079 */   MCD::OPC_FilterValue, 22, 17, 0, 0, // Skip to: 13101
/* 13084 */   MCD::OPC_CheckPredicate, 30, 80, 24, 0, // Skip to: 19313
/* 13089 */   MCD::OPC_CheckField, 19, 1, 0, 73, 24, 0, // Skip to: 19313
/* 13096 */   MCD::OPC_Decode, 129, 13, 170, 2, // Opcode: INSVE_H
/* 13101 */   MCD::OPC_FilterValue, 23, 63, 24, 0, // Skip to: 19313
/* 13106 */   MCD::OPC_ExtractField, 18, 2,  // Inst{19-18} ...
/* 13109 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 13124
/* 13114 */   MCD::OPC_CheckPredicate, 30, 50, 24, 0, // Skip to: 19313
/* 13119 */   MCD::OPC_Decode, 130, 13, 170, 2, // Opcode: INSVE_W
/* 13124 */   MCD::OPC_FilterValue, 2, 40, 24, 0, // Skip to: 19313
/* 13129 */   MCD::OPC_CheckPredicate, 30, 35, 24, 0, // Skip to: 19313
/* 13134 */   MCD::OPC_CheckField, 17, 1, 0, 28, 24, 0, // Skip to: 19313
/* 13141 */   MCD::OPC_Decode, 128, 13, 170, 2, // Opcode: INSVE_D
/* 13146 */   MCD::OPC_FilterValue, 26, 227, 1, 0, // Skip to: 13634
/* 13151 */   MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 13154 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 13169
/* 13159 */   MCD::OPC_CheckPredicate, 30, 5, 24, 0, // Skip to: 19313
/* 13164 */   MCD::OPC_Decode, 254, 10, 131, 2, // Opcode: FCAF_W
/* 13169 */   MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 13184
/* 13174 */   MCD::OPC_CheckPredicate, 30, 246, 23, 0, // Skip to: 19313
/* 13179 */   MCD::OPC_Decode, 253, 10, 132, 2, // Opcode: FCAF_D
/* 13184 */   MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 13199
/* 13189 */   MCD::OPC_CheckPredicate, 30, 231, 23, 0, // Skip to: 19313
/* 13194 */   MCD::OPC_Decode, 153, 11, 131, 2, // Opcode: FCUN_W
/* 13199 */   MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 13214
/* 13204 */   MCD::OPC_CheckPredicate, 30, 216, 23, 0, // Skip to: 19313
/* 13209 */   MCD::OPC_Decode, 152, 11, 132, 2, // Opcode: FCUN_D
/* 13214 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 13229
/* 13219 */   MCD::OPC_CheckPredicate, 30, 201, 23, 0, // Skip to: 19313
/* 13224 */   MCD::OPC_Decode, 128, 11, 131, 2, // Opcode: FCEQ_W
/* 13229 */   MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 13244
/* 13234 */   MCD::OPC_CheckPredicate, 30, 186, 23, 0, // Skip to: 19313
/* 13239 */   MCD::OPC_Decode, 255, 10, 132, 2, // Opcode: FCEQ_D
/* 13244 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 13259
/* 13249 */   MCD::OPC_CheckPredicate, 30, 171, 23, 0, // Skip to: 19313
/* 13254 */   MCD::OPC_Decode, 145, 11, 131, 2, // Opcode: FCUEQ_W
/* 13259 */   MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 13274
/* 13264 */   MCD::OPC_CheckPredicate, 30, 156, 23, 0, // Skip to: 19313
/* 13269 */   MCD::OPC_Decode, 144, 11, 132, 2, // Opcode: FCUEQ_D
/* 13274 */   MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 13289
/* 13279 */   MCD::OPC_CheckPredicate, 30, 141, 23, 0, // Skip to: 19313
/* 13284 */   MCD::OPC_Decode, 134, 11, 131, 2, // Opcode: FCLT_W
/* 13289 */   MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 13304
/* 13294 */   MCD::OPC_CheckPredicate, 30, 126, 23, 0, // Skip to: 19313
/* 13299 */   MCD::OPC_Decode, 133, 11, 132, 2, // Opcode: FCLT_D
/* 13304 */   MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 13319
/* 13309 */   MCD::OPC_CheckPredicate, 30, 111, 23, 0, // Skip to: 19313
/* 13314 */   MCD::OPC_Decode, 149, 11, 131, 2, // Opcode: FCULT_W
/* 13319 */   MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 13334
/* 13324 */   MCD::OPC_CheckPredicate, 30, 96, 23, 0, // Skip to: 19313
/* 13329 */   MCD::OPC_Decode, 148, 11, 132, 2, // Opcode: FCULT_D
/* 13334 */   MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 13349
/* 13339 */   MCD::OPC_CheckPredicate, 30, 81, 23, 0, // Skip to: 19313
/* 13344 */   MCD::OPC_Decode, 132, 11, 131, 2, // Opcode: FCLE_W
/* 13349 */   MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 13364
/* 13354 */   MCD::OPC_CheckPredicate, 30, 66, 23, 0, // Skip to: 19313
/* 13359 */   MCD::OPC_Decode, 131, 11, 132, 2, // Opcode: FCLE_D
/* 13364 */   MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 13379
/* 13369 */   MCD::OPC_CheckPredicate, 30, 51, 23, 0, // Skip to: 19313
/* 13374 */   MCD::OPC_Decode, 147, 11, 131, 2, // Opcode: FCULE_W
/* 13379 */   MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 13394
/* 13384 */   MCD::OPC_CheckPredicate, 30, 36, 23, 0, // Skip to: 19313
/* 13389 */   MCD::OPC_Decode, 146, 11, 132, 2, // Opcode: FCULE_D
/* 13394 */   MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 13409
/* 13399 */   MCD::OPC_CheckPredicate, 30, 21, 23, 0, // Skip to: 19313
/* 13404 */   MCD::OPC_Decode, 239, 11, 131, 2, // Opcode: FSAF_W
/* 13409 */   MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 13424
/* 13414 */   MCD::OPC_CheckPredicate, 30, 6, 23, 0, // Skip to: 19313
/* 13419 */   MCD::OPC_Decode, 238, 11, 132, 2, // Opcode: FSAF_D
/* 13424 */   MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 13439
/* 13429 */   MCD::OPC_CheckPredicate, 30, 247, 22, 0, // Skip to: 19313
/* 13434 */   MCD::OPC_Decode, 148, 12, 131, 2, // Opcode: FSUN_W
/* 13439 */   MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 13454
/* 13444 */   MCD::OPC_CheckPredicate, 30, 232, 22, 0, // Skip to: 19313
/* 13449 */   MCD::OPC_Decode, 147, 12, 132, 2, // Opcode: FSUN_D
/* 13454 */   MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 13469
/* 13459 */   MCD::OPC_CheckPredicate, 30, 217, 22, 0, // Skip to: 19313
/* 13464 */   MCD::OPC_Decode, 241, 11, 131, 2, // Opcode: FSEQ_W
/* 13469 */   MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 13484
/* 13474 */   MCD::OPC_CheckPredicate, 30, 202, 22, 0, // Skip to: 19313
/* 13479 */   MCD::OPC_Decode, 240, 11, 132, 2, // Opcode: FSEQ_D
/* 13484 */   MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 13499
/* 13489 */   MCD::OPC_CheckPredicate, 30, 187, 22, 0, // Skip to: 19313
/* 13494 */   MCD::OPC_Decode, 140, 12, 131, 2, // Opcode: FSUEQ_W
/* 13499 */   MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 13514
/* 13504 */   MCD::OPC_CheckPredicate, 30, 172, 22, 0, // Skip to: 19313
/* 13509 */   MCD::OPC_Decode, 139, 12, 132, 2, // Opcode: FSUEQ_D
/* 13514 */   MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 13529
/* 13519 */   MCD::OPC_CheckPredicate, 30, 157, 22, 0, // Skip to: 19313
/* 13524 */   MCD::OPC_Decode, 245, 11, 131, 2, // Opcode: FSLT_W
/* 13529 */   MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 13544
/* 13534 */   MCD::OPC_CheckPredicate, 30, 142, 22, 0, // Skip to: 19313
/* 13539 */   MCD::OPC_Decode, 244, 11, 132, 2, // Opcode: FSLT_D
/* 13544 */   MCD::OPC_FilterValue, 26, 10, 0, 0, // Skip to: 13559
/* 13549 */   MCD::OPC_CheckPredicate, 30, 127, 22, 0, // Skip to: 19313
/* 13554 */   MCD::OPC_Decode, 144, 12, 131, 2, // Opcode: FSULT_W
/* 13559 */   MCD::OPC_FilterValue, 27, 10, 0, 0, // Skip to: 13574
/* 13564 */   MCD::OPC_CheckPredicate, 30, 112, 22, 0, // Skip to: 19313
/* 13569 */   MCD::OPC_Decode, 143, 12, 132, 2, // Opcode: FSULT_D
/* 13574 */   MCD::OPC_FilterValue, 28, 10, 0, 0, // Skip to: 13589
/* 13579 */   MCD::OPC_CheckPredicate, 30, 97, 22, 0, // Skip to: 19313
/* 13584 */   MCD::OPC_Decode, 243, 11, 131, 2, // Opcode: FSLE_W
/* 13589 */   MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 13604
/* 13594 */   MCD::OPC_CheckPredicate, 30, 82, 22, 0, // Skip to: 19313
/* 13599 */   MCD::OPC_Decode, 242, 11, 132, 2, // Opcode: FSLE_D
/* 13604 */   MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 13619
/* 13609 */   MCD::OPC_CheckPredicate, 30, 67, 22, 0, // Skip to: 19313
/* 13614 */   MCD::OPC_Decode, 142, 12, 131, 2, // Opcode: FSULE_W
/* 13619 */   MCD::OPC_FilterValue, 31, 57, 22, 0, // Skip to: 19313
/* 13624 */   MCD::OPC_CheckPredicate, 30, 52, 22, 0, // Skip to: 19313
/* 13629 */   MCD::OPC_Decode, 141, 12, 132, 2, // Opcode: FSULE_D
/* 13634 */   MCD::OPC_FilterValue, 27, 137, 1, 0, // Skip to: 14032
/* 13639 */   MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 13642 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 13657
/* 13647 */   MCD::OPC_CheckPredicate, 30, 29, 22, 0, // Skip to: 19313
/* 13652 */   MCD::OPC_Decode, 252, 10, 131, 2, // Opcode: FADD_W
/* 13657 */   MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 13672
/* 13662 */   MCD::OPC_CheckPredicate, 30, 14, 22, 0, // Skip to: 19313
/* 13667 */   MCD::OPC_Decode, 244, 10, 132, 2, // Opcode: FADD_D
/* 13672 */   MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 13687
/* 13677 */   MCD::OPC_CheckPredicate, 30, 255, 21, 0, // Skip to: 19313
/* 13682 */   MCD::OPC_Decode, 138, 12, 131, 2, // Opcode: FSUB_W
/* 13687 */   MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 13702
/* 13692 */   MCD::OPC_CheckPredicate, 30, 240, 21, 0, // Skip to: 19313
/* 13697 */   MCD::OPC_Decode, 130, 12, 132, 2, // Opcode: FSUB_D
/* 13702 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 13717
/* 13707 */   MCD::OPC_CheckPredicate, 30, 225, 21, 0, // Skip to: 19313
/* 13712 */   MCD::OPC_Decode, 223, 11, 131, 2, // Opcode: FMUL_W
/* 13717 */   MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 13732
/* 13722 */   MCD::OPC_CheckPredicate, 30, 210, 21, 0, // Skip to: 19313
/* 13727 */   MCD::OPC_Decode, 215, 11, 132, 2, // Opcode: FMUL_D
/* 13732 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 13747
/* 13737 */   MCD::OPC_CheckPredicate, 30, 195, 21, 0, // Skip to: 19313
/* 13742 */   MCD::OPC_Decode, 162, 11, 131, 2, // Opcode: FDIV_W
/* 13747 */   MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 13762
/* 13752 */   MCD::OPC_CheckPredicate, 30, 180, 21, 0, // Skip to: 19313
/* 13757 */   MCD::OPC_Decode, 154, 11, 132, 2, // Opcode: FDIV_D
/* 13762 */   MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 13777
/* 13767 */   MCD::OPC_CheckPredicate, 30, 165, 21, 0, // Skip to: 19313
/* 13772 */   MCD::OPC_Decode, 197, 11, 135, 2, // Opcode: FMADD_W
/* 13777 */   MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 13792
/* 13782 */   MCD::OPC_CheckPredicate, 30, 150, 21, 0, // Skip to: 19313
/* 13787 */   MCD::OPC_Decode, 196, 11, 136, 2, // Opcode: FMADD_D
/* 13792 */   MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 13807
/* 13797 */   MCD::OPC_CheckPredicate, 30, 135, 21, 0, // Skip to: 19313
/* 13802 */   MCD::OPC_Decode, 214, 11, 135, 2, // Opcode: FMSUB_W
/* 13807 */   MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 13822
/* 13812 */   MCD::OPC_CheckPredicate, 30, 120, 21, 0, // Skip to: 19313
/* 13817 */   MCD::OPC_Decode, 213, 11, 136, 2, // Opcode: FMSUB_D
/* 13822 */   MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 13837
/* 13827 */   MCD::OPC_CheckPredicate, 30, 105, 21, 0, // Skip to: 19313
/* 13832 */   MCD::OPC_Decode, 166, 11, 131, 2, // Opcode: FEXP2_W
/* 13837 */   MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 13852
/* 13842 */   MCD::OPC_CheckPredicate, 30, 90, 21, 0, // Skip to: 19313
/* 13847 */   MCD::OPC_Decode, 165, 11, 132, 2, // Opcode: FEXP2_D
/* 13852 */   MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 13867
/* 13857 */   MCD::OPC_CheckPredicate, 30, 75, 21, 0, // Skip to: 19313
/* 13862 */   MCD::OPC_Decode, 163, 11, 171, 2, // Opcode: FEXDO_H
/* 13867 */   MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 13882
/* 13872 */   MCD::OPC_CheckPredicate, 30, 60, 21, 0, // Skip to: 19313
/* 13877 */   MCD::OPC_Decode, 164, 11, 172, 2, // Opcode: FEXDO_W
/* 13882 */   MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 13897
/* 13887 */   MCD::OPC_CheckPredicate, 30, 45, 21, 0, // Skip to: 19313
/* 13892 */   MCD::OPC_Decode, 153, 12, 171, 2, // Opcode: FTQ_H
/* 13897 */   MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 13912
/* 13902 */   MCD::OPC_CheckPredicate, 30, 30, 21, 0, // Skip to: 19313
/* 13907 */   MCD::OPC_Decode, 154, 12, 172, 2, // Opcode: FTQ_W
/* 13912 */   MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 13927
/* 13917 */   MCD::OPC_CheckPredicate, 30, 15, 21, 0, // Skip to: 19313
/* 13922 */   MCD::OPC_Decode, 205, 11, 131, 2, // Opcode: FMIN_W
/* 13927 */   MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 13942
/* 13932 */   MCD::OPC_CheckPredicate, 30, 0, 21, 0, // Skip to: 19313
/* 13937 */   MCD::OPC_Decode, 204, 11, 132, 2, // Opcode: FMIN_D
/* 13942 */   MCD::OPC_FilterValue, 26, 10, 0, 0, // Skip to: 13957
/* 13947 */   MCD::OPC_CheckPredicate, 30, 241, 20, 0, // Skip to: 19313
/* 13952 */   MCD::OPC_Decode, 203, 11, 131, 2, // Opcode: FMIN_A_W
/* 13957 */   MCD::OPC_FilterValue, 27, 10, 0, 0, // Skip to: 13972
/* 13962 */   MCD::OPC_CheckPredicate, 30, 226, 20, 0, // Skip to: 19313
/* 13967 */   MCD::OPC_Decode, 202, 11, 132, 2, // Opcode: FMIN_A_D
/* 13972 */   MCD::OPC_FilterValue, 28, 10, 0, 0, // Skip to: 13987
/* 13977 */   MCD::OPC_CheckPredicate, 30, 211, 20, 0, // Skip to: 19313
/* 13982 */   MCD::OPC_Decode, 201, 11, 131, 2, // Opcode: FMAX_W
/* 13987 */   MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 14002
/* 13992 */   MCD::OPC_CheckPredicate, 30, 196, 20, 0, // Skip to: 19313
/* 13997 */   MCD::OPC_Decode, 200, 11, 132, 2, // Opcode: FMAX_D
/* 14002 */   MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 14017
/* 14007 */   MCD::OPC_CheckPredicate, 30, 181, 20, 0, // Skip to: 19313
/* 14012 */   MCD::OPC_Decode, 199, 11, 131, 2, // Opcode: FMAX_A_W
/* 14017 */   MCD::OPC_FilterValue, 31, 171, 20, 0, // Skip to: 19313
/* 14022 */   MCD::OPC_CheckPredicate, 30, 166, 20, 0, // Skip to: 19313
/* 14027 */   MCD::OPC_Decode, 198, 11, 132, 2, // Opcode: FMAX_A_D
/* 14032 */   MCD::OPC_FilterValue, 28, 107, 1, 0, // Skip to: 14400
/* 14037 */   MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 14040 */   MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 14055
/* 14045 */   MCD::OPC_CheckPredicate, 30, 143, 20, 0, // Skip to: 19313
/* 14050 */   MCD::OPC_Decode, 143, 11, 131, 2, // Opcode: FCOR_W
/* 14055 */   MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 14070
/* 14060 */   MCD::OPC_CheckPredicate, 30, 128, 20, 0, // Skip to: 19313
/* 14065 */   MCD::OPC_Decode, 142, 11, 132, 2, // Opcode: FCOR_D
/* 14070 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 14085
/* 14075 */   MCD::OPC_CheckPredicate, 30, 113, 20, 0, // Skip to: 19313
/* 14080 */   MCD::OPC_Decode, 151, 11, 131, 2, // Opcode: FCUNE_W
/* 14085 */   MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 14100
/* 14090 */   MCD::OPC_CheckPredicate, 30, 98, 20, 0, // Skip to: 19313
/* 14095 */   MCD::OPC_Decode, 150, 11, 132, 2, // Opcode: FCUNE_D
/* 14100 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 14115
/* 14105 */   MCD::OPC_CheckPredicate, 30, 83, 20, 0, // Skip to: 19313
/* 14110 */   MCD::OPC_Decode, 141, 11, 131, 2, // Opcode: FCNE_W
/* 14115 */   MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 14130
/* 14120 */   MCD::OPC_CheckPredicate, 30, 68, 20, 0, // Skip to: 19313
/* 14125 */   MCD::OPC_Decode, 140, 11, 132, 2, // Opcode: FCNE_D
/* 14130 */   MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 14145
/* 14135 */   MCD::OPC_CheckPredicate, 30, 53, 20, 0, // Skip to: 19313
/* 14140 */   MCD::OPC_Decode, 206, 16, 130, 2, // Opcode: MUL_Q_H
/* 14145 */   MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 14160
/* 14150 */   MCD::OPC_CheckPredicate, 30, 38, 20, 0, // Skip to: 19313
/* 14155 */   MCD::OPC_Decode, 207, 16, 131, 2, // Opcode: MUL_Q_W
/* 14160 */   MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 14175
/* 14165 */   MCD::OPC_CheckPredicate, 30, 23, 20, 0, // Skip to: 19313
/* 14170 */   MCD::OPC_Decode, 196, 14, 134, 2, // Opcode: MADD_Q_H
/* 14175 */   MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 14190
/* 14180 */   MCD::OPC_CheckPredicate, 30, 8, 20, 0, // Skip to: 19313
/* 14185 */   MCD::OPC_Decode, 197, 14, 135, 2, // Opcode: MADD_Q_W
/* 14190 */   MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 14205
/* 14195 */   MCD::OPC_CheckPredicate, 30, 249, 19, 0, // Skip to: 19313
/* 14200 */   MCD::OPC_Decode, 247, 15, 134, 2, // Opcode: MSUB_Q_H
/* 14205 */   MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 14220
/* 14210 */   MCD::OPC_CheckPredicate, 30, 234, 19, 0, // Skip to: 19313
/* 14215 */   MCD::OPC_Decode, 248, 15, 135, 2, // Opcode: MSUB_Q_W
/* 14220 */   MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 14235
/* 14225 */   MCD::OPC_CheckPredicate, 30, 219, 19, 0, // Skip to: 19313
/* 14230 */   MCD::OPC_Decode, 249, 11, 131, 2, // Opcode: FSOR_W
/* 14235 */   MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 14250
/* 14240 */   MCD::OPC_CheckPredicate, 30, 204, 19, 0, // Skip to: 19313
/* 14245 */   MCD::OPC_Decode, 248, 11, 132, 2, // Opcode: FSOR_D
/* 14250 */   MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 14265
/* 14255 */   MCD::OPC_CheckPredicate, 30, 189, 19, 0, // Skip to: 19313
/* 14260 */   MCD::OPC_Decode, 146, 12, 131, 2, // Opcode: FSUNE_W
/* 14265 */   MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 14280
/* 14270 */   MCD::OPC_CheckPredicate, 30, 174, 19, 0, // Skip to: 19313
/* 14275 */   MCD::OPC_Decode, 145, 12, 132, 2, // Opcode: FSUNE_D
/* 14280 */   MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 14295
/* 14285 */   MCD::OPC_CheckPredicate, 30, 159, 19, 0, // Skip to: 19313
/* 14290 */   MCD::OPC_Decode, 247, 11, 131, 2, // Opcode: FSNE_W
/* 14295 */   MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 14310
/* 14300 */   MCD::OPC_CheckPredicate, 30, 144, 19, 0, // Skip to: 19313
/* 14305 */   MCD::OPC_Decode, 246, 11, 132, 2, // Opcode: FSNE_D
/* 14310 */   MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 14325
/* 14315 */   MCD::OPC_CheckPredicate, 30, 129, 19, 0, // Skip to: 19313
/* 14320 */   MCD::OPC_Decode, 182, 16, 130, 2, // Opcode: MULR_Q_H
/* 14325 */   MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 14340
/* 14330 */   MCD::OPC_CheckPredicate, 30, 114, 19, 0, // Skip to: 19313
/* 14335 */   MCD::OPC_Decode, 183, 16, 131, 2, // Opcode: MULR_Q_W
/* 14340 */   MCD::OPC_FilterValue, 26, 10, 0, 0, // Skip to: 14355
/* 14345 */   MCD::OPC_CheckPredicate, 30, 99, 19, 0, // Skip to: 19313
/* 14350 */   MCD::OPC_Decode, 180, 14, 134, 2, // Opcode: MADDR_Q_H
/* 14355 */   MCD::OPC_FilterValue, 27, 10, 0, 0, // Skip to: 14370
/* 14360 */   MCD::OPC_CheckPredicate, 30, 84, 19, 0, // Skip to: 19313
/* 14365 */   MCD::OPC_Decode, 181, 14, 135, 2, // Opcode: MADDR_Q_W
/* 14370 */   MCD::OPC_FilterValue, 28, 10, 0, 0, // Skip to: 14385
/* 14375 */   MCD::OPC_CheckPredicate, 30, 69, 19, 0, // Skip to: 19313
/* 14380 */   MCD::OPC_Decode, 231, 15, 134, 2, // Opcode: MSUBR_Q_H
/* 14385 */   MCD::OPC_FilterValue, 29, 59, 19, 0, // Skip to: 19313
/* 14390 */   MCD::OPC_CheckPredicate, 30, 54, 19, 0, // Skip to: 19313
/* 14395 */   MCD::OPC_Decode, 232, 15, 135, 2, // Opcode: MSUBR_Q_W
/* 14400 */   MCD::OPC_FilterValue, 30, 76, 3, 0, // Skip to: 15249
/* 14405 */   MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 14408 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 14423
/* 14413 */   MCD::OPC_CheckPredicate, 30, 31, 19, 0, // Skip to: 19313
/* 14418 */   MCD::OPC_Decode, 134, 5, 129, 2, // Opcode: AND_V
/* 14423 */   MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 14438
/* 14428 */   MCD::OPC_CheckPredicate, 30, 16, 19, 0, // Skip to: 19313
/* 14433 */   MCD::OPC_Decode, 251, 16, 129, 2, // Opcode: OR_V
/* 14438 */   MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 14453
/* 14443 */   MCD::OPC_CheckPredicate, 30, 1, 19, 0, // Skip to: 19313
/* 14448 */   MCD::OPC_Decode, 238, 16, 129, 2, // Opcode: NOR_V
/* 14453 */   MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 14468
/* 14458 */   MCD::OPC_CheckPredicate, 30, 242, 18, 0, // Skip to: 19313
/* 14463 */   MCD::OPC_Decode, 251, 21, 129, 2, // Opcode: XOR_V
/* 14468 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 14483
/* 14473 */   MCD::OPC_CheckPredicate, 30, 227, 18, 0, // Skip to: 19313
/* 14478 */   MCD::OPC_Decode, 178, 6, 133, 2, // Opcode: BMNZ_V
/* 14483 */   MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 14498
/* 14488 */   MCD::OPC_CheckPredicate, 30, 212, 18, 0, // Skip to: 19313
/* 14493 */   MCD::OPC_Decode, 180, 6, 133, 2, // Opcode: BMZ_V
/* 14498 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 14513
/* 14503 */   MCD::OPC_CheckPredicate, 30, 197, 18, 0, // Skip to: 19313
/* 14508 */   MCD::OPC_Decode, 222, 6, 133, 2, // Opcode: BSEL_V
/* 14513 */   MCD::OPC_FilterValue, 24, 243, 0, 0, // Skip to: 14761
/* 14518 */   MCD::OPC_ExtractField, 16, 5,  // Inst{20-16} ...
/* 14521 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 14536
/* 14526 */   MCD::OPC_CheckPredicate, 30, 174, 18, 0, // Skip to: 19313
/* 14531 */   MCD::OPC_Decode, 179, 11, 173, 2, // Opcode: FILL_B
/* 14536 */   MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 14551
/* 14541 */   MCD::OPC_CheckPredicate, 30, 159, 18, 0, // Skip to: 19313
/* 14546 */   MCD::OPC_Decode, 181, 11, 174, 2, // Opcode: FILL_H
/* 14551 */   MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 14566
/* 14556 */   MCD::OPC_CheckPredicate, 30, 144, 18, 0, // Skip to: 19313
/* 14561 */   MCD::OPC_Decode, 182, 11, 175, 2, // Opcode: FILL_W
/* 14566 */   MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 14581
/* 14571 */   MCD::OPC_CheckPredicate, 38, 129, 18, 0, // Skip to: 19313
/* 14576 */   MCD::OPC_Decode, 180, 11, 176, 2, // Opcode: FILL_D
/* 14581 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 14596
/* 14586 */   MCD::OPC_CheckPredicate, 30, 114, 18, 0, // Skip to: 19313
/* 14591 */   MCD::OPC_Decode, 163, 17, 165, 2, // Opcode: PCNT_B
/* 14596 */   MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 14611
/* 14601 */   MCD::OPC_CheckPredicate, 30, 99, 18, 0, // Skip to: 19313
/* 14606 */   MCD::OPC_Decode, 165, 17, 177, 2, // Opcode: PCNT_H
/* 14611 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 14626
/* 14616 */   MCD::OPC_CheckPredicate, 30, 84, 18, 0, // Skip to: 19313
/* 14621 */   MCD::OPC_Decode, 166, 17, 178, 2, // Opcode: PCNT_W
/* 14626 */   MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 14641
/* 14631 */   MCD::OPC_CheckPredicate, 30, 69, 18, 0, // Skip to: 19313
/* 14636 */   MCD::OPC_Decode, 164, 17, 179, 2, // Opcode: PCNT_D
/* 14641 */   MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 14656
/* 14646 */   MCD::OPC_CheckPredicate, 30, 54, 18, 0, // Skip to: 19313
/* 14651 */   MCD::OPC_Decode, 215, 16, 165, 2, // Opcode: NLOC_B
/* 14656 */   MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 14671
/* 14661 */   MCD::OPC_CheckPredicate, 30, 39, 18, 0, // Skip to: 19313
/* 14666 */   MCD::OPC_Decode, 217, 16, 177, 2, // Opcode: NLOC_H
/* 14671 */   MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 14686
/* 14676 */   MCD::OPC_CheckPredicate, 30, 24, 18, 0, // Skip to: 19313
/* 14681 */   MCD::OPC_Decode, 218, 16, 178, 2, // Opcode: NLOC_W
/* 14686 */   MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 14701
/* 14691 */   MCD::OPC_CheckPredicate, 30, 9, 18, 0, // Skip to: 19313
/* 14696 */   MCD::OPC_Decode, 216, 16, 179, 2, // Opcode: NLOC_D
/* 14701 */   MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 14716
/* 14706 */   MCD::OPC_CheckPredicate, 30, 250, 17, 0, // Skip to: 19313
/* 14711 */   MCD::OPC_Decode, 219, 16, 165, 2, // Opcode: NLZC_B
/* 14716 */   MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 14731
/* 14721 */   MCD::OPC_CheckPredicate, 30, 235, 17, 0, // Skip to: 19313
/* 14726 */   MCD::OPC_Decode, 221, 16, 177, 2, // Opcode: NLZC_H
/* 14731 */   MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 14746
/* 14736 */   MCD::OPC_CheckPredicate, 30, 220, 17, 0, // Skip to: 19313
/* 14741 */   MCD::OPC_Decode, 222, 16, 178, 2, // Opcode: NLZC_W
/* 14746 */   MCD::OPC_FilterValue, 15, 210, 17, 0, // Skip to: 19313
/* 14751 */   MCD::OPC_CheckPredicate, 30, 205, 17, 0, // Skip to: 19313
/* 14756 */   MCD::OPC_Decode, 220, 16, 179, 2, // Opcode: NLZC_D
/* 14761 */   MCD::OPC_FilterValue, 25, 195, 17, 0, // Skip to: 19313
/* 14766 */   MCD::OPC_ExtractField, 16, 5,  // Inst{20-16} ...
/* 14769 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 14784
/* 14774 */   MCD::OPC_CheckPredicate, 30, 182, 17, 0, // Skip to: 19313
/* 14779 */   MCD::OPC_Decode, 130, 11, 178, 2, // Opcode: FCLASS_W
/* 14784 */   MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 14799
/* 14789 */   MCD::OPC_CheckPredicate, 30, 167, 17, 0, // Skip to: 19313
/* 14794 */   MCD::OPC_Decode, 129, 11, 179, 2, // Opcode: FCLASS_D
/* 14799 */   MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 14814
/* 14804 */   MCD::OPC_CheckPredicate, 30, 152, 17, 0, // Skip to: 19313
/* 14809 */   MCD::OPC_Decode, 156, 12, 178, 2, // Opcode: FTRUNC_S_W
/* 14814 */   MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 14829
/* 14819 */   MCD::OPC_CheckPredicate, 30, 137, 17, 0, // Skip to: 19313
/* 14824 */   MCD::OPC_Decode, 155, 12, 179, 2, // Opcode: FTRUNC_S_D
/* 14829 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 14844
/* 14834 */   MCD::OPC_CheckPredicate, 30, 122, 17, 0, // Skip to: 19313
/* 14839 */   MCD::OPC_Decode, 158, 12, 178, 2, // Opcode: FTRUNC_U_W
/* 14844 */   MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 14859
/* 14849 */   MCD::OPC_CheckPredicate, 30, 107, 17, 0, // Skip to: 19313
/* 14854 */   MCD::OPC_Decode, 157, 12, 179, 2, // Opcode: FTRUNC_U_D
/* 14859 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 14874
/* 14864 */   MCD::OPC_CheckPredicate, 30, 92, 17, 0, // Skip to: 19313
/* 14869 */   MCD::OPC_Decode, 129, 12, 178, 2, // Opcode: FSQRT_W
/* 14874 */   MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 14889
/* 14879 */   MCD::OPC_CheckPredicate, 30, 77, 17, 0, // Skip to: 19313
/* 14884 */   MCD::OPC_Decode, 250, 11, 179, 2, // Opcode: FSQRT_D
/* 14889 */   MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 14904
/* 14894 */   MCD::OPC_CheckPredicate, 30, 62, 17, 0, // Skip to: 19313
/* 14899 */   MCD::OPC_Decode, 237, 11, 178, 2, // Opcode: FRSQRT_W
/* 14904 */   MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 14919
/* 14909 */   MCD::OPC_CheckPredicate, 30, 47, 17, 0, // Skip to: 19313
/* 14914 */   MCD::OPC_Decode, 236, 11, 179, 2, // Opcode: FRSQRT_D
/* 14919 */   MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 14934
/* 14924 */   MCD::OPC_CheckPredicate, 30, 32, 17, 0, // Skip to: 19313
/* 14929 */   MCD::OPC_Decode, 233, 11, 178, 2, // Opcode: FRCP_W
/* 14934 */   MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 14949
/* 14939 */   MCD::OPC_CheckPredicate, 30, 17, 17, 0, // Skip to: 19313
/* 14944 */   MCD::OPC_Decode, 232, 11, 179, 2, // Opcode: FRCP_D
/* 14949 */   MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 14964
/* 14954 */   MCD::OPC_CheckPredicate, 30, 2, 17, 0, // Skip to: 19313
/* 14959 */   MCD::OPC_Decode, 235, 11, 178, 2, // Opcode: FRINT_W
/* 14964 */   MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 14979
/* 14969 */   MCD::OPC_CheckPredicate, 30, 243, 16, 0, // Skip to: 19313
/* 14974 */   MCD::OPC_Decode, 234, 11, 179, 2, // Opcode: FRINT_D
/* 14979 */   MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 14994
/* 14984 */   MCD::OPC_CheckPredicate, 30, 228, 16, 0, // Skip to: 19313
/* 14989 */   MCD::OPC_Decode, 184, 11, 178, 2, // Opcode: FLOG2_W
/* 14994 */   MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 15009
/* 14999 */   MCD::OPC_CheckPredicate, 30, 213, 16, 0, // Skip to: 19313
/* 15004 */   MCD::OPC_Decode, 183, 11, 179, 2, // Opcode: FLOG2_D
/* 15009 */   MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 15024
/* 15014 */   MCD::OPC_CheckPredicate, 30, 198, 16, 0, // Skip to: 19313
/* 15019 */   MCD::OPC_Decode, 168, 11, 180, 2, // Opcode: FEXUPL_W
/* 15024 */   MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 15039
/* 15029 */   MCD::OPC_CheckPredicate, 30, 183, 16, 0, // Skip to: 19313
/* 15034 */   MCD::OPC_Decode, 167, 11, 181, 2, // Opcode: FEXUPL_D
/* 15039 */   MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 15054
/* 15044 */   MCD::OPC_CheckPredicate, 30, 168, 16, 0, // Skip to: 19313
/* 15049 */   MCD::OPC_Decode, 170, 11, 180, 2, // Opcode: FEXUPR_W
/* 15054 */   MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 15069
/* 15059 */   MCD::OPC_CheckPredicate, 30, 153, 16, 0, // Skip to: 19313
/* 15064 */   MCD::OPC_Decode, 169, 11, 181, 2, // Opcode: FEXUPR_D
/* 15069 */   MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 15084
/* 15074 */   MCD::OPC_CheckPredicate, 30, 138, 16, 0, // Skip to: 19313
/* 15079 */   MCD::OPC_Decode, 176, 11, 180, 2, // Opcode: FFQL_W
/* 15084 */   MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 15099
/* 15089 */   MCD::OPC_CheckPredicate, 30, 123, 16, 0, // Skip to: 19313
/* 15094 */   MCD::OPC_Decode, 175, 11, 181, 2, // Opcode: FFQL_D
/* 15099 */   MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 15114
/* 15104 */   MCD::OPC_CheckPredicate, 30, 108, 16, 0, // Skip to: 19313
/* 15109 */   MCD::OPC_Decode, 178, 11, 180, 2, // Opcode: FFQR_W
/* 15114 */   MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 15129
/* 15119 */   MCD::OPC_CheckPredicate, 30, 93, 16, 0, // Skip to: 19313
/* 15124 */   MCD::OPC_Decode, 177, 11, 181, 2, // Opcode: FFQR_D
/* 15129 */   MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 15144
/* 15134 */   MCD::OPC_CheckPredicate, 30, 78, 16, 0, // Skip to: 19313
/* 15139 */   MCD::OPC_Decode, 150, 12, 178, 2, // Opcode: FTINT_S_W
/* 15144 */   MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 15159
/* 15149 */   MCD::OPC_CheckPredicate, 30, 63, 16, 0, // Skip to: 19313
/* 15154 */   MCD::OPC_Decode, 149, 12, 179, 2, // Opcode: FTINT_S_D
/* 15159 */   MCD::OPC_FilterValue, 26, 10, 0, 0, // Skip to: 15174
/* 15164 */   MCD::OPC_CheckPredicate, 30, 48, 16, 0, // Skip to: 19313
/* 15169 */   MCD::OPC_Decode, 152, 12, 178, 2, // Opcode: FTINT_U_W
/* 15174 */   MCD::OPC_FilterValue, 27, 10, 0, 0, // Skip to: 15189
/* 15179 */   MCD::OPC_CheckPredicate, 30, 33, 16, 0, // Skip to: 19313
/* 15184 */   MCD::OPC_Decode, 151, 12, 179, 2, // Opcode: FTINT_U_D
/* 15189 */   MCD::OPC_FilterValue, 28, 10, 0, 0, // Skip to: 15204
/* 15194 */   MCD::OPC_CheckPredicate, 30, 18, 16, 0, // Skip to: 19313
/* 15199 */   MCD::OPC_Decode, 172, 11, 178, 2, // Opcode: FFINT_S_W
/* 15204 */   MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 15219
/* 15209 */   MCD::OPC_CheckPredicate, 30, 3, 16, 0, // Skip to: 19313
/* 15214 */   MCD::OPC_Decode, 171, 11, 179, 2, // Opcode: FFINT_S_D
/* 15219 */   MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 15234
/* 15224 */   MCD::OPC_CheckPredicate, 30, 244, 15, 0, // Skip to: 19313
/* 15229 */   MCD::OPC_Decode, 174, 11, 178, 2, // Opcode: FFINT_U_W
/* 15234 */   MCD::OPC_FilterValue, 31, 234, 15, 0, // Skip to: 19313
/* 15239 */   MCD::OPC_CheckPredicate, 30, 229, 15, 0, // Skip to: 19313
/* 15244 */   MCD::OPC_Decode, 173, 11, 179, 2, // Opcode: FFINT_U_D
/* 15249 */   MCD::OPC_FilterValue, 32, 10, 0, 0, // Skip to: 15264
/* 15254 */   MCD::OPC_CheckPredicate, 30, 214, 15, 0, // Skip to: 19313
/* 15259 */   MCD::OPC_Decode, 209, 13, 182, 2, // Opcode: LD_B
/* 15264 */   MCD::OPC_FilterValue, 33, 10, 0, 0, // Skip to: 15279
/* 15269 */   MCD::OPC_CheckPredicate, 30, 199, 15, 0, // Skip to: 19313
/* 15274 */   MCD::OPC_Decode, 211, 13, 182, 2, // Opcode: LD_H
/* 15279 */   MCD::OPC_FilterValue, 34, 10, 0, 0, // Skip to: 15294
/* 15284 */   MCD::OPC_CheckPredicate, 30, 184, 15, 0, // Skip to: 19313
/* 15289 */   MCD::OPC_Decode, 212, 13, 182, 2, // Opcode: LD_W
/* 15294 */   MCD::OPC_FilterValue, 35, 10, 0, 0, // Skip to: 15309
/* 15299 */   MCD::OPC_CheckPredicate, 30, 169, 15, 0, // Skip to: 19313
/* 15304 */   MCD::OPC_Decode, 210, 13, 182, 2, // Opcode: LD_D
/* 15309 */   MCD::OPC_FilterValue, 36, 10, 0, 0, // Skip to: 15324
/* 15314 */   MCD::OPC_CheckPredicate, 30, 154, 15, 0, // Skip to: 19313
/* 15319 */   MCD::OPC_Decode, 166, 20, 182, 2, // Opcode: ST_B
/* 15324 */   MCD::OPC_FilterValue, 37, 10, 0, 0, // Skip to: 15339
/* 15329 */   MCD::OPC_CheckPredicate, 30, 139, 15, 0, // Skip to: 19313
/* 15334 */   MCD::OPC_Decode, 168, 20, 182, 2, // Opcode: ST_H
/* 15339 */   MCD::OPC_FilterValue, 38, 10, 0, 0, // Skip to: 15354
/* 15344 */   MCD::OPC_CheckPredicate, 30, 124, 15, 0, // Skip to: 19313
/* 15349 */   MCD::OPC_Decode, 169, 20, 182, 2, // Opcode: ST_W
/* 15354 */   MCD::OPC_FilterValue, 39, 114, 15, 0, // Skip to: 19313
/* 15359 */   MCD::OPC_CheckPredicate, 30, 109, 15, 0, // Skip to: 19313
/* 15364 */   MCD::OPC_Decode, 167, 20, 182, 2, // Opcode: ST_D
/* 15369 */   MCD::OPC_FilterValue, 31, 165, 12, 0, // Skip to: 18611
/* 15374 */   MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 15377 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 15392
/* 15382 */   MCD::OPC_CheckPredicate, 28, 86, 15, 0, // Skip to: 19313
/* 15387 */   MCD::OPC_Decode, 209, 10, 183, 2, // Opcode: EXT
/* 15392 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 15407
/* 15397 */   MCD::OPC_CheckPredicate, 28, 71, 15, 0, // Skip to: 19313
/* 15402 */   MCD::OPC_Decode, 249, 12, 184, 2, // Opcode: INS
/* 15407 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 15429
/* 15412 */   MCD::OPC_CheckPredicate, 43, 56, 15, 0, // Skip to: 19313
/* 15417 */   MCD::OPC_CheckField, 6, 5, 0, 49, 15, 0, // Skip to: 19313
/* 15424 */   MCD::OPC_Decode, 231, 11, 185, 2, // Opcode: FORK
/* 15429 */   MCD::OPC_FilterValue, 9, 23, 0, 0, // Skip to: 15457
/* 15434 */   MCD::OPC_CheckPredicate, 43, 34, 15, 0, // Skip to: 19313
/* 15439 */   MCD::OPC_CheckField, 16, 5, 0, 27, 15, 0, // Skip to: 19313
/* 15446 */   MCD::OPC_CheckField, 6, 5, 0, 20, 15, 0, // Skip to: 19313
/* 15453 */   MCD::OPC_Decode, 128, 22, 14, // Opcode: YIELD
/* 15457 */   MCD::OPC_FilterValue, 10, 48, 0, 0, // Skip to: 15510
/* 15462 */   MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 15465 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 15480
/* 15470 */   MCD::OPC_CheckPredicate, 37, 254, 14, 0, // Skip to: 19313
/* 15475 */   MCD::OPC_Decode, 156, 14, 186, 2, // Opcode: LWX
/* 15480 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 15495
/* 15485 */   MCD::OPC_CheckPredicate, 37, 239, 14, 0, // Skip to: 19313
/* 15490 */   MCD::OPC_Decode, 221, 13, 186, 2, // Opcode: LHX
/* 15495 */   MCD::OPC_FilterValue, 6, 229, 14, 0, // Skip to: 19313
/* 15500 */   MCD::OPC_CheckPredicate, 37, 224, 14, 0, // Skip to: 19313
/* 15505 */   MCD::OPC_Decode, 181, 13, 186, 2, // Opcode: LBUX
/* 15510 */   MCD::OPC_FilterValue, 12, 17, 0, 0, // Skip to: 15532
/* 15515 */   MCD::OPC_CheckPredicate, 37, 209, 14, 0, // Skip to: 19313
/* 15520 */   MCD::OPC_CheckField, 6, 10, 0, 202, 14, 0, // Skip to: 19313
/* 15527 */   MCD::OPC_Decode, 254, 12, 187, 2, // Opcode: INSV
/* 15532 */   MCD::OPC_FilterValue, 16, 109, 1, 0, // Skip to: 15902
/* 15537 */   MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 15540 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 15555
/* 15545 */   MCD::OPC_CheckPredicate, 37, 179, 14, 0, // Skip to: 19313
/* 15550 */   MCD::OPC_Decode, 220, 4, 188, 2, // Opcode: ADDU_QB
/* 15555 */   MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 15570
/* 15560 */   MCD::OPC_CheckPredicate, 37, 164, 14, 0, // Skip to: 19313
/* 15565 */   MCD::OPC_Decode, 210, 20, 188, 2, // Opcode: SUBU_QB
/* 15570 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 15585
/* 15575 */   MCD::OPC_CheckPredicate, 37, 149, 14, 0, // Skip to: 19313
/* 15580 */   MCD::OPC_Decode, 224, 4, 188, 2, // Opcode: ADDU_S_QB
/* 15585 */   MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 15600
/* 15590 */   MCD::OPC_CheckPredicate, 37, 134, 14, 0, // Skip to: 19313
/* 15595 */   MCD::OPC_Decode, 214, 20, 188, 2, // Opcode: SUBU_S_QB
/* 15600 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 15615
/* 15605 */   MCD::OPC_CheckPredicate, 37, 119, 14, 0, // Skip to: 19313
/* 15610 */   MCD::OPC_Decode, 170, 16, 188, 2, // Opcode: MULEU_S_PH_QBL
/* 15615 */   MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 15630
/* 15620 */   MCD::OPC_CheckPredicate, 37, 104, 14, 0, // Skip to: 19313
/* 15625 */   MCD::OPC_Decode, 172, 16, 188, 2, // Opcode: MULEU_S_PH_QBR
/* 15630 */   MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 15645
/* 15635 */   MCD::OPC_CheckPredicate, 70, 89, 14, 0, // Skip to: 19313
/* 15640 */   MCD::OPC_Decode, 218, 4, 188, 2, // Opcode: ADDU_PH
/* 15645 */   MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 15660
/* 15650 */   MCD::OPC_CheckPredicate, 70, 74, 14, 0, // Skip to: 19313
/* 15655 */   MCD::OPC_Decode, 208, 20, 188, 2, // Opcode: SUBU_PH
/* 15660 */   MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 15675
/* 15665 */   MCD::OPC_CheckPredicate, 37, 59, 14, 0, // Skip to: 19313
/* 15670 */   MCD::OPC_Decode, 191, 4, 188, 2, // Opcode: ADDQ_PH
/* 15675 */   MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 15690
/* 15680 */   MCD::OPC_CheckPredicate, 37, 44, 14, 0, // Skip to: 19313
/* 15685 */   MCD::OPC_Decode, 179, 20, 188, 2, // Opcode: SUBQ_PH
/* 15690 */   MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 15705
/* 15695 */   MCD::OPC_CheckPredicate, 70, 29, 14, 0, // Skip to: 19313
/* 15700 */   MCD::OPC_Decode, 222, 4, 188, 2, // Opcode: ADDU_S_PH
/* 15705 */   MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 15720
/* 15710 */   MCD::OPC_CheckPredicate, 70, 14, 14, 0, // Skip to: 19313
/* 15715 */   MCD::OPC_Decode, 212, 20, 188, 2, // Opcode: SUBU_S_PH
/* 15720 */   MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 15735
/* 15725 */   MCD::OPC_CheckPredicate, 37, 255, 13, 0, // Skip to: 19313
/* 15730 */   MCD::OPC_Decode, 193, 4, 188, 2, // Opcode: ADDQ_S_PH
/* 15735 */   MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 15750
/* 15740 */   MCD::OPC_CheckPredicate, 37, 240, 13, 0, // Skip to: 19313
/* 15745 */   MCD::OPC_Decode, 181, 20, 188, 2, // Opcode: SUBQ_S_PH
/* 15750 */   MCD::OPC_FilterValue, 16, 9, 0, 0, // Skip to: 15764
/* 15755 */   MCD::OPC_CheckPredicate, 37, 225, 13, 0, // Skip to: 19313
/* 15760 */   MCD::OPC_Decode, 197, 4, 49, // Opcode: ADDSC
/* 15764 */   MCD::OPC_FilterValue, 17, 9, 0, 0, // Skip to: 15778
/* 15769 */   MCD::OPC_CheckPredicate, 37, 211, 13, 0, // Skip to: 19313
/* 15774 */   MCD::OPC_Decode, 234, 4, 49, // Opcode: ADDWC
/* 15778 */   MCD::OPC_FilterValue, 18, 9, 0, 0, // Skip to: 15792
/* 15783 */   MCD::OPC_CheckPredicate, 37, 197, 13, 0, // Skip to: 19313
/* 15788 */   MCD::OPC_Decode, 168, 15, 49, // Opcode: MODSUB
/* 15792 */   MCD::OPC_FilterValue, 20, 17, 0, 0, // Skip to: 15814
/* 15797 */   MCD::OPC_CheckPredicate, 37, 183, 13, 0, // Skip to: 19313
/* 15802 */   MCD::OPC_CheckField, 16, 5, 0, 176, 13, 0, // Skip to: 19313
/* 15809 */   MCD::OPC_Decode, 128, 18, 189, 2, // Opcode: RADDU_W_QB
/* 15814 */   MCD::OPC_FilterValue, 22, 9, 0, 0, // Skip to: 15828
/* 15819 */   MCD::OPC_CheckPredicate, 37, 161, 13, 0, // Skip to: 19313
/* 15824 */   MCD::OPC_Decode, 195, 4, 49, // Opcode: ADDQ_S_W
/* 15828 */   MCD::OPC_FilterValue, 23, 9, 0, 0, // Skip to: 15842
/* 15833 */   MCD::OPC_CheckPredicate, 37, 147, 13, 0, // Skip to: 19313
/* 15838 */   MCD::OPC_Decode, 183, 20, 49, // Opcode: SUBQ_S_W
/* 15842 */   MCD::OPC_FilterValue, 28, 10, 0, 0, // Skip to: 15857
/* 15847 */   MCD::OPC_CheckPredicate, 37, 133, 13, 0, // Skip to: 19313
/* 15852 */   MCD::OPC_Decode, 166, 16, 190, 2, // Opcode: MULEQ_S_W_PHL
/* 15857 */   MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 15872
/* 15862 */   MCD::OPC_CheckPredicate, 37, 118, 13, 0, // Skip to: 19313
/* 15867 */   MCD::OPC_Decode, 168, 16, 190, 2, // Opcode: MULEQ_S_W_PHR
/* 15872 */   MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 15887
/* 15877 */   MCD::OPC_CheckPredicate, 70, 103, 13, 0, // Skip to: 19313
/* 15882 */   MCD::OPC_Decode, 178, 16, 188, 2, // Opcode: MULQ_S_PH
/* 15887 */   MCD::OPC_FilterValue, 31, 93, 13, 0, // Skip to: 19313
/* 15892 */   MCD::OPC_CheckPredicate, 37, 88, 13, 0, // Skip to: 19313
/* 15897 */   MCD::OPC_Decode, 174, 16, 188, 2, // Opcode: MULQ_RS_PH
/* 15902 */   MCD::OPC_FilterValue, 17, 113, 1, 0, // Skip to: 16276
/* 15907 */   MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 15910 */   MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 15931
/* 15915 */   MCD::OPC_CheckPredicate, 37, 65, 13, 0, // Skip to: 19313
/* 15920 */   MCD::OPC_CheckField, 11, 5, 0, 58, 13, 0, // Skip to: 19313
/* 15927 */   MCD::OPC_Decode, 208, 7, 67, // Opcode: CMPU_EQ_QB
/* 15931 */   MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 15952
/* 15936 */   MCD::OPC_CheckPredicate, 37, 44, 13, 0, // Skip to: 19313
/* 15941 */   MCD::OPC_CheckField, 11, 5, 0, 37, 13, 0, // Skip to: 19313
/* 15948 */   MCD::OPC_Decode, 212, 7, 67, // Opcode: CMPU_LT_QB
/* 15952 */   MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 15973
/* 15957 */   MCD::OPC_CheckPredicate, 37, 23, 13, 0, // Skip to: 19313
/* 15962 */   MCD::OPC_CheckField, 11, 5, 0, 16, 13, 0, // Skip to: 19313
/* 15969 */   MCD::OPC_Decode, 210, 7, 67, // Opcode: CMPU_LE_QB
/* 15973 */   MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 15988
/* 15978 */   MCD::OPC_CheckPredicate, 37, 2, 13, 0, // Skip to: 19313
/* 15983 */   MCD::OPC_Decode, 170, 17, 188, 2, // Opcode: PICK_QB
/* 15988 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 16003
/* 15993 */   MCD::OPC_CheckPredicate, 37, 243, 12, 0, // Skip to: 19313
/* 15998 */   MCD::OPC_Decode, 202, 7, 190, 2, // Opcode: CMPGU_EQ_QB
/* 16003 */   MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 16018
/* 16008 */   MCD::OPC_CheckPredicate, 37, 228, 12, 0, // Skip to: 19313
/* 16013 */   MCD::OPC_Decode, 206, 7, 190, 2, // Opcode: CMPGU_LT_QB
/* 16018 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 16033
/* 16023 */   MCD::OPC_CheckPredicate, 37, 213, 12, 0, // Skip to: 19313
/* 16028 */   MCD::OPC_Decode, 204, 7, 190, 2, // Opcode: CMPGU_LE_QB
/* 16033 */   MCD::OPC_FilterValue, 8, 16, 0, 0, // Skip to: 16054
/* 16038 */   MCD::OPC_CheckPredicate, 37, 198, 12, 0, // Skip to: 19313
/* 16043 */   MCD::OPC_CheckField, 11, 5, 0, 191, 12, 0, // Skip to: 19313
/* 16050 */   MCD::OPC_Decode, 218, 7, 67, // Opcode: CMP_EQ_PH
/* 16054 */   MCD::OPC_FilterValue, 9, 16, 0, 0, // Skip to: 16075
/* 16059 */   MCD::OPC_CheckPredicate, 37, 177, 12, 0, // Skip to: 19313
/* 16064 */   MCD::OPC_CheckField, 11, 5, 0, 170, 12, 0, // Skip to: 19313
/* 16071 */   MCD::OPC_Decode, 232, 7, 67, // Opcode: CMP_LT_PH
/* 16075 */   MCD::OPC_FilterValue, 10, 16, 0, 0, // Skip to: 16096
/* 16080 */   MCD::OPC_CheckPredicate, 37, 156, 12, 0, // Skip to: 19313
/* 16085 */   MCD::OPC_CheckField, 11, 5, 0, 149, 12, 0, // Skip to: 19313
/* 16092 */   MCD::OPC_Decode, 226, 7, 67, // Opcode: CMP_LE_PH
/* 16096 */   MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 16111
/* 16101 */   MCD::OPC_CheckPredicate, 37, 135, 12, 0, // Skip to: 19313
/* 16106 */   MCD::OPC_Decode, 168, 17, 188, 2, // Opcode: PICK_PH
/* 16111 */   MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 16126
/* 16116 */   MCD::OPC_CheckPredicate, 37, 120, 12, 0, // Skip to: 19313
/* 16121 */   MCD::OPC_Decode, 215, 17, 188, 2, // Opcode: PRECRQ_QB_PH
/* 16126 */   MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 16141
/* 16131 */   MCD::OPC_CheckPredicate, 70, 105, 12, 0, // Skip to: 19313
/* 16136 */   MCD::OPC_Decode, 219, 17, 188, 2, // Opcode: PRECR_QB_PH
/* 16141 */   MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 16156
/* 16146 */   MCD::OPC_CheckPredicate, 37, 90, 12, 0, // Skip to: 19313
/* 16151 */   MCD::OPC_Decode, 128, 17, 188, 2, // Opcode: PACKRL_PH
/* 16156 */   MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 16171
/* 16161 */   MCD::OPC_CheckPredicate, 37, 75, 12, 0, // Skip to: 19313
/* 16166 */   MCD::OPC_Decode, 211, 17, 188, 2, // Opcode: PRECRQU_S_QB_PH
/* 16171 */   MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 16186
/* 16176 */   MCD::OPC_CheckPredicate, 37, 60, 12, 0, // Skip to: 19313
/* 16181 */   MCD::OPC_Decode, 213, 17, 191, 2, // Opcode: PRECRQ_PH_W
/* 16186 */   MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 16201
/* 16191 */   MCD::OPC_CheckPredicate, 37, 45, 12, 0, // Skip to: 19313
/* 16196 */   MCD::OPC_Decode, 217, 17, 191, 2, // Opcode: PRECRQ_RS_PH_W
/* 16201 */   MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 16216
/* 16206 */   MCD::OPC_CheckPredicate, 70, 30, 12, 0, // Skip to: 19313
/* 16211 */   MCD::OPC_Decode, 196, 7, 190, 2, // Opcode: CMPGDU_EQ_QB
/* 16216 */   MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 16231
/* 16221 */   MCD::OPC_CheckPredicate, 70, 15, 12, 0, // Skip to: 19313
/* 16226 */   MCD::OPC_Decode, 200, 7, 190, 2, // Opcode: CMPGDU_LT_QB
/* 16231 */   MCD::OPC_FilterValue, 26, 10, 0, 0, // Skip to: 16246
/* 16236 */   MCD::OPC_CheckPredicate, 70, 0, 12, 0, // Skip to: 19313
/* 16241 */   MCD::OPC_Decode, 198, 7, 190, 2, // Opcode: CMPGDU_LE_QB
/* 16246 */   MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 16261
/* 16251 */   MCD::OPC_CheckPredicate, 70, 241, 11, 0, // Skip to: 19313
/* 16256 */   MCD::OPC_Decode, 221, 17, 192, 2, // Opcode: PRECR_SRA_PH_W
/* 16261 */   MCD::OPC_FilterValue, 31, 231, 11, 0, // Skip to: 19313
/* 16266 */   MCD::OPC_CheckPredicate, 70, 226, 11, 0, // Skip to: 19313
/* 16271 */   MCD::OPC_Decode, 223, 17, 192, 2, // Opcode: PRECR_SRA_R_PH_W
/* 16276 */   MCD::OPC_FilterValue, 18, 128, 1, 0, // Skip to: 16665
/* 16281 */   MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 16284 */   MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 16306
/* 16289 */   MCD::OPC_CheckPredicate, 70, 203, 11, 0, // Skip to: 19313
/* 16294 */   MCD::OPC_CheckField, 21, 5, 0, 196, 11, 0, // Skip to: 19313
/* 16301 */   MCD::OPC_Decode, 170, 4, 193, 2, // Opcode: ABSQ_S_QB
/* 16306 */   MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 16321
/* 16311 */   MCD::OPC_CheckPredicate, 37, 181, 11, 0, // Skip to: 19313
/* 16316 */   MCD::OPC_Decode, 149, 18, 194, 2, // Opcode: REPL_QB
/* 16321 */   MCD::OPC_FilterValue, 3, 17, 0, 0, // Skip to: 16343
/* 16326 */   MCD::OPC_CheckPredicate, 37, 166, 11, 0, // Skip to: 19313
/* 16331 */   MCD::OPC_CheckField, 21, 5, 0, 159, 11, 0, // Skip to: 19313
/* 16338 */   MCD::OPC_Decode, 145, 18, 195, 2, // Opcode: REPLV_QB
/* 16343 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 16365
/* 16348 */   MCD::OPC_CheckPredicate, 37, 144, 11, 0, // Skip to: 19313
/* 16353 */   MCD::OPC_CheckField, 21, 5, 0, 137, 11, 0, // Skip to: 19313
/* 16360 */   MCD::OPC_Decode, 191, 17, 193, 2, // Opcode: PRECEQU_PH_QBL
/* 16365 */   MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 16387
/* 16370 */   MCD::OPC_CheckPredicate, 37, 122, 11, 0, // Skip to: 19313
/* 16375 */   MCD::OPC_CheckField, 21, 5, 0, 115, 11, 0, // Skip to: 19313
/* 16382 */   MCD::OPC_Decode, 195, 17, 193, 2, // Opcode: PRECEQU_PH_QBR
/* 16387 */   MCD::OPC_FilterValue, 6, 17, 0, 0, // Skip to: 16409
/* 16392 */   MCD::OPC_CheckPredicate, 37, 100, 11, 0, // Skip to: 19313
/* 16397 */   MCD::OPC_CheckField, 21, 5, 0, 93, 11, 0, // Skip to: 19313
/* 16404 */   MCD::OPC_Decode, 192, 17, 193, 2, // Opcode: PRECEQU_PH_QBLA
/* 16409 */   MCD::OPC_FilterValue, 7, 17, 0, 0, // Skip to: 16431
/* 16414 */   MCD::OPC_CheckPredicate, 37, 78, 11, 0, // Skip to: 19313
/* 16419 */   MCD::OPC_CheckField, 21, 5, 0, 71, 11, 0, // Skip to: 19313
/* 16426 */   MCD::OPC_Decode, 196, 17, 193, 2, // Opcode: PRECEQU_PH_QBRA
/* 16431 */   MCD::OPC_FilterValue, 9, 17, 0, 0, // Skip to: 16453
/* 16436 */   MCD::OPC_CheckPredicate, 37, 56, 11, 0, // Skip to: 19313
/* 16441 */   MCD::OPC_CheckField, 21, 5, 0, 49, 11, 0, // Skip to: 19313
/* 16448 */   MCD::OPC_Decode, 168, 4, 193, 2, // Opcode: ABSQ_S_PH
/* 16453 */   MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 16467
/* 16458 */   MCD::OPC_CheckPredicate, 37, 34, 11, 0, // Skip to: 19313
/* 16463 */   MCD::OPC_Decode, 147, 18, 84, // Opcode: REPL_PH
/* 16467 */   MCD::OPC_FilterValue, 11, 17, 0, 0, // Skip to: 16489
/* 16472 */   MCD::OPC_CheckPredicate, 37, 20, 11, 0, // Skip to: 19313
/* 16477 */   MCD::OPC_CheckField, 21, 5, 0, 13, 11, 0, // Skip to: 19313
/* 16484 */   MCD::OPC_Decode, 143, 18, 195, 2, // Opcode: REPLV_PH
/* 16489 */   MCD::OPC_FilterValue, 12, 17, 0, 0, // Skip to: 16511
/* 16494 */   MCD::OPC_CheckPredicate, 37, 254, 10, 0, // Skip to: 19313
/* 16499 */   MCD::OPC_CheckField, 21, 5, 0, 247, 10, 0, // Skip to: 19313
/* 16506 */   MCD::OPC_Decode, 199, 17, 196, 2, // Opcode: PRECEQ_W_PHL
/* 16511 */   MCD::OPC_FilterValue, 13, 17, 0, 0, // Skip to: 16533
/* 16516 */   MCD::OPC_CheckPredicate, 37, 232, 10, 0, // Skip to: 19313
/* 16521 */   MCD::OPC_CheckField, 21, 5, 0, 225, 10, 0, // Skip to: 19313
/* 16528 */   MCD::OPC_Decode, 201, 17, 196, 2, // Opcode: PRECEQ_W_PHR
/* 16533 */   MCD::OPC_FilterValue, 17, 17, 0, 0, // Skip to: 16555
/* 16538 */   MCD::OPC_CheckPredicate, 37, 210, 10, 0, // Skip to: 19313
/* 16543 */   MCD::OPC_CheckField, 21, 5, 0, 203, 10, 0, // Skip to: 19313
/* 16550 */   MCD::OPC_Decode, 172, 4, 197, 2, // Opcode: ABSQ_S_W
/* 16555 */   MCD::OPC_FilterValue, 27, 17, 0, 0, // Skip to: 16577
/* 16560 */   MCD::OPC_CheckPredicate, 37, 188, 10, 0, // Skip to: 19313
/* 16565 */   MCD::OPC_CheckField, 21, 5, 0, 181, 10, 0, // Skip to: 19313
/* 16572 */   MCD::OPC_Decode, 145, 6, 197, 2, // Opcode: BITREV
/* 16577 */   MCD::OPC_FilterValue, 28, 17, 0, 0, // Skip to: 16599
/* 16582 */   MCD::OPC_CheckPredicate, 37, 166, 10, 0, // Skip to: 19313
/* 16587 */   MCD::OPC_CheckField, 21, 5, 0, 159, 10, 0, // Skip to: 19313
/* 16594 */   MCD::OPC_Decode, 203, 17, 193, 2, // Opcode: PRECEU_PH_QBL
/* 16599 */   MCD::OPC_FilterValue, 29, 17, 0, 0, // Skip to: 16621
/* 16604 */   MCD::OPC_CheckPredicate, 37, 144, 10, 0, // Skip to: 19313
/* 16609 */   MCD::OPC_CheckField, 21, 5, 0, 137, 10, 0, // Skip to: 19313
/* 16616 */   MCD::OPC_Decode, 207, 17, 193, 2, // Opcode: PRECEU_PH_QBR
/* 16621 */   MCD::OPC_FilterValue, 30, 17, 0, 0, // Skip to: 16643
/* 16626 */   MCD::OPC_CheckPredicate, 37, 122, 10, 0, // Skip to: 19313
/* 16631 */   MCD::OPC_CheckField, 21, 5, 0, 115, 10, 0, // Skip to: 19313
/* 16638 */   MCD::OPC_Decode, 204, 17, 193, 2, // Opcode: PRECEU_PH_QBLA
/* 16643 */   MCD::OPC_FilterValue, 31, 105, 10, 0, // Skip to: 19313
/* 16648 */   MCD::OPC_CheckPredicate, 37, 100, 10, 0, // Skip to: 19313
/* 16653 */   MCD::OPC_CheckField, 21, 5, 0, 93, 10, 0, // Skip to: 19313
/* 16660 */   MCD::OPC_Decode, 208, 17, 193, 2, // Opcode: PRECEU_PH_QBRA
/* 16665 */   MCD::OPC_FilterValue, 19, 75, 1, 0, // Skip to: 17001
/* 16670 */   MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 16673 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 16688
/* 16678 */   MCD::OPC_CheckPredicate, 37, 70, 10, 0, // Skip to: 19313
/* 16683 */   MCD::OPC_Decode, 149, 19, 198, 2, // Opcode: SHLL_QB
/* 16688 */   MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 16703
/* 16693 */   MCD::OPC_CheckPredicate, 37, 55, 10, 0, // Skip to: 19313
/* 16698 */   MCD::OPC_Decode, 181, 19, 198, 2, // Opcode: SHRL_QB
/* 16703 */   MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 16718
/* 16708 */   MCD::OPC_CheckPredicate, 37, 40, 10, 0, // Skip to: 19313
/* 16713 */   MCD::OPC_Decode, 141, 19, 199, 2, // Opcode: SHLLV_QB
/* 16718 */   MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 16733
/* 16723 */   MCD::OPC_CheckPredicate, 37, 25, 10, 0, // Skip to: 19313
/* 16728 */   MCD::OPC_Decode, 177, 19, 199, 2, // Opcode: SHRLV_QB
/* 16733 */   MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 16748
/* 16738 */   MCD::OPC_CheckPredicate, 70, 10, 10, 0, // Skip to: 19313
/* 16743 */   MCD::OPC_Decode, 167, 19, 198, 2, // Opcode: SHRA_QB
/* 16748 */   MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 16763
/* 16753 */   MCD::OPC_CheckPredicate, 70, 251, 9, 0, // Skip to: 19313
/* 16758 */   MCD::OPC_Decode, 171, 19, 198, 2, // Opcode: SHRA_R_QB
/* 16763 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 16778
/* 16768 */   MCD::OPC_CheckPredicate, 70, 236, 9, 0, // Skip to: 19313
/* 16773 */   MCD::OPC_Decode, 157, 19, 199, 2, // Opcode: SHRAV_QB
/* 16778 */   MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 16793
/* 16783 */   MCD::OPC_CheckPredicate, 70, 221, 9, 0, // Skip to: 19313
/* 16788 */   MCD::OPC_Decode, 161, 19, 199, 2, // Opcode: SHRAV_R_QB
/* 16793 */   MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 16808
/* 16798 */   MCD::OPC_CheckPredicate, 37, 206, 9, 0, // Skip to: 19313
/* 16803 */   MCD::OPC_Decode, 147, 19, 198, 2, // Opcode: SHLL_PH
/* 16808 */   MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 16823
/* 16813 */   MCD::OPC_CheckPredicate, 37, 191, 9, 0, // Skip to: 19313
/* 16818 */   MCD::OPC_Decode, 165, 19, 198, 2, // Opcode: SHRA_PH
/* 16823 */   MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 16838
/* 16828 */   MCD::OPC_CheckPredicate, 37, 176, 9, 0, // Skip to: 19313
/* 16833 */   MCD::OPC_Decode, 139, 19, 199, 2, // Opcode: SHLLV_PH
/* 16838 */   MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 16853
/* 16843 */   MCD::OPC_CheckPredicate, 37, 161, 9, 0, // Skip to: 19313
/* 16848 */   MCD::OPC_Decode, 155, 19, 199, 2, // Opcode: SHRAV_PH
/* 16853 */   MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 16868
/* 16858 */   MCD::OPC_CheckPredicate, 37, 146, 9, 0, // Skip to: 19313
/* 16863 */   MCD::OPC_Decode, 151, 19, 198, 2, // Opcode: SHLL_S_PH
/* 16868 */   MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 16883
/* 16873 */   MCD::OPC_CheckPredicate, 37, 131, 9, 0, // Skip to: 19313
/* 16878 */   MCD::OPC_Decode, 169, 19, 198, 2, // Opcode: SHRA_R_PH
/* 16883 */   MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 16898
/* 16888 */   MCD::OPC_CheckPredicate, 37, 116, 9, 0, // Skip to: 19313
/* 16893 */   MCD::OPC_Decode, 143, 19, 199, 2, // Opcode: SHLLV_S_PH
/* 16898 */   MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 16913
/* 16903 */   MCD::OPC_CheckPredicate, 37, 101, 9, 0, // Skip to: 19313
/* 16908 */   MCD::OPC_Decode, 159, 19, 199, 2, // Opcode: SHRAV_R_PH
/* 16913 */   MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 16928
/* 16918 */   MCD::OPC_CheckPredicate, 37, 86, 9, 0, // Skip to: 19313
/* 16923 */   MCD::OPC_Decode, 153, 19, 200, 2, // Opcode: SHLL_S_W
/* 16928 */   MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 16943
/* 16933 */   MCD::OPC_CheckPredicate, 37, 71, 9, 0, // Skip to: 19313
/* 16938 */   MCD::OPC_Decode, 173, 19, 200, 2, // Opcode: SHRA_R_W
/* 16943 */   MCD::OPC_FilterValue, 22, 9, 0, 0, // Skip to: 16957
/* 16948 */   MCD::OPC_CheckPredicate, 37, 56, 9, 0, // Skip to: 19313
/* 16953 */   MCD::OPC_Decode, 145, 19, 43, // Opcode: SHLLV_S_W
/* 16957 */   MCD::OPC_FilterValue, 23, 9, 0, 0, // Skip to: 16971
/* 16962 */   MCD::OPC_CheckPredicate, 37, 42, 9, 0, // Skip to: 19313
/* 16967 */   MCD::OPC_Decode, 163, 19, 43, // Opcode: SHRAV_R_W
/* 16971 */   MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 16986
/* 16976 */   MCD::OPC_CheckPredicate, 70, 28, 9, 0, // Skip to: 19313
/* 16981 */   MCD::OPC_Decode, 179, 19, 198, 2, // Opcode: SHRL_PH
/* 16986 */   MCD::OPC_FilterValue, 27, 18, 9, 0, // Skip to: 19313
/* 16991 */   MCD::OPC_CheckPredicate, 70, 13, 9, 0, // Skip to: 19313
/* 16996 */   MCD::OPC_Decode, 175, 19, 199, 2, // Opcode: SHRLV_PH
/* 17001 */   MCD::OPC_FilterValue, 24, 237, 0, 0, // Skip to: 17243
/* 17006 */   MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 17009 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 17024
/* 17014 */   MCD::OPC_CheckPredicate, 70, 246, 8, 0, // Skip to: 19313
/* 17019 */   MCD::OPC_Decode, 213, 4, 188, 2, // Opcode: ADDUH_QB
/* 17024 */   MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 17039
/* 17029 */   MCD::OPC_CheckPredicate, 70, 231, 8, 0, // Skip to: 19313
/* 17034 */   MCD::OPC_Decode, 203, 20, 188, 2, // Opcode: SUBUH_QB
/* 17039 */   MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 17054
/* 17044 */   MCD::OPC_CheckPredicate, 70, 216, 8, 0, // Skip to: 19313
/* 17049 */   MCD::OPC_Decode, 215, 4, 188, 2, // Opcode: ADDUH_R_QB
/* 17054 */   MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 17069
/* 17059 */   MCD::OPC_CheckPredicate, 70, 201, 8, 0, // Skip to: 19313
/* 17064 */   MCD::OPC_Decode, 205, 20, 188, 2, // Opcode: SUBUH_R_QB
/* 17069 */   MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 17084
/* 17074 */   MCD::OPC_CheckPredicate, 70, 186, 8, 0, // Skip to: 19313
/* 17079 */   MCD::OPC_Decode, 183, 4, 188, 2, // Opcode: ADDQH_PH
/* 17084 */   MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 17099
/* 17089 */   MCD::OPC_CheckPredicate, 70, 171, 8, 0, // Skip to: 19313
/* 17094 */   MCD::OPC_Decode, 171, 20, 188, 2, // Opcode: SUBQH_PH
/* 17099 */   MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 17114
/* 17104 */   MCD::OPC_CheckPredicate, 70, 156, 8, 0, // Skip to: 19313
/* 17109 */   MCD::OPC_Decode, 185, 4, 188, 2, // Opcode: ADDQH_R_PH
/* 17114 */   MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 17129
/* 17119 */   MCD::OPC_CheckPredicate, 70, 141, 8, 0, // Skip to: 19313
/* 17124 */   MCD::OPC_Decode, 173, 20, 188, 2, // Opcode: SUBQH_R_PH
/* 17129 */   MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 17144
/* 17134 */   MCD::OPC_CheckPredicate, 70, 126, 8, 0, // Skip to: 19313
/* 17139 */   MCD::OPC_Decode, 204, 16, 188, 2, // Opcode: MUL_PH
/* 17144 */   MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 17159
/* 17149 */   MCD::OPC_CheckPredicate, 70, 111, 8, 0, // Skip to: 19313
/* 17154 */   MCD::OPC_Decode, 209, 16, 188, 2, // Opcode: MUL_S_PH
/* 17159 */   MCD::OPC_FilterValue, 16, 9, 0, 0, // Skip to: 17173
/* 17164 */   MCD::OPC_CheckPredicate, 70, 96, 8, 0, // Skip to: 19313
/* 17169 */   MCD::OPC_Decode, 189, 4, 49, // Opcode: ADDQH_W
/* 17173 */   MCD::OPC_FilterValue, 17, 9, 0, 0, // Skip to: 17187
/* 17178 */   MCD::OPC_CheckPredicate, 70, 82, 8, 0, // Skip to: 19313
/* 17183 */   MCD::OPC_Decode, 177, 20, 49, // Opcode: SUBQH_W
/* 17187 */   MCD::OPC_FilterValue, 18, 9, 0, 0, // Skip to: 17201
/* 17192 */   MCD::OPC_CheckPredicate, 70, 68, 8, 0, // Skip to: 19313
/* 17197 */   MCD::OPC_Decode, 187, 4, 49, // Opcode: ADDQH_R_W
/* 17201 */   MCD::OPC_FilterValue, 19, 9, 0, 0, // Skip to: 17215
/* 17206 */   MCD::OPC_CheckPredicate, 70, 54, 8, 0, // Skip to: 19313
/* 17211 */   MCD::OPC_Decode, 175, 20, 49, // Opcode: SUBQH_R_W
/* 17215 */   MCD::OPC_FilterValue, 22, 9, 0, 0, // Skip to: 17229
/* 17220 */   MCD::OPC_CheckPredicate, 70, 40, 8, 0, // Skip to: 19313
/* 17225 */   MCD::OPC_Decode, 180, 16, 49, // Opcode: MULQ_S_W
/* 17229 */   MCD::OPC_FilterValue, 23, 31, 8, 0, // Skip to: 19313
/* 17234 */   MCD::OPC_CheckPredicate, 70, 26, 8, 0, // Skip to: 19313
/* 17239 */   MCD::OPC_Decode, 176, 16, 49, // Opcode: MULQ_RS_W
/* 17243 */   MCD::OPC_FilterValue, 25, 17, 0, 0, // Skip to: 17265
/* 17248 */   MCD::OPC_CheckPredicate, 71, 12, 8, 0, // Skip to: 19313
/* 17253 */   MCD::OPC_CheckField, 6, 1, 0, 5, 8, 0, // Skip to: 19313
/* 17260 */   MCD::OPC_Decode, 139, 14, 201, 2, // Opcode: LWLE
/* 17265 */   MCD::OPC_FilterValue, 26, 17, 0, 0, // Skip to: 17287
/* 17270 */   MCD::OPC_CheckPredicate, 71, 246, 7, 0, // Skip to: 19313
/* 17275 */   MCD::OPC_CheckField, 6, 1, 0, 239, 7, 0, // Skip to: 19313
/* 17282 */   MCD::OPC_Decode, 150, 14, 201, 2, // Opcode: LWRE
/* 17287 */   MCD::OPC_FilterValue, 27, 17, 0, 0, // Skip to: 17309
/* 17292 */   MCD::OPC_CheckPredicate, 45, 224, 7, 0, // Skip to: 19313
/* 17297 */   MCD::OPC_CheckField, 6, 1, 0, 217, 7, 0, // Skip to: 19313
/* 17304 */   MCD::OPC_Decode, 248, 6, 202, 2, // Opcode: CACHEE
/* 17309 */   MCD::OPC_FilterValue, 28, 17, 0, 0, // Skip to: 17331
/* 17314 */   MCD::OPC_CheckPredicate, 45, 202, 7, 0, // Skip to: 19313
/* 17319 */   MCD::OPC_CheckField, 6, 1, 0, 195, 7, 0, // Skip to: 19313
/* 17326 */   MCD::OPC_Decode, 192, 18, 201, 2, // Opcode: SBE
/* 17331 */   MCD::OPC_FilterValue, 29, 17, 0, 0, // Skip to: 17353
/* 17336 */   MCD::OPC_CheckPredicate, 45, 180, 7, 0, // Skip to: 19313
/* 17341 */   MCD::OPC_CheckField, 6, 1, 0, 173, 7, 0, // Skip to: 19313
/* 17348 */   MCD::OPC_Decode, 130, 19, 201, 2, // Opcode: SHE
/* 17353 */   MCD::OPC_FilterValue, 30, 17, 0, 0, // Skip to: 17375
/* 17358 */   MCD::OPC_CheckPredicate, 45, 158, 7, 0, // Skip to: 19313
/* 17363 */   MCD::OPC_CheckField, 6, 1, 0, 151, 7, 0, // Skip to: 19313
/* 17370 */   MCD::OPC_Decode, 201, 18, 201, 2, // Opcode: SCE
/* 17375 */   MCD::OPC_FilterValue, 31, 17, 0, 0, // Skip to: 17397
/* 17380 */   MCD::OPC_CheckPredicate, 45, 136, 7, 0, // Skip to: 19313
/* 17385 */   MCD::OPC_CheckField, 6, 1, 0, 129, 7, 0, // Skip to: 19313
/* 17392 */   MCD::OPC_Decode, 243, 20, 201, 2, // Opcode: SWE
/* 17397 */   MCD::OPC_FilterValue, 32, 69, 0, 0, // Skip to: 17471
/* 17402 */   MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 17405 */   MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 17427
/* 17410 */   MCD::OPC_CheckPredicate, 28, 106, 7, 0, // Skip to: 19313
/* 17415 */   MCD::OPC_CheckField, 21, 5, 0, 99, 7, 0, // Skip to: 19313
/* 17422 */   MCD::OPC_Decode, 240, 21, 197, 2, // Opcode: WSBH
/* 17427 */   MCD::OPC_FilterValue, 16, 17, 0, 0, // Skip to: 17449
/* 17432 */   MCD::OPC_CheckPredicate, 28, 84, 7, 0, // Skip to: 19313
/* 17437 */   MCD::OPC_CheckField, 21, 5, 0, 77, 7, 0, // Skip to: 19313
/* 17444 */   MCD::OPC_Decode, 228, 18, 197, 2, // Opcode: SEB
/* 17449 */   MCD::OPC_FilterValue, 24, 67, 7, 0, // Skip to: 19313
/* 17454 */   MCD::OPC_CheckPredicate, 28, 62, 7, 0, // Skip to: 19313
/* 17459 */   MCD::OPC_CheckField, 21, 5, 0, 55, 7, 0, // Skip to: 19313
/* 17466 */   MCD::OPC_Decode, 231, 18, 197, 2, // Opcode: SEH
/* 17471 */   MCD::OPC_FilterValue, 33, 17, 0, 0, // Skip to: 17493
/* 17476 */   MCD::OPC_CheckPredicate, 71, 40, 7, 0, // Skip to: 19313
/* 17481 */   MCD::OPC_CheckField, 6, 1, 0, 33, 7, 0, // Skip to: 19313
/* 17488 */   MCD::OPC_Decode, 247, 20, 201, 2, // Opcode: SWLE
/* 17493 */   MCD::OPC_FilterValue, 34, 17, 0, 0, // Skip to: 17515
/* 17498 */   MCD::OPC_CheckPredicate, 71, 18, 7, 0, // Skip to: 19313
/* 17503 */   MCD::OPC_CheckField, 6, 1, 0, 11, 7, 0, // Skip to: 19313
/* 17510 */   MCD::OPC_Decode, 128, 21, 201, 2, // Opcode: SWRE
/* 17515 */   MCD::OPC_FilterValue, 35, 17, 0, 0, // Skip to: 17537
/* 17520 */   MCD::OPC_CheckPredicate, 45, 252, 6, 0, // Skip to: 19313
/* 17525 */   MCD::OPC_CheckField, 6, 1, 0, 245, 6, 0, // Skip to: 19313
/* 17532 */   MCD::OPC_Decode, 226, 17, 202, 2, // Opcode: PREFE
/* 17537 */   MCD::OPC_FilterValue, 40, 17, 0, 0, // Skip to: 17559
/* 17542 */   MCD::OPC_CheckPredicate, 45, 230, 6, 0, // Skip to: 19313
/* 17547 */   MCD::OPC_CheckField, 6, 1, 0, 223, 6, 0, // Skip to: 19313
/* 17554 */   MCD::OPC_Decode, 188, 13, 201, 2, // Opcode: LBuE
/* 17559 */   MCD::OPC_FilterValue, 41, 17, 0, 0, // Skip to: 17581
/* 17564 */   MCD::OPC_CheckPredicate, 45, 208, 6, 0, // Skip to: 19313
/* 17569 */   MCD::OPC_CheckField, 6, 1, 0, 201, 6, 0, // Skip to: 19313
/* 17576 */   MCD::OPC_Decode, 226, 13, 201, 2, // Opcode: LHuE
/* 17581 */   MCD::OPC_FilterValue, 44, 17, 0, 0, // Skip to: 17603
/* 17586 */   MCD::OPC_CheckPredicate, 45, 186, 6, 0, // Skip to: 19313
/* 17591 */   MCD::OPC_CheckField, 6, 1, 0, 179, 6, 0, // Skip to: 19313
/* 17598 */   MCD::OPC_Decode, 178, 13, 201, 2, // Opcode: LBE
/* 17603 */   MCD::OPC_FilterValue, 45, 17, 0, 0, // Skip to: 17625
/* 17608 */   MCD::OPC_CheckPredicate, 45, 164, 6, 0, // Skip to: 19313
/* 17613 */   MCD::OPC_CheckField, 6, 1, 0, 157, 6, 0, // Skip to: 19313
/* 17620 */   MCD::OPC_Decode, 218, 13, 201, 2, // Opcode: LHE
/* 17625 */   MCD::OPC_FilterValue, 46, 17, 0, 0, // Skip to: 17647
/* 17630 */   MCD::OPC_CheckPredicate, 45, 142, 6, 0, // Skip to: 19313
/* 17635 */   MCD::OPC_CheckField, 6, 1, 0, 135, 6, 0, // Skip to: 19313
/* 17642 */   MCD::OPC_Decode, 236, 13, 201, 2, // Opcode: LLE
/* 17647 */   MCD::OPC_FilterValue, 47, 17, 0, 0, // Skip to: 17669
/* 17652 */   MCD::OPC_CheckPredicate, 45, 120, 6, 0, // Skip to: 19313
/* 17657 */   MCD::OPC_CheckField, 6, 1, 0, 113, 6, 0, // Skip to: 19313
/* 17664 */   MCD::OPC_Decode, 134, 14, 201, 2, // Opcode: LWE
/* 17669 */   MCD::OPC_FilterValue, 48, 231, 1, 0, // Skip to: 18161
/* 17674 */   MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 17677 */   MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 17699
/* 17682 */   MCD::OPC_CheckPredicate, 70, 90, 6, 0, // Skip to: 19313
/* 17687 */   MCD::OPC_CheckField, 13, 3, 0, 83, 6, 0, // Skip to: 19313
/* 17694 */   MCD::OPC_Decode, 145, 10, 234, 1, // Opcode: DPA_W_PH
/* 17699 */   MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 17721
/* 17704 */   MCD::OPC_CheckPredicate, 70, 68, 6, 0, // Skip to: 19313
/* 17709 */   MCD::OPC_CheckField, 13, 3, 0, 61, 6, 0, // Skip to: 19313
/* 17716 */   MCD::OPC_Decode, 168, 10, 234, 1, // Opcode: DPS_W_PH
/* 17721 */   MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 17743
/* 17726 */   MCD::OPC_CheckPredicate, 70, 46, 6, 0, // Skip to: 19313
/* 17731 */   MCD::OPC_CheckField, 13, 3, 0, 39, 6, 0, // Skip to: 19313
/* 17738 */   MCD::OPC_Decode, 186, 16, 234, 1, // Opcode: MULSA_W_PH
/* 17743 */   MCD::OPC_FilterValue, 3, 17, 0, 0, // Skip to: 17765
/* 17748 */   MCD::OPC_CheckPredicate, 37, 24, 6, 0, // Skip to: 19313
/* 17753 */   MCD::OPC_CheckField, 13, 3, 0, 17, 6, 0, // Skip to: 19313
/* 17760 */   MCD::OPC_Decode, 139, 10, 234, 1, // Opcode: DPAU_H_QBL
/* 17765 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 17787
/* 17770 */   MCD::OPC_CheckPredicate, 37, 2, 6, 0, // Skip to: 19313
/* 17775 */   MCD::OPC_CheckField, 13, 3, 0, 251, 5, 0, // Skip to: 19313
/* 17782 */   MCD::OPC_Decode, 137, 10, 234, 1, // Opcode: DPAQ_S_W_PH
/* 17787 */   MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 17809
/* 17792 */   MCD::OPC_CheckPredicate, 37, 236, 5, 0, // Skip to: 19313
/* 17797 */   MCD::OPC_CheckField, 13, 3, 0, 229, 5, 0, // Skip to: 19313
/* 17804 */   MCD::OPC_Decode, 154, 10, 234, 1, // Opcode: DPSQ_S_W_PH
/* 17809 */   MCD::OPC_FilterValue, 6, 17, 0, 0, // Skip to: 17831
/* 17814 */   MCD::OPC_CheckPredicate, 37, 214, 5, 0, // Skip to: 19313
/* 17819 */   MCD::OPC_CheckField, 13, 3, 0, 207, 5, 0, // Skip to: 19313
/* 17826 */   MCD::OPC_Decode, 184, 16, 234, 1, // Opcode: MULSAQ_S_W_PH
/* 17831 */   MCD::OPC_FilterValue, 7, 17, 0, 0, // Skip to: 17853
/* 17836 */   MCD::OPC_CheckPredicate, 37, 192, 5, 0, // Skip to: 19313
/* 17841 */   MCD::OPC_CheckField, 13, 3, 0, 185, 5, 0, // Skip to: 19313
/* 17848 */   MCD::OPC_Decode, 141, 10, 234, 1, // Opcode: DPAU_H_QBR
/* 17853 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 17875
/* 17858 */   MCD::OPC_CheckPredicate, 70, 170, 5, 0, // Skip to: 19313
/* 17863 */   MCD::OPC_CheckField, 13, 3, 0, 163, 5, 0, // Skip to: 19313
/* 17870 */   MCD::OPC_Decode, 143, 10, 234, 1, // Opcode: DPAX_W_PH
/* 17875 */   MCD::OPC_FilterValue, 9, 17, 0, 0, // Skip to: 17897
/* 17880 */   MCD::OPC_CheckPredicate, 70, 148, 5, 0, // Skip to: 19313
/* 17885 */   MCD::OPC_CheckField, 13, 3, 0, 141, 5, 0, // Skip to: 19313
/* 17892 */   MCD::OPC_Decode, 166, 10, 234, 1, // Opcode: DPSX_W_PH
/* 17897 */   MCD::OPC_FilterValue, 11, 17, 0, 0, // Skip to: 17919
/* 17902 */   MCD::OPC_CheckPredicate, 37, 126, 5, 0, // Skip to: 19313
/* 17907 */   MCD::OPC_CheckField, 13, 3, 0, 119, 5, 0, // Skip to: 19313
/* 17914 */   MCD::OPC_Decode, 162, 10, 234, 1, // Opcode: DPSU_H_QBL
/* 17919 */   MCD::OPC_FilterValue, 12, 17, 0, 0, // Skip to: 17941
/* 17924 */   MCD::OPC_CheckPredicate, 37, 104, 5, 0, // Skip to: 19313
/* 17929 */   MCD::OPC_CheckField, 13, 3, 0, 97, 5, 0, // Skip to: 19313
/* 17936 */   MCD::OPC_Decode, 135, 10, 234, 1, // Opcode: DPAQ_SA_L_W
/* 17941 */   MCD::OPC_FilterValue, 13, 17, 0, 0, // Skip to: 17963
/* 17946 */   MCD::OPC_CheckPredicate, 37, 82, 5, 0, // Skip to: 19313
/* 17951 */   MCD::OPC_CheckField, 13, 3, 0, 75, 5, 0, // Skip to: 19313
/* 17958 */   MCD::OPC_Decode, 152, 10, 234, 1, // Opcode: DPSQ_SA_L_W
/* 17963 */   MCD::OPC_FilterValue, 15, 17, 0, 0, // Skip to: 17985
/* 17968 */   MCD::OPC_CheckPredicate, 37, 60, 5, 0, // Skip to: 19313
/* 17973 */   MCD::OPC_CheckField, 13, 3, 0, 53, 5, 0, // Skip to: 19313
/* 17980 */   MCD::OPC_Decode, 164, 10, 234, 1, // Opcode: DPSU_H_QBR
/* 17985 */   MCD::OPC_FilterValue, 16, 17, 0, 0, // Skip to: 18007
/* 17990 */   MCD::OPC_CheckPredicate, 37, 38, 5, 0, // Skip to: 19313
/* 17995 */   MCD::OPC_CheckField, 13, 3, 0, 31, 5, 0, // Skip to: 19313
/* 18002 */   MCD::OPC_Decode, 200, 14, 234, 1, // Opcode: MAQ_SA_W_PHL
/* 18007 */   MCD::OPC_FilterValue, 18, 17, 0, 0, // Skip to: 18029
/* 18012 */   MCD::OPC_CheckPredicate, 37, 16, 5, 0, // Skip to: 19313
/* 18017 */   MCD::OPC_CheckField, 13, 3, 0, 9, 5, 0, // Skip to: 19313
/* 18024 */   MCD::OPC_Decode, 202, 14, 234, 1, // Opcode: MAQ_SA_W_PHR
/* 18029 */   MCD::OPC_FilterValue, 20, 17, 0, 0, // Skip to: 18051
/* 18034 */   MCD::OPC_CheckPredicate, 37, 250, 4, 0, // Skip to: 19313
/* 18039 */   MCD::OPC_CheckField, 13, 3, 0, 243, 4, 0, // Skip to: 19313
/* 18046 */   MCD::OPC_Decode, 204, 14, 234, 1, // Opcode: MAQ_S_W_PHL
/* 18051 */   MCD::OPC_FilterValue, 22, 17, 0, 0, // Skip to: 18073
/* 18056 */   MCD::OPC_CheckPredicate, 37, 228, 4, 0, // Skip to: 19313
/* 18061 */   MCD::OPC_CheckField, 13, 3, 0, 221, 4, 0, // Skip to: 19313
/* 18068 */   MCD::OPC_Decode, 206, 14, 234, 1, // Opcode: MAQ_S_W_PHR
/* 18073 */   MCD::OPC_FilterValue, 24, 17, 0, 0, // Skip to: 18095
/* 18078 */   MCD::OPC_CheckPredicate, 70, 206, 4, 0, // Skip to: 19313
/* 18083 */   MCD::OPC_CheckField, 13, 3, 0, 199, 4, 0, // Skip to: 19313
/* 18090 */   MCD::OPC_Decode, 133, 10, 234, 1, // Opcode: DPAQX_S_W_PH
/* 18095 */   MCD::OPC_FilterValue, 25, 17, 0, 0, // Skip to: 18117
/* 18100 */   MCD::OPC_CheckPredicate, 70, 184, 4, 0, // Skip to: 19313
/* 18105 */   MCD::OPC_CheckField, 13, 3, 0, 177, 4, 0, // Skip to: 19313
/* 18112 */   MCD::OPC_Decode, 150, 10, 234, 1, // Opcode: DPSQX_S_W_PH
/* 18117 */   MCD::OPC_FilterValue, 26, 17, 0, 0, // Skip to: 18139
/* 18122 */   MCD::OPC_CheckPredicate, 70, 162, 4, 0, // Skip to: 19313
/* 18127 */   MCD::OPC_CheckField, 13, 3, 0, 155, 4, 0, // Skip to: 19313
/* 18134 */   MCD::OPC_Decode, 131, 10, 234, 1, // Opcode: DPAQX_SA_W_PH
/* 18139 */   MCD::OPC_FilterValue, 27, 145, 4, 0, // Skip to: 19313
/* 18144 */   MCD::OPC_CheckPredicate, 70, 140, 4, 0, // Skip to: 19313
/* 18149 */   MCD::OPC_CheckField, 13, 3, 0, 133, 4, 0, // Skip to: 19313
/* 18156 */   MCD::OPC_Decode, 148, 10, 234, 1, // Opcode: DPSQX_SA_W_PH
/* 18161 */   MCD::OPC_FilterValue, 49, 48, 0, 0, // Skip to: 18214
/* 18166 */   MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 18169 */   MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 18184
/* 18174 */   MCD::OPC_CheckPredicate, 70, 110, 4, 0, // Skip to: 19313
/* 18179 */   MCD::OPC_Decode, 138, 5, 203, 2, // Opcode: APPEND
/* 18184 */   MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 18199
/* 18189 */   MCD::OPC_CheckPredicate, 70, 95, 4, 0, // Skip to: 19313
/* 18194 */   MCD::OPC_Decode, 232, 17, 203, 2, // Opcode: PREPEND
/* 18199 */   MCD::OPC_FilterValue, 16, 85, 4, 0, // Skip to: 19313
/* 18204 */   MCD::OPC_CheckPredicate, 70, 80, 4, 0, // Skip to: 19313
/* 18209 */   MCD::OPC_Decode, 182, 5, 203, 2, // Opcode: BALIGN
/* 18214 */   MCD::OPC_FilterValue, 56, 107, 1, 0, // Skip to: 18582
/* 18219 */   MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 18222 */   MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 18244
/* 18227 */   MCD::OPC_CheckPredicate, 37, 57, 4, 0, // Skip to: 19313
/* 18232 */   MCD::OPC_CheckField, 13, 3, 0, 50, 4, 0, // Skip to: 19313
/* 18239 */   MCD::OPC_Decode, 232, 10, 204, 2, // Opcode: EXTR_W
/* 18244 */   MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 18266
/* 18249 */   MCD::OPC_CheckPredicate, 37, 35, 4, 0, // Skip to: 19313
/* 18254 */   MCD::OPC_CheckField, 13, 3, 0, 28, 4, 0, // Skip to: 19313
/* 18261 */   MCD::OPC_Decode, 224, 10, 205, 2, // Opcode: EXTRV_W
/* 18266 */   MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 18288
/* 18271 */   MCD::OPC_CheckPredicate, 37, 13, 4, 0, // Skip to: 19313
/* 18276 */   MCD::OPC_CheckField, 13, 3, 0, 6, 4, 0, // Skip to: 19313
/* 18283 */   MCD::OPC_Decode, 210, 10, 204, 2, // Opcode: EXTP
/* 18288 */   MCD::OPC_FilterValue, 3, 17, 0, 0, // Skip to: 18310
/* 18293 */   MCD::OPC_CheckPredicate, 37, 247, 3, 0, // Skip to: 19313
/* 18298 */   MCD::OPC_CheckField, 13, 3, 0, 240, 3, 0, // Skip to: 19313
/* 18305 */   MCD::OPC_Decode, 215, 10, 205, 2, // Opcode: EXTPV
/* 18310 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 18332
/* 18315 */   MCD::OPC_CheckPredicate, 37, 225, 3, 0, // Skip to: 19313
/* 18320 */   MCD::OPC_CheckField, 13, 3, 0, 218, 3, 0, // Skip to: 19313
/* 18327 */   MCD::OPC_Decode, 228, 10, 204, 2, // Opcode: EXTR_R_W
/* 18332 */   MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 18354
/* 18337 */   MCD::OPC_CheckPredicate, 37, 203, 3, 0, // Skip to: 19313
/* 18342 */   MCD::OPC_CheckField, 13, 3, 0, 196, 3, 0, // Skip to: 19313
/* 18349 */   MCD::OPC_Decode, 220, 10, 205, 2, // Opcode: EXTRV_R_W
/* 18354 */   MCD::OPC_FilterValue, 6, 17, 0, 0, // Skip to: 18376
/* 18359 */   MCD::OPC_CheckPredicate, 37, 181, 3, 0, // Skip to: 19313
/* 18364 */   MCD::OPC_CheckField, 13, 3, 0, 174, 3, 0, // Skip to: 19313
/* 18371 */   MCD::OPC_Decode, 226, 10, 204, 2, // Opcode: EXTR_RS_W
/* 18376 */   MCD::OPC_FilterValue, 7, 17, 0, 0, // Skip to: 18398
/* 18381 */   MCD::OPC_CheckPredicate, 37, 159, 3, 0, // Skip to: 19313
/* 18386 */   MCD::OPC_CheckField, 13, 3, 0, 152, 3, 0, // Skip to: 19313
/* 18393 */   MCD::OPC_Decode, 218, 10, 205, 2, // Opcode: EXTRV_RS_W
/* 18398 */   MCD::OPC_FilterValue, 10, 17, 0, 0, // Skip to: 18420
/* 18403 */   MCD::OPC_CheckPredicate, 37, 137, 3, 0, // Skip to: 19313
/* 18408 */   MCD::OPC_CheckField, 13, 3, 0, 130, 3, 0, // Skip to: 19313
/* 18415 */   MCD::OPC_Decode, 211, 10, 204, 2, // Opcode: EXTPDP
/* 18420 */   MCD::OPC_FilterValue, 11, 17, 0, 0, // Skip to: 18442
/* 18425 */   MCD::OPC_CheckPredicate, 37, 115, 3, 0, // Skip to: 19313
/* 18430 */   MCD::OPC_CheckField, 13, 3, 0, 108, 3, 0, // Skip to: 19313
/* 18437 */   MCD::OPC_Decode, 212, 10, 205, 2, // Opcode: EXTPDPV
/* 18442 */   MCD::OPC_FilterValue, 14, 17, 0, 0, // Skip to: 18464
/* 18447 */   MCD::OPC_CheckPredicate, 37, 93, 3, 0, // Skip to: 19313
/* 18452 */   MCD::OPC_CheckField, 13, 3, 0, 86, 3, 0, // Skip to: 19313
/* 18459 */   MCD::OPC_Decode, 230, 10, 204, 2, // Opcode: EXTR_S_H
/* 18464 */   MCD::OPC_FilterValue, 15, 17, 0, 0, // Skip to: 18486
/* 18469 */   MCD::OPC_CheckPredicate, 37, 71, 3, 0, // Skip to: 19313
/* 18474 */   MCD::OPC_CheckField, 13, 3, 0, 64, 3, 0, // Skip to: 19313
/* 18481 */   MCD::OPC_Decode, 222, 10, 205, 2, // Opcode: EXTRV_S_H
/* 18486 */   MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 18501
/* 18491 */   MCD::OPC_CheckPredicate, 37, 49, 3, 0, // Skip to: 19313
/* 18496 */   MCD::OPC_Decode, 130, 18, 206, 2, // Opcode: RDDSP
/* 18501 */   MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 18516
/* 18506 */   MCD::OPC_CheckPredicate, 40, 34, 3, 0, // Skip to: 19313
/* 18511 */   MCD::OPC_Decode, 237, 21, 207, 2, // Opcode: WRDSP
/* 18516 */   MCD::OPC_FilterValue, 26, 17, 0, 0, // Skip to: 18538
/* 18521 */   MCD::OPC_CheckPredicate, 37, 19, 3, 0, // Skip to: 19313
/* 18526 */   MCD::OPC_CheckField, 13, 7, 0, 12, 3, 0, // Skip to: 19313
/* 18533 */   MCD::OPC_Decode, 135, 19, 208, 2, // Opcode: SHILO
/* 18538 */   MCD::OPC_FilterValue, 27, 17, 0, 0, // Skip to: 18560
/* 18543 */   MCD::OPC_CheckPredicate, 37, 253, 2, 0, // Skip to: 19313
/* 18548 */   MCD::OPC_CheckField, 13, 8, 0, 246, 2, 0, // Skip to: 19313
/* 18555 */   MCD::OPC_Decode, 136, 19, 209, 2, // Opcode: SHILOV
/* 18560 */   MCD::OPC_FilterValue, 31, 236, 2, 0, // Skip to: 19313
/* 18565 */   MCD::OPC_CheckPredicate, 37, 231, 2, 0, // Skip to: 19313
/* 18570 */   MCD::OPC_CheckField, 13, 8, 0, 224, 2, 0, // Skip to: 19313
/* 18577 */   MCD::OPC_Decode, 147, 16, 209, 2, // Opcode: MTHLIP
/* 18582 */   MCD::OPC_FilterValue, 59, 214, 2, 0, // Skip to: 19313
/* 18587 */   MCD::OPC_CheckPredicate, 27, 209, 2, 0, // Skip to: 19313
/* 18592 */   MCD::OPC_CheckField, 21, 5, 0, 202, 2, 0, // Skip to: 19313
/* 18599 */   MCD::OPC_CheckField, 9, 2, 0, 195, 2, 0, // Skip to: 19313
/* 18606 */   MCD::OPC_Decode, 132, 18, 210, 2, // Opcode: RDHWR
/* 18611 */   MCD::OPC_FilterValue, 32, 10, 0, 0, // Skip to: 18626
/* 18616 */   MCD::OPC_CheckPredicate, 27, 180, 2, 0, // Skip to: 19313
/* 18621 */   MCD::OPC_Decode, 176, 13, 128, 1, // Opcode: LB
/* 18626 */   MCD::OPC_FilterValue, 33, 10, 0, 0, // Skip to: 18641
/* 18631 */   MCD::OPC_CheckPredicate, 27, 165, 2, 0, // Skip to: 19313
/* 18636 */   MCD::OPC_Decode, 216, 13, 128, 1, // Opcode: LH
/* 18641 */   MCD::OPC_FilterValue, 34, 10, 0, 0, // Skip to: 18656
/* 18646 */   MCD::OPC_CheckPredicate, 31, 150, 2, 0, // Skip to: 19313
/* 18651 */   MCD::OPC_Decode, 137, 14, 128, 1, // Opcode: LWL
/* 18656 */   MCD::OPC_FilterValue, 35, 10, 0, 0, // Skip to: 18671
/* 18661 */   MCD::OPC_CheckPredicate, 27, 135, 2, 0, // Skip to: 19313
/* 18666 */   MCD::OPC_Decode, 251, 13, 128, 1, // Opcode: LW
/* 18671 */   MCD::OPC_FilterValue, 36, 10, 0, 0, // Skip to: 18686
/* 18676 */   MCD::OPC_CheckPredicate, 27, 120, 2, 0, // Skip to: 19313
/* 18681 */   MCD::OPC_Decode, 186, 13, 128, 1, // Opcode: LBu
/* 18686 */   MCD::OPC_FilterValue, 37, 10, 0, 0, // Skip to: 18701
/* 18691 */   MCD::OPC_CheckPredicate, 27, 105, 2, 0, // Skip to: 19313
/* 18696 */   MCD::OPC_Decode, 224, 13, 128, 1, // Opcode: LHu
/* 18701 */   MCD::OPC_FilterValue, 38, 10, 0, 0, // Skip to: 18716
/* 18706 */   MCD::OPC_CheckPredicate, 31, 90, 2, 0, // Skip to: 19313
/* 18711 */   MCD::OPC_Decode, 148, 14, 128, 1, // Opcode: LWR
/* 18716 */   MCD::OPC_FilterValue, 40, 10, 0, 0, // Skip to: 18731
/* 18721 */   MCD::OPC_CheckPredicate, 27, 75, 2, 0, // Skip to: 19313
/* 18726 */   MCD::OPC_Decode, 188, 18, 128, 1, // Opcode: SB
/* 18731 */   MCD::OPC_FilterValue, 41, 10, 0, 0, // Skip to: 18746
/* 18736 */   MCD::OPC_CheckPredicate, 27, 60, 2, 0, // Skip to: 19313
/* 18741 */   MCD::OPC_Decode, 254, 18, 128, 1, // Opcode: SH
/* 18746 */   MCD::OPC_FilterValue, 42, 10, 0, 0, // Skip to: 18761
/* 18751 */   MCD::OPC_CheckPredicate, 31, 45, 2, 0, // Skip to: 19313
/* 18756 */   MCD::OPC_Decode, 245, 20, 128, 1, // Opcode: SWL
/* 18761 */   MCD::OPC_FilterValue, 43, 10, 0, 0, // Skip to: 18776
/* 18766 */   MCD::OPC_CheckPredicate, 27, 30, 2, 0, // Skip to: 19313
/* 18771 */   MCD::OPC_Decode, 231, 20, 128, 1, // Opcode: SW
/* 18776 */   MCD::OPC_FilterValue, 46, 10, 0, 0, // Skip to: 18791
/* 18781 */   MCD::OPC_CheckPredicate, 31, 15, 2, 0, // Skip to: 19313
/* 18786 */   MCD::OPC_Decode, 254, 20, 128, 1, // Opcode: SWR
/* 18791 */   MCD::OPC_FilterValue, 47, 10, 0, 0, // Skip to: 18806
/* 18796 */   MCD::OPC_CheckPredicate, 72, 0, 2, 0, // Skip to: 19313
/* 18801 */   MCD::OPC_Decode, 247, 6, 211, 2, // Opcode: CACHE
/* 18806 */   MCD::OPC_FilterValue, 48, 10, 0, 0, // Skip to: 18821
/* 18811 */   MCD::OPC_CheckPredicate, 73, 241, 1, 0, // Skip to: 19313
/* 18816 */   MCD::OPC_Decode, 231, 13, 128, 1, // Opcode: LL
/* 18821 */   MCD::OPC_FilterValue, 49, 10, 0, 0, // Skip to: 18836
/* 18826 */   MCD::OPC_CheckPredicate, 48, 226, 1, 0, // Skip to: 19313
/* 18831 */   MCD::OPC_Decode, 254, 13, 212, 2, // Opcode: LWC1
/* 18836 */   MCD::OPC_FilterValue, 50, 148, 0, 0, // Skip to: 18989
/* 18841 */   MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 18844 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 18866
/* 18849 */   MCD::OPC_CheckPredicate, 61, 78, 0, 0, // Skip to: 18932
/* 18854 */   MCD::OPC_CheckField, 14, 2, 0, 71, 0, 0, // Skip to: 18932
/* 18861 */   MCD::OPC_Decode, 191, 12, 213, 2, // Opcode: GSLWLC1
/* 18866 */   MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 18888
/* 18871 */   MCD::OPC_CheckPredicate, 61, 56, 0, 0, // Skip to: 18932
/* 18876 */   MCD::OPC_CheckField, 14, 2, 0, 49, 0, 0, // Skip to: 18932
/* 18883 */   MCD::OPC_Decode, 194, 12, 213, 2, // Opcode: GSLWRC1
/* 18888 */   MCD::OPC_FilterValue, 6, 17, 0, 0, // Skip to: 18910
/* 18893 */   MCD::OPC_CheckPredicate, 61, 34, 0, 0, // Skip to: 18932
/* 18898 */   MCD::OPC_CheckField, 14, 2, 0, 27, 0, 0, // Skip to: 18932
/* 18905 */   MCD::OPC_Decode, 180, 12, 213, 2, // Opcode: GSLDLC1
/* 18910 */   MCD::OPC_FilterValue, 7, 17, 0, 0, // Skip to: 18932
/* 18915 */   MCD::OPC_CheckPredicate, 61, 12, 0, 0, // Skip to: 18932
/* 18920 */   MCD::OPC_CheckField, 14, 2, 0, 5, 0, 0, // Skip to: 18932
/* 18927 */   MCD::OPC_Decode, 184, 12, 213, 2, // Opcode: GSLDRC1
/* 18932 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 18935 */   MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 18957
/* 18940 */   MCD::OPC_CheckPredicate, 41, 34, 0, 0, // Skip to: 18979
/* 18945 */   MCD::OPC_CheckField, 5, 1, 1, 27, 0, 0, // Skip to: 18979
/* 18952 */   MCD::OPC_Decode, 188, 12, 214, 2, // Opcode: GSLQ
/* 18957 */   MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 18979
/* 18962 */   MCD::OPC_CheckPredicate, 61, 12, 0, 0, // Skip to: 18979
/* 18967 */   MCD::OPC_CheckField, 5, 1, 1, 5, 0, 0, // Skip to: 18979
/* 18974 */   MCD::OPC_Decode, 133, 22, 215, 2, // Opcode: gsLQC1
/* 18979 */   MCD::OPC_CheckPredicate, 31, 73, 1, 0, // Skip to: 19313
/* 18984 */   MCD::OPC_Decode, 128, 14, 216, 2, // Opcode: LWC2
/* 18989 */   MCD::OPC_FilterValue, 51, 10, 0, 0, // Skip to: 19004
/* 18994 */   MCD::OPC_CheckPredicate, 72, 58, 1, 0, // Skip to: 19313
/* 18999 */   MCD::OPC_Decode, 225, 17, 211, 2, // Opcode: PREF
/* 19004 */   MCD::OPC_FilterValue, 53, 10, 0, 0, // Skip to: 19019
/* 19009 */   MCD::OPC_CheckPredicate, 57, 43, 1, 0, // Skip to: 19313
/* 19014 */   MCD::OPC_Decode, 192, 13, 212, 2, // Opcode: LDC1
/* 19019 */   MCD::OPC_FilterValue, 54, 43, 0, 0, // Skip to: 19067
/* 19024 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 19027 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 19042
/* 19032 */   MCD::OPC_CheckPredicate, 41, 20, 0, 0, // Skip to: 19057
/* 19037 */   MCD::OPC_Decode, 135, 22, 217, 2, // Opcode: gsLWXC1
/* 19042 */   MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 19057
/* 19047 */   MCD::OPC_CheckPredicate, 41, 5, 0, 0, // Skip to: 19057
/* 19052 */   MCD::OPC_Decode, 131, 22, 217, 2, // Opcode: gsLDXC1
/* 19057 */   MCD::OPC_CheckPredicate, 39, 251, 0, 0, // Skip to: 19313
/* 19062 */   MCD::OPC_Decode, 196, 13, 216, 2, // Opcode: LDC2
/* 19067 */   MCD::OPC_FilterValue, 56, 10, 0, 0, // Skip to: 19082
/* 19072 */   MCD::OPC_CheckPredicate, 73, 236, 0, 0, // Skip to: 19313
/* 19077 */   MCD::OPC_Decode, 196, 18, 128, 1, // Opcode: SC
/* 19082 */   MCD::OPC_FilterValue, 57, 10, 0, 0, // Skip to: 19097
/* 19087 */   MCD::OPC_CheckPredicate, 48, 221, 0, 0, // Skip to: 19313
/* 19092 */   MCD::OPC_Decode, 235, 20, 212, 2, // Opcode: SWC1
/* 19097 */   MCD::OPC_FilterValue, 58, 148, 0, 0, // Skip to: 19250
/* 19102 */   MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 19105 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 19127
/* 19110 */   MCD::OPC_CheckPredicate, 61, 78, 0, 0, // Skip to: 19193
/* 19115 */   MCD::OPC_CheckField, 14, 2, 0, 71, 0, 0, // Skip to: 19193
/* 19122 */   MCD::OPC_Decode, 215, 12, 213, 2, // Opcode: GSSWLC1
/* 19127 */   MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 19149
/* 19132 */   MCD::OPC_CheckPredicate, 61, 56, 0, 0, // Skip to: 19193
/* 19137 */   MCD::OPC_CheckField, 14, 2, 0, 49, 0, 0, // Skip to: 19193
/* 19144 */   MCD::OPC_Decode, 218, 12, 213, 2, // Opcode: GSSWRC1
/* 19149 */   MCD::OPC_FilterValue, 6, 17, 0, 0, // Skip to: 19171
/* 19154 */   MCD::OPC_CheckPredicate, 61, 34, 0, 0, // Skip to: 19193
/* 19159 */   MCD::OPC_CheckField, 14, 2, 0, 27, 0, 0, // Skip to: 19193
/* 19166 */   MCD::OPC_Decode, 206, 12, 213, 2, // Opcode: GSSDLC1
/* 19171 */   MCD::OPC_FilterValue, 7, 17, 0, 0, // Skip to: 19193
/* 19176 */   MCD::OPC_CheckPredicate, 61, 12, 0, 0, // Skip to: 19193
/* 19181 */   MCD::OPC_CheckField, 14, 2, 0, 5, 0, 0, // Skip to: 19193
/* 19188 */   MCD::OPC_Decode, 209, 12, 213, 2, // Opcode: GSSDRC1
/* 19193 */   MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 19196 */   MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 19218
/* 19201 */   MCD::OPC_CheckPredicate, 41, 34, 0, 0, // Skip to: 19240
/* 19206 */   MCD::OPC_CheckField, 5, 1, 1, 27, 0, 0, // Skip to: 19240
/* 19213 */   MCD::OPC_Decode, 212, 12, 214, 2, // Opcode: GSSQ
/* 19218 */   MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 19240
/* 19223 */   MCD::OPC_CheckPredicate, 61, 12, 0, 0, // Skip to: 19240
/* 19228 */   MCD::OPC_CheckField, 5, 1, 1, 5, 0, 0, // Skip to: 19240
/* 19235 */   MCD::OPC_Decode, 140, 22, 215, 2, // Opcode: gsSQC1
/* 19240 */   MCD::OPC_CheckPredicate, 31, 68, 0, 0, // Skip to: 19313
/* 19245 */   MCD::OPC_Decode, 237, 20, 216, 2, // Opcode: SWC2
/* 19250 */   MCD::OPC_FilterValue, 61, 10, 0, 0, // Skip to: 19265
/* 19255 */   MCD::OPC_CheckPredicate, 57, 53, 0, 0, // Skip to: 19313
/* 19260 */   MCD::OPC_Decode, 214, 18, 212, 2, // Opcode: SDC1
/* 19265 */   MCD::OPC_FilterValue, 62, 43, 0, 0, // Skip to: 19313
/* 19270 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 19273 */   MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 19288
/* 19278 */   MCD::OPC_CheckPredicate, 41, 20, 0, 0, // Skip to: 19303
/* 19283 */   MCD::OPC_Decode, 142, 22, 217, 2, // Opcode: gsSWXC1
/* 19288 */   MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 19303
/* 19293 */   MCD::OPC_CheckPredicate, 41, 5, 0, 0, // Skip to: 19303
/* 19298 */   MCD::OPC_Decode, 138, 22, 217, 2, // Opcode: gsSDXC1
/* 19303 */   MCD::OPC_CheckPredicate, 39, 5, 0, 0, // Skip to: 19313
/* 19308 */   MCD::OPC_Decode, 218, 18, 216, 2, // Opcode: SDC2
/* 19313 */   MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMips32_64_PTR6432[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 24
/* 8 */       MCD::OPC_CheckPredicate, 74, 41, 0, 0, // Skip to: 54
/* 13 */      MCD::OPC_CheckField, 0, 21, 8, 34, 0, 0, // Skip to: 54
/* 20 */      MCD::OPC_Decode, 159, 13, 13, // Opcode: JR64
/* 24 */      MCD::OPC_FilterValue, 48, 10, 0, 0, // Skip to: 39
/* 29 */      MCD::OPC_CheckPredicate, 75, 20, 0, 0, // Skip to: 54
/* 34 */      MCD::OPC_Decode, 232, 13, 128, 1, // Opcode: LL64
/* 39 */      MCD::OPC_FilterValue, 56, 10, 0, 0, // Skip to: 54
/* 44 */      MCD::OPC_CheckPredicate, 75, 5, 0, 0, // Skip to: 54
/* 49 */      MCD::OPC_Decode, 197, 18, 128, 1, // Opcode: SC64
/* 54 */      MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMips32r6_64r632[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 0, 14, 2, 0, // Skip to: 534
/* 8 */       MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 11 */      MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 33
/* 16 */      MCD::OPC_CheckPredicate, 76, 133, 9, 0, // Skip to: 2458
/* 21 */      MCD::OPC_CheckField, 8, 3, 0, 126, 9, 0, // Skip to: 2458
/* 28 */      MCD::OPC_Decode, 243, 13, 172, 1, // Opcode: LSA_R6
/* 33 */      MCD::OPC_FilterValue, 9, 17, 0, 0, // Skip to: 55
/* 38 */      MCD::OPC_CheckPredicate, 76, 111, 9, 0, // Skip to: 2458
/* 43 */      MCD::OPC_CheckField, 6, 15, 16, 104, 9, 0, // Skip to: 2458
/* 50 */      MCD::OPC_Decode, 167, 13, 173, 1, // Opcode: JR_HB_R6
/* 55 */      MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 70
/* 60 */      MCD::OPC_CheckPredicate, 77, 89, 9, 0, // Skip to: 2458
/* 65 */      MCD::OPC_Decode, 213, 18, 175, 1, // Opcode: SDBBP_R6
/* 70 */      MCD::OPC_FilterValue, 16, 23, 0, 0, // Skip to: 98
/* 75 */      MCD::OPC_CheckPredicate, 76, 74, 9, 0, // Skip to: 2458
/* 80 */      MCD::OPC_CheckField, 16, 5, 0, 67, 9, 0, // Skip to: 2458
/* 87 */      MCD::OPC_CheckField, 6, 5, 1, 60, 9, 0, // Skip to: 2458
/* 94 */      MCD::OPC_Decode, 195, 7, 14, // Opcode: CLZ_R6
/* 98 */      MCD::OPC_FilterValue, 17, 23, 0, 0, // Skip to: 126
/* 103 */     MCD::OPC_CheckPredicate, 76, 46, 9, 0, // Skip to: 2458
/* 108 */     MCD::OPC_CheckField, 16, 5, 0, 39, 9, 0, // Skip to: 2458
/* 115 */     MCD::OPC_CheckField, 6, 5, 1, 32, 9, 0, // Skip to: 2458
/* 122 */     MCD::OPC_Decode, 175, 7, 14, // Opcode: CLO_R6
/* 126 */     MCD::OPC_FilterValue, 18, 23, 0, 0, // Skip to: 154
/* 131 */     MCD::OPC_CheckPredicate, 78, 18, 9, 0, // Skip to: 2458
/* 136 */     MCD::OPC_CheckField, 16, 5, 0, 11, 9, 0, // Skip to: 2458
/* 143 */     MCD::OPC_CheckField, 6, 5, 1, 4, 9, 0, // Skip to: 2458
/* 150 */     MCD::OPC_Decode, 195, 9, 15, // Opcode: DCLZ_R6
/* 154 */     MCD::OPC_FilterValue, 19, 23, 0, 0, // Skip to: 182
/* 159 */     MCD::OPC_CheckPredicate, 78, 246, 8, 0, // Skip to: 2458
/* 164 */     MCD::OPC_CheckField, 16, 5, 0, 239, 8, 0, // Skip to: 2458
/* 171 */     MCD::OPC_CheckField, 6, 5, 1, 232, 8, 0, // Skip to: 2458
/* 178 */     MCD::OPC_Decode, 193, 9, 15, // Opcode: DCLO_R6
/* 182 */     MCD::OPC_FilterValue, 21, 17, 0, 0, // Skip to: 204
/* 187 */     MCD::OPC_CheckPredicate, 78, 218, 8, 0, // Skip to: 2458
/* 192 */     MCD::OPC_CheckField, 8, 3, 0, 211, 8, 0, // Skip to: 2458
/* 199 */     MCD::OPC_Decode, 226, 9, 181, 1, // Opcode: DLSA_R6
/* 204 */     MCD::OPC_FilterValue, 24, 31, 0, 0, // Skip to: 240
/* 209 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 212 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 226
/* 217 */     MCD::OPC_CheckPredicate, 77, 188, 8, 0, // Skip to: 2458
/* 222 */     MCD::OPC_Decode, 208, 16, 49, // Opcode: MUL_R6
/* 226 */     MCD::OPC_FilterValue, 3, 179, 8, 0, // Skip to: 2458
/* 231 */     MCD::OPC_CheckPredicate, 77, 174, 8, 0, // Skip to: 2458
/* 236 */     MCD::OPC_Decode, 161, 16, 49, // Opcode: MUH
/* 240 */     MCD::OPC_FilterValue, 25, 31, 0, 0, // Skip to: 276
/* 245 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 248 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 262
/* 253 */     MCD::OPC_CheckPredicate, 77, 152, 8, 0, // Skip to: 2458
/* 258 */     MCD::OPC_Decode, 196, 16, 49, // Opcode: MULU
/* 262 */     MCD::OPC_FilterValue, 3, 143, 8, 0, // Skip to: 2458
/* 267 */     MCD::OPC_CheckPredicate, 77, 138, 8, 0, // Skip to: 2458
/* 272 */     MCD::OPC_Decode, 162, 16, 49, // Opcode: MUHU
/* 276 */     MCD::OPC_FilterValue, 26, 31, 0, 0, // Skip to: 312
/* 281 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 284 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 298
/* 289 */     MCD::OPC_CheckPredicate, 77, 116, 8, 0, // Skip to: 2458
/* 294 */     MCD::OPC_Decode, 211, 9, 49, // Opcode: DIV
/* 298 */     MCD::OPC_FilterValue, 3, 107, 8, 0, // Skip to: 2458
/* 303 */     MCD::OPC_CheckPredicate, 77, 102, 8, 0, // Skip to: 2458
/* 308 */     MCD::OPC_Decode, 167, 15, 49, // Opcode: MOD
/* 312 */     MCD::OPC_FilterValue, 27, 31, 0, 0, // Skip to: 348
/* 317 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 320 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 334
/* 325 */     MCD::OPC_CheckPredicate, 77, 80, 8, 0, // Skip to: 2458
/* 330 */     MCD::OPC_Decode, 212, 9, 49, // Opcode: DIVU
/* 334 */     MCD::OPC_FilterValue, 3, 71, 8, 0, // Skip to: 2458
/* 339 */     MCD::OPC_CheckPredicate, 77, 66, 8, 0, // Skip to: 2458
/* 344 */     MCD::OPC_Decode, 170, 15, 49, // Opcode: MODU
/* 348 */     MCD::OPC_FilterValue, 28, 31, 0, 0, // Skip to: 384
/* 353 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 356 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 370
/* 361 */     MCD::OPC_CheckPredicate, 78, 44, 8, 0, // Skip to: 2458
/* 366 */     MCD::OPC_Decode, 246, 9, 12, // Opcode: DMUL_R6
/* 370 */     MCD::OPC_FilterValue, 3, 35, 8, 0, // Skip to: 2458
/* 375 */     MCD::OPC_CheckPredicate, 78, 30, 8, 0, // Skip to: 2458
/* 380 */     MCD::OPC_Decode, 240, 9, 12, // Opcode: DMUH
/* 384 */     MCD::OPC_FilterValue, 29, 31, 0, 0, // Skip to: 420
/* 389 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 392 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 406
/* 397 */     MCD::OPC_CheckPredicate, 78, 8, 8, 0, // Skip to: 2458
/* 402 */     MCD::OPC_Decode, 245, 9, 12, // Opcode: DMULU
/* 406 */     MCD::OPC_FilterValue, 3, 255, 7, 0, // Skip to: 2458
/* 411 */     MCD::OPC_CheckPredicate, 78, 250, 7, 0, // Skip to: 2458
/* 416 */     MCD::OPC_Decode, 241, 9, 12, // Opcode: DMUHU
/* 420 */     MCD::OPC_FilterValue, 30, 31, 0, 0, // Skip to: 456
/* 425 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 428 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 442
/* 433 */     MCD::OPC_CheckPredicate, 78, 228, 7, 0, // Skip to: 2458
/* 438 */     MCD::OPC_Decode, 198, 9, 12, // Opcode: DDIV
/* 442 */     MCD::OPC_FilterValue, 3, 219, 7, 0, // Skip to: 2458
/* 447 */     MCD::OPC_CheckPredicate, 78, 214, 7, 0, // Skip to: 2458
/* 452 */     MCD::OPC_Decode, 232, 9, 12, // Opcode: DMOD
/* 456 */     MCD::OPC_FilterValue, 31, 31, 0, 0, // Skip to: 492
/* 461 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 464 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 478
/* 469 */     MCD::OPC_CheckPredicate, 78, 192, 7, 0, // Skip to: 2458
/* 474 */     MCD::OPC_Decode, 199, 9, 12, // Opcode: DDIVU
/* 478 */     MCD::OPC_FilterValue, 3, 183, 7, 0, // Skip to: 2458
/* 483 */     MCD::OPC_CheckPredicate, 78, 178, 7, 0, // Skip to: 2458
/* 488 */     MCD::OPC_Decode, 233, 9, 12, // Opcode: DMODU
/* 492 */     MCD::OPC_FilterValue, 53, 16, 0, 0, // Skip to: 513
/* 497 */     MCD::OPC_CheckPredicate, 79, 164, 7, 0, // Skip to: 2458
/* 502 */     MCD::OPC_CheckField, 6, 5, 0, 157, 7, 0, // Skip to: 2458
/* 509 */     MCD::OPC_Decode, 234, 18, 49, // Opcode: SELEQZ
/* 513 */     MCD::OPC_FilterValue, 55, 148, 7, 0, // Skip to: 2458
/* 518 */     MCD::OPC_CheckPredicate, 79, 143, 7, 0, // Skip to: 2458
/* 523 */     MCD::OPC_CheckField, 6, 5, 0, 136, 7, 0, // Skip to: 2458
/* 530 */     MCD::OPC_Decode, 241, 18, 49, // Opcode: SELNEZ
/* 534 */     MCD::OPC_FilterValue, 1, 77, 0, 0, // Skip to: 616
/* 539 */     MCD::OPC_ExtractField, 16, 5,  // Inst{20-16} ...
/* 542 */     MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 557
/* 547 */     MCD::OPC_CheckPredicate, 78, 114, 7, 0, // Skip to: 2458
/* 552 */     MCD::OPC_Decode, 187, 9, 218, 2, // Opcode: DAHI
/* 557 */     MCD::OPC_FilterValue, 17, 17, 0, 0, // Skip to: 579
/* 562 */     MCD::OPC_CheckPredicate, 76, 99, 7, 0, // Skip to: 2458
/* 567 */     MCD::OPC_CheckField, 21, 5, 0, 92, 7, 0, // Skip to: 2458
/* 574 */     MCD::OPC_Decode, 179, 5, 185, 1, // Opcode: BAL
/* 579 */     MCD::OPC_FilterValue, 23, 17, 0, 0, // Skip to: 601
/* 584 */     MCD::OPC_CheckPredicate, 77, 77, 7, 0, // Skip to: 2458
/* 589 */     MCD::OPC_CheckField, 21, 5, 0, 70, 7, 0, // Skip to: 2458
/* 596 */     MCD::OPC_Decode, 185, 19, 219, 2, // Opcode: SIGRIE
/* 601 */     MCD::OPC_FilterValue, 30, 60, 7, 0, // Skip to: 2458
/* 606 */     MCD::OPC_CheckPredicate, 78, 55, 7, 0, // Skip to: 2458
/* 611 */     MCD::OPC_Decode, 189, 9, 218, 2, // Opcode: DATI
/* 616 */     MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 631
/* 621 */     MCD::OPC_CheckPredicate, 77, 40, 7, 0, // Skip to: 2458
/* 626 */     MCD::OPC_Decode, 237, 5, 220, 2, // Opcode: BGEZALC
/* 631 */     MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 646
/* 636 */     MCD::OPC_CheckPredicate, 77, 25, 7, 0, // Skip to: 2458
/* 641 */     MCD::OPC_Decode, 167, 6, 221, 2, // Opcode: BLTZALC
/* 646 */     MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 661
/* 651 */     MCD::OPC_CheckPredicate, 77, 10, 7, 0, // Skip to: 2458
/* 656 */     MCD::OPC_Decode, 215, 5, 222, 2, // Opcode: BEQC
/* 661 */     MCD::OPC_FilterValue, 15, 10, 0, 0, // Skip to: 676
/* 666 */     MCD::OPC_CheckPredicate, 76, 251, 6, 0, // Skip to: 2458
/* 671 */     MCD::OPC_Decode, 148, 5, 190, 1, // Opcode: AUI
/* 676 */     MCD::OPC_FilterValue, 16, 45, 0, 0, // Skip to: 726
/* 681 */     MCD::OPC_ExtractField, 0, 16,  // Inst{15-0} ...
/* 684 */     MCD::OPC_FilterValue, 4, 16, 0, 0, // Skip to: 705
/* 689 */     MCD::OPC_CheckPredicate, 76, 228, 6, 0, // Skip to: 2458
/* 694 */     MCD::OPC_CheckField, 21, 5, 11, 221, 6, 0, // Skip to: 2458
/* 701 */     MCD::OPC_Decode, 206, 10, 80, // Opcode: EVP
/* 705 */     MCD::OPC_FilterValue, 36, 212, 6, 0, // Skip to: 2458
/* 710 */     MCD::OPC_CheckPredicate, 76, 207, 6, 0, // Skip to: 2458
/* 715 */     MCD::OPC_CheckField, 21, 5, 11, 200, 6, 0, // Skip to: 2458
/* 722 */     MCD::OPC_Decode, 189, 10, 80, // Opcode: DVP
/* 726 */     MCD::OPC_FilterValue, 17, 135, 3, 0, // Skip to: 1634
/* 731 */     MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 734 */     MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 749
/* 739 */     MCD::OPC_CheckPredicate, 80, 178, 6, 0, // Skip to: 2458
/* 744 */     MCD::OPC_Decode, 190, 5, 223, 2, // Opcode: BC1EQZ
/* 749 */     MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 764
/* 754 */     MCD::OPC_CheckPredicate, 80, 163, 6, 0, // Skip to: 2458
/* 759 */     MCD::OPC_Decode, 195, 5, 223, 2, // Opcode: BC1NEZ
/* 764 */     MCD::OPC_FilterValue, 16, 182, 0, 0, // Skip to: 951
/* 769 */     MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 772 */     MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 787
/* 777 */     MCD::OPC_CheckPredicate, 80, 140, 6, 0, // Skip to: 2458
/* 782 */     MCD::OPC_Decode, 250, 18, 224, 2, // Opcode: SEL_S
/* 787 */     MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 802
/* 792 */     MCD::OPC_CheckPredicate, 80, 125, 6, 0, // Skip to: 2458
/* 797 */     MCD::OPC_Decode, 239, 18, 206, 1, // Opcode: SELEQZ_S
/* 802 */     MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 817
/* 807 */     MCD::OPC_CheckPredicate, 80, 110, 6, 0, // Skip to: 2458
/* 812 */     MCD::OPC_Decode, 246, 18, 206, 1, // Opcode: SELNEZ_S
/* 817 */     MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 832
/* 822 */     MCD::OPC_CheckPredicate, 80, 95, 6, 0, // Skip to: 2458
/* 827 */     MCD::OPC_Decode, 178, 14, 225, 2, // Opcode: MADDF_S
/* 832 */     MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 847
/* 837 */     MCD::OPC_CheckPredicate, 80, 80, 6, 0, // Skip to: 2458
/* 842 */     MCD::OPC_Decode, 229, 15, 225, 2, // Opcode: MSUBF_S
/* 847 */     MCD::OPC_FilterValue, 26, 17, 0, 0, // Skip to: 869
/* 852 */     MCD::OPC_CheckPredicate, 80, 65, 6, 0, // Skip to: 2458
/* 857 */     MCD::OPC_CheckField, 16, 5, 0, 58, 6, 0, // Skip to: 2458
/* 864 */     MCD::OPC_Decode, 153, 18, 207, 1, // Opcode: RINT_S
/* 869 */     MCD::OPC_FilterValue, 27, 17, 0, 0, // Skip to: 891
/* 874 */     MCD::OPC_CheckPredicate, 80, 43, 6, 0, // Skip to: 2458
/* 879 */     MCD::OPC_CheckField, 16, 5, 0, 36, 6, 0, // Skip to: 2458
/* 886 */     MCD::OPC_Decode, 154, 7, 207, 1, // Opcode: CLASS_S
/* 891 */     MCD::OPC_FilterValue, 28, 10, 0, 0, // Skip to: 906
/* 896 */     MCD::OPC_CheckPredicate, 80, 21, 6, 0, // Skip to: 2458
/* 901 */     MCD::OPC_Decode, 157, 15, 206, 1, // Opcode: MIN_S
/* 906 */     MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 921
/* 911 */     MCD::OPC_CheckPredicate, 80, 6, 6, 0, // Skip to: 2458
/* 916 */     MCD::OPC_Decode, 226, 14, 206, 1, // Opcode: MAX_S
/* 921 */     MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 936
/* 926 */     MCD::OPC_CheckPredicate, 80, 247, 5, 0, // Skip to: 2458
/* 931 */     MCD::OPC_Decode, 141, 15, 206, 1, // Opcode: MINA_S
/* 936 */     MCD::OPC_FilterValue, 31, 237, 5, 0, // Skip to: 2458
/* 941 */     MCD::OPC_CheckPredicate, 80, 232, 5, 0, // Skip to: 2458
/* 946 */     MCD::OPC_Decode, 210, 14, 206, 1, // Opcode: MAXA_S
/* 951 */     MCD::OPC_FilterValue, 17, 182, 0, 0, // Skip to: 1138
/* 956 */     MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 959 */     MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 974
/* 964 */     MCD::OPC_CheckPredicate, 80, 209, 5, 0, // Skip to: 2458
/* 969 */     MCD::OPC_Decode, 248, 18, 226, 2, // Opcode: SEL_D
/* 974 */     MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 989
/* 979 */     MCD::OPC_CheckPredicate, 80, 194, 5, 0, // Skip to: 2458
/* 984 */     MCD::OPC_Decode, 236, 18, 225, 1, // Opcode: SELEQZ_D
/* 989 */     MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 1004
/* 994 */     MCD::OPC_CheckPredicate, 80, 179, 5, 0, // Skip to: 2458
/* 999 */     MCD::OPC_Decode, 243, 18, 225, 1, // Opcode: SELNEZ_D
/* 1004 */    MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 1019
/* 1009 */    MCD::OPC_CheckPredicate, 80, 164, 5, 0, // Skip to: 2458
/* 1014 */    MCD::OPC_Decode, 176, 14, 226, 2, // Opcode: MADDF_D
/* 1019 */    MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 1034
/* 1024 */    MCD::OPC_CheckPredicate, 80, 149, 5, 0, // Skip to: 2458
/* 1029 */    MCD::OPC_Decode, 227, 15, 226, 2, // Opcode: MSUBF_D
/* 1034 */    MCD::OPC_FilterValue, 26, 17, 0, 0, // Skip to: 1056
/* 1039 */    MCD::OPC_CheckPredicate, 80, 134, 5, 0, // Skip to: 2458
/* 1044 */    MCD::OPC_CheckField, 16, 5, 0, 127, 5, 0, // Skip to: 2458
/* 1051 */    MCD::OPC_Decode, 151, 18, 218, 1, // Opcode: RINT_D
/* 1056 */    MCD::OPC_FilterValue, 27, 17, 0, 0, // Skip to: 1078
/* 1061 */    MCD::OPC_CheckPredicate, 80, 112, 5, 0, // Skip to: 2458
/* 1066 */    MCD::OPC_CheckField, 16, 5, 0, 105, 5, 0, // Skip to: 2458
/* 1073 */    MCD::OPC_Decode, 152, 7, 218, 1, // Opcode: CLASS_D
/* 1078 */    MCD::OPC_FilterValue, 28, 10, 0, 0, // Skip to: 1093
/* 1083 */    MCD::OPC_CheckPredicate, 80, 90, 5, 0, // Skip to: 2458
/* 1088 */    MCD::OPC_Decode, 155, 15, 225, 1, // Opcode: MIN_D
/* 1093 */    MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 1108
/* 1098 */    MCD::OPC_CheckPredicate, 80, 75, 5, 0, // Skip to: 2458
/* 1103 */    MCD::OPC_Decode, 224, 14, 225, 1, // Opcode: MAX_D
/* 1108 */    MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 1123
/* 1113 */    MCD::OPC_CheckPredicate, 80, 60, 5, 0, // Skip to: 2458
/* 1118 */    MCD::OPC_Decode, 139, 15, 225, 1, // Opcode: MINA_D
/* 1123 */    MCD::OPC_FilterValue, 31, 50, 5, 0, // Skip to: 2458
/* 1128 */    MCD::OPC_CheckPredicate, 80, 45, 5, 0, // Skip to: 2458
/* 1133 */    MCD::OPC_Decode, 208, 14, 225, 1, // Opcode: MAXA_D
/* 1138 */    MCD::OPC_FilterValue, 20, 243, 0, 0, // Skip to: 1386
/* 1143 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 1146 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 1161
/* 1151 */    MCD::OPC_CheckPredicate, 80, 22, 5, 0, // Skip to: 2458
/* 1156 */    MCD::OPC_Decode, 223, 7, 227, 2, // Opcode: CMP_F_S
/* 1161 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 1176
/* 1166 */    MCD::OPC_CheckPredicate, 80, 7, 5, 0, // Skip to: 2458
/* 1171 */    MCD::OPC_Decode, 154, 8, 227, 2, // Opcode: CMP_UN_S
/* 1176 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 1191
/* 1181 */    MCD::OPC_CheckPredicate, 80, 248, 4, 0, // Skip to: 2458
/* 1186 */    MCD::OPC_Decode, 220, 7, 227, 2, // Opcode: CMP_EQ_S
/* 1191 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 1206
/* 1196 */    MCD::OPC_CheckPredicate, 80, 233, 4, 0, // Skip to: 2458
/* 1201 */    MCD::OPC_Decode, 142, 8, 227, 2, // Opcode: CMP_UEQ_S
/* 1206 */    MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 1221
/* 1211 */    MCD::OPC_CheckPredicate, 80, 218, 4, 0, // Skip to: 2458
/* 1216 */    MCD::OPC_Decode, 234, 7, 227, 2, // Opcode: CMP_LT_S
/* 1221 */    MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 1236
/* 1226 */    MCD::OPC_CheckPredicate, 80, 203, 4, 0, // Skip to: 2458
/* 1231 */    MCD::OPC_Decode, 150, 8, 227, 2, // Opcode: CMP_ULT_S
/* 1236 */    MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 1251
/* 1241 */    MCD::OPC_CheckPredicate, 80, 188, 4, 0, // Skip to: 2458
/* 1246 */    MCD::OPC_Decode, 228, 7, 227, 2, // Opcode: CMP_LE_S
/* 1251 */    MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 1266
/* 1256 */    MCD::OPC_CheckPredicate, 80, 173, 4, 0, // Skip to: 2458
/* 1261 */    MCD::OPC_Decode, 146, 8, 227, 2, // Opcode: CMP_ULE_S
/* 1266 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 1281
/* 1271 */    MCD::OPC_CheckPredicate, 80, 158, 4, 0, // Skip to: 2458
/* 1276 */    MCD::OPC_Decode, 238, 7, 227, 2, // Opcode: CMP_SAF_S
/* 1281 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 1296
/* 1286 */    MCD::OPC_CheckPredicate, 80, 143, 4, 0, // Skip to: 2458
/* 1291 */    MCD::OPC_Decode, 138, 8, 227, 2, // Opcode: CMP_SUN_S
/* 1296 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 1311
/* 1301 */    MCD::OPC_CheckPredicate, 80, 128, 4, 0, // Skip to: 2458
/* 1306 */    MCD::OPC_Decode, 242, 7, 227, 2, // Opcode: CMP_SEQ_S
/* 1311 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 1326
/* 1316 */    MCD::OPC_CheckPredicate, 80, 113, 4, 0, // Skip to: 2458
/* 1321 */    MCD::OPC_Decode, 254, 7, 227, 2, // Opcode: CMP_SUEQ_S
/* 1326 */    MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 1341
/* 1331 */    MCD::OPC_CheckPredicate, 80, 98, 4, 0, // Skip to: 2458
/* 1336 */    MCD::OPC_Decode, 250, 7, 227, 2, // Opcode: CMP_SLT_S
/* 1341 */    MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 1356
/* 1346 */    MCD::OPC_CheckPredicate, 80, 83, 4, 0, // Skip to: 2458
/* 1351 */    MCD::OPC_Decode, 134, 8, 227, 2, // Opcode: CMP_SULT_S
/* 1356 */    MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 1371
/* 1361 */    MCD::OPC_CheckPredicate, 80, 68, 4, 0, // Skip to: 2458
/* 1366 */    MCD::OPC_Decode, 246, 7, 227, 2, // Opcode: CMP_SLE_S
/* 1371 */    MCD::OPC_FilterValue, 15, 58, 4, 0, // Skip to: 2458
/* 1376 */    MCD::OPC_CheckPredicate, 80, 53, 4, 0, // Skip to: 2458
/* 1381 */    MCD::OPC_Decode, 130, 8, 227, 2, // Opcode: CMP_SULE_S
/* 1386 */    MCD::OPC_FilterValue, 21, 43, 4, 0, // Skip to: 2458
/* 1391 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 1394 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 1409
/* 1399 */    MCD::OPC_CheckPredicate, 80, 30, 4, 0, // Skip to: 2458
/* 1404 */    MCD::OPC_Decode, 222, 7, 228, 2, // Opcode: CMP_F_D
/* 1409 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 1424
/* 1414 */    MCD::OPC_CheckPredicate, 80, 15, 4, 0, // Skip to: 2458
/* 1419 */    MCD::OPC_Decode, 152, 8, 228, 2, // Opcode: CMP_UN_D
/* 1424 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 1439
/* 1429 */    MCD::OPC_CheckPredicate, 80, 0, 4, 0, // Skip to: 2458
/* 1434 */    MCD::OPC_Decode, 216, 7, 228, 2, // Opcode: CMP_EQ_D
/* 1439 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 1454
/* 1444 */    MCD::OPC_CheckPredicate, 80, 241, 3, 0, // Skip to: 2458
/* 1449 */    MCD::OPC_Decode, 140, 8, 228, 2, // Opcode: CMP_UEQ_D
/* 1454 */    MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 1469
/* 1459 */    MCD::OPC_CheckPredicate, 80, 226, 3, 0, // Skip to: 2458
/* 1464 */    MCD::OPC_Decode, 230, 7, 228, 2, // Opcode: CMP_LT_D
/* 1469 */    MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 1484
/* 1474 */    MCD::OPC_CheckPredicate, 80, 211, 3, 0, // Skip to: 2458
/* 1479 */    MCD::OPC_Decode, 148, 8, 228, 2, // Opcode: CMP_ULT_D
/* 1484 */    MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 1499
/* 1489 */    MCD::OPC_CheckPredicate, 80, 196, 3, 0, // Skip to: 2458
/* 1494 */    MCD::OPC_Decode, 224, 7, 228, 2, // Opcode: CMP_LE_D
/* 1499 */    MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 1514
/* 1504 */    MCD::OPC_CheckPredicate, 80, 181, 3, 0, // Skip to: 2458
/* 1509 */    MCD::OPC_Decode, 144, 8, 228, 2, // Opcode: CMP_ULE_D
/* 1514 */    MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 1529
/* 1519 */    MCD::OPC_CheckPredicate, 80, 166, 3, 0, // Skip to: 2458
/* 1524 */    MCD::OPC_Decode, 236, 7, 228, 2, // Opcode: CMP_SAF_D
/* 1529 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 1544
/* 1534 */    MCD::OPC_CheckPredicate, 80, 151, 3, 0, // Skip to: 2458
/* 1539 */    MCD::OPC_Decode, 136, 8, 228, 2, // Opcode: CMP_SUN_D
/* 1544 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 1559
/* 1549 */    MCD::OPC_CheckPredicate, 80, 136, 3, 0, // Skip to: 2458
/* 1554 */    MCD::OPC_Decode, 240, 7, 228, 2, // Opcode: CMP_SEQ_D
/* 1559 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 1574
/* 1564 */    MCD::OPC_CheckPredicate, 80, 121, 3, 0, // Skip to: 2458
/* 1569 */    MCD::OPC_Decode, 252, 7, 228, 2, // Opcode: CMP_SUEQ_D
/* 1574 */    MCD::OPC_FilterValue, 12, 10, 0, 0, // Skip to: 1589
/* 1579 */    MCD::OPC_CheckPredicate, 80, 106, 3, 0, // Skip to: 2458
/* 1584 */    MCD::OPC_Decode, 248, 7, 228, 2, // Opcode: CMP_SLT_D
/* 1589 */    MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 1604
/* 1594 */    MCD::OPC_CheckPredicate, 80, 91, 3, 0, // Skip to: 2458
/* 1599 */    MCD::OPC_Decode, 132, 8, 228, 2, // Opcode: CMP_SULT_D
/* 1604 */    MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 1619
/* 1609 */    MCD::OPC_CheckPredicate, 80, 76, 3, 0, // Skip to: 2458
/* 1614 */    MCD::OPC_Decode, 244, 7, 228, 2, // Opcode: CMP_SLE_D
/* 1619 */    MCD::OPC_FilterValue, 15, 66, 3, 0, // Skip to: 2458
/* 1624 */    MCD::OPC_CheckPredicate, 80, 61, 3, 0, // Skip to: 2458
/* 1629 */    MCD::OPC_Decode, 128, 8, 228, 2, // Opcode: CMP_SULE_D
/* 1634 */    MCD::OPC_FilterValue, 18, 93, 0, 0, // Skip to: 1732
/* 1639 */    MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 1642 */    MCD::OPC_FilterValue, 9, 10, 0, 0, // Skip to: 1657
/* 1647 */    MCD::OPC_CheckPredicate, 77, 38, 3, 0, // Skip to: 2458
/* 1652 */    MCD::OPC_Decode, 200, 5, 229, 2, // Opcode: BC2EQZ
/* 1657 */    MCD::OPC_FilterValue, 10, 10, 0, 0, // Skip to: 1672
/* 1662 */    MCD::OPC_CheckPredicate, 77, 23, 3, 0, // Skip to: 2458
/* 1667 */    MCD::OPC_Decode, 130, 14, 230, 2, // Opcode: LWC2_R6
/* 1672 */    MCD::OPC_FilterValue, 11, 10, 0, 0, // Skip to: 1687
/* 1677 */    MCD::OPC_CheckPredicate, 77, 8, 3, 0, // Skip to: 2458
/* 1682 */    MCD::OPC_Decode, 239, 20, 230, 2, // Opcode: SWC2_R6
/* 1687 */    MCD::OPC_FilterValue, 13, 10, 0, 0, // Skip to: 1702
/* 1692 */    MCD::OPC_CheckPredicate, 77, 249, 2, 0, // Skip to: 2458
/* 1697 */    MCD::OPC_Decode, 202, 5, 229, 2, // Opcode: BC2NEZ
/* 1702 */    MCD::OPC_FilterValue, 14, 10, 0, 0, // Skip to: 1717
/* 1707 */    MCD::OPC_CheckPredicate, 77, 234, 2, 0, // Skip to: 2458
/* 1712 */    MCD::OPC_Decode, 198, 13, 230, 2, // Opcode: LDC2_R6
/* 1717 */    MCD::OPC_FilterValue, 15, 224, 2, 0, // Skip to: 2458
/* 1722 */    MCD::OPC_CheckPredicate, 77, 219, 2, 0, // Skip to: 2458
/* 1727 */    MCD::OPC_Decode, 220, 18, 230, 2, // Opcode: SDC2_R6
/* 1732 */    MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 1747
/* 1737 */    MCD::OPC_CheckPredicate, 77, 204, 2, 0, // Skip to: 2458
/* 1742 */    MCD::OPC_Decode, 242, 5, 231, 2, // Opcode: BGEZC
/* 1747 */    MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 1762
/* 1752 */    MCD::OPC_CheckPredicate, 77, 189, 2, 0, // Skip to: 2458
/* 1757 */    MCD::OPC_Decode, 172, 6, 232, 2, // Opcode: BLTZC
/* 1762 */    MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 1777
/* 1767 */    MCD::OPC_CheckPredicate, 77, 174, 2, 0, // Skip to: 2458
/* 1772 */    MCD::OPC_Decode, 183, 6, 233, 2, // Opcode: BNEC
/* 1777 */    MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 1792
/* 1782 */    MCD::OPC_CheckPredicate, 78, 159, 2, 0, // Skip to: 2458
/* 1787 */    MCD::OPC_Decode, 190, 9, 191, 1, // Opcode: DAUI
/* 1792 */    MCD::OPC_FilterValue, 31, 135, 1, 0, // Skip to: 2188
/* 1797 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 1800 */    MCD::OPC_FilterValue, 15, 123, 0, 0, // Skip to: 1928
/* 1805 */    MCD::OPC_ExtractField, 6, 10,  // Inst{15-6} ...
/* 1808 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 1823
/* 1813 */    MCD::OPC_CheckPredicate, 81, 128, 2, 0, // Skip to: 2458
/* 1818 */    MCD::OPC_Decode, 163, 8, 234, 2, // Opcode: CRC32B
/* 1823 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 1838
/* 1828 */    MCD::OPC_CheckPredicate, 81, 113, 2, 0, // Skip to: 2458
/* 1833 */    MCD::OPC_Decode, 169, 8, 234, 2, // Opcode: CRC32H
/* 1838 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 1853
/* 1843 */    MCD::OPC_CheckPredicate, 81, 98, 2, 0, // Skip to: 2458
/* 1848 */    MCD::OPC_Decode, 170, 8, 234, 2, // Opcode: CRC32W
/* 1853 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 1868
/* 1858 */    MCD::OPC_CheckPredicate, 82, 83, 2, 0, // Skip to: 2458
/* 1863 */    MCD::OPC_Decode, 168, 8, 234, 2, // Opcode: CRC32D
/* 1868 */    MCD::OPC_FilterValue, 4, 10, 0, 0, // Skip to: 1883
/* 1873 */    MCD::OPC_CheckPredicate, 81, 68, 2, 0, // Skip to: 2458
/* 1878 */    MCD::OPC_Decode, 164, 8, 234, 2, // Opcode: CRC32CB
/* 1883 */    MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 1898
/* 1888 */    MCD::OPC_CheckPredicate, 81, 53, 2, 0, // Skip to: 2458
/* 1893 */    MCD::OPC_Decode, 166, 8, 234, 2, // Opcode: CRC32CH
/* 1898 */    MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 1913
/* 1903 */    MCD::OPC_CheckPredicate, 81, 38, 2, 0, // Skip to: 2458
/* 1908 */    MCD::OPC_Decode, 167, 8, 234, 2, // Opcode: CRC32CW
/* 1913 */    MCD::OPC_FilterValue, 7, 28, 2, 0, // Skip to: 2458
/* 1918 */    MCD::OPC_CheckPredicate, 82, 23, 2, 0, // Skip to: 2458
/* 1923 */    MCD::OPC_Decode, 165, 8, 234, 2, // Opcode: CRC32CD
/* 1928 */    MCD::OPC_FilterValue, 32, 47, 0, 0, // Skip to: 1980
/* 1933 */    MCD::OPC_ExtractField, 8, 3,  // Inst{10-8} ...
/* 1936 */    MCD::OPC_FilterValue, 0, 24, 0, 0, // Skip to: 1965
/* 1941 */    MCD::OPC_CheckPredicate, 76, 0, 2, 0, // Skip to: 2458
/* 1946 */    MCD::OPC_CheckField, 21, 5, 0, 249, 1, 0, // Skip to: 2458
/* 1953 */    MCD::OPC_CheckField, 6, 2, 0, 242, 1, 0, // Skip to: 2458
/* 1960 */    MCD::OPC_Decode, 147, 6, 197, 2, // Opcode: BITSWAP
/* 1965 */    MCD::OPC_FilterValue, 2, 232, 1, 0, // Skip to: 2458
/* 1970 */    MCD::OPC_CheckPredicate, 76, 227, 1, 0, // Skip to: 2458
/* 1975 */    MCD::OPC_Decode, 248, 4, 235, 2, // Opcode: ALIGN
/* 1980 */    MCD::OPC_FilterValue, 36, 47, 0, 0, // Skip to: 2032
/* 1985 */    MCD::OPC_ExtractField, 9, 2,  // Inst{10-9} ...
/* 1988 */    MCD::OPC_FilterValue, 0, 24, 0, 0, // Skip to: 2017
/* 1993 */    MCD::OPC_CheckPredicate, 78, 204, 1, 0, // Skip to: 2458
/* 1998 */    MCD::OPC_CheckField, 21, 5, 0, 197, 1, 0, // Skip to: 2458
/* 2005 */    MCD::OPC_CheckField, 6, 3, 0, 190, 1, 0, // Skip to: 2458
/* 2012 */    MCD::OPC_Decode, 191, 9, 236, 2, // Opcode: DBITSWAP
/* 2017 */    MCD::OPC_FilterValue, 1, 180, 1, 0, // Skip to: 2458
/* 2022 */    MCD::OPC_CheckPredicate, 78, 175, 1, 0, // Skip to: 2458
/* 2027 */    MCD::OPC_Decode, 188, 9, 237, 2, // Opcode: DALIGN
/* 2032 */    MCD::OPC_FilterValue, 37, 17, 0, 0, // Skip to: 2054
/* 2037 */    MCD::OPC_CheckPredicate, 77, 160, 1, 0, // Skip to: 2458
/* 2042 */    MCD::OPC_CheckField, 6, 1, 0, 153, 1, 0, // Skip to: 2458
/* 2049 */    MCD::OPC_Decode, 252, 6, 202, 2, // Opcode: CACHE_R6
/* 2054 */    MCD::OPC_FilterValue, 38, 10, 0, 0, // Skip to: 2069
/* 2059 */    MCD::OPC_CheckPredicate, 83, 138, 1, 0, // Skip to: 2458
/* 2064 */    MCD::OPC_Decode, 205, 18, 238, 2, // Opcode: SC_R6
/* 2069 */    MCD::OPC_FilterValue, 39, 10, 0, 0, // Skip to: 2084
/* 2074 */    MCD::OPC_CheckPredicate, 76, 123, 1, 0, // Skip to: 2458
/* 2079 */    MCD::OPC_Decode, 200, 18, 238, 2, // Opcode: SCD_R6
/* 2084 */    MCD::OPC_FilterValue, 53, 17, 0, 0, // Skip to: 2106
/* 2089 */    MCD::OPC_CheckPredicate, 77, 108, 1, 0, // Skip to: 2458
/* 2094 */    MCD::OPC_CheckField, 6, 1, 0, 101, 1, 0, // Skip to: 2458
/* 2101 */    MCD::OPC_Decode, 231, 17, 202, 2, // Opcode: PREF_R6
/* 2106 */    MCD::OPC_FilterValue, 54, 10, 0, 0, // Skip to: 2121
/* 2111 */    MCD::OPC_CheckPredicate, 83, 86, 1, 0, // Skip to: 2458
/* 2116 */    MCD::OPC_Decode, 240, 13, 238, 2, // Opcode: LL_R6
/* 2121 */    MCD::OPC_FilterValue, 55, 10, 0, 0, // Skip to: 2136
/* 2126 */    MCD::OPC_CheckPredicate, 78, 71, 1, 0, // Skip to: 2458
/* 2131 */    MCD::OPC_Decode, 235, 13, 238, 2, // Opcode: LLD_R6
/* 2136 */    MCD::OPC_FilterValue, 61, 61, 1, 0, // Skip to: 2458
/* 2141 */    MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 2144 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 2166
/* 2149 */    MCD::OPC_CheckPredicate, 84, 48, 1, 0, // Skip to: 2458
/* 2154 */    MCD::OPC_CheckField, 10, 11, 0, 41, 1, 0, // Skip to: 2458
/* 2161 */    MCD::OPC_Decode, 159, 12, 173, 1, // Opcode: GINVI
/* 2166 */    MCD::OPC_FilterValue, 2, 31, 1, 0, // Skip to: 2458
/* 2171 */    MCD::OPC_CheckPredicate, 84, 26, 1, 0, // Skip to: 2458
/* 2176 */    MCD::OPC_CheckField, 10, 11, 0, 19, 1, 0, // Skip to: 2458
/* 2183 */    MCD::OPC_Decode, 161, 12, 239, 2, // Opcode: GINVT
/* 2188 */    MCD::OPC_FilterValue, 50, 10, 0, 0, // Skip to: 2203
/* 2193 */    MCD::OPC_CheckPredicate, 77, 4, 1, 0, // Skip to: 2458
/* 2198 */    MCD::OPC_Decode, 188, 5, 240, 2, // Opcode: BC
/* 2203 */    MCD::OPC_FilterValue, 53, 27, 0, 0, // Skip to: 2235
/* 2208 */    MCD::OPC_CheckPredicate, 24, 12, 0, 0, // Skip to: 2225
/* 2213 */    MCD::OPC_CheckField, 16, 5, 0, 5, 0, 0, // Skip to: 2225
/* 2220 */    MCD::OPC_Decode, 253, 5, 167, 1, // Opcode: BGTZC_MMR6
/* 2225 */    MCD::OPC_CheckPredicate, 24, 228, 0, 0, // Skip to: 2458
/* 2230 */    MCD::OPC_Decode, 174, 6, 167, 1, // Opcode: BLTZC_MMR6
/* 2235 */    MCD::OPC_FilterValue, 54, 26, 0, 0, // Skip to: 2266
/* 2240 */    MCD::OPC_CheckPredicate, 76, 11, 0, 0, // Skip to: 2256
/* 2245 */    MCD::OPC_CheckField, 21, 5, 0, 4, 0, 0, // Skip to: 2256
/* 2252 */    MCD::OPC_Decode, 154, 13, 91, // Opcode: JIC
/* 2256 */    MCD::OPC_CheckPredicate, 77, 197, 0, 0, // Skip to: 2458
/* 2261 */    MCD::OPC_Decode, 222, 5, 241, 2, // Opcode: BEQZC
/* 2266 */    MCD::OPC_FilterValue, 58, 10, 0, 0, // Skip to: 2281
/* 2271 */    MCD::OPC_CheckPredicate, 76, 182, 0, 0, // Skip to: 2458
/* 2276 */    MCD::OPC_Decode, 180, 5, 240, 2, // Opcode: BALC
/* 2281 */    MCD::OPC_FilterValue, 59, 109, 0, 0, // Skip to: 2395
/* 2286 */    MCD::OPC_ExtractField, 19, 2,  // Inst{20-19} ...
/* 2289 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 2304
/* 2294 */    MCD::OPC_CheckPredicate, 76, 159, 0, 0, // Skip to: 2458
/* 2299 */    MCD::OPC_Decode, 175, 4, 161, 1, // Opcode: ADDIUPC
/* 2304 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 2319
/* 2309 */    MCD::OPC_CheckPredicate, 76, 144, 0, 0, // Skip to: 2458
/* 2314 */    MCD::OPC_Decode, 145, 14, 161, 1, // Opcode: LWPC
/* 2319 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 2334
/* 2324 */    MCD::OPC_CheckPredicate, 77, 129, 0, 0, // Skip to: 2458
/* 2329 */    MCD::OPC_Decode, 154, 14, 161, 1, // Opcode: LWUPC
/* 2334 */    MCD::OPC_FilterValue, 3, 119, 0, 0, // Skip to: 2458
/* 2339 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 2342 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 2357
/* 2347 */    MCD::OPC_CheckPredicate, 85, 106, 0, 0, // Skip to: 2458
/* 2352 */    MCD::OPC_Decode, 205, 13, 242, 2, // Opcode: LDPC
/* 2357 */    MCD::OPC_FilterValue, 1, 96, 0, 0, // Skip to: 2458
/* 2362 */    MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 2365 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 2380
/* 2370 */    MCD::OPC_CheckPredicate, 76, 83, 0, 0, // Skip to: 2458
/* 2375 */    MCD::OPC_Decode, 149, 5, 162, 1, // Opcode: AUIPC
/* 2380 */    MCD::OPC_FilterValue, 3, 73, 0, 0, // Skip to: 2458
/* 2385 */    MCD::OPC_CheckPredicate, 76, 68, 0, 0, // Skip to: 2458
/* 2390 */    MCD::OPC_Decode, 250, 4, 162, 1, // Opcode: ALUIPC
/* 2395 */    MCD::OPC_FilterValue, 61, 27, 0, 0, // Skip to: 2427
/* 2400 */    MCD::OPC_CheckPredicate, 24, 12, 0, 0, // Skip to: 2417
/* 2405 */    MCD::OPC_CheckField, 16, 5, 0, 5, 0, 0, // Skip to: 2417
/* 2412 */    MCD::OPC_Decode, 155, 6, 169, 1, // Opcode: BLEZC_MMR6
/* 2417 */    MCD::OPC_CheckPredicate, 24, 36, 0, 0, // Skip to: 2458
/* 2422 */    MCD::OPC_Decode, 244, 5, 169, 1, // Opcode: BGEZC_MMR6
/* 2427 */    MCD::OPC_FilterValue, 62, 26, 0, 0, // Skip to: 2458
/* 2432 */    MCD::OPC_CheckPredicate, 76, 11, 0, 0, // Skip to: 2448
/* 2437 */    MCD::OPC_CheckField, 21, 5, 0, 4, 0, 0, // Skip to: 2448
/* 2444 */    MCD::OPC_Decode, 151, 13, 91, // Opcode: JIALC
/* 2448 */    MCD::OPC_CheckPredicate, 77, 5, 0, 0, // Skip to: 2458
/* 2453 */    MCD::OPC_Decode, 198, 6, 241, 2, // Opcode: BNEZC
/* 2458 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMips32r6_64r6_Ambiguous32[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 6, 27, 0, 0, // Skip to: 35
/* 8 */       MCD::OPC_CheckPredicate, 77, 12, 0, 0, // Skip to: 25
/* 13 */      MCD::OPC_CheckField, 21, 5, 0, 5, 0, 0, // Skip to: 25
/* 20 */      MCD::OPC_Decode, 151, 6, 220, 2, // Opcode: BLEZALC
/* 25 */      MCD::OPC_CheckPredicate, 77, 165, 0, 0, // Skip to: 195
/* 30 */      MCD::OPC_Decode, 231, 5, 220, 2, // Opcode: BGEUC
/* 35 */      MCD::OPC_FilterValue, 7, 27, 0, 0, // Skip to: 67
/* 40 */      MCD::OPC_CheckPredicate, 77, 12, 0, 0, // Skip to: 57
/* 45 */      MCD::OPC_CheckField, 21, 5, 0, 5, 0, 0, // Skip to: 57
/* 52 */      MCD::OPC_Decode, 249, 5, 221, 2, // Opcode: BGTZALC
/* 57 */      MCD::OPC_CheckPredicate, 77, 133, 0, 0, // Skip to: 195
/* 62 */      MCD::OPC_Decode, 161, 6, 221, 2, // Opcode: BLTUC
/* 67 */      MCD::OPC_FilterValue, 8, 27, 0, 0, // Skip to: 99
/* 72 */      MCD::OPC_CheckPredicate, 77, 12, 0, 0, // Skip to: 89
/* 77 */      MCD::OPC_CheckField, 21, 5, 0, 5, 0, 0, // Skip to: 89
/* 84 */      MCD::OPC_Decode, 220, 5, 233, 2, // Opcode: BEQZALC
/* 89 */      MCD::OPC_CheckPredicate, 77, 101, 0, 0, // Skip to: 195
/* 94 */      MCD::OPC_Decode, 211, 6, 222, 2, // Opcode: BOVC
/* 99 */      MCD::OPC_FilterValue, 22, 27, 0, 0, // Skip to: 131
/* 104 */     MCD::OPC_CheckPredicate, 77, 12, 0, 0, // Skip to: 121
/* 109 */     MCD::OPC_CheckField, 21, 5, 0, 5, 0, 0, // Skip to: 121
/* 116 */     MCD::OPC_Decode, 153, 6, 231, 2, // Opcode: BLEZC
/* 121 */     MCD::OPC_CheckPredicate, 77, 69, 0, 0, // Skip to: 195
/* 126 */     MCD::OPC_Decode, 228, 5, 231, 2, // Opcode: BGEC
/* 131 */     MCD::OPC_FilterValue, 23, 27, 0, 0, // Skip to: 163
/* 136 */     MCD::OPC_CheckPredicate, 77, 12, 0, 0, // Skip to: 153
/* 141 */     MCD::OPC_CheckField, 21, 5, 0, 5, 0, 0, // Skip to: 153
/* 148 */     MCD::OPC_Decode, 251, 5, 232, 2, // Opcode: BGTZC
/* 153 */     MCD::OPC_CheckPredicate, 77, 37, 0, 0, // Skip to: 195
/* 158 */     MCD::OPC_Decode, 158, 6, 232, 2, // Opcode: BLTC
/* 163 */     MCD::OPC_FilterValue, 24, 27, 0, 0, // Skip to: 195
/* 168 */     MCD::OPC_CheckPredicate, 77, 12, 0, 0, // Skip to: 185
/* 173 */     MCD::OPC_CheckField, 21, 5, 0, 5, 0, 0, // Skip to: 185
/* 180 */     MCD::OPC_Decode, 196, 6, 233, 2, // Opcode: BNEZALC
/* 185 */     MCD::OPC_CheckPredicate, 77, 5, 0, 0, // Skip to: 195
/* 190 */     MCD::OPC_Decode, 204, 6, 233, 2, // Opcode: BNVC
/* 195 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMips32r6_64r6_BranchZero32[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 18
/* 8 */       MCD::OPC_CheckPredicate, 86, 20, 0, 0, // Skip to: 33
/* 13 */      MCD::OPC_Decode, 243, 5, 231, 2, // Opcode: BGEZC64
/* 18 */      MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 33
/* 23 */      MCD::OPC_CheckPredicate, 86, 5, 0, 0, // Skip to: 33
/* 28 */      MCD::OPC_Decode, 173, 6, 232, 2, // Opcode: BLTZC64
/* 33 */      MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMips32r6_64r6_GP6432[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 0, 53, 0, 0, // Skip to: 61
/* 8 */       MCD::OPC_ExtractField, 0, 11,  // Inst{10-0} ...
/* 11 */      MCD::OPC_FilterValue, 53, 9, 0, 0, // Skip to: 25
/* 16 */      MCD::OPC_CheckPredicate, 87, 226, 0, 0, // Skip to: 247
/* 21 */      MCD::OPC_Decode, 235, 18, 12, // Opcode: SELEQZ64
/* 25 */      MCD::OPC_FilterValue, 55, 9, 0, 0, // Skip to: 39
/* 30 */      MCD::OPC_CheckPredicate, 87, 212, 0, 0, // Skip to: 247
/* 35 */      MCD::OPC_Decode, 242, 18, 12, // Opcode: SELNEZ64
/* 39 */      MCD::OPC_FilterValue, 137, 8, 202, 0, 0, // Skip to: 247
/* 45 */      MCD::OPC_CheckPredicate, 76, 197, 0, 0, // Skip to: 247
/* 50 */      MCD::OPC_CheckField, 11, 10, 0, 190, 0, 0, // Skip to: 247
/* 57 */      MCD::OPC_Decode, 166, 13, 13, // Opcode: JR_HB64_R6
/* 61 */      MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 76
/* 66 */      MCD::OPC_CheckPredicate, 86, 176, 0, 0, // Skip to: 247
/* 71 */      MCD::OPC_Decode, 232, 5, 220, 2, // Opcode: BGEUC64
/* 76 */      MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 91
/* 81 */      MCD::OPC_CheckPredicate, 86, 161, 0, 0, // Skip to: 247
/* 86 */      MCD::OPC_Decode, 162, 6, 221, 2, // Opcode: BLTUC64
/* 91 */      MCD::OPC_FilterValue, 8, 10, 0, 0, // Skip to: 106
/* 96 */      MCD::OPC_CheckPredicate, 86, 146, 0, 0, // Skip to: 247
/* 101 */     MCD::OPC_Decode, 216, 5, 222, 2, // Opcode: BEQC64
/* 106 */     MCD::OPC_FilterValue, 22, 27, 0, 0, // Skip to: 138
/* 111 */     MCD::OPC_CheckPredicate, 86, 12, 0, 0, // Skip to: 128
/* 116 */     MCD::OPC_CheckField, 21, 5, 0, 5, 0, 0, // Skip to: 128
/* 123 */     MCD::OPC_Decode, 154, 6, 231, 2, // Opcode: BLEZC64
/* 128 */     MCD::OPC_CheckPredicate, 86, 114, 0, 0, // Skip to: 247
/* 133 */     MCD::OPC_Decode, 229, 5, 231, 2, // Opcode: BGEC64
/* 138 */     MCD::OPC_FilterValue, 23, 27, 0, 0, // Skip to: 170
/* 143 */     MCD::OPC_CheckPredicate, 86, 12, 0, 0, // Skip to: 160
/* 148 */     MCD::OPC_CheckField, 21, 5, 0, 5, 0, 0, // Skip to: 160
/* 155 */     MCD::OPC_Decode, 252, 5, 232, 2, // Opcode: BGTZC64
/* 160 */     MCD::OPC_CheckPredicate, 86, 82, 0, 0, // Skip to: 247
/* 165 */     MCD::OPC_Decode, 159, 6, 232, 2, // Opcode: BLTC64
/* 170 */     MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 185
/* 175 */     MCD::OPC_CheckPredicate, 86, 67, 0, 0, // Skip to: 247
/* 180 */     MCD::OPC_Decode, 184, 6, 233, 2, // Opcode: BNEC64
/* 185 */     MCD::OPC_FilterValue, 54, 26, 0, 0, // Skip to: 216
/* 190 */     MCD::OPC_CheckPredicate, 86, 11, 0, 0, // Skip to: 206
/* 195 */     MCD::OPC_CheckField, 21, 5, 0, 4, 0, 0, // Skip to: 206
/* 202 */     MCD::OPC_Decode, 155, 13, 11, // Opcode: JIC64
/* 206 */     MCD::OPC_CheckPredicate, 86, 36, 0, 0, // Skip to: 247
/* 211 */     MCD::OPC_Decode, 224, 5, 243, 2, // Opcode: BEQZC64
/* 216 */     MCD::OPC_FilterValue, 62, 26, 0, 0, // Skip to: 247
/* 221 */     MCD::OPC_CheckPredicate, 86, 11, 0, 0, // Skip to: 237
/* 226 */     MCD::OPC_CheckField, 21, 5, 0, 4, 0, 0, // Skip to: 237
/* 233 */     MCD::OPC_Decode, 152, 13, 11, // Opcode: JIALC64
/* 237 */     MCD::OPC_CheckPredicate, 86, 5, 0, 0, // Skip to: 247
/* 242 */     MCD::OPC_Decode, 200, 6, 243, 2, // Opcode: BNEZC64
/* 247 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMips32r6_64r6_PTR6432[] = {
/* 0 */       MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 3 */       MCD::OPC_FilterValue, 38, 17, 0, 0, // Skip to: 25
/* 8 */       MCD::OPC_CheckPredicate, 88, 34, 0, 0, // Skip to: 47
/* 13 */      MCD::OPC_CheckField, 26, 6, 31, 27, 0, 0, // Skip to: 47
/* 20 */      MCD::OPC_Decode, 198, 18, 238, 2, // Opcode: SC64_R6
/* 25 */      MCD::OPC_FilterValue, 54, 17, 0, 0, // Skip to: 47
/* 30 */      MCD::OPC_CheckPredicate, 88, 12, 0, 0, // Skip to: 47
/* 35 */      MCD::OPC_CheckField, 26, 6, 31, 5, 0, 0, // Skip to: 47
/* 42 */      MCD::OPC_Decode, 233, 13, 238, 2, // Opcode: LL64_R6
/* 47 */      MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMips6432[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 0, 236, 1, 0, // Skip to: 500
/* 8 */       MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 11 */      MCD::OPC_FilterValue, 8, 16, 0, 0, // Skip to: 32
/* 16 */      MCD::OPC_CheckPredicate, 69, 214, 6, 0, // Skip to: 1771
/* 21 */      MCD::OPC_CheckField, 6, 15, 16, 207, 6, 0, // Skip to: 1771
/* 28 */      MCD::OPC_Decode, 165, 13, 13, // Opcode: JR_HB64
/* 32 */      MCD::OPC_FilterValue, 9, 45, 0, 0, // Skip to: 82
/* 37 */      MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 40 */      MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 61
/* 45 */      MCD::OPC_CheckPredicate, 89, 185, 6, 0, // Skip to: 1771
/* 50 */      MCD::OPC_CheckField, 16, 5, 0, 178, 6, 0, // Skip to: 1771
/* 57 */      MCD::OPC_Decode, 138, 13, 15, // Opcode: JALR64
/* 61 */      MCD::OPC_FilterValue, 16, 169, 6, 0, // Skip to: 1771
/* 66 */      MCD::OPC_CheckPredicate, 28, 164, 6, 0, // Skip to: 1771
/* 71 */      MCD::OPC_CheckField, 16, 5, 0, 157, 6, 0, // Skip to: 1771
/* 78 */      MCD::OPC_Decode, 145, 13, 15, // Opcode: JALR_HB64
/* 82 */      MCD::OPC_FilterValue, 20, 17, 0, 0, // Skip to: 104
/* 87 */      MCD::OPC_CheckPredicate, 90, 143, 6, 0, // Skip to: 1771
/* 92 */      MCD::OPC_CheckField, 6, 5, 0, 136, 6, 0, // Skip to: 1771
/* 99 */      MCD::OPC_Decode, 179, 10, 244, 2, // Opcode: DSLLV
/* 104 */     MCD::OPC_FilterValue, 22, 33, 0, 0, // Skip to: 142
/* 109 */     MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 112 */     MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 127
/* 117 */     MCD::OPC_CheckPredicate, 90, 113, 6, 0, // Skip to: 1771
/* 122 */     MCD::OPC_Decode, 185, 10, 244, 2, // Opcode: DSRLV
/* 127 */     MCD::OPC_FilterValue, 1, 103, 6, 0, // Skip to: 1771
/* 132 */     MCD::OPC_CheckPredicate, 91, 98, 6, 0, // Skip to: 1771
/* 137 */     MCD::OPC_Decode, 172, 10, 244, 2, // Opcode: DROTRV
/* 142 */     MCD::OPC_FilterValue, 23, 17, 0, 0, // Skip to: 164
/* 147 */     MCD::OPC_CheckPredicate, 90, 83, 6, 0, // Skip to: 1771
/* 152 */     MCD::OPC_CheckField, 6, 5, 0, 76, 6, 0, // Skip to: 1771
/* 159 */     MCD::OPC_Decode, 182, 10, 244, 2, // Opcode: DSRAV
/* 164 */     MCD::OPC_FilterValue, 28, 17, 0, 0, // Skip to: 186
/* 169 */     MCD::OPC_CheckPredicate, 92, 61, 6, 0, // Skip to: 1771
/* 174 */     MCD::OPC_CheckField, 6, 10, 0, 54, 6, 0, // Skip to: 1771
/* 181 */     MCD::OPC_Decode, 243, 9, 236, 1, // Opcode: DMULT
/* 186 */     MCD::OPC_FilterValue, 29, 17, 0, 0, // Skip to: 208
/* 191 */     MCD::OPC_CheckPredicate, 92, 39, 6, 0, // Skip to: 1771
/* 196 */     MCD::OPC_CheckField, 6, 10, 0, 32, 6, 0, // Skip to: 1771
/* 203 */     MCD::OPC_Decode, 244, 9, 236, 1, // Opcode: DMULTu
/* 208 */     MCD::OPC_FilterValue, 30, 17, 0, 0, // Skip to: 230
/* 213 */     MCD::OPC_CheckPredicate, 92, 17, 6, 0, // Skip to: 1771
/* 218 */     MCD::OPC_CheckField, 6, 10, 0, 10, 6, 0, // Skip to: 1771
/* 225 */     MCD::OPC_Decode, 174, 10, 236, 1, // Opcode: DSDIV
/* 230 */     MCD::OPC_FilterValue, 31, 17, 0, 0, // Skip to: 252
/* 235 */     MCD::OPC_CheckPredicate, 92, 251, 5, 0, // Skip to: 1771
/* 240 */     MCD::OPC_CheckField, 6, 10, 0, 244, 5, 0, // Skip to: 1771
/* 247 */     MCD::OPC_Decode, 188, 10, 236, 1, // Opcode: DUDIV
/* 252 */     MCD::OPC_FilterValue, 44, 16, 0, 0, // Skip to: 273
/* 257 */     MCD::OPC_CheckPredicate, 90, 229, 5, 0, // Skip to: 1771
/* 262 */     MCD::OPC_CheckField, 6, 5, 0, 222, 5, 0, // Skip to: 1771
/* 269 */     MCD::OPC_Decode, 183, 9, 12, // Opcode: DADD
/* 273 */     MCD::OPC_FilterValue, 45, 16, 0, 0, // Skip to: 294
/* 278 */     MCD::OPC_CheckPredicate, 90, 208, 5, 0, // Skip to: 1771
/* 283 */     MCD::OPC_CheckField, 6, 5, 0, 201, 5, 0, // Skip to: 1771
/* 290 */     MCD::OPC_Decode, 186, 9, 12, // Opcode: DADDu
/* 294 */     MCD::OPC_FilterValue, 46, 16, 0, 0, // Skip to: 315
/* 299 */     MCD::OPC_CheckPredicate, 90, 187, 5, 0, // Skip to: 1771
/* 304 */     MCD::OPC_CheckField, 6, 5, 0, 180, 5, 0, // Skip to: 1771
/* 311 */     MCD::OPC_Decode, 186, 10, 12, // Opcode: DSUB
/* 315 */     MCD::OPC_FilterValue, 47, 16, 0, 0, // Skip to: 336
/* 320 */     MCD::OPC_CheckPredicate, 90, 166, 5, 0, // Skip to: 1771
/* 325 */     MCD::OPC_CheckField, 6, 5, 0, 159, 5, 0, // Skip to: 1771
/* 332 */     MCD::OPC_Decode, 187, 10, 12, // Opcode: DSUBu
/* 336 */     MCD::OPC_FilterValue, 56, 17, 0, 0, // Skip to: 358
/* 341 */     MCD::OPC_CheckPredicate, 90, 145, 5, 0, // Skip to: 1771
/* 346 */     MCD::OPC_CheckField, 21, 5, 0, 138, 5, 0, // Skip to: 1771
/* 353 */     MCD::OPC_Decode, 176, 10, 245, 2, // Opcode: DSLL
/* 358 */     MCD::OPC_FilterValue, 58, 33, 0, 0, // Skip to: 396
/* 363 */     MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 366 */     MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 381
/* 371 */     MCD::OPC_CheckPredicate, 90, 115, 5, 0, // Skip to: 1771
/* 376 */     MCD::OPC_Decode, 183, 10, 245, 2, // Opcode: DSRL
/* 381 */     MCD::OPC_FilterValue, 1, 105, 5, 0, // Skip to: 1771
/* 386 */     MCD::OPC_CheckPredicate, 91, 100, 5, 0, // Skip to: 1771
/* 391 */     MCD::OPC_Decode, 170, 10, 245, 2, // Opcode: DROTR
/* 396 */     MCD::OPC_FilterValue, 59, 17, 0, 0, // Skip to: 418
/* 401 */     MCD::OPC_CheckPredicate, 90, 85, 5, 0, // Skip to: 1771
/* 406 */     MCD::OPC_CheckField, 21, 5, 0, 78, 5, 0, // Skip to: 1771
/* 413 */     MCD::OPC_Decode, 180, 10, 245, 2, // Opcode: DSRA
/* 418 */     MCD::OPC_FilterValue, 60, 17, 0, 0, // Skip to: 440
/* 423 */     MCD::OPC_CheckPredicate, 90, 63, 5, 0, // Skip to: 1771
/* 428 */     MCD::OPC_CheckField, 21, 5, 0, 56, 5, 0, // Skip to: 1771
/* 435 */     MCD::OPC_Decode, 177, 10, 245, 2, // Opcode: DSLL32
/* 440 */     MCD::OPC_FilterValue, 62, 33, 0, 0, // Skip to: 478
/* 445 */     MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 448 */     MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 463
/* 453 */     MCD::OPC_CheckPredicate, 90, 33, 5, 0, // Skip to: 1771
/* 458 */     MCD::OPC_Decode, 184, 10, 245, 2, // Opcode: DSRL32
/* 463 */     MCD::OPC_FilterValue, 1, 23, 5, 0, // Skip to: 1771
/* 468 */     MCD::OPC_CheckPredicate, 91, 18, 5, 0, // Skip to: 1771
/* 473 */     MCD::OPC_Decode, 171, 10, 245, 2, // Opcode: DROTR32
/* 478 */     MCD::OPC_FilterValue, 63, 8, 5, 0, // Skip to: 1771
/* 483 */     MCD::OPC_CheckPredicate, 90, 3, 5, 0, // Skip to: 1771
/* 488 */     MCD::OPC_CheckField, 21, 5, 0, 252, 4, 0, // Skip to: 1771
/* 495 */     MCD::OPC_Decode, 181, 10, 245, 2, // Opcode: DSRA32
/* 500 */     MCD::OPC_FilterValue, 16, 85, 0, 0, // Skip to: 590
/* 505 */     MCD::OPC_ExtractField, 3, 8,  // Inst{10-3} ...
/* 508 */     MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 546
/* 513 */     MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 516 */     MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 531
/* 521 */     MCD::OPC_CheckPredicate, 93, 221, 4, 0, // Skip to: 1771
/* 526 */     MCD::OPC_Decode, 227, 9, 246, 2, // Opcode: DMFC0
/* 531 */     MCD::OPC_FilterValue, 5, 211, 4, 0, // Skip to: 1771
/* 536 */     MCD::OPC_CheckPredicate, 93, 206, 4, 0, // Skip to: 1771
/* 541 */     MCD::OPC_Decode, 235, 9, 247, 2, // Opcode: DMTC0
/* 546 */     MCD::OPC_FilterValue, 32, 17, 0, 0, // Skip to: 568
/* 551 */     MCD::OPC_CheckPredicate, 94, 191, 4, 0, // Skip to: 1771
/* 556 */     MCD::OPC_CheckField, 21, 5, 3, 184, 4, 0, // Skip to: 1771
/* 563 */     MCD::OPC_Decode, 231, 9, 246, 2, // Opcode: DMFGC0
/* 568 */     MCD::OPC_FilterValue, 96, 174, 4, 0, // Skip to: 1771
/* 573 */     MCD::OPC_CheckPredicate, 94, 169, 4, 0, // Skip to: 1771
/* 578 */     MCD::OPC_CheckField, 21, 5, 3, 162, 4, 0, // Skip to: 1771
/* 585 */     MCD::OPC_Decode, 239, 9, 247, 2, // Opcode: DMTGC0
/* 590 */     MCD::OPC_FilterValue, 18, 47, 0, 0, // Skip to: 642
/* 595 */     MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 598 */     MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 620
/* 603 */     MCD::OPC_CheckPredicate, 93, 139, 4, 0, // Skip to: 1771
/* 608 */     MCD::OPC_CheckField, 3, 8, 0, 132, 4, 0, // Skip to: 1771
/* 615 */     MCD::OPC_Decode, 229, 9, 248, 2, // Opcode: DMFC2
/* 620 */     MCD::OPC_FilterValue, 5, 122, 4, 0, // Skip to: 1771
/* 625 */     MCD::OPC_CheckPredicate, 93, 117, 4, 0, // Skip to: 1771
/* 630 */     MCD::OPC_CheckField, 3, 8, 0, 110, 4, 0, // Skip to: 1771
/* 637 */     MCD::OPC_Decode, 237, 9, 249, 2, // Opcode: DMTC2
/* 642 */     MCD::OPC_FilterValue, 21, 3, 1, 0, // Skip to: 906
/* 647 */     MCD::OPC_ExtractField, 0, 13,  // Inst{12-0} ...
/* 650 */     MCD::OPC_FilterValue, 188, 8, 10, 0, 0, // Skip to: 666
/* 656 */     MCD::OPC_CheckPredicate, 14, 86, 4, 0, // Skip to: 1771
/* 661 */     MCD::OPC_Decode, 221, 8, 250, 2, // Opcode: C_F_D64_MM
/* 666 */     MCD::OPC_FilterValue, 252, 8, 10, 0, 0, // Skip to: 682
/* 672 */     MCD::OPC_CheckPredicate, 14, 70, 4, 0, // Skip to: 1771
/* 677 */     MCD::OPC_Decode, 177, 9, 250, 2, // Opcode: C_UN_D64_MM
/* 682 */     MCD::OPC_FilterValue, 188, 9, 10, 0, 0, // Skip to: 698
/* 688 */     MCD::OPC_CheckPredicate, 14, 54, 4, 0, // Skip to: 1771
/* 693 */     MCD::OPC_Decode, 215, 8, 250, 2, // Opcode: C_EQ_D64_MM
/* 698 */     MCD::OPC_FilterValue, 252, 9, 10, 0, 0, // Skip to: 714
/* 704 */     MCD::OPC_CheckPredicate, 14, 38, 4, 0, // Skip to: 1771
/* 709 */     MCD::OPC_Decode, 159, 9, 250, 2, // Opcode: C_UEQ_D64_MM
/* 714 */     MCD::OPC_FilterValue, 188, 10, 10, 0, 0, // Skip to: 730
/* 720 */     MCD::OPC_CheckPredicate, 14, 22, 4, 0, // Skip to: 1771
/* 725 */     MCD::OPC_Decode, 141, 9, 250, 2, // Opcode: C_OLT_D64_MM
/* 730 */     MCD::OPC_FilterValue, 252, 10, 10, 0, 0, // Skip to: 746
/* 736 */     MCD::OPC_CheckPredicate, 14, 6, 4, 0, // Skip to: 1771
/* 741 */     MCD::OPC_Decode, 171, 9, 250, 2, // Opcode: C_ULT_D64_MM
/* 746 */     MCD::OPC_FilterValue, 188, 11, 10, 0, 0, // Skip to: 762
/* 752 */     MCD::OPC_CheckPredicate, 14, 246, 3, 0, // Skip to: 1771
/* 757 */     MCD::OPC_Decode, 135, 9, 250, 2, // Opcode: C_OLE_D64_MM
/* 762 */     MCD::OPC_FilterValue, 252, 11, 10, 0, 0, // Skip to: 778
/* 768 */     MCD::OPC_CheckPredicate, 14, 230, 3, 0, // Skip to: 1771
/* 773 */     MCD::OPC_Decode, 165, 9, 250, 2, // Opcode: C_ULE_D64_MM
/* 778 */     MCD::OPC_FilterValue, 188, 12, 10, 0, 0, // Skip to: 794
/* 784 */     MCD::OPC_CheckPredicate, 14, 214, 3, 0, // Skip to: 1771
/* 789 */     MCD::OPC_Decode, 153, 9, 250, 2, // Opcode: C_SF_D64_MM
/* 794 */     MCD::OPC_FilterValue, 252, 12, 10, 0, 0, // Skip to: 810
/* 800 */     MCD::OPC_CheckPredicate, 14, 198, 3, 0, // Skip to: 1771
/* 805 */     MCD::OPC_Decode, 245, 8, 250, 2, // Opcode: C_NGLE_D64_MM
/* 810 */     MCD::OPC_FilterValue, 188, 13, 10, 0, 0, // Skip to: 826
/* 816 */     MCD::OPC_CheckPredicate, 14, 182, 3, 0, // Skip to: 1771
/* 821 */     MCD::OPC_Decode, 147, 9, 250, 2, // Opcode: C_SEQ_D64_MM
/* 826 */     MCD::OPC_FilterValue, 252, 13, 10, 0, 0, // Skip to: 842
/* 832 */     MCD::OPC_CheckPredicate, 14, 166, 3, 0, // Skip to: 1771
/* 837 */     MCD::OPC_Decode, 251, 8, 250, 2, // Opcode: C_NGL_D64_MM
/* 842 */     MCD::OPC_FilterValue, 188, 14, 10, 0, 0, // Skip to: 858
/* 848 */     MCD::OPC_CheckPredicate, 14, 150, 3, 0, // Skip to: 1771
/* 853 */     MCD::OPC_Decode, 233, 8, 250, 2, // Opcode: C_LT_D64_MM
/* 858 */     MCD::OPC_FilterValue, 252, 14, 10, 0, 0, // Skip to: 874
/* 864 */     MCD::OPC_CheckPredicate, 14, 134, 3, 0, // Skip to: 1771
/* 869 */     MCD::OPC_Decode, 239, 8, 250, 2, // Opcode: C_NGE_D64_MM
/* 874 */     MCD::OPC_FilterValue, 188, 15, 10, 0, 0, // Skip to: 890
/* 880 */     MCD::OPC_CheckPredicate, 14, 118, 3, 0, // Skip to: 1771
/* 885 */     MCD::OPC_Decode, 227, 8, 250, 2, // Opcode: C_LE_D64_MM
/* 890 */     MCD::OPC_FilterValue, 252, 15, 107, 3, 0, // Skip to: 1771
/* 896 */     MCD::OPC_CheckPredicate, 14, 102, 3, 0, // Skip to: 1771
/* 901 */     MCD::OPC_Decode, 129, 9, 250, 2, // Opcode: C_NGT_D64_MM
/* 906 */     MCD::OPC_FilterValue, 24, 10, 0, 0, // Skip to: 921
/* 911 */     MCD::OPC_CheckPredicate, 95, 87, 3, 0, // Skip to: 1771
/* 916 */     MCD::OPC_Decode, 184, 9, 251, 2, // Opcode: DADDi
/* 921 */     MCD::OPC_FilterValue, 25, 10, 0, 0, // Skip to: 936
/* 926 */     MCD::OPC_CheckPredicate, 90, 72, 3, 0, // Skip to: 1771
/* 931 */     MCD::OPC_Decode, 185, 9, 251, 2, // Opcode: DADDiu
/* 936 */     MCD::OPC_FilterValue, 26, 10, 0, 0, // Skip to: 951
/* 941 */     MCD::OPC_CheckPredicate, 95, 57, 3, 0, // Skip to: 1771
/* 946 */     MCD::OPC_Decode, 204, 13, 128, 1, // Opcode: LDL
/* 951 */     MCD::OPC_FilterValue, 27, 10, 0, 0, // Skip to: 966
/* 956 */     MCD::OPC_CheckPredicate, 95, 42, 3, 0, // Skip to: 1771
/* 961 */     MCD::OPC_Decode, 206, 13, 128, 1, // Opcode: LDR
/* 966 */     MCD::OPC_FilterValue, 28, 33, 0, 0, // Skip to: 1004
/* 971 */     MCD::OPC_ExtractField, 0, 11,  // Inst{10-0} ...
/* 974 */     MCD::OPC_FilterValue, 36, 10, 0, 0, // Skip to: 989
/* 979 */     MCD::OPC_CheckPredicate, 96, 19, 3, 0, // Skip to: 1771
/* 984 */     MCD::OPC_Decode, 194, 9, 252, 2, // Opcode: DCLZ
/* 989 */     MCD::OPC_FilterValue, 37, 9, 3, 0, // Skip to: 1771
/* 994 */     MCD::OPC_CheckPredicate, 96, 4, 3, 0, // Skip to: 1771
/* 999 */     MCD::OPC_Decode, 192, 9, 252, 2, // Opcode: DCLO
/* 1004 */    MCD::OPC_FilterValue, 31, 145, 0, 0, // Skip to: 1154
/* 1009 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 1012 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 1027
/* 1017 */    MCD::OPC_CheckPredicate, 91, 237, 2, 0, // Skip to: 1771
/* 1022 */    MCD::OPC_Decode, 205, 9, 253, 2, // Opcode: DEXTM
/* 1027 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 1042
/* 1032 */    MCD::OPC_CheckPredicate, 91, 222, 2, 0, // Skip to: 1771
/* 1037 */    MCD::OPC_Decode, 206, 9, 253, 2, // Opcode: DEXTU
/* 1042 */    MCD::OPC_FilterValue, 3, 10, 0, 0, // Skip to: 1057
/* 1047 */    MCD::OPC_CheckPredicate, 91, 207, 2, 0, // Skip to: 1771
/* 1052 */    MCD::OPC_Decode, 203, 9, 253, 2, // Opcode: DEXT
/* 1057 */    MCD::OPC_FilterValue, 5, 10, 0, 0, // Skip to: 1072
/* 1062 */    MCD::OPC_CheckPredicate, 91, 192, 2, 0, // Skip to: 1771
/* 1067 */    MCD::OPC_Decode, 209, 9, 254, 2, // Opcode: DINSM
/* 1072 */    MCD::OPC_FilterValue, 6, 10, 0, 0, // Skip to: 1087
/* 1077 */    MCD::OPC_CheckPredicate, 91, 177, 2, 0, // Skip to: 1771
/* 1082 */    MCD::OPC_Decode, 210, 9, 254, 2, // Opcode: DINSU
/* 1087 */    MCD::OPC_FilterValue, 7, 10, 0, 0, // Skip to: 1102
/* 1092 */    MCD::OPC_CheckPredicate, 91, 162, 2, 0, // Skip to: 1771
/* 1097 */    MCD::OPC_Decode, 208, 9, 254, 2, // Opcode: DINS
/* 1102 */    MCD::OPC_FilterValue, 36, 152, 2, 0, // Skip to: 1771
/* 1107 */    MCD::OPC_ExtractField, 6, 5,  // Inst{10-6} ...
/* 1110 */    MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 1132
/* 1115 */    MCD::OPC_CheckPredicate, 91, 139, 2, 0, // Skip to: 1771
/* 1120 */    MCD::OPC_CheckField, 21, 5, 0, 132, 2, 0, // Skip to: 1771
/* 1127 */    MCD::OPC_Decode, 173, 10, 236, 2, // Opcode: DSBH
/* 1132 */    MCD::OPC_FilterValue, 5, 122, 2, 0, // Skip to: 1771
/* 1137 */    MCD::OPC_CheckPredicate, 91, 117, 2, 0, // Skip to: 1771
/* 1142 */    MCD::OPC_CheckField, 21, 5, 0, 110, 2, 0, // Skip to: 1771
/* 1149 */    MCD::OPC_Decode, 175, 10, 236, 2, // Opcode: DSHD
/* 1154 */    MCD::OPC_FilterValue, 39, 10, 0, 0, // Skip to: 1169
/* 1159 */    MCD::OPC_CheckPredicate, 90, 95, 2, 0, // Skip to: 1771
/* 1164 */    MCD::OPC_Decode, 163, 14, 128, 1, // Opcode: LWu
/* 1169 */    MCD::OPC_FilterValue, 44, 10, 0, 0, // Skip to: 1184
/* 1174 */    MCD::OPC_CheckPredicate, 95, 80, 2, 0, // Skip to: 1771
/* 1179 */    MCD::OPC_Decode, 224, 18, 128, 1, // Opcode: SDL
/* 1184 */    MCD::OPC_FilterValue, 45, 10, 0, 0, // Skip to: 1199
/* 1189 */    MCD::OPC_CheckPredicate, 95, 65, 2, 0, // Skip to: 1771
/* 1194 */    MCD::OPC_Decode, 225, 18, 128, 1, // Opcode: SDR
/* 1199 */    MCD::OPC_FilterValue, 50, 183, 0, 0, // Skip to: 1387
/* 1204 */    MCD::OPC_ExtractField, 0, 11,  // Inst{10-0} ...
/* 1207 */    MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 1222
/* 1212 */    MCD::OPC_CheckPredicate, 41, 42, 2, 0, // Skip to: 1771
/* 1217 */    MCD::OPC_Decode, 177, 12, 255, 2, // Opcode: GSLBLE
/* 1222 */    MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 1237
/* 1227 */    MCD::OPC_CheckPredicate, 41, 27, 2, 0, // Skip to: 1771
/* 1232 */    MCD::OPC_Decode, 176, 12, 255, 2, // Opcode: GSLBGT
/* 1237 */    MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 1252
/* 1242 */    MCD::OPC_CheckPredicate, 41, 12, 2, 0, // Skip to: 1771
/* 1247 */    MCD::OPC_Decode, 187, 12, 255, 2, // Opcode: GSLHLE
/* 1252 */    MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 1267
/* 1257 */    MCD::OPC_CheckPredicate, 41, 253, 1, 0, // Skip to: 1771
/* 1262 */    MCD::OPC_Decode, 186, 12, 255, 2, // Opcode: GSLHGT
/* 1267 */    MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 1282
/* 1272 */    MCD::OPC_CheckPredicate, 41, 238, 1, 0, // Skip to: 1771
/* 1277 */    MCD::OPC_Decode, 192, 12, 255, 2, // Opcode: GSLWLE
/* 1282 */    MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 1297
/* 1287 */    MCD::OPC_CheckPredicate, 41, 223, 1, 0, // Skip to: 1771
/* 1292 */    MCD::OPC_Decode, 189, 12, 255, 2, // Opcode: GSLWGT
/* 1297 */    MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 1312
/* 1302 */    MCD::OPC_CheckPredicate, 41, 208, 1, 0, // Skip to: 1771
/* 1307 */    MCD::OPC_Decode, 181, 12, 255, 2, // Opcode: GSLDLE
/* 1312 */    MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 1327
/* 1317 */    MCD::OPC_CheckPredicate, 41, 193, 1, 0, // Skip to: 1771
/* 1322 */    MCD::OPC_Decode, 178, 12, 255, 2, // Opcode: GSLDGT
/* 1327 */    MCD::OPC_FilterValue, 28, 10, 0, 0, // Skip to: 1342
/* 1332 */    MCD::OPC_CheckPredicate, 41, 178, 1, 0, // Skip to: 1771
/* 1337 */    MCD::OPC_Decode, 193, 12, 128, 3, // Opcode: GSLWLEC1
/* 1342 */    MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 1357
/* 1347 */    MCD::OPC_CheckPredicate, 41, 163, 1, 0, // Skip to: 1771
/* 1352 */    MCD::OPC_Decode, 190, 12, 128, 3, // Opcode: GSLWGTC1
/* 1357 */    MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 1372
/* 1362 */    MCD::OPC_CheckPredicate, 41, 148, 1, 0, // Skip to: 1771
/* 1367 */    MCD::OPC_Decode, 182, 12, 128, 3, // Opcode: GSLDLEC1
/* 1372 */    MCD::OPC_FilterValue, 31, 138, 1, 0, // Skip to: 1771
/* 1377 */    MCD::OPC_CheckPredicate, 41, 133, 1, 0, // Skip to: 1771
/* 1382 */    MCD::OPC_Decode, 179, 12, 128, 3, // Opcode: GSLDGTC1
/* 1387 */    MCD::OPC_FilterValue, 52, 10, 0, 0, // Skip to: 1402
/* 1392 */    MCD::OPC_CheckPredicate, 92, 118, 1, 0, // Skip to: 1771
/* 1397 */    MCD::OPC_Decode, 234, 13, 128, 1, // Opcode: LLD
/* 1402 */    MCD::OPC_FilterValue, 54, 63, 0, 0, // Skip to: 1470
/* 1407 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1410 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 1425
/* 1415 */    MCD::OPC_CheckPredicate, 41, 95, 1, 0, // Skip to: 1771
/* 1420 */    MCD::OPC_Decode, 129, 22, 129, 3, // Opcode: gsLBX
/* 1425 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 1440
/* 1430 */    MCD::OPC_CheckPredicate, 41, 80, 1, 0, // Skip to: 1771
/* 1435 */    MCD::OPC_Decode, 132, 22, 129, 3, // Opcode: gsLHX
/* 1440 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 1455
/* 1445 */    MCD::OPC_CheckPredicate, 41, 65, 1, 0, // Skip to: 1771
/* 1450 */    MCD::OPC_Decode, 134, 22, 129, 3, // Opcode: gsLWX
/* 1455 */    MCD::OPC_FilterValue, 3, 55, 1, 0, // Skip to: 1771
/* 1460 */    MCD::OPC_CheckPredicate, 41, 50, 1, 0, // Skip to: 1771
/* 1465 */    MCD::OPC_Decode, 130, 22, 129, 3, // Opcode: gsLDX
/* 1470 */    MCD::OPC_FilterValue, 55, 10, 0, 0, // Skip to: 1485
/* 1475 */    MCD::OPC_CheckPredicate, 90, 35, 1, 0, // Skip to: 1771
/* 1480 */    MCD::OPC_Decode, 191, 13, 128, 1, // Opcode: LD
/* 1485 */    MCD::OPC_FilterValue, 58, 183, 0, 0, // Skip to: 1673
/* 1490 */    MCD::OPC_ExtractField, 0, 11,  // Inst{10-0} ...
/* 1493 */    MCD::OPC_FilterValue, 16, 10, 0, 0, // Skip to: 1508
/* 1498 */    MCD::OPC_CheckPredicate, 41, 12, 1, 0, // Skip to: 1771
/* 1503 */    MCD::OPC_Decode, 203, 12, 255, 2, // Opcode: GSSBLE
/* 1508 */    MCD::OPC_FilterValue, 17, 10, 0, 0, // Skip to: 1523
/* 1513 */    MCD::OPC_CheckPredicate, 41, 253, 0, 0, // Skip to: 1771
/* 1518 */    MCD::OPC_Decode, 202, 12, 255, 2, // Opcode: GSSBGT
/* 1523 */    MCD::OPC_FilterValue, 18, 10, 0, 0, // Skip to: 1538
/* 1528 */    MCD::OPC_CheckPredicate, 41, 238, 0, 0, // Skip to: 1771
/* 1533 */    MCD::OPC_Decode, 211, 12, 255, 2, // Opcode: GSSHLE
/* 1538 */    MCD::OPC_FilterValue, 19, 10, 0, 0, // Skip to: 1553
/* 1543 */    MCD::OPC_CheckPredicate, 41, 223, 0, 0, // Skip to: 1771
/* 1548 */    MCD::OPC_Decode, 210, 12, 255, 2, // Opcode: GSSHGT
/* 1553 */    MCD::OPC_FilterValue, 20, 10, 0, 0, // Skip to: 1568
/* 1558 */    MCD::OPC_CheckPredicate, 41, 208, 0, 0, // Skip to: 1771
/* 1563 */    MCD::OPC_Decode, 216, 12, 255, 2, // Opcode: GSSWLE
/* 1568 */    MCD::OPC_FilterValue, 21, 10, 0, 0, // Skip to: 1583
/* 1573 */    MCD::OPC_CheckPredicate, 41, 193, 0, 0, // Skip to: 1771
/* 1578 */    MCD::OPC_Decode, 213, 12, 255, 2, // Opcode: GSSWGT
/* 1583 */    MCD::OPC_FilterValue, 22, 10, 0, 0, // Skip to: 1598
/* 1588 */    MCD::OPC_CheckPredicate, 41, 178, 0, 0, // Skip to: 1771
/* 1593 */    MCD::OPC_Decode, 207, 12, 255, 2, // Opcode: GSSDLE
/* 1598 */    MCD::OPC_FilterValue, 23, 10, 0, 0, // Skip to: 1613
/* 1603 */    MCD::OPC_CheckPredicate, 41, 163, 0, 0, // Skip to: 1771
/* 1608 */    MCD::OPC_Decode, 204, 12, 255, 2, // Opcode: GSSDGT
/* 1613 */    MCD::OPC_FilterValue, 28, 10, 0, 0, // Skip to: 1628
/* 1618 */    MCD::OPC_CheckPredicate, 41, 148, 0, 0, // Skip to: 1771
/* 1623 */    MCD::OPC_Decode, 217, 12, 128, 3, // Opcode: GSSWLEC1
/* 1628 */    MCD::OPC_FilterValue, 29, 10, 0, 0, // Skip to: 1643
/* 1633 */    MCD::OPC_CheckPredicate, 41, 133, 0, 0, // Skip to: 1771
/* 1638 */    MCD::OPC_Decode, 214, 12, 128, 3, // Opcode: GSSWGTC1
/* 1643 */    MCD::OPC_FilterValue, 30, 10, 0, 0, // Skip to: 1658
/* 1648 */    MCD::OPC_CheckPredicate, 41, 118, 0, 0, // Skip to: 1771
/* 1653 */    MCD::OPC_Decode, 208, 12, 128, 3, // Opcode: GSSDLEC1
/* 1658 */    MCD::OPC_FilterValue, 31, 108, 0, 0, // Skip to: 1771
/* 1663 */    MCD::OPC_CheckPredicate, 41, 103, 0, 0, // Skip to: 1771
/* 1668 */    MCD::OPC_Decode, 205, 12, 128, 3, // Opcode: GSSDGTC1
/* 1673 */    MCD::OPC_FilterValue, 60, 10, 0, 0, // Skip to: 1688
/* 1678 */    MCD::OPC_CheckPredicate, 95, 88, 0, 0, // Skip to: 1771
/* 1683 */    MCD::OPC_Decode, 199, 18, 128, 1, // Opcode: SCD
/* 1688 */    MCD::OPC_FilterValue, 62, 63, 0, 0, // Skip to: 1756
/* 1693 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1696 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 1711
/* 1701 */    MCD::OPC_CheckPredicate, 41, 65, 0, 0, // Skip to: 1771
/* 1706 */    MCD::OPC_Decode, 136, 22, 129, 3, // Opcode: gsSBX
/* 1711 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 1726
/* 1716 */    MCD::OPC_CheckPredicate, 41, 50, 0, 0, // Skip to: 1771
/* 1721 */    MCD::OPC_Decode, 139, 22, 129, 3, // Opcode: gsSHX
/* 1726 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 1741
/* 1731 */    MCD::OPC_CheckPredicate, 41, 35, 0, 0, // Skip to: 1771
/* 1736 */    MCD::OPC_Decode, 141, 22, 129, 3, // Opcode: gsSWX
/* 1741 */    MCD::OPC_FilterValue, 3, 25, 0, 0, // Skip to: 1771
/* 1746 */    MCD::OPC_CheckPredicate, 41, 20, 0, 0, // Skip to: 1771
/* 1751 */    MCD::OPC_Decode, 137, 22, 129, 3, // Opcode: gsSDX
/* 1756 */    MCD::OPC_FilterValue, 63, 10, 0, 0, // Skip to: 1771
/* 1761 */    MCD::OPC_CheckPredicate, 90, 5, 0, 0, // Skip to: 1771
/* 1766 */    MCD::OPC_Decode, 206, 18, 128, 1, // Opcode: SD
/* 1771 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMipsDSP32[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 35, 10, 0, 0, // Skip to: 18
/* 8 */       MCD::OPC_CheckPredicate, 97, 20, 0, 0, // Skip to: 33
/* 13 */      MCD::OPC_Decode, 132, 14, 128, 1, // Opcode: LWDSP
/* 18 */      MCD::OPC_FilterValue, 43, 10, 0, 0, // Skip to: 33
/* 23 */      MCD::OPC_CheckPredicate, 97, 5, 0, 0, // Skip to: 33
/* 28 */      MCD::OPC_Decode, 241, 20, 128, 1, // Opcode: SWDSP
/* 33 */      MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableMipsFP6432[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 17, 74, 5, 0, // Skip to: 1362
/* 8 */       MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 11 */      MCD::OPC_FilterValue, 0, 106, 0, 0, // Skip to: 122
/* 16 */      MCD::OPC_ExtractField, 21, 5,  // Inst{25-21} ...
/* 19 */      MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 41
/* 24 */      MCD::OPC_CheckPredicate, 98, 239, 5, 0, // Skip to: 1548
/* 29 */      MCD::OPC_CheckField, 6, 5, 0, 232, 5, 0, // Skip to: 1548
/* 36 */      MCD::OPC_Decode, 239, 14, 130, 3, // Opcode: MFC1_D64
/* 41 */      MCD::OPC_FilterValue, 3, 17, 0, 0, // Skip to: 63
/* 46 */      MCD::OPC_CheckPredicate, 99, 217, 5, 0, // Skip to: 1548
/* 51 */      MCD::OPC_CheckField, 6, 5, 0, 210, 5, 0, // Skip to: 1548
/* 58 */      MCD::OPC_Decode, 249, 14, 130, 3, // Opcode: MFHC1_D64
/* 63 */      MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 85
/* 68 */      MCD::OPC_CheckPredicate, 98, 195, 5, 0, // Skip to: 1548
/* 73 */      MCD::OPC_CheckField, 6, 5, 0, 188, 5, 0, // Skip to: 1548
/* 80 */      MCD::OPC_Decode, 254, 15, 131, 3, // Opcode: MTC1_D64
/* 85 */      MCD::OPC_FilterValue, 7, 17, 0, 0, // Skip to: 107
/* 90 */      MCD::OPC_CheckPredicate, 99, 173, 5, 0, // Skip to: 1548
/* 95 */      MCD::OPC_CheckField, 6, 5, 0, 166, 5, 0, // Skip to: 1548
/* 102 */     MCD::OPC_Decode, 137, 16, 132, 3, // Opcode: MTHC1_D64
/* 107 */     MCD::OPC_FilterValue, 17, 156, 5, 0, // Skip to: 1548
/* 112 */     MCD::OPC_CheckPredicate, 98, 151, 5, 0, // Skip to: 1548
/* 117 */     MCD::OPC_Decode, 247, 10, 225, 1, // Opcode: FADD_D64
/* 122 */     MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 144
/* 127 */     MCD::OPC_CheckPredicate, 98, 136, 5, 0, // Skip to: 1548
/* 132 */     MCD::OPC_CheckField, 21, 5, 17, 129, 5, 0, // Skip to: 1548
/* 139 */     MCD::OPC_Decode, 133, 12, 225, 1, // Opcode: FSUB_D64
/* 144 */     MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 166
/* 149 */     MCD::OPC_CheckPredicate, 98, 114, 5, 0, // Skip to: 1548
/* 154 */     MCD::OPC_CheckField, 21, 5, 17, 107, 5, 0, // Skip to: 1548
/* 161 */     MCD::OPC_Decode, 218, 11, 225, 1, // Opcode: FMUL_D64
/* 166 */     MCD::OPC_FilterValue, 3, 17, 0, 0, // Skip to: 188
/* 171 */     MCD::OPC_CheckPredicate, 98, 92, 5, 0, // Skip to: 1548
/* 176 */     MCD::OPC_CheckField, 21, 5, 17, 85, 5, 0, // Skip to: 1548
/* 183 */     MCD::OPC_Decode, 157, 11, 225, 1, // Opcode: FDIV_D64
/* 188 */     MCD::OPC_FilterValue, 4, 18, 0, 0, // Skip to: 211
/* 193 */     MCD::OPC_CheckPredicate, 100, 70, 5, 0, // Skip to: 1548
/* 198 */     MCD::OPC_CheckField, 16, 10, 160, 4, 62, 5, 0, // Skip to: 1548
/* 206 */     MCD::OPC_Decode, 253, 11, 218, 1, // Opcode: FSQRT_D64
/* 211 */     MCD::OPC_FilterValue, 5, 18, 0, 0, // Skip to: 234
/* 216 */     MCD::OPC_CheckPredicate, 98, 47, 5, 0, // Skip to: 1548
/* 221 */     MCD::OPC_CheckField, 16, 10, 160, 4, 39, 5, 0, // Skip to: 1548
/* 229 */     MCD::OPC_Decode, 240, 10, 218, 1, // Opcode: FABS_D64
/* 234 */     MCD::OPC_FilterValue, 6, 18, 0, 0, // Skip to: 257
/* 239 */     MCD::OPC_CheckPredicate, 98, 24, 5, 0, // Skip to: 1548
/* 244 */     MCD::OPC_CheckField, 16, 10, 160, 4, 16, 5, 0, // Skip to: 1548
/* 252 */     MCD::OPC_Decode, 208, 11, 218, 1, // Opcode: FMOV_D64
/* 257 */     MCD::OPC_FilterValue, 7, 18, 0, 0, // Skip to: 280
/* 262 */     MCD::OPC_CheckPredicate, 98, 1, 5, 0, // Skip to: 1548
/* 267 */     MCD::OPC_CheckField, 16, 10, 160, 4, 249, 4, 0, // Skip to: 1548
/* 275 */     MCD::OPC_Decode, 226, 11, 218, 1, // Opcode: FNEG_D64
/* 280 */     MCD::OPC_FilterValue, 8, 35, 0, 0, // Skip to: 320
/* 285 */     MCD::OPC_ExtractField, 16, 10,  // Inst{25-16} ...
/* 288 */     MCD::OPC_FilterValue, 128, 4, 10, 0, 0, // Skip to: 304
/* 294 */     MCD::OPC_CheckPredicate, 100, 225, 4, 0, // Skip to: 1548
/* 299 */     MCD::OPC_Decode, 161, 18, 211, 1, // Opcode: ROUND_L_S
/* 304 */     MCD::OPC_FilterValue, 160, 4, 214, 4, 0, // Skip to: 1548
/* 310 */     MCD::OPC_CheckPredicate, 101, 209, 4, 0, // Skip to: 1548
/* 315 */     MCD::OPC_Decode, 159, 18, 218, 1, // Opcode: ROUND_L_D64
/* 320 */     MCD::OPC_FilterValue, 9, 35, 0, 0, // Skip to: 360
/* 325 */     MCD::OPC_ExtractField, 16, 10,  // Inst{25-16} ...
/* 328 */     MCD::OPC_FilterValue, 128, 4, 10, 0, 0, // Skip to: 344
/* 334 */     MCD::OPC_CheckPredicate, 100, 185, 4, 0, // Skip to: 1548
/* 339 */     MCD::OPC_Decode, 215, 21, 211, 1, // Opcode: TRUNC_L_S
/* 344 */     MCD::OPC_FilterValue, 160, 4, 174, 4, 0, // Skip to: 1548
/* 350 */     MCD::OPC_CheckPredicate, 101, 169, 4, 0, // Skip to: 1548
/* 355 */     MCD::OPC_Decode, 213, 21, 218, 1, // Opcode: TRUNC_L_D64
/* 360 */     MCD::OPC_FilterValue, 10, 35, 0, 0, // Skip to: 400
/* 365 */     MCD::OPC_ExtractField, 16, 10,  // Inst{25-16} ...
/* 368 */     MCD::OPC_FilterValue, 128, 4, 10, 0, 0, // Skip to: 384
/* 374 */     MCD::OPC_CheckPredicate, 100, 145, 4, 0, // Skip to: 1548
/* 379 */     MCD::OPC_Decode, 255, 6, 211, 1, // Opcode: CEIL_L_S
/* 384 */     MCD::OPC_FilterValue, 160, 4, 134, 4, 0, // Skip to: 1548
/* 390 */     MCD::OPC_CheckPredicate, 101, 129, 4, 0, // Skip to: 1548
/* 395 */     MCD::OPC_Decode, 253, 6, 218, 1, // Opcode: CEIL_L_D64
/* 400 */     MCD::OPC_FilterValue, 11, 35, 0, 0, // Skip to: 440
/* 405 */     MCD::OPC_ExtractField, 16, 10,  // Inst{25-16} ...
/* 408 */     MCD::OPC_FilterValue, 128, 4, 10, 0, 0, // Skip to: 424
/* 414 */     MCD::OPC_CheckPredicate, 100, 105, 4, 0, // Skip to: 1548
/* 419 */     MCD::OPC_Decode, 187, 11, 211, 1, // Opcode: FLOOR_L_S
/* 424 */     MCD::OPC_FilterValue, 160, 4, 94, 4, 0, // Skip to: 1548
/* 430 */     MCD::OPC_CheckPredicate, 101, 89, 4, 0, // Skip to: 1548
/* 435 */     MCD::OPC_Decode, 185, 11, 218, 1, // Opcode: FLOOR_L_D64
/* 440 */     MCD::OPC_FilterValue, 12, 18, 0, 0, // Skip to: 463
/* 445 */     MCD::OPC_CheckPredicate, 100, 74, 4, 0, // Skip to: 1548
/* 450 */     MCD::OPC_CheckField, 16, 10, 160, 4, 66, 4, 0, // Skip to: 1548
/* 458 */     MCD::OPC_Decode, 164, 18, 133, 3, // Opcode: ROUND_W_D64
/* 463 */     MCD::OPC_FilterValue, 13, 18, 0, 0, // Skip to: 486
/* 468 */     MCD::OPC_CheckPredicate, 100, 51, 4, 0, // Skip to: 1548
/* 473 */     MCD::OPC_CheckField, 16, 10, 160, 4, 43, 4, 0, // Skip to: 1548
/* 481 */     MCD::OPC_Decode, 218, 21, 133, 3, // Opcode: TRUNC_W_D64
/* 486 */     MCD::OPC_FilterValue, 14, 18, 0, 0, // Skip to: 509
/* 491 */     MCD::OPC_CheckPredicate, 100, 28, 4, 0, // Skip to: 1548
/* 496 */     MCD::OPC_CheckField, 16, 10, 160, 4, 20, 4, 0, // Skip to: 1548
/* 504 */     MCD::OPC_Decode, 130, 7, 133, 3, // Opcode: CEIL_W_D64
/* 509 */     MCD::OPC_FilterValue, 15, 18, 0, 0, // Skip to: 532
/* 514 */     MCD::OPC_CheckPredicate, 100, 5, 4, 0, // Skip to: 1548
/* 519 */     MCD::OPC_CheckField, 16, 10, 160, 4, 253, 3, 0, // Skip to: 1548
/* 527 */     MCD::OPC_Decode, 190, 11, 133, 3, // Opcode: FLOOR_W_D64
/* 532 */     MCD::OPC_FilterValue, 17, 47, 0, 0, // Skip to: 584
/* 537 */     MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 540 */     MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 562
/* 545 */     MCD::OPC_CheckPredicate, 102, 230, 3, 0, // Skip to: 1548
/* 550 */     MCD::OPC_CheckField, 21, 5, 17, 223, 3, 0, // Skip to: 1548
/* 557 */     MCD::OPC_Decode, 188, 15, 134, 3, // Opcode: MOVF_D64
/* 562 */     MCD::OPC_FilterValue, 1, 213, 3, 0, // Skip to: 1548
/* 567 */     MCD::OPC_CheckPredicate, 102, 208, 3, 0, // Skip to: 1548
/* 572 */     MCD::OPC_CheckField, 21, 5, 17, 201, 3, 0, // Skip to: 1548
/* 579 */     MCD::OPC_Decode, 208, 15, 134, 3, // Opcode: MOVT_D64
/* 584 */     MCD::OPC_FilterValue, 18, 17, 0, 0, // Skip to: 606
/* 589 */     MCD::OPC_CheckPredicate, 102, 186, 3, 0, // Skip to: 1548
/* 594 */     MCD::OPC_CheckField, 21, 5, 17, 179, 3, 0, // Skip to: 1548
/* 601 */     MCD::OPC_Decode, 220, 15, 135, 3, // Opcode: MOVZ_I_D64
/* 606 */     MCD::OPC_FilterValue, 19, 17, 0, 0, // Skip to: 628
/* 611 */     MCD::OPC_CheckPredicate, 102, 164, 3, 0, // Skip to: 1548
/* 616 */     MCD::OPC_CheckField, 21, 5, 17, 157, 3, 0, // Skip to: 1548
/* 623 */     MCD::OPC_Decode, 200, 15, 135, 3, // Opcode: MOVN_I_D64
/* 628 */     MCD::OPC_FilterValue, 21, 18, 0, 0, // Skip to: 651
/* 633 */     MCD::OPC_CheckPredicate, 103, 142, 3, 0, // Skip to: 1548
/* 638 */     MCD::OPC_CheckField, 16, 10, 160, 4, 134, 3, 0, // Skip to: 1548
/* 646 */     MCD::OPC_Decode, 139, 18, 218, 1, // Opcode: RECIP_D64
/* 651 */     MCD::OPC_FilterValue, 22, 18, 0, 0, // Skip to: 674
/* 656 */     MCD::OPC_CheckPredicate, 103, 119, 3, 0, // Skip to: 1548
/* 661 */     MCD::OPC_CheckField, 16, 10, 160, 4, 111, 3, 0, // Skip to: 1548
/* 669 */     MCD::OPC_Decode, 172, 18, 218, 1, // Opcode: RSQRT_D64
/* 674 */     MCD::OPC_FilterValue, 32, 51, 0, 0, // Skip to: 730
/* 679 */     MCD::OPC_ExtractField, 16, 10,  // Inst{25-16} ...
/* 682 */     MCD::OPC_FilterValue, 160, 4, 10, 0, 0, // Skip to: 698
/* 688 */     MCD::OPC_CheckPredicate, 98, 87, 3, 0, // Skip to: 1548
/* 693 */     MCD::OPC_Decode, 196, 8, 133, 3, // Opcode: CVT_S_D64
/* 698 */     MCD::OPC_FilterValue, 160, 5, 10, 0, 0, // Skip to: 714
/* 704 */     MCD::OPC_CheckPredicate, 104, 71, 3, 0, // Skip to: 1548
/* 709 */     MCD::OPC_Decode, 198, 8, 133, 3, // Opcode: CVT_S_L
/* 714 */     MCD::OPC_FilterValue, 192, 5, 60, 3, 0, // Skip to: 1548
/* 720 */     MCD::OPC_CheckPredicate, 105, 55, 3, 0, // Skip to: 1548
/* 725 */     MCD::OPC_Decode, 201, 8, 133, 3, // Opcode: CVT_S_PU64
/* 730 */     MCD::OPC_FilterValue, 33, 51, 0, 0, // Skip to: 786
/* 735 */     MCD::OPC_ExtractField, 16, 10,  // Inst{25-16} ...
/* 738 */     MCD::OPC_FilterValue, 128, 4, 10, 0, 0, // Skip to: 754
/* 744 */     MCD::OPC_CheckPredicate, 98, 31, 3, 0, // Skip to: 1548
/* 749 */     MCD::OPC_Decode, 182, 8, 211, 1, // Opcode: CVT_D64_S
/* 754 */     MCD::OPC_FilterValue, 128, 5, 10, 0, 0, // Skip to: 770
/* 760 */     MCD::OPC_CheckPredicate, 98, 15, 3, 0, // Skip to: 1548
/* 765 */     MCD::OPC_Decode, 184, 8, 211, 1, // Opcode: CVT_D64_W
/* 770 */     MCD::OPC_FilterValue, 160, 5, 4, 3, 0, // Skip to: 1548
/* 776 */     MCD::OPC_CheckPredicate, 104, 255, 2, 0, // Skip to: 1548
/* 781 */     MCD::OPC_Decode, 181, 8, 218, 1, // Opcode: CVT_D64_L
/* 786 */     MCD::OPC_FilterValue, 36, 18, 0, 0, // Skip to: 809
/* 791 */     MCD::OPC_CheckPredicate, 98, 240, 2, 0, // Skip to: 1548
/* 796 */     MCD::OPC_CheckField, 16, 10, 160, 4, 232, 2, 0, // Skip to: 1548
/* 804 */     MCD::OPC_Decode, 207, 8, 133, 3, // Opcode: CVT_W_D64
/* 809 */     MCD::OPC_FilterValue, 38, 17, 0, 0, // Skip to: 831
/* 814 */     MCD::OPC_CheckPredicate, 105, 217, 2, 0, // Skip to: 1548
/* 819 */     MCD::OPC_CheckField, 21, 5, 16, 210, 2, 0, // Skip to: 1548
/* 826 */     MCD::OPC_Decode, 193, 8, 136, 3, // Opcode: CVT_PS_S64
/* 831 */     MCD::OPC_FilterValue, 40, 18, 0, 0, // Skip to: 854
/* 836 */     MCD::OPC_CheckPredicate, 105, 195, 2, 0, // Skip to: 1548
/* 841 */     MCD::OPC_CheckField, 16, 10, 192, 5, 187, 2, 0, // Skip to: 1548
/* 849 */     MCD::OPC_Decode, 200, 8, 133, 3, // Opcode: CVT_S_PL64
/* 854 */     MCD::OPC_FilterValue, 44, 17, 0, 0, // Skip to: 876
/* 859 */     MCD::OPC_CheckPredicate, 105, 172, 2, 0, // Skip to: 1548
/* 864 */     MCD::OPC_CheckField, 21, 5, 22, 165, 2, 0, // Skip to: 1548
/* 871 */     MCD::OPC_Decode, 176, 17, 225, 1, // Opcode: PLL_PS64
/* 876 */     MCD::OPC_FilterValue, 45, 17, 0, 0, // Skip to: 898
/* 881 */     MCD::OPC_CheckPredicate, 105, 150, 2, 0, // Skip to: 1548
/* 886 */     MCD::OPC_CheckField, 21, 5, 22, 143, 2, 0, // Skip to: 1548
/* 893 */     MCD::OPC_Decode, 177, 17, 225, 1, // Opcode: PLU_PS64
/* 898 */     MCD::OPC_FilterValue, 48, 24, 0, 0, // Skip to: 927
/* 903 */     MCD::OPC_CheckPredicate, 106, 128, 2, 0, // Skip to: 1548
/* 908 */     MCD::OPC_CheckField, 21, 5, 17, 121, 2, 0, // Skip to: 1548
/* 915 */     MCD::OPC_CheckField, 6, 2, 0, 114, 2, 0, // Skip to: 1548
/* 922 */     MCD::OPC_Decode, 220, 8, 137, 3, // Opcode: C_F_D64
/* 927 */     MCD::OPC_FilterValue, 49, 24, 0, 0, // Skip to: 956
/* 932 */     MCD::OPC_CheckPredicate, 106, 99, 2, 0, // Skip to: 1548
/* 937 */     MCD::OPC_CheckField, 21, 5, 17, 92, 2, 0, // Skip to: 1548
/* 944 */     MCD::OPC_CheckField, 6, 2, 0, 85, 2, 0, // Skip to: 1548
/* 951 */     MCD::OPC_Decode, 176, 9, 137, 3, // Opcode: C_UN_D64
/* 956 */     MCD::OPC_FilterValue, 50, 24, 0, 0, // Skip to: 985
/* 961 */     MCD::OPC_CheckPredicate, 106, 70, 2, 0, // Skip to: 1548
/* 966 */     MCD::OPC_CheckField, 21, 5, 17, 63, 2, 0, // Skip to: 1548
/* 973 */     MCD::OPC_CheckField, 6, 2, 0, 56, 2, 0, // Skip to: 1548
/* 980 */     MCD::OPC_Decode, 214, 8, 137, 3, // Opcode: C_EQ_D64
/* 985 */     MCD::OPC_FilterValue, 51, 24, 0, 0, // Skip to: 1014
/* 990 */     MCD::OPC_CheckPredicate, 106, 41, 2, 0, // Skip to: 1548
/* 995 */     MCD::OPC_CheckField, 21, 5, 17, 34, 2, 0, // Skip to: 1548
/* 1002 */    MCD::OPC_CheckField, 6, 2, 0, 27, 2, 0, // Skip to: 1548
/* 1009 */    MCD::OPC_Decode, 158, 9, 137, 3, // Opcode: C_UEQ_D64
/* 1014 */    MCD::OPC_FilterValue, 52, 24, 0, 0, // Skip to: 1043
/* 1019 */    MCD::OPC_CheckPredicate, 106, 12, 2, 0, // Skip to: 1548
/* 1024 */    MCD::OPC_CheckField, 21, 5, 17, 5, 2, 0, // Skip to: 1548
/* 1031 */    MCD::OPC_CheckField, 6, 2, 0, 254, 1, 0, // Skip to: 1548
/* 1038 */    MCD::OPC_Decode, 140, 9, 137, 3, // Opcode: C_OLT_D64
/* 1043 */    MCD::OPC_FilterValue, 53, 24, 0, 0, // Skip to: 1072
/* 1048 */    MCD::OPC_CheckPredicate, 106, 239, 1, 0, // Skip to: 1548
/* 1053 */    MCD::OPC_CheckField, 21, 5, 17, 232, 1, 0, // Skip to: 1548
/* 1060 */    MCD::OPC_CheckField, 6, 2, 0, 225, 1, 0, // Skip to: 1548
/* 1067 */    MCD::OPC_Decode, 170, 9, 137, 3, // Opcode: C_ULT_D64
/* 1072 */    MCD::OPC_FilterValue, 54, 24, 0, 0, // Skip to: 1101
/* 1077 */    MCD::OPC_CheckPredicate, 106, 210, 1, 0, // Skip to: 1548
/* 1082 */    MCD::OPC_CheckField, 21, 5, 17, 203, 1, 0, // Skip to: 1548
/* 1089 */    MCD::OPC_CheckField, 6, 2, 0, 196, 1, 0, // Skip to: 1548
/* 1096 */    MCD::OPC_Decode, 134, 9, 137, 3, // Opcode: C_OLE_D64
/* 1101 */    MCD::OPC_FilterValue, 55, 24, 0, 0, // Skip to: 1130
/* 1106 */    MCD::OPC_CheckPredicate, 106, 181, 1, 0, // Skip to: 1548
/* 1111 */    MCD::OPC_CheckField, 21, 5, 17, 174, 1, 0, // Skip to: 1548
/* 1118 */    MCD::OPC_CheckField, 6, 2, 0, 167, 1, 0, // Skip to: 1548
/* 1125 */    MCD::OPC_Decode, 164, 9, 137, 3, // Opcode: C_ULE_D64
/* 1130 */    MCD::OPC_FilterValue, 56, 24, 0, 0, // Skip to: 1159
/* 1135 */    MCD::OPC_CheckPredicate, 106, 152, 1, 0, // Skip to: 1548
/* 1140 */    MCD::OPC_CheckField, 21, 5, 17, 145, 1, 0, // Skip to: 1548
/* 1147 */    MCD::OPC_CheckField, 6, 2, 0, 138, 1, 0, // Skip to: 1548
/* 1154 */    MCD::OPC_Decode, 152, 9, 137, 3, // Opcode: C_SF_D64
/* 1159 */    MCD::OPC_FilterValue, 57, 24, 0, 0, // Skip to: 1188
/* 1164 */    MCD::OPC_CheckPredicate, 106, 123, 1, 0, // Skip to: 1548
/* 1169 */    MCD::OPC_CheckField, 21, 5, 17, 116, 1, 0, // Skip to: 1548
/* 1176 */    MCD::OPC_CheckField, 6, 2, 0, 109, 1, 0, // Skip to: 1548
/* 1183 */    MCD::OPC_Decode, 244, 8, 137, 3, // Opcode: C_NGLE_D64
/* 1188 */    MCD::OPC_FilterValue, 58, 24, 0, 0, // Skip to: 1217
/* 1193 */    MCD::OPC_CheckPredicate, 106, 94, 1, 0, // Skip to: 1548
/* 1198 */    MCD::OPC_CheckField, 21, 5, 17, 87, 1, 0, // Skip to: 1548
/* 1205 */    MCD::OPC_CheckField, 6, 2, 0, 80, 1, 0, // Skip to: 1548
/* 1212 */    MCD::OPC_Decode, 146, 9, 137, 3, // Opcode: C_SEQ_D64
/* 1217 */    MCD::OPC_FilterValue, 59, 24, 0, 0, // Skip to: 1246
/* 1222 */    MCD::OPC_CheckPredicate, 106, 65, 1, 0, // Skip to: 1548
/* 1227 */    MCD::OPC_CheckField, 21, 5, 17, 58, 1, 0, // Skip to: 1548
/* 1234 */    MCD::OPC_CheckField, 6, 2, 0, 51, 1, 0, // Skip to: 1548
/* 1241 */    MCD::OPC_Decode, 250, 8, 137, 3, // Opcode: C_NGL_D64
/* 1246 */    MCD::OPC_FilterValue, 60, 24, 0, 0, // Skip to: 1275
/* 1251 */    MCD::OPC_CheckPredicate, 106, 36, 1, 0, // Skip to: 1548
/* 1256 */    MCD::OPC_CheckField, 21, 5, 17, 29, 1, 0, // Skip to: 1548
/* 1263 */    MCD::OPC_CheckField, 6, 2, 0, 22, 1, 0, // Skip to: 1548
/* 1270 */    MCD::OPC_Decode, 232, 8, 137, 3, // Opcode: C_LT_D64
/* 1275 */    MCD::OPC_FilterValue, 61, 24, 0, 0, // Skip to: 1304
/* 1280 */    MCD::OPC_CheckPredicate, 106, 7, 1, 0, // Skip to: 1548
/* 1285 */    MCD::OPC_CheckField, 21, 5, 17, 0, 1, 0, // Skip to: 1548
/* 1292 */    MCD::OPC_CheckField, 6, 2, 0, 249, 0, 0, // Skip to: 1548
/* 1299 */    MCD::OPC_Decode, 238, 8, 137, 3, // Opcode: C_NGE_D64
/* 1304 */    MCD::OPC_FilterValue, 62, 24, 0, 0, // Skip to: 1333
/* 1309 */    MCD::OPC_CheckPredicate, 106, 234, 0, 0, // Skip to: 1548
/* 1314 */    MCD::OPC_CheckField, 21, 5, 17, 227, 0, 0, // Skip to: 1548
/* 1321 */    MCD::OPC_CheckField, 6, 2, 0, 220, 0, 0, // Skip to: 1548
/* 1328 */    MCD::OPC_Decode, 226, 8, 137, 3, // Opcode: C_LE_D64
/* 1333 */    MCD::OPC_FilterValue, 63, 210, 0, 0, // Skip to: 1548
/* 1338 */    MCD::OPC_CheckPredicate, 106, 205, 0, 0, // Skip to: 1548
/* 1343 */    MCD::OPC_CheckField, 21, 5, 17, 198, 0, 0, // Skip to: 1548
/* 1350 */    MCD::OPC_CheckField, 6, 2, 0, 191, 0, 0, // Skip to: 1548
/* 1357 */    MCD::OPC_Decode, 128, 9, 137, 3, // Opcode: C_NGT_D64
/* 1362 */    MCD::OPC_FilterValue, 19, 151, 0, 0, // Skip to: 1518
/* 1367 */    MCD::OPC_ExtractField, 0, 6,  // Inst{5-0} ...
/* 1370 */    MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 1392
/* 1375 */    MCD::OPC_CheckPredicate, 107, 168, 0, 0, // Skip to: 1548
/* 1380 */    MCD::OPC_CheckField, 11, 5, 0, 161, 0, 0, // Skip to: 1548
/* 1387 */    MCD::OPC_Decode, 208, 13, 138, 3, // Opcode: LDXC164
/* 1392 */    MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 1414
/* 1397 */    MCD::OPC_CheckPredicate, 108, 146, 0, 0, // Skip to: 1548
/* 1402 */    MCD::OPC_CheckField, 11, 5, 0, 139, 0, 0, // Skip to: 1548
/* 1409 */    MCD::OPC_Decode, 246, 13, 138, 3, // Opcode: LUXC164
/* 1414 */    MCD::OPC_FilterValue, 9, 17, 0, 0, // Skip to: 1436
/* 1419 */    MCD::OPC_CheckPredicate, 107, 124, 0, 0, // Skip to: 1548
/* 1424 */    MCD::OPC_CheckField, 6, 5, 0, 117, 0, 0, // Skip to: 1548
/* 1431 */    MCD::OPC_Decode, 227, 18, 139, 3, // Opcode: SDXC164
/* 1436 */    MCD::OPC_FilterValue, 13, 17, 0, 0, // Skip to: 1458
/* 1441 */    MCD::OPC_CheckPredicate, 108, 102, 0, 0, // Skip to: 1548
/* 1446 */    MCD::OPC_CheckField, 6, 5, 0, 95, 0, 0, // Skip to: 1548
/* 1453 */    MCD::OPC_Decode, 229, 20, 139, 3, // Opcode: SUXC164
/* 1458 */    MCD::OPC_FilterValue, 33, 10, 0, 0, // Skip to: 1473
/* 1463 */    MCD::OPC_CheckPredicate, 109, 80, 0, 0, // Skip to: 1548
/* 1468 */    MCD::OPC_Decode, 192, 14, 140, 3, // Opcode: MADD_D64
/* 1473 */    MCD::OPC_FilterValue, 41, 10, 0, 0, // Skip to: 1488
/* 1478 */    MCD::OPC_CheckPredicate, 109, 65, 0, 0, // Skip to: 1548
/* 1483 */    MCD::OPC_Decode, 243, 15, 140, 3, // Opcode: MSUB_D64
/* 1488 */    MCD::OPC_FilterValue, 49, 10, 0, 0, // Skip to: 1503
/* 1493 */    MCD::OPC_CheckPredicate, 110, 50, 0, 0, // Skip to: 1548
/* 1498 */    MCD::OPC_Decode, 225, 16, 140, 3, // Opcode: NMADD_D64
/* 1503 */    MCD::OPC_FilterValue, 57, 40, 0, 0, // Skip to: 1548
/* 1508 */    MCD::OPC_CheckPredicate, 110, 35, 0, 0, // Skip to: 1548
/* 1513 */    MCD::OPC_Decode, 230, 16, 140, 3, // Opcode: NMSUB_D64
/* 1518 */    MCD::OPC_FilterValue, 53, 10, 0, 0, // Skip to: 1533
/* 1523 */    MCD::OPC_CheckPredicate, 100, 20, 0, 0, // Skip to: 1548
/* 1528 */    MCD::OPC_Decode, 193, 13, 212, 2, // Opcode: LDC164
/* 1533 */    MCD::OPC_FilterValue, 61, 10, 0, 0, // Skip to: 1548
/* 1538 */    MCD::OPC_CheckPredicate, 100, 5, 0, 0, // Skip to: 1548
/* 1543 */    MCD::OPC_Decode, 215, 18, 212, 2, // Opcode: SDC164
/* 1548 */    MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset& Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[Mips::FeatureMips16]);
  case 1:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureCnMips] && !Bits[Mips::FeatureMicroMips]);
  case 2:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips2] && !Bits[Mips::FeatureCnMips] && !Bits[Mips::FeatureMicroMips]);
  case 3:
    return (Bits[Mips::FeatureCnMips] && Bits[Mips::FeatureCnMips] && !Bits[Mips::FeatureLoongson3a] && Bits[Mips::FeatureCnMips]);
  case 4:
    return (Bits[Mips::FeatureCnMips] && Bits[Mips::FeatureMips64] && Bits[Mips::FeatureCnMips] && !Bits[Mips::FeatureLoongson3a] && !Bits[Mips::FeatureMicroMips]);
  case 5:
    return (Bits[Mips::FeatureMicroMips] && !Bits[Mips::FeatureMips32r6]);
  case 6:
    return (Bits[Mips::FeatureMicroMips]);
  case 7:
    return (Bits[Mips::FeatureMicroMips] && Bits[Mips::FeatureDSP]);
  case 8:
    return (Bits[Mips::FeatureMicroMips] && Bits[Mips::FeatureDSPR2]);
  case 9:
    return (Bits[Mips::FeatureMicroMips] && Bits[Mips::FeatureMips32r5] && Bits[Mips::FeatureVirt]);
  case 10:
    return (Bits[Mips::FeatureMicroMips] && Bits[Mips::FeatureDSPR3]);
  case 11:
    return (Bits[Mips::FeatureMicroMips] && !Bits[Mips::FeatureMips32r6] && Bits[Mips::FeatureDSP]);
  case 12:
    return (Bits[Mips::FeatureMicroMips] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureSoftFloat]);
  case 13:
    return (Bits[Mips::FeatureMicroMips] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMadd4]);
  case 14:
    return (Bits[Mips::FeatureMicroMips] && Bits[Mips::FeatureFP64Bit] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureSoftFloat]);
  case 15:
    return (Bits[Mips::FeatureMicroMips] && !Bits[Mips::FeatureFP64Bit] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMadd4]);
  case 16:
    return (Bits[Mips::FeatureMicroMips] && !Bits[Mips::FeatureFP64Bit] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureSoftFloat]);
  case 17:
    return (Bits[Mips::FeatureMicroMips] && !Bits[Mips::FeatureFP64Bit] && !Bits[Mips::FeatureSoftFloat]);
  case 18:
    return (Bits[Mips::FeatureMicroMips] && !Bits[Mips::FeatureSoftFloat]);
  case 19:
    return (Bits[Mips::FeatureMicroMips] && Bits[Mips::FeatureFP64Bit] && !Bits[Mips::FeatureSoftFloat]);
  case 20:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureSoftFloat]);
  case 21:
    return (Bits[Mips::FeatureMicroMips] && Bits[Mips::FeatureEVA]);
  case 22:
    return (Bits[Mips::FeatureMicroMips] && !Bits[Mips::FeatureMips32r6] && Bits[Mips::FeatureEVA]);
  case 23:
    return (Bits[Mips::FeatureMicroMips] && Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureSoftFloat]);
  case 24:
    return (Bits[Mips::FeatureMicroMips] && Bits[Mips::FeatureMips32r6]);
  case 25:
    return (Bits[Mips::FeatureMicroMips] && Bits[Mips::FeatureMips32r6] && Bits[Mips::FeatureGINV]);
  case 26:
    return (Bits[Mips::FeatureMicroMips] && Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureSoftFloat]);
  case 27:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureMicroMips]);
  case 28:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips32r2] && !Bits[Mips::FeatureMicroMips]);
  case 29:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips4_32] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 30:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMSA]);
  case 31:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureMicroMips]);
  case 32:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips32r2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6]);
  case 33:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureMicroMips] && !Bits[Mips::FeatureUseIndirectJumpsHazard]);
  case 34:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips32]);
  case 35:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips4_32] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureMicroMips]);
  case 36:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips2] && !Bits[Mips::FeatureMicroMips]);
  case 37:
    return (Bits[Mips::FeatureDSP]);
  case 38:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMSA] && Bits[Mips::FeatureMips64]);
  case 39:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureMicroMips]);
  case 40:
    return (Bits[Mips::FeatureDSP] && !Bits[Mips::FeatureMicroMips]);
  case 41:
    return (Bits[Mips::FeatureLoongson3a] && Bits[Mips::FeatureLoongson3a] && Bits[Mips::FeatureLoongson3a]);
  case 42:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips32r5] && Bits[Mips::FeatureVirt] && !Bits[Mips::FeatureMicroMips]);
  case 43:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMT] && !Bits[Mips::FeatureMicroMips]);
  case 44:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips3_32] && !Bits[Mips::FeatureMicroMips]);
  case 45:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips32r2] && Bits[Mips::FeatureEVA] && !Bits[Mips::FeatureMicroMips]);
  case 46:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips32r5] && !Bits[Mips::FeatureMicroMips]);
  case 47:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips32] && !Bits[Mips::FeatureMicroMips]);
  case 48:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 49:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips3] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 50:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips32r2] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 51:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 52:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 53:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips2] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 54:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips4_32r2] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 55:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureFP64Bit] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 56:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips3_32r2] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 57:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips2] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 58:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips4_32] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 59:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips4_32r2] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 60:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureFP64Bit] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 61:
    return (Bits[Mips::FeatureLoongson3a] && Bits[Mips::FeatureLoongson3a] && !Bits[Mips::FeatureSoftFloat] && Bits[Mips::FeatureLoongson3a]);
  case 62:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips4_32r2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat]);
  case 63:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips4_32r2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 64:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips5_32r2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 65:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips4_32r2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips] && !Bits[Mips::FeatureMadd4]);
  case 66:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips4_32r2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips] && !Bits[Mips::FeatureMadd4]);
  case 67:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips4_32r2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMadd4] && !Bits[Mips::FeatureMicroMips]);
  case 68:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips4_32r2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMadd4] && !Bits[Mips::FeatureMicroMips]);
  case 69:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips32] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureMicroMips]);
  case 70:
    return (Bits[Mips::FeatureDSPR2]);
  case 71:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips32r2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && Bits[Mips::FeatureEVA] && !Bits[Mips::FeatureMicroMips]);
  case 72:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips3_32] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureMicroMips]);
  case 73:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeaturePTR64Bit] && Bits[Mips::FeatureMips2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureMicroMips]);
  case 74:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeaturePTR64Bit] && !Bits[Mips::FeatureMicroMips]);
  case 75:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeaturePTR64Bit] && Bits[Mips::FeatureMips2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureMicroMips]);
  case 76:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips32r6]);
  case 77:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMicroMips]);
  case 78:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureMicroMips]);
  case 79:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeatureGP64Bit] && Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMicroMips]);
  case 80:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 81:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips32r6] && Bits[Mips::FeatureCRC] && !Bits[Mips::FeatureMicroMips]);
  case 82:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips64r6] && Bits[Mips::FeatureCRC] && !Bits[Mips::FeatureMicroMips]);
  case 83:
    return (!Bits[Mips::FeatureMips16] && !Bits[Mips::FeaturePTR64Bit] && Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMicroMips]);
  case 84:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips32r6] && Bits[Mips::FeatureGINV] && !Bits[Mips::FeatureMicroMips]);
  case 85:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips64r6]);
  case 86:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureGP64Bit] && Bits[Mips::FeatureMips64r6]);
  case 87:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureGP64Bit] && Bits[Mips::FeatureMips32r6]);
  case 88:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeaturePTR64Bit] && Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureMicroMips]);
  case 89:
    return (!Bits[Mips::FeatureMips16]);
  case 90:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips3] && !Bits[Mips::FeatureMicroMips]);
  case 91:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips64r2] && !Bits[Mips::FeatureMicroMips]);
  case 92:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips3] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureMicroMips]);
  case 93:
    return (Bits[Mips::FeatureMips64]);
  case 94:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips64r5] && Bits[Mips::FeatureVirt]);
  case 95:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips3] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6]);
  case 96:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureMips64] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureMicroMips]);
  case 97:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureDSP]);
  case 98:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureFP64Bit] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 99:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips32r2] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 100:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips2] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 101:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips3_32] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 102:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips4_32] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 103:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips4_32r2] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 104:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips3_32r2] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 105:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips32r2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 106:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureFP64Bit] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 107:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips4_32r2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat]);
  case 108:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips5_32r2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips]);
  case 109:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips4_32r2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMicroMips] && !Bits[Mips::FeatureMadd4]);
  case 110:
    return (!Bits[Mips::FeatureMips16] && Bits[Mips::FeatureFP64Bit] && Bits[Mips::FeatureMips4_32r2] && !Bits[Mips::FeatureMips32r6] && !Bits[Mips::FeatureMips64r6] && !Bits[Mips::FeatureSoftFloat] && !Bits[Mips::FeatureMadd4] && !Bits[Mips::FeatureMicroMips]);
  }
}

template<typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const void *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  InsnType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 8, 3);
    if (DecodeCPU16RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 8, 3);
    if (DecodeCPU16RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 3);
    if (DecodeCPU16RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 3, 2) << 3;
    tmp |= fieldFromInstruction(insn, 5, 3) << 0;
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeCPU16RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 2, 3);
    if (DecodeCPU16RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 3);
    if (DecodeCPU16RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 3);
    if (DecodeCPU16RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 8, 3);
    if (DecodeCPU16RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 3);
    if (DecodeCPU16RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 8, 3);
    if (DecodeCPU16RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 3);
    if (DecodeCPU16RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 3);
    if (DecodeCPU16RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 8:
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 0, 5) << 0;
    tmp |= fieldFromInstruction(insn, 16, 5) << 11;
    tmp |= fieldFromInstruction(insn, 21, 6) << 5;
    if (DecodeBranchTarget(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 5, 3);
    if (DecodeCPU16RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 10:
    if (DecodeFMem3(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 10);
    if (DecodeSImmWithOffsetAndScale<10>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 11, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTarget(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 1, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 4, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 20:
    if (DecodeMemMMImm4(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 4, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 1, 3);
    if (DecodePOOL16BEncodedField(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 4, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeANDI16Imm(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 3, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 3, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 3, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 26:
    if (DecodeMemMMReglistImm4Lsl2(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 0, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeUImmWithOffsetAndScale<5, 0, 4>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 30:
    if (DecodeMemMMSPImm5Lsl2(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 1, 4);
    if (DecodeSImmWithOffsetAndScale<4>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 1, 9);
    if (DecodeSimm9SP(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 33:
    if (DecodeMemMMGPImm7Lsl2(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 4, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 1, 3);
    if (DecodeAddiur2Simm7(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 1, 6);
    if (DecodeUImmWithOffsetAndScale<6, 0, 4>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 36:
    if (DecodeMovePOperands(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 7);
    if (DecodeBranchTarget7MM(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 0, 10);
    if (DecodeBranchTarget10MM(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 7);
    if (DecodeLi16Imm(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 16, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 6, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeInsSize(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 14, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 6);
    if (DecodeSImmWithOffsetAndScale<6>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeUImmWithOffset<5, 1>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeCOP0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeCOP0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 14, 2);
    if (DecodeHI32DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 13, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 63:
    tmp = fieldFromInstruction(insn, 14, 2);
    if (DecodeLO32DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 64:
    tmp = fieldFromInstruction(insn, 14, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 65:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 66:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 67:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 68:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 69:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 70:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 71:
    tmp = fieldFromInstruction(insn, 14, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 73:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeHWRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 74:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 75:
    tmp = fieldFromInstruction(insn, 16, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 76:
    tmp = fieldFromInstruction(insn, 16, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 77:
    tmp = fieldFromInstruction(insn, 14, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 78:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeCOP2RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 79:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeCOP2RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 80:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 81:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 13, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 82:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 7);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 83:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 84:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 10);
    if (DecodeSImmWithOffsetAndScale<10>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 85:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeSImmWithOffsetAndScale<16>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 86:
    if (DecodeMemMMImm16(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 87:
    if (DecodeMemMMImm12(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 88:
    if (DecodeCacheOpMM(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 89:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTargetMM(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 90:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeSImmWithOffsetAndScale<16>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 91:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 92:
    if (DecodeSyncI_MM(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 93:
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTarget1SImm16(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 94:
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTargetMM(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 95:
    tmp = fieldFromInstruction(insn, 18, 3);
    if (DecodeFCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTargetMM(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 96:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 97:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 98:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 99:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 100:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 101:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 13, 3);
    if (DecodeFCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 102:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 103:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 13, 3);
    if (DecodeFCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 104:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 105:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 106:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 107:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 108:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 109:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 110:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 111:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 13, 3);
    if (DecodeFCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 112:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 113:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 114:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 115:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeCCRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 116:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 117:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 118:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeCCRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 119:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 120:
    tmp = fieldFromInstruction(insn, 13, 3);
    if (DecodeFCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 121:
    tmp = fieldFromInstruction(insn, 13, 3);
    if (DecodeFCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 122:
    if (DecodeMemMMImm9(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 123:
    if (DecodePrefeOpMM(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 124:
    if (DecodeJumpTargetMM(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 125:
    tmp = fieldFromInstruction(insn, 23, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 23);
    if (DecodeSimm23Lsl2(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 126:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTargetMM(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 127:
    if (DecodeFMemMMR2(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 128:
    if (DecodeMem(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 129:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 130:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 131:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 132:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 133:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 134:
    tmp = fieldFromInstruction(insn, 1, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 4, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 135:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 4, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 136:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 4, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRMM16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 137:
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 138:
    tmp = fieldFromInstruction(insn, 5, 5);
    if (DecodeUImmWithOffsetAndScale<5, 0, 4>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 139:
    tmp = fieldFromInstruction(insn, 6, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 140:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeHWRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 141:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 2);
    if (DecodeUImmWithOffset<2, 1>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 142:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 143:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 144:
    tmp = fieldFromInstruction(insn, 6, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 145:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 146:
    if (DecodeLoadByte15(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 147:
    if (DecodeFMemCop2MMR6(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 148:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTargetMM(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 149:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeCOP2RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTargetMM(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 150:
    if (DecodeSynciR6(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 151:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 152:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGRCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 153:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGRCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 154:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 155:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 156:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGRCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 157:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 158:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 159:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 160:
    if (DecodePOP35GroupBranchMMR6(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 161:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 19);
    if (DecodeSimm19Lsl2(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 162:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeSImmWithOffsetAndScale<16>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 163:
    if (DecodePOP37GroupBranchMMR6(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 164:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 21);
    if (DecodeBranchTarget21MM(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 165:
    tmp = fieldFromInstruction(insn, 0, 26);
    if (DecodeBranchTarget26MM(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 166:
    if (DecodeBlezGroupBranchMMR6(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 167:
    if (DecodePOP65GroupBranchMMR6(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 168:
    if (DecodeBgtzGroupBranchMMR6(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 169:
    if (DecodePOP75GroupBranchMMR6(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 170:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 171:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 18, 3);
    if (DecodeFCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 172:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 2);
    if (DecodeUImmWithOffset<2, 1>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 173:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 174:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 175:
    tmp = fieldFromInstruction(insn, 6, 20);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 176:
    tmp = fieldFromInstruction(insn, 6, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 177:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 178:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 179:
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeHI32DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 180:
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeLO32DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 181:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 2);
    if (DecodeUImmWithOffset<2, 1>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 182:
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 183:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 184:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTarget(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 185:
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTarget(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 186:
    if (DecodeSyncI(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 187:
    if (DecodeJumpTarget(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 188:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTarget(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 189:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeSImmWithOffsetAndScale<16>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 190:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 191:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 192:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeCOP0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 193:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeCOP0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 194:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 4, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 195:
    tmp = fieldFromInstruction(insn, 11, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 196:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 197:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 198:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeCCRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 199:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 200:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 201:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 202:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeCCRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 203:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 204:
    tmp = fieldFromInstruction(insn, 18, 3);
    if (DecodeFCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTarget(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 205:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTarget(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 206:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 207:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 208:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 18, 3);
    if (DecodeFCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 209:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 210:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 211:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 212:
    tmp = fieldFromInstruction(insn, 8, 3);
    if (DecodeFCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 213:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 214:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 215:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 216:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 18, 3);
    if (DecodeFCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 217:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 218:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 219:
    tmp = fieldFromInstruction(insn, 8, 3);
    if (DecodeFCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 220:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTarget(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 221:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTarget(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 222:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTarget(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 223:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeCOP2RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 224:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeCOP2RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 225:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 226:
    if (DecodeCop2Fd0_LS(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 227:
    if (DecodeCop2Ft0_LS(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 228:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 229:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 230:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 231:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 232:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 233:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeAFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 234:
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 235:
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 11, 5) << 0;
    tmp |= fieldFromInstruction(insn, 16, 5) << 0;
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 236:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 237:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 238:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 239:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 240:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 241:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 242:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 243:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 244:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 245:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 246:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 247:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 248:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 249:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 250:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 251:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 252:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 253:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 254:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 255:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 256:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 257:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 258:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 259:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 260:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 261:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 262:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 263:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 264:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 265:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 266:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 267:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 268:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 269:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 270:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 271:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 272:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 273:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 274:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 275:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 276:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 277:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 278:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 279:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 280:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 281:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 282:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 283:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSACtrlRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 284:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 285:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 286:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 287:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 288:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSACtrlRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 289:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 290:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 291:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 292:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 293:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 294:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 295:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 296:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 297:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 298:
    if (DecodeINSVE_DF(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 299:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 300:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 301:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128BRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 302:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 303:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 304:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 305:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 306:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 307:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 308:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128HRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 309:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeMSA128DRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeMSA128WRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 310:
    if (DecodeMSA128Mem(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 311:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeUImmWithOffset<5, 1>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 312:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeInsSize(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 313:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 314:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 315:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 316:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 317:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 318:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 319:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 320:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 321:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 322:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 323:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 324:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 325:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 326:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 327:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeDSPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 328:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 329:
    if (DecodeMemEVA(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 330:
    if (DecodeCacheeOp_CacheOpR6(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 331:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 332:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 333:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 334:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 335:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 336:
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 6);
    if (DecodeSImmWithOffsetAndScale<6>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 337:
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeACC64DSPRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 338:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeHWRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 339:
    if (DecodeCacheOp(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 340:
    if (DecodeFMem(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 341:
    if (DecodeFMemLSImm8_6(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 342:
    if (DecodeMemLSImm9_6(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 343:
    if (DecodeFMemLSImm9_6(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 344:
    if (DecodeFMem2(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 345:
    if (DecodeBaseIndexOffsetC1_LS(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 346:
    if (DecodeDAHIDATI(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 347:
    tmp = fieldFromInstruction(insn, 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 348:
    if (DecodeBlezGroupBranch(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 349:
    if (DecodeBgtzGroupBranch(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 350:
    if (DecodeAddiGroupBranch(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 351:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTarget(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 352:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGRCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 353:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 354:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 355:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGRCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 356:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGRCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 357:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeCOP2RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeBranchTarget(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 358:
    if (DecodeFMemCop2R6(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 359:
    if (DecodeBlezlGroupBranch(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 360:
    if (DecodeBgtzlGroupBranch(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 361:
    if (DecodeDaddiGroupBranch(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 362:
    if (DecodeCRC(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 363:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 364:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 365:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 366:
    if (DecodeSpecial3LlSc(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 367:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 368:
    tmp = fieldFromInstruction(insn, 0, 26);
    if (DecodeBranchTarget26(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 369:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 21);
    if (DecodeBranchTarget21(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 370:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 18);
    if (DecodeSimm18Lsl3(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 371:
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 21);
    if (DecodeBranchTarget21(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 372:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 373:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 374:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeCOP0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 375:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeCOP0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 376:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeCOP2RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 377:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeCOP2RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 378:
    tmp = fieldFromInstruction(insn, 13, 3);
    if (DecodeFCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 379:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (DecodeSImmWithOffsetAndScale<16>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 380:
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 11, 5) << 0;
    tmp |= fieldFromInstruction(insn, 16, 5) << 0;
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 381:
    if (DecodeDEXT(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 382:
    if (DecodeDINS(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 383:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 384:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeGPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 385:
    if (DecodeBaseIndexOffset_LS(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 386:
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 387:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 388:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 389:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 390:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 18, 3);
    if (DecodeFCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 391:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeGPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 392:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 393:
    tmp = fieldFromInstruction(insn, 8, 3);
    if (DecodeFCCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 394:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 395:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodePtrRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 396:
    tmp = fieldFromInstruction(insn, 6, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 21, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    if (DecodeFGR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  }
}

template<typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const void *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset& Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint32_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      ++Ptr;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      unsigned Len;
      InsnType Val = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      InsnType FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      uint32_t ExpectedValue = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      unsigned Len;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      unsigned Len;
      InsnType PositiveMask = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      InsnType NegativeMask = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      bool Fail = (insn & PositiveMask) || (~insn & NegativeMask);
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n":"PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // End llvm namespace
